<?php

// Exit if accessed directly
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}


add_action( 'vc_load_default_templates_action','nectar_custom_studio_templates_for_vc' );


/**
 * Salient Studio templates.
 *
 * @since 1.0
 */
if( !function_exists('nectar_custom_studio_templates_for_vc') ) {

function nectar_custom_studio_templates_for_vc() {

$cat_display_names = array(
	'about' => esc_html__('About', 'salient-core'),
	'blog' => esc_html__('Blog', 'salient-core'),
	'cta' => esc_html__('Call To Action', 'salient-core'),
	'counters' => esc_html__('Counters', 'salient-core'),
	'general' => esc_html__('General', 'salient-core'),
	'icons' => esc_html__('Icons', 'salient-core'),
	'hero_section' => esc_html__('Hero Section', 'salient-core'),
	'google_map' => esc_html__('Map', 'salient-core'),
	'lottie' => esc_html__('Lottie', 'salient-core'),
	'portfolio' => esc_html__('Project', 'salient-core'),
	'pricing' => esc_html__('Pricing', 'salient-core'),
	'services' => esc_html__('Services', 'salient-core'),
	'team' => esc_html__('Team', 'salient-core'),
	'testimonials' => esc_html__('Testimonials', 'salient-core'),
	'shop' => esc_html__('Shop', 'salient-core'),
	'new' => esc_html__('New', 'salient-core')
);




$data = array();
$data['name'] = esc_html__( 'Magazine Hero Section', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['blog'];
$data['custom_class'] = 'blog date-24-June-2023';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/2023-mag-hero.webp' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="custom" column_direction="default" column_direction_tablet="default" column_direction_phone="default" scene_position="center" bottom_padding="4%" top_padding_tablet="15" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" advanced_gradient_angle="0" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" gradient_type="default" shape_type=""][vc_column column_element_direction_desktop="default" column_element_spacing="0px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" column_padding_type="advanced"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" bottom_margin="-15px" bottom_margin_tablet="0" column_element_direction_desktop="default" column_element_spacing="0px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in" animation_easing="easeOutSine" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="default" gradient_type="default"][split_line_heading animation_type="line-reveal-by-space" font_style="h1" fit_text_to_container="true" line_reveal_by_space_text_effect="none" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="SALIENT MAG" font_size="13.6vw" font_line_height="1"][/split_line_heading][/vc_column_inner][/vc_row_inner][nectar_post_grid post_type="post" blog_category="all" order="DESC" orderby="date" pagination="none" columns="4" columns_tablet="default" columns_phone="default" grid_item_spacing="15px" grid_item_height="30vh" enable_masonry="yes" 4_col_masonry_layout="mixed" image_size="large" aspect_ratio_image_size="yes" custom_image_aspect_ratio="4-3" image_loading="skip-lazy-load" animation="zoom-out-reveal" animation_stagger="1" animation_easing="easeInOutCubic" parallax_scrolling="yes" heading_tag="default" font_size_min="16px" font_size_max="24px" display_categories="yes" category_functionality="default" category_position="default" category_style="button" category_display="parent_only" additional_meta_display="large_items_only" display_date="yes" display_author="yes" author_functionality="default" author_position="multiline" additional_meta_size="small" grid_style="content_under_image" content_under_image_text_align="left" text_color="dark" hover_effect="zoom" border_radius="10px" custom_font_size="1.3vw" posts_per_page="5" display_type="grid" font_line_height="1.4"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Modern Blog Carousel', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['blog'];
$data['custom_class'] = 'blog date-23-June-2023';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/2023-mag-carousel.webp' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" scene_position="center" top_padding="4%" bottom_padding="8%" left_padding_phone="0" constrain_group_6="yes" right_padding_phone="0" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" advanced_gradient_angle="0" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" gradient_type="default" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="0px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" column_padding_type="default"][vc_row_inner equal_height="yes" content_placement="bottom" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bottom_padding="1%" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner right_padding_desktop="30%" right_padding_phone="5%" column_element_direction_desktop="default" column_element_spacing="5px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="advanced" gradient_type="default" offset="vc_col-xs-8"][vc_column_text]Featured Headlines[/vc_column_text][nectar_responsive_text font_size_min="20" font_size_max="44px" font_size_desktop="2.2vw" font_line_height="1.3"]
<h4>Check out the latest news from around the world</h4>
[/nectar_responsive_text][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="default" gradient_type="default" offset="vc_col-xs-4"][nectar_cta btn_style="curved-arrow-animation" heading_tag="h6" button_color="default" button_border_thickness="0px" link_type="regular" alignment="right" alignment_tablet="default" alignment_phone="default" display="block" display_tablet="inherit" display_phone="inherit" link_text="View all"][/vc_column_inner][/vc_row_inner][nectar_post_grid post_type="post" blog_category="all" order="DESC" orderby="date" flickity_controls="touch_total" flickity_touch_total_style="tooltip_text" flickity_touch_total_blurred_bg="yes" flickity_touch_total_indicator_bg_color="rgba(255,255,255,0.25)" flickity_touch_total_indicator_icon_color="#000000" flickity_overflow="visible" flickity_wrap_around="no-wrap" columns="3" columns_tablet="default" columns_phone="default" desktop_small_cols_flickity="3" tablet_cols_flickity="2" phone_cols_flickity="1" grid_item_spacing="15px" grid_item_height="50vh" 3_col_masonry_layout="default" image_size="large" image_loading="lazy-load" animation="none" animation_stagger="90" animation_easing="default" heading_tag="default" font_size_min="16px" font_size_max="28px" enable_indicator="yes" mouse_indicator_style="default" mouse_indicator_text="read" mouse_indicator_color="rgba(10,10,10,0.24)" mouse_indicator_text_color="#ffffff" mouse_indicator_blurred_bg="yes" display_categories="yes" category_functionality="default" category_position="default" category_style="button" category_display="parent_only" display_date="yes" display_author="yes" author_functionality="default" author_position="default" additional_meta_size="small" grid_style="content_overlaid" text_content_layout="all_bottom_left_shadow" color_overlay="#0a0a0a" color_overlay_opacity="0" color_overlay_hover_opacity="0" text_color="light" text_color_hover="light" text_opacity="1" text_hover_opacity="1" hover_effect="animated_underline_zoom" border_radius="10px" custom_font_size="1.8vw" posts_per_page="5" display_type="carousel"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Sticky Posts Section', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['blog'];
$data['custom_class'] = 'blog date-22-June-2023';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/2023-mag-hot-posts-simple.webp' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" scene_position="center" top_padding="8%" bottom_padding="8%" left_padding_phone="0" constrain_group_6="yes" right_padding_phone="0" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" advanced_gradient_angle="0" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" gradient_type="default" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" top_margin="-7.5%" top_margin_tablet="-10%" column_element_direction_desktop="default" column_element_spacing="0px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="7/12" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" column_padding_type="default"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bottom_padding="15" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="default" gradient_type="default"][nectar_post_grid post_type="post" blog_category="all" order="DESC" orderby="date" pagination="none" columns="1" columns_tablet="default" columns_phone="default" grid_item_spacing="15px" grid_item_height="60vh" image_size="full" image_loading="lazy-load" animation="none" animation_stagger="90" animation_easing="default" parallax_scrolling="yes" heading_tag="default" font_size_max="48px" display_categories="yes" category_functionality="default" category_position="default" category_style="button" category_display="parent_only" display_date="yes" display_author="yes" author_functionality="default" author_position="multiline" additional_meta_size="small" grid_style="content_overlaid" text_content_layout="all_bottom_left_shadow" color_overlay_opacity="0.3" color_overlay_hover_opacity="0.4" text_color="light" text_color_hover="light" text_opacity="1" text_hover_opacity="1" hover_effect="zoom" border_radius="10px" content_overlaid_padding_desktop="50px" content_overlaid_padding_tablet="35px" posts_per_page="1" display_type="grid" custom_font_size="2.4vw" font_size_tablet="26px" post_offset="5"][/vc_column_inner][/vc_row_inner][nectar_post_grid post_type="post" blog_category="all" order="DESC" orderby="date" pagination="none" columns="2" columns_tablet="default" columns_phone="default" grid_item_spacing="15px" grid_item_height="60vh" image_size="full" aspect_ratio_image_size="yes" custom_image_aspect_ratio="4-3" image_loading="lazy-load" animation="none" animation_stagger="90" animation_easing="default" parallax_scrolling="yes" heading_tag="default" font_size_min="16px" font_size_max="24px" display_categories="yes" category_functionality="default" category_position="default" category_style="button" category_display="parent_only" display_date="yes" display_author="yes" author_functionality="default" author_position="default" additional_meta_size="small" grid_style="content_under_image" card_design="yes" card_bg_color="#ffffff" content_under_image_text_align="left" text_color="dark" hover_effect="zoom" border_radius="10px" 2_col_masonry_layout="default" custom_font_size="1.4vw" posts_per_page="2" display_type="grid" post_offset="8"][/vc_column][vc_column top_padding_desktop="6%" bottom_padding_desktop="2%" left_padding_desktop="14%" right_padding_desktop="5%" left_padding_tablet="0" right_padding_tablet="0" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" sticky_content="true" sticky_content_functionality="css" sticky_content_alignment="middle" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="5/12" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="advanced" gradient_type="default"][nectar_post_grid post_type="post" blog_category="all" order="DESC" orderby="date" pagination="none" ignore_sticky_posts="yes" columns="1" columns_tablet="default" columns_phone="default" grid_item_spacing="10px" image_size="portfolio-thumb_large" aspect_ratio_image_size="yes" custom_image_aspect_ratio="3-2" content_next_to_image_image_width="33.3%" content_next_to_image_image_gap="10%" content_next_to_image_image_position="right" image_loading="lazy-load" animation="none" animation_stagger="90" animation_easing="default" heading_tag="h3" font_size_min="16px" font_size_max="24px" display_categories="yes" category_functionality="static" category_position="default" category_style="underline" category_display="parent_only" display_date="yes" additional_meta_size="small" grid_style="content_next_to_image" text_color="dark" content_next_to_image_vertical_align="middle" hover_effect="animated_underline" border_radius="10px" content_next_to_image_divider="yes" content_next_to_image_divider_color="#e5e5e5" posts_per_page="4" display_type="grid" custom_font_size="1.4vw" font_line_height="1.3" post_offset="10"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Friendly Sign Up Form', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['blog'];
$data['custom_class'] = 'blog date-22-June-2023';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/2023-mag-form.webp' );
$data['content'] = <<<CONTENT
[vc_row type="in_container" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" scene_position="center" bottom_margin="4%" text_color="dark" text_align="left" row_border_radius="15px" row_border_radius_applies="bg" overflow="visible" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" shape_type="" gradient_type="default"][vc_column top_padding_desktop="6%" constrain_group_100="yes" bottom_padding_desktop="6%" left_padding_desktop="6%" constrain_group_101="yes" right_padding_desktop="6%" column_element_direction_desktop="default" column_element_spacing="default" centered_text="true" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="15px" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="advanced" gradient_type="default"][nectar_lottie trigger_type="play" mobile_func="default" loop="true" trigger_offset="0.00,100.00" frame_constraint="0.00,100.00" width_desktop="50" alignment="center" preserve_aspect_ratio="xMidYMid meet" json_url="https://assets1.lottiefiles.com/packages/lf20_UyIC2q.json"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" top_padding="20" left_padding_desktop="30%" constrain_group_2="yes" right_padding_desktop="30%" left_padding_phone="13%" constrain_group_6="yes" right_padding_phone="13%" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][nectar_responsive_text font_size_min="20px" font_size_max="60px" font_size_desktop="3vw" font_line_height="1.3"]
<h3>Stay up to date and never miss out.</h3>
[/nectar_responsive_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" left_padding_desktop="25%" constrain_group_2="yes" right_padding_desktop="25%" left_padding_tablet="0" constrain_group_4="yes" right_padding_tablet="0" left_padding_phone="0" constrain_group_6="yes" right_padding_phone="0" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_column_text]Add your form shortcode here[/vc_column_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="10px" centered_text="true" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="default" gradient_type="default"][nectar_circle_images images="https://themenectar.com/img/demo-media/unsplash/webp/ff1dfc85f81f.webp,https://themenectar.com/img/demo-media/unsplash/webp/fc2fcf082f87.webp,https://themenectar.com/img/demo-media/unsplash/webp/c5799533a786.webp" sizing="50px" positioning="overlapping" stacking_order="ltr" border_color="#f7f7f7" alignment_desktop="middle" alignment_tablet="inherit" alignment_phone="inherit" animation="none" image_size="nectar_small_square" image_loading="lazy-load" numerical_circle="true" alignment="left" text_content="Join the community" numerical_circle_number="+1k"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Single Featured Blog Post', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['blog'];
$data['custom_class'] = 'blog date-22-June-2023';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/2023-mag-recent-post.webp' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" scene_position="center" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" shape_type="" gradient_type="default"][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][recent_posts style="single_large_featured" large_featured_padding="18%" button_color="Extra-Color-3" button_arrow_style="curved" load_in_animation="zoom_out_reveal" single_large_featured_content_side_spacing="default" single_large_featured_content_alignment="bottom" large_featured_content_max_width="default" font_size_max="48px" bg_overlay="diagonal_gradient" large_featured_heading_tag="h3" category="all" order="DESC" orderby="date" image_loading="lazy-load" single_large_featured_content_side-spacing="" large_featured_font_size="8vw" font_size_phone="26px" font_size_desktop="3vw" font_line_height="1.2" post_offset=""][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Mixed Style Recent Posts', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['blog'];
$data['custom_class'] = 'blog date-21-June-2023';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/2023-mag-triple.webp' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="custom" column_direction="default" column_direction_tablet="default" column_direction_phone="default" scene_position="center" top_padding="5%" bottom_padding="10%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" advanced_gradient_angle="0" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" gradient_type="default" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="0px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" column_padding_type="default"][vc_row_inner equal_height="yes" content_placement="bottom" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bottom_padding="1%" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner right_padding_desktop="24%" right_padding_phone="5%" column_element_direction_desktop="default" column_element_spacing="5px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="advanced" gradient_type="default" offset="vc_col-xs-8"][vc_column_text]Featured Headlines[/vc_column_text][nectar_responsive_text font_size_min="20" font_size_max="44px" font_size_desktop="2.2vw" font_line_height="1.3"]
<h4>Technology</h4>
[/nectar_responsive_text][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="default" gradient_type="default" offset="vc_col-xs-4"][nectar_cta btn_style="curved-arrow-animation" heading_tag="h6" button_color="default" button_border_thickness="0px" link_type="regular" alignment="right" alignment_tablet="default" alignment_phone="default" display="block" display_tablet="inherit" display_phone="inherit" link_text="View all"][/vc_column_inner][/vc_row_inner][nectar_post_grid post_type="post" blog_category="all" order="DESC" orderby="date" pagination="none" columns="4" columns_tablet="default" columns_phone="default" grid_item_spacing="15px" grid_item_height="50vh" enable_masonry="yes" 4_col_masonry_layout="vert_staggered_middle" image_size="full" image_loading="lazy-load" animation="zoom-out-reveal" animation_stagger="1" animation_easing="easeInOutCubic" heading_tag="default" font_size_min="16px" font_size_max="24px" additional_meta_display="large_items_only" display_date="yes" display_author="yes" author_functionality="default" author_position="multiline" additional_meta_size="small" grid_style="content_under_image" content_under_image_text_align="left" text_color="dark" hover_effect="zoom" border_radius="10px" shadow_on_hover="yes" custom_font_size="1.4vw" posts_per_page="3" display_type="grid"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Dark Featured Posts', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['blog'];
$data['custom_class'] = 'blog date-20-June-2023';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/2023-mag-dark.webp' );
$data['content'] = <<<CONTENT
[vc_row type="in_container" full_screen_row_position="middle" column_margin="custom" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#0f0f0f" scene_position="center" top_padding="6%" constrain_group_1="yes" bottom_padding="6%" left_padding_desktop="6%" constrain_group_2="yes" right_padding_desktop="6%" text_color="light" text_align="left" row_border_radius="15px" row_border_radius_applies="bg" overflow="visible" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" gradient_type="default" shape_type=""][vc_column left_padding_desktop="13%" constrain_group_101="yes" right_padding_desktop="13%" bottom_margin="5%" column_element_direction_desktop="default" column_element_spacing="10px" centered_text="true" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="advanced" gradient_type="default"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" zindex="1" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="default" gradient_type="default" animation_offset="75%"][vc_column_text]Business Mastery[/vc_column_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][split_line_heading animation_type="line-reveal-by-space" font_style="h2" font_size_max="130px" line_reveal_by_space_text_effect="letter-reveal-bottom" stagger_animation="true" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="THE STRATEGIC ADVANTAGE" font_size="8vw" font_line_height="1"][/split_line_heading][/vc_column_inner][/vc_row_inner][/vc_column][vc_column right_padding_tablet="15" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" zindex="10" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="advanced" gradient_type="default" offset="vc_col-xs-8"][nectar_post_grid post_type="post" blog_category="all" order="DESC" orderby="date" pagination="none" columns="2" columns_tablet="1" columns_phone="1" grid_item_spacing="35px" grid_item_height="30vh" image_size="full" aspect_ratio_image_size="yes" custom_image_aspect_ratio="3-2" image_loading="default" animation="none" animation_stagger="90" animation_easing="default" parallax_scrolling="yes" heading_tag="default" font_size_max="48px" display_categories="yes" category_functionality="default" category_position="overlaid" category_style="button" category_display="parent_only" display_excerpt="yes" excerpt_display="default" additional_meta_size="default" grid_style="content_under_image" content_under_image_text_align="left" text_color="light" hover_effect="zoom" border_radius="10px" posts_per_page="2" display_type="grid" custom_font_size="2.4vw" font_line_height="1.2"][/vc_column][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="default" gradient_type="default" offset="vc_col-xs-4"][vc_row_inner column_margin="custom" column_margin_custom="70" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="3/4" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][nectar_post_grid post_type="post" blog_category="all" order="DESC" orderby="date" pagination="none" columns="3" columns_tablet="1" columns_phone="1" grid_item_spacing="35px" grid_item_height="30vh" 3_col_masonry_layout="default" image_size="large" aspect_ratio_image_size="yes" custom_image_aspect_ratio="1-1" image_loading="default" animation="none" animation_stagger="90" animation_easing="default" heading_tag="default" font_size_min="14px" font_size_max="24px" additional_meta_size="default" grid_style="content_under_image" content_under_image_text_align="left" text_color="light" hover_effect="zoom" border_radius="10px" read_more_button="yes" posts_per_page="3" display_type="grid" custom_font_size="1.3vw" font_size_tablet="1.3vw" font_size_phone="14px" post_offset="3"][/vc_column_inner][vc_column_inner bottom_padding_desktop="100%" top_margin="35" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="10px" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/4" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="advanced" gradient_type="default" offset="vc_hidden-sm vc_hidden-xs"][nectar_cta btn_style="curved-arrow-animation" heading_tag="p" border_radius="200" button_color="default" text_color="#ffffff" button_border_color="#c1c1c1" button_border_color_hover="#ffffff" button_border_thickness="1px" link_type="regular" alignment="right" alignment_tablet="default" alignment_phone="default" display="block" display_tablet="inherit" display_phone="inherit" position_desktop="absolute" top_position_desktop="0" bottom_position_desktop="0" left_position_desktop="0" right_position_desktop="0" link_text="View all" font_size_desktop="1.2vw"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Dark Recent Posts', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['blog'];
$data['custom_class'] = 'blog date-20-June-2023';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/2023-mag-dark-small.webp' );
$data['content'] = <<<CONTENT
[vc_row type="in_container" full_screen_row_position="middle" column_margin="custom" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#0f0f0f" scene_position="center" top_padding="3%" constrain_group_1="yes" bottom_padding="3%" left_padding_desktop="6%" constrain_group_2="yes" right_padding_desktop="6%" text_color="light" text_align="left" row_border_radius="15px" row_border_radius_applies="bg" overflow="visible" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" gradient_type="default" shape_type=""][vc_column column_element_direction_desktop="default" column_element_spacing="10px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="advanced" gradient_type="default"][vc_row_inner column_margin="custom" column_margin_custom="70" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="3/4" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][nectar_post_grid post_type="post" blog_category="all" order="DESC" orderby="date" pagination="none" columns="3" columns_tablet="1" columns_phone="1" grid_item_spacing="35px" grid_item_height="30vh" 3_col_masonry_layout="default" image_size="large" aspect_ratio_image_size="yes" custom_image_aspect_ratio="1-1" image_loading="default" animation="none" animation_stagger="90" animation_easing="default" heading_tag="default" font_size_min="14px" font_size_max="24px" additional_meta_size="default" grid_style="content_under_image" content_under_image_text_align="left" text_color="light" hover_effect="zoom" border_radius="10px" read_more_button="yes" posts_per_page="3" display_type="grid" custom_font_size="1.3vw" font_size_tablet="1.3vw" font_size_phone="14px" post_offset="3"][/vc_column_inner][vc_column_inner bottom_padding_desktop="100%" top_margin="35" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="10px" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/4" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="advanced" gradient_type="default" offset="vc_hidden-sm vc_hidden-xs"][nectar_cta btn_style="curved-arrow-animation" heading_tag="p" border_radius="200" button_color="default" text_color="#ffffff" button_border_color="#c1c1c1" button_border_color_hover="#ffffff" button_border_thickness="1px" link_type="regular" alignment="right" alignment_tablet="default" alignment_phone="default" display="block" display_tablet="inherit" display_phone="inherit" position_desktop="absolute" top_position_desktop="0" bottom_position_desktop="0" left_position_desktop="0" right_position_desktop="0" link_text="View all" font_size_desktop="1.2vw"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Sticky Posts Section With Creative Header', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['blog'];
$data['custom_class'] = 'blog date-19-June-2023';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/2023-mag-hot.webp' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" scene_position="center" top_padding="5%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" zindex="100" overflow="hidden" advanced_gradient_angle="0" overlay_strength="0.3" gradient_direction="left_to_right" enable_shape_divider="true" shape_divider_color="#000000" shape_divider_position="bottom" shape_divider_height="1px" bg_image_animation="none" gradient_type="default" shape_type="straight_section"][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="0px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" column_padding_type="default"][nectar_scrolling_text scroll_direction="ltr" scroll_speed="slow" text_color="#0a0a0a" move_on_scroll_animation="yes" style="text_outline" outline_thickness="ultra-thin" outline_applies_to="text_only" text_repeat_number="3" text_repeat_divider="custom" text_repeat_divider_scale="half" text_repeat_divider_custom_color="#000000" text_repeat_divider_custom_spin_animation="yes" overflow="visible" background_image_animation="None" custom_font_size="10vw" custom_font_size_mobile="13vw" text_repeat_divider_custom="✱"]
<h2>HOT POSTS</h2>
[/nectar_scrolling_text][/vc_column][/vc_row][vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" scene_position="center" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" zindex="auto" overflow="hidden" advanced_gradient_angle="0" overlay_strength="0.3" gradient_direction="left_to_right" enable_shape_divider="true" shape_divider_color="#000000" shape_divider_position="bottom" shape_divider_height="1px" bg_image_animation="none" gradient_type="default" shape_type="straight_section"][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="0px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" column_padding_type="default"][nectar_scrolling_text scroll_direction="rtl" scroll_speed="slow" text_color="#0a0a0a" move_on_scroll_animation="yes" style="text_outline" outline_thickness="ultra-thin" outline_applies_to="text_only" text_repeat_number="3" text_repeat_divider="custom" text_repeat_divider_scale="half" text_repeat_divider_custom_spin_animation="yes" overflow="visible" background_image_animation="None" custom_font_size="10vw" custom_font_size_mobile="13vw" text_repeat_divider_custom="✱"]
<h2>HOT POSTS</h2>
[/nectar_scrolling_text][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="absolute" row_position_tablet="inherit" row_position_phone="inherit" top_position_desktop="0" left_position_desktop="0" max_width_desktop="100%" zindex="500" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][nectar_scrolling_text scroll_direction="rtl" scroll_speed="slow" text_color="#0a0a0a" move_on_scroll_animation="yes" style="text_outline" outline_thickness="ultra-thin" outline_applies_to="both" text_repeat_number="3" text_repeat_divider="custom" text_repeat_divider_scale="half" text_repeat_divider_custom_spin_animation="yes" overflow="visible" background_image_animation="None" custom_font_size="10vw" custom_font_size_mobile="13vw" text_repeat_divider_custom="✱"]
<h2><em>HOT POSTS</em></h2>
[/nectar_scrolling_text][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row][vc_row type="full_width_background" full_screen_row_position="middle" column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" scene_position="center" top_padding="2%" bottom_padding="8%" left_padding_phone="0" constrain_group_6="yes" right_padding_phone="0" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" advanced_gradient_angle="0" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" gradient_type="default" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" top_margin="-7.5%" top_margin_tablet="-10%" column_element_direction_desktop="default" column_element_spacing="0px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="7/12" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" column_padding_type="default"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bottom_padding="15" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="default" gradient_type="default"][nectar_post_grid post_type="post" blog_category="all" order="DESC" orderby="date" pagination="none" columns="1" columns_tablet="default" columns_phone="default" grid_item_spacing="15px" grid_item_height="60vh" image_size="full" image_loading="lazy-load" animation="none" animation_stagger="90" animation_easing="default" parallax_scrolling="yes" heading_tag="default" font_size_max="48px" display_categories="yes" category_functionality="default" category_position="default" category_style="button" category_display="parent_only" display_date="yes" display_author="yes" author_functionality="default" author_position="multiline" additional_meta_size="small" grid_style="content_overlaid" text_content_layout="all_bottom_left_shadow" color_overlay_opacity="0.3" color_overlay_hover_opacity="0.4" text_color="light" text_color_hover="light" text_opacity="1" text_hover_opacity="1" hover_effect="zoom" border_radius="10px" content_overlaid_padding_desktop="50px" content_overlaid_padding_tablet="35px" posts_per_page="1" display_type="grid" custom_font_size="2.4vw" font_size_tablet="26px" post_offset="5"][/vc_column_inner][/vc_row_inner][nectar_post_grid post_type="post" blog_category="all" order="DESC" orderby="date" pagination="none" columns="2" columns_tablet="default" columns_phone="default" grid_item_spacing="15px" grid_item_height="60vh" image_size="full" aspect_ratio_image_size="yes" custom_image_aspect_ratio="4-3" image_loading="lazy-load" animation="none" animation_stagger="90" animation_easing="default" parallax_scrolling="yes" heading_tag="default" font_size_min="16px" font_size_max="24px" display_categories="yes" category_functionality="default" category_position="default" category_style="button" category_display="parent_only" display_date="yes" display_author="yes" author_functionality="default" author_position="default" additional_meta_size="small" grid_style="content_under_image" card_design="yes" card_bg_color="#ffffff" content_under_image_text_align="left" text_color="dark" hover_effect="zoom" border_radius="10px" 2_col_masonry_layout="default" custom_font_size="1.4vw" posts_per_page="2" display_type="grid" post_offset="8"][/vc_column][vc_column top_padding_desktop="6%" bottom_padding_desktop="2%" left_padding_desktop="14%" right_padding_desktop="5%" left_padding_tablet="0" right_padding_tablet="0" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" sticky_content="true" sticky_content_functionality="css" sticky_content_alignment="middle" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="5/12" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="advanced" gradient_type="default"][nectar_post_grid post_type="post" blog_category="all" order="DESC" orderby="date" pagination="none" ignore_sticky_posts="yes" columns="1" columns_tablet="default" columns_phone="default" grid_item_spacing="10px" image_size="portfolio-thumb_large" aspect_ratio_image_size="yes" custom_image_aspect_ratio="3-2" content_next_to_image_image_width="33.3%" content_next_to_image_image_gap="10%" content_next_to_image_image_position="right" image_loading="lazy-load" animation="none" animation_stagger="90" animation_easing="default" heading_tag="h3" font_size_min="16px" font_size_max="24px" display_categories="yes" category_functionality="static" category_position="default" category_style="underline" category_display="parent_only" display_date="yes" additional_meta_size="small" grid_style="content_next_to_image" text_color="dark" content_next_to_image_vertical_align="middle" hover_effect="animated_underline" border_radius="10px" content_next_to_image_divider="yes" content_next_to_image_divider_color="#e5e5e5" posts_per_page="4" display_type="grid" custom_font_size="1.4vw" font_line_height="1.3" post_offset="10"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Scroll Opacity Reveal Text', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['blog'];
$data['custom_class'] = 'blog date-9-June-2023';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/2023-mag-text-fade.webp' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="custom" column_margin_custom="5%" column_direction="default" column_direction_tablet="default" column_direction_phone="default" scene_position="center" top_padding="8%" constrain_group_1="yes" bottom_padding="8%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" shape_type="" gradient_type="default"][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" sticky_content="true" sticky_content_functionality="css" sticky_content_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/webp/photo-1525440584458-b53d13a848de.webp" background_image_position="center center" background_image_stacking="default" background_image_loading="default" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" mask_enable="true" mask_shape="circle-rect" mask_size="contain" mask_alignment_desktop="left-top" column_padding_type="default" gradient_type="default" offset="vc_col-xs-3 vc_hidden-xs"][divider line_type="No Line" custom_height="45vh" custom_height_tablet="35vw" custom_height_phone="25vw"][/vc_column][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="10px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="2/3" tablet_width_inherit="small_desktop" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="default" gradient_type="default"][vc_column_text]Only the educated are free[/vc_column_text][split_line_heading animation_type="line-reveal-by-space" font_style="h3" font_size_max="90px" line_reveal_by_space_text_effect="scroll-opacity-reveal" stagger_animation="true" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="Reading is a passport to countless adventures and a key to unlocking the vast treasury of human wisdom." font_size="4.5vw" font_size_phone="3em" font_line_height="1.3" font_size_tablet="7vw"][/split_line_heading][divider line_type="No Line" custom_height="3vw"][split_line_heading animation_type="line-reveal-by-space" font_style="h3" font_size_max="90px" line_reveal_by_space_text_effect="scroll-opacity-reveal" stagger_animation="true" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="And the beautiful thing about learning is nobody can take it away from you." font_size="4.5vw" font_size_phone="3em" font_line_height="1.3" font_size_tablet="7vw"][/split_line_heading][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" top_padding="10%" top_padding_tablet="5%" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][/vc_column_inner][vc_column_inner left_padding_desktop="10%" left_padding_tablet="0" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="advanced" gradient_type="default"][nectar_responsive_text]From expert tips to step-by-step guides, our magazine serves as a trusted companion on your journey toward personal and professional growth.[/nectar_responsive_text][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Magazine Carousel Natural Aspect Ratio', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['blog'];
$data['custom_class'] = 'blog date-18-June-2023';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/2023-mag-carousel-2.webp' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" scene_position="center" top_padding="4%" constrain_group_1="yes" bottom_padding="4%" left_padding_phone="0" constrain_group_6="yes" right_padding_phone="0" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" advanced_gradient_angle="0" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" gradient_type="default" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="0px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" column_padding_type="default"][vc_row_inner equal_height="yes" content_placement="bottom" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bottom_padding="1%" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner right_padding_desktop="24%" right_padding_phone="5%" column_element_direction_desktop="default" column_element_spacing="5px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="advanced" gradient_type="default" offset="vc_col-xs-8"][vc_column_text]Updated Daily[/vc_column_text][nectar_responsive_text font_size_min="20" font_size_max="44px" font_size_desktop="2.6vw" font_line_height="1.3"]
<h4>All Categories</h4>
[/nectar_responsive_text][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" enable_border_animation="true" column_padding_type="default" gradient_type="default" offset="vc_col-xs-4"][nectar_cta btn_style="curved-arrow-animation" heading_tag="h6" button_color="default" button_border_thickness="0px" link_type="regular" alignment="right" alignment_tablet="default" alignment_phone="default" display="block" display_tablet="inherit" display_phone="inherit" link_text="View all"][/vc_column_inner][/vc_row_inner][nectar_post_grid post_type="post" blog_category="all" order="DESC" orderby="date" flickity_controls="touch_total" flickity_touch_total_style="tooltip_text" flickity_touch_total_blurred_bg="yes" flickity_touch_total_indicator_bg_color="rgba(255,255,255,0.46)" flickity_touch_total_indicator_icon_color="#000000" flickity_overflow="visible" flickity_wrap_around="no-wrap" columns="3" columns_tablet="default" columns_phone="default" desktop_small_cols_flickity="3" tablet_cols_flickity="2" phone_cols_flickity="1" grid_item_spacing="15px" grid_item_height="50vh" 3_col_masonry_layout="default" image_size="large" aspect_ratio_image_size="yes" custom_image_aspect_ratio="default" image_loading="lazy-load" animation="none" animation_stagger="90" animation_easing="default" heading_tag="default" font_size_max="24px" enable_indicator="yes" mouse_indicator_style="default" mouse_indicator_text="read" mouse_indicator_color="rgba(10,10,10,0.24)" mouse_indicator_text_color="#ffffff" mouse_indicator_blurred_bg="yes" display_categories="yes" category_functionality="default" category_position="overlaid" category_style="button" category_display="parent_only" display_excerpt="yes" excerpt_display="default" additional_meta_size="small" grid_style="content_under_image" content_under_image_text_align="left" text_color="dark" hover_effect="animated_underline_zoom" border_radius="10px" read_more_button="yes" custom_font_size="1.8vw" posts_per_page="5" display_type="carousel"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );





$data = array();
$data['name'] = esc_html__( 'Huge Impact Text Animation Hero', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['hero_section'];
$data['custom_class'] = 'hero_section date-8-June-2023';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/yellow-grad-hero.webp' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" full_height="yes" animated_gradient_bg="true" animated_gradient_bg_color_1="#ffc90a" animated_gradient_bg_speed="850" animated_gradient_bg_blending_mode="linear" scene_position="center" left_padding_desktop="19%" constrain_group_2="yes" right_padding_desktop="19%" left_padding_phone="10%" constrain_group_6="yes" right_padding_phone="10%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" advanced_gradient="linear-gradient(0deg, rgb(255,255,255) 1%, rgba(243,243,243,0) 32%)" shape_divider_position="bottom" bg_image_animation="none" gradient_type="advanced" shape_type="" advanced_gradient_display_type="linear"][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="0px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="default" gradient_type="default"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="horizontal" column_element_direction_tablet="horizontal" column_element_direction_phone="horizontal" column_element_alignment="center" column_element_spacing="20px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="default" gradient_type="default"][split_line_heading animation_type="line-reveal-by-space" font_style="h1" line_reveal_by_space_text_effect="twist-bottom-2" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="Transform" font_size="7vw" font_line_height="1.1" font_size_tablet="8vw" font_size_phone="8vw"][/split_line_heading][split_line_heading animation_type="line-reveal-by-space" font_style="i" line_reveal_by_space_text_effect="twist-bottom-2" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" font_size="7vw" font_line_height="1.1" animation_delay="100" text_content="ideas" font_size_tablet="8vw" font_size_phone="8vw"][/split_line_heading][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="right" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all" class="middle-heading"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="horizontal" column_element_direction_tablet="horizontal" column_element_direction_phone="horizontal" column_element_alignment="center" column_element_spacing="20px" desktop_text_alignment="right" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="default" gradient_type="default"][split_line_heading animation_type="line-reveal-by-space" font_style="i" line_reveal_by_space_text_effect="twist-bottom-2" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="into" font_size="7vw" font_line_height="1.1" animation_offset="100%" animation_delay="200" font_size_tablet="8vw" font_size_phone="8vw"][/split_line_heading][split_line_heading animation_type="line-reveal-by-space" font_style="i" line_reveal_by_space_text_effect="twist-bottom-2" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="beautiful," font_size="7vw" font_line_height="1.1" animation_offset="100%" animation_delay="300" font_size_tablet="8vw" font_size_phone="8vw"][/split_line_heading][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" left_padding_desktop="5vw" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="horizontal" column_element_direction_tablet="horizontal" column_element_direction_phone="horizontal" column_element_alignment="center" column_element_spacing="20px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="default" gradient_type="default"][split_line_heading animation_type="line-reveal-by-space" font_style="i" line_reveal_by_space_text_effect="twist-bottom-2" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="fast" font_size="7vw" font_line_height="1.1" animation_offset="100%" animation_delay="400" font_size_tablet="8vw" font_size_phone="8vw"][/split_line_heading][split_line_heading animation_type="line-reveal-by-space" font_style="h1" line_reveal_by_space_text_effect="twist-bottom-2" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="websites" font_size="7vw" font_line_height="1.1" animation_offset="100%" animation_delay="500" font_size_tablet="8vw" font_size_phone="8vw"][/split_line_heading][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );





$data = array();
$data['name'] = esc_html__( 'Dark Radial Gradient 404', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-8-June-2023';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/2023-dark-404.webp' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#000000" full_height="yes" video_bg="use_video" video_mp4="https://themenectar.com/salient/mag/wp-content/uploads/sites/41/2023/07/pexels-michael-james-16296844-2160p-1-1.mp4" background_video_loading="default" scene_position="center" text_color="light" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" advanced_gradient="radial-gradient(circle at center, rgba(0,0,0,0) 19%, rgb(0,0,0) 77%)" shape_divider_position="bottom" bg_image_animation="none" gradient_type="advanced" shape_type="" advanced_gradient_display_type="radial"][vc_column top_padding_desktop="8%" column_element_direction_desktop="default" column_element_spacing="0px" centered_text="true" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="advanced" gradient_type="default"][nectar_responsive_text font_size_desktop="20vw" font_line_height="1" font_size_tablet="23vw"]
<h1>404</h1>
[/nectar_responsive_text][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" zindex="100" overflow="visible" pointer_events="all"][vc_column_inner top_padding_desktop="3%" left_padding_desktop="32%" constrain_group_101="yes" right_padding_desktop="32%" left_padding_tablet="30%" constrain_group_103="yes" right_padding_tablet="30%" left_padding_phone="20%" constrain_group_105="yes" right_padding_phone="20%" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="15px" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="advanced" gradient_type="default"][nectar_responsive_text font_size_desktop="3vw" font_line_height="1.3" font_size_tablet="4vw" font_size_phone="5vw"]
<h2>Oh, no! This page doesn't exist.</h2>
[/nectar_responsive_text][nectar_cta btn_style="curved-arrow-animation" heading_tag="h6" button_color="default" text_color="#ffffff" button_border_color="#919191" button_border_color_hover="#ffffff" button_border_thickness="1px" link_type="regular" alignment="center" alignment_tablet="default" alignment_phone="default" constrain_group_3="yes" constrain_group_4="yes" display="block" display_tablet="inherit" display_phone="inherit" font_size_desktop="1.1vw" link_text="Back to Home" url="https://themenectar.com/salient/mag" margin_top="60" padding_top="1em" padding_bottom="1em" padding_left="2em" padding_right="2em" font_size_tablet="16px"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Video Mask 404', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-8-June-2023';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/2023-404-light.webp' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#ffffff" full_height="yes" scene_position="center" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" gradient_type="default" shape_type=""][vc_column top_padding_desktop="8%" column_element_direction_desktop="default" column_element_spacing="0px" centered_text="true" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="advanced" gradient_type="default"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="relative" row_position_tablet="inherit" row_position_phone="inherit" zindex="1" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/4" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" video_bg="use_video" video_mp4="https://themenectar.com/demo-media/dark-ink.mp4" background_video_loading="default" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" mask_enable="true" mask_shape="custom" mask_custom_image="LOCAL_SVG_ASSET__404" mask_size="contain" column_padding_type="default" gradient_type="default"][divider line_type="No Line" custom_height="25vh" custom_height_tablet="25vw"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/4" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="relative" row_position_tablet="inherit" row_position_phone="inherit" zindex="1000" overflow="visible" pointer_events="all"][vc_column_inner top_padding_desktop="8%" bottom_padding_desktop="6%" left_padding_desktop="32%" constrain_group_101="yes" right_padding_desktop="32%" left_padding_tablet="30%" constrain_group_103="yes" right_padding_tablet="30%" left_padding_phone="20%" constrain_group_105="yes" right_padding_phone="20%" top_margin="-5%" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color="#ffffff" background_color_opacity="0.2" background_hover_color_opacity="1" column_backdrop_filter="blur" column_backdrop_filter_blur="15" column_shadow="none" column_border_radius="15px" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="advanced" gradient_type="default"][nectar_responsive_text font_size_desktop="4vw" font_line_height="1.3" font_size_tablet="5vw" font_size_phone="6vw"]
<h2>Well, it seems like you're lost.</h2>
[/nectar_responsive_text][nectar_cta btn_style="curved-arrow-animation" heading_tag="h6" button_color="default" text_color="#000000" button_border_color="#3452ff" button_border_thickness="1px" link_type="regular" alignment="center" alignment_tablet="default" alignment_phone="default" constrain_group_3="yes" constrain_group_4="yes" display="block" display_tablet="inherit" display_phone="inherit" font_size_desktop="1.1vw" link_text="Back to Home" url="https://themenectar.com/salient/mag" margin_top="60" padding_top="1em" padding_bottom="1em" padding_left="2em" padding_right="2em" font_size_tablet="16px"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Dark Footer with Fit Text', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-8-June-2023';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/2023-mag-footer.webp' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="none" equal_height="yes" content_placement="top" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#111111" scene_position="center" top_padding="8%" bottom_padding="0" text_color="light" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" overlay_strength="0.8" gradient_direction="radial" shape_divider_position="bottom" bg_image_animation="none" shape_type="straight_section" gradient_type="default"][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="0px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="default" gradient_type="default"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" left_padding_desktop="15%" constrain_group_2="yes" right_padding_desktop="15%" left_padding_phone="20%" constrain_group_6="yes" right_padding_phone="20%" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" centered_text="true" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="small_desktop" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="default" gradient_type="default"][nectar_responsive_text font_size_min="20px" text_color="#ffffff" font_size_desktop="1.8vw" font_line_height="1.2" font_size_tablet="20px" font_size_phone="20px"]
<h3>Subscribe and never miss out</h3>
[/nectar_responsive_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" top_padding="2%" constrain_group_1="yes" bottom_padding="2%" left_padding_desktop="30%" constrain_group_2="yes" right_padding_desktop="30%" left_padding_tablet="10%" constrain_group_4="yes" right_padding_tablet="10%" left_padding_phone="0" constrain_group_6="yes" right_padding_phone="0" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_column_text]
<p style="text-align: center;">Add your form shortcode here</p>
[/vc_column_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bottom_padding="20" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="0px" centered_text="true" desktop_text_alignment="default" tablet_text_alignment="center" phone_text_alignment="center" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="default" gradient_type="default"][nectar_cta btn_style="underline" heading_tag="h6" button_color="default" text_color="#ffffff" button_border_thickness="0px" link_type="regular" alignment="left" alignment_tablet="default" alignment_phone="default" constrain_group_3="yes" constrain_group_4="yes" display="inline" display_tablet="inline-block" display_phone="inline-block" icon_family="none" link_text="Home" padding_top="1em" padding_bottom="1em" padding_left="1em" padding_right="1em"][nectar_cta btn_style="underline" heading_tag="h6" button_color="default" text_color="#ffffff" button_border_thickness="0px" link_type="regular" alignment="left" alignment_tablet="default" alignment_phone="default" constrain_group_3="yes" constrain_group_4="yes" display="inline" display_tablet="inline-block" display_phone="inline-block" icon_family="none" link_text="About" padding_top="1em" padding_bottom="1em" padding_left="1em" padding_right="1em"][nectar_cta btn_style="underline" heading_tag="h6" button_color="default" text_color="#ffffff" button_border_thickness="0px" link_type="regular" alignment="left" alignment_tablet="default" alignment_phone="default" constrain_group_3="yes" constrain_group_4="yes" display="inline" display_tablet="inline-block" display_phone="inline-block" icon_family="none" link_text="More Demos" padding_top="1em" padding_bottom="1em" padding_left="1em" padding_right="1em"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bottom_padding="30" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][split_line_heading animation_type="line-reveal-by-space" font_style="h1" fit_text_to_container="true" line_reveal_by_space_text_effect="none" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="SALIENT MAG" font_line_height="1"][/split_line_heading][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'SVG Mask Quote Section', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'] . ' ' . $cat_display_names['testimonials'];
$data['custom_class'] = 'general testimonials date-7-June-2023';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/2023-quote.webp' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" scene_position="center" top_padding="3%" constrain_group_1="yes" bottom_padding="3%" bottom_padding_phone="15%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" gradient_type="default" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="0px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="default" gradient_type="default"][vc_row_inner equal_height="yes" content_placement="middle" column_margin="custom" column_margin_custom="7%" column_direction="default" column_direction_tablet="default" column_direction_phone="default" top_padding_tablet="7%" constrain_group_3="yes" bottom_padding_tablet="7%" top_padding_phone="0" constrain_group_5="yes" bottom_padding_phone="0" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner left_padding_phone="10%" constrain_group_105="yes" right_padding_phone="10%" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="small_desktop" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="advanced" gradient_type="default"][image_with_animation image_url="https://themenectar.com/img/demo-media/unsplash/webp/600-600-guy.webp" image_size="large" animation_type="entrance" animation="None" animation_movement_type="transform_y" hover_animation="none" alignment="" border_radius="none" box_shadow="none" image_loading="default" max_width="100%" max_width_mobile="default" mask_enable="true" mask_shape="circle-rect" mask_size="contain"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="2/3" tablet_width_inherit="small_desktop" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="default" gradient_type="default"][nectar_badge display_tag="label" badge_style="default" bg_color_type="global" color="accent-color" text_color="#ffffff" padding="small" border_radius="5px" display="block" text="Quality Work" margin_bottom="10"][nectar_responsive_text font_size_max="32px" font_size_desktop="2vw" font_line_height="1.5" font_size_phone="4.7vw" font_size_tablet="2.5vw"]
<h4>“I have used ThemeNectar 3 times and they have been fantastic every time. They communicated clearly upfront and delivered exactly what was promised right on time.”</h4>
[/nectar_responsive_text][nectar_responsive_text]Corey Barnes, SEO Mania[/nectar_responsive_text][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'Vertical Staggered Post Grid', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['blog'];
$data['custom_class'] = 'blog date-9-June-2023';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/2023-tight-masonry-post-grid.webp' );
$data['content'] = <<<CONTENT
[vc_row type="in_container" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" scene_position="center" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none"][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][nectar_post_grid post_type="post" blog_category="all" order="DESC" orderby="rand" pagination="none" columns="3" columns_tablet="default" columns_phone="default" grid_item_spacing="5px" grid_item_height="40vh" enable_masonry="yes" 3_col_masonry_layout="vert_staggered" image_size="full" image_loading="lazy-load" animation="none" animation_stagger="100" animation_easing="easeInOutCubic" heading_tag="default" font_size_min="16px" font_size_max="24px" enable_indicator="yes" mouse_indicator_style="tooltip_text" mouse_indicator_text="read" mouse_indicator_color="rgba(255,255,255,0.25)" mouse_indicator_text_color="#000000" mouse_indicator_blurred_bg="yes" display_categories="yes" category_functionality="default" category_position="default" category_style="button" category_display="parent_only" display_date="yes" display_author="yes" author_functionality="default" author_position="default" additional_meta_size="small" grid_style="content_overlaid" text_content_layout="all_bottom_left_shadow" color_overlay_opacity="0.3" color_overlay_hover_opacity="0.4" text_color="light" text_color_hover="light" text_opacity="1" text_hover_opacity="1" hover_effect="animated_underline_zoom" border_radius="10px" custom_font_size="1.3vw" posts_per_page="9" display_type="grid" post_offset="2" image_loading_lazy_skip="3" font_line_height="1.4"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'Lottie Helpful Hero', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'] . ' ' . $cat_display_names['lottie'];
$data['custom_class'] = 'general lottie date-19-June-2023';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/2023-lottie-header.webp' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="none" equal_height="yes" content_placement="middle" column_direction="default" column_direction_tablet="default" column_direction_phone="default" scene_position="center" top_padding="8%" constrain_group_1="yes" bottom_padding="8%" top_padding_tablet="8%" constrain_group_3="yes" bottom_padding_tablet="8%" top_padding_phone="7%" constrain_group_5="yes" bottom_padding_phone="7%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" gradient_type="default" shape_type=""][vc_column right_padding_desktop="15%" right_padding_phone="0" bottom_margin_tablet="10%" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.8" width="1/2" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" column_padding_type="advanced"][vc_row_inner column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" right_padding_desktop="10%" right_padding_tablet="5%" right_padding_phone="3%" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="0px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" column_padding_type="default"][nectar_badge display_tag="label" badge_style="line" text_color="#3452ff" line_width="15" text="Theme Partner" margin_left="-25px" margin_bottom="10"][nectar_responsive_text font_size_max="50px" font_size_desktop="3vw" font_line_height="1.2" font_size_phone="6vw" font_size_tablet="4vw"]
<h1>Professional Salient Customization</h1>
[/nectar_responsive_text][divider line_type="No Line" custom_height="20"][nectar_responsive_text font_size_min="16px" font_size_max="20px" font_size_desktop="1.1vw" font_line_height="1.6"]Get top-tier development services delivered by our handpicked network of skilled Salient and WordPress experts, exclusively through our partners at ThemeNectar.[/nectar_responsive_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" top_padding="2vw" top_padding_tablet="5vw" top_padding_phone="6vw" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="horizontal" column_element_direction_tablet="horizontal" column_element_direction_phone="horizontal" column_element_alignment="center" column_element_spacing="20px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" column_padding_type="default"][nectar_cta btn_style="text-reveal-wave" heading_tag="span" button_color="accent-color" text_color="#ffffff" button_border_thickness="0px" link_type="regular" alignment="left" alignment_tablet="default" alignment_phone="default" constrain_group_3="yes" constrain_group_4="yes" display="inline" display_tablet="inherit" display_phone="inherit" icon_family="none" link_text="Start a project" padding_top="0.8em" padding_bottom="0.8em" padding_left="2.2em" padding_right="2.2em" margin_right="0.8em" font_size_desktop="1.1vw" font_size_tablet="14"][nectar_cta btn_style="underline" heading_tag="span" button_color="default" text_color="#000000" button_border_thickness="0px" link_type="regular" alignment="left" alignment_tablet="default" alignment_phone="default" constrain_group_3="yes" display="inline" display_tablet="inherit" display_phone="inherit" icon_family="none" link_text="Explore service" padding_top="4" padding_bottom="4" font_size_desktop="1.1vw" font_size_tablet="16"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="padding-5-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="left-right" column_element_direction_desktop="default" column_element_spacing="0px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color="#e3f3e2" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="20px" column_link_target="_self" column_position="relative" advanced_gradient_angle="180" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" column_padding_type="default"][nectar_lottie trigger_type="play" mobile_func="default" loop="true" trigger_offset="0.00,100.00" frame_constraint="0.00,100.00" speed="0.8" width_desktop="100%" alignment="center" preserve_aspect_ratio="xMidYMid meet" css_animation="fade-in" json_url="https://lottie.host/c2ca6359-99d3-4340-b4ce-46fc276f2a82/S5qDD0tPKS.json" class_name="multiply-blend"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Colorful Personal Header', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['hero_section'];
$data['custom_class'] = 'hero_section date-10-June-2023';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/multi-grad-hero.webp' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" scene_position="center" top_padding="40" constrain_group_1="yes" bottom_padding="40" left_padding_desktop="40" constrain_group_2="yes" right_padding_desktop="40" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" overlay_strength="0.3" gradient_direction="radial" shape_divider_color="#ffffff" shape_divider_position="bottom" bg_image_animation="zoom-out" shape_type="curve" gradient_type="default"][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="0px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="center" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="radial" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="default" gradient_type="default"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" zindex="20" overflow="visible" pointer_events="all"][vc_column_inner top_padding_desktop="6%" constrain_group_100="yes" bottom_padding_desktop="6%" left_padding_desktop="10%" constrain_group_101="yes" right_padding_desktop="10%" column_element_direction_desktop="default" column_element_spacing="0px" centered_text="true" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/mullti-gradient-large.webp" background_image_position="center center" background_image_stacking="default" enable_bg_scale="true" background_image_loading="default" column_backdrop_filter="none" font_color="#000000" column_shadow="none" column_border_radius="15px" column_link_target="_self" overflow="visible" advanced_gradient="linear-gradient(0deg, rgba(243,243,243,0) 19%, rgb(255,255,255) 100%)" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" parallax_bg="true" parallax_bg_speed="fast" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="advanced" gradient_type="advanced" advanced_gradient_display_type="linear"][divider line_type="No Line" custom_height="10vh"][split_line_heading animation_type="line-reveal-by-space" font_style="h1" line_reveal_by_space_text_effect="none" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="Hi, I'm Amelia! I like to share business wisdom as an entrepreneur to empower others." font_size="6vw" font_line_height="1.2" font_size_tablet="6vw"][/split_line_heading][nectar_cta btn_style="underline" heading_tag="h5" button_color="default" text_color="#0a0a0a" button_border_thickness="0px" link_type="regular" alignment="center" alignment_tablet="default" alignment_phone="default" constrain_group_3="yes" display="block" display_tablet="inherit" display_phone="inherit" icon_family="none" link_text="Explore" margin_top="40" padding_top="18" padding_bottom="18" font_size_desktop="20" font_size_tablet="18" font_size_phone="16"][divider line_type="No Line" custom_height="10vh"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'SaaS Dark Hero', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['hero_section'];
$data['custom_class'] = 'hero_section date-11-July-2022';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/promo-header-dark.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" equal_height="yes" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#000000" animated_gradient_bg="true" animated_gradient_bg_color_1="#000775" animated_gradient_bg_speed="850" animated_gradient_bg_blending_mode="organic" scene_position="center" text_color="light" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="hidden" advanced_gradient_angle="15" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="clip-path" clip_path_animation_type="default" clip_path_animation_applies="row" clip_path_start_top_desktop="0" clip_path_start_bottom_desktop="0" clip_path_start_left_desktop="0" clip_path_start_right_desktop="0" clip_path_end_top_desktop="80px" clip_path_end_bottom_desktop="0" clip_path_end_left_desktop="30px" clip_path_end_right_desktop="30px" clip_path_end_top_phone="50px" clip_path_end_bottom_phone="24px" clip_path_end_left_phone="24px" clip_path_end_right_phone="24px" clip_path_start_roundness="0" clip_path_end_roundness="20px" clip_path_animation_addon="fade" video_mute="true" shape_type="straight_section" gradient_type="default" bg_image_animation_delay="100"][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="0px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="static" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="parallax" animation_movement_type="default" column_parallax_intensity="-4" persist_movement_on_mobile="true" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" column_padding_type="default"][vc_row_inner equal_height="yes" content_placement="bottom" column_margin="custom" column_margin_custom="6vw" column_direction="default" column_direction_tablet="default" column_direction_phone="default" top_padding="13%" left_padding_desktop="10%" constrain_group_2="yes" right_padding_desktop="10%" top_padding_tablet="20%" top_padding_phone="25%" left_padding_phone="14%" constrain_group_6="yes" right_padding_phone="14%" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner left_padding_tablet="10%" constrain_group_103="yes" right_padding_tablet="10%" left_padding_phone="0" right_padding_phone="0" column_element_direction_desktop="default" column_element_spacing="5px" desktop_text_alignment="default" tablet_text_alignment="center" phone_text_alignment="center" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="1" width="3/5" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="slight-fade-in-from-bottom" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_color="rgba(255,255,255,0.22)" column_border_style="solid" gradient_type="default" column_padding_type="advanced" delay="400"][nectar_highlighted_text scribble_color="#ffffff" style="scribble" scribble_shape="basic-underline" scribble_thickness="thin" scribble_speed="1.3s" scribble_easing="ease_in_out" custom_font_size="5vw" font_size_tablet="7vw" font_line_height="1.1" font_size_phone="8vw" delay="400"]
<h1><em><strong>Beautiful</strong></em> websites with less work</h1>
[/nectar_highlighted_text][divider line_type="No Line" custom_height="50" custom_height_tablet="30"][nectar_cta btn_style="text-reveal-wave" heading_tag="span" button_color="default" button_color_hover="#3452ff" text_color="#ffffff" button_border_color="#3452ff" button_border_color_hover="#3452ff" button_border_thickness="1px" link_type="regular" alignment="left" alignment_tablet="default" alignment_phone="default" constrain_group_3="yes" constrain_group_4="yes" display="block" display_tablet="inherit" display_phone="inherit" icon_family="none" link_text="Explore Features" padding_top="1em" padding_bottom="1em" padding_left="2.3em" padding_right="2.3em" url="#features" margin_bottom="16" font_size_desktop="1.1vw" font_size_tablet="2vw" font_size_phone="16px"][/vc_column_inner][vc_column_inner left_padding_tablet="20%" constrain_group_103="yes" right_padding_tablet="20%" left_padding_phone="8%" constrain_group_105="yes" right_padding_phone="8%" top_margin_tablet="40" column_element_direction_desktop="default" column_element_spacing="10px" desktop_text_alignment="default" tablet_text_alignment="center" phone_text_alignment="center" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="2/5" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="slight-fade-in-from-bottom" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="advanced" gradient_type="default" delay="500"][split_line_heading animation_type="line-reveal-by-space" font_style="p" line_reveal_by_space_text_effect="default" stagger_animation="true" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="Salient is a next-generation WordPress theme that brings professional design results to anyone, without any coding required." font_size="1.3vw" font_line_height="1.4" animation_delay="400" font_size_tablet="2vw" font_size_phone="16px"][/split_line_heading][divider line_type="No Line" custom_height="30"][nectar_circle_images images="https://themenectar.com/img/demo-media/unsplash/webp/ff1dfc85f81f.webp,https://themenectar.com/img/demo-media/unsplash/webp/fc2fcf082f87.webp,https://themenectar.com/img/demo-media/unsplash/webp/c5799533a786.webp,https://themenectar.com/img/demo-media/unsplash/webp/adf270f4f417.webp" sizing="40px" positioning="overlapping" stacking_order="ltr" alignment_desktop="left" alignment_tablet="middle" alignment_phone="middle" animation="none" image_size="nectar_small_square" image_loading="skip-lazy-load" alignment="left"][nectar_responsive_text]<strong>6k+ reviews</strong> (4.8 of 5)[/nectar_responsive_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" top_padding="7%" left_padding_desktop="10%" constrain_group_2="yes" right_padding_desktop="10%" left_padding_tablet="17%" constrain_group_4="yes" right_padding_tablet="17%" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color="rgba(255,255,255,0.06)" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="20px" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="slight-fade-in-from-bottom" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="default" gradient_type="default" delay="600"][image_with_animation image_url="https://themenectar.com/img/demo-media/promo/landing-toolbar.webp" image_size="full" animation_type="entrance" animation="None" animation_movement_type="transform_y" hover_animation="none" alignment="center" border_radius="none" box_shadow="none" image_loading="default" max_width="100%" max_width_mobile="default"][image_with_animation image_url="https://themenectar.com/img/demo-media/promo/promo-landing-builder.webp" image_size="full" animation_type="entrance" animation="None" animation_movement_type="transform_y" hover_animation="none" alignment="" border_radius="none" box_shadow="none" image_loading="skip-lazy-load" max_width="none" max_width_mobile="default"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Staggered Impact Text', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['hero_section'] . ', ' .$cat_display_names['general'];
$data['custom_class'] = 'general hero_section date-3-July-2022';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/promo-staggered-text.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" scene_position="center" top_padding="10%" bottom_padding="10%" left_padding_desktop="18%" constrain_group_2="yes" right_padding_desktop="18%" left_padding_phone="10%" constrain_group_6="yes" right_padding_phone="10%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" gradient_type="default" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="20px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="default" gradient_type="default"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="horizontal" column_element_direction_tablet="horizontal" column_element_direction_phone="horizontal" column_element_alignment="center" column_element_spacing="20px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="default" gradient_type="default"][split_line_heading animation_type="line-reveal-by-space" font_style="h1" line_reveal_by_space_text_effect="none" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="ENCHANT" font_size="10vw" font_line_height="0.9" font_size_tablet="11vw" font_size_phone="13vw"][/split_line_heading][nectar_lottie trigger_type="play" mobile_func="default" loop="true" trigger_offset="0.00,100.00" frame_constraint="0.00,100.00" speed="0.7" width_desktop="8vw" width_tablet="10vw" width_phone="12vw" alignment="left" preserve_aspect_ratio="xMidYMid meet" json_url="https://assets5.lottiefiles.com/packages/lf20_9r65d17y.json"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="right" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="default" gradient_type="default"][split_line_heading animation_type="line-reveal-by-space" font_style="h1" line_reveal_by_space_text_effect="none" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="YOUR" font_size="10vw" font_line_height="0.9" animation_offset="100%" font_size_tablet="11vw" font_size_phone="13vw"][/split_line_heading][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="30px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="default" gradient_type="default"][split_line_heading animation_type="line-reveal-by-space" font_style="h1" line_reveal_by_space_text_effect="none" content_alignment="center" mobile_content_alignment="inherit" link_target="_self" text_content="AUDIENCE" font_size="10vw" font_line_height="0.9" animation_offset="100%" font_size_tablet="11vw" font_size_phone="13vw"][/split_line_heading][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Split Gradient Columns', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['about'];
$data['custom_class'] = 'about date-3-July-2022';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/design-split-gradient.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" equal_height="yes" content_placement="middle" column_direction="default" column_direction_tablet="default" column_direction_phone="default" scene_position="center" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" gradient_type="default" shape_type=""][vc_column column_padding="padding-7-percent" column_padding_tablet="padding-10-percent" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="0px" centered_text="true" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" font_color="#ffffff" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" advanced_gradient="radial-gradient(circle at top right, rgb(251,189,16) 5%, rgba(193,202,215,255) 43%, rgb(192,202,218) 58%, rgb(51,97,255) 94%)" advanced_gradient_radial_position="top right" width="1/2" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="default" gradient_type="advanced" advanced_gradient_display_type="radial"][split_line_heading animation_type="line-reveal-by-space" font_style="h2" text_color="#ffffff" line_reveal_by_space_text_effect="default" stagger_animation="true" mobile_disable_animation="true" content_alignment="center" mobile_content_alignment="inherit" link_target="_self" text_content="DEEP SPACE EXPLORATION" font_size="4vw" font_line_height="1.1" font_size_tablet="7vw"][/split_line_heading][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" top_padding="8%" constrain_group_1="yes" bottom_padding="8%" left_padding_desktop="25%" constrain_group_2="yes" right_padding_desktop="25%" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][image_with_animation image_url="https://themenectar.com/img/demo-media/unsplash/webp/511cafe4a5c7.webp" image_size="full" animation_type="entrance" animation="None" animation_movement_type="transform_y" hover_animation="none" alignment="" border_radius="custom" box_shadow="none" top_left_border_radius="200" top_right_border_radius="200" bottom_right_border_radius="200" bottom_left_border_radius="200" image_loading="default" max_width="100%" max_width_mobile="default"][/vc_column_inner][/vc_row_inner][split_line_heading animation_type="line-reveal-by-space" font_style="p" text_color="#ffffff" line_reveal_by_space_text_effect="default" stagger_animation="true" mobile_disable_animation="true" content_alignment="center" mobile_content_alignment="inherit" link_target="_self" text_content="Retention is key to successful business growth. Our platform gives your customers a better experience from start to finish in order for you to easily turn them into lifelong fans." font_size="1.1vw" font_line_height="1.7" animation_offset="96%" font_size_tablet="2.5vw" font_size_phone="16px"][/split_line_heading][/vc_column][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/webp/photo-1658498042419-be460a938f93.webp" background_image_position="center top" background_image_stacking="default" enable_bg_scale="true" background_image_loading="default" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" parallax_bg="true" parallax_bg_speed="very_subtle" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="default" gradient_type="default"][divider line_type="No Line" custom_height="40vh"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'SAAS Hero', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['hero_section'];
$data['custom_class'] = 'hero_section date-14-July-2022';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/saas-header.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="none" equal_height="yes" content_placement="middle" column_direction="default" column_direction_tablet="default" column_direction_phone="default" scene_position="center" top_padding="5%" bottom_padding="5%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="hidden" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" gradient_type="default" shape_type=""][vc_column top_padding_desktop="4vw" bottom_padding_desktop="6vw" left_padding_desktop="7vw" constrain_group_101="yes" right_padding_desktop="7vw" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.8" width="1/2" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" column_padding_type="advanced"][vc_row_inner column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" top_padding="5%" right_padding_desktop="10%" top_padding_tablet="8%" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="0px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" mobile_disable_entrance_animation="true" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" column_padding_type="default" delay="900"][nectar_highlighted_text scribble_color="#ffce59" style="scribble" scribble_shape="basic-underline" scribble_thickness="regular" scribble_speed="0s" scribble_easing="ease_in_out" disable_mobile_animation="true" custom_font_size="5vw" font_size_tablet="7vw" font_line_height="1.1em"]
<h1>Where marketing &amp; automation <em>intersect.</em></h1>
[/nectar_highlighted_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" top_padding="3vw" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="horizontal" column_element_direction_tablet="horizontal" column_element_direction_phone="horizontal" column_element_alignment="center" column_element_spacing="20px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" mobile_disable_entrance_animation="true" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" delay="1100" column_padding_type="default" animation_offset="100%"][nectar_cta btn_style="text-reveal-wave" heading_tag="span" button_color="accent-color" text_color="#ffffff" button_border_thickness="0px" link_type="new_tab" alignment="left" alignment_tablet="default" alignment_phone="default" constrain_group_3="yes" constrain_group_4="yes" display="inline" display_tablet="inherit" display_phone="inherit" icon_family="none" link_text="Get started" padding_top="0.8em" padding_bottom="0.8em" padding_left="2.2em" padding_right="2.2em" margin_right="1em" font_size_desktop="1.1vw" url="https://themenectar.com/demo/resort" font_size_tablet="14"][nectar_cta btn_style="underline" heading_tag="span" button_color="default" text_color="#000000" button_border_thickness="0px" link_type="regular" alignment="left" alignment_tablet="default" alignment_phone="default" constrain_group_3="yes" display="inline" display_tablet="inherit" display_phone="inherit" icon_family="iconsmind" link_text="Explore features" padding_top="4" padding_bottom="4" font_size_desktop="1.1vw" icon_iconsmind="iconsmind-Leafs" url="#features" font_size_tablet="16"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column right_padding_desktop="7vw" top_padding_tablet="30" left_padding_tablet="7vw" constrain_group_103="yes" right_padding_tablet="7vw" column_element_direction_desktop="default" column_element_spacing="0px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="relative" advanced_gradient_angle="180" width="1/2" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="advanced" advanced_gradient_display_type="linear" column_padding_type="advanced"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="20px" column_link_target="_self" overflow="hidden" advanced_gradient="radial-gradient(circle at bottom, rgb(43,198,255) 0%, rgb(47,86,255) 76%)" advanced_gradient_radial_position="bottom" width="1/1" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="mask-reveal" animation_mask_direction="left" animation_mask_shape="straight" mobile_disable_entrance_animation="true" animation_easing="easeInOutCubic" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="advanced" column_padding_type="default" advanced_gradient_display_type="radial"][nectar_animated_shape shape_color="#ffce59" width_desktop="77vw" width_tablet="154vw" animation="grow-in" animation_disable_mobile="true" animation_easing="easeInOutCubic" animation_movement_type="transform_y" position_desktop="absolute" top_position_desktop="0" left_position_desktop="0" translate_y_desktop="-50%" translate_x_desktop="-50%" zindex="-1" animation_delay="30"][image_with_animation image_url="https://themenectar.com/img/demo-media/saas/sass-guy.webp" image_size="full" animation_type="entrance" animation="slide-up" disable_mobile_animation="true" animation_easing="easeInOutCubic" animation_movement_type="transform_y" hover_animation="none" alignment="center" border_radius="none" box_shadow="none" image_loading="skip-lazy-load" max_width="100%" max_width_mobile="default"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" translate_x="-35%" text_align="left" row_position="absolute" row_position_tablet="inherit" row_position_phone="inherit" top_position_desktop="20%" left_position_desktop="-1%" left_position_tablet="14%" zindex="500" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="entrance_and_parallax" animation_movement_type="default" column_parallax_intensity="1.2" persist_movement_on_mobile="true" enable_animation="true" animation="fade-in-from-bottom" mobile_disable_entrance_animation="true" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" column_padding_type="default" delay="900"][image_with_animation image_url="https://themenectar.com/img/demo-media/saas/saas-sales.jpeg" image_size="full" animation_type="entrance" animation="None" animation_movement_type="transform_y" hover_animation="none" alignment="" border_radius="15px" box_shadow="custom" box_shadow_method="default" image_loading="skip-lazy-load" max_width="custom" max_width_custom="18vw" custom_box_shadow="horizontal:50,vertical:60,blur:60,spread:-20,opacity:0.175" custom_sizes_attr="(min-width: 1000px) 18vw, 30vw" max_width_custom_tablet="30vw"][nectar_lottie trigger_type="play" mobile_func="remove" trigger_offset="0.00,100.00" frame_constraint="0.00,100.00" width_desktop="6vw" alignment="center" preserve_aspect_ratio="xMidYMid meet" position_desktop="absolute" top_position_desktop="6%" left_position_desktop="5%" mobile_disable_css_animation="true" preserveaspectratio="center" json_url="https://assets4.lottiefiles.com/packages/lf20_d1q2zqsv.json" trigger_delay="900"][/vc_column_inner][/vc_row_inner]
[vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" translate_x="0%" text_align="left" row_position="absolute" row_position_tablet="inherit" row_position_phone="inherit" top_position_desktop="70%" right_position_desktop="6%" right_position_tablet="4%" zindex="500" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="entrance_and_parallax" animation_movement_type="default" column_parallax_intensity="2" persist_movement_on_mobile="true" enable_animation="true" animation="fade-in-from-bottom" mobile_disable_entrance_animation="true" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" delay="1100" column_padding_type="default" animation_offset="120%"][image_with_animation image_url="https://themenectar.com/img/demo-media/saas/saas-user-badge.jpeg" image_size="full" animation_type="entrance" animation="None" animation_movement_type="transform_y" hover_animation="none" alignment="" border_radius="15px" box_shadow="custom" box_shadow_method="default" image_loading="skip-lazy-load" max_width="custom" max_width_custom="15vw" custom_sizes_attr="(min-width: 1000px) 15vw, 30vw" custom_box_shadow="horizontal:30,vertical:45,blur:50,spread:-20,opacity:0.175" max_width_custom_tablet="30vw"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Animated Gradient Footer', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'] . ', ' . $cat_display_names['cta'];
$data['custom_class'] = 'general cta date-3-July-2022';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/2022-promo-footer.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#0a0a0a" animated_gradient_bg="true" animated_gradient_bg_color_1="#233caf" animated_gradient_bg_speed="850" animated_gradient_bg_blending_mode="linear" scene_position="center" text_color="light" text_align="left" row_border_radius="none" row_border_radius_applies="bg" zindex="1" overflow="visible" advanced_gradient_angle="0" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" gradient_type="default" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="5px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="static" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" column_padding_type="default"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" top_padding="13%" bottom_padding="11%" left_padding_desktop="20%" constrain_group_2="yes" right_padding_desktop="20%" top_padding_tablet="30%" bottom_padding_tablet="25%" left_padding_phone="12%" constrain_group_6="yes" right_padding_phone="12%" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" centered_text="true" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" column_padding_type="default"][nectar_highlighted_text scribble_color="#ffffff" style="scribble" scribble_shape="squiggle-underline-2" scribble_thickness="thin" scribble_speed="1.6s" scribble_easing="ease_in_out" custom_font_size="6vw" font_size_phone="8vw"]
<h1>Build a website that you are <strong><em>proud of</em></strong></h1>
[/nectar_highlighted_text][divider line_type="No Line" custom_height="5vw"][nectar_cta btn_style="text-reveal-wave" heading_tag="span" text_color="#000000" button_color="white" button_color_hover="#f4f4f4" button_border_thickness="0px" link_type="new_tab" alignment="center" alignment_tablet="default" alignment_phone="default" constrain_group_3="yes" constrain_group_4="yes" display="block" display_tablet="inherit" display_phone="inherit" icon_family="none" link_text="Purchase Salient" padding_top="12" padding_bottom="12" padding_left="35" padding_right="35" url="#"][/vc_column_inner][/vc_row_inner][vc_row_inner equal_height="yes" content_placement="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" top_padding="2%" constrain_group_1="yes" bottom_padding="2%" left_padding_desktop="3%" constrain_group_2="yes" right_padding_desktop="3%" top_padding_phone="5%" constrain_group_5="yes" bottom_padding_phone="5%" left_padding_phone="5%" constrain_group_6="yes" right_padding_phone="5%" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all" css=".vc_custom_1659042013149{border-top-width: 1px !important;border-top-color: rgba(255,255,255,0.2) !important;border-top-style: solid !important;}"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="small_desktop" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="default" gradient_type="default" offset="vc_col-xs-5"][nectar_responsive_text]<b>© </b>[nectar_current_year] Salient.[/nectar_responsive_text][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="0px" desktop_text_alignment="right" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="small_desktop" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="default" gradient_type="default" offset="vc_col-xs-7"][nectar_cta btn_style="underline" heading_tag="p" text_color="#ffffff" button_color="default" button_border_thickness="0px" link_type="regular" alignment="right" alignment_tablet="right" alignment_phone="right" constrain_group_4="yes" display="inline" display_tablet="inline-block" display_phone="inline-block" icon_family="none" link_text="Docs" padding_left="15" padding_right="15"][nectar_cta btn_style="underline" heading_tag="p" text_color="#ffffff" button_color="default" button_border_thickness="0px" link_type="regular" alignment="right" alignment_tablet="right" alignment_phone="right" display="inline" display_tablet="inline-block" display_phone="inline-block" icon_family="none" link_text="Help Center" padding_left="15"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Hand-Drawn Underline Intro Text', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-3-July-2022';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/saas-text-intro.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" equal_height="yes" content_placement="middle" column_direction="default" column_direction_tablet="default" column_direction_phone="default" scene_position="center" top_padding="12%" bottom_padding="5%" left_padding_desktop="27vw" constrain_group_2="yes" right_padding_desktop="27vw" bottom_padding_tablet="12%" left_padding_tablet="20vw" constrain_group_4="yes" right_padding_tablet="20vw" left_padding_phone="7vw" constrain_group_6="yes" right_padding_phone="7vw" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" advanced_gradient_angle="0" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" gradient_type="default" shape_type=""][vc_column column_element_direction_desktop="default" column_element_spacing="0px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="static" advanced_gradient_angle="65" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="advanced" gradient_type="advanced" advanced_gradient_display_type="linear"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bottom_padding="7%" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="0px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="default" gradient_type="default" animation_offset="90%"][nectar_animated_shape shape_color="#ffffff" width_desktop="15vw" animation="none" animation_easing="default" animation_movement_type="transform_y" animation_movement_intensity="0.6" animation_movement_persist_on_mobile="true" position_desktop="absolute" top_position_desktop="0" left_position_desktop="0" translate_y_desktop="-30%" translate_x_desktop="-50%" zindex="-1"][nectar_highlighted_text scribble_color="#318fff" style="scribble" scribble_shape="squiggle-underline" scribble_thickness="thick" scribble_speed="1.6s" scribble_easing="ease_in_out" custom_font_size="3vw" id="circle-highlight2" font_line_height="1.4" font_size_tablet="4vw" font_size_phone="5vw"]
<h2>The best customer relationship management platform for just about <em>everything.</em></h2>
[/nectar_highlighted_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="default" gradient_type="default"][split_line_heading animation_type="line-reveal-by-space" font_style="p" line_reveal_by_space_text_effect="default" stagger_animation="true" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="Convert leads into customers and then turn those customers into loyal fans of your brand by leveraging next-generation automation and AI. Yes, it really can be automated, and no, you're not dreaming." font_size="1.2vw" max_width="90%" font_line_height="1.8" font_size_tablet="16px"][/split_line_heading][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Clip Path Expanding Video', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-9-July-2022';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/saas-video.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" video_bg="use_video" video_external="https://www.youtube.com/watch?v=6oTurM7gESE" background_video_loading="lazy-load" scene_position="center" text_color="light" text_align="left" row_border_radius="none" row_border_radius_applies="bg" zindex="10" overflow="visible" advanced_gradient="linear-gradient(0deg, rgba(0,0,0,0.478) 0%, rgba(243,243,243,0) 48%)" shape_divider_position="top" bg_image_animation="clip-path" clip_path_animation_type="scroll" clip_path_animation_applies="row" clip_path_start_left_desktop="14%" clip_path_start_right_desktop="14%" clip_path_end_left_desktop="0%" clip_path_end_right_desktop="0%" clip_path_start_roundness="20px" clip_path_end_roundness="0px" animation_trigger_offset="0.00,100.00" animation_trigger_origin="top" trigger_offset="30.00,60.00" gradient_type="advanced" shape_type="straight_section" advanced_gradient_display_type="linear"][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="0px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="default" gradient_type="default"][nectar_video_player_self_hosted el_aspect_tablet="43" player_functionality="lightbox" play_button_style="follow_mouse" play_button_hide="yes" play_button_color="#0a0a0a" play_button_icon_color="#ffffff" border_radius="none" box_shadow="none" video_lightbox_url="https://vimeo.com/118023315" advanced_gradient_display_type="linear"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" left_padding_desktop="10%" constrain_group_2="yes" right_padding_desktop="10%" text_align="left" min_width_desktop="100%" row_position="absolute" row_position_tablet="inherit" row_position_phone="inherit" bottom_position_desktop="5vw" zindex="1000" overflow="visible" pointer_events="none"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="5px" centered_text="true" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="default" gradient_type="default"][nectar_responsive_text text_color="#ffffff" font_size_desktop="2vw" font_size_tablet="4vw"]
<h3>Automate your growth</h3>
[/nectar_responsive_text][nectar_responsive_text text_color="#ffffff" font_size_desktop="1.2vw" font_line_height="2.5" font_size_tablet="14"]3:45 duration[/nectar_responsive_text][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'SAAS Trust-builder', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-12-July-2022';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/saas-above-testimonial.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" scene_position="center" top_padding="5%" constrain_group_1="yes" bottom_padding="5%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" gradient_type="default" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="0px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="default" gradient_type="default"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bottom_padding="5%" left_padding_desktop="25vw" constrain_group_2="yes" right_padding_desktop="25vw" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" centered_text="true" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="default" gradient_type="default"][nectar_text_inline_images media_type="images" image_size="large" image_effect="circle_fade_in" image_effect_stagger="yes" right_margin_desktop="-6%" image_loading="skip-lazy-load" line_reveal_by_space_text_effect="" content_alignment="" font_style="h1" font_size="3vw" font_line_height="1.4" font_size_desktop="4vw" font_size_tablet="4vw" max_width="" font_size_phone="5vw"]
<h2>Trusted by over 4,000 clients worldwide ***</h2>
[/nectar_text_inline_images][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'SAAS Testimonial Slider', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['testimonials'];
$data['custom_class'] = 'testimonials date-8-July-2022';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/saas-testimonials.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" scene_position="center" top_padding="5%" constrain_group_1="yes" bottom_padding="5%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" gradient_type="default" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="0px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="default" gradient_type="default"][testimonial_slider style="multiple_visible" color="accent-color-dark" slider_controls="next_prev_arrows" flickity_border_radius="20px" enable_shadow="true" custom_width_desktop="40%" font_size_desktop="1.3vw" font_line_height="1.7" shadow="horizontal:22,vertical:20,blur:60,spread:0,opacity:0.575" custom_box_shadow="horizontal:40,vertical:60,blur:60,spread:-20,opacity:0.175" font_size_tablet="16"][testimonial star_rating="none" title="Testimonial" id="1659387611495-9" name="Aura Brooks" subtitle="Marketing Director, Owl Eyes" quote="We checked out Salient to see what all the hype was about and here we are a year later with a 30% increased bottom line! If you're looking for the latest and greatest, I can't recommend this CRM platform enough." tab_id="1659387611495-2"][testimonial star_rating="none" title="Testimonial" id="1659387611509-0" name="Eve Crawford" subtitle="CEO at ThemeNectar" quote="Our productivity has noticably gone up since implementing the platform. We are now able to dedicate more time on our products while having the peace of mind that our customer experience has improved." tab_id="1659387611510-3"][testimonial star_rating="none" title="Testimonial" id="1659387611517-0" name="Jack Graham" subtitle="Project Manager, Coffee Inc" quote="Salient has enhanced our user experience and allowed us to move faster than ever and our company is now positioned to scale. We've seen a rediculous growth of 80% in just a few months!" tab_id="1659387611517-5"][testimonial star_rating="none" title="Testimonial" id="1659387611525-8" name="Zak Reid" subtitle="CTO at Envato" quote="Simply put, Salient is an excellent tool to accelerate growth and save time. We've been very pleased with the results from implementing the platform into our company." tab_id="1659387611525-4"][/testimonial_slider][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Feature Split #1', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'] . ', ' . $cat_display_names['lottie'];
$data['custom_class'] = 'general lottie date-11-July-2022';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/saas-lottie-1.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="none" equal_height="yes" content_placement="middle" column_direction="default" column_direction_tablet="default" column_direction_phone="default" scene_position="center" top_padding="5%" bottom_padding="7%" left_padding_desktop="7%" constrain_group_2="yes" right_padding_desktop="7%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" advanced_gradient_angle="0" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" gradient_type="default" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="0px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="relative" advanced_gradient_angle="180" width="1/2" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="advanced" advanced_gradient_display_type="linear" column_padding_type="default"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner top_padding_desktop="60vh" top_padding_tablet="50vh" top_padding_phone="40vh" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/saas/saas-feature-bg.webp" background_image_position="center center" background_image_stacking="front" enable_bg_scale="true" background_image_loading="default" column_backdrop_filter="none" column_shadow="none" column_border_radius="20px" column_link_target="_self" overflow="visible" advanced_gradient_angle="312" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" parallax_bg="true" parallax_bg_speed="minimum" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" column_padding_type="advanced"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="absolute" row_position_tablet="inherit" row_position_phone="inherit" bottom_position_desktop="30" left_position_desktop="30" zindex="500" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color="#ffffff" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="15px" column_link_target="_self" overflow="hidden" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="mask-reveal" animation_mask_direction="left_bottom" animation_mask_shape="circle" animation_easing="easeInOutCubic" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" column_padding_type="default" animation_offset="95%"][nectar_lottie trigger_type="play" mobile_func="default" trigger_offset="0.00,100.00" frame_constraint="0.00,100.00" width_desktop="18vw" width_tablet="36vw" alignment="center" preserve_aspect_ratio="xMidYMid meet" css_animation="fade-in" preserveaspectratio="center" json_url="https://assets10.lottiefiles.com/packages/lf20_erb8mppf.json" trigger_delay="500"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column left_padding_desktop="7vw" column_element_direction_desktop="default" column_element_spacing="30px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="static" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" column_padding_type="advanced"][vc_row_inner column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" right_padding_desktop="5%" top_padding_tablet="8%" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][split_line_heading animation_type="line-reveal-by-space" font_style="h2" text_color="#000000" line_reveal_by_space_text_effect="default" stagger_animation="true" mobile_disable_animation="true" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="Create loyal customers that love your brand" font_size="3vw" font_line_height="1.3"][/split_line_heading][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" right_padding_desktop="14%" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in" animation_easing="easeInOutQuad" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="default" gradient_type="default"][nectar_responsive_text font_size_min="16px" font_size_desktop="1.1vw" font_line_height="1.8"]Retention is key to successful business growth. Our platform gives your customers a better experience from start to finish in order for you to easily turn them into lifelong fans.[/nectar_responsive_text][nectar_cta btn_style="underline" heading_tag="span" button_color="default" text_color="#ff6b3d" button_border_thickness="0px" link_type="new_tab" alignment="left" alignment_tablet="default" alignment_phone="default" constrain_group_3="yes" display="block" display_tablet="inherit" display_phone="inherit" icon_family="none" link_text="Start your trial" padding_top="4" padding_bottom="4" url="#" font_size_desktop="1.1vw" font_size_tablet="16"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Feature Box', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'] . ', ' . $cat_display_names['lottie'];
$data['custom_class'] = 'general lottie date-10-July-2022';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/2022-promo-features-3.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="20px" equal_height="yes" content_placement="middle" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#f0f2f6" scene_position="center" top_padding="4%" constrain_group_1="yes" bottom_padding="4%" left_padding_desktop="5%" constrain_group_2="yes" right_padding_desktop="5%" left_padding_phone="14px" constrain_group_6="yes" right_padding_phone="14px" text_color="light" text_align="left" row_border_radius="none" row_border_radius_applies="bg" zindex="10" overflow="visible" id="studio" advanced_gradient_angle="0" shape_divider_position="bottom" bg_image_animation="none" shape_type="" gradient_type="advanced" advanced_gradient_display_type="linear"][vc_column top_padding_desktop="7%" left_padding_desktop="18%" constrain_group_101="yes" right_padding_desktop="18%" top_padding_tablet="8vw" left_padding_phone="8vw" constrain_group_105="yes" right_padding_phone="8vw" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/promo/ecommerce-bg.jpeg" background_image_position="center center" background_image_stacking="default" background_image_loading="default" column_backdrop_filter="none" column_shadow="none" column_border_radius="20px" column_link_target="_self" column_position="default" overflow="hidden" advanced_gradient_angle="0" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" parallax_bg="true" parallax_bg_speed="minimum" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="advanced" column_padding_type="advanced" advanced_gradient_display_type="linear"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bottom_padding="5%" left_padding_desktop="18%" constrain_group_2="yes" right_padding_desktop="18%" left_padding_tablet="10%" constrain_group_4="yes" right_padding_tablet="10%" left_padding_phone="0" constrain_group_6="yes" right_padding_phone="0" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="10px" centered_text="true" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="default" gradient_type="default"][nectar_responsive_text font_size_desktop="1.8vw" font_line_height="1.3" font_size_tablet="22px"]
<h3>Powerful WooCommerce Functionality</h3>
[/nectar_responsive_text][nectar_responsive_text font_size_min="14px" font_size_max="20px" font_size_desktop="1.1vw" font_line_height="1.5"]Unlock incredible store building potential with an AJAX off-canvas cart, product quickview, advanced reviews, premium gallery styles, collapsable product widget area, and much more.[/nectar_responsive_text][nectar_cta btn_style="text-reveal-wave" heading_tag="span" button_color="black" text_color="#ffffff" button_border_thickness="0px" link_type="regular" alignment="center" alignment_tablet="default" alignment_phone="default" constrain_group_3="yes" constrain_group_4="yes" display="block" display_tablet="inherit" display_phone="inherit" icon_family="none" link_text="View All Features" margin_top="40" padding_top="12" padding_bottom="12" padding_left="35" padding_right="35"][/vc_column_inner][/vc_row_inner][vc_row_inner equal_height="yes" content_placement="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" left_padding_tablet="5%" constrain_group_4="yes" right_padding_tablet="5%" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_element_direction_desktop="default" column_element_spacing="default" centered_text="true" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" advanced_gradient_angle="0" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" parallax_bg="true" parallax_bg_speed="very_subtle" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="advanced" advanced_gradient_display_type="linear" column_padding_type="advanced"][nectar_lottie trigger_type="play" mobile_func="default" trigger_offset="15.00,100.00" frame_constraint="0.00,100.00" width_desktop="14vw" alignment="center" preserve_aspect_ratio="xMidYMid meet" enable_shadow="true" position_desktop="absolute" top_position_desktop="50%" right_position_desktop="0" translate_y_desktop="-50%" translate_x_desktop="50%" json_url="https://assets7.lottiefiles.com/packages/lf20_thwjheep.json" zindex="10" custom_box_shadow="horizontal:0,vertical:25,blur:30,spread:0,opacity:0.2"][image_with_animation image_url="https://themenectar.com/img/demo-media/promo/ecommerce-robust-preview.jpeg" image_size="full" animation_type="entrance" animation="None" animation_movement_type="transform_y" hover_animation="none" alignment="" border_radius="custom" box_shadow="none" top_left_border_radius="20px" top_right_border_radius="20px" image_loading="default" max_width="100%" max_width_mobile="default"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Feature Split #2', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-2-July-2022';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/saas-feature-3.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="none" equal_height="yes" content_placement="middle" column_direction="default" column_direction_tablet="column_reverse" column_direction_phone="column_reverse" scene_position="center" top_padding="7%" constrain_group_1="yes" bottom_padding="7%" left_padding_desktop="7%" constrain_group_2="yes" right_padding_desktop="7%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" advanced_gradient_angle="0" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" gradient_type="default" shape_type=""][vc_column right_padding_desktop="7vw" left_padding_tablet="7vw" right_padding_tablet="0" column_element_direction_desktop="default" column_element_spacing="30px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="static" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" column_padding_type="advanced"][vc_row_inner column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" right_padding_desktop="5%" top_padding_tablet="8%" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][split_line_heading animation_type="line-reveal-by-space" font_style="h2" text_color="#000000" line_reveal_by_space_text_effect="default" stagger_animation="true" mobile_disable_animation="true" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="AI driven solutions for exceptional outcomes" font_size="3vw" font_line_height="1.3"][/split_line_heading][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" right_padding_desktop="10%" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in" mobile_disable_entrance_animation="true" animation_easing="easeInOutQuad" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" column_padding_type="default"][fancy-ul icon_type="standard_check" color="Accent-Color" alignment="left" spacing="10px" font_size_min="16px" font_size_desktop="1.1vw" font_line_height="1.6"]
<ul>
 	<li>AI-Powered marketing strategies</li>
 	<li>Live customer support chat widget</li>
 	<li>Automatic scaling campaign tools</li>
 	<li>Adaptive testing/reporting</li>
</ul>
[/fancy-ul][nectar_cta btn_style="underline" heading_tag="span" button_color="default" text_color="#ff6b3d" button_border_thickness="0px" link_type="new_tab" alignment="left" alignment_tablet="default" alignment_phone="default" constrain_group_3="yes" display="block" display_tablet="inherit" display_phone="inherit" icon_family="none" link_text="View A Demo" padding_top="4" padding_bottom="4" url="#" font_size_desktop="1.1vw" font_size_tablet="16"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_element_direction_desktop="default" column_element_spacing="0px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="relative" overflow="hidden" advanced_gradient_angle="180" width="1/2" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="advanced" advanced_gradient_display_type="linear" column_padding_type="advanced"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color="#d3dbe1" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="20px" column_link_target="_self" overflow="hidden" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" column_padding_type="advanced"][nectar_animated_shape shape_color="rgba(0,0,0,0.11)" width_desktop="50vw" animation="grow-in" animation_disable_mobile="true" animation_easing="easeInOutCubic" animation_movement_type="transform_y" position_desktop="absolute" top_position_desktop="0" right_position_desktop="0" translate_y_desktop="-50%" translate_x_desktop="50%" zindex="-1" animation_offset="80%"][image_with_animation image_url="https://themenectar.com/img/demo-media/saas/saas-phone.webp" image_size="full" animation_type="entrance" animation="None" animation_movement_type="transform_y" animation_movement_intensity=".7" animation_movement_persist_on_mobile="true" hover_animation="none" alignment="center" border_radius="none" box_shadow="custom" box_shadow_method="filter" image_loading="default" max_width="custom" max_width_custom="60%" custom_box_shadow="horizontal:30,vertical:60,blur:60,spread:-20,opacity:0.25" margin_bottom="-12%" margin_top="14%"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Large Gradient Hero', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['hero_section'];
$data['custom_class'] = 'hero_section date-10-July-2022';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/yellow-gradient-landing.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="custom" column_margin_custom="8%" equal_height="yes" content_placement="bottom" column_direction="default" column_direction_tablet="default" column_direction_phone="default" scene_position="center" top_padding="8%" left_padding_desktop="8%" constrain_group_2="yes" right_padding_desktop="8%" top_padding_tablet="15%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="hidden" advanced_gradient="radial-gradient(circle at top right, rgb(255,189,36) 4%, rgb(247,243,239) 81%)" advanced_gradient_radial_position="top right" shape_divider_position="bottom" bg_image_animation="none" gradient_type="advanced" advanced_gradient_display_type="radial" shape_type=""][vc_column bottom_padding_desktop="8vw" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="center" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/4" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="advanced" gradient_type="default"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="padding-4-percent" column_padding_phone="padding-2-percent" column_padding_position="all" bottom_margin="4vw" bottom_margin_tablet="0" column_element_direction_desktop="default" column_element_spacing="5px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="default" gradient_type="default" animation_offset="100%" offset="vc_col-xs-6"][nectar_responsive_text font_size_desktop="1.3vw" font_line_height="1.4" font_size_tablet="16px" font_size_phone="14px"]All that you need to create your own beautiful website.[/nectar_responsive_text][nectar_cta btn_style="underline" heading_tag="h6" button_color="default" button_border_thickness="0px" link_type="regular" alignment="left" alignment_tablet="default" alignment_phone="default" display="block" display_tablet="inherit" display_phone="inherit" icon_family="none" link_text="Take a tour" font_size_desktop="1.3vw" font_size_tablet="16px" font_size_phone="14px" margin_top="20"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="padding-4-percent" column_padding_phone="padding-2-percent" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="5px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="default" gradient_type="default" delay="150" offset="vc_col-xs-6"][nectar_responsive_text font_size_desktop="1.3vw" font_line_height="1.4" font_size_tablet="16px" font_size_phone="14px"]Innovative design that makes people stop and stare.[/nectar_responsive_text][nectar_cta btn_style="underline" heading_tag="h6" button_color="default" button_border_thickness="0px" link_type="regular" alignment="left" alignment_tablet="default" alignment_phone="default" display="block" display_tablet="inherit" display_phone="inherit" icon_family="none" link_text="Sign up now" font_size_desktop="1.3vw" font_size_tablet="16px" font_size_phone="14px" margin_top="20"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_element_direction_desktop="default" column_element_spacing="5px" centered_text="true" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="advanced" gradient_type="default"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" zindex="100" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="5px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="default" gradient_type="default"][split_line_heading animation_type="line-reveal-by-space" font_style="h1" line_reveal_by_space_text_effect="letter-reveal-bottom" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="salient" font_size="8vw" font_line_height="1" font_size_tablet="12vw"][/split_line_heading][split_line_heading animation_type="line-reveal-by-space" font_style="h1" line_reveal_by_space_text_effect="letter-reveal-bottom" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="DESIGN" font_size="8vw" font_line_height="1" animation_delay="200" font_size_tablet="12vw"][/split_line_heading][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" translate_x="50%" text_align="left" row_position="absolute" row_position_tablet="inherit" row_position_phone="inherit" top_position_desktop="45%" right_position_desktop="0" top_position_tablet="40%" right_position_tablet="7%" zindex="100" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/webp/photo-1587613727490-514da4285de3.webp" background_image_position="center center" background_image_stacking="default" enable_bg_scale="true" background_image_loading="default" column_backdrop_filter="none" column_shadow="custom" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="grow-in" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" mask_enable="true" mask_size="custom" mask_scale="70" mask_alignment_desktop="center-center" column_padding_type="default" gradient_type="default" custom_box_shadow="horizontal:0,vertical:30,blur:40,spread:0,opacity:0.45"][nectar_icon icon_family="fontawesome" icon_style="default" icon_color_type="color_scheme" icon_color="white" icon_padding="20px" zindex="10" pointer_events="all" position_desktop="absolute" top_position_desktop="50%" left_position_desktop="50%" translate_y_desktop="-50%" translate_x_desktop="-50%" icon_fontawesome="fa fa-play" icon_size="20"]
[image_with_animation image_url="https://themenectar.com/img/demo-media/spinners/play-video-dark.png" image_size="full" animation_type="looped" loop_animation="rotate" animation_movement_type="transform_y" hover_animation="none" alignment="" img_link_target="lightbox" border_radius="none" image_loading="default" max_width="custom" position_desktop="relative" max_width_custom="8vw" img_link="https://www.youtube.com/watch?v=6oTurM7gESE" zindex="1000" max_width_custom_tablet="15vw"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner top_margin="-4vw" top_margin_tablet="-7vw" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color="#f7f3ef" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" mask_enable="true" mask_shape="circle-rect" mask_size="cover" mask_alignment_desktop="center-top" column_padding_type="advanced" gradient_type="default"][image_with_animation image_url="https://themenectar.com/img/demo-media/saas/sunglasses-guy.webp" image_size="full" animation_type="entrance" animation="slide-up" animation_easing="default" animation_movement_type="transform_y" hover_animation="none" alignment="center" border_radius="none" box_shadow="none" image_loading="default" max_width="125%" max_width_mobile="default"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column bottom_padding_desktop="8vw" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/4" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="advanced" gradient_type="default" offset="vc_hidden-sm vc_hidden-xs"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="5px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="default" gradient_type="default"][nectar_responsive_text font_size_desktop="3vw" font_line_height="1.3"]
<h3>98%</h3>
[/nectar_responsive_text][nectar_responsive_text font_size_desktop="1.3vw" font_line_height="1"]
<h6>Customer</h6>
[/nectar_responsive_text][nectar_responsive_text font_size_desktop="1.3vw" font_line_height="1"]
<h6>Satisfaction</h6>
[/nectar_responsive_text][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Feature Split #3', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'] . ', ' . $cat_display_names['lottie'];
$data['custom_class'] = 'general lottie date-10-July-2022';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/saas-lottie-2.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" equal_height="yes" content_placement="middle" column_direction="default" column_direction_tablet="default" column_direction_phone="default" scene_position="center" top_padding="5%" bottom_padding="7%" left_padding_desktop="7%" constrain_group_2="yes" right_padding_desktop="7%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" advanced_gradient_angle="0" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" gradient_type="default" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="0px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="relative" advanced_gradient_angle="180" width="1/2" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="advanced" advanced_gradient_display_type="linear" column_padding_type="default"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner top_padding_desktop="60vh" top_padding_tablet="50vh" top_padding_phone="40vh" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/webp/photo-1587613727490-514da4285de3.webp" background_image_position="center center" background_image_stacking="front" enable_bg_scale="true" background_image_loading="default" column_backdrop_filter="none" column_shadow="none" column_border_radius="20px" column_link_target="_self" overflow="visible" advanced_gradient_angle="312" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" parallax_bg="true" parallax_bg_speed="minimum" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" column_padding_type="advanced"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="absolute" row_position_tablet="inherit" row_position_phone="inherit" bottom_position_desktop="30" right_position_desktop="30" zindex="500" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color="#ffffff" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="15px" column_link_target="_self" overflow="hidden" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="mask-reveal" animation_mask_direction="right_bottom" animation_mask_shape="circle" animation_easing="easeInOutCubic" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" column_padding_type="default" animation_offset="95%"][nectar_lottie trigger_type="play" mobile_func="default" trigger_offset="0.00,100.00" frame_constraint="0.00,100.00" width_desktop="18vw" width_tablet="36vw" alignment="center" preserve_aspect_ratio="xMidYMid meet" css_animation="fade-in" preserveaspectratio="center" json_url="https://assets4.lottiefiles.com/packages/lf20_yvkok161.json" trigger_delay="500"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column left_padding_desktop="7vw" column_element_direction_desktop="default" column_element_spacing="30px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="static" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" column_padding_type="advanced"][vc_row_inner column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" right_padding_desktop="5%" top_padding_tablet="8%" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][split_line_heading animation_type="line-reveal-by-space" font_style="h2" text_color="#000000" line_reveal_by_space_text_effect="default" stagger_animation="true" mobile_disable_animation="true" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="Seriously improve your lead conversion rate" font_size="3vw" font_line_height="1.3"][/split_line_heading][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" right_padding_desktop="10%" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in" mobile_disable_entrance_animation="true" animation_easing="easeOutQuad" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" column_padding_type="default"][fancy-ul icon_type="standard_check" color="Accent-Color" alignment="left" spacing="10px" font_size_min="16px" font_size_desktop="1.1vw" font_line_height="1.6"]
<ul>
 	<li>Intuitive customer analytics</li>
 	<li>Advertisement conversion events</li>
 	<li>Automation of sales/marketing</li>
</ul>
[/fancy-ul][nectar_cta btn_style="underline" heading_tag="span" button_color="default" text_color="#ff6b3d" button_border_thickness="0px" link_type="new_tab" alignment="left" alignment_tablet="default" alignment_phone="default" constrain_group_3="yes" display="block" display_tablet="inherit" display_phone="inherit" icon_family="none" link_text="Start your trial" padding_top="4" padding_bottom="4" url="https://themenectar.com/salient" font_size_desktop="1.1vw" font_size_tablet="16"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Hand-drawn text underline', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-10-July-2022';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/saas-pricing-text.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" scene_position="center" top_padding="8%" constrain_group_1="yes" bottom_padding="8%" left_padding_desktop="7%" constrain_group_2="yes" right_padding_desktop="7%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" advanced_gradient_angle="0" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" gradient_type="default" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" padding_type="default" gradient_type="default"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bottom_padding="3%" left_padding_desktop="24%" constrain_group_2="yes" right_padding_desktop="24%" left_padding_phone="5%" constrain_group_6="yes" right_padding_phone="5%" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" centered_text="true" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" column_padding_type="default"][nectar_highlighted_text scribble_color="#ffce59" style="scribble" scribble_shape="squiggle-underline-2" scribble_thickness="thick" scribble_speed="1.1s" scribble_easing="ease_in_out" custom_font_size="4vw"]
<h2>Tailored pricing plans <em>designed</em> for you</h2>
[/nectar_highlighted_text][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Toggle Pricing Tables', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['pricing']. ', ' . $cat_display_names['lottie'];
$data['custom_class'] = 'pricing lottie date-9-July-2022';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/saas-pricing.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" scene_position="center" top_padding="8%" constrain_group_1="yes" bottom_padding="8%" left_padding_desktop="7%" constrain_group_2="yes" right_padding_desktop="7%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" advanced_gradient_angle="0" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" gradient_type="default" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" padding_type="default" gradient_type="default"][vc_row_inner column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" translate_y="-44px" translate_x="170px" rotate_desktop="350" text_align="left" row_position="absolute" row_position_tablet="inherit" row_position_phone="inherit" left_position_desktop="50%" overflow="visible" pointer_events="none"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="5px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" column_padding_type="default" offset="vc_hidden-xs"][nectar_badge display_tag="italic" badge_style="default" bg_color_type="custom" text_color="#000000" padding="none" border_radius="20px" display="block" text="Save 25%"][nectar_lottie trigger_type="play" mobile_func="default" trigger_offset="8.00,100.00" frame_constraint="0.00,100.00" speed="0.9" width_desktop="40px" alignment="left" preserve_aspect_ratio="xMidYMid meet" preserveaspectratio="center" json_url="https://assets2.lottiefiles.com/packages/lf20_ddvwtafj.json"][/vc_column_inner][/vc_row_inner][tabbed_section style="toggle_button" tab_change_animation="none" tab_color="Accent-Color" vs_content_animation="fade" vs_link_animation="opacity" vs_navigation_alignment="left" vs_navigation_width_2="25%" vs_navigation_func="default" vs_navigation_width="regular" vs_navigation_spacing="15px" vs_navigation_mobile_display="visible" vs_tab_spacing="5%" animation=""][tab icon_family="none" title="Pay Monthly" id="1659385701588-4" tab_id="1659385701589-2"][vc_row_inner equal_height="yes" column_margin="40px" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner top_padding_desktop="40" constrain_group_100="yes" bottom_padding_desktop="40" left_padding_desktop="40" constrain_group_101="yes" right_padding_desktop="40" column_element_direction_desktop="default" column_element_spacing="10px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color="#ff6b3d" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" font_color="#ffffff" column_shadow="custom" column_border_radius="15px" column_link_target="_self" zindex="100" overflow="hidden" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" padding_type="advanced" column_padding_type="advanced" column_shadow_custom="" custom_box_shadow="horizontal:40,vertical:60,blur:60,spread:-20,opacity:0.175"][nectar_lottie trigger_type="play" mobile_func="default" loop="true" trigger_offset="0.00,100.00" frame_constraint="0.00,100.00" speed="0.2" width_desktop="150%" height_desktop="150%" alignment="center" preserve_aspect_ratio="xMidYMid meet" position_desktop="absolute" top_position_desktop="0" left_position_desktop="0" translate_y_desktop="-50%" translate_x_desktop="25%" preserveaspectratio="none" json_url="https://assets1.lottiefiles.com/packages/lf20_w4NUp4.json" zindex="-1"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color_type="color_scheme" icon_color="white" icon_padding="0px" pointer_events="all" icon_iconsmind="iconsmind-Plant"][nectar_responsive_text font_style="h4" content_alignment="default" mobile_content_alignment="inherit" font_size="5vw" font_line_height="1" font_size_desktop="2vw" font_size_tablet="3vw" font_size_phone="16"]Basic[/nectar_responsive_text][nectar_responsive_text font_style="h3" content_alignment="default" mobile_content_alignment="inherit" font_size="5vw" font_line_height="1" font_size_desktop="4vw" font_size_tablet="7vw"]Free[/nectar_responsive_text][divider line_type="No Line" custom_height="15"][fancy-ul icon_type="standard_dot" alignment="left" spacing="10px" font_size_min="16px" font_size_desktop="1.1vw"]</p>
<ul>
<li>Live chat widget</li>
<li>Email marketing</li>
<li>Custom Forms</li>
<li>Traffic analytics</li>
</ul>
<p>[/fancy-ul][divider line_type="No Line" custom_height="90"][nectar_cta btn_style="text-reveal-wave" heading_tag="span" button_color="white" text_color="#000000" button_border_thickness="0px" link_type="regular" alignment="center" alignment_tablet="default" alignment_phone="default" constrain_group_3="yes" constrain_group_4="yes" display="block" display_tablet="inherit" display_phone="inherit" icon_family="none" position_desktop="absolute" bottom_position_desktop="40" left_position_desktop="40" right_position_desktop="40" padding_top="0.8em" padding_bottom="0.8em" padding_left="40" padding_right="40" link_text="Get Started"][/vc_column_inner][vc_column_inner top_padding_desktop="40" constrain_group_100="yes" bottom_padding_desktop="40" left_padding_desktop="40" constrain_group_101="yes" right_padding_desktop="40" column_element_direction_desktop="default" column_element_spacing="10px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color="#ffffff" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" font_color="#000000" column_shadow="none" column_border_radius="15px" column_link_target="_self" overflow="visible" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="advanced" gradient_type="default"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color_type="color_scheme" icon_color="black" icon_padding="0px" pointer_events="all" icon_iconsmind="iconsmind-Leafs"][nectar_responsive_text font_style="h4" content_alignment="default" mobile_content_alignment="inherit" font_size="5vw" font_line_height="1" font_size_desktop="2vw" font_size_tablet="3vw" font_size_phone="16px"]Premium[/nectar_responsive_text][nectar_price_typography before_text_scale="0.4" after_text_scale="0.4" font_style="h3" price_text="29" before_text="$" after_text="/ month" font_size_desktop="4vw" font_size_tablet="7vw" font_line_height="1.5"][divider line_type="No Line" custom_height="15"][fancy-ul icon_type="standard_dot" alignment="left" spacing="10px" font_size_min="16px" font_size_desktop="1.1vw"]</p>
<ul>
<li>Everything in basic</li>
<li>Marketing automation</li>
<li>Advanced chatbot</li>
<li>Campaign management</li>
<li>Collaboration tools</li>
</ul>
<p>[/fancy-ul][divider line_type="No Line" custom_height="90"][nectar_cta btn_style="text-reveal-wave" heading_tag="span" button_color="accent-color" text_color="#ffffff" button_border_thickness="0px" link_type="regular" alignment="center" alignment_tablet="default" alignment_phone="default" constrain_group_3="yes" constrain_group_4="yes" display="block" display_tablet="inherit" display_phone="inherit" icon_family="none" position_desktop="absolute" bottom_position_desktop="40" left_position_desktop="40" right_position_desktop="40" padding_top="0.8em" padding_bottom="0.8em" padding_left="40" padding_right="40" link_text="Get Started"][/vc_column_inner][vc_column_inner top_padding_desktop="40" constrain_group_100="yes" bottom_padding_desktop="40" left_padding_desktop="40" constrain_group_101="yes" right_padding_desktop="40" column_element_direction_desktop="default" column_element_spacing="10px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color="#ffffff" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="15px" column_link_target="_self" overflow="visible" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" column_padding_type="advanced"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color_type="color_scheme" icon_color="black" icon_padding="0px" pointer_events="all" icon_iconsmind="iconsmind-Flowerpot"][nectar_responsive_text font_style="h4" content_alignment="default" mobile_content_alignment="inherit" font_size="5vw" font_line_height="1" font_size_desktop="2vw" font_size_tablet="3vw" font_size_phone="16px"]Platinum[/nectar_responsive_text][nectar_price_typography before_text_scale="0.4" after_text_scale="0.4" font_style="h3" price_text="59" before_text="$" after_text="/ month" font_size_desktop="4vw" font_size_tablet="7vw" font_line_height="1.5"][divider line_type="No Line" custom_height="15"][fancy-ul icon_type="standard_dot" alignment="left" spacing="10px" font_size_min="16px" font_size_desktop="1.1vw"]</p>
<ul>
<li>Everything in premium</li>
<li>A/B testing sanbox</li>
<li>Custom permissions</li>
<li>Social media automation</li>
<li>Sales automation tools</li>
</ul>
<p>[/fancy-ul][divider line_type="No Line" custom_height="90"][nectar_cta btn_style="text-reveal-wave" heading_tag="span" button_color="accent-color" text_color="#ffffff" button_border_thickness="0px" link_type="regular" alignment="center" alignment_tablet="default" alignment_phone="default" constrain_group_3="yes" constrain_group_4="yes" display="block" display_tablet="inherit" display_phone="inherit" icon_family="none" position_desktop="absolute" bottom_position_desktop="40" left_position_desktop="40" right_position_desktop="40" padding_top="0.8em" padding_bottom="0.8em" padding_left="40" padding_right="40" link_text="Get Started"][/vc_column_inner][/vc_row_inner][/tab][tab icon_family="none" title="Pay Yearly" id="1659385701727-9" tab_id="1659385701727-7"][vc_row_inner equal_height="yes" column_margin="40px" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner top_padding_desktop="40" constrain_group_100="yes" bottom_padding_desktop="40" left_padding_desktop="40" constrain_group_101="yes" right_padding_desktop="40" column_element_direction_desktop="default" column_element_spacing="10px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color="#ff6b3d" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" font_color="#ffffff" column_shadow="custom" column_border_radius="15px" column_link_target="_self" zindex="100" overflow="hidden" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" padding_type="advanced" column_padding_type="advanced" column_shadow_custom="" custom_box_shadow="horizontal:40,vertical:60,blur:60,spread:-20,opacity:0.175"][nectar_lottie trigger_type="play" mobile_func="default" loop="true" trigger_offset="0.00,100.00" frame_constraint="0.00,100.00" speed="0.2" width_desktop="150%" height_desktop="150%" alignment="center" preserve_aspect_ratio="xMidYMid meet" position_desktop="absolute" top_position_desktop="0" left_position_desktop="0" translate_y_desktop="-50%" translate_x_desktop="25%" preserveaspectratio="none" json_url="https://assets1.lottiefiles.com/packages/lf20_w4NUp4.json" zindex="-1"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color_type="color_scheme" icon_color="white" icon_padding="0px" pointer_events="all" icon_iconsmind="iconsmind-Plant"][nectar_responsive_text font_style="h4" content_alignment="default" mobile_content_alignment="inherit" font_size="5vw" font_line_height="1" font_size_desktop="2vw" font_size_tablet="3vw" font_size_phone="16"]Basic[/nectar_responsive_text][nectar_responsive_text font_style="h3" content_alignment="default" mobile_content_alignment="inherit" font_size="5vw" font_line_height="1" font_size_desktop="4vw" font_size_tablet="7vw"]Free[/nectar_responsive_text][divider line_type="No Line" custom_height="15"][fancy-ul icon_type="standard_dot" alignment="left" spacing="10px" font_size_min="16px" font_size_desktop="1.1vw"]</p>
<ul>
<li>Live chat widget</li>
<li>Email marketing</li>
<li>Custom Forms</li>
<li>Traffic analytics</li>
</ul>
<p>[/fancy-ul][divider line_type="No Line" custom_height="90"][nectar_cta btn_style="text-reveal-wave" heading_tag="span" button_color="white" text_color="#000000" button_border_thickness="0px" link_type="regular" alignment="center" alignment_tablet="default" alignment_phone="default" constrain_group_3="yes" constrain_group_4="yes" display="block" display_tablet="inherit" display_phone="inherit" icon_family="none" position_desktop="absolute" bottom_position_desktop="40" left_position_desktop="40" right_position_desktop="40" padding_top="0.8em" padding_bottom="0.8em" padding_left="40" padding_right="40" link_text="Get Started"][/vc_column_inner][vc_column_inner top_padding_desktop="40" constrain_group_100="yes" bottom_padding_desktop="40" left_padding_desktop="40" constrain_group_101="yes" right_padding_desktop="40" column_element_direction_desktop="default" column_element_spacing="10px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color="#ffffff" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" font_color="#000000" column_shadow="none" column_border_radius="15px" column_link_target="_self" overflow="visible" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="advanced" gradient_type="default"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color_type="color_scheme" icon_color="black" icon_padding="0px" pointer_events="all" icon_iconsmind="iconsmind-Leafs"][nectar_responsive_text font_style="h4" content_alignment="default" mobile_content_alignment="inherit" font_size="5vw" font_line_height="1" font_size_desktop="2vw" font_size_tablet="3vw" font_size_phone="16px"]Premium[/nectar_responsive_text][nectar_price_typography before_text_scale="0.4" after_text_scale="0.4" font_style="h3" price_text="250" before_text="$" after_text="/ year" font_size_desktop="4vw" font_size_tablet="7vw" font_line_height="1.5"][divider line_type="No Line" custom_height="15"][fancy-ul icon_type="standard_dot" alignment="left" spacing="10px" font_size_min="16px" font_size_desktop="1.1vw"]</p>
<ul>
<li>Everything in basic</li>
<li>Marketing automation</li>
<li>Advanced chatbot</li>
<li>Campaign management</li>
<li>Collaboration tools</li>
</ul>
<p>[/fancy-ul][divider line_type="No Line" custom_height="90"][nectar_cta btn_style="text-reveal-wave" heading_tag="span" button_color="accent-color" text_color="#ffffff" button_border_thickness="0px" link_type="regular" alignment="center" alignment_tablet="default" alignment_phone="default" constrain_group_3="yes" constrain_group_4="yes" display="block" display_tablet="inherit" display_phone="inherit" icon_family="none" position_desktop="absolute" bottom_position_desktop="40" left_position_desktop="40" right_position_desktop="40" padding_top="0.8em" padding_bottom="0.8em" padding_left="40" padding_right="40" link_text="Get Started"][/vc_column_inner][vc_column_inner top_padding_desktop="40" constrain_group_100="yes" bottom_padding_desktop="40" left_padding_desktop="40" constrain_group_101="yes" right_padding_desktop="40" column_element_direction_desktop="default" column_element_spacing="10px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color="#ffffff" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="15px" column_link_target="_self" overflow="visible" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" column_padding_type="advanced"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color_type="color_scheme" icon_color="black" icon_padding="0px" pointer_events="all" icon_iconsmind="iconsmind-Flowerpot"][nectar_responsive_text font_style="h4" content_alignment="default" mobile_content_alignment="inherit" font_size="5vw" font_line_height="1" font_size_desktop="2vw" font_size_tablet="3vw" font_size_phone="16px"]Platinum[/nectar_responsive_text][nectar_price_typography before_text_scale="0.4" after_text_scale="0.4" font_style="h3" price_text="500" before_text="$" after_text="/ year" font_size_desktop="4vw" font_size_tablet="7vw" font_line_height="1.5"][divider line_type="No Line" custom_height="15"][fancy-ul icon_type="standard_dot" alignment="left" spacing="10px" font_size_min="16px" font_size_desktop="1.1vw"]</p>
<ul>
<li>Everything in premium</li>
<li>A/B testing sanbox</li>
<li>Custom permissions</li>
<li>Social media automation</li>
<li>Sales automation tools</li>
</ul>
<p>[/fancy-ul][divider line_type="No Line" custom_height="90"][nectar_cta btn_style="text-reveal-wave" heading_tag="span" button_color="accent-color" text_color="#ffffff" button_border_thickness="0px" link_type="regular" alignment="center" alignment_tablet="default" alignment_phone="default" constrain_group_3="yes" constrain_group_4="yes" display="block" display_tablet="inherit" display_phone="inherit" icon_family="none" position_desktop="absolute" bottom_position_desktop="40" left_position_desktop="40" right_position_desktop="40" padding_top="0.8em" padding_bottom="0.8em" padding_left="40" padding_right="40" link_text="Get Started"][/vc_column_inner][/vc_row_inner][/tab][/tabbed_section][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Tilted Scrolling Text', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-8-July-2022';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/saas-strips.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#318fff" scene_position="center" top_padding="2%" constrain_group_1="yes" bottom_padding="2%" top_margin="5%" scale_desktop="1.02" rotate_desktop="2" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="hidden" advanced_gradient_angle="0" shape_divider_position="bottom" bg_image_animation="none" gradient_type="advanced" shape_type="" advanced_gradient_display_type="linear"][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="0px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="parallax" animation_movement_type="transform_x" column_parallax_intensity="-2.5" persist_movement_on_mobile="true" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" column_padding_type="default"][nectar_scrolling_text scroll_direction="rtl" scroll_speed="slowest" text_color="#0a0a0a" style="default" text_repeat_number="5" text_repeat_divider="space" text_space_amount="medium" overflow="visible" background_image_animation="None" custom_font_size="5vw" custom_font_size_mobile="9vw"]
<h2>Grow your business</h2>
[/nectar_scrolling_text][/vc_column][/vc_row][vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#ffce59" scene_position="center" top_padding="2%" constrain_group_1="yes" bottom_padding="2%" bottom_margin="5%" scale_desktop="1.02" rotate_desktop="358" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" zindex="20" overflow="hidden" advanced_gradient_angle="0" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" gradient_type="default" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="0px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="parallax" animation_movement_type="transform_x" column_parallax_intensity="2.5" persist_movement_on_mobile="true" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" column_padding_type="default"][nectar_scrolling_text scroll_direction="ltr" scroll_speed="slowest" text_color="#0a0a0a" style="default" text_repeat_number="5" text_repeat_divider="space" text_space_amount="medium" overflow="visible" background_image_animation="None" custom_font_size="5vw" custom_font_size_mobile="9vw"]
<h2>Grow your business</h2>
[/nectar_scrolling_text][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'Clip Path Connected Sections', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-7-July-2022';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/saas-faq-footer.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" scene_position="center" top_padding="8%" left_padding_desktop="10%" constrain_group_2="yes" right_padding_desktop="10%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" gradient_type="default" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bottom_padding="4%" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" centered_text="true" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][nectar_highlighted_text style="none" custom_font_size="3vw" font_size_tablet="6vw" font_line_height="1.2"]
<h1>Frequently asked questions</h1>
[/nectar_highlighted_text][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row][vc_row type="full_width_content" full_screen_row_position="middle" column_margin="custom" column_margin_custom="7vw" equal_height="yes" content_placement="middle" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#f8f8f8" scene_position="center" top_padding="3%" bottom_padding="12%" left_padding_desktop="7vw" constrain_group_2="yes" right_padding_desktop="7vw" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" advanced_gradient_angle="0" overlay_strength="0.8" gradient_direction="left_to_right" enable_shape_divider="true" shape_divider_color="#000000" shape_divider_position="bottom" shape_divider_height="99%" bg_image_animation="clip-path" clip_path_animation_type="scroll" clip_path_animation_applies="default" clip_path_start_bottom_desktop="0" clip_path_start_left_desktop="0" clip_path_start_right_desktop="0" clip_path_end_bottom_desktop="4%" clip_path_end_left_desktop="4%" clip_path_end_right_desktop="4%" clip_path_start_roundness="0" clip_path_end_roundness="20" animation_trigger_offset="32.00,50.00" animation_trigger_origin="bottom" shape_type="straight_section" gradient_type="default"][vc_column left_padding_desktop="2vw" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="advanced" gradient_type="default"][toggles style="minimal_shadow" accordion="true" accordion_starting_functionality="default" border_radius="none"][toggle color="Accent-Color" heading_tag="h3" heading_tag_functionality="default" title="What does CRM mean?"][vc_column_text]CRM stands for Content Relationship Management. Using a CRM platform gives everyone involved in your business a way to manage customer interactions to increase growth.[/vc_column_text][/toggle][toggle color="Accent-Color" heading_tag="h3" heading_tag_functionality="default" title="Is it really free to start?"][vc_column_text]Yes! You can opt to stay within the free tier for as long as you want to. It's a great way to get a feel for the platform before deciding to upgrade to take advantage of the more advanced features.[/vc_column_text][/toggle][toggle color="Accent-Color" heading_tag="h3" heading_tag_functionality="default" title="Can I import data?"][vc_column_text]Yes! Getting your existing data in is easy. Simply export your existing customers to a .csv file and import them within a couple of clicks.[/vc_column_text][/toggle][/toggles][/vc_column][vc_column right_padding_desktop="2vw" top_margin_tablet="10%" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="advanced" gradient_type="default"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color="#ff6b3d" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="15px" column_link_target="_self" overflow="hidden" advanced_gradient_radial_position="top right" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="default" gradient_type="advanced" advanced_gradient_display_type="radial"][nectar_animated_shape shape_color="#ffce59" width_desktop="65vw" animation="none" animation_easing="easeInOutCubic" animation_movement_type="transform_y" position_desktop="absolute" top_position_desktop="0" bottom_position_desktop="0" left_position_desktop="0" translate_y_desktop="10%" translate_x_desktop="-50%" zindex="-1" animation_offset="160%"][image_with_animation image_url="https://themenectar.com/img/demo-media/saas/saas-girl.webp" image_size="full" animation_type="entrance" animation="None" animation_movement_type="transform_y" animation_movement_intensity="-0.8" hover_animation="none" alignment="" border_radius="none" box_shadow="custom" box_shadow_method="filter" image_loading="default" max_width="100%" max_width_mobile="default" custom_box_shadow="horizontal:-25,vertical:5,blur:25,spread:0,opacity:0" margin_bottom="-10%" margin_top="5%"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row][vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#000000" scene_position="center" top_padding="10%" bottom_padding="10%" left_padding_desktop="6vw" constrain_group_2="yes" right_padding_desktop="6vw" top_padding_tablet="20%" bottom_padding_tablet="10%" text_color="light" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" advanced_gradient_angle="0" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" shape_type="" gradient_type="default"][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="0px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="default" gradient_type="default"][vc_row_inner equal_height="yes" content_placement="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bottom_padding="5%" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner right_padding_desktop="25%" bottom_margin_phone="30" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="2/3" tablet_width_inherit="small_desktop" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="advanced" gradient_type="default" offset="vc_col-lg-8 vc_col-md-6"][split_line_heading animation_type="line-reveal-by-space" font_style="h2" line_reveal_by_space_text_effect="default" stagger_animation="true" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="Scale your brand and earn more revenue" font_size="4vw"][/split_line_heading][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" bottom_margin_tablet="0" column_element_direction_desktop="default" column_element_spacing="10px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/6" tablet_width_inherit="small_desktop" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="default" gradient_type="default" delay="150" offset="vc_col-lg-2 vc_col-md-3"][vc_column_text]
<h5>Connect</h5>
[/vc_column_text][nectar_cta btn_style="underline" heading_tag="h4" button_color="default" button_border_thickness="0px" link_type="regular" alignment="left" alignment_tablet="default" alignment_phone="default" display="block" display_tablet="inherit" display_phone="inherit" icon_family="none" link_text="Testimonials" url="#features" margin_top="10" font_size_desktop="1.3vw" font_size_tablet="16px"][nectar_cta btn_style="underline" heading_tag="h4" button_color="default" button_border_thickness="0px" link_type="regular" alignment="left" alignment_tablet="default" alignment_phone="default" display="block" display_tablet="inherit" display_phone="inherit" icon_family="none" link_text="Features" url="#features" font_size_desktop="1.3vw" font_size_tablet="16px"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="10px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/6" tablet_width_inherit="small_desktop" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="default" gradient_type="default" delay="300" offset="vc_col-lg-2 vc_col-md-3"][vc_column_text]
<h5>Contact Us</h5>
[/vc_column_text][nectar_cta btn_style="underline" heading_tag="h4" button_color="default" button_border_thickness="0px" link_type="regular" alignment="left" alignment_tablet="default" alignment_phone="default" display="block" display_tablet="inherit" display_phone="inherit" icon_family="none" link_text="+216 (0)40 3629 4753" margin_top="10" font_size_desktop="1.3vw" font_size_tablet="16px"][nectar_cta btn_style="underline" heading_tag="h4" button_color="default" button_border_thickness="0px" link_type="regular" alignment="left" alignment_tablet="default" alignment_phone="default" display="block" display_tablet="inherit" display_phone="inherit" icon_family="none" link_text="hello@domain.com" font_size_desktop="1.3vw" font_size_tablet="16px"][/vc_column_inner][/vc_row_inner][vc_row_inner equal_height="yes" content_placement="top" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" bottom_margin_phone="30" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="2/3" tablet_width_inherit="small_desktop" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="default" gradient_type="default"][nectar_cta btn_style="text-reveal-wave" heading_tag="h6" button_color="accent-color" text_color="#ffffff" button_border_thickness="0px" link_type="regular" alignment="left" alignment_tablet="default" alignment_phone="default" constrain_group_3="yes" constrain_group_4="yes" display="block" display_tablet="inherit" display_phone="inherit" icon_family="none" font_size_desktop="1.1vw" link_text="Start your trial" url="#" padding_top="1em" padding_bottom="1em" padding_left="2.5em" padding_right="2.5em" font_size_tablet="16"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="small_desktop" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" mobile_disable_entrance_animation="true" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="default" gradient_type="default" delay="150" animation_offset="110%"][nectar_responsive_text]©  [nectar_current_year]. Website built with <a href="https://themenectar.com/salient">Salient</a>.[/nectar_responsive_text][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Happy FAQ Section', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['about'];
$data['custom_class'] = 'about date-7-July-2022';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/saas-faq.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" scene_position="center" top_padding="8%" left_padding_desktop="10%" constrain_group_2="yes" right_padding_desktop="10%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" gradient_type="default" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bottom_padding="4%" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" centered_text="true" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][nectar_highlighted_text style="none" custom_font_size="3vw" font_size_tablet="6vw" font_line_height="1.2"]
<h1>Frequently asked questions</h1>
[/nectar_highlighted_text][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row][vc_row type="full_width_content" full_screen_row_position="middle" column_margin="custom" column_margin_custom="7vw" equal_height="yes" content_placement="middle" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#f8f8f8" scene_position="center" top_padding="3%" bottom_padding="12%" left_padding_desktop="7vw" constrain_group_2="yes" right_padding_desktop="7vw" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" advanced_gradient_angle="0" overlay_strength="0.8" gradient_direction="left_to_right" shape_divider_color="#000000" shape_divider_position="bottom" shape_divider_height="99%" bg_image_animation="none" shape_type="straight_section" gradient_type="default"][vc_column left_padding_desktop="2vw" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="advanced" gradient_type="default"][toggles style="minimal_shadow" accordion="true" accordion_starting_functionality="default" border_radius="none"][toggle color="Accent-Color" heading_tag="h3" heading_tag_functionality="default" title="What does CRM mean?"][vc_column_text]CRM stands for Content Relationship Management. Using a CRM platform gives everyone involved in your business a way to manage customer interactions to increase growth.[/vc_column_text][/toggle][toggle color="Accent-Color" heading_tag="h3" heading_tag_functionality="default" title="Is it really free to start?"][vc_column_text]Yes! You can opt to stay within the free tier for as long as you want to. It's a great way to get a feel for the platform before deciding to upgrade to take advantage of the more advanced features.[/vc_column_text][/toggle][toggle color="Accent-Color" heading_tag="h3" heading_tag_functionality="default" title="Can I import data?"][vc_column_text]Yes! Getting your existing data in is easy. Simply export your existing customers to a .csv file and import them within a couple of clicks.[/vc_column_text][/toggle][/toggles][/vc_column][vc_column right_padding_desktop="2vw" top_margin_tablet="10%" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="advanced" gradient_type="default"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color="#ff6b3d" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="15px" column_link_target="_self" overflow="hidden" advanced_gradient_radial_position="top right" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="default" gradient_type="advanced" advanced_gradient_display_type="radial"][nectar_animated_shape shape_color="#ffce59" width_desktop="65vw" animation="none" animation_easing="easeInOutCubic" animation_movement_type="transform_y" position_desktop="absolute" top_position_desktop="0" bottom_position_desktop="0" left_position_desktop="0" translate_y_desktop="10%" translate_x_desktop="-50%" zindex="-1" animation_offset="160%"][image_with_animation image_url="https://themenectar.com/img/demo-media/saas/saas-girl.webp" image_size="full" animation_type="entrance" animation="None" animation_movement_type="transform_y" animation_movement_intensity="-0.8" hover_animation="none" alignment="" border_radius="none" box_shadow="custom" box_shadow_method="filter" image_loading="default" max_width="100%" max_width_mobile="default" custom_box_shadow="horizontal:-25,vertical:5,blur:25,spread:0,opacity:0" margin_bottom="-10%" margin_top="5%"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'Dark SAAS Footer', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-7-July-2022';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/saas-footer.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#000000" scene_position="center" top_padding="10%" bottom_padding="10%" left_padding_desktop="6vw" constrain_group_2="yes" right_padding_desktop="6vw" top_padding_tablet="20%" bottom_padding_tablet="10%" text_color="light" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" advanced_gradient_angle="0" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" shape_type="" gradient_type="default"][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="0px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="default" gradient_type="default"][vc_row_inner equal_height="yes" content_placement="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bottom_padding="5%" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner right_padding_desktop="25%" bottom_margin_phone="30" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="2/3" tablet_width_inherit="small_desktop" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="advanced" gradient_type="default" offset="vc_col-lg-8 vc_col-md-6"][split_line_heading animation_type="line-reveal-by-space" font_style="h2" line_reveal_by_space_text_effect="default" stagger_animation="true" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="Scale your brand and earn more revenue" font_size="4vw"][/split_line_heading][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" bottom_margin_tablet="0" column_element_direction_desktop="default" column_element_spacing="10px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/6" tablet_width_inherit="small_desktop" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="default" gradient_type="default" delay="150" offset="vc_col-lg-2 vc_col-md-3"][vc_column_text]
<h5>Connect</h5>
[/vc_column_text][nectar_cta btn_style="underline" heading_tag="h4" button_color="default" button_border_thickness="0px" link_type="regular" alignment="left" alignment_tablet="default" alignment_phone="default" display="block" display_tablet="inherit" display_phone="inherit" icon_family="none" link_text="Testimonials" url="#features" margin_top="10" font_size_desktop="1.3vw" font_size_tablet="16px"][nectar_cta btn_style="underline" heading_tag="h4" button_color="default" button_border_thickness="0px" link_type="regular" alignment="left" alignment_tablet="default" alignment_phone="default" display="block" display_tablet="inherit" display_phone="inherit" icon_family="none" link_text="Features" url="#features" font_size_desktop="1.3vw" font_size_tablet="16px"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="10px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/6" tablet_width_inherit="small_desktop" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="default" gradient_type="default" delay="300" offset="vc_col-lg-2 vc_col-md-3"][vc_column_text]
<h5>Contact Us</h5>
[/vc_column_text][nectar_cta btn_style="underline" heading_tag="h4" button_color="default" button_border_thickness="0px" link_type="regular" alignment="left" alignment_tablet="default" alignment_phone="default" display="block" display_tablet="inherit" display_phone="inherit" icon_family="none" link_text="+216 (0)40 3629 4753" margin_top="10" font_size_desktop="1.3vw" font_size_tablet="16px"][nectar_cta btn_style="underline" heading_tag="h4" button_color="default" button_border_thickness="0px" link_type="regular" alignment="left" alignment_tablet="default" alignment_phone="default" display="block" display_tablet="inherit" display_phone="inherit" icon_family="none" link_text="hello@domain.com" font_size_desktop="1.3vw" font_size_tablet="16px"][/vc_column_inner][/vc_row_inner][vc_row_inner equal_height="yes" content_placement="top" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" bottom_margin_phone="30" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="2/3" tablet_width_inherit="small_desktop" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="default" gradient_type="default"][nectar_cta btn_style="text-reveal-wave" heading_tag="h6" button_color="accent-color" text_color="#ffffff" button_border_thickness="0px" link_type="regular" alignment="left" alignment_tablet="default" alignment_phone="default" constrain_group_3="yes" constrain_group_4="yes" display="block" display_tablet="inherit" display_phone="inherit" icon_family="none" font_size_desktop="1.1vw" link_text="Start your trial" url="#" padding_top="1em" padding_bottom="1em" padding_left="2.5em" padding_right="2.5em" font_size_tablet="16"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="small_desktop" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" mobile_disable_entrance_animation="true" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="default" gradient_type="default" delay="150" animation_offset="110%"][nectar_responsive_text]©  [nectar_current_year]. Website built with <a href="https://themenectar.com/salient">Salient</a>.[/nectar_responsive_text][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Animated Gradient Hero', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['hero_section'] . ', ' . $cat_display_names['lottie'];
$data['custom_class'] = 'hero_section lottie date-7-July-2022';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/2022-promo-heading.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" equal_height="yes" content_placement="middle" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#edeef1" full_height="yes" columns_placement="stretch" animated_gradient_bg="true" animated_gradient_bg_color_1="#ffb71e" animated_gradient_bg_speed="850" animated_gradient_bg_blending_mode="linear" scene_position="center" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="hidden" advanced_gradient_angle="15" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="clip-path" clip_path_animation_type="default" clip_path_animation_applies="row" clip_path_start_top_desktop="0px" clip_path_start_bottom_desktop="0px" clip_path_start_left_desktop="0px" clip_path_start_right_desktop="0px" clip_path_end_top_desktop="30px" clip_path_end_bottom_desktop="30px" clip_path_end_left_desktop="30px" clip_path_end_right_desktop="30px" clip_path_end_top_phone="50px" clip_path_end_bottom_phone="24px" clip_path_end_left_phone="24px" clip_path_end_right_phone="24px" clip_path_start_roundness="0" clip_path_end_roundness="20px" clip_path_animation_addon="none" video_mute="true" shape_type="straight_section" gradient_type="default" bg_image_animation_delay="1000"][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="0px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="static" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="parallax" animation_movement_type="default" column_parallax_intensity="-4" bg_image_animation="none" parallax_bg="true" parallax_bg_speed="medium_fast" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" column_padding_type="default"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" top_padding="4%" bottom_padding="30" left_padding_desktop="22%" constrain_group_2="yes" right_padding_desktop="22%" left_padding_phone="14%" constrain_group_6="yes" right_padding_phone="14%" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_element_direction_desktop="default" column_element_spacing="default" centered_text="true" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="1" width="1/1" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="slight-twist" animation_easing="easeInOutCubic" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_color="rgba(255,255,255,0.22)" column_border_style="solid" gradient_type="default" column_padding_type="advanced" delay="200"][nectar_highlighted_text scribble_color="#000000" style="scribble" scribble_shape="basic-underline" scribble_thickness="thin" scribble_speed="1.6s" scribble_easing="ease_out" custom_font_size="6vw" delay="1000" font_size_tablet="6vw" font_line_height="1.1" font_size_phone="10vw"]
<h1><strong><em>Beautiful</em></strong> websites with less work</h1>
[/nectar_highlighted_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner left_padding_desktop="38%" constrain_group_101="yes" right_padding_desktop="38%" left_padding_tablet="30%" constrain_group_103="yes" right_padding_tablet="30%" left_padding_phone="20%" constrain_group_105="yes" right_padding_phone="20%" column_element_direction_desktop="default" column_element_spacing="default" centered_text="true" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="1" width="1/1" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="slight-twist" animation_easing="easeInOutCubic" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_color="rgba(255,255,255,0.22)" column_border_style="solid" gradient_type="default" column_padding_type="advanced"][split_line_heading animation_type="line-reveal-by-space" font_style="p" line_reveal_by_space_text_effect="default" stagger_animation="true" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="A next-generation WordPress theme that brings professional design results to anyone, without any coding required." font_size="1.2vw" font_line_height="1.6" animation_delay="1200" font_size_tablet="16"][/split_line_heading][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="absolute" row_position_tablet="inherit" row_position_phone="inherit" bottom_position_desktop="60" left_position_desktop="60" zindex="10" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="10px" centered_text="true" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" delay="1300" animation_offset="100%" column_padding_type="default" offset="vc_hidden-sm vc_hidden-xs"][nectar_circle_images images="https://themenectar.com/img/demo-media/unsplash/webp/ff1dfc85f81f.webp,https://themenectar.com/img/demo-media/unsplash/webp/fc2fcf082f87.webp,https://themenectar.com/img/demo-media/unsplash/webp/c5799533a786.webp,https://themenectar.com/img/demo-media/unsplash/webp/adf270f4f417.webp" sizing="40px" positioning="overlapping" stacking_order="ltr" alignment="left" animation="none" image_size="nectar_small_square" image_loading="default"][nectar_responsive_text]<strong>6k+ reviews</strong> (4.8 <em>of</em> 5)[/nectar_responsive_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" translate_x="-50%" text_align="left" row_position="absolute" row_position_tablet="inherit" row_position_phone="inherit" bottom_position_desktop="60" left_position_desktop="50%" zindex="10" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" delay="1500" animation_offset="100%" column_padding_type="default" offset="vc_hidden-lg vc_hidden-md"][nectar_cta btn_style="text-reveal-wave" heading_tag="span" button_color="default" button_border_thickness="0px" link_type="regular" alignment="left" alignment_tablet="default" alignment_phone="default" display="block" display_tablet="inherit" display_phone="inherit" icon_family="none" link_text="Scroll Down" url="#intro"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="absolute" row_position_tablet="inherit" row_position_phone="inherit" bottom_position_desktop="60" right_position_desktop="60" zindex="10" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="0px" centered_text="true" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" delay="1300" animation_offset="100%" column_padding_type="default" offset="vc_hidden-sm vc_hidden-xs"][nectar_lottie trigger_type="play" mobile_func="default" loop="true" trigger_offset="0.00,100.00" frame_constraint="0.00,100.00" speed="0.8" width_desktop="55px" alignment="center" preserve_aspect_ratio="xMidYMid meet" json_url="https://assets1.lottiefiles.com/packages/lf20_9r65d17y.json"][nectar_responsive_text font_line_height="1.3"]<strong>Salient</strong>[/nectar_responsive_text][nectar_responsive_text font_line_height="1.3" font_size_desktop="0.9em"]<em>by</em> ThemeNectar[/nectar_responsive_text][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Sticky Media Sections', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-7-July-2022';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/2022-promo-sticky-media.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#ffffff" scene_position="center" top_padding="7%" bottom_padding="10%" left_padding_desktop="6%" constrain_group_2="yes" right_padding_desktop="6%" left_padding_tablet="8%" constrain_group_4="yes" right_padding_tablet="8%" top_padding_phone="25%" left_padding_phone="24px" constrain_group_6="yes" right_padding_phone="24px" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" zindex="10" overflow="visible" id="features" advanced_gradient_angle="0" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_color="#0a0a0a" shape_divider_position="top" shape_divider_height="1" bg_image_animation="none" gradient_type="default" shape_type="straight_section"][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][nectar_sticky_media_sections content_position="right" content_spacing="45vh" media_width="60%" media_height="75vh" mobile_aspect_ratio="4-3" border_radius="15px"][nectar_sticky_media_section section_type="image" image="https://themenectar.com/img/demo-media/promo/sticky-media-1.jpg"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" top_padding="15vh" top_padding_tablet="0" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][split_line_heading animation_type="line-reveal-by-space" font_style="h2" line_reveal_by_space_text_effect="none" stagger_animation="true" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="Template library" font_size="3vw"][/split_line_heading][nectar_responsive_text font_size_min="16px" font_size_max="21px" font_size_desktop="1.2vw" font_line_height="1.7"]Not all templates are created equal. Salient offers access to a perpetually updated library of <strong>professional</strong> section templates, with currently over 400 to choose from — all created with passion and held to a high standard for aesthetic quality.[/nectar_responsive_text][/vc_column_inner][/vc_row_inner][/nectar_sticky_media_section][nectar_sticky_media_section section_type="image" image="https://themenectar.com/img/demo-media/promo/sticky-media-2.jpg"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][split_line_heading animation_type="line-reveal-by-space" font_style="h2" line_reveal_by_space_text_effect="none" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="Visual page builder" font_size="3vw"][/split_line_heading][nectar_responsive_text font_size_min="16px" font_size_max="21px" font_size_desktop="1.2vw" font_line_height="1.7"]Build like it's [nectar_current_year]. Experience a high-performing, modern take on the WPBakery page builder — The editor you already know, but with supercharged power to handle complex designs and the flexibility to <strong>create any type of website.</strong>[/nectar_responsive_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" top_padding="30" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][fancy-ul icon_type="standard_dot" alignment="left" spacing="10px" font_size_min="16px" font_size_max="21px" link_style="default" font_size_desktop="1.2vw"]
<ul>
 	<li>Set option values unique based on screen size</li>
 	<li>Sidebar &amp; modal editing layout options</li>
 	<li>Visually intuitive graphical settings UI</li>
 	<li>Front-end &amp; back-end editors</li>
 	<li>Reusable global sections</li>
 	<li>Tree-list element view</li>
</ul>
[/fancy-ul][/vc_column_inner][/vc_row_inner][/nectar_sticky_media_section][nectar_sticky_media_section section_type="image" image="https://themenectar.com/img/demo-media/promo/sticky-media-3.jpg"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][split_line_heading animation_type="line-reveal-by-space" font_style="h2" line_reveal_by_space_text_effect="none" stagger_animation="true" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="Premium elements" font_size="3vw"][/split_line_heading][nectar_responsive_text font_size_min="16px" font_size_max="21px" font_size_desktop="1.2vw" font_line_height="1.7"]A unique collection of over <strong>65 elements</strong> that make building a beautiful site easy. The Salient element set brings the latest web trends to your fingertips without any coding needed. We actively seek to bring fresh innovation by pushing the boundaries of what's possible on the web.[/nectar_responsive_text][/vc_column_inner][/vc_row_inner][/nectar_sticky_media_section][/nectar_sticky_media_sections][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'Trust-Building Section', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-5-July-2022';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/2022-promo-trusted.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#ffffff" animated_gradient_bg="true" animated_gradient_bg_color_1="#ffb10a" animated_gradient_bg_speed="850" animated_gradient_bg_blending_mode="linear" scene_position="center" top_padding="1%" bottom_padding="10%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" zindex="2" overflow="visible" id="trusted" advanced_gradient="linear-gradient(0deg, rgb(255,255,255) 4%, rgba(255,255,255,0) 30%, rgba(255,255,255,0) 75%, rgb(255,255,255) 96%)" shape_divider_position="bottom" bg_image_animation="none" gradient_type="advanced" shape_type="" advanced_gradient_display_type="linear"][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="0px" centered_text="true" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="static" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][carousel script="flickity" flickity_formatting="default" desktop_cols_flickity="6" desktop_small_cols_flickity="6" tablet_cols_flickity="5" phone_cols_flickity="4" flickity_controls="none" color="default" flickity_overflow="hidden" flickity_wrap_around="wrap" flickity_spacing="default" flickity_column_vertical_alignment="middle" column_padding="custom" column_padding_custom="4vw" flickity_element_spacing="default" border_radius="none" autorotate="true" autorotate_type="ticker" ticker_speed="slow"][item simple_slider_bg_image_position="default" simple_slider_overlay_strength="0.3" simple_slider_bg_image_loading="default" id="1659369460849-3" title="Item" tab_id="1659369460849-4"][image_with_animation image_url="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo.png" image_size="full" animation_type="entrance" animation="None" animation_movement_type="transform_y" hover_animation="none" alignment="" border_radius="none" box_shadow="none" image_loading="default" max_width="100%" max_width_mobile="default"][/item][item simple_slider_bg_image_position="default" simple_slider_overlay_strength="0.3" simple_slider_bg_image_loading="default" id="1659369460857-0" title="Item" tab_id="1659369460857-3"][image_with_animation image_url="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo.png" image_size="full" animation_type="entrance" animation="None" animation_movement_type="transform_y" hover_animation="none" alignment="" border_radius="none" box_shadow="none" image_loading="default" max_width="100%" max_width_mobile="default"][/item][item simple_slider_bg_image_position="default" simple_slider_overlay_strength="0.3" simple_slider_bg_image_loading="default" id="1659369460865-3" title="Item" tab_id="1659369460865-3"][image_with_animation image_url="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo.png" image_size="full" animation_type="entrance" animation="None" animation_movement_type="transform_y" hover_animation="none" alignment="" border_radius="none" box_shadow="none" image_loading="default" max_width="100%" max_width_mobile="default"][/item][item simple_slider_bg_image_position="default" simple_slider_overlay_strength="0.3" simple_slider_bg_image_loading="default" id="1659369460873-1" title="Item" tab_id="1659369460873-7"][image_with_animation image_url="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo.png" image_size="full" animation_type="entrance" animation="None" animation_movement_type="transform_y" hover_animation="none" alignment="" border_radius="none" box_shadow="none" image_loading="default" max_width="100%" max_width_mobile="default"][/item][item simple_slider_bg_image_position="default" simple_slider_overlay_strength="0.3" simple_slider_bg_image_loading="default" id="1659369460885-5" title="Item" tab_id="1659369460886-9"][image_with_animation image_url="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo.png" image_size="full" animation_type="entrance" animation="None" animation_movement_type="transform_y" hover_animation="none" alignment="" border_radius="none" box_shadow="none" image_loading="default" max_width="100%" max_width_mobile="default"][/item][item simple_slider_bg_image_position="default" simple_slider_overlay_strength="0.3" simple_slider_bg_image_loading="default" id="1659369460897-0" title="Item" tab_id="1659369460898-7"][image_with_animation image_url="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo.png" image_size="full" animation_type="entrance" animation="None" animation_movement_type="transform_y" hover_animation="none" alignment="" border_radius="none" box_shadow="none" image_loading="default" max_width="100%" max_width_mobile="default"][/item][item simple_slider_bg_image_position="default" simple_slider_overlay_strength="0.3" simple_slider_bg_image_loading="default" id="1659369460909-6" title="Item" tab_id="1659369460909-6"][image_with_animation image_url="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo.png" image_size="full" animation_type="entrance" animation="None" animation_movement_type="transform_y" hover_animation="none" alignment="" border_radius="none" box_shadow="none" image_loading="default" max_width="100%" max_width_mobile="default"][/item][/carousel][divider line_type="No Line" custom_height="8vh" custom_height_phone="2vh"][split_line_heading animation_type="line-reveal-by-space" font_style="h3" line_reveal_by_space_text_effect="none" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="Trusted by" font_size="6vw" font_line_height="1"][/split_line_heading][nectar_rotating_words_title heading_tag="h3" dynamic_text="130k websites, industry leaders, top designers" duration="3000" dynamic_heading_tag="default" element_animation="none" mobile_display="inline" font_size="6vw"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Features Grid #1', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'] . ', ' . $cat_display_names['lottie'];
$data['custom_class'] = 'general lottie date-6-July-2022';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/2022-promo-features-1.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="20px" equal_height="yes" content_placement="top" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#f0f2f6" scene_position="center" top_padding="4%" constrain_group_1="yes" bottom_padding="4%" left_padding_desktop="5%" constrain_group_2="yes" right_padding_desktop="5%" left_padding_phone="14px" constrain_group_6="yes" right_padding_phone="14px" bottom_margin="0" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" zindex="10" overflow="visible" advanced_gradient_angle="0" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" shape_type="" gradient_type="default"][vc_column top_padding_desktop="4vw" bottom_padding_desktop="1vw" left_padding_desktop="4vw" constrain_group_101="yes" right_padding_desktop="4vw" top_padding_tablet="8vw" left_padding_tablet="8vw" constrain_group_103="yes" right_padding_tablet="8vw" bottom_margin_tablet="20" column_element_direction_desktop="default" column_element_spacing="10px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color="#ffffff" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="20px" column_link_target="_self" column_position="default" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" column_padding_type="advanced"][nectar_badge display_tag="label" badge_style="default" bg_color_type="custom" bg_color_custom="#3452ff" text_color="#ffffff" padding="small" border_radius="20px" display="block" text="New" margin_bottom="20"][nectar_responsive_text font_size_desktop="1.8vw" font_size_tablet="22px" font_line_height="1.3"]
<h3>Lottie Integration</h3>
[/nectar_responsive_text][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner right_padding_tablet="33vw" right_padding_phone="0" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="advanced" gradient_type="default"][nectar_responsive_text font_size_min="14px" font_size_max="20px" font_size_desktop="1.1vw" font_line_height="1.5"]Tap into a vast library of free, beautiful animations or create your own using Adobe After Effects.[/nectar_responsive_text][/vc_column_inner][/vc_row_inner][nectar_lottie trigger_type="play" mobile_func="default" loop="true" trigger_offset="0.00,100.00" frame_constraint="0.00,100.00" speed="0.8" width_desktop="90%" width_tablet="70%" width_phone="90%" alignment="center" preserve_aspect_ratio="xMidYMid meet" json_url="https://assets2.lottiefiles.com/packages/lf20_f8xnmcvu.json"][/vc_column][vc_column top_padding_desktop="4vw" constrain_group_100="yes" bottom_padding_desktop="4vw" left_padding_desktop="4vw" constrain_group_101="yes" right_padding_desktop="4vw" top_padding_tablet="8vw" constrain_group_102="yes" bottom_padding_tablet="8vw" left_padding_tablet="8vw" constrain_group_103="yes" right_padding_tablet="8vw" bottom_margin_tablet="20" column_element_direction_desktop="default" column_element_spacing="10px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color="#3452ff" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" font_color="#ffffff" column_shadow="none" column_border_radius="20px" column_link_target="_self" column_position="default" advanced_gradient_angle="135" width="1/3" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="advanced" advanced_gradient_display_type="linear" column_padding_type="advanced"][nectar_responsive_text font_size_desktop="1.8vw" font_size_tablet="22px" font_line_height="1.3"]
<h3>Mega Menu Builder</h3>
[/nectar_responsive_text][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner right_padding_tablet="33vw" right_padding_phone="0" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="advanced" gradient_type="default"][nectar_responsive_text font_size_min="14px" font_size_max="20px" font_size_desktop="1.1vw" font_line_height="1.5"]Build gorgeous megamenus with columns, images, icons, and buttons all through an easy interface.[/nectar_responsive_text][/vc_column_inner][/vc_row_inner][image_with_animation image_url="https://themenectar.com/img/demo-media/promo/megamenu.webp" image_size="full" animation_type="entrance" animation="None" animation_movement_type="transform_y" hover_animation="none" alignment="center" border_radius="none" box_shadow="none" image_loading="default" max_width="110%" max_width_mobile="default" margin_top="13%"][/vc_column][vc_column top_padding_desktop="4vw" constrain_group_100="yes" bottom_padding_desktop="4vw" left_padding_desktop="4vw" constrain_group_101="yes" right_padding_desktop="4vw" top_padding_tablet="8vw" constrain_group_102="yes" bottom_padding_tablet="8vw" left_padding_tablet="8vw" constrain_group_103="yes" right_padding_tablet="8vw" column_element_direction_desktop="default" column_element_spacing="10px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color="#ffc444" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" font_color="#000000" column_shadow="none" column_border_radius="20px" column_link_target="_self" column_position="default" overflow="hidden" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="advanced" gradient_type="default"][nectar_responsive_text font_size_desktop="1.8vw" font_size_tablet="22px" font_line_height="1.3"]
<h3>Search With Substance</h3>
[/nectar_responsive_text][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner right_padding_tablet="33vw" right_padding_phone="0" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="advanced" gradient_type="default"][nectar_responsive_text font_size_min="14px" font_size_max="20px" font_size_desktop="1.1vw" font_line_height="1.5"]Advanced AJAX search functionality with multiple layout options that are capable of bringing up results in real-time.[/nectar_responsive_text][/vc_column_inner][/vc_row_inner][divider line_type="No Line" custom_height_tablet="60vw"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" min_width_desktop="152%" row_position="absolute" row_position_tablet="inherit" row_position_phone="inherit" bottom_position_desktop="-8%" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="custom" top_left_border_radius="20px" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="default" gradient_type="default"][image_with_animation image_url="https://themenectar.com/img/demo-media/promo/promo-search.jpg" image_size="full" animation_type="entrance" animation="None" animation_movement_type="transform_y" hover_animation="none" alignment="" border_radius="none" box_shadow="none" image_loading="default" max_width="100%" max_width_mobile="default"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Features Grid #2', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'] . ', ' . $cat_display_names['lottie'];
$data['custom_class'] = 'general lottie date-5-July-2022';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/2022-promo-features-2.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="20px" equal_height="yes" content_placement="top" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#f0f2f6" scene_position="center" top_padding="4%" constrain_group_1="yes" bottom_padding="4%" left_padding_desktop="5%" constrain_group_2="yes" right_padding_desktop="5%" left_padding_phone="14px" constrain_group_6="yes" right_padding_phone="14px" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" zindex="10" overflow="visible" advanced_gradient_angle="0" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" shape_type="" gradient_type="default"][vc_column top_padding_desktop="4vw" constrain_group_100="yes" bottom_padding_desktop="4vw" left_padding_desktop="4vw" constrain_group_101="yes" right_padding_desktop="4vw" top_padding_tablet="8vw" constrain_group_102="yes" bottom_padding_tablet="8vw" left_padding_tablet="8vw" constrain_group_103="yes" right_padding_tablet="8vw" bottom_margin_tablet="20" column_element_direction_desktop="default" column_element_spacing="0px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color="#ffffff" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="15px" column_link_target="_self" column_position="default" overflow="hidden" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="7/12" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_color="rgba(10,10,10,0.1)" column_border_style="solid" gradient_type="default" column_padding_type="advanced"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner right_padding_desktop="25%" right_padding_tablet="33vw" right_padding_phone="0" column_element_direction_desktop="default" column_element_spacing="10px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" font_color="#0a0000" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" column_padding_type="advanced"][nectar_responsive_text font_size_desktop="1.8vw" font_size_tablet="22px" font_line_height="1.3"]
<h3>Responsive Editing</h3>
[/nectar_responsive_text][nectar_responsive_text font_size_min="14px" font_size_max="20px" font_size_desktop="1.1vw" font_line_height="1.5"]Maximize your control and create intricate responsive layouts with the ability to control settings uniquely per each device viewport.[/nectar_responsive_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="relative" row_position_tablet="inherit" row_position_phone="inherit" top_position_desktop="10%" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" column_padding_type="default" gradient_type="default"][image_with_animation image_url="https://themenectar.com/img/demo-media/promo/promo-responsive.jpg" image_size="full" animation_type="entrance" animation="None" animation_movement_type="transform_y" hover_animation="none" alignment="" border_radius="none" box_shadow="none" image_loading="default" max_width="100%" max_width_mobile="default"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column top_padding_desktop="4vw" constrain_group_100="yes" bottom_padding_desktop="4vw" left_padding_desktop="4vw" constrain_group_101="yes" right_padding_desktop="4vw" top_padding_tablet="8vw" constrain_group_102="yes" bottom_padding_tablet="8vw" left_padding_tablet="8vw" constrain_group_103="yes" right_padding_tablet="8vw" column_element_direction_desktop="default" column_element_spacing="20px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color="#ffffff" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" font_color="#000000" column_shadow="none" column_border_radius="15px" column_link_target="_self" column_position="default" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="5/12" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_color="rgba(0,0,0,0.15)" column_border_style="solid" gradient_type="default" column_padding_type="advanced"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner right_padding_tablet="33vw" right_padding_phone="0" column_element_direction_desktop="default" column_element_spacing="10px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" font_color="#000000" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" column_padding_type="advanced"][nectar_badge display_tag="label" badge_style="default" bg_color_type="global" color="accent-color" text_color="#ffffff" padding="small" border_radius="20px" display="block" text="New" margin_bottom="20"][nectar_responsive_text font_size_desktop="1.8vw" font_size_tablet="22px" font_line_height="1.3"]
<h3>Global Sections</h3>
[/nectar_responsive_text][nectar_responsive_text font_size_min="14px" font_size_max="20px" font_size_desktop="1.1vw" font_line_height="1.5"]The easy way to manage a section that you place on multiple pages of your site. Edits made in one location will instantly reflect in all instances where the section is used.[/nectar_responsive_text][divider line_type="No Line" custom_height="1vh"][/vc_column_inner][/vc_row_inner][nectar_lottie trigger_type="play" mobile_func="default" trigger_offset="10.00,100.00" frame_constraint="0.00,100.00" width_desktop="80%" alignment="center" preserve_aspect_ratio="xMidYMid meet" enable_shadow="true" json_url="https://assets4.lottiefiles.com/packages/lf20_zxmqc93z.json" custom_box_shadow="horizontal:0,vertical:25,blur:14,spread:0,opacity:0.075"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'Features Grid #4', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-3-July-2022';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/2022-promo-features-4.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="20px" equal_height="yes" content_placement="top" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#f0f2f6" scene_position="center" top_padding="4%" constrain_group_1="yes" bottom_padding="4%" left_padding_desktop="5%" constrain_group_2="yes" right_padding_desktop="5%" left_padding_phone="14px" constrain_group_6="yes" right_padding_phone="14px" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" zindex="10" overflow="visible" advanced_gradient_angle="0" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" shape_type="" gradient_type="default"][vc_column top_padding_desktop="4vw" left_padding_desktop="4vw" constrain_group_101="yes" right_padding_desktop="4vw" top_padding_tablet="8vw" left_padding_tablet="8vw" constrain_group_103="yes" right_padding_tablet="8vw" bottom_margin_tablet="20" column_element_direction_desktop="default" column_element_spacing="20px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color="#ffc444" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" font_color="#000000" column_shadow="none" column_border_radius="15px" column_link_target="_self" column_position="default" overflow="hidden" advanced_gradient_angle="150" width="5/12" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_color="rgba(0,0,0,0.15)" column_border_style="solid" gradient_type="advanced" advanced_gradient_display_type="linear" column_padding_type="advanced"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner right_padding_tablet="33vw" right_padding_phone="0" column_element_direction_desktop="default" column_element_spacing="10px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" column_padding_type="advanced"][nectar_responsive_text font_size_desktop="1.8vw" font_size_tablet="22px" font_line_height="1.3"]
<div class="wpb_text_column wpb_content_element vc_custom_1490624298920">
<div class="wpb_wrapper">
<h3>Free Updates for Life</h3>
</div>
</div>
[/nectar_responsive_text][nectar_responsive_text font_size_min="14px" font_size_max="20px" font_size_desktop="1.1vw" font_line_height="1.5"]Over the past 10 years, we've consistently released updates with new features and fixes. You'll get free access to all future updates with a single purchase.[/nectar_responsive_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" min_width_desktop="100%" row_position="relative" row_position_tablet="inherit" row_position_phone="inherit" zindex="100" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][image_with_animation image_url="https://themenectar.com/img/demo-media/promo/promo-updates.png" image_size="full" animation_type="entrance" animation="None" animation_movement_type="transform_y" hover_animation="none" alignment="center" border_radius="none" box_shadow="none" image_loading="default" max_width="custom" max_width_custom="90%"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="0px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="15px" column_link_target="_self" column_position="default" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="7/12" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" column_padding_type="default"][vc_row_inner equal_height="yes" content_placement="top" column_margin="20px" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bottom_padding="20px" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all" css=".vc_custom_1659929996435{margin-bottom: 0px !important;}"][vc_column_inner top_padding_desktop="4vw" constrain_group_100="yes" bottom_padding_desktop="4vw" left_padding_desktop="4vw" right_padding_desktop="60%" top_padding_tablet="8vw" constrain_group_102="yes" bottom_padding_tablet="8vw" left_padding_tablet="8vw" right_padding_tablet="50%" right_padding_phone="40%" bottom_margin_tablet="0" column_element_direction_desktop="default" column_element_spacing="10px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color="#3452ff" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" font_color="#ffffff" column_shadow="none" column_border_radius="15px" column_link_target="_self" overflow="hidden" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" column_padding_type="advanced"][nectar_responsive_text font_size_desktop="1.8vw" font_size_tablet="22px" font_line_height="1.3"]
<h3>Google Fonts</h3>
[/nectar_responsive_text][nectar_responsive_text font_size_min="14px" font_size_max="20px" font_size_desktop="1.1vw" font_line_height="1.5"]Choose from over 1,400 Google fonts with powerful responsive typography settings.[/nectar_responsive_text][image_with_animation image_url="https://themenectar.com/img/demo-media/promo/promo-google-fonts-logo.webp" image_size="full" animation_type="entrance" animation="None" animation_movement_type="transform_y" hover_animation="none" alignment="right" border_radius="none" box_shadow="none" image_loading="default" max_width="custom" position_desktop="absolute" top_position_desktop="20%" right_position_desktop="5%" top_position_phone="50%" right_position_phone="10%" translate_y_phone="-50%" max_width_custom="23vw" max_width_custom_tablet="35vw" max_width_custom_phone="18vw"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner top_padding_desktop="4vw" constrain_group_100="yes" bottom_padding_desktop="4vw" left_padding_desktop="4vw" constrain_group_101="yes" right_padding_desktop="4vw" top_padding_tablet="8vw" constrain_group_102="yes" bottom_padding_tablet="8vw" left_padding_tablet="8vw" constrain_group_103="yes" right_padding_tablet="8vw" bottom_margin="0" column_element_direction_desktop="default" column_element_spacing="10px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color="#ffffff" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" font_color="#0a0000" column_shadow="none" column_border_radius="20px" column_link_target="_self" overflow="visible" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_color="rgba(0,0,0,0.15)" column_border_style="solid" gradient_type="default" column_padding_type="advanced"][nectar_responsive_text font_size_desktop="1.8vw" font_size_tablet="22px" font_line_height="1.3"]
<h3>Blazing Performance</h3>
[/nectar_responsive_text][nectar_responsive_text font_size_min="14px" font_size_max="20px" font_size_desktop="1.1vw" font_line_height="1.5"]Salient is Built with modern tooling and includes a suite of simple to use, yet powerful performance options created to target page speed scoring. View the report from <a href="#" target="_blank" rel="noopener"><strong>GTMetrix</strong></a> or <a href="#" target="_blank" rel="noopener"><strong>Google Lighthouse</strong></a>.[/nectar_responsive_text][divider line_type="No Line" custom_height="1vh"][nectar_lottie trigger_type="play" mobile_func="default" loop="true" trigger_offset="0.00,100.00" frame_constraint="0.00,100.00" speed="0.7" width_desktop="50%" width_phone="100%" alignment="left" preserve_aspect_ratio="xMidYMid meet" json_url="https://assets7.lottiefiles.com/packages/lf20_xui5jtgp.json"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Features Grid #5', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'] . ', ' . $cat_display_names['lottie'];
$data['custom_class'] = 'general lottie date-2-July-2022';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/2022-promo-features-5.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="20px" equal_height="yes" content_placement="top" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#f0f2f6" scene_position="center" top_padding="4%" constrain_group_1="yes" bottom_padding="4%" left_padding_desktop="5%" constrain_group_2="yes" right_padding_desktop="5%" left_padding_phone="14px" constrain_group_6="yes" right_padding_phone="14px" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" zindex="10" overflow="visible" advanced_gradient_angle="0" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" shape_type="" gradient_type="default"][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" bottom_margin_tablet="20px" column_element_direction_desktop="default" column_element_spacing="0px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color="#ffffff" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" font_color="#000000" column_shadow="none" column_border_radius="20px" column_link_target="_self" column_position="default" overflow="hidden" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_color="rgba(0,0,0,0.15)" column_border_style="solid" gradient_type="default" column_padding_type="default"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" right_padding_desktop="24%" right_padding_phone="0" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner top_padding_desktop="4vw" constrain_group_100="yes" bottom_padding_desktop="4vw" left_padding_desktop="4vw" constrain_group_101="yes" right_padding_desktop="4vw" top_padding_tablet="8vw" constrain_group_102="yes" bottom_padding_tablet="8vw" left_padding_tablet="8vw" constrain_group_103="yes" right_padding_tablet="8vw" bottom_margin="-5%" column_element_direction_desktop="default" column_element_spacing="10px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" column_padding_type="advanced"][nectar_responsive_text font_size_desktop="1.8vw" font_size_tablet="22px" font_line_height="1.3"]
<h3>Salient Help Center</h3>
[/nectar_responsive_text][nectar_responsive_text font_size_min="14px" font_size_max="20px" font_size_desktop="1.1vw" font_line_height="1.5"]We offer hands-on support with a professional team of agents to ensure that your questions get answered in a timely manner.[/nectar_responsive_text][/vc_column_inner][/vc_row_inner][image_with_animation image_url="https://themenectar.com/img/demo-media/promo/helpcenter.webp" image_size="full" animation_type="entrance" animation="None" animation_movement_type="transform_y" hover_animation="none" alignment="" border_radius="none" box_shadow="none" image_loading="default" max_width="custom"][/vc_column][vc_column top_padding_desktop="4vw" constrain_group_100="yes" bottom_padding_desktop="4vw" left_padding_desktop="4vw" right_padding_desktop="22vw" top_padding_tablet="8vw" constrain_group_102="yes" bottom_padding_tablet="8vw" left_padding_tablet="8vw" right_padding_tablet="50vw" right_padding_phone="33vw" column_element_direction_desktop="default" column_element_spacing="20px" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/promo/promo-docs.jpeg" background_image_position="center top" background_image_stacking="default" enable_bg_scale="true" background_image_loading="default" column_backdrop_filter="none" font_color="#ffffff" column_shadow="none" column_border_radius="20px" column_link_target="_self" column_position="default" overflow="hidden" advanced_gradient_angle="0" width="1/2" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" parallax_bg="true" parallax_bg_speed="minimum" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="advanced" advanced_gradient_display_type="linear" column_padding_type="advanced"][nectar_responsive_text font_size_desktop="1.8vw" font_size_tablet="22px" font_line_height="1.3"]
<h3>Demo Importer</h3>
[/nectar_responsive_text][nectar_responsive_text font_size_min="14px" font_size_max="20px" font_size_desktop="1.1vw" font_line_height="1.5"]Easily import any of the demos with one click via our simple demo importer plugin.[/nectar_responsive_text][divider line_type="No Line" custom_height="30vh"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Minimal FAQ', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-2-July-2022';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/2022-promo-faq.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" equal_height="yes" content_placement="middle" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#ffffff" scene_position="center" top_padding="12%" bottom_padding="12%" left_padding_desktop="25%" constrain_group_2="yes" right_padding_desktop="25%" left_padding_tablet="20%" constrain_group_4="yes" right_padding_tablet="20%" left_padding_phone="24px" constrain_group_6="yes" right_padding_phone="24px" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" zindex="10" overflow="visible" advanced_gradient_angle="0" overlay_strength="0.8" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" parallax_bg="true" parallax_bg_speed="fast" shape_type="" gradient_type="default"][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="right" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bottom_padding="3%" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" centered_text="true" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][nectar_responsive_text font_size_desktop="3vw" font_size_tablet="5vw" font_size_phone="8vw" font_line_height="1.1"]
<h3>Frequently asked questions</h3>
[/nectar_responsive_text][/vc_column_inner][/vc_row_inner][toggles style="minimal_shadow" accordion="true" accordion_starting_functionality="default" border_radius="20px"][toggle color="Default" heading_tag="h3" heading_tag_functionality="default" title="Was this site built with Salient?"][nectar_responsive_text font_size_min="14px" font_size_max="20px" font_size_desktop="1.1vw" font_line_height="1.6"]Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis ultricies metus sed turpis pulvinar eleifend. Pellentesque a tempor turpis, quis congue odio.[/nectar_responsive_text][/toggle][toggle color="Default" heading_tag="h3" heading_tag_functionality="default" title="Where can I purchase Salient?"][nectar_responsive_text font_size_min="14px" font_size_max="20px" font_size_desktop="1.1vw" font_line_height="1.6"]Proin accumsan mauris ut sem gravida, vel aliquam orci ornare. Cras sed urna neque. Vivamus mauris odio, pretium ac nunc a, ornare faucibus augue. Praesent quis lorem magna.[/nectar_responsive_text][/toggle][toggle color="Default" heading_tag="h3" heading_tag_functionality="default" title="What is included with my purchase?"][fancy-ul icon_type="standard_dot" alignment="left" spacing="5px" font_size_min="14px" font_size_max="20px" font_size_desktop="1.1vw" font_line_height="1.6"]
<ul>
 	<li>Lorem ipsum dolor sit amet, consectetur.</li>
 	<li> adipiscing elit. Duis ultricies metus .</li>
 	<li>sed turpis pulvinar eleifend. Pellentesque.</li>
 	<li>a tempor turpis, quis congue odio.</li>
 	<li><strong>Aliquam tristique, quam sed vulputate lobortis.</strong></li>
</ul>
[/fancy-ul][/toggle][toggle color="Default" heading_tag="h3" heading_tag_functionality="default" title="How can I get support after purchasing?"][nectar_responsive_text font_size_min="14px" font_size_max="20px" font_size_desktop="1.1vw" font_line_height="1.6"]Donec orci est, viverra a volutpat vel, tempus non ipsum. Donec pellentesque aliquam pharetra. Maecenas tincidunt molestie enim, quis fringilla nisi laoreet in. Etiam ac nibh eget odio porta laoreet a at dui.[/nectar_responsive_text][/toggle][toggle color="Default" heading_tag="h3" heading_tag_functionality="default" title="Why should I trust ThemeNectar?"][nectar_responsive_text font_size_min="14px" font_size_max="20px" font_size_desktop="1.1vw" font_line_height="1.6"]Aenean facilisis facilisis nulla, non accumsan mauris gravida faucibus. <strong>Sed commodo laoreet erat</strong>, id elementum ipsum. Aliquam erat volutpat. Nulla ac dignissim elit, sit amet sollicitudin eros. Cras facilisis neque nec dui dignissim congue. Vestibulum ac fringilla lorem. Nulla dignissim mollis consequat.[/nectar_responsive_text][/toggle][/toggles][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );






$data = array();
$data['name'] = esc_html__( 'Project Testimonial', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['portfolio'];
$data['custom_class'] = 'portfolio date-12-Nov-2021';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/architect-quote-image.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" equal_height="yes" content_placement="middle" column_direction="default" column_direction_tablet="default" column_direction_phone="default" scene_position="center" top_padding="10%" bottom_padding="5%" left_padding_desktop="5%" constrain_group_2="yes" right_padding_desktop="5%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" advanced_gradient_angle="0" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" gradient_type="default" shape_type=""][vc_column column_padding="padding-3-percent" column_padding_tablet="no-extra-padding" column_padding_phone="no-extra-padding" column_padding_position="right" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="7/12" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bottom_padding_tablet="40" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/webp/photo-1548248823-ce16a73b6d49.webp" background_image_position="center center" enable_bg_scale="true" background_image_loading="default" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" parallax_bg="true" parallax_bg_speed="very_subtle" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][divider line_type="No Line" custom_height="70vh" custom_height_tablet="50vh"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="padding-3-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="left" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="5/12" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][split_line_heading animation_type="line-reveal-by-space" font_style="h2" line_reveal_by_space_text_effect="none" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="The Outcome" font_size="3vw"][/split_line_heading][split_line_heading animation_type="line-reveal-by-space" font_style="p" line_reveal_by_space_text_effect="none" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="Lorem ipsum dolor sit amet, consectetur adipiscing elit. Pellentesque ante quam, ultrices nec vulputate et, egestas et quam. Lorem ipsum dolor sit amet, consectetur adipiscing elit." font_size="1.1vw" font_line_height="1.7" font_size_tablet="18" font_size_phone="16"][/split_line_heading][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" left_padding_desktop="8%" constrain_group_2="yes" right_padding_desktop="8%" left_padding_phone="0" constrain_group_6="yes" right_padding_phone="0" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][divider line_type="Vertical Line" divider_color="black" custom_height="35"][nectar_single_testimonial testimonial_style="basic" image="https://themenectar.com/img/demo-media/unsplash/webp/photo-1472099645785-5658abf4ff4e.webp" quote="Alex was there every step of the way and brought my vision further than I could have imagined!" name="Josh Margolis" subtitle="Founder of DAF"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'Project Header', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['portfolio'];
$data['custom_class'] = 'portfolio date-12-Nov-2021';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/architect-project-header.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#566678" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/photo-1535056074155-0004ae6c6283.webp" bg_position="center center" background_image_loading="default" bg_repeat="no-repeat" scene_position="center" top_padding="12%" constrain_group_1="yes" bottom_padding="12%" left_padding_desktop="10%" constrain_group_2="yes" right_padding_desktop="10%" top_padding_tablet="25%" text_color="light" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" enable_gradient="true" color_overlay="rgba(10,10,10,0.4)" color_overlay_2="#0a0a0a" advanced_gradient_angle="0" overlay_strength="0.95" gradient_direction="top_to_bottom" shape_divider_position="bottom" bg_image_animation="zoom-out-slow" parallax_bg="true" parallax_bg_speed="fast" gradient_type="default" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="0px" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][vc_row_inner column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" zindex="100" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][split_line_heading animation_type="line-reveal-by-space" font_style="h1" line_reveal_by_space_text_effect="letter-reveal-bottom" stagger_animation="true" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="Penn Center" font_size="8vw"][/split_line_heading][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" top_padding="1%" constrain_group_1="yes" bottom_padding="1%" left_padding_desktop="25%" constrain_group_2="yes" right_padding_desktop="25%" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" delay="300"][divider line_type="Vertical Line" divider_color="white" custom_height="50" custom_height_tablet="25"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" left_padding_desktop="30%" constrain_group_2="yes" right_padding_desktop="30%" left_padding_tablet="15%" constrain_group_4="yes" right_padding_tablet="15%" left_padding_phone="8%" constrain_group_6="yes" right_padding_phone="8%" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][split_line_heading animation_type="line-reveal-by-space" font_style="p" line_reveal_by_space_text_effect="default" stagger_animation="true" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="Lorem ipsum dolor sit amet, consectetur adipiscing elit. Pellentesque ante quam, ultrices nec vulputate et, egestas et quam. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque vestibulum, nunc in finibus condimentum." font_size="1.1vw" font_line_height="1.6" animation_delay="500" animation_offset="100%" font_size_tablet="18" font_size_phone="16"][/split_line_heading][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Company Culture List', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'] . ', ' . $cat_display_names['about'];
$data['custom_class'] = 'general about date-12-Nov-2021';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/architect-culture.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" scene_position="center" top_padding="5%" bottom_padding="5%" left_padding_desktop="6%" constrain_group_2="yes" right_padding_desktop="6%" top_padding_tablet="10%" bottom_padding_tablet="20%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" id="values" advanced_gradient_angle="0" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" shape_type="" gradient_type="default"][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][split_line_heading animation_type="line-reveal-by-space" font_style="h1" line_reveal_by_space_text_effect="letter-reveal-bottom" stagger_animation="true" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="Culture" font_size="9vw" font_size_tablet="8vw" font_size_phone="10vw"][/split_line_heading][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][divider line_type="Full Width Line" line_thickness="1" divider_color="black" animate="yes" custom_height="45"][/vc_column_inner][/vc_row_inner][vc_row_inner equal_height="yes" content_placement="middle" column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="padding-5-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="right" column_element_spacing="10px" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="2/3" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" offset="vc_col-xs-10"][nectar_highlighted_text color_type="gradient" highlight_color="#9ebee7" secondary_color="#dcf0ff" style="full_text" highlight_expansion="default" custom_font_size="2vw"]
<h2>Innovate each project with <strong><em>no exceptions</em></strong>.</h2>
[/nectar_highlighted_text][vc_column_text]Lorem ipsum dolor sit amet, consectetur adipiscing elit.[/vc_column_text][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" offset="vc_col-xs-2"][split_line_heading animation_type="line-reveal-by-space" font_style="h2" line_reveal_by_space_text_effect="letter-reveal-bottom" content_alignment="right" mobile_content_alignment="inherit" link_target="_self" text_content="01" font_size="7vw" font_line_height="1" font_size_phone="46" font_size_tablet="70"][/split_line_heading][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][divider line_type="Full Width Line" line_thickness="1" divider_color="black" animate="yes" custom_height="45"][/vc_column_inner][/vc_row_inner][vc_row_inner equal_height="yes" content_placement="middle" column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="padding-5-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="right" column_element_spacing="10px" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="2/3" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" offset="vc_col-xs-10"][nectar_highlighted_text color_type="gradient" highlight_color="#9ebee7" secondary_color="#dcf0ff" style="full_text" highlight_expansion="default" custom_font_size="2vw"]
<h2>Always <strong><em>overdeliver</em></strong> to our clients.</h2>
[/nectar_highlighted_text][vc_column_text]Vivamus risus quam, dapibus non libero eu, bibendum.[/vc_column_text][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" offset="vc_col-xs-2"][split_line_heading animation_type="line-reveal-by-space" font_style="h2" line_reveal_by_space_text_effect="letter-reveal-bottom" content_alignment="right" mobile_content_alignment="inherit" link_target="_self" text_content="02" font_size="7vw" font_line_height="1" font_size_phone="46" font_size_tablet="70"][/split_line_heading][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][divider line_type="Full Width Line" line_thickness="1" divider_color="black" animate="yes" custom_height="45"][/vc_column_inner][/vc_row_inner][vc_row_inner equal_height="yes" content_placement="middle" column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="padding-5-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="right" column_element_spacing="10px" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="2/3" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" offset="vc_col-xs-10"][nectar_highlighted_text color_type="gradient" highlight_color="#9ebee7" secondary_color="#dcf0ff" style="full_text" highlight_expansion="default" custom_font_size="2vw"]
<h2>Build things that <strong><em>inspire</em></strong> people.</h2>
[/nectar_highlighted_text][vc_column_text]Nam magna dui, venenatis dignissim pharetra.[/vc_column_text][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" offset="vc_col-xs-2"][split_line_heading animation_type="line-reveal-by-space" font_style="h2" line_reveal_by_space_text_effect="letter-reveal-bottom" content_alignment="right" mobile_content_alignment="inherit" link_target="_self" text_content="03" font_size="7vw" font_line_height="1" font_size_phone="46" font_size_tablet="70"][/split_line_heading][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Parallax Text and Image', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-12-Nov-2021';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/architect-text-image-3jpg.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" scene_position="center" top_padding="5%" constrain_group_1="yes" bottom_padding="5%" left_padding_desktop="6%" constrain_group_2="yes" right_padding_desktop="6%" top_padding_tablet="10%" constrain_group_3="yes" bottom_padding_tablet="10%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" id="about" advanced_gradient_angle="0" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" gradient_type="default" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_row_inner equal_height="yes" content_placement="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" bottom_margin_tablet="40" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/webp/photo-1610733374054-59454fe657cd.webp" background_image_position="center center" enable_bg_scale="true" background_image_loading="default" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="2/3" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" parallax_bg="true" parallax_bg_speed="very_subtle" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][divider line_type="No Line" custom_height_tablet="75vh"][/vc_column_inner][vc_column_inner column_padding="padding-6-percent" column_padding_tablet="no-extra-padding" column_padding_phone="no-extra-padding" column_padding_position="left" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="default" animation_type="parallax" animation_movement_type="default" column_parallax_intensity="1" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][divider line_type="No Line" custom_height="30vh" custom_height_tablet="0"][split_line_heading animation_type="line-reveal-by-space" font_style="h2" line_reveal_by_space_text_effect="default" stagger_animation="true" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="Modern Architecture" font_size="3vw"][/split_line_heading][split_line_heading animation_type="line-reveal-by-space" font_style="p" line_reveal_by_space_text_effect="none" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut elit tellus, luctus nec ullamcorper mattis, pulvinar dapibus leo. Lorem ipsum dolor sit amet, consectetur adipiscing elit." font_size="1.1vw" font_line_height="1.7" font_size_tablet="18" font_size_phone="16"][/split_line_heading][split_line_heading animation_type="line-reveal-by-space" font_style="p" line_reveal_by_space_text_effect="none" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="Ut elit tellus, luctus nec ullamcorper mattis, pulvinar dapibus leo. Lorem ipsum dolor sit amet, consectetur adipiscing elit." font_size="1.1vw" font_line_height="1.7" font_size_tablet="18" font_size_phone="16"][/split_line_heading][nectar_cta btn_style="arrow-animation" heading_tag="h6" text_color="#000000" button_color="default" button_border_color="#cccccc" button_border_color_hover="#0a0a0a" button_border_thickness="1px" link_type="regular" alignment="left" alignment_tablet="default" alignment_phone="default" constrain_group_3="yes" constrain_group_4="yes" display="block" display_tablet="inherit" display_phone="inherit" link_text="Contact Us" margin_top="50" padding_top="15" padding_bottom="15" padding_left="40" padding_right="40"][divider line_type="No Line" custom_height="30vh" custom_height_tablet="0" custom_height_phone="0"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Parallax Team Section', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general']  . ', ' . $cat_display_names['about'];
$data['custom_class'] = 'general about date-13-Nov-2021';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/architect-team.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" scene_position="center" top_padding="5%" bottom_padding="5%" left_padding_desktop="6%" constrain_group_2="yes" right_padding_desktop="6%" top_padding_tablet="10%" constrain_group_3="yes" bottom_padding_tablet="10%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" id="team" advanced_gradient_angle="0" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" gradient_type="default" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" sticky_content="true" sticky_content_functionality="css" sticky_content_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][split_line_heading animation_type="line-reveal-by-space" font_style="h2" line_reveal_by_space_text_effect="none" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="Meet The Team" font_size="3vw"][/split_line_heading][split_line_heading animation_type="line-reveal-by-space" font_style="p" line_reveal_by_space_text_effect="none" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="We're an award-winning multidisciplinary team based in Philadelphia with a passion for creating innovative architecture. We work with businesses and people to create a more beautiful world." font_size="1.1vw" font_line_height="1.7" font_size_tablet="18" font_size_phone="16"][/split_line_heading][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" left_padding_desktop="8%" constrain_group_2="yes" right_padding_desktop="8%" left_padding_phone="0" constrain_group_6="yes" right_padding_phone="0" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][divider line_type="Vertical Line" divider_color="black" custom_height="35"][nectar_single_testimonial testimonial_style="basic" image="https://themenectar.com/img/demo-media/unsplash/webp/photo-1545803928-04e3f4cdd4ed.webp" quote="Alex was there every step of the way and brought my vision further than I could have imagined!" name="Josh Margolis" subtitle="Founder of DAF"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="padding-6-percent" column_padding_tablet="no-extra-padding" column_padding_phone="no-extra-padding" column_padding_position="left" column_element_spacing="0px" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="2/3" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][vc_row_inner column_margin="30px" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bottom_padding="20" top_padding_tablet="40" bottom_padding_tablet="0" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="small_desktop" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][team_member image_url="https://themenectar.com/img/demo-media/unsplash/webp/photo-1633332755192-727a05c4013d.webp" bio_alt_image_url="https://themenectar.com/img/demo-media/unsplash/webp/photo-1633332755192-727a05c4013d.webp" team_memeber_style="bio_fullscreen_alt" bio_fullscreen_alt_parallax="true" bio_fullscreen_alt_hide_link_arrow="true" image_loading="default" team_member_bio_full_html="html" hide_link_arrow="true" name="Phil Martinez" job_position="CEO, Founder" image_size="regular" social_icon_1="fa fa-instagram" social_link_1="#" social_icon_2="fa fa-twitter" social_link_2="#"]Consectetur adipiscing elit. Etiam id mi faucibus, malesuada quam eget, facilisis turpis. Quisque ac purus erat.

Donec id pharetra tellus, vitae vehicula dolor. Aenean leo lorem, tempor vel mauris in, interdum fringilla erat. Nam auctor sodales dapibus. Ut et nibh sed neque lobortis mollis. Cras mauris tellus, ornare sed vestibulum eu, sagittis vitae justo. Vivamus pellentesque augue in orci commodo dignissim. Fusce id mi lacus.

Nullam ultricies mollis lorem, ac gravida diam pretium eget. Ut porttitor scelerisque lacus, a fringilla felis blandit sed.[/team_member][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="small_desktop" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][team_member image_url="https://themenectar.com/img/demo-media/unsplash/webp/photo-1580489944761-15a19d654956.webp" bio_alt_image_url="https://themenectar.com/img/demo-media/unsplash/webp/photo-1580489944761-15a19d654956.webp" team_memeber_style="bio_fullscreen_alt" bio_fullscreen_alt_parallax="true" bio_fullscreen_alt_hide_link_arrow="true" image_loading="default" team_member_bio_full_html="html" hide_link_arrow="true" name="Alex Smith" job_position="CFO, Partner" image_size="regular" social_icon_1="fa fa-facebook" social_link_1="#" social_icon_2="fa fa-envelope" social_link_2="#"]Consectetur adipiscing elit. Etiam id mi faucibus, malesuada quam eget, facilisis turpis. Quisque ac purus erat.Donec id pharetra tellus, vitae vehicula dolor. Aenean leo lorem, tempor vel mauris in, interdum fringilla erat.

Nam auctor sodales dapibus. Ut et nibh sed neque lobortis mollis. Cras mauris tellus, ornare sed vestibulum eu, sagittis vitae justo. Vivamus pellentesque augue in orci commodo dignissim. Fusce id mi lacus.

Nullam ultricies mollis lorem, ac gravida diam pretium eget. Ut porttitor scelerisque lacus, a fringilla felis blandit sed.[/team_member][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="30px" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all" css=".vc_custom_1634415872169{margin-bottom: 0px !important;}"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="small_desktop" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][team_member image_url="https://themenectar.com/img/demo-media/unsplash/webp/photo-1472099645785-5658abf4ff4e-2.webp" bio_alt_image_url="https://themenectar.com/img/demo-media/unsplash/webp/photo-1472099645785-5658abf4ff4e.webp" team_memeber_style="bio_fullscreen_alt" bio_fullscreen_alt_parallax="true" bio_fullscreen_alt_hide_link_arrow="true" image_loading="default" team_member_bio_full_html="html" hide_link_arrow="true" name="Kara Cohen" job_position="Associate" image_size="regular" social_icon_1="fa fa-facebook" social_link_1="#" social_icon_2="fa fa-instagram" social_link_2="#" social_icon_3="fa fa-github" social_link_3="#"]Quisque elit nisl, varius nec ullamcorper eget, egestas vitae mi. Nam hendrerit eros a sagittis tempus. Mauris hendrerit hendrerit consequat. Nunc eget dui pulvinar, auctor neque sed, convallis ipsum. Fusce sagittis, dui a malesuada ullamcorper, nulla dolor interdum ipsum.

Ac condimentum eros lacus vestibulum nunc. Nunc maximus, massa et dictum dictum, risus massa dignissim nisl, at vestibulum ligula ante id metus. Morbi fringilla rhoncus porta.[/team_member][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="small_desktop" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][team_member image_url="https://themenectar.com/img/demo-media/unsplash/webp/photo-1562124638-724e13052daf.webp" bio_alt_image_url="https://themenectar.com/img/demo-media/unsplash/webp/photo-1562124638-724e13052daf.webp" team_memeber_style="bio_fullscreen_alt" bio_fullscreen_alt_parallax="true" bio_fullscreen_alt_hide_link_arrow="true" image_loading="default" team_member_bio_full_html="html" hide_link_arrow="true" name="Justin Klein" job_position="Office Manager" image_size="regular" social_icon_1="fa fa-instagram" social_link_1="#"]Etiam nulla velit, pharetra vel leo a, pretium rhoncus eros. Fusce eu hendrerit ipsum, vitae volutpat dui. Nunc eget mi tincidunt, luctus turpis at, pharetra diam. Nam sit amet purus cursus, rhoncus nibh nec, volutpat purus. Orci varius natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Vestibulum id iaculis velit, vitae faucibus augue. In quis lectus nisi.[/team_member][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="small_desktop" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][team_member image_url="https://themenectar.com/img/demo-media/unsplash/webp/photo-1542327897-acbfd35f0163.webp" bio_alt_image_url="https://themenectar.com/img/demo-media/unsplash/webp/photo-1542327897-acbfd35f0163.webp" team_memeber_style="bio_fullscreen_alt" bio_fullscreen_alt_parallax="true" bio_fullscreen_alt_hide_link_arrow="true" image_loading="default" team_member_bio_full_html="html" hide_link_arrow="true" name="Andy Morris" job_position="Designer" image_size="regular" social_icon_1="fa fa-twitter" social_link_1="#" social_icon_2="fa fa-instagram" social_link_2="#"]Etiam nulla velit, pharetra vel leo a, pretium rhoncus eros. Fusce eu hendrerit ipsum, vitae volutpat dui. Nunc eget mi tincidunt, luctus turpis at, pharetra diam. Nam sit amet purus cursus, rhoncus nibh nec, volutpat purus. Orci varius natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Vestibulum id iaculis velit, vitae faucibus augue. In quis lectus nisi.

Quisque elit nisl, varius nec ullamcorper eget, egestas vitae mi. Nam hendrerit eros a sagittis tempus. Mauris hendrerit hendrerit consequat. Nunc eget dui pulvinar, auctor neque sed, convallis ipsum. Fusce sagittis, dui a malesuada ullamcorper, nulla dolor interdum ipsum, ac condimentum eros lacus vestibulum nunc. Nunc maximus, massa et dictum dictum, risus massa dignissim nisl, at vestibulum ligula ante id metus. Morbi fringilla rhoncus porta.[/team_member][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Clean text block', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-12-Nov-2021';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/architect-text-heading.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" scene_position="center" top_padding="10%" bottom_padding="5%" left_padding_desktop="27%" constrain_group_2="yes" right_padding_desktop="27%" top_padding_tablet="20%" bottom_padding_tablet="10%" left_padding_tablet="20%" constrain_group_4="yes" right_padding_tablet="20%" left_padding_phone="6%" constrain_group_6="yes" right_padding_phone="6%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" advanced_gradient_angle="0" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" gradient_type="default" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="0px" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][vc_row_inner column_margin="20px" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" bottom_margin="20" column_element_spacing="0px" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" animation_offset="80%"][vc_column_text]
<h5>COMPANY</h5>
[/vc_column_text][/vc_column_inner][/vc_row_inner][split_line_heading animation_type="line-reveal-by-space" font_style="h1" line_reveal_by_space_text_effect="default" stagger_animation="true" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="We are a professional architecture firm based in Philadelphia" font_size="4vw" font_size_phone="10vw"][/split_line_heading][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'Page Header With Anchor Links', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'] . ', ' . $cat_display_names['about'];
$data['custom_class'] = 'general about date-12-Nov-2021';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/architect-about-header.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" equal_height="yes" content_placement="middle" column_direction="default" column_direction_tablet="default" column_direction_phone="default" scene_position="center" top_padding="8%" bottom_padding="10%" left_padding_desktop="6%" constrain_group_2="yes" right_padding_desktop="6%" top_padding_tablet="20%" top_padding_phone="25%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" zindex="100" overflow="visible" advanced_gradient_angle="0" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="fade-in" gradient_type="default" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][vc_row_inner equal_height="yes" content_placement="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" bottom_margin_tablet="20" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="4/5" tablet_width_inherit="small_desktop" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" offset="vc_col-md-9"][split_line_heading animation_type="line-reveal-by-space" font_style="h1" line_reveal_by_space_text_effect="letter-reveal-bottom" stagger_animation="true" mobile_disable_animation="true" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="About Salient" font_size="9vw" font_size_tablet="9vw" font_size_phone="10vw"][/split_line_heading][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="10px" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/5" tablet_width_inherit="small_desktop" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" mobile_disable_entrance_animation="true" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" delay="500" offset="vc_col-md-3"][nectar_cta btn_style="underline" heading_tag="h6" text_color="#0a0a0a" button_color="default" button_border_thickness="0px" link_type="regular" alignment="left" alignment_tablet="default" alignment_phone="default" display="block" display_tablet="inherit" display_phone="inline-block" link_text="Team" url="#team" margin_right="25"][nectar_cta btn_style="underline" heading_tag="h6" text_color="#0a0a0a" button_color="default" button_border_thickness="0px" link_type="regular" alignment="left" alignment_tablet="default" alignment_phone="default" display="block" display_tablet="inherit" display_phone="inline-block" link_text="Values" url="#about" margin_right="25"][nectar_cta btn_style="underline" heading_tag="h6" text_color="#0a0a0a" button_color="default" button_border_thickness="0px" link_type="regular" alignment="left" alignment_tablet="default" alignment_phone="default" display="block" display_tablet="inherit" display_phone="inline-block" link_text="Culture" url="#values"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row][vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" scene_position="center" left_padding_desktop="6%" constrain_group_2="yes" right_padding_desktop="6%" top_margin="-5%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" advanced_gradient_angle="0" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" gradient_type="default" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/webp/photo-1556761175-4b46a572b786.webp" background_image_position="center bottom" enable_bg_scale="true" background_image_loading="default" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" mobile_disable_entrance_animation="true" bg_image_animation="none" parallax_bg="true" parallax_bg_speed="very_subtle" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" delay="600"][divider line_type="No Line" custom_height="100vh" custom_height_tablet="70vh" custom_height_phone="50vh"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );





$data = array();
$data['name'] = esc_html__( 'Parallax Typography Scene', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-12-Nov-2021';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/architect-typography-scene.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" scene_position="center" top_padding="15%" text_color="light" text_align="left" row_border_radius="none" row_border_radius_applies="bg" zindex="10" overflow="hidden" advanced_gradient="linear-gradient(183deg, rgb(158, 190, 231) 5%, rgb(220,240,255) 90%)" advanced_gradient_angle="183" shape_divider_position="bottom" bg_image_animation="slight-zoom-out-reveal" shape_type="" gradient_type="advanced" advanced_gradient_display_type="linear"][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="0px" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" zindex="10" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" translate_x="-13%" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" zindex="100" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="parallax" animation_movement_type="transform_x" column_parallax_intensity="2.5" persist_movement_on_mobile="true" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][nectar_scrolling_text scroll_direction="ltr" scroll_speed="slower" text_color="#ffffff" style="default" text_repeat_number="3" text_repeat_divider="none" overflow="visible" background_image_animation="None" custom_font_size="10vw" custom_font_size_mobile="11vw"]
<h1>salient architecture</h1>
[/nectar_scrolling_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="parallax" animation_movement_type="transform_x" column_parallax_intensity="-2.5" persist_movement_on_mobile="true" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][nectar_scrolling_text scroll_direction="rtl" scroll_speed="slower" text_color="#ffffff" style="default" text_repeat_number="3" text_repeat_divider="none" overflow="visible" background_image_animation="None" custom_font_size="10vw" custom_font_size_mobile="11vw"]
<h1>salient architecture</h1>
[/nectar_scrolling_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" top_margin="-20vw" top_margin_tablet="-23vw" column_element_spacing="default" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][image_with_animation image_url="https://themenectar.com/img/demo-media/architect/red-building-gPvqQOAOXCw.png" image_size="full" animation_type="entrance" animation="None" hover_animation="none" alignment="center" border_radius="none" box_shadow="none" image_loading="skip-lazy-load" max_width="100%" max_width_mobile="default"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'Sticky Text Vertical Post Grid', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'] . ', ' . $cat_display_names['portfolio'];
$data['custom_class'] = 'general portfolio date-12-Nov-2021';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/architect-portfolio-sticky.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" scene_position="center" top_padding="10%" constrain_group_1="yes" bottom_padding="10%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" shape_type="" gradient_type="default"][vc_column column_padding="padding-6-percent" column_padding_tablet="padding-5-percent" column_padding_phone="inherit" column_padding_position="left-right" column_element_spacing="default" sticky_content="true" sticky_content_functionality="css" sticky_content_alignment="middle" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][vc_row_inner column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bottom_padding="15" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][vc_column_text]
<h5>PORTFOLIO</h5>
[/vc_column_text][/vc_column_inner][/vc_row_inner][split_line_heading animation_type="line-reveal-by-space" font_style="h2" line_reveal_by_space_text_effect="default" stagger_animation="true" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="Making the world a more beautiful place." font_size="3vw" max_width="80%"][/split_line_heading][vc_row_inner column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bottom_padding_tablet="5%" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][nectar_cta btn_style="arrow-animation" heading_tag="h6" text_color="#000000" button_color="default" button_border_color="#cccccc" button_border_color_hover="#0a0a0a" button_border_thickness="1px" link_type="regular" alignment="left" alignment_tablet="default" alignment_phone="default" constrain_group_3="yes" constrain_group_4="yes" display="block" display_tablet="inherit" display_phone="inherit" link_text="View All Projects" margin_top="30" padding_top="15" padding_bottom="15" padding_left="40" padding_right="40" url="https://themenectar.com/salient/architect/salient-architect-projects/"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="no-extra-padding" column_padding_tablet="padding-5-percent" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="30px" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][nectar_post_grid post_type="post" blog_category="all" order="DESC" orderby="date" pagination="none" columns="1" grid_item_spacing="35px" grid_item_height="60vh" image_size="large" image_loading="default" animation="none" heading_tag="h3" enable_indicator="yes" mouse_indicator_style="default" mouse_indicator_text="view" mouse_indicator_color="#ff5149" display_categories="yes" category_functionality="static" category_position="default" display_excerpt="yes" grid_style="content_under_image" content_under_image_text_align="left" text_color="dark" hover_effect="animated_underline_zoom" border_radius="none" posts_per_page="3" custom_font_size="2vw"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Text with Inline Images', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-13-Nov-2021';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/architect-inline-images.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" scene_position="center" top_padding="6%" bottom_padding="12%" left_padding_desktop="27%" constrain_group_2="yes" right_padding_desktop="27%" bottom_padding_tablet="15%" left_padding_tablet="18%" constrain_group_4="yes" right_padding_tablet="18%" left_padding_phone="8%" constrain_group_6="yes" right_padding_phone="8%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" advanced_gradient_angle="0" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" gradient_type="default" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][nectar_text_inline_images images="" image_size="nectar_small_square" image_effect="circle_fade_in" image_loading="default" line_reveal_by_space_text_effect="" content_alignment="" font_style="h1" font_size="3vw" font_line_height="1.4" font_size_desktop="3vw" font_size_tablet="4vw" max_width="" font_size_phone="5vw"]
<h2>We're * changing the way <a href="#"><strong>architecture</strong></a> is * built for clients by utilizing Virtual Reality * to provide * immersive previews during our <a href="#"><strong>build process</strong></a>.</h2>
[/nectar_text_inline_images][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'Scrolling Text Heading', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-12-Nov-2021';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/architect-scrolling-text.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" scene_position="center" top_padding="5%" constrain_group_1="yes" bottom_padding="5%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="hidden" advanced_gradient_angle="0" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" gradient_type="default" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="0px" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][vc_row_inner column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" zindex="100" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="parallax" animation_movement_type="transform_x" column_parallax_intensity="3.5" persist_movement_on_mobile="true" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][nectar_scrolling_text scroll_direction="ltr" scroll_speed="slowest" text_color="#0a0a0a" style="text_outline" outline_thickness="ultra-thin" text_repeat_number="5" text_repeat_divider="none" overflow="visible" background_image_animation="None" custom_font_size="11vw" custom_font_size_mobile="15vw"]
<h1><em>innovation </em></h1>
[/nectar_scrolling_text][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Parallax Images and Text Alt', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'] . ', ' . $cat_display_names['about'];
$data['custom_class'] = 'general about date-12-Nov-2021';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/architect-images-and-text-2.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" equal_height="yes" content_placement="middle" column_direction="default" column_direction_tablet="default" column_direction_phone="default" scene_position="center" top_padding="6%" constrain_group_1="yes" bottom_padding="6%" left_padding_tablet="8%" constrain_group_4="yes" right_padding_tablet="8%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" advanced_gradient_angle="0" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" gradient_type="default" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="0px" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" right_padding_desktop="20%" right_padding_tablet="10%" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/webp/photo-1556761175-4b46a572b786.webp" background_image_position="center center" enable_bg_scale="true" background_image_loading="default" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" parallax_bg="true" parallax_bg_speed="very_subtle" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][divider line_type="No Line" custom_height="90vh" custom_height_tablet="70vh" custom_height_phone="60vh"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" translate_y="-50%" text_align="left" min_width_desktop="40%" row_position="absolute" row_position_tablet="inherit" row_position_phone="inherit" top_position_desktop="50%" right_position_desktop="0" zindex="50" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/webp/photo-1636366312163-456bd30acd11.webp" background_image_position="center center" enable_bg_scale="true" background_image_loading="default" column_shadow="x_large_depth" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="parallax" animation_movement_type="default" column_parallax_intensity="2.25" persist_movement_on_mobile="true" bg_image_animation="none" parallax_bg="true" parallax_bg_speed="very_subtle" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][divider line_type="No Line" custom_height="50vh" custom_height_tablet="40vh" custom_height_phone="35vh"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="padding-8-percent" column_padding_tablet="no-extra-padding" column_padding_phone="no-extra-padding" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][vc_row_inner column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bottom_padding="10" top_padding_tablet="7%" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][vc_column_text]
<h5>COMMERICAL</h5>
[/vc_column_text][/vc_column_inner][/vc_row_inner][split_line_heading animation_type="line-reveal-by-space" font_style="h2" text_color="#000000" line_reveal_by_space_text_effect="default" stagger_animation="true" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="We create structural beauty by innovating" font_size="3vw"][/split_line_heading][vc_row_inner column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][split_line_heading animation_type="line-reveal-by-space" font_style="p" line_reveal_by_space_text_effect="none" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="Aliquam non lectus id purus cursus porta. Nullam vel felis elementum, ornare magna non, feugiat ex. Phasellus erat ligula, laoreet sit amet magna vel, aliquet facilisis libero." font_size="1.1vw" font_line_height="1.7" font_size_tablet="18px" font_size_phone="16px"][/split_line_heading][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" top_padding="30" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][nectar_badge display_tag="label" bg_color_type="custom" bg_color_custom="#efefef" text_color="#1e1c1c" padding="medium" border_radius="20px" display="inline" text="Award Winning" margin_bottom="15" margin_right="15"][nectar_badge display_tag="label" bg_color_type="custom" bg_color_custom="#efefef" text_color="#1e1c1c" padding="medium" border_radius="20px" display="inline" text="Established Team" margin_bottom="15" margin_right="15"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Architect Carousel', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'] . ', ' . $cat_display_names['services'];
$data['custom_class'] = 'general services date-12-Nov-2021';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/architect-carousel-1.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" scene_position="center" top_padding="6%" bottom_padding="6%" left_padding_desktop="8%" right_padding_desktop="8%" top_padding_tablet="10%" bottom_padding_tablet="15%" left_padding_tablet="8%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="hidden" advanced_gradient_angle="0" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_color="#000000" shape_divider_position="top" bg_image_animation="none" shape_type="straight_section" gradient_type="default"][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="0px" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][carousel script="flickity" flickity_formatting="default" desktop_cols_flickity="4" desktop_small_cols_flickity="3" tablet_cols_flickity="2" flickity_controls="touch_total" flickity_touch_total_style="solid_bg" flickity_touch_total_indicator_bg_color="#ff5149" flickity_touch_total_indicator_icon_color="#ffffff" flickity_touch_total_hide_indicator="true" color="default" flickity_overflow="visible" flickity_wrap_around="no-wrap" flickity_spacing="15px" flickity_column_vertical_alignment="default" column_padding="0" flickity_element_spacing="0" flickity_image_scale_on_drag="true" border_radius="none"][item simple_slider_bg_image_position="default" simple_slider_overlay_strength="0.3" simple_slider_bg_image_loading="default" id="1636930600818-5" title="Item" tab_id="1636930600818-9"][fancy_box box_style="image_above_text_underline" image_url="https://themenectar.com/img/demo-media/unsplash/webp/photo-1610733374054-59454fe657cd.webp" image_aspect_ratio="4-5" content_color="#000000" border_radius="default" image_loading="default" enable_animation="true" animation="fade-in-from-right" image_size="large" link_url="" link_screen_reader="Daily anti-aging cream"]
<h4>Perfect Exterior Lines</h4>
Lorem ipsum dolor sit amet, consectetur adipiscing elit.[/fancy_box][/item][item simple_slider_bg_image_position="default" simple_slider_overlay_strength="0.3" simple_slider_bg_image_loading="default" id="1636930600875-9" title="Item" tab_id="1636930600876-10"][fancy_box box_style="image_above_text_underline" image_url="https://themenectar.com/img/demo-media/unsplash/webp/photo-1622372738946-62e02505feb3.webp" image_aspect_ratio="4-5" content_color="#000000" border_radius="default" image_loading="default" enable_animation="true" animation="fade-in-from-right" image_size="large" delay="100"]
<h4>Square footage optimzation</h4>
Praesent porttitor pharetra sodales. Sed quam elit, congue eget est.[/fancy_box][/item][item simple_slider_bg_image_position="default" simple_slider_overlay_strength="0.3" simple_slider_bg_image_loading="default" id="1636930600904-0" title="Item" tab_id="1636930600906-2"][fancy_box box_style="image_above_text_underline" image_url="https://themenectar.com/img/demo-media/unsplash/webp/photo-1604014237744-2f4ab6bfbcc2.webp" image_aspect_ratio="4-5" content_color="#000000" border_radius="default" image_loading="default" enable_animation="true" animation="fade-in-from-right" image_size="large" delay="200"]
<h4>Aesthetic layouts</h4>
Vivamus tempor a mauris a consectetur. Duis lorem mauris, feugiat.[/fancy_box][/item][item simple_slider_bg_image_url="https://themenectar.com/img/demo-media/unsplash/webp/photo-1604014237256-11d475e2a2d8.webp" simple_slider_bg_image_position="default" simple_slider_overlay_strength="0.3" simple_slider_bg_image_loading="default" id="1636930600937-2" title="Item" tab_id="1636930600938-7"][fancy_box box_style="image_above_text_underline" image_url="https://themenectar.com/img/demo-media/unsplash/webp/photo-1525440584458-b53d13a848de.webp" image_aspect_ratio="4-5" content_color="#000000" border_radius="default" image_loading="default" enable_animation="true" animation="fade-in-from-right" image_size="large" delay="300"]
<h4>Natural light utilization</h4>
interdum accumsan libero. Etiam pretium laoreet tincidunt. Morbi semper quam orci.[/fancy_box][/item][item simple_slider_bg_image_position="default" simple_slider_overlay_strength="0.3" simple_slider_bg_image_loading="default" id="1636930600970-8" title="Item" tab_id="1636930600971-9"][fancy_box box_style="image_above_text_underline" image_url="https://themenectar.com/img/demo-media/unsplash/webp/photo-1549407704-aeb7ffce9a76.webp" image_aspect_ratio="4-5" content_color="#000000" border_radius="default" image_loading="default" enable_animation="true" animation="fade-in-from-right" image_size="large" delay="400"]
<h4>Precise details in every room</h4>
Praesent a urna non quam commodo scelerisque. Donec iaculis nunc.[/fancy_box][/item][item simple_slider_bg_image_position="default" simple_slider_overlay_strength="0.3" simple_slider_bg_image_loading="default" id="1636930600999-6" title="Item" tab_id="1636930601000-1"][fancy_box box_style="image_above_text_underline" image_url="https://themenectar.com/img/demo-media/unsplash/webp/photo-1556761175-4b46a572b786.webp" image_aspect_ratio="4-5" content_color="#000000" border_radius="default" image_loading="default" enable_animation="true" animation="fade-in-from-right" image_size="large" delay="500"]
<h4>Ultra modern designs</h4>
Donec venenatis faucibus nibh ut tristique. Mauris odio augue, pulvinar quis lacus at.[/fancy_box][/item][/carousel][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'Parallax Images and Text', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'] . ', ' . $cat_display_names['about'];
$data['custom_class'] = 'general about date-12-Nov-2021';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/architect-images-and-text-1.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" equal_height="yes" content_placement="middle" column_direction="default" column_direction_tablet="column_reverse" column_direction_phone="column_reverse" scene_position="center" top_padding="12%" bottom_padding="6%" left_padding_tablet="8%" constrain_group_4="yes" right_padding_tablet="8%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" advanced_gradient_angle="0" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" gradient_type="default" shape_type=""][vc_column column_padding="padding-8-percent" column_padding_tablet="no-extra-padding" column_padding_phone="no-extra-padding" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][vc_row_inner column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bottom_padding="10" top_padding_tablet="8%" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][vc_column_text]
<h5>RESIDENTIAL</h5>
[/vc_column_text][/vc_column_inner][/vc_row_inner][split_line_heading animation_type="line-reveal-by-space" font_style="h2" text_color="#000000" line_reveal_by_space_text_effect="default" stagger_animation="true" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="Iconic architecture expertly developed" font_size="3vw"][/split_line_heading][vc_row_inner column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" right_padding_tablet="25%" right_padding_phone="0" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="0px" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][split_line_heading animation_type="line-reveal-by-space" font_style="p" line_reveal_by_space_text_effect="none" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aliquam fringilla est sapien, nec semper neque auctor nec. Duis vehicula quis mi at vehicula. Vivamus at." font_size="1.1vw" font_line_height="1.7" font_size_tablet="18px" font_size_phone="16px"][/split_line_heading][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" top_padding="50" top_padding_tablet="30" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="0px" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="small_desktop" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" offset="vc_col-xs-4"][split_line_heading animation_type="line-reveal-by-space" font_style="h2" line_reveal_by_space_text_effect="default" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="30+" font_size="2.5vw" font_line_height="1" animation_delay="200"][/split_line_heading][split_line_heading animation_type="line-reveal-by-space" font_style="p" line_reveal_by_space_text_effect="default" stagger_animation="true" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="Years of experience" font_size="1.1vw" font_line_height="1.5" animation_delay="300" max_width="60%" font_size_tablet="16px" font_size_phone="13px"][/split_line_heading][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="0px" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="small_desktop" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" offset="vc_col-xs-4"][split_line_heading animation_type="line-reveal-by-space" font_style="h2" line_reveal_by_space_text_effect="default" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="10x" font_size="2.5vw" font_line_height="1" animation_delay="200"][/split_line_heading][split_line_heading animation_type="line-reveal-by-space" font_style="p" line_reveal_by_space_text_effect="default" stagger_animation="true" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="Builder of the year" font_size="1.1vw" font_line_height="1.5" max_width="55%" animation_delay="300" font_size_tablet="16px" font_size_phone="13px"][/split_line_heading][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" offset="vc_hidden-sm vc_hidden-xs"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="0px" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" left_padding_desktop="20%" left_padding_tablet="10%" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/webp/photo-1549407294-0bf7c458df48.webp" background_image_position="center center" enable_bg_scale="true" background_image_loading="default" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" parallax_bg="true" parallax_bg_speed="very_subtle" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][divider line_type="No Line" custom_height="90vh" custom_height_tablet="70vh" custom_height_phone="60vh"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" translate_y="-50%" text_align="left" min_width_desktop="40%" row_position="absolute" row_position_tablet="inherit" row_position_phone="inherit" top_position_desktop="50%" left_position_desktop="0" zindex="50" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/webp/photo-1600585153206-c6ff50dfb3c6.webp" background_image_position="center center" enable_bg_scale="true" background_image_loading="default" column_shadow="x_large_depth" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="parallax" animation_movement_type="default" column_parallax_intensity="2.25" persist_movement_on_mobile="true" bg_image_animation="none" parallax_bg="true" parallax_bg_speed="very_subtle" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][divider line_type="No Line" custom_height="50vh" custom_height_tablet="40vh" custom_height_phone="35vh"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'Fullscreen Video Hero', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['hero_section'];
$data['custom_class'] = 'hero_section date-13-Nov-2021';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/architect-landing-header.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#2b323a" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/photo-1449247666642-264389f5f5b1.webp" bg_position="left top" background_image_loading="default" bg_repeat="no-repeat" full_height="yes" scene_position="center" left_padding_desktop="8%" constrain_group_2="yes" right_padding_desktop="8%" text_color="light" text_align="left" row_border_radius="none" row_border_radius_applies="bg" zindex="100" overflow="hidden" color_overlay="rgba(0,0,0,0.78)" advanced_gradient_angle="0" overlay_strength="0.8" gradient_direction="radial" shape_divider_position="bottom" bg_image_animation="fade-in" mobile_disable_bg_image_animation="true" shape_type="" gradient_type="default"][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="top-bottom" column_element_spacing="0px" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="static" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][vc_row_inner column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" left_padding_desktop="13vw" constrain_group_2="yes" right_padding_desktop="13vw" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" zindex="10" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][split_line_heading animation_type="line-reveal-by-space" font_style="h1" line_reveal_by_space_text_effect="letter-reveal-bottom" stagger_animation="true" mobile_disable_animation="true" content_alignment="left" mobile_content_alignment="inherit" link_target="_self" text_content="Rethink architecture." font_size="9vw" font_line_height="0.95" font_size_tablet="10vw" animation_delay="150"][/split_line_heading][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" translate_y="55%" translate_x="-50%" text_align="left" min_width_desktop="175px" row_position="absolute" row_position_tablet="inherit" row_position_phone="inherit" bottom_position_desktop="0" left_position_desktop="50%" zindex="100" overflow="visible" pointer_events="all"][vc_column_inner column_padding="padding-2-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="1" width="1/1" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" mobile_disable_entrance_animation="true" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" mobile_disable_animation="true" gradient_type="default" column_link="#section-two" delay="600" animation_offset="100%"][image_with_animation image_url="https://themenectar.com/img/demo-media/spinners/scroll-down-light.png" image_size="full" animation_type="looped" loop_animation="rotate" hover_animation="none" alignment="" border_radius="none" image_loading="skip-lazy-load" max_width="custom" max_width_custom="175"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'Minimal Blog Grid', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['blog'];
$data['custom_class'] = 'blog date-11-Nov-2021';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/resort-news-full.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" scene_position="center" top_padding="175" bottom_padding="3%" top_padding_tablet="25%" top_padding_phone="35%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" advanced_gradient_angle="0" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" shape_type="straight_section" gradient_type="default"][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="top-bottom" column_element_spacing="0px" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][vc_row_inner column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" left_padding_desktop="8%" constrain_group_2="yes" right_padding_desktop="8%" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="0px" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][split_line_heading animation_type="line-reveal-by-space" font_style="h1" line_reveal_by_space_text_effect="letter-reveal-bottom" mobile_disable_animation="true" content_alignment="center" mobile_content_alignment="inherit" link_target="_self" text_content="THE" font_size="13vw" font_line_height="0.8" font_size_tablet="13vw"][/split_line_heading][split_line_heading animation_type="line-reveal-by-space" font_style="h1" line_reveal_by_space_text_effect="letter-reveal-bottom" mobile_disable_animation="true" content_alignment="center" mobile_content_alignment="inherit" link_target="_self" text_content="NEWS" font_size="13vw" font_line_height="0.8" animation_delay="150" font_size_tablet="13vw"][/split_line_heading][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row][vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" scene_position="center" left_padding_desktop="5%" constrain_group_2="yes" right_padding_desktop="5%" left_padding_phone="0" constrain_group_6="yes" right_padding_phone="0" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" advanced_gradient_angle="0" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" gradient_type="default" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" mobile_disable_entrance_animation="true" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" delay="500" animation_offset="99%"][nectar_post_grid post_type="post" blog_category="all" order="DESC" orderby="date" pagination="load-more" button_color="black" columns="3" grid_item_spacing="35px" grid_item_height="50vh" image_size="full" aspect_ratio_image_size="yes" custom_image_aspect_ratio="3-2" image_loading="default" animation="none" heading_tag="default" enable_indicator="yes" mouse_indicator_style="default" mouse_indicator_text="read" mouse_indicator_color="#eddecc" mouse_indicator_text_color="#000000" display_categories="yes" category_functionality="default" category_position="default" display_excerpt="yes" grid_style="content_under_image" content_under_image_text_align="left" text_color="dark" hover_effect="animated_underline_zoom" border_radius="none" shadow_on_hover="yes" custom_font_size="2.8vw" posts_per_page="12"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Parallax Image Gallery With Captions', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-11-Nov-2021';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/resort-image-gallery.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" scene_position="center" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" advanced_gradient_angle="0" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" gradient_type="default" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="0px" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" animation_type="default" enable_animation="true" animation="fade-in" mobile_disable_entrance_animation="true" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" delay="800"][vc_gallery type="flickity_static_height_style" images="" flickity_spacing="10px" flickity_controls="touch_total_alt" flickity_touch_total_style="solid_bg" flickity_touch_total_indicator_bg_color="#f4ece2" flickity_touch_total_indicator_icon_color="#000000" flickity_overflow="hidden" flickity_wrap_around="wrap" flickity_image_parallax="true" flickity_box_shadow="none" image_loading="default" display_title_caption="true" onclick="link_image" flickity_img_height="70vh" flickity_img_small_desktop_height="70vh" flickity_img_tablet_height="40vh" flickity_img_mobile_height="250px"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Large Animated Header', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-11-Nov-2021';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/resort-page-heading.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" scene_position="center" top_padding="175" top_padding_tablet="25%" top_padding_phone="35%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" advanced_gradient_angle="0" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" shape_type="straight_section" gradient_type="default"][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="top-bottom" column_element_spacing="0px" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][vc_row_inner column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" left_padding_desktop="8%" constrain_group_2="yes" right_padding_desktop="8%" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="0px" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][split_line_heading animation_type="line-reveal-by-space" font_style="h1" line_reveal_by_space_text_effect="letter-reveal-bottom" mobile_disable_animation="true" content_alignment="center" mobile_content_alignment="inherit" link_target="_self" text_content="RESORT" font_size="13vw" font_line_height="0.8" font_size_tablet="13vw"][/split_line_heading][split_line_heading animation_type="line-reveal-by-space" font_style="h1" line_reveal_by_space_text_effect="letter-reveal-bottom" mobile_disable_animation="true" content_alignment="center" mobile_content_alignment="inherit" link_target="_self" text_content="GALLERY" font_size="13vw" font_line_height="0.8" animation_delay="200" font_size_tablet="13vw"][/split_line_heading][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" top_padding="3%" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" mobile_disable_entrance_animation="true" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" delay="600"][vc_column_text]
<h5>Explore the resort</h5>
[/vc_column_text][divider line_type="Vertical Line" divider_color="black" custom_height="100" custom_height_tablet="60" custom_height_phone="50"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Scrolling Tabbed Rooms', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-11-Nov-2021';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/resort-vertical-tabbed-2.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" scene_position="center" top_padding="6%" bottom_padding="8%" left_padding_desktop="8%" left_padding_tablet="8%" constrain_group_4="yes" right_padding_tablet="8%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" advanced_gradient_angle="0" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" shape_type="" gradient_type="default"][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" animation_type="default" enable_animation="true" animation="fade-in" mobile_disable_entrance_animation="true" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" delay="400"][tabbed_section style="vertical_scrolling" tab_color="Accent-Color" vs_navigation_func="active_link_only" vs_navigation_width="regular" vs_tab_spacing="35%" vs_tab_tag="h2" vs_cta_style="text-reveal-wave" vs_cta_text_color="#0a0a0a" vs_cta_bg_color="accent-color" vs_cta_heading_tag="h5" vs_sticky_aspect="default" vs_font_size="3vw" vs_sub_desc_font_size="1.05vw"][tab icon_family="none" title="Standard selection" id="1636819609648-4" tab_id="1636819609649-0" sub_desc="Get a good night's sleep in our luxurious standard room. Featuring king size beds, walk-in showers and wifi internet."][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/webp/photo-1616046229478-9901c5536a45.webp" background_image_position="center center" enable_bg_scale="true" background_image_loading="skip-lazy-load" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" parallax_bg="true" parallax_bg_speed="very_subtle" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][divider line_type="No Line" custom_height="80vh" custom_height_tablet="50vh"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" left_padding_desktop="12%" left_padding_tablet="10%" constrain_group_4="yes" right_padding_tablet="10%" translate_y="33%" translate_y_tablet="0" text_align="left" min_width_desktop="60%" row_position="absolute" row_position_tablet="relative" row_position_phone="inherit" bottom_position_desktop="0" left_position_desktop="0" zindex="100" overflow="visible" pointer_events="all"][vc_column_inner column_padding="padding-3-percent" column_padding_tablet="padding-4-percent" column_padding_phone="inherit" column_padding_position="all" top_margin_tablet="-20%" column_element_spacing="10px" background_color="#ffffff" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="parallax" animation_movement_type="default" column_parallax_intensity="1.5" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][split_line_heading animation_type="line-reveal-by-space" font_style="h2" line_reveal_by_space_text_effect="none" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="From $200/night" font_size="2vw" font_line_height="1" font_size_tablet="3vw" font_size_phone="5vw"][/split_line_heading][split_line_heading animation_type="line-reveal-by-space" font_style="h2" line_reveal_by_space_text_effect="none" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="Junior Studio" font_size="4vw" font_line_height="1" font_size_tablet="6vw" font_size_phone="8vw"][/split_line_heading][divider line_type="No Line" custom_height="15"][fancy-ul icon_type="standard_dot" alignment="left" spacing="5px"]
<ul>
 	<li>Capacity: 2</li>
 	<li>Number of rooms: 30</li>
 	<li>Square Footage: 200</li>
 	<li>Beds: 1 Baths: 1</li>
</ul>
[/fancy-ul][nectar_cta btn_style="text-reveal-wave" heading_tag="h5" text_color="#000000" button_color="accent-color" button_border_thickness="0px" link_type="regular" alignment="left" alignment_tablet="default" alignment_phone="default" constrain_group_3="yes" constrain_group_4="yes" display="block" link_text="Reserve Room" padding_top="15" padding_bottom="15" padding_left="35" padding_right="35" margin_top="40"][/vc_column_inner][/vc_row_inner][/tab][tab icon_family="none" title="Rooms with a view" id="1636819609781-9" tab_id="1636819609782-9" sub_desc="We offer highrise rooms to elevate your view of the ocean even further. The perfect romantic getaway spot for couples."][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/webp/photo-1559414059-34fe0a59e57a.webp" background_image_position="center center" enable_bg_scale="true" background_image_loading="default" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" parallax_bg="true" parallax_bg_speed="very_subtle" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][divider line_type="No Line" custom_height="80vh" custom_height_tablet="50vh"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" right_padding_desktop="12%" left_padding_tablet="10%" constrain_group_4="yes" right_padding_tablet="10%" translate_y="33%" translate_y_tablet="0" text_align="left" min_width_desktop="60%" row_position="absolute" row_position_tablet="relative" row_position_phone="inherit" bottom_position_desktop="0" right_position_desktop="0" zindex="100" overflow="visible" pointer_events="all"][vc_column_inner column_padding="padding-3-percent" column_padding_tablet="padding-4-percent" column_padding_phone="inherit" column_padding_position="all" top_margin_tablet="-20%" column_element_spacing="10px" background_color="#ffffff" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="parallax" animation_movement_type="default" column_parallax_intensity="1.5" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][split_line_heading animation_type="line-reveal-by-space" font_style="h2" line_reveal_by_space_text_effect="none" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="From $350/night" font_size="2vw" font_line_height="1" font_size_tablet="3vw" font_size_phone="5vw"][/split_line_heading][split_line_heading animation_type="line-reveal-by-space" font_style="h2" line_reveal_by_space_text_effect="none" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="Highrise Suite" font_size="4vw" font_line_height="1" font_size_tablet="6vw" font_size_phone="8vw"][/split_line_heading][divider line_type="No Line" custom_height="15"][fancy-ul icon_type="standard_dot" alignment="left" spacing="5px"]
<ul>
 	<li>Capacity: 4</li>
 	<li>Number of rooms: 15</li>
 	<li>Square Footage: 350</li>
 	<li>Beds: 2 Baths: 2</li>
</ul>
[/fancy-ul][nectar_cta btn_style="text-reveal-wave" heading_tag="h5" text_color="#000000" button_color="accent-color" button_border_thickness="0px" link_type="regular" alignment="left" alignment_tablet="default" alignment_phone="default" constrain_group_3="yes" constrain_group_4="yes" display="block" link_text="Reserve Room" padding_top="15" padding_bottom="15" padding_left="35" padding_right="35" margin_top="40"][/vc_column_inner][/vc_row_inner][/tab][tab icon_family="none" title="For large groups" id="1636819609866-2" tab_id="1636819609867-8" sub_desc="Leave all of your troubles behind and enjoy the ultimate escape in our deluxe cabins, perfect for the vacationing family."][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/webp/photo-1572970385182-97a64c98205b.webp" background_image_position="center center" enable_bg_scale="true" background_image_loading="default" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" parallax_bg="true" parallax_bg_speed="very_subtle" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][divider line_type="No Line" custom_height="80vh" custom_height_tablet="50vh"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" left_padding_desktop="12%" left_padding_tablet="10%" constrain_group_4="yes" right_padding_tablet="10%" translate_y="33%" translate_y_tablet="0" text_align="left" min_width_desktop="60%" row_position="absolute" row_position_tablet="relative" row_position_phone="inherit" bottom_position_desktop="0" left_position_desktop="0" zindex="100" overflow="visible" pointer_events="all"][vc_column_inner column_padding="padding-3-percent" column_padding_tablet="padding-4-percent" column_padding_phone="inherit" column_padding_position="all" top_margin_tablet="-20%" column_element_spacing="10px" background_color="#ffffff" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="parallax" animation_movement_type="default" column_parallax_intensity="1.5" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][split_line_heading animation_type="line-reveal-by-space" font_style="h2" line_reveal_by_space_text_effect="none" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="From $750/night" font_size="2vw" font_line_height="1" font_size_tablet="3vw" font_size_phone="5vw"][/split_line_heading][split_line_heading animation_type="line-reveal-by-space" font_style="h2" line_reveal_by_space_text_effect="none" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="Deluxe Villa" font_size="4vw" font_line_height="1" font_size_tablet="6vw" font_size_phone="8vw"][/split_line_heading][divider line_type="No Line" custom_height="15"][fancy-ul icon_type="standard_dot" alignment="left" spacing="5px"]
<ul>
 	<li>Capacity: 8</li>
 	<li>Number of rooms: 20</li>
 	<li>Square Footage: 800</li>
 	<li>Beds: 4 Baths: 3</li>
</ul>
[/fancy-ul][nectar_cta btn_style="text-reveal-wave" heading_tag="h5" text_color="#000000" button_color="accent-color" button_border_thickness="0px" link_type="regular" alignment="left" alignment_tablet="default" alignment_phone="default" constrain_group_3="yes" constrain_group_4="yes" display="block" link_text="Reserve Room" padding_top="15" padding_bottom="15" padding_left="35" padding_right="35" margin_top="40"][/vc_column_inner][/vc_row_inner][/tab][tab icon_family="none" title="Exclusive experience" id="1636819609960-0" tab_id="1636819609961-0" sub_desc="A once in a lifetime experience awaits you. Stay on the water in one of our exclusive bungalows hundreds of feet out on the ocean"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/webp/photo-1590523277581-658f9545acd2.webp" background_image_position="center center" enable_bg_scale="true" background_image_loading="default" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" parallax_bg="true" parallax_bg_speed="very_subtle" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][divider line_type="No Line" custom_height="80vh" custom_height_tablet="50vh"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" right_padding_desktop="12%" left_padding_tablet="10%" constrain_group_4="yes" right_padding_tablet="10%" translate_y="33%" translate_y_tablet="0" text_align="left" min_width_desktop="60%" row_position="absolute" row_position_tablet="relative" row_position_phone="inherit" bottom_position_desktop="0" right_position_desktop="0" zindex="100" overflow="visible" pointer_events="all"][vc_column_inner column_padding="padding-3-percent" column_padding_tablet="padding-4-percent" column_padding_phone="inherit" column_padding_position="all" top_margin_tablet="-20%" column_element_spacing="10px" background_color="#ffffff" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="parallax" animation_movement_type="default" column_parallax_intensity="1.5" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][split_line_heading animation_type="line-reveal-by-space" font_style="h2" line_reveal_by_space_text_effect="none" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="From $1000/night" font_size="2vw" font_line_height="1" font_size_tablet="3vw" font_size_phone="5vw"][/split_line_heading][split_line_heading animation_type="line-reveal-by-space" font_style="h2" line_reveal_by_space_text_effect="none" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="Water Bungalow" font_size="4vw" font_line_height="1" font_size_tablet="6vw" font_size_phone="8vw"][/split_line_heading][divider line_type="No Line" custom_height="15"][fancy-ul icon_type="standard_dot" alignment="left" spacing="5px"]
<ul>
 	<li>Capacity: 4</li>
 	<li>Number of rooms: 12</li>
 	<li>Square Footage: 550</li>
 	<li>Beds: 2 Baths: 2</li>
</ul>
[/fancy-ul][nectar_cta btn_style="text-reveal-wave" heading_tag="h5" text_color="#000000" button_color="accent-color" button_border_thickness="0px" link_type="regular" alignment="left" alignment_tablet="default" alignment_phone="default" constrain_group_3="yes" constrain_group_4="yes" display="block" link_text="Reserve Room" padding_top="15" padding_bottom="15" padding_left="35" padding_right="35" margin_top="40"][/vc_column_inner][/vc_row_inner][/tab][/tabbed_section][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Light Footer', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-11-Nov-2021';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/resort-footer.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#f4ece2" scene_position="center" top_padding="6%" constrain_group_1="yes" bottom_padding="6%" left_padding_desktop="8%" constrain_group_2="yes" right_padding_desktop="8%" top_padding_tablet="12%" constrain_group_3="yes" bottom_padding_tablet="12%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" advanced_gradient_angle="0" overlay_strength="0.3" gradient_direction="left_to_right" enable_shape_divider="true" shape_divider_color="rgba(0,0,0,0.1)" shape_divider_position="both" shape_divider_height="1" bg_image_animation="none" shape_type="straight_section" gradient_type="default"][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="center" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" bg_image_animation="none" border_type="advanced" column_border_style="solid" gradient_type="default"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" right_padding_desktop="40%" bottom_padding_tablet="10%" left_padding_phone="10%" constrain_group_6="yes" right_padding_phone="10%" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="10px" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][vc_column_text]
<h4>Do you believe in magic?</h4>
[/vc_column_text][split_line_heading animation_type="line-reveal-by-space" font_style="p" line_reveal_by_space_text_effect="none" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" font_size="1.05vw" font_line_height="1.6" text_content="This entire website was built with Salient, a creative next-generation WordPress theme." font_size_tablet="16"][/split_line_heading][nectar_cta btn_style="text-reveal-wave" heading_tag="h5" text_color="#000000" button_color="accent-color" button_border_thickness="0px" link_type="regular" alignment="left" alignment_tablet="default" alignment_phone="default" constrain_group_3="yes" constrain_group_4="yes" display="block" link_text="I don't believe it" margin_top="35" padding_top="15" padding_bottom="15" padding_left="35" padding_right="35"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="center" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][vc_row_inner column_margin="50px" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="padding-5-percent" column_padding_tablet="no-extra-padding" column_padding_phone="no-extra-padding" column_padding_position="left" bottom_margin_phone="40" column_element_spacing="0px" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="small_desktop" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" delay="150"][vc_column_text css=".vc_custom_1636697193664{margin-bottom: 10px !important;}"]
<h4>Address</h4>
[/vc_column_text][split_line_heading animation_type="line-reveal-by-space" font_style="p" line_reveal_by_space_text_effect="none" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" font_size="1.05vw" font_line_height="1.6" text_content="The Castle" font_size_tablet="16"][/split_line_heading][split_line_heading animation_type="line-reveal-by-space" font_style="p" line_reveal_by_space_text_effect="none" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" font_size="1.05vw" font_line_height="1.6" text_content="345 2500 Castle Dr." font_size_tablet="16"][/split_line_heading][split_line_heading animation_type="line-reveal-by-space" font_style="p" line_reveal_by_space_text_effect="none" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" font_size="1.05vw" font_line_height="1.6" text_content="Port Douglas, Queensland" font_size_tablet="16"][/split_line_heading][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" bottom_margin_tablet="0" bottom_margin_phone="0" column_element_spacing="0px" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="small_desktop" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" delay="300"][vc_column_text css=".vc_custom_1636697263705{margin-bottom: 10px !important;}"]
<h4>Connect</h4>
[/vc_column_text][split_line_heading animation_type="line-reveal-by-space" font_style="p" line_reveal_by_space_text_effect="none" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" font_size="1.05vw" font_line_height="1.6" text_content="T: +216 (0)40 3629 4753" font_size_tablet="16"][/split_line_heading][split_line_heading animation_type="line-reveal-by-space" font_style="p" line_reveal_by_space_text_effect="none" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" font_size="1.05vw" font_line_height="1.6" text_content="E: hello@themenectar.com" font_size_tablet="16"][/split_line_heading][vc_column_text] [/vc_column_text][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row][vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#f4ece2" scene_position="center" top_padding="28" constrain_group_1="yes" bottom_padding="28" left_padding_desktop="8%" constrain_group_2="yes" right_padding_desktop="8%" top_padding_tablet="6%" constrain_group_3="yes" bottom_padding_tablet="6%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" advanced_gradient_angle="0" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" gradient_type="default" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" tablet_text_alignment="center" phone_text_alignment="center" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" animation_offset="101%"][vc_column_text]<b>© </b>[nectar_current_year] Salient Hotel[/vc_column_text][/vc_column][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" tablet_text_alignment="center" phone_text_alignment="center" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" animation_offset="101%"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" top_padding_tablet="10" text_align="right" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="0px" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][nectar_cta btn_style="underline" heading_tag="p" button_color="default" button_border_thickness="0px" link_type="regular" alignment="right" alignment_tablet="center" alignment_phone="default" constrain_group_4="yes" display="inline" link_text="Terms &amp; Conditions" padding_left="25" padding_right="25"][nectar_cta btn_style="underline" heading_tag="p" button_color="default" button_border_thickness="0px" link_type="regular" alignment="right" alignment_tablet="center" alignment_phone="default" constrain_group_4="yes" display="inline" link_text="Privacy Policy" padding_left="25" padding_right="25"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Cropped Parallax CTA', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['cta'];
$data['custom_class'] = 'cta date-11-Nov-2021';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/resort-cta.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" scene_position="center" top_padding="10%" top_padding_tablet="15%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" advanced_gradient_angle="0" shape_divider_position="bottom" bg_image_animation="none" shape_type="" gradient_type="advanced" advanced_gradient_display_type="linear"][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bottom_padding="3%" left_padding_desktop="30%" constrain_group_2="yes" right_padding_desktop="30%" bottom_padding_tablet="6%" left_padding_tablet="13%" constrain_group_4="yes" right_padding_tablet="13%" left_padding_phone="11%" constrain_group_6="yes" right_padding_phone="11%" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="0px" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][vc_column_text]
<h5>RESERVATIONS</h5>
[/vc_column_text][split_line_heading animation_type="line-reveal-by-space" font_style="h2" line_reveal_by_space_text_effect="none" content_alignment="center" mobile_content_alignment="inherit" link_target="_self" text_content="It's time for that vacation" font_line_height="1" max_width="58%" font_size="4vw"][/split_line_heading][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row][vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" scene_position="center" bottom_padding="10%" bottom_padding_tablet="15%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" advanced_gradient_angle="0" shape_divider_position="bottom" bg_image_animation="none" shape_type="" gradient_type="advanced" advanced_gradient_display_type="linear"][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" left_padding_desktop="10%" constrain_group_2="yes" right_padding_desktop="10%" translate_y="-50%" translate_x="-50%" text_align="left" min_width_desktop="100%" row_position="absolute" row_position_tablet="inherit" row_position_phone="inherit" top_position_desktop="50%" left_position_desktop="50%" zindex="200" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="parallax" animation_movement_type="default" column_parallax_intensity="2" persist_movement_on_mobile="true" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][split_line_heading animation_type="line-reveal-by-space" font_style="h1" line_reveal_by_space_text_effect="letter-reveal-top" stagger_animation="true" content_alignment="center" mobile_content_alignment="inherit" link_target="_self" link_indicator="true" link_indicator_bg_color="#f4ece2" link_indicator_icon_color="#000000" text_content="BOOK NOW" font_size="13vw" link_href="http://google.com" font_line_height="0.9" font_size_tablet="14vw"][/split_line_heading][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" left_padding_desktop="34%" constrain_group_2="yes" right_padding_desktop="34%" left_padding_tablet="30%" constrain_group_4="yes" right_padding_tablet="30%" left_padding_phone="27%" constrain_group_6="yes" right_padding_phone="27%" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/webp/photo-1504941214544-9c1c44559ab4.webp" background_image_position="center center" enable_bg_scale="true" background_image_loading="default" video_mp4="" background_video_loading="lazy-load" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="radial" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][divider line_type="No Line" custom_height="75vh" custom_height_tablet="45vh"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Full Width Layered Parallax Blocks', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['services'];
$data['custom_class'] = 'services date-11-Nov-2021';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/resort-split-parallax.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#7a95a8" scene_position="center" text_color="light" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" advanced_gradient_angle="0" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" shape_type="" gradient_type="default"][vc_column column_padding="padding-5-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="5px" background_color_opacity="1" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/webp/photo-1583939003579-730e3918a45a.webp" background_image_position="center center" enable_bg_scale="true" background_image_loading="default" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" enable_gradient="true" color_overlay="rgba(0,0,0,0.62)" advanced_gradient_angle="0" gradient_direction="radial" overlay_strength="0.5" width="1/2" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" animation_type="default" bg_image_animation="none" parallax_bg="true" parallax_bg_speed="very_subtle" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][divider line_type="No Line" custom_height="35vh" custom_height_phone="150"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="0px" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][split_line_heading animation_type="line-reveal-by-space" font_style="h2" line_reveal_by_space_text_effect="none" content_alignment="center" mobile_content_alignment="inherit" link_target="_self" text_content="Weddings" font_size="3vw"][/split_line_heading][nectar_cta btn_style="underline" heading_tag="span" text_color="#ffffff" button_color="default" button_border_thickness="0px" link_type="regular" alignment="center" alignment_tablet="default" alignment_phone="default" display="block" link_text="Learn More" url="#"][/vc_column_inner][/vc_row_inner][divider line_type="No Line" custom_height="35vh" custom_height_phone="150"][/vc_column][vc_column column_padding="padding-5-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="5px" background_color_opacity="1" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/webp/photo-1515168985652-8454bcc8fcaf.webp" background_image_position="center center" enable_bg_scale="true" background_image_loading="default" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" enable_gradient="true" color_overlay="rgba(0,0,0,0.72)" color_overlay_2="rgba(0,0,0,0.24)" advanced_gradient_angle="0" gradient_direction="radial" overlay_strength="0.5" width="1/2" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" animation_type="default" bg_image_animation="none" parallax_bg="true" parallax_bg_speed="fast" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][divider line_type="No Line" custom_height="35vh" custom_height_phone="150"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="0px" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" delay="200"][split_line_heading animation_type="line-reveal-by-space" font_style="h2" line_reveal_by_space_text_effect="none" content_alignment="center" mobile_content_alignment="inherit" link_target="_self" text_content="Conferences" font_size="3vw"][/split_line_heading][nectar_cta btn_style="underline" heading_tag="span" text_color="#ffffff" button_color="default" button_border_thickness="0px" link_type="regular" alignment="center" alignment_tablet="default" alignment_phone="default" display="block" link_text="Learn More" url="#"][/vc_column_inner][/vc_row_inner][divider line_type="No Line" custom_height="35vh" custom_height_phone="150"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Featured Recent Posts List', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['blog'];
$data['custom_class'] = 'blog date-11-Nov-2021';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/resort-news.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" scene_position="center" top_padding="6%" bottom_padding="5%" left_padding_desktop="8%" constrain_group_2="yes" right_padding_desktop="8%" top_padding_tablet="15%" constrain_group_9="yes" constrain_group_10="yes" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" advanced_gradient_angle="0" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" shape_type="" gradient_type="default"][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="0px" sticky_content="true" sticky_content_functionality="css" sticky_content_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="default" tablet_text_alignment="center" phone_text_alignment="center" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" left_padding_tablet="10%" constrain_group_4="yes" right_padding_tablet="10%" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][split_line_heading animation_type="line-reveal-by-space" font_style="h3" line_reveal_by_space_text_effect="default" stagger_animation="true" content_alignment="left" mobile_content_alignment="center" link_target="_self" text_content="Read the latest news" font_size="4vw" font_line_height="0.9" max_width="75%"][/split_line_heading][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" top_padding="20" right_padding_desktop="15%" top_padding_tablet="0" left_padding_tablet="10%" constrain_group_4="yes" right_padding_tablet="10%" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" offset="vc_hidden-sm vc_hidden-xs"][split_line_heading animation_type="line-reveal-by-space" font_style="p" line_reveal_by_space_text_effect="none" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="Track events, lean about activities and get vacation tips for your stay with us." font_size="1.05vw" font_line_height="1.6" font_size_tablet="16"][/split_line_heading][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="padding-6-percent" column_padding_tablet="no-extra-padding" column_padding_phone="no-extra-padding" column_padding_position="left" column_element_spacing="0px" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="2/3" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][nectar_post_grid post_type="post" blog_category="all" order="DESC" orderby="date" pagination="none" ignore_sticky_posts="yes" grid_item_spacing="40px" image_size="portfolio-thumb_large" image_loading="default" animation="fade-in-from-bottom" heading_tag="h4" grid_style="vertical_list" vertical_list_hover_effect="slight_move" vertical_list_border_color="rgba(0,0,0,0.35)" vertical_list_read_more="yes" vertical_list_counter="yes" text_color="dark" posts_per_page="4"][/vc_column][/vc_row][vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" scene_position="center" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="hidden" advanced_gradient_angle="0" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" gradient_type="default" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_row_inner content_placement="middle" column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="parallax" animation_movement_type="transform_x" column_parallax_intensity="3.5" persist_movement_on_mobile="true" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][nectar_scrolling_text scroll_direction="ltr" scroll_speed="slowest" text_color="#000000" style="text_outline" outline_thickness="ultra-thin" text_repeat_number="4" text_repeat_divider="space" overflow="visible" background_image_animation="None" custom_font_size="13vw" custom_font_size_mobile="20vw"]
<h1><em>PRIVATE EVENTS</em></h1>
[/nectar_scrolling_text][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Fancy Box Parallax Carousel', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['services'];
$data['custom_class'] = 'services date-11-Nov-2021';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/resort-parallax-carousel.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" scene_position="center" top_padding="6%" constrain_group_1="yes" bottom_padding="6%" left_padding_desktop="8%" right_padding_desktop="8%" top_padding_tablet="15%" constrain_group_3="yes" bottom_padding_tablet="15%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="hidden" id="impact" advanced_gradient_angle="0" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="top" shape_divider_height="50%" bg_image_animation="none" shape_type="straight_section" gradient_type="default"][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bottom_padding="15" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][vc_column_text]
<h5>ACTIVITIES</h5>
[/vc_column_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bottom_padding="3%" right_padding_desktop="70%" bottom_padding_tablet="6%" right_padding_tablet="40%" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][split_line_heading animation_type="line-reveal-by-space" font_style="h3" line_reveal_by_space_text_effect="default" stagger_animation="true" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="The adventure starts now" font_size="4vw" font_line_height="0.9"][/split_line_heading][/vc_column_inner][/vc_row_inner][carousel script="flickity" flickity_formatting="default" desktop_cols_flickity="3" desktop_small_cols_flickity="2" tablet_cols_flickity="2" flickity_controls="touch_total" flickity_touch_total_style="solid_bg" flickity_touch_total_indicator_bg_color="#f4ece2" flickity_touch_total_indicator_icon_color="#000000" flickity_touch_total_hide_indicator="true" color="default" flickity_overflow="visible" flickity_wrap_around="no-wrap" flickity_spacing="10px" flickity_centered_cells="true" flickity_column_vertical_alignment="bottom" column_padding="0" flickity_element_spacing="0" border_radius="none"][item simple_slider_bg_image_position="default" simple_slider_overlay_strength="0.3" simple_slider_bg_image_loading="default" id="1636816204207-0" title="Item" tab_id="1636816204207-0"][fancy_box box_style="hover_desc" icon_family="iconsmind" image_url="https://themenectar.com/img/demo-media/unsplash/webp/photo-1605144156683-5ebde77feed5.webp" hover_color="accent-color" hover_color_custom="#000000" hover_desc_color_opacity="0.9" hover_desc_hover_overlay_opacity="0.4" disable_hover_movement="true" bg_parallax="true" icon_position="top" box_alignment="left" hover_desc_bg_animation="none" border_radius="default" image_loading="lazy-load" color_scheme="dark" secondary_content="here's some awesome text that would only be shown on hover" min_height="75vh" icon_iconsmind="iconsmind-Golf" min_height_tablet="550"]
<h4>Premier Golf Course</h4>
A true test of the champion; Test your skills at our full 18-hole immaculate course overlooking the ocean.[/fancy_box][/item][item simple_slider_bg_image_position="default" simple_slider_overlay_strength="0.3" simple_slider_bg_image_loading="default" id="1636816204244-9" title="Item" tab_id="1636816204245-9"][fancy_box box_style="hover_desc" icon_family="iconsmind" image_url="https://themenectar.com/img/demo-media/unsplash/webp/photo-1567227278154-0b83bcf237e1.webp" hover_color="accent-color" hover_color_custom="#0a0202" hover_desc_color_opacity="0.9" hover_desc_hover_overlay_opacity="0.4" disable_hover_movement="true" bg_parallax="true" icon_position="top" box_alignment="left" hover_desc_bg_animation="none" border_radius="default" image_loading="lazy-load" color_scheme="dark" secondary_content="here's some awesome text that would only be shown on hover" min_height="75vh" icon_iconsmind="iconsmind-Leafs" min_height_tablet="550"]
<h4>Relaxing Wellness Spa</h4>
Another layer of relaxation awaits you on your vacation. Featuring massages, a hair salon, and nail studio.[/fancy_box][/item][item simple_slider_bg_image_position="default" simple_slider_overlay_strength="0.3" simple_slider_bg_image_loading="default" id="1636816204265-8" title="Item" tab_id="1636816204266-1"][fancy_box box_style="hover_desc" icon_family="iconsmind" image_url="https://themenectar.com/img/demo-media/unsplash/webp/photo-1602199926649-2e5e447bab97.webp" hover_color="accent-color" hover_color_custom="#000000" hover_desc_color_opacity="0.9" hover_desc_hover_overlay_opacity="0.4" disable_hover_movement="true" bg_parallax="true" icon_position="top" box_alignment="left" hover_desc_bg_animation="none" border_radius="default" image_loading="lazy-load" color_scheme="dark" secondary_content="here's some awesome text that would only be shown on hover" min_height="75vh" icon_iconsmind="iconsmind-Snorkel" min_height_tablet="550"]
<h4>Scuba Diving &amp; Snorkeling</h4>
Explore the crystal clear waters from down under with our scuba excursion.[/fancy_box][/item][item simple_slider_bg_image_position="default" simple_slider_overlay_strength="0.3" simple_slider_bg_image_loading="default" id="1636816204294-1" title="Item" tab_id="1636816204295-5"][fancy_box box_style="hover_desc" icon_family="iconsmind" image_url="https://themenectar.com/img/demo-media/unsplash/webp/photo-1600521605615-a8d3a23d8262.webp" hover_color="extra-color-1" hover_color_custom="#000000" hover_desc_color_opacity="0.9" hover_desc_hover_overlay_opacity="0.4" disable_hover_movement="true" bg_parallax="true" icon_position="top" box_alignment="left" hover_desc_bg_animation="none" border_radius="default" image_loading="lazy-load" color_scheme="dark" secondary_content="here's some awesome text that would only be shown on hover" min_height="75vh" icon_iconsmind="iconsmind-Jeep" min_height_tablet="550"]
<h4>Premium Wildlife Tours</h4>
Expertly guided scenic and tours of the land available in group UTV sessions.[/fancy_box][/item][item simple_slider_bg_image_position="default" simple_slider_overlay_strength="0.3" simple_slider_bg_image_loading="default" id="1636816204322-6" title="Item" tab_id="1636816204323-10"][fancy_box box_style="hover_desc" icon_family="iconsmind" image_url="https://themenectar.com/img/demo-media/unsplash/webp/photo-1551524358-f34c0214781d.webp" hover_color="extra-color-1" hover_color_custom="#000000" hover_desc_color_opacity="0.9" hover_desc_hover_overlay_opacity="0.4" disable_hover_movement="true" bg_parallax="true" icon_position="top" box_alignment="left" hover_desc_bg_animation="none" border_radius="default" image_loading="lazy-load" color_scheme="dark" secondary_content="here's some awesome text that would only be shown on hover" min_height="75vh" icon_iconsmind="iconsmind-Wave" min_height_tablet="550"]
<h4>Professional Surf Lessons</h4>
Get another item off your bucket list and immerse yourself in the swell with our instructors.[/fancy_box][/item][item simple_slider_bg_image_position="default" simple_slider_overlay_strength="0.3" simple_slider_bg_image_loading="default" id="1636816204348-2" title="Item" tab_id="1636816204349-3"][fancy_box box_style="hover_desc" icon_family="iconsmind" image_url="https://themenectar.com/img/demo-media/unsplash/webp/photo-1499510318569-1a3d67dc3976.webp" hover_color="accent-color" hover_color_custom="#0a0202" hover_desc_color_opacity="0.9" hover_desc_hover_overlay_opacity="0.4" disable_hover_movement="true" bg_parallax="true" icon_position="top" box_alignment="left" hover_desc_bg_animation="none" border_radius="default" image_loading="lazy-load" color_scheme="dark" secondary_content="here's some awesome text that would only be shown on hover" min_height="75vh" icon_iconsmind="iconsmind-Tennis" min_height_tablet="550"]
<h4>Clay Tennis Courts</h4>
Professional-quality tennis courts that are available to you all year round. Classes and lessons are also available.[/fancy_box][/item][/carousel][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Images and Parallax Text Column', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'] . ', ' . $cat_display_names['about'];
$data['custom_class'] = 'general about date-11-Nov-2021';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/resort-parallax-text.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" scene_position="center" top_padding="14%" left_padding_desktop="8%" right_padding_desktop="8%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" advanced_gradient="radial-gradient(circle at top right, rgb(255,200,129) 0%, rgba(243,243,243,0) 41%)" advanced_gradient_radial_position="top right" shape_divider_position="bottom" bg_image_animation="none" parallax_bg="true" parallax_bg_speed="fast" gradient_type="advanced" shape_type="" advanced_gradient_display_type="radial"][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="0px" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" advanced_gradient_angle="0" gradient_direction="radial" overlay_strength="0.5" width="1/2" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" translate_y="-50%" translate_x="50%" text_align="left" min_width_desktop="175" row_position="absolute" row_position_tablet="inherit" row_position_phone="inherit" top_position_desktop="0" right_position_desktop="0" zindex="100" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default" offset="vc_hidden-sm vc_hidden-xs"][image_with_animation image_url="https://themenectar.com/img/demo-media/spinners/ocean-views.png" image_size="full" animation_type="looped" loop_animation="rotate" hover_animation="none" alignment="" border_radius="none" image_loading="skip-lazy-load" max_width="custom" el_class="dark-filter" max_width_custom="175"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bottom_padding_tablet="8%" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/webp/photo-1516752093629-7d10b9d79a18.webp" background_image_position="center center" enable_bg_scale="true" background_image_loading="default" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="radial" overlay_strength="0.5" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][divider line_type="No Line" custom_height="90vh" custom_height_tablet="450"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="padding-14-percent" column_padding_tablet="no-extra-padding" column_padding_phone="no-extra-padding" column_padding_position="left" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" animation_type="parallax" animation_movement_type="default" column_parallax_intensity="1.75" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" top_padding="10vh" bottom_padding="15" top_padding_tablet="0" top_padding_phone="0" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][vc_column_text]
<h5>Excellence</h5>
[/vc_column_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="0px" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][split_line_heading animation_type="line-reveal-by-space" font_style="h3" line_reveal_by_space_text_effect="default" stagger_animation="true" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="Where forest meets ocean" font_size="4vw" font_line_height="0.9" max_width="85%"][/split_line_heading][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" top_padding="4%" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" zindex="100" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][split_line_heading animation_type="line-reveal-by-space" font_style="p" line_reveal_by_space_text_effect="none" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="Nestled right in the middle of a natural juxtaposition. Salient is more than a resort; it's an unforgettable experience for you and your whole family." font_size="1.05vw" font_line_height="1.6" font_size_tablet="16"][/split_line_heading][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" top_padding="4%" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" zindex="100" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="0px" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][divider line_type="Vertical Line" divider_color="black" custom_height="34"][split_line_heading animation_type="line-reveal-by-space" font_style="i" line_reveal_by_space_text_effect="none" content_alignment="center" mobile_content_alignment="inherit" link_target="_self" text_content="The best of both worlds; Refreshing greenery with scenic ocean views." font_line_height="1.3" max_width="70%" font_size="1.45vw" font_size_tablet="22px"][/split_line_heading][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" top_padding="8%" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/webp/photo-1615228100591-976c4e87b179.webp" background_image_position="center center" enable_bg_scale="true" background_image_loading="default" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][divider line_type="No Line" custom_height="65vh" custom_height_tablet="350"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Image Slider with Static Text Overlaid', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'] . ', ' . $cat_display_names['about'];
$data['custom_class'] = 'general about date-11-Nov-2021';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/resort-slider-carousel.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" scene_position="center" constrain_group_9="yes" constrain_group_10="yes" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" advanced_gradient="linear-gradient(125deg, rgb(122, 149, 168) 15%, rgb(122, 149, 168) 15%)" advanced_gradient_angle="125" shape_divider_color="#f0ece5" shape_divider_position="bottom" shape_divider_height="33%" bg_image_animation="none" shape_type="straight_section" gradient_type="advanced" advanced_gradient_display_type="linear"][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="top" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][vc_row_inner equal_height="yes" content_placement="middle" column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" left_padding_desktop="35%" constrain_group_2="yes" right_padding_desktop="35%" left_padding_tablet="25%" constrain_group_4="yes" right_padding_tablet="25%" left_padding_phone="12%" constrain_group_6="yes" right_padding_phone="12%" translate_y="-50%" translate_x="-50%" text_align="left" min_width_desktop="100%" row_position="absolute" row_position_tablet="inherit" row_position_phone="inherit" top_position_desktop="50%" left_position_desktop="50%" zindex="100" overflow="visible" pointer_events="none"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="0px" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][nectar_icon icon_family="linea" enable_animation="true" animation_speed="medium" icon_style="default" icon_color_type="custom" icon_color_custom="#f4ece2" icon_padding="15px" icon_linea="icon-basic-compass"][split_line_heading animation_type="line-reveal-by-space" font_style="h2" text_color="#f4ece2" line_reveal_by_space_text_effect="default" stagger_animation="true" content_alignment="center" mobile_content_alignment="inherit" link_target="_self" text_content="Stunning views, outstanding service, and michelin star dining." font_size="3vw" font_size_tablet="5vw" font_line_height="1.3" font_size_phone="38px"][/split_line_heading][/vc_column_inner][/vc_row_inner][carousel script="simple_slider" simple_slider_sizing="aspect_ratio" simple_slider_aspect_ratio="2-1" simple_slider_pagination_controls="true" simple_slider_pagination_coloring="light" simple_slider_pagination_alignment="default" simple_slider_touch_indicator="true" simple_slider_touch_indicator_bg_color="#f4ece2" simple_slider_touch_indicator_icon_color="#000000" simple_slider_transition_type="slide" simple_slider_parallax="true" simple_slider_wrap="true" simple_slider_min_height="450"][item simple_slider_bg_image_url="https://themenectar.com/img/demo-media/unsplash/webp/photo-1634304233286-8c7956a85b29.webp" simple_slider_bg_image_position="center-top" simple_slider_font_color="#ffffff" simple_slider_color_overlay="rgba(0,0,0,0.74)" simple_slider_overlay_strength="0.3" simple_slider_bg_image_loading="default" simple_slider_gradient_direction="left_to_right" bg_image_url="" bg_image_position="default" image_url="" id="1636774480591-9" title="Item" tab_id="1636774480592-0"][vc_column_text][/vc_column_text][/item][item simple_slider_bg_image_url="https://themenectar.com/img/demo-media/unsplash/webp/photo-1446038236174-69712e24d137.webp" simple_slider_bg_image_position="center-bottom" simple_slider_font_color="#ffffff" simple_slider_color_overlay="rgba(10,10,10,0.5)" simple_slider_overlay_strength="0.3" simple_slider_bg_image_loading="default" simple_slider_gradient_direction="left_to_right" bg_image_url="" bg_image_position="default" image_url="" id="1636774480618-8" title="Item" tab_id="1636774480619-4"][vc_column_text][/vc_column_text][/item][item simple_slider_bg_image_url="https://themenectar.com/img/demo-media/unsplash/webp/photo-1508238100279-3b16198926a4.webp" simple_slider_bg_image_position="center-bottom" simple_slider_font_color="#ffffff" simple_slider_color_overlay="rgba(0,0,0,0.78)" simple_slider_overlay_strength="0.3" simple_slider_bg_image_loading="default" simple_slider_gradient_direction="left_to_right" bg_image_url="" bg_image_position="default" image_url="" id="1636774480643-1" title="Item" tab_id="1636774480643-2"][vc_column_text][/vc_column_text][/item][/carousel][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Scrolling Tabbed Images', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-11-Nov-2021';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/resort-vertical-tabbed.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" scene_position="center" top_padding="6%" bottom_padding="12%" left_padding_desktop="8%" right_padding_tablet="8%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" advanced_gradient_angle="0" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" shape_type="" gradient_type="default"][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][tabbed_section style="vertical_scrolling" tab_color="Accent-Color" vs_navigation_func="active_link_only" vs_navigation_width="wide" vs_tab_spacing="20px" vs_tab_tag="h2" vs_enable_cta="true" vs_cta_style="text-reveal-wave" vs_cta_text_color="#0a0a0a" vs_cta_bg_color="accent-color" vs_cta_heading_tag="h5" constrain_group_1="yes" constrain_group_2="yes" vs_sticky_aspect="default" vs_cta_text="View All Accommodations" vs_cta_padding_top="15" vs_cta_padding_bottom="15" vs_cta_padding_left="25" vs_cta_padding_right="25" vs_font_size="4vw" vs_sub_desc_font_size="1.05vw"][tab icon_family="none" title="Single Suites" id="1636774480206-0" tab_id="1636774480207-0" sub_desc="Bohemian-inspired interiors with breathtaking views of the ocean from one side, and lushes greenery from the other. Ranges from 200 - 300 sqft."][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/webp/photo-1559414059-34fe0a59e57a.webp"  background_image_position="center bottom" enable_bg_scale="true" background_image_loading="default" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" parallax_bg="true" parallax_bg_speed="fast" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][divider line_type="No Line" custom_height="90vh" custom_height_tablet="50vh"][/vc_column_inner][/vc_row_inner][/tab][tab icon_family="none" title="Private Cabins" id="1636774480315-8" tab_id="1636774480317-5" sub_desc="Leave all of your troubles behind and enjoy the ultimate escape in our deluxe cabins, perfect for the vacationing family. Ranges from 400 - 600 sqft."][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/webp/photo-1572970385182-97a64c98205b.webp" background_image_position="center bottom" enable_bg_scale="true" background_image_loading="default" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" parallax_bg="true" parallax_bg_speed="fast" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][divider line_type="No Line" custom_height="90vh" custom_height_tablet="50vh"][/vc_column_inner][/vc_row_inner][/tab][tab icon_family="none" title="Ocean Villas" id="1636774480370-4" tab_id="1636774480370-3" sub_desc="A once in a lifetime experience awaits you. Stay on the water in one of our exclusive bungalows hundreds of feet out on the ocean. Ranges from 300 - 500 sqft."][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/webp/photo-1590523277581-658f9545acd2.webp" background_image_position="center center" enable_bg_scale="true" background_image_loading="default" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" parallax_bg="true" parallax_bg_speed="fast" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][divider line_type="No Line" custom_height="90vh" custom_height_tablet="50vh"][/vc_column_inner][/vc_row_inner][/tab][/tabbed_section][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Text With Inline Images', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-11-Nov-2021';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/resort-text-with-images.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" scene_position="center" top_padding="6%" constrain_group_1="yes" bottom_padding="6%" left_padding_desktop="16%" constrain_group_2="yes" right_padding_desktop="16%" left_padding_phone="8%" constrain_group_6="yes" right_padding_phone="8%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" advanced_gradient_angle="0" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" shape_type="" gradient_type="default"][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="0px" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][nectar_text_inline_images images="" image_size="medium" image_effect="circle_reveal" image_effect_rm_mobile="yes" image_loading="skip-lazy-load" line_reveal_by_space_text_effect="default" content_alignment="default" font_size="3vw" font_size_desktop="6vw" font_line_height="1.3" font_size_tablet="6vw" font_size_phone="8vw"]
<h2>An * enchanting new resort nestled on the coast of  Queensland *</h2>
[/nectar_text_inline_images][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Landing Hero Video', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['hero_section'];
$data['custom_class'] = 'hero_section date-11-Nov-2021';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/resort-landing-video.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" scene_position="center" top_padding="80" bottom_padding="6%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="hidden" advanced_gradient_angle="0" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" shape_type="straight_section" gradient_type="default"][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="top-bottom" column_element_spacing="0px" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][vc_row_inner column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" left_padding_desktop="8%" constrain_group_2="yes" right_padding_desktop="8%" translate_y="26%" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" zindex="200" overflow="visible" pointer_events="none"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="0px" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="parallax" animation_movement_type="default" column_parallax_intensity="1" persist_movement_on_mobile="true" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" gradient_type="default"][split_line_heading animation_type="line-reveal-by-space" font_style="h1" text_color="#0a0909" line_reveal_by_space_text_effect="letter-reveal-bottom" mobile_disable_animation="true" content_alignment="center" mobile_content_alignment="inherit" link_target="_self" text_content="YOUR" font_size="13vw" font_line_height="0.8" font_size_tablet="13vw"][/split_line_heading][split_line_heading animation_type="line-reveal-by-space" font_style="h1" text_color="#0a0808" line_reveal_by_space_text_effect="letter-reveal-bottom" mobile_disable_animation="true" content_alignment="center" mobile_content_alignment="inherit" link_target="_self" text_content="PARADISE" font_size="13vw" font_line_height="0.8" font_size_tablet="13vw" animation_delay="200"][/split_line_heading][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" left_padding_desktop="8%" constrain_group_2="yes" right_padding_desktop="8%" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" zindex="1" overflow="hidden" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" advanced_gradient_angle="0" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" mobile_disable_entrance_animation="true" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" delay="550" gradient_type="default"][nectar_video_player_self_hosted video_mp4="" video_image="https://themenectar.com/img/demo-media/unsplash/webp/photo-1633797755709-9eea6ff21df2.webp" el_aspect="235" el_aspect_tablet="169" rm_on_mobile="true" player_functionality="lightbox" play_button_style="follow_mouse" play_button_color="#f4ece2" play_button_icon_color="#122120" border_radius="none" box_shadow="none" advanced_gradient="linear-gradient(180deg, rgba(244,236,226,0.22) 5%, rgba(255,255,255,0) 85%)" advanced_gradient_angle="180" video_lightbox_url="https://vimeo.com/118023315" advanced_gradient_display_type="linear"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'Soft Footer With CTA', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general']. ', ' . $cat_display_names['cta'];
$data['custom_class'] = 'general cta date-22-Feb-2021';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/ecom-robust-footer-3.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#c498d9" scene_position="center" top_padding="10%" bottom_padding="5%" top_padding_tablet="20%" bottom_padding_tablet="10%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" right_padding_desktop="20%" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][split_line_heading animation_type="line-reveal-by-space" font_style="h2" stagger_animation="true" content_alignment="default" mobile_content_alignment="inherit" text_content="Don't wait any longer, take control of your skin today" font_size="8vh"][/split_line_heading][/vc_column_inner][/vc_row_inner][vc_row_inner equal_height="yes" content_placement="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" top_padding="15" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="small_desktop" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom" border_type="simple" column_border_width="none" column_border_style="solid" offset="vc_col-md-6"][vc_custom_heading text="Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt" font_container="tag:p|font_size:18|text_align:left|line_height:1.8" use_theme_fonts="yes"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="small_desktop" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom" border_type="simple" column_border_width="none" column_border_style="solid" offset="vc_col-md-6"][nectar_cta btn_style="see-through" heading_tag="h6" text_color="#ffffff" button_color="black" link_type="regular" alignment="right" alignment_tablet="default" alignment_phone="left" constrain_group_1="yes" constrain_group_3="yes" constrain_group_4="yes" display="block" link_text="Shop Now" padding_top="20" padding_bottom="20" padding_left="50" padding_right="50" url="https://themenectar.com/promo" margin_top="20" margin_bottom="20"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row][vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#c498d9" scene_position="center" top_padding="5%" bottom_padding="10%" top_padding_tablet="10%" bottom_padding_tablet="20%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overlay_strength="0.3" gradient_direction="left_to_right" enable_shape_divider="true" shape_divider_color="#0a0a0a" shape_divider_position="top" shape_divider_height="1" bg_image_animation="none" shape_type="straight_section"][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" bg_image_animation="none" border_type="advanced" column_border_style="solid"][vc_row_inner equal_height="yes" content_placement="top" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="small_desktop" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom" border_type="simple" column_border_width="none" column_border_style="solid" offset="vc_col-md-6"][vc_column_text]
<h5>Contact Us</h5>
[/vc_column_text][nectar_cta btn_style="underline" heading_tag="h4" button_color="default" link_type="regular" alignment="left" alignment_tablet="default" alignment_phone="default" display="block" link_text="+216 (0)40 3629 4753"][nectar_cta btn_style="underline" heading_tag="h4" button_color="default" link_type="regular" alignment="left" alignment_tablet="default" alignment_phone="default" display="block" link_text="hello@domain.com"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="small_desktop" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom" border_type="simple" column_border_width="none" column_border_style="solid" offset="vc_col-md-6"][vc_column_text]
<h5>Connect</h5>
[/vc_column_text][nectar_cta btn_style="underline" heading_tag="h6" button_color="default" link_type="regular" alignment="left" alignment_tablet="default" alignment_phone="default" display="inline" link_text="Instagram" margin_right="30" margin_bottom="10"][nectar_cta btn_style="underline" heading_tag="h6" button_color="default" link_type="regular" alignment="left" alignment_tablet="default" alignment_phone="default" display="inline" link_text="FaceBook" padding_right="30" margin_bottom="10"][nectar_cta btn_style="underline" heading_tag="h6" button_color="default" link_type="regular" alignment="left" alignment_tablet="default" alignment_phone="default" display="inline" link_text="Twitter" padding_right="25" margin_bottom="10"][nectar_cta btn_style="underline" heading_tag="h6" button_color="default" link_type="regular" alignment="left" alignment_tablet="default" alignment_phone="default" display="inline" link_text="YouTube" padding_right="25" margin_bottom="10"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Dark Footer With CTA', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general']. ', ' . $cat_display_names['cta'];
$data['custom_class'] = 'general cta date-22-Feb-2021';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/ecom-robust-footer-2.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#000000" scene_position="center" top_padding="10%" bottom_padding="5%" top_padding_tablet="20%" bottom_padding_tablet="10%" text_color="light" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" right_padding_desktop="20%" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][split_line_heading animation_type="line-reveal-by-space" font_style="h2" stagger_animation="true" content_alignment="default" mobile_content_alignment="inherit" text_content="Don't wait any longer, take control of your skin today" font_size="8vh"][/split_line_heading][/vc_column_inner][/vc_row_inner][vc_row_inner equal_height="yes" content_placement="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" top_padding="15" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="small_desktop" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom" border_type="simple" column_border_width="none" column_border_style="solid" offset="vc_col-md-6"][vc_custom_heading text="Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt" font_container="tag:p|font_size:18|text_align:left|line_height:1.8" use_theme_fonts="yes"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="small_desktop" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom" border_type="simple" column_border_width="none" column_border_style="solid" offset="vc_col-md-6"][nectar_cta btn_style="see-through" heading_tag="h6" button_color="accent-color" link_type="regular" alignment="right" alignment_tablet="default" alignment_phone="left" constrain_group_1="yes" constrain_group_3="yes" constrain_group_4="yes" display="block" link_text="Shop Now" padding_top="20" padding_bottom="20" padding_left="50" padding_right="50" url="https://themenectar.com/promo" margin_top="20" margin_bottom="20"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row][vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#000000" scene_position="center" top_padding="5%" bottom_padding="10%" top_padding_tablet="10%" bottom_padding_tablet="20%" text_color="light" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overlay_strength="0.3" gradient_direction="left_to_right" enable_shape_divider="true" shape_divider_color="#5b5b5b" shape_divider_position="top" shape_divider_height="1" bg_image_animation="none" shape_type="straight_section"][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" bg_image_animation="none" border_type="advanced" column_border_style="solid"][vc_row_inner equal_height="yes" content_placement="top" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="small_desktop" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom" border_type="simple" column_border_width="none" column_border_style="solid" offset="vc_col-md-6"][vc_column_text]
<h5>Contact Us</h5>
[/vc_column_text][nectar_cta btn_style="underline" heading_tag="h4" button_color="default" link_type="regular" alignment="left" alignment_tablet="default" alignment_phone="default" display="block" link_text="+216 (0)40 3629 4753"][nectar_cta btn_style="underline" heading_tag="h4" button_color="default" link_type="regular" alignment="left" alignment_tablet="default" alignment_phone="default" display="block" link_text="hello@domain.com"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="small_desktop" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom" border_type="simple" column_border_width="none" column_border_style="solid" offset="vc_col-md-6"][vc_column_text]
<h5>Connect</h5>
[/vc_column_text][nectar_cta btn_style="underline" heading_tag="h6" text_color="#ffffff" button_color="default" link_type="regular" alignment="left" alignment_tablet="default" alignment_phone="default" display="inline" link_text="Instagram" margin_right="30" margin_bottom="10"][nectar_cta btn_style="underline" heading_tag="h6" text_color="#ffffff" button_color="default" link_type="regular" alignment="left" alignment_tablet="default" alignment_phone="default" display="inline" link_text="FaceBook" padding_right="30" margin_bottom="10"][nectar_cta btn_style="underline" heading_tag="h6" text_color="#ffffff" button_color="default" link_type="regular" alignment="left" alignment_tablet="default" alignment_phone="default" display="inline" link_text="Twitter" padding_right="25" margin_bottom="10"][nectar_cta btn_style="underline" heading_tag="h6" text_color="#ffffff" button_color="default" link_type="regular" alignment="left" alignment_tablet="default" alignment_phone="default" display="inline" link_text="YouTube" padding_right="25" margin_bottom="10"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );





$data = array();
$data['name'] = esc_html__( 'WooCommerce Overflowing Product Carousel', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['shop'];
$data['custom_class'] = 'shop date-22-Feb-2021';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/ecom-robust-product-carousel.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" scene_position="center" top_padding="8%" constrain_group_1="yes" bottom_padding="8%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][nectar_woo_products product_type="all" category="all" columns="4" flickity_mobile_column_width="100%" orderby="date" order="DESC" carousel="1" script="flickity" flickity_wrap="no-wrap" flickity_overflow="visible" flickity_controls="touch_indicator" flickity_image_scale_on_drag="true" flickity_item_animation="fade-in-side" per_page="8"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'Minimal Full Width Grid Columns', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'] . ', ' . $cat_display_names['services'];
$data['custom_class'] = 'general services date-23-Feb-2021';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/ecom-robust-three-col-text-img.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#ffffff" scene_position="center" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="0px" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" bg_image_animation="none" border_type="advanced" border_bottom_desktop="1" column_border_color="#919ec6" column_border_style="solid"][vc_row_inner equal_height="yes" content_placement="middle" column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left"][vc_column_inner column_padding="padding-5-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" bg_image_animation="none" enable_animation="true" animation="fade-in" border_type="advanced" border_bottom_desktop="1" column_border_color="#919ec6" column_border_style="solid" offset="vc_col-xs-7"][nectar_highlighted_text color_type="regular" highlight_color="#ff7530" text_color="#000000" style="full_text" highlight_expansion="default" custom_font_size="4vw"]
<h2>How your skin was <em>meant to be</em>.</h2>
[/nectar_highlighted_text][/vc_column_inner][vc_column_inner column_padding="padding-5-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="right" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" bg_image_animation="none" enable_animation="true" animation="fade-in" border_type="advanced" border_bottom_desktop="1" column_border_color="#919ec6" column_border_style="solid" offset="vc_col-xs-5"][vc_column_text max_width="300"]
<h5>A new way to replenish skin tone and texture.</h5>
[/vc_column_text][/vc_column_inner][/vc_row_inner][vc_row_inner equal_height="yes" column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left"][vc_column_inner column_padding="padding-5-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="default" bg_image_animation="none" enable_animation="true" animation="fade-in" border_type="simple" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1616207860454{margin-bottom: 30px !important;}"]
<h3>Glowing</h3>
Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore.[/vc_column_text][image_with_animation image_url="https://themenectar.com/img/demo-media/unsplash/webp/600-800-waterfall.webp" animation="None" hover_animation="zoom-crop" alignment="" img_link_large="yes" border_radius="none" box_shadow="x_large_depth" image_loading="default" max_width="100%" max_width_mobile="default"][/vc_column_inner][vc_column_inner column_padding="padding-5-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="default" bg_image_animation="none" enable_animation="true" animation="fade-in" border_type="advanced" border_left_desktop="1" border_right_desktop="1" column_border_color="#919ec6" column_border_style="solid" delay="150"][vc_column_text css=".vc_custom_1616207874149{margin-bottom: 30px !important;}"]
<h3>Resilient</h3>
Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.[/vc_column_text][image_with_animation image_url="https://themenectar.com/img/demo-media/unsplash/webp/600-800-leaves.webp" animation="None" hover_animation="zoom-crop" alignment="" img_link_large="yes" border_radius="none" box_shadow="x_large_depth" image_loading="default" max_width="100%" max_width_mobile="default"][/vc_column_inner][vc_column_inner column_padding="padding-5-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="default" bg_image_animation="none" enable_animation="true" animation="fade-in" border_type="simple" column_border_width="none" column_border_style="solid" delay="300"][vc_column_text css=".vc_custom_1616207884304{margin-bottom: 30px !important;}"]
<h3>Smooth</h3>
nostrud exercitation ullamco laboris nisi ut sunt in culpa qui officia deserunt mollit anim id est laborum.[/vc_column_text][image_with_animation image_url="https://themenectar.com/img/demo-media/unsplash/webp/600-800-trees.webp" animation="None" hover_animation="zoom-crop" alignment="" img_link_large="yes" border_radius="none" box_shadow="x_large_depth" image_loading="default" max_width="100%" max_width_mobile="default"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Rotating Text Hero Section', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['hero_section'];
$data['custom_class'] = 'hero_section date-24-Feb-2021';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/ecom-robust-header.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#9fc5d0" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/photo-1611912902203-c4be99ca7126.webp" bg_position="center center" background_image_loading="skip-lazy-load" bg_repeat="no-repeat" scene_position="center" top_padding="15%" bottom_padding="15%" top_padding_tablet="30%" constrain_group_3="yes" bottom_padding_tablet="30%" top_padding_phone="40%" constrain_group_5="yes" bottom_padding_phone="40%" text_color="custom" text_align="left" row_border_radius="none" row_border_radius_applies="bg" color_overlay="#000000" overlay_strength="0.3" gradient_direction="radial" shape_divider_color="#ffffff" shape_divider_position="bottom" shape_divider_height="45%" bg_image_animation="zoom-out" parallax_bg="true" parallax_bg_speed="fast" shape_type="straight_section"][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="0px" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="radial" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="center" bg_image_animation="zoom-out-reveal" parallax_bg="true" parallax_bg_speed="fast" border_type="simple" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" zindex="20"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="0px" background_color_opacity="1" background_hover_color_opacity="1" font_color="#ffffff" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][split_line_heading animation_type="line-reveal-by-space" font_style="h1" stagger_animation="true" content_alignment="default" mobile_content_alignment="inherit" text_content="Skincare made" font_size="10vh" animation_delay="200"][/split_line_heading][nectar_rotating_words_title heading_tag="h1" dynamic_text="simple, pure, honest, custom" ending_text="for you." duration="2500" dynamic_heading_tag="default" element_animation="stagger_words" mobile_display="inline" text_flow="inline" element_animation_delay="550" font_size="10vh"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" zindex="20"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="0px" background_color_opacity="1" background_hover_color_opacity="1" font_color="#ffffff" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom" border_type="simple" column_border_width="none" column_border_style="solid" delay="650"][nectar_cta btn_style="underline" heading_tag="span" text_color="#ffffff" button_color="default" link_type="regular" alignment="left" alignment_tablet="default" alignment_phone="default" constrain_group_3="yes" display="block" link_text="Shop Now" margin_top="30" padding_top="18" padding_bottom="18" margin_bottom="20" url="https://themenectar.com/demo/salient-ecommerce-robust/product-category/skincare/"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'Fancy Box Carousel', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-23-Feb-2021';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/ecom-robust-carousel.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#ffffff" scene_position="center" top_padding="8%" bottom_padding="8%" top_padding_tablet="16%" bottom_padding_tablet="16%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_color="#000000" shape_divider_position="top" bg_image_animation="none" shape_type="straight_section"][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="0px" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_row_inner equal_height="yes" content_placement="bottom" column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bottom_padding="30" bottom_padding_tablet="20" text_align="left"][vc_column_inner column_padding="padding-5-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="right" column_element_spacing="5px" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="small_desktop" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_column_text]</p>
<h2>Featured Products</h2>
<p>Quality ingredients. Real results.[/vc_column_text][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="small_desktop" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" offset="vc_hidden-xs"][nectar_cta btn_style="underline" heading_tag="span" text_color="#000000" button_color="default" link_type="regular" alignment="right" alignment_tablet="default" alignment_phone="default" display="block" link_text="View All Products" url=""][/vc_column_inner][/vc_row_inner][carousel script="flickity" flickity_formatting="default" desktop_cols_flickity="4" desktop_small_cols_flickity="3" tablet_cols_flickity="2" flickity_controls="touch_total" flickity_touch_total_hide_indicator="true" flickity_touch_total_icon_color="dark" color="extra-color-2" flickity_overflow="visible" flickity_wrap_around="no-wrap" flickity_spacing="15px" column_padding="0" flickity_element_spacing="0" flickity_image_scale_on_drag="true" border_radius="none"][item simple_slider_bg_image_position="default" simple_slider_overlay_strength="0.3" id="1616288228607-7" tab_id="1616288228608-5" title="Item"][fancy_box box_style="image_above_text_underline" image_url="https://themenectar.com/img/demo-media/unsplash/webp/neutral-camera.webp" image_aspect_ratio="4-5" content_color="#000000" border_radius="default" image_loading="default" enable_animation="true" animation="fade-in-from-right" image_size="large" link_url="https://themenectar.com/promo" link_screen_reader="Daily anti-aging cream"]</p>
<h4>Daily anti-acne cream with Tretinoin</h4>
<p>A multi purpose cream that fights breakouts while keeping skin youthful.[/fancy_box][/item][item simple_slider_bg_image_position="default" simple_slider_overlay_strength="0.3" id="1616288228653-4" tab_id="1616288228653-6" title="Item"][fancy_box box_style="image_above_text_underline" image_url="https://themenectar.com/img/demo-media/unsplash/webp/neutral-explore.webp" image_aspect_ratio="4-5" content_color="#000000" border_radius="default" image_loading="default" enable_animation="true" animation="fade-in-from-right" image_size="large" link_url="" delay="100" link_screen_reader="Magic eye cream"]</p>
<h4>Magic eye kit</h4>
<p>Super charged active retinol cream that fights off stubborn eye bags 24/7.[/fancy_box][/item][item simple_slider_bg_image_position="default" simple_slider_overlay_strength="0.3" id="1616288228676-8" tab_id="1616288228677-10" title="Item"][fancy_box box_style="image_above_text_underline" image_url="https://themenectar.com/img/demo-media/unsplash/webp/neutral-field.webp" image_aspect_ratio="4-5" content_color="#000000" border_radius="default" image_loading="default" enable_animation="true" animation="fade-in-from-right" image_size="large" link_url="" delay="200" link_screen_reader="Multi-peptide soothing moisturizer"]</p>
<h4>Multi-peptide soothing moisturizer</h4>
<p>An excellent source of antioxidants to sooth your skin. Made from waterlily extracts.[/fancy_box][/item][item simple_slider_bg_image_url="670" simple_slider_bg_image_position="default" simple_slider_overlay_strength="0.3" id="1616288228696-1" tab_id="1616288228696-10" title="Item"][fancy_box box_style="image_above_text_underline" image_url="https://themenectar.com/img/demo-media/unsplash/webp/neutral-girl-2.webp" image_aspect_ratio="4-5" content_color="#000000" border_radius="default" image_loading="default" enable_animation="true" animation="fade-in-from-right" image_size="large" link_url="" delay="300" link_screen_reader="Refreshing complete vitamin C Nectar serum"]</p>
<h4>Refreshing complete vitamin C Nectar serum</h4>
<p>Protect and rejuvenate your skin with our most potent vitamin C serum yet.[/fancy_box][/item][item simple_slider_bg_image_position="default" simple_slider_overlay_strength="0.3" id="1616288228721-9" tab_id="1616288228722-10" title="Item"][fancy_box box_style="image_above_text_underline" image_url="https://themenectar.com/img/demo-media/unsplash/webp/neutral-girl.webp" image_aspect_ratio="4-5" content_color="#000000" border_radius="default" image_loading="default" enable_animation="true" animation="fade-in-from-right" image_size="large" link_url="" delay="400" link_screen_reader="The All-In-One Anti Ace"]</p>
<h4>The All-In-One Anti Ace</h4>
<p>A simple daily supplement that combats acne before it starts.[/fancy_box][/item][item simple_slider_bg_image_position="default" simple_slider_overlay_strength="0.3" id="1616288228768-4" tab_id="1616288228769-4" title="Item"][fancy_box box_style="image_above_text_underline" image_url="https://themenectar.com/img/demo-media/unsplash/webp/neutral-explore.webp" image_aspect_ratio="4-5" content_color="#000000" border_radius="default" image_loading="default" enable_animation="true" animation="fade-in-from-right" image_size="large" link_url="" delay="500" link_screen_reader="The Nectar Super Secret Serum"]</p>
<h4>The Nectar Super Secret Serum</h4>
<p>The best kept secret in the skincare world can finally be yours.[/fancy_box][/item][item simple_slider_bg_image_position="default" simple_slider_overlay_strength="0.3" id="1616288228793-7" tab_id="1616288228794-9" title="Item"][fancy_box box_style="image_above_text_underline" image_url="https://themenectar.com/img/demo-media/unsplash/webp/neutral-camera.webp" image_aspect_ratio="4-5" content_color="#000000" border_radius="default" image_loading="default" enable_animation="true" animation="fade-in-from-right" image_size="large" link_url="https://themenectar.com/" delay="600" link_screen_reader="Vegetable Vitamins"]</p>
<h4>Natural Face Wash</h4>
<p>Easily get the vitamins you've been missing for perfect skin.[/fancy_box][/item][/carousel][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Overflowing Parallax Left With Text', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'] . ', ' . $cat_display_names['about'];
$data['custom_class'] = 'about general date-23-Feb-2021';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/ecom-robust-cascading-left.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#ffffff" scene_position="center" top_padding="4%" bottom_padding="2%" left_padding_desktop="8%" constrain_group_2="yes" right_padding_desktop="8%" top_padding_tablet="8%" constrain_group_3="yes" bottom_padding_tablet="8%" left_padding_phone="0" constrain_group_6="yes" right_padding_phone="0" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_row_inner equal_height="yes" content_placement="middle" column_margin="90px" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left"][vc_column_inner column_padding="padding-4-percent" column_padding_tablet="no-extra-padding" column_padding_phone="no-extra-padding" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][nectar_cascading_images image_1_bg_color="#ff7530" image_1_offset_x_sign="+" image_1_offset_x="0%" image_1_offset_y_sign="+" image_1_offset_y="20%" image_1_rotate_sign="+" image_1_rotate="none" image_1_scale="1" image_1_padding="none" image_1_box_shadow="none" image_1_max_width_desktop="100%" image_1_max_width_mobile="100%" image_1_image_width_mobile="default" image_2_url="http://54cb3baa74d4d851e8b7-2e7f88565dceb0a8192c6645d1f8b1b4.r12.cf2.rackcdn.com/bottle-mockup.png" image_2_offset_x_sign="+" image_2_offset_x="0%" image_2_offset_y_sign="+" image_2_offset_y="10%" image_2_rotate_sign="+" image_2_rotate="none" image_2_scale="1" image_2_padding="none" image_2_box_shadow="none" image_2_max_width_desktop="100%" image_2_max_width_mobile="100%" image_2_image_width_mobile="default" image_3_offset_x_sign="+" image_3_offset_x="0%" image_3_offset_y_sign="+" image_3_offset_y="0%" image_3_rotate_sign="+" image_3_rotate="none" image_3_scale="1" image_3_padding="auto" image_3_box_shadow="none" image_3_max_width_desktop="100%" image_3_max_width_mobile="100%" image_3_image_width_mobile="default" image_4_offset_x_sign="+" image_4_offset_x="0%" image_4_offset_y_sign="+" image_4_offset_y="0%" image_4_rotate_sign="+" image_4_rotate="none" image_4_scale="1" image_4_padding="auto" image_4_box_shadow="none" image_4_max_width_desktop="100%" image_4_max_width_mobile="100%" image_4_image_width_mobile="default" element_sizing="forced" element_sizing_aspect="1-1" image_loading="default" border_radius="none" parallax_scrolling="yes" layer_1_parallax_scrolling="no" parallax_scrolling_intensity="subtle" overflow="hidden"][/vc_column_inner][vc_column_inner column_padding="padding-4-percent" column_padding_tablet="inherit" column_padding_phone="no-extra-padding" column_padding_position="all" top_margin="6%" top_margin_tablet="0" top_margin_phone="4%" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" bg_image_animation="none" parallax_bg="true" parallax_bg_speed="fast" border_type="simple" column_border_width="none" column_border_style="solid"][split_line_heading animation_type="line-reveal-by-space" font_style="h2" stagger_animation="true" content_alignment="default" mobile_content_alignment="inherit" text_content="Anti-Acne solutions that yield fast results" max_width="550"][/split_line_heading][vc_column_text max_width="550"]Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts.[/vc_column_text][nectar_cta btn_style="underline" heading_tag="span" text_color="#000000" button_color="default" link_type="regular" alignment="left" alignment_tablet="default" alignment_phone="default" display="block" link_text="Shop Anti-Acne" url=""][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Overflowing Parallax Right With Text', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'] . ', ' . $cat_display_names['about'];
$data['custom_class'] = 'about general date-23-Feb-2021';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/ecom-robust-cascading-right.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#ffffff" scene_position="center" top_padding="2%" bottom_padding="4%" left_padding_desktop="8%" constrain_group_2="yes" right_padding_desktop="8%" top_padding_tablet="8%" constrain_group_3="yes" bottom_padding_tablet="8%" left_padding_phone="0" constrain_group_6="yes" right_padding_phone="0" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_row_inner equal_height="yes" content_placement="middle" column_margin="90px" column_direction="default" column_direction_tablet="column_reverse" column_direction_phone="column_reverse" text_align="left"][vc_column_inner column_padding="padding-4-percent" column_padding_tablet="inherit" column_padding_phone="no-extra-padding" column_padding_position="all" top_margin="6%" top_margin_tablet="0" top_margin_phone="4%" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="radial" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" bg_image_animation="none" parallax_bg="true" parallax_bg_speed="very_subtle" border_type="simple" column_border_width="none" column_border_style="solid"][split_line_heading animation_type="line-reveal-by-space" font_style="h2" stagger_animation="true" content_alignment="default" mobile_content_alignment="inherit" text_content="Expertly crafted serums for all skin types" max_width="550"][/split_line_heading][vc_column_text max_width="550"]Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts.[/vc_column_text][nectar_cta btn_style="underline" heading_tag="span" text_color="#000000" button_color="default" link_type="regular" alignment="left" alignment_tablet="default" alignment_phone="default" display="block" link_text="Shop Serums" url=""][/vc_column_inner][vc_column_inner column_padding="padding-4-percent" column_padding_tablet="no-extra-padding" column_padding_phone="no-extra-padding" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][nectar_cascading_images image_1_bg_color="#bcafd3" image_1_offset_x_sign="+" image_1_offset_x="0%" image_1_offset_y_sign="+" image_1_offset_y="20%" image_1_rotate_sign="+" image_1_rotate="none" image_1_scale="1" image_1_padding="none" image_1_box_shadow="none" image_1_max_width_desktop="100%" image_1_max_width_mobile="100%" image_1_image_width_mobile="default" image_2_url="http://54cb3baa74d4d851e8b7-2e7f88565dceb0a8192c6645d1f8b1b4.r12.cf2.rackcdn.com/bottle-mockup.png" image_2_offset_x_sign="+" image_2_offset_x="0%" image_2_offset_y_sign="+" image_2_offset_y="10%" image_2_rotate_sign="+" image_2_rotate="none" image_2_scale="1" image_2_padding="none" image_2_box_shadow="none" image_2_max_width_desktop="100%" image_2_max_width_mobile="100%" image_2_image_width_mobile="default" image_3_offset_x_sign="+" image_3_offset_x="0%" image_3_offset_y_sign="+" image_3_offset_y="0%" image_3_rotate_sign="+" image_3_rotate="none" image_3_scale="1" image_3_padding="auto" image_3_box_shadow="none" image_3_max_width_desktop="100%" image_3_max_width_mobile="100%" image_3_image_width_mobile="default" image_4_offset_x_sign="+" image_4_offset_x="0%" image_4_offset_y_sign="+" image_4_offset_y="0%" image_4_rotate_sign="+" image_4_rotate="none" image_4_scale="1" image_4_padding="auto" image_4_box_shadow="none" image_4_max_width_desktop="100%" image_4_max_width_mobile="100%" image_4_image_width_mobile="default" element_sizing="forced" element_sizing_aspect="1-1" image_loading="default" border_radius="none" parallax_scrolling="yes" layer_1_parallax_scrolling="no" parallax_scrolling_intensity="subtle" overflow="hidden"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'Interactive Shop Categories', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['shop'];
$data['custom_class'] = 'shop date-21-Feb-2021';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/ecom-robust-category-grid.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#ffffff" scene_position="center" top_padding="8%" bottom_padding="8%" left_padding_desktop="10%" constrain_group_2="yes" right_padding_desktop="10%" top_padding_tablet="8%" bottom_padding_tablet="20%" top_padding_phone="20%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overlay_strength="0.3" gradient_direction="left_to_right" enable_shape_divider="true" shape_divider_color="#e0e0e0" shape_divider_position="bottom" shape_divider_height="1" bg_image_animation="none" shape_type="straight_section"][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="0px" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bottom_padding="20" bottom_padding_tablet="10" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_column_text]</p>
<h6>All Categories</h6>
<p>[/vc_column_text][/vc_column_inner][/vc_row_inner][nectar_category_grid post_type="products" product_category="all" heading_tag="h2" subtext="none" image_loading="lazy-load" grid_style="mouse_follow_image" image_aspect_ratio="4-5" text_color="dark" text_color_hover="dark" subtext_visibility="always" item_divider_custom=""][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Show-stopper Slider Carousel', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-23-Feb-2021';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/ecom-robust-slider.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#ff7747" scene_position="center" top_padding="12%" left_padding_desktop="15%" constrain_group_2="yes" right_padding_desktop="15%" top_padding_tablet="20%" left_padding_tablet="10%" constrain_group_4="yes" right_padding_tablet="10%" left_padding_phone="0" constrain_group_6="yes" right_padding_phone="0" text_color="light" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" shape_type="straight_section"][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="0px" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bottom_padding="20" bottom_padding_tablet="10" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom" border_type="simple" column_border_width="none" column_border_style="solid"][vc_column_text]</p>
<h6>Real Results, Guaranteed</h6>
<p>[/vc_column_text][/vc_column_inner][/vc_row_inner][split_line_heading animation_type="line-reveal-by-space" font_style="h2" stagger_animation="true" content_alignment="default" mobile_content_alignment="inherit" text_content="Our products are FDA approved and backed by real science" font_size="9vh"][/split_line_heading][/vc_column][/vc_row][vc_row type="full_width_background" full_screen_row_position="middle" column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#ff7747" scene_position="center" top_padding="6%" bottom_padding="6%" top_padding_tablet="7%" bottom_padding_tablet="10%" text_color="custom" custom_text_color="#d4c0ff" text_align="left" row_border_radius="none" row_border_radius_applies="bg" id="impact" overlay_strength="0.3" gradient_direction="left_to_right" enable_shape_divider="true" shape_divider_color="#ffffff" shape_divider_position="bottom" shape_divider_height="50%" bg_image_animation="none" shape_type="straight_section"][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][carousel script="simple_slider" simple_slider_sizing="aspect_ratio" simple_slider_aspect_ratio="2-1" simple_slider_arrow_controls="true" simple_slider_arrow_positioning="inside" simple_slider_pagination_controls="true" simple_slider_pagination_coloring="light" simple_slider_pagination_alignment="right" simple_slider_parallax="true" simple_slider_min_height="575" autorotation_speed="6000"][item simple_slider_bg_image_url="https://themenectar.com/img/demo-media/unsplash/webp/neutral-girl-2.webp" simple_slider_bg_image_position="center-center" simple_slider_font_color="#ffffff" simple_slider_overlay_strength="0.3" simple_slider_gradient_direction="left_to_right" bg_image_url="" bg_image_position="default" image_url="" id="1616288229240-2" tab_id="1616288229241-6" title="Item"][vc_row_inner equal_height="yes" content_placement="middle" column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_column_text max_width="425"]</p>
<h2>Clear up acne breakouts in as little as two days.</h2>
<p>[/vc_column_text][nectar_cta btn_style="underline" heading_tag="span" text_color="#ffffff" button_color="default" link_type="regular" alignment="left" alignment_tablet="default" alignment_phone="default" display="block" link_text="Shop Now" url="" margin_top="35"][/vc_column_inner][/vc_row_inner][/item][item simple_slider_bg_image_url="https://themenectar.com/img/demo-media/unsplash/webp/neutral-girl.webp" simple_slider_bg_image_position="center-center" simple_slider_font_color="#ffffff" simple_slider_overlay_strength="0.3" simple_slider_gradient_direction="left_to_right" bg_image_url="" bg_image_position="default" image_url="" id="1616288229294-4" tab_id="1616288229295-10" title="Item"][vc_row_inner equal_height="yes" content_placement="middle" column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_column_text max_width="450"]</p>
<h2>Finally, a face wash that delivers.</h2>
<p>[/vc_column_text][nectar_cta btn_style="underline" heading_tag="span" text_color="#ffffff" button_color="default" link_type="regular" alignment="left" alignment_tablet="default" alignment_phone="default" display="block" link_text="Explore" url="" margin_top="35"][/vc_column_inner][/vc_row_inner][/item][item simple_slider_bg_image_url="https://themenectar.com/img/demo-media/unsplash/webp/neutral-field.webp" simple_slider_bg_image_position="center-center" simple_slider_font_color="#ffffff" simple_slider_overlay_strength="0.3" simple_slider_gradient_direction="left_to_right" bg_image_url="" bg_image_position="default" image_url="" id="1616288229350-5" tab_id="1616288229351-10" title="Item"][vc_row_inner equal_height="yes" content_placement="middle" column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_column_text max_width="450"]</p>
<h2>Developed to provide deep regeneration.</h2>
<p>[/vc_column_text][nectar_cta btn_style="underline" heading_tag="span" text_color="#ffffff" button_color="default" link_type="regular" alignment="left" alignment_tablet="default" alignment_phone="default" display="block" link_text="Explore" url="https://themenectar.com/" margin_top="35"][/vc_column_inner][/vc_row_inner][/item][/carousel][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'Staggered Testimonials', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['testimonials'];
$data['custom_class'] = 'testimonials date-22-Feb-2021';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/ecom-robust-testimonials.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="90px" column_direction="default" column_direction_tablet="column_reverse" column_direction_phone="column_reverse" bg_color="#ffffff" scene_position="center" top_padding="6%" bottom_padding="2%" left_padding_desktop="8%" constrain_group_2="yes" right_padding_desktop="8%" top_padding_tablet="10%" bottom_padding_tablet="8%" left_padding_tablet="0" constrain_group_4="yes" right_padding_tablet="0" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overlay_strength="0.3" gradient_direction="left_to_right" enable_shape_divider="true" shape_divider_color="#ffffff" shape_divider_position="bottom" shape_divider_height="50%" shape_divider_height_tablet="75%" bg_image_animation="none" shape_type="straight_section"][vc_column column_padding="padding-3-percent" column_padding_tablet="no-extra-padding" column_padding_phone="no-extra-padding" column_padding_position="left-right" top_margin_tablet="20" column_element_spacing="10px" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left"][vc_column_inner column_padding="padding-10-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="0px" background_color_opacity="1" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/webp/tall-testimonial.webp" background_image_position="left top" enable_bg_scale="true" background_image_loading="default" font_color="#ffffff" column_shadow="none" column_border_radius="none" column_link_target="_self" enable_gradient="true" color_overlay_2="#ff4600" gradient_direction="top_to_bottom" overlay_strength="0.5" width="1/1" tablet_width_inherit="default" bg_image_animation="none" parallax_bg="true" parallax_bg_speed="very_subtle" border_type="simple" column_border_width="none" column_border_style="solid"][divider line_type="No Line" custom_height="40vh" custom_height_phone="200"][vc_column_text]
<h4>Marley Cohen</h4>
[/vc_column_text][vc_column_text]Dry Skin[/vc_column_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" top_padding="10%" left_padding_desktop="10%" constrain_group_2="yes" right_padding_desktop="10%" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="5px" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" bg_image_animation="none" enable_animation="true" animation="fade-in" border_type="simple" column_border_width="none" column_border_style="solid"][nectar_icon icon_family="fontawesome" icon_style="default" icon_color_type="color_scheme" icon_color="Accent-Color" icon_padding="0px" icon_fontawesome="fa fa-star" icon_size="14" margin_right="5"][nectar_icon icon_family="fontawesome" icon_style="default" icon_color_type="color_scheme" icon_color="Accent-Color" icon_padding="0px" icon_fontawesome="fa fa-star" icon_size="14" margin_right="5"][nectar_icon icon_family="fontawesome" icon_style="default" icon_color_type="color_scheme" icon_color="Accent-Color" icon_padding="0px" icon_fontawesome="fa fa-star" icon_size="14" margin_right="5"][nectar_icon icon_family="fontawesome" icon_style="default" icon_color_type="color_scheme" icon_color="Accent-Color" icon_padding="0px" icon_fontawesome="fa fa-star" icon_size="14" margin_right="5"][nectar_icon icon_family="fontawesome" icon_style="default" icon_color_type="color_scheme" icon_color="Accent-Color" icon_padding="0px" icon_fontawesome="fa fa-star" icon_size="14" margin_right="5"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bottom_padding="10%" left_padding_desktop="10%" constrain_group_2="yes" right_padding_desktop="10%" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="5px" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][split_line_heading animation_type="line-reveal-by-space" font_style="h5" stagger_animation="true" mobile_disable_animation="true" content_alignment="default" mobile_content_alignment="inherit" text_content="``Vivamus egestas tincidunt sapien at pulvinar. Nullam pretium lorem est. Mauris orci lectus, porttitor ac quam a, egestas.``" max_width="650"][/split_line_heading][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="padding-3-percent" column_padding_tablet="no-extra-padding" column_padding_phone="no-extra-padding" column_padding_position="left-right" column_element_spacing="10px" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bottom_padding="30" bottom_padding_tablet="15" right_padding_tablet="15%" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][split_line_heading animation_type="line-reveal-by-space" font_style="h2" stagger_animation="true" content_alignment="default" mobile_content_alignment="inherit" text_content="Real people with life-changing results" max_width="575"][/split_line_heading][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left"][vc_column_inner column_padding="padding-10-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="0px" background_color_opacity="1" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/webp/tall-testimonial-2.webp" background_image_position="center center" enable_bg_scale="true" background_image_loading="default" font_color="#ffffff" column_shadow="none" column_border_radius="none" column_link_target="_self" enable_gradient="true" color_overlay_2="#ff4600" gradient_direction="top_to_bottom" overlay_strength="0.5" width="1/1" tablet_width_inherit="default" bg_image_animation="none" parallax_bg="true" parallax_bg_speed="very_subtle" border_type="simple" column_border_width="none" column_border_style="solid"][divider line_type="No Line" custom_height="40vh" custom_height_phone="200"][vc_column_text]
<h4>TJ Davis</h4>
[/vc_column_text][vc_column_text]Oily Skin[/vc_column_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" top_padding="10%" left_padding_desktop="10%" constrain_group_2="yes" right_padding_desktop="10%" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="5px" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" bg_image_animation="none" enable_animation="true" animation="fade-in" border_type="simple" column_border_width="none" column_border_style="solid"][nectar_icon icon_family="fontawesome" icon_style="default" icon_color_type="color_scheme" icon_color="Accent-Color" icon_padding="0px" icon_fontawesome="fa fa-star" icon_size="14" margin_right="5"][nectar_icon icon_family="fontawesome" icon_style="default" icon_color_type="color_scheme" icon_color="Accent-Color" icon_padding="0px" icon_fontawesome="fa fa-star" icon_size="14" margin_right="5"][nectar_icon icon_family="fontawesome" icon_style="default" icon_color_type="color_scheme" icon_color="Accent-Color" icon_padding="0px" icon_fontawesome="fa fa-star" icon_size="14" margin_right="5"][nectar_icon icon_family="fontawesome" icon_style="default" icon_color_type="color_scheme" icon_color="Accent-Color" icon_padding="0px" icon_fontawesome="fa fa-star" icon_size="14" margin_right="5"][nectar_icon icon_family="fontawesome" icon_style="default" icon_color_type="color_scheme" icon_color="Accent-Color" icon_padding="0px" icon_fontawesome="fa fa-star-half-o" icon_size="14"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bottom_padding="10%" left_padding_desktop="10%" constrain_group_2="yes" right_padding_desktop="10%" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="5px" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][split_line_heading animation_type="line-reveal-by-space" font_style="h5" stagger_animation="true" mobile_disable_animation="true" content_alignment="default" mobile_content_alignment="inherit" text_content="``Mauris orci lectus, porttitor ac quam a, egestas consequat lorem. Nullam tincidunt. Mauris orci lectus, porttitor ac quam.``" max_width="650"][/split_line_heading][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'Triple Info Columns', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'] . ', ' . $cat_display_names['services'];
$data['custom_class'] = 'general services date-22-Feb-2021';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/ecom-robust-three-col-text.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" scene_position="center" top_padding="6%" bottom_padding="12%" bottom_padding_tablet="30%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_row_inner equal_height="yes" column_margin="90px" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="0px" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="default" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom" border_type="simple" column_border_width="none" column_border_style="solid"][vc_column_text max_width="350"]
<h4>Quality Ingredients</h4>
[/vc_column_text][divider line_type="No Line" custom_height="15"][vc_column_text max_width="350"]Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts.[/vc_column_text][nectar_cta btn_style="underline" heading_tag="span" text_color="#000000" button_color="default" link_type="regular" alignment="center" alignment_tablet="default" alignment_phone="default" display="block" link_text="Explore" url="" margin_top="15"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" top_margin_tablet="50" constrain_group_3="yes" bottom_margin_tablet="50" top_margin_phone="30" constrain_group_5="yes" bottom_margin_phone="30" column_element_spacing="0px" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="default" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom" border_type="simple" column_border_width="none" column_border_style="solid" delay="100"][vc_column_text max_width="350"]
<h4>Lasting Results</h4>
[/vc_column_text][divider line_type="No Line" custom_height="15"][vc_column_text max_width="350"]Even the all-powerful Pointing has no control about the blind texts. One day a line of blind text by the name.[/vc_column_text][nectar_cta btn_style="underline" heading_tag="span" text_color="#000000" button_color="default" link_type="regular" alignment="center" alignment_tablet="default" alignment_phone="default" display="block" link_text="Explore" url="" margin_top="15"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" top_margin_tablet="20" column_element_spacing="0px" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="default" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom" border_type="simple" column_border_width="none" column_border_style="solid" delay="200"][vc_column_text max_width="350"]
<h4>Fast Shipping</h4>
[/vc_column_text][divider line_type="No Line" custom_height="15"][vc_column_text max_width="350"]A small river named Duden flows by their place and supplies it with the necessary regelialia.[/vc_column_text][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'Fun Dual Column Footer', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-22-Feb-2021';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/ecom-robust-footer.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="none" equal_height="yes" content_placement="middle" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#111111" scene_position="center" text_color="light" text_align="left" row_border_radius="none" row_border_radius_applies="bg" color_overlay="#111111" overlay_strength="0.8" gradient_direction="radial" shape_divider_position="bottom" bg_image_animation="none" shape_type="straight_section"][vc_column column_padding="padding-10-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="right" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_row_inner equal_height="yes" column_margin="70px" column_direction="default" column_direction_tablet="default" column_direction_phone="default" top_padding="25%" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="small_desktop" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_column_text]
<h4>Come Visit</h4>
The Castle Unit 345 2500 Castle Dr
Manhattan, NY[/vc_column_text][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="small_desktop" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_column_text]
<h4>Contact Us</h4>
+216 (0)40 3629 4753
hello@themenectar.com[/vc_column_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" top_padding="5%" bottom_padding="25%" bottom_padding_tablet="15%" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="0px" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][nectar_cta btn_style="underline" heading_tag="span" text_color="#ffffff" button_color="default" link_type="regular" alignment="left" alignment_tablet="default" alignment_phone="default" display="inline" link_text="Instagram" margin_right="30" margin_bottom="10"][nectar_cta btn_style="underline" heading_tag="span" text_color="#ffffff" button_color="default" link_type="regular" alignment="left" alignment_tablet="default" alignment_phone="default" display="inline" link_text="FaceBook" padding_right="30" margin_bottom="10"][nectar_cta btn_style="underline" heading_tag="span" text_color="#ffffff" button_color="default" link_type="regular" alignment="left" alignment_tablet="default" alignment_phone="default" display="inline" link_text="Twitter" padding_right="25" margin_bottom="10"][nectar_cta btn_style="underline" heading_tag="span" text_color="#ffffff" button_color="default" link_type="regular" alignment="left" alignment_tablet="default" alignment_phone="default" display="inline" link_text="YouTube" padding_right="25" margin_bottom="10"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="padding-10-percent" column_padding_tablet="no-extra-padding" column_padding_phone="no-extra-padding" column_padding_position="left" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" bg_image_animation="none" border_type="advanced" border_left_desktop="1" border_left_tablet="0" border_top_tablet="1" border_left_phone="0" border_top_phone="1" column_border_color="#5e5e5e" column_border_style="solid"][vc_row_inner column_margin="90px" column_direction="default" column_direction_tablet="default" column_direction_phone="default" top_padding="15%" constrain_group_1="yes" bottom_padding="15%" top_padding_tablet="15%" bottom_padding_tablet="10%" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_column_text max_width="500"]
<h2>Stay in the loop with our weekly newsletter</h2>
[/vc_column_text][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row][vc_row type="full_width_content" full_screen_row_position="middle" column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#111111" scene_position="center" text_color="light" text_align="left" row_border_radius="none" row_border_radius_applies="bg" color_overlay="#111111" overlay_strength="0.8" gradient_direction="radial" shape_divider_position="bottom" bg_image_animation="none" shape_type="straight_section"][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" bg_image_animation="none" border_type="advanced" border_top_desktop="1" border_top_tablet="0" border_top_phone="0" column_border_color="#5e5e5e" column_border_style="solid"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" top_padding="50" constrain_group_1="yes" bottom_padding="50" top_padding_tablet="0" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][nectar_scrolling_text scroll_direction="ltr" scroll_speed="slowest" style="text_outline" outline_thickness="thin" text_repeat_number="5" text_repeat_divider="custom" text_repeat_divider_scale="half" overflow="hidden" background_image_animation="None" custom_font_size="11vh" text_repeat_divider_custom="·" custom_font_size_mobile="8vh"]
<h2><a href="#"><em>Salient WordPress Theme</em></a></h2>
[/nectar_scrolling_text][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );





$data = array();
$data['name'] = esc_html__( 'Text right with parallax image', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-22-Feb-2021';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/ecom-robust-left-parallax-img.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="90px" equal_height="yes" content_placement="middle" column_direction="default" column_direction_tablet="column_reverse" column_direction_phone="column_reverse" bg_color="#ffffff" scene_position="center" top_padding="6%" bottom_padding="2%" top_padding_tablet="8%" bottom_padding_tablet="8%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" id="home" overlay_strength="0.5" gradient_direction="top_to_bottom" shape_divider_position="bottom" bg_image_animation="none" shape_type="straight_section"][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.5" width="1/2" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" offset="vc_col-xs-12"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/webp/mountain.webp" background_image_position="center center" enable_bg_scale="true" background_image_loading="default" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.5" width="1/1" tablet_width_inherit="default" bg_image_animation="none" parallax_bg="true" parallax_bg_speed="fast" border_type="simple" column_border_width="none" column_border_style="solid"][divider line_type="No Line" custom_height="55vh" custom_height_tablet="40vh" custom_height_phone="300px"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="padding-4-percent" column_padding_tablet="no-extra-padding" column_padding_phone="no-extra-padding" column_padding_position="right" column_element_spacing="10px" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" zindex="100" gradient_direction="left_t_to_right_b" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" offset="vc_col-xs-12"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" min_width="47vh"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="5px" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom" border_type="simple" column_border_width="none" column_border_style="solid" enable_border_animation="true"][nectar_highlighted_text color_type="regular" highlight_color="#ff7530" text_color="#ff7530" style="regular_underline" highlight_expansion="default" underline_thickness="1px" delay="400"]
<h5><em>No Shortcuts</em></h5>
[/nectar_highlighted_text][vc_column_text css_animation="none" css=".vc_custom_1615162301211{margin-bottom: 20px !important;}"]
<h3>Glowing Skin</h3>
[/vc_column_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" min_width="47vh"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="5px" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom" border_type="simple" column_border_width="none" column_border_style="solid" enable_border_animation="true"][vc_column_text]Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer lobortis, nunc quis pharetra volutpat, nulla tellus commodo quam, non rutrum purus leo laoreet risus. Praesent id ipsum in nibh interdum eleifend quis et tellus. Suspendisse eu facilisis eros. Cras egestas convallis sem, a rutrum nisl.

Quisque pulvinar, metus ac scelerisque scelerisque, arcu dui consectetur lorem, at tristique magna magna vel sapien. Vivamus commodo sodales sem faucibus tincidunt. Nunc ut mi id dui suscipit varius et vel mi.

Nunc vel nunc vitae risus ornare convallis. Vestibulum non sem at turpis dictum pulvinar at interdum urna. Ut nec iaculis urna.[/vc_column_text][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Text left with parallax image', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-22-Feb-2021';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/ecom-robust-right-parallax-img.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="90px" equal_height="yes" content_placement="middle" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#ffffff" scene_position="center" top_padding_tablet="8%" bottom_padding_tablet="8%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" id="home" overlay_strength="0.5" gradient_direction="top_to_bottom" shape_divider_position="bottom" bg_image_animation="none" shape_type="straight_section"][vc_column column_padding="padding-4-percent" column_padding_tablet="no-extra-padding" column_padding_phone="no-extra-padding" column_padding_position="right" column_element_spacing="10px" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" zindex="100" gradient_direction="left_t_to_right_b" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" offset="vc_col-xs-12"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" min_width="47vh"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="5px" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom" border_type="simple" column_border_width="none" column_border_style="solid" enable_border_animation="true"][nectar_highlighted_text color_type="regular" highlight_color="#ff7530" text_color="#ff7530" style="regular_underline" highlight_expansion="default" underline_thickness="1px" delay="400"]
<h5><em>The difference</em></h5>
[/nectar_highlighted_text][vc_column_text css_animation="none" css=".vc_custom_1615162291092{margin-bottom: 20px !important;}"]
<h3>Gentle Exfoliation</h3>
[/vc_column_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" min_width="47vh"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="5px" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom" border_type="simple" column_border_width="none" column_border_style="solid" enable_border_animation="true"][vc_column_text]
<h6>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer lobortis, nunc quis pharetra volutpat, nulla tellus commodo quam, non rutrum purus leo laoreet risus. Praesent id ipsum in nibh interdum eleifend quis et tellus. Suspendisse eu facilisis eros.</h6>
[/vc_column_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="90px" column_direction="default" column_direction_tablet="default" column_direction_phone="default" top_padding="30" top_padding_tablet="0" top_padding_phone="0" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" top_margin="20" bottom_margin="20" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="small_desktop" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom" border_type="simple" column_border_width="none" column_border_style="solid" offset="vc_col-lg-6 vc_col-md-12"][vc_column_text css_animation="none" css=".vc_custom_1615162320908{margin-bottom: 10px !important;}"]
<h4>Vegan</h4>
[/vc_column_text][vc_column_text]The Big Oxmox advised her not to do so, because there were thousands of bad Commas, wild Question Marks and devious Semikoli.[/vc_column_text][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" top_margin="20" bottom_margin="20" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="small_desktop" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom" border_type="simple" column_border_width="none" column_border_style="solid" offset="vc_col-lg-6 vc_col-md-12"][vc_column_text css_animation="none" css=".vc_custom_1615162311994{margin-bottom: 10px !important;}"]
<h4>Non-abrasive</h4>
[/vc_column_text][vc_column_text]Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean.[/vc_column_text][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.5" width="1/2" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" offset="vc_col-xs-12"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/webp/large-urban.webp" background_image_position="center center" enable_bg_scale="true" background_image_loading="default" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.5" width="1/1" tablet_width_inherit="default" bg_image_animation="none" parallax_bg="true" parallax_bg_speed="fast" border_type="simple" column_border_width="none" column_border_style="solid"][divider line_type="No Line" custom_height="55vh" custom_height_tablet="40vh" custom_height_phone="300px"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Carousel FAQ', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-20-Feb-2021';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/ecom-robust-faq.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#ffffff" scene_position="center" top_padding="4%" bottom_padding="9%" top_padding_tablet="20%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overlay_strength="1" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bottom_padding="1.5%" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][split_line_heading animation_type="line-reveal-by-space" font_style="h2" text_color="#000000" stagger_animation="true" content_alignment="center" mobile_content_alignment="inherit" text_content="Need more info? Check out our most frequently asked questions." max_width="700"][/split_line_heading][/vc_column_inner][/vc_row_inner][carousel script="flickity" flickity_formatting="default" desktop_cols_flickity="3" desktop_small_cols_flickity="2" tablet_cols_flickity="2" flickity_controls="default" color="default" flickity_overflow="visible" flickity_wrap_around="no-wrap" pagination_alignment_flickity="default" flickity_spacing="15px" column_padding="30px" flickity_element_spacing="30px" flickity_image_scale_on_drag="true" border_radius="none" enable_column_border="true"][item simple_slider_bg_image_position="default" simple_slider_overlay_strength="0.3" id="1616281899173-8" tab_id="1616281899174-2" title="Item"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left"][vc_column_inner column_padding="padding-2-percent" column_padding_tablet="inherit" column_padding_phone="no-extra-padding" column_padding_position="all" column_element_spacing="10px" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_column_text max_width="375"]</p>
<h4>How soon will products ship outside the U.S.?</h4>
<p>[/vc_column_text][vc_column_text css=".vc_custom_1616282728232{margin-top: 10px !important;}" max_width="375"]Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris facilisis lorem sed nisl vulputate varius. Integer quis fermentum enim.[/vc_column_text][/vc_column_inner][/vc_row_inner][/item][item simple_slider_bg_image_position="default" simple_slider_overlay_strength="0.3" id="1616281899251-5" tab_id="1616281899252-9" title="Item"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left"][vc_column_inner column_padding="padding-2-percent" column_padding_tablet="inherit" column_padding_phone="no-extra-padding" column_padding_position="all" column_element_spacing="10px" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_column_text max_width="375"]</p>
<h4>What is your return policy for opened products?</h4>
<p>[/vc_column_text][vc_column_text css=".vc_custom_1616282737786{margin-top: 10px !important;}" max_width="375"]In vulputate dolor eu fermentum pharetra. Sed finibus nunc sed hendrerit imperdiet. Nam nisi justo, maximus id elit vel, dictum lacinia turpis.[/vc_column_text][/vc_column_inner][/vc_row_inner][/item][item simple_slider_bg_image_position="default" simple_slider_overlay_strength="0.3" id="1616281899312-6" tab_id="1616281899313-6" title="Item"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left"][vc_column_inner column_padding="padding-2-percent" column_padding_tablet="inherit" column_padding_phone="no-extra-padding" column_padding_position="all" column_element_spacing="10px" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_column_text max_width="375"]</p>
<h4>Are all of your products organic and cruely-free?</h4>
<p>[/vc_column_text][vc_column_text css=".vc_custom_1616282746674{margin-top: 10px !important;}" max_width="375"]Nam nisi justo, maximus id elit vel, dictum lacinia turpis. Integer cursus lorem vitae urna pharetra, ac aliquet metus condimentum.[/vc_column_text][/vc_column_inner][/vc_row_inner][/item][item simple_slider_bg_image_position="default" simple_slider_overlay_strength="0.3" id="1616281899370-3" tab_id="1616281899371-10" title="Item"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left"][vc_column_inner column_padding="padding-2-percent" column_padding_tablet="inherit" column_padding_phone="no-extra-padding" column_padding_position="all" column_element_spacing="10px" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_column_text max_width="375"]</p>
<h4>Do you offer any promotions for first-time buyers?</h4>
<p>[/vc_column_text][vc_column_text css=".vc_custom_1616282753059{margin-top: 10px !important;}" max_width="375"]Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris facilisis lorem sed nisl vulputate varius. Integer quis fermentum enim.[/vc_column_text][/vc_column_inner][/vc_row_inner][/item][/carousel][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Layered Parallax Blocks', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['services'] . ', ' . $cat_display_names['cta'];
$data['custom_class'] = 'services cta date-21-Feb-2021';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/ecom-robust-dual-parallax.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#ffffff" scene_position="center" top_padding="4%" bottom_padding="4%" top_padding_tablet="8%" constrain_group_3="yes" bottom_padding_tablet="8%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_row_inner equal_height="yes" content_placement="middle" column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left"][vc_column_inner column_padding="padding-5-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/webp/neutral-field.webp" background_image_position="center center" enable_bg_scale="true" background_image_loading="default" font_color="#ffffff" column_shadow="none" column_border_radius="none" column_link_target="_self" enable_gradient="true" color_overlay="#0a0a0a" gradient_direction="radial" overlay_strength="0.5" width="1/2" tablet_width_inherit="default" bg_image_animation="none" parallax_bg="true" parallax_bg_speed="very_subtle" border_type="simple" column_border_width="none" column_border_style="solid"][divider line_type="No Line" custom_height="35vh" custom_height_phone="150"][vc_column_text max_width="350" css=".vc_custom_1607992185528{margin-bottom: 15px !important;}"]
<h2>Serums</h2>
[/vc_column_text][nectar_cta btn_style="underline" heading_tag="span" text_color="#ffffff" button_color="default" link_type="regular" alignment="center" alignment_tablet="default" alignment_phone="default" display="block" link_text="Shop Now" url="#"][divider line_type="No Line" custom_height="35vh" custom_height_phone="150"][/vc_column_inner][vc_column_inner column_padding="padding-5-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/webp/neutral-girl.webp" background_image_position="center center" enable_bg_scale="true" background_image_loading="default" font_color="#ffffff" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="radial" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" bg_image_animation="none" parallax_bg="true" parallax_bg_speed="fast" border_type="simple" column_border_width="none" column_border_style="solid"][divider line_type="No Line" custom_height="35vh" custom_height_phone="150"][vc_column_text css=".vc_custom_1607992178595{margin-bottom: 15px !important;}" max_width="350"]
<h2>Anti-Acne</h2>
[/vc_column_text][nectar_cta btn_style="underline" heading_tag="span" text_color="#ffffff" button_color="default" link_type="regular" alignment="center" alignment_tablet="default" alignment_phone="default" display="block" link_text="Shop Now" url="#"][divider line_type="No Line" custom_height="35vh" custom_height_phone="150"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Rotating Words, Text Above Image', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['hero_section'];
$data['custom_class'] = 'hero_section date-20-Feb-2018';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/ecom-robust-header-2.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#ffeddc" scene_position="center" top_padding="8%" constrain_group_1="yes" bottom_padding="8%" text_color="custom" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overlay_strength="0.3" gradient_direction="left_to_right" enable_shape_divider="true" shape_divider_color="#ffffff" shape_divider_position="bottom" shape_divider_height="33%" bg_image_animation="none" shape_type="straight_section"][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="top-bottom" column_element_spacing="0px" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="radial" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bottom_padding="35" left_padding_desktop="6%" constrain_group_2="yes" right_padding_desktop="6%" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="0px" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][split_line_heading animation_type="line-reveal-by-space" font_style="h1" stagger_animation="true" content_alignment="default" mobile_content_alignment="inherit" text_content="Premium skincare" font_size="7vh"][/split_line_heading][nectar_rotating_words_title heading_tag="h1" beginning_text="made" dynamic_text="simple, affordable, honestly, suited" ending_text="for you." duration="2500" dynamic_heading_tag="default" element_animation="stagger_words" mobile_display="inline" text_flow="inline" element_animation_delay="300" font_size="7vh"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left"][vc_column_inner column_padding="padding-2-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="0px" background_color_opacity="1" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/webp/large-business.webp" background_image_position="center center" enable_bg_scale="true" background_image_loading="default" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom" parallax_bg="true" parallax_bg_speed="fast" border_type="simple" column_border_width="none" column_border_style="solid"][divider line_type="No Line" custom_height="60vh" custom_height_tablet="50vh" custom_height_phone="40vh"][split_line_heading animation_type="line-reveal-by-space" font_style="h5" text_color="#ffffff" stagger_animation="true" content_alignment="right" mobile_content_alignment="left" text_content="Skin that glows, guaranteed." max_width="300"][/split_line_heading][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Call To Action with Scrolling Text Button', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['cta'];
$data['custom_class'] = 'cta date-19-Feb-2021';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/ecom-robust-cta.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" scene_position="center" top_padding="5%" constrain_group_1="yes" bottom_padding="5%" text_color="light" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="padding-11-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/webp/large-adventure.webp" background_image_position="center center" background_image_loading="default" column_shadow="none" column_border_radius="15px" column_link_target="_self" enable_gradient="true" color_overlay="#3648d6" color_overlay_2="#ff7530" gradient_direction="left_b_to_right_t" overlay_strength="0.95" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" bg_image_animation="none" parallax_bg="true" parallax_bg_speed="fast" border_type="simple" column_border_width="none"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bottom_padding="20" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][split_line_heading animation_type="line-reveal-by-space" font_style="h2" stagger_animation="true" content_alignment="default" mobile_content_alignment="inherit" text_content="Take the leap today and start building your site" max_width="700" font_size="65px"][/split_line_heading][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" left_padding_desktop="25%" constrain_group_2="yes" right_padding_desktop="25%" left_padding_tablet="20%" constrain_group_4="yes" right_padding_tablet="20%" left_padding_phone="15%" constrain_group_6="yes" right_padding_phone="15%" text_align="left"][vc_column_inner column_padding="padding-3-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="top-bottom" column_element_spacing="default" background_color="#ff7530" background_color_opacity="1" background_color_hover="#3648d6" background_hover_color_opacity="1" column_shadow="none" column_border_radius="10px" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom" border_type="simple" column_border_width="none" column_border_style="solid" column_link="#"][nectar_scrolling_text scroll_direction="ltr" scroll_speed="medium" text_color="#ffffff" style="default" text_repeat_number="6" text_repeat_divider="space" overflow="hidden" background_image_animation="None" custom_font_size="30px"]
<h4> Learn More</h4>
[/nectar_scrolling_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" top_padding="10" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom" border_type="simple" column_border_width="none" column_border_style="solid"][vc_column_text]⚬ Quality guarantee ⚬ Free 30-day trial ⚬ Trusted globally[/vc_column_text][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );






$data = array();
$data['name'] = esc_html__( 'Post Grid, Content Under Featured Image', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['blog'];
$data['custom_class'] = 'blog date-18-Jan-2020';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/npo-blog-2.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="in_container" full_screen_row_position="middle" column_margin="default" scene_position="center" text_color="dark" text_align="left" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none"][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][nectar_post_grid post_type="post" blog_category="all" order="DESC" orderby="date" pagination="load-more" button_color="black" columns="3" grid_item_spacing="25px" grid_item_height="30vh" image_size="large" image_loading="default" heading_tag="default" enable_indicator="yes" mouse_indicator_style="default" mouse_indicator_text="view" mouse_indicator_color="#000000" animation="none" display_categories="yes" display_date="yes" display_excerpt="yes" grid_style="content_under_image" text_color="dark" hover_effect="zoom" border_radius="5px" posts_per_page="6"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'Post Grid, Content Under Featured Image Masonry', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['blog'];
$data['custom_class'] = 'blog date-18-Jan-2020';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/npo-blog-1.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="in_container" full_screen_row_position="middle" column_margin="default" scene_position="center" text_color="dark" text_align="left" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none"][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][nectar_post_grid post_type="post" blog_category="all" order="DESC" orderby="date" pagination="load-more" button_color="black" columns="4" grid_item_spacing="25px" grid_item_height="30vh" enable_masonry="yes" image_size="large" image_loading="default" heading_tag="default" enable_indicator="yes" mouse_indicator_style="default" mouse_indicator_text="view" mouse_indicator_color="#000000" animation="none" display_categories="yes" display_date="yes" display_excerpt="yes" grid_style="content_under_image" text_color="dark" hover_effect="zoom" border_radius="5px" posts_per_page="6"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Nonprofit Dual CTA', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['cta'];
$data['custom_class'] = 'cta date-18-Jan-2020';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/npo-cta.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" bg_color="#ffffff" scene_position="center" top_padding="8%" text_color="dark" text_align="left" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_b_to_right_t" overlay_strength="1" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_row_inner column_margin="default" bottom_padding="5%" text_align="left"][vc_column_inner centered_text="true" column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][split_line_heading animation_type="line-reveal-by-space" font_style="h2" text_content="It's time to make nature our priority. Let's change the world together." max_width="650"][/split_line_heading][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row][vc_row type="full_width_background" full_screen_row_position="middle" column_margin="none" equal_height="yes" content_placement="middle" bg_color="#ffffff" scene_position="center" bottom_padding="8%" text_color="dark" text_align="left" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color="#f4f4f4" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" tablet_text_alignment="center" phone_text_alignment="center" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][vc_row_inner equal_height="yes" content_placement="middle" column_margin="none" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/webp/neutral-field.webp" background_image_position="center center" enable_bg_scale="true" column_shadow="none" column_border_radius="none" column_link_target="_self" enable_gradient="true" color_overlay_2="#f4f4f4" gradient_direction="left_to_right" overlay_strength="1" width="1/2" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" offset="vc_hidden-sm vc_hidden-xs"][/vc_column_inner][vc_column_inner column_padding="padding-3-percent" column_padding_tablet="padding-6-percent" column_padding_phone="padding-12-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="5/12" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][divider line_type="No Line" custom_height="5vh" custom_height_tablet="0vh"][vc_column_text css=".vc_custom_1579541117059{margin-bottom: 50px !important;}"]Every little bit helps the greater good of the world.[/vc_column_text][nectar_cta btn_style="arrow-animation" heading_tag="h5" text_color="#ffffff" button_color="accent-color" link_type="regular" alignment="left" display="block" link_text="Donate" url="#" padding_top="15" padding_right="30" padding_bottom="15" padding_left="25"][divider line_type="No Line" custom_height="5vh" custom_height_tablet="0vh"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/12" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/webp/neutral-explore.webp" background_image_position="center center" enable_bg_scale="true" column_shadow="none" column_border_radius="none" column_link_target="_self" color_overlay="rgba(0,0,0,0.7)" gradient_direction="left_to_right" overlay_strength="0.8" width="1/2" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner centered_text="true" column_padding="padding-12-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" font_color="#ffffff" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_column_text css=".vc_custom_1579541110385{margin-bottom: 50px !important;}" max_width="280"]We have a long track record of wide-reaching effects.[/vc_column_text][nectar_cta btn_style="arrow-animation" heading_tag="h5" text_color="#000000" button_color="white" link_type="regular" alignment="center" display="block" link_text="See our Impact" url="#" padding_top="15" padding_right="30" padding_bottom="15" padding_left="25"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'Nonprofit Scrolling Text', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['about'] . ', ' . $cat_display_names['general'];
$data['custom_class'] = 'about general date-19-Jan-2020';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/npo-scrolling2.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#f7f7f7" scene_position="center" top_padding="14%" constrain_group_1="yes" bottom_padding="14%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" zindex="100" id="beliefs" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_row_inner column_margin="90px" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bottom_padding="5%" text_align="left"][vc_column_inner column_padding="padding-2-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="right" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_column_text]
<h3>If we can find the right way to teach people about wildlife, they will be touched.</h3>
[/vc_column_text][/vc_column_inner][vc_column_inner column_padding="padding-2-percent" column_padding_tablet="no-extra-padding" column_padding_phone="no-extra-padding" column_padding_position="left" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_column_text]Aliquam ligula lectus, efficitur non pretium quis, elementum quis sapien. Nunc dapibus mi vitae mi placerat eleifend. Cras ullamcorper. Aliquam ligula lectus, efficitur non pretium quis.[/vc_column_text][nectar_cta btn_style="arrow-animation" heading_tag="h5" text_color="#000000" button_color="default" link_type="regular" alignment="left" display="block" link_text="Make a Donation" url="#" margin_top="30"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][nectar_scrolling_text scroll_direction="ltr" scroll_speed="slow" text_color="#b5b5b5" style="text_outline" outline_thickness="thin" text_repeat_number="3" text_repeat_divider="none" overflow="hidden" background_image_url="https://themenectar.com/img/demo-media/unsplash/webp/large-adventure.webp" background_image_animation="ro-reveal-from-bottom" separate_text_coloring="true" text_color_front="#ffffff" scroll_functionality="automatic" custom_font_size="15vh" custom_font_size_mobile="11vw" background_image_height="55vh"]
<h2><i>You Can Make A Difference</i></h2>
[/nectar_scrolling_text][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Nonprofit Scrolling Text Dark', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['about'] . ', ' . $cat_display_names['general'];
$data['custom_class'] = 'about general date-19-Jan-2020';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/npo-scrolling.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" bg_color="#000000" scene_position="center" top_padding="14%" constrain_group_1="yes" bottom_padding="14%" text_color="light" text_align="left" zindex="100" id="beliefs" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_row_inner column_margin="90px" bottom_padding="5%" text_align="left"][vc_column_inner column_padding="padding-2-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="right" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_column_text]</p>
<h3>If we can find the right way to teach people about wildlife, they will be touched.</h3>
<p>[/vc_column_text][/vc_column_inner][vc_column_inner column_padding="padding-2-percent" column_padding_tablet="no-extra-padding" column_padding_phone="no-extra-padding" column_padding_position="left" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_column_text]Aliquam ligula lectus, efficitur non pretium quis, elementum quis sapien. Nunc dapibus mi vitae mi placerat eleifend. Cras ullamcorper molestie massa, at suscipit quam rhoncus vel. Suspendisse accumsan id diam et laoreet. Etiam eu feugiat nulla.[/vc_column_text][nectar_cta btn_style="arrow-animation" heading_tag="h5" text_color="#ffffff" button_color="default" link_type="regular" alignment="left" display="block" link_text="Make a Donation" url="#" margin_top="30"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][nectar_scrolling_text scroll_direction="ltr" scroll_speed="slow" text_color="#595959" style="text_outline" outline_thickness="thin" text_repeat_number="3" text_repeat_divider="none" overflow="hidden" background_image_url="https://themenectar.com/img/demo-media/unsplash/webp/large-adventure.webp" background_image_animation="ro-reveal-from-bottom" separate_text_coloring="true" text_color_front="#ffffff" scroll_functionality="automatic" custom_font_size="15vh" custom_font_size_mobile="11vw" background_image_height="55vh"]</p>
<h2><i>You Can Make A Difference</i></h2>
<p>[/nectar_scrolling_text][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );





$data = array();
$data['name'] = esc_html__( 'Nonprofit Recent Posts', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['blog'];
$data['custom_class'] = 'services blog date-19-Jan-2020';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/npo-recent-posts.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" scene_position="center" top_padding="8%" constrain_group_1="yes" bottom_padding="8%" text_color="dark" text_align="left" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][split_line_heading animation_type="line-reveal-by-space" font_style="h2" text_content="Recent News Articles" max_width="600"][/split_line_heading][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in"][nectar_post_grid post_type="post" blog_category="all" order="DESC" orderby="date" pagination="none" columns="3" image_size="large" image_loading="lazy-load" heading_tag="h3" animation="fade-in-from-bottom" display_date="yes" grid_style="mouse_follow_image" text_color="dark" post_title_overlay="yes" mouse_follow_image_alignment="middle" mouse_follow_post_spacing="45px" border_radius="none" meta_visibility="always" posts_per_page="6" custom_font_size="28px"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'Nonprofit Services and Testimonials', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['services'] . ', ' . $cat_display_names['testimonials'];
$data['custom_class'] = 'services testimonials date-20-Jan-2020';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/npo-services.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" bg_color="#ffffff" full_screen_row_position="middle" column_margin="default" scene_position="center" top_padding="12%" text_color="dark" text_align="left" id="testimonials" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_row_inner column_margin="default" bottom_padding="3%" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][split_line_heading animation_type="line-reveal-by-space" font_style="h2" text_content="Measurable results are the name of the game" max_width="450"][/split_line_heading][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="90px" text_align="left"][vc_column_inner column_padding="padding-2-percent" column_padding_tablet="no-extra-padding" column_padding_phone="no-extra-padding" column_padding_position="right" bottom_margin_tablet="5%" bottom_margin_phone="5%" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][nectar_single_testimonial testimonial_style="basic_left_image" image="https://themenectar.com/img/demo-media/unsplash/webp/small-smile-guy.webp" add_image_shadow="true" quote="Phasellus viverra nulla ut metus varius laoreet. Quisque rutrum. Aenean imperdiet elementum semper. Etiam ultricies nisi vel augue. Curabitur ullamcorper." name="Kara Lucas" subtitle="Animal Activist"][/vc_column_inner][vc_column_inner column_padding="padding-2-percent" column_padding_tablet="no-extra-padding" column_padding_phone="no-extra-padding" column_padding_position="left" top_margin="150px" top_margin_tablet="5%" top_margin_phone="5%" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][nectar_single_testimonial testimonial_style="basic_left_image" image="https://themenectar.com/img/demo-media/unsplash/webp/small-smile.webp" add_image_shadow="true" quote="Nullam quis ante. Etiam sit amet orci eget eros faucibus tincidunt. Duis leo. Fringilla mauris sit amet. Donec sodales sagittis. Aenean commodo ligula." name="Alexander Gerard" subtitle="Conversationalist"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row][vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" bg_color="#ffffff" scene_position="center" bottom_padding="12%" text_color="dark" text_align="left" id="impact" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][carousel script="flickity" flickity_formatting="default" desktop_cols_flickity="3" desktop_small_cols_flickity="3" tablet_cols_flickity="2" flickity_controls="touch_total" color="default" flickity_overflow="visible" flickity_wrap_around="no-wrap" flickity_spacing="default" column_padding="0" flickity_image_scale_on_drag="true" border_radius="none"][item id="1583163501716-5" title="Item" tab_id="1583163501718-4"][fancy_box box_style="hover_desc" icon_family="none" image_url="https://themenectar.com/img/demo-media/unsplash/webp/large-mountain.webp" hover_color="accent-color" box_alignment="left" hover_desc_bg_animation="none" border_radius="default" image_loading="lazy-load" color_scheme="dark" secondary_content="here's some awesome text that would only be shown on hover" min_height="450" hover_content="Phasellus viverra nulla ut metus varius laoreet. Quisque rutrum."]
<h3>Forests</h3>
[/fancy_box][/item][item id="1583163501860-1" title="Item" tab_id="1583163501861-9"][fancy_box box_style="hover_desc" icon_family="none" image_url="https://themenectar.com/img/demo-media/unsplash/webp/animal-bird.webp" hover_color="accent-color" box_alignment="left" hover_desc_bg_animation="none" border_radius="default" image_loading="lazy-load" color_scheme="dark" secondary_content="here's some awesome text that would only be shown on hover" min_height="450" hover_content="Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Aenean commodo ligula."]
<h3>Birds</h3>
[/fancy_box][/item][item id="1583163501970-2" title="Item" tab_id="1583163501971-2"][fancy_box box_style="hover_desc" icon_family="none" image_url="https://themenectar.com/img/demo-media/unsplash/webp/animal-dolphin.webp" hover_color="accent-color" box_alignment="left" hover_desc_bg_animation="none" border_radius="default" image_loading="lazy-load" color_scheme="dark" secondary_content="here's some awesome text that would only be shown on hover" min_height="450" hover_content="Socis natoque penatibus et magnis dis parturient montes."]
<h3>Dolphin</h3>
[/fancy_box][/item][item id="1583163502066-1" title="Item" tab_id="1583163502067-3"][fancy_box box_style="hover_desc" icon_family="none" image_url="https://themenectar.com/img/demo-media/unsplash/webp/animal-panda.webp" hover_color="accent-color" box_alignment="left" hover_desc_bg_animation="none" border_radius="default" image_loading="lazy-load" color_scheme="dark" secondary_content="here's some awesome text that would only be shown on hover" min_height="450" hover_content="Phasellus viverra nulla ut metus varius laoreet. Quisque rutrum."]
<h3>Pandas</h3>
[/fancy_box][/item][item id="1583163502157-8" title="Item" tab_id="1583163502158-10"][fancy_box box_style="hover_desc" icon_family="none" image_url="https://themenectar.com/img/demo-media/unsplash/webp/animal-rhino.webp" hover_color="accent-color" box_alignment="left" hover_desc_bg_animation="none" border_radius="default" image_loading="lazy-load" color_scheme="dark" secondary_content="here's some awesome text that would only be shown on hover" min_height="450" hover_content="Sed vulputate purus sed facilisis dignissim erat."]
<h3>Rhino</h3>
[/fancy_box][/item][item id="1583163502244-7" title="Item" tab_id="1583163502246-2"][fancy_box box_style="hover_desc" icon_family="none" image_url="https://themenectar.com/img/demo-media/unsplash/webp/animal-turtle.webp" hover_color="accent-color" box_alignment="left" hover_desc_bg_animation="none" border_radius="default" image_loading="lazy-load" color_scheme="dark" secondary_content="here's some awesome text that would only be shown on hover" min_height="450" hover_content="Socis natoque penatibus et magnis dis parturient montes."]
<h3>Turtles</h3>
[/fancy_box][/item][item id="1583163502353-0" title="Item" tab_id="1583163502354-1"][fancy_box box_style="hover_desc" icon_family="none" image_url="https://themenectar.com/img/demo-media/unsplash/webp/animal-cow.webp" hover_color="accent-color" box_alignment="left" hover_desc_bg_animation="none" border_radius="default" image_loading="lazy-load" color_scheme="dark" secondary_content="here's some awesome text that would only be shown on hover" min_height="450" hover_content="Sed vulputate purus sed facilisis dignissim erat."]
<h3>Cattle</h3>
[/fancy_box][/item][/carousel][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Nonprofit Reveal Image and Text', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['hero_section'];
$data['custom_class'] = 'general date-20-Jan-2020';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/npo-image-overlap.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" equal_height="yes" content_placement="middle" scene_position="center" text_color="dark" text_align="left" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" zindex="100" gradient_direction="left_to_right" overlay_strength="0.3" width="5/12" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][image_with_animation image_url="https://themenectar.com/img/demo-media/unsplash/webp/animal-rhino.jpg" alignment="" animation="ro-reveal-from-left" hover_animation="none" border_radius="none" image_loading="default" max_width="125%" max_width_mobile="default" margin_top="25%" margin_bottom="25%" margin_top_tablet="0px" margin_bottom_tablet="0px" margin_top_phone="0px" margin_bottom_phone="0px"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="padding-12-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color="#f0f5f9" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_t_to_right_b" overlay_strength="1" width="7/12" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" translate_y="20px" translate_x="10%" translate_y_tablet="30px" translate_x_tablet="0px" translate_x_phone="nonw"][vc_row_inner column_margin="default" translate_x="15%" translate_x_tablet="0%" translate_x_phone="0%" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_column_text css_animation="none" css=".vc_custom_1582826380836{margin-bottom: 40px !important;}" max_width="550"]
<h2>Nature can be fully saved through love from people</h2>
[/vc_column_text][vc_column_text css_animation="none" css=".vc_custom_1579198858100{margin-bottom: 40px !important;}" max_width="550"]Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Aenean commodo ligula eget dolor. Aenean massa. Nulla consequat massa quis enim. Sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus lorem mus.[/vc_column_text][nectar_cta btn_style="arrow-animation" heading_tag="h5" text_color="#000000" button_color="default" link_type="video_lightbox" alignment="left" display="block" link_text="Watch Our Video" url="https://www.youtube.com/watch?v=RDC1ZFFhZq8"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Nonprofit Reveal Image and Text Alt', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['hero_section'];
$data['custom_class'] = 'general date-20-Jan-2020';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/npo-image-overlap-2.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" equal_height="yes" content_placement="middle" column_direction="default" column_direction_tablet="default" column_direction_phone="default" scene_position="center" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="padding-12-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color="#f0f5f9" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_t_to_right_b" overlay_strength="1" width="7/12" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" bg_image_animation="none" column_border_width="none" column_border_style="solid" translate_y="20px" translate_x="10%" translate_y_tablet="30px" translate_x_tablet="0px" translate_x_phone="nonw"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" translate_x="-15%" translate_x_tablet="0%" translate_x_phone="0%" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" bg_image_animation="none" column_border_width="none" column_border_style="solid"][vc_column_text css_animation="none" css=".vc_custom_1582826380836{margin-bottom: 40px !important;}" max_width="550"]
<h2>Nature can be fully saved through love from people</h2>
[/vc_column_text][vc_column_text css_animation="none" css=".vc_custom_1579198858100{margin-bottom: 40px !important;}" max_width="550"]Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Aenean commodo ligula eget dolor. Aenean massa. Nulla consequat massa quis enim. Sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus lorem mus.[/vc_column_text][nectar_cta btn_style="arrow-animation" heading_tag="h5" text_color="#000000" button_color="default" link_type="video_lightbox" alignment="left" alignment_tablet="default" alignment_phone="default" display="block" link_text="Watch Our Video" url="https://www.youtube.com/watch?v=RDC1ZFFhZq8"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" zindex="100" gradient_direction="left_to_right" overlay_strength="0.3" width="5/12" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" bg_image_animation="none" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" bg_image_animation="none" column_border_width="none" column_border_style="solid"][image_with_animation image_url="https://themenectar.com/img/demo-media/unsplash/webp/animal-turtle.webp" animation="ro-reveal-from-right" hover_animation="none" alignment="right" border_radius="none" image_loading="default" max_width="125%" max_width_mobile="default" margin_top="25%" margin_bottom="25%" margin_top_tablet="0px" margin_bottom_tablet="0px" margin_top_phone="0px" margin_bottom_phone="0px"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );





$data = array();
$data['name'] = esc_html__( 'Nonprofit Intro Text', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['hero_section'];
$data['custom_class'] = 'general date-20-Jan-2020';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/npo-text.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" bg_color="#ffffff" scene_position="center" top_padding="10%" constrain_group_1="yes" bottom_padding="10%" text_color="dark" text_align="left" id="philosophy" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][nectar_highlighted_text color_type="regular" highlight_color="#00cae8" style="regular_underline" delay="200"]
<h3>We stand proudly <a href="#"><em>united as one</em></a>. Our goal is to protect the all lifeforms on our planet. Together, we're part of something larger and <em><a href="#">extraordinary</a></em>. The future of wildlife depends on all of us acting now. With our combined efforts, we can prevent species on the <a href="#"><em>verge of extinction</em></a> from disappearing forever.</h3>
[/nectar_highlighted_text][nectar_cta btn_style="arrow-animation" heading_tag="h5" text_color="#000000" button_color="default" link_type="new_tab" alignment="left" display="block" link_text="Make a Donation" url="#" margin_top="60"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'Ageless Hero', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['hero_section'];
$data['custom_class'] = 'hero_section date-21-Jan-2020';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/npo-header.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="none" equal_height="yes" content_placement="middle" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#ffffff" scene_position="center" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" id="home" overlay_strength="0.5" gradient_direction="top_to_bottom" shape_divider_position="bottom" bg_image_animation="none" shape_type="straight_section" gradient_type="default"][vc_column column_padding="no-extra-padding" column_padding_tablet="padding-6-percent" column_padding_phone="inherit" column_padding_position="top" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" zindex="100" gradient_direction="left_t_to_right_b" overlay_strength="0.3" width="1/4" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" delay="400" offset="vc_col-xs-6"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" top_padding_tablet="40" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" min_width_desktop="60vh" min_width_tablet="50vw" min_width_phone="50vw" overflow="visible" pointer_events="all" min_width="47vh"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" enable_border_animation="true"][nectar_highlighted_text style="text_outline" outline_thickness="regular" text_outline_color="#000000" text="9vh" custom_font_size="10vh"]
<h1>Protecting our Diverse <em>Wildlife</em></h1>
[/nectar_highlighted_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" top_padding_tablet="0px" top_padding_phone="0px" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" min_width_tablet="0px" min_width_phone="0px" overflow="visible" pointer_events="all" min_width="47vh"][vc_column_inner column_padding="padding-9-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="right" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" enable_border_animation="true"][vc_column_text]Through steady action, we will ensure a bright future for our beautiful planet.[/vc_column_text][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.5" width="3/4" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" offset="vc_col-xs-6"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" min_width_desktop="75vw" min_width_tablet="50vw" min_width_phone="50vw" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/webp/monkey-tall.webp" background_image_position="center center" background_image_stacking="default" enable_bg_scale="true" background_image_loading="default" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.5" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="ro-reveal-from-bottom" border_type="simple" column_border_width="none" column_border_style="solid"][divider line_type="No Line" custom_height="100vh" custom_height_tablet="80vh"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'Dark Wellness Gradient Highlight Intro', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-8-Jan-2020';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/gradient-highlight-intro-text-dark.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" bg_color="#000000" scene_position="center" top_padding="8%" constrain_group_1="yes" bottom_padding="8%" text_color="light" text_align="left" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_row_inner column_margin="default" bottom_padding="" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="2/3" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][nectar_highlighted_text color_type="gradient" highlight_color="#ff6b30" secondary_color="#000000" style="regular_underline"]
<h3><em><a href="#">Achieve</a></em> your goals easier than ever before. We offer a wide range of rewarding amenities which are all <em><a href="#">personalized</a></em> to specific <a href="#"><em>your needs</em></a>.</h3>
[/nectar_highlighted_text][/vc_column_inner][vc_column_inner centered_text="true" column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Dark Wellness Gradient Highlight Text Section', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-8-Jan-2020';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/overlapping-highlight-text-dark.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="90px" equal_height="yes" content_placement="middle" bg_color="#000000" scene_position="center" top_padding="8%" constrain_group_1="yes" bottom_padding="8%" top_padding_tablet="15%" constrain_group_3="yes" bottom_padding_tablet="15%" text_color="light" text_align="left" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/webp/fitness-tall.webp" background_image_position="center top" enable_bg_scale="true" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" bg_image_animation="zoom-out"][divider line_type="No Line" custom_height_tablet="600" custom_height_phone="500"][/vc_column][vc_column column_padding="padding-7-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" zindex="100" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_row_inner column_margin="default" translate_x="-28%" translate_x_tablet="0%" translate_x_phone="0%" text_align="left"][vc_column_inner column_padding="padding-10-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="right" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][nectar_highlighted_text color_type="gradient" highlight_color="#ff6b30" secondary_color="rgba(255,107,48,0.01)" style="half_text" custom_font_size="7vh"]
<h2>Elevate Your Body and <em>Mind</em></h2>
[/nectar_highlighted_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" top_margin="40" top_margin_tablet="0px" top_margin_phone="0px" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_column_text css=".vc_custom_1580329676960{padding-right: 10% !important;}"]Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean.[/vc_column_text][nectar_cta btn_style="arrow-animation" heading_tag="h5" text_color="#ffffff" button_color="default" link_type="regular" alignment="left" display="block" link_text="Explore amenities" url="#" margin_top="10"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Wellness Services', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['services'];
$data['custom_class'] = 'services date-8-Jan-2020';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/colored-services-dark.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" bg_color="#000000" scene_position="center" top_padding="8%" constrain_group_1="yes" bottom_padding="8%" text_color="light" text_align="left" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][fancy_box box_style="parallax_hover" icon_family="none" image_url="https://themenectar.com/img/demo-media/unsplash/webp/food.webp" parallax_hover_box_alignment="bottom" parallax_hover_box_overlay="#0b473a" parallax_hover_box_overlay_opacity="0.9" parallax_hover_box_overlay_opacity_hover="0.3" border_radius="default" image_loading="default" color_scheme="dark" secondary_content="here's some awesome text that would only be shown on hover" min_height="400"]
<h4>Nutritional Plans</h4>
Catered to suit your lifestyle.[/fancy_box][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom" delay="50"][fancy_box box_style="parallax_hover" icon_family="none" image_url="https://themenectar.com/img/demo-media/unsplash/webp/800-500-bike.webp" parallax_hover_box_alignment="bottom" parallax_hover_box_overlay="#ff6b30" parallax_hover_box_overlay_opacity="0.9" parallax_hover_box_overlay_opacity_hover="0.3" border_radius="default" image_loading="default" color_scheme="dark" secondary_content="" min_height="400"]
<h4>Fitness Center</h4>
Custom programs built for you.[/fancy_box][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom" delay="100"][fancy_box box_style="parallax_hover" icon_family="none" image_url="https://themenectar.com/img/demo-media/unsplash/webp/800-500-room.webp" parallax_hover_box_alignment="bottom" parallax_hover_box_overlay="#36302c" parallax_hover_box_overlay_opacity="0.9" parallax_hover_box_overlay_opacity_hover="0.3" border_radius="default" image_loading="default" color_scheme="dark" secondary_content="here's some awesome text that would only be shown on hover" min_height="400"]
<h4>Full Day Spa</h4>
5,000 square feet of pure bliss.[/fancy_box][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" top_padding="4%" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/4" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom" offset="vc_col-xs-6"][vc_column_text css=".vc_custom_1581452718117{margin-bottom: 15px !important;}"]
<h4>Skin Care</h4>
[/vc_column_text][fancy-ul icon_type="none" alignment="left" spacing="15px"]
<ul>
 	<li>Vitamin C Cleanse</li>
 	<li>Organic Tea Facial</li>
 	<li>Ultra Hydration Facial</li>
 	<li>Vampire Facial</li>
</ul>
[/fancy-ul][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/4" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom" delay="50" offset="vc_col-xs-6"][vc_column_text css=".vc_custom_1581452713162{margin-bottom: 15px !important;}"]
<h4>Psychology</h4>
[/vc_column_text][fancy-ul icon_type="none" alignment="left" spacing="15px"]
<ul>
 	<li>Mature life</li>
 	<li>Prenatal well-being</li>
 	<li>Relationship Counseling</li>
 	<li>General Stress</li>
</ul>
[/fancy-ul][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/4" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom" delay="100" offset="vc_col-xs-6"][vc_column_text css=".vc_custom_1581452723639{margin-bottom: 15px !important;}"]
<h4>Grooming</h4>
[/vc_column_text][fancy-ul icon_type="none" alignment="left" spacing="15px"]
<ul>
 	<li>Blow-Outs</li>
 	<li>General Styling</li>
 	<li>Keratin Treatments</li>
 	<li>Scalp Treatments</li>
</ul>
[/fancy-ul][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/4" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom" delay="150" offset="vc_col-xs-6"][vc_column_text css=".vc_custom_1581452728136{margin-bottom: 15px !important;}"]
<h4>Massage</h4>
[/vc_column_text][fancy-ul icon_type="none" alignment="left" spacing="15px"]
<ul>
 	<li>Therapeutic</li>
 	<li>Deep Tissue</li>
 	<li>Essential Oil</li>
 	<li>Couples</li>
</ul>
[/fancy-ul][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Dark Wellness Pricing Tiers', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['pricing'];
$data['custom_class'] = 'pricing date-8-Jan-2020';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/pricing-tiers-dark.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" bg_color="#000000" scene_position="center" top_padding="8%" constrain_group_1="yes" bottom_padding="8%" text_color="light" text_align="left" overlay_strength="0.8" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_row_inner column_margin="none" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][nectar_horizontal_list_item columns="4" column_layout_using_4_columns="large_first" col_1_text_align="left" col_2_text_align="left" col_3_text_align="right" col_4_text_align="right" col_1_text_element="h3" col_2_text_element="p" col_3_text_element="h4" col_4_text_element="p" font_family="p" hover_effect="full_border" hover_color="accent-color" border_radius="5px" icon_family="iconsmind" icon_size="large" col_1_content="Bronze" col_2_content="Access to facility 7 days out of the month, Basic group classes, Personal Coach." cta_1_text="Join Now" col_3_content="$25/mo" icon_iconsmind="iconsmind-Dry"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="none" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][nectar_horizontal_list_item columns="4" column_layout_using_4_columns="large_first" col_1_text_align="left" col_2_text_align="left" col_3_text_align="right" col_4_text_align="right" col_1_text_element="h3" col_2_text_element="p" col_3_text_element="h4" col_4_text_element="p" font_family="p" hover_effect="full_border" hover_color="accent-color" border_radius="5px" icon_family="iconsmind" icon_size="large" col_1_content="Silver" col_2_content="Bronze + Unlimited Access to facilties from every day from 9am - 10pm, Personal nutritionist, Personal trainer." cta_1_text="Join Now" col_3_content="$35/mo" icon_iconsmind="iconsmind-Plant"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="none" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][nectar_horizontal_list_item columns="4" column_layout_using_4_columns="large_first" col_1_text_align="left" col_2_text_align="left" col_3_text_align="right" col_4_text_align="right" col_1_text_element="h3" col_2_text_element="p" col_3_text_element="h4" col_4_text_element="p" font_family="p" hover_effect="full_border" hover_color="accent-color" border_radius="5px" icon_family="iconsmind" icon_size="large" col_1_content="Gold" col_2_content="Silver + Fully unlimited access to facility, Bi-monthly therapy, Monthly massage." cta_1_text="Join Now" col_3_content="$50/mo" icon_iconsmind="iconsmind-Flowerpot"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="none" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][nectar_horizontal_list_item columns="4" column_layout_using_4_columns="large_first" col_1_text_align="left" col_2_text_align="left" col_3_text_align="right" col_4_text_align="right" col_1_text_element="h3" col_2_text_element="p" col_3_text_element="h4" col_4_text_element="p" font_family="p" hover_effect="full_border" hover_color="accent-color" border_radius="5px" icon_family="iconsmind" icon_size="large" col_1_content="Platinum" col_2_content="Gold + Business Coaching, Bi-weekly therapy, Access to cryotherapy and thermotherapy rooms, Spa package discounts." cta_1_text="Join Now" col_3_content="$100/mo" icon_iconsmind="iconsmind-Palm-Tree"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Dark Wellness Gradient Highlight Text Section 2', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-8-Jan-2020';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/overlapping-highlight-text2-dark.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="90px" equal_height="yes" content_placement="middle" bg_color="#000000" scene_position="center" top_padding="8%" constrain_group_1="yes" bottom_padding="8%" top_padding_tablet="20%" constrain_group_3="yes" bottom_padding_tablet="20%" text_color="light" text_align="left" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="padding-7-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" zindex="100" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_row_inner column_margin="default" translate_x="15%" translate_x_tablet="0%" translate_x_phone="0%" text_align="left" min_width_desktop="120%" min_width_tablet="0px"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][nectar_highlighted_text color_type="gradient" highlight_color="#ff6b30" secondary_color="rgba(255,107,48,0.01)" style="half_text" custom_font_size="7vh"]
<h2>Flourish with Optimism, Live <em>Deliberately</em></h2>
[/nectar_highlighted_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" top_margin="40" top_margin_tablet="0px" top_margin_phone="0px" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_column_text css=".vc_custom_1580329697124{padding-right: 10% !important;}"]A small river named Duden flows by their place and supplies it with the necessary regelialia. It is a paradisematic country, in which roasted parts of sentences fly into your mouth. Even the all-powerful Pointing has no control about the blind texts.[/vc_column_text][/vc_column_inner][/vc_row_inner][vc_row_inner equal_height="yes" content_placement="middle" column_margin="70px" top_padding="40" text_align="left"][vc_column_inner centered_text="true" column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" offset="vc_col-xs-4"][image_with_animation image_url="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo-light.png" alignment="" animation="None" hover_animation="none" border_radius="none" box_shadow="none" image_loading="lazy-load" max_width="100%" max_width_mobile="default"][/vc_column_inner][vc_column_inner centered_text="true" column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="small_desktop" column_border_width="none" column_border_style="solid" bg_image_animation="none" offset="vc_col-xs-4"][image_with_animation image_url="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo-light.png" alignment="" animation="None" hover_animation="none" border_radius="none" box_shadow="none" image_loading="lazy-load" max_width="100%" max_width_mobile="default"][/vc_column_inner][vc_column_inner centered_text="true" column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="small_desktop" column_border_width="none" column_border_style="solid" bg_image_animation="none" offset="vc_col-sm-offset-0 vc_col-xs-4"][image_with_animation image_url="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo-light.png" alignment="" animation="None" hover_animation="none" border_radius="none" box_shadow="none" image_loading="lazy-load" max_width="100%" max_width_mobile="default"][/vc_column_inner][/vc_row_inner][vc_row_inner equal_height="yes" content_placement="middle" column_margin="70px" text_align="left"][vc_column_inner centered_text="true" column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="small_desktop" column_border_width="none" column_border_style="solid" bg_image_animation="none" offset="vc_col-xs-4"][image_with_animation image_url="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo-light.png" alignment="" animation="None" hover_animation="none" border_radius="none" box_shadow="none" image_loading="lazy-load" max_width="100%" max_width_mobile="default"][/vc_column_inner][vc_column_inner centered_text="true" column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="small_desktop" column_border_width="none" column_border_style="solid" bg_image_animation="none" offset="vc_col-xs-4"][image_with_animation image_url="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo-light.png" alignment="" animation="None" hover_animation="none" border_radius="none" box_shadow="none" image_loading="lazy-load" max_width="100%" max_width_mobile="default"][/vc_column_inner][vc_column_inner centered_text="true" column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="small_desktop" column_border_width="none" column_border_style="solid" bg_image_animation="none" offset="vc_col-sm-offset-0 vc_col-xs-4"][image_with_animation image_url="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo-light.png" alignment="" animation="None" hover_animation="none" border_radius="none" box_shadow="none" image_loading="lazy-load" max_width="100%" max_width_mobile="default"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/webp/fitness-pushup.webp" background_image_position="right center" enable_bg_scale="true" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" bg_image_animation="zoom-out"][divider line_type="No Line" custom_height_tablet="600" custom_height_phone="500"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Dark Wellness Interactive Recent Posts', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['blog'];
$data['custom_class'] = 'blog date-8-Jan-2020';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/featured-img-mouse-follow-post-grid-2.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" bg_color="#000000" scene_position="center" top_padding="8%" constrain_group_1="yes" bottom_padding="8%" text_color="light" text_align="left" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_row_inner column_margin="none" bottom_padding="3%" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][vc_column_text max_width="450"]
<h2>Recent blog articles we've written</h2>
[/vc_column_text][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][/vc_column_inner][/vc_row_inner][nectar_post_grid post_type="post" blog_category="all" order="DESC" orderby="date" pagination="none" columns="3" image_size="large" image_loading="lazy-load" heading_tag="h3" animation="fade-in-from-bottom" display_date="yes" grid_style="mouse_follow_image" text_color="light" post_title_overlay="yes" mouse_follow_image_alignment="middle" mouse_follow_post_spacing="25px" border_radius="none" posts_per_page="3" custom_font_size="28px"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Wellness Interactive Recent Posts', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['blog'];
$data['custom_class'] = 'blog date-10-Jan-2020';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/featured-img-mouse-follow-post-grid.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" bg_color="#ffffff" scene_position="center" top_padding="8%" constrain_group_1="yes" bottom_padding="8%" text_color="dark" text_align="left" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_row_inner column_margin="none" bottom_padding="3%" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][vc_column_text max_width="450"]
<h2>Recent blog articles we've written</h2>
[/vc_column_text][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][/vc_column_inner][/vc_row_inner][nectar_post_grid post_type="post" blog_category="all" order="DESC" orderby="date" pagination="none" columns="3" image_size="large" image_loading="lazy-load" heading_tag="h3" animation="fade-in-from-bottom" display_date="yes" grid_style="mouse_follow_image" text_color="dark" post_title_overlay="yes" mouse_follow_image_alignment="middle" mouse_follow_post_spacing="25px" border_radius="none" posts_per_page="3" custom_font_size="28px"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Wellness Video Overlap', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-10-Jan-2020';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/video-lightbox-split-bg.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" bg_color="#ffffff" scene_position="center" bottom_padding="8%" constrain_group_1="yes" top_padding="8%" text_color="light" text_align="left" overlay_strength="0.3" gradient_direction="left_to_right" enable_shape_divider="true" shape_divider_color="#0b473a" shape_divider_position="bottom" shape_divider_height="50%" bg_image_animation="none" shape_type="straight_section"][vc_column centered_text="true" column_padding="padding-4-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="left-right" background_color_opacity="1" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/webp/large-adventure.webp" background_image_position="center center" enable_bg_scale="true" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" bg_image_animation="zoom-out"][divider line_type="No Line" custom_height="25vh" custom_height_tablet="20vh"][vc_row_inner column_margin="20px" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][nectar_video_lightbox link_style="play_button" video_url="https://vimeo.com/118023315"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="none" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_column_text]
<h2>Your Life, Rejuvenated</h2>
[/vc_column_text][/vc_column_inner][/vc_row_inner][divider line_type="No Line" custom_height="25vh" custom_height_tablet="20vh"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'Wellness Pricing Tiers', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['pricing'];
$data['custom_class'] = 'pricing date-10-Jan-2020';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/pricing-tiers.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" bg_color="#ffffff" scene_position="center" top_padding="8%" constrain_group_1="yes" bottom_padding="8%" text_color="dark" text_align="left" overlay_strength="0.8" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_row_inner column_margin="none" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][nectar_horizontal_list_item columns="4" column_layout_using_4_columns="large_first" col_1_text_align="left" col_2_text_align="left" col_3_text_align="right" col_4_text_align="right" col_1_text_element="h3" col_2_text_element="p" col_3_text_element="h4" col_4_text_element="p" font_family="p" hover_effect="full_border" hover_color="accent-color" border_radius="5px" icon_family="iconsmind" icon_size="large" col_1_content="Bronze" col_2_content="Access to facility 7 days out of the month, Basic group classes, Personal Coach." cta_1_text="Join Now" col_3_content="$25/mo" icon_iconsmind="iconsmind-Dry"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="none" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][nectar_horizontal_list_item columns="4" column_layout_using_4_columns="large_first" col_1_text_align="left" col_2_text_align="left" col_3_text_align="right" col_4_text_align="right" col_1_text_element="h3" col_2_text_element="p" col_3_text_element="h4" col_4_text_element="p" font_family="p" hover_effect="full_border" hover_color="accent-color" border_radius="5px" icon_family="iconsmind" icon_size="large" col_1_content="Silver" col_2_content="Bronze + Unlimited Access to facilties from every day from 9am - 10pm, Personal nutritionist, Personal trainer." cta_1_text="Join Now" col_3_content="$35/mo" icon_iconsmind="iconsmind-Plant"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="none" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][nectar_horizontal_list_item columns="4" column_layout_using_4_columns="large_first" col_1_text_align="left" col_2_text_align="left" col_3_text_align="right" col_4_text_align="right" col_1_text_element="h3" col_2_text_element="p" col_3_text_element="h4" col_4_text_element="p" font_family="p" hover_effect="full_border" hover_color="accent-color" border_radius="5px" icon_family="iconsmind" icon_size="large" col_1_content="Gold" col_2_content="Silver + Fully unlimited access to facility, Bi-monthly therapy, Monthly massage." cta_1_text="Join Now" col_3_content="$50/mo" icon_iconsmind="iconsmind-Flowerpot"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="none" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][nectar_horizontal_list_item columns="4" column_layout_using_4_columns="large_first" col_1_text_align="left" col_2_text_align="left" col_3_text_align="right" col_4_text_align="right" col_1_text_element="h3" col_2_text_element="p" col_3_text_element="h4" col_4_text_element="p" font_family="p" hover_effect="full_border" hover_color="accent-color" border_radius="5px" icon_family="iconsmind" icon_size="large" col_1_content="Platinum" col_2_content="Gold + Business Coaching, Bi-weekly therapy, Access to cryotherapy and thermotherapy rooms, Spa package discounts." cta_1_text="Join Now" col_3_content="$100/mo" icon_iconsmind="iconsmind-Palm-Tree"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'Wellness Testimonials with Scrolling Text', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['testimonials'];
$data['custom_class'] = 'testimonials date-10-Jan-2020';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/testimonials-scrolling-text.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" equal_height="yes" bg_color="#0b473a" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/neutral-field.webp" bg_position="center center" bg_repeat="no-repeat" scene_position="center" top_padding="12%" bottom_padding="1%" text_color="light" text_align="left" enable_gradient="true" color_overlay="#0b473a" color_overlay_2="rgba(11,71,58,0.7)" overlay_strength="1" gradient_direction="top_to_bottom" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" font_color="#ffffff" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_row_inner column_margin="90px" bottom_padding="14%" text_align="left"][vc_column_inner column_padding="padding-4-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="right" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][nectar_single_testimonial testimonial_style="basic" text_color="#ffffff" quote="People take different roads seeking fulfillment and happiness. Just because they’re not on your road doesn’t mean they’ve gotten lost." name="Kara Lucas" subtitle="Yoga Instructor"][/vc_column_inner][vc_column_inner column_padding="padding-4-percent" column_padding_tablet="no-extra-padding" column_padding_phone="no-extra-padding" column_padding_position="left" top_margin="200px" top_margin_tablet="50px" top_margin_phone="50px" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][nectar_single_testimonial testimonial_style="basic" text_color="#ffffff" quote="If we are to create a more peaceful world, made up of peaceful individuals, we need a greater concern for others. Altruism. That gives inner strength, self-confidence." name="Alex Cohen" subtitle="Life Coach"][/vc_column_inner][/vc_row_inner][nectar_scrolling_text scroll_direction="rtl" scroll_speed="medium" text_color="#ffffff" style="text_outline" outline_thickness="thin" text_repeat_number="5" text_repeat_divider="custom" text_repeat_divider_scale="half" overflow="visible" background_image_animation="None" custom_font_size="10vh" text_repeat_divider_custom="⚬"]
<h2>a better life</h2>
[/nectar_scrolling_text][/vc_column][/vc_row][vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" bg_color="#ffffff" scene_position="center" top_padding="1%" bottom_padding="12%" text_color="dark" text_align="left" overlay_strength="0.8" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][nectar_scrolling_text scroll_direction="ltr" scroll_speed="medium" text_color="#0b473a" style="text_outline" outline_thickness="thin" text_repeat_number="5" text_repeat_divider="custom" text_repeat_divider_scale="half" overflow="visible" background_image_animation="None" custom_font_size="10vh" text_repeat_divider_custom="⚬"]
<h2>awaits you</h2>
[/nectar_scrolling_text][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Wellness Gradient Highlight Text Section 2', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-10-Jan-2020';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/overlapping-highlight-text2.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="90px" equal_height="yes" content_placement="middle" bg_color="#ffffff" scene_position="center" top_padding="8%" constrain_group_1="yes" bottom_padding="8%" top_padding_tablet="20%" constrain_group_3="yes" bottom_padding_tablet="20%" text_color="dark" text_align="left" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="padding-7-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" zindex="100" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_row_inner column_margin="default" translate_x="15%" translate_x_tablet="0%" translate_x_phone="0%" text_align="left" min_width_desktop="120%" min_width_tablet="0px"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][nectar_highlighted_text color_type="gradient" highlight_color="#ff6b30" secondary_color="rgba(255,107,48,0.01)" style="half_text" custom_font_size="7vh"]</p>
<h2>Flourish with Optimism, Live <em>Deliberately</em></h2>
<p>[/nectar_highlighted_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" top_margin="40" top_margin_tablet="0px" top_margin_phone="0px" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_column_text css=".vc_custom_1580329697124{padding-right: 10% !important;}"]A small river named Duden flows by their place and supplies it with the necessary regelialia. It is a paradisematic country, in which roasted parts of sentences fly into your mouth. Even the all-powerful Pointing has no control about the blind texts.[/vc_column_text][/vc_column_inner][/vc_row_inner][vc_row_inner equal_height="yes" content_placement="middle" column_margin="70px" top_padding="40" text_align="left"][vc_column_inner centered_text="true" column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" offset="vc_col-xs-4"][image_with_animation image_url="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo-grey.png" alignment="" animation="None" hover_animation="none" border_radius="none" box_shadow="none" image_loading="lazy-load" max_width="100%" max_width_mobile="default"][/vc_column_inner][vc_column_inner centered_text="true" column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="small_desktop" column_border_width="none" column_border_style="solid" bg_image_animation="none" offset="vc_col-xs-4"][image_with_animation image_url="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo-grey.png" alignment="" animation="None" hover_animation="none" border_radius="none" box_shadow="none" image_loading="lazy-load" max_width="100%" max_width_mobile="default"][/vc_column_inner][vc_column_inner centered_text="true" column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="small_desktop" column_border_width="none" column_border_style="solid" bg_image_animation="none" offset="vc_col-sm-offset-0 vc_col-xs-4"][image_with_animation image_url="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo-grey.png" alignment="" animation="None" hover_animation="none" border_radius="none" box_shadow="none" image_loading="lazy-load" max_width="100%" max_width_mobile="default"][/vc_column_inner][/vc_row_inner][vc_row_inner equal_height="yes" content_placement="middle" column_margin="70px" text_align="left"][vc_column_inner centered_text="true" column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="small_desktop" column_border_width="none" column_border_style="solid" bg_image_animation="none" offset="vc_col-xs-4"][image_with_animation image_url="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo-grey.png" alignment="" animation="None" hover_animation="none" border_radius="none" box_shadow="none" image_loading="lazy-load" max_width="100%" max_width_mobile="default"][/vc_column_inner][vc_column_inner centered_text="true" column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="small_desktop" column_border_width="none" column_border_style="solid" bg_image_animation="none" offset="vc_col-xs-4"][image_with_animation image_url="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo-grey.png" alignment="" animation="None" hover_animation="none" border_radius="none" box_shadow="none" image_loading="lazy-load" max_width="100%" max_width_mobile="default"][/vc_column_inner][vc_column_inner centered_text="true" column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="small_desktop" column_border_width="none" column_border_style="solid" bg_image_animation="none" offset="vc_col-sm-offset-0 vc_col-xs-4"][image_with_animation image_url="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo-grey.png" alignment="" animation="None" hover_animation="none" border_radius="none" box_shadow="none" image_loading="lazy-load" max_width="100%" max_width_mobile="default"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/webp/neutral-camera.webp" background_image_position="right center" enable_bg_scale="true" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" bg_image_animation="zoom-out"][divider line_type="No Line" custom_height_tablet="600" custom_height_phone="500"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'Wellness Services', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['services'];
$data['custom_class'] = 'services date-10-Jan-2020';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/colored-services.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" bg_color="#ffffff" scene_position="center" top_padding="8%" constrain_group_1="yes" bottom_padding="8%" text_color="dark" text_align="left" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][fancy_box box_style="parallax_hover" icon_family="none" image_url="https://themenectar.com/img/demo-media/unsplash/webp/food.webp" parallax_hover_box_alignment="bottom" parallax_hover_box_overlay="#0b473a" parallax_hover_box_overlay_opacity="0.9" parallax_hover_box_overlay_opacity_hover="0.3" border_radius="default" image_loading="default" color_scheme="dark" secondary_content="here's some awesome text that would only be shown on hover" min_height="400"]
<h4>Nutritional Plans</h4>
Catered to suit your lifestyle.[/fancy_box][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom" delay="50"][fancy_box box_style="parallax_hover" icon_family="none" image_url="https://themenectar.com/img/demo-media/unsplash/webp/fitness-pushup.webp" parallax_hover_box_alignment="bottom" parallax_hover_box_overlay="#ff6b30" parallax_hover_box_overlay_opacity="0.9" parallax_hover_box_overlay_opacity_hover="0.3" border_radius="default" image_loading="default" color_scheme="dark" secondary_content="" min_height="400"]
<h4>Fitness Center</h4>
Custom programs built for you.[/fancy_box][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom" delay="100"][fancy_box box_style="parallax_hover" icon_family="none" image_url="https://themenectar.com/img/demo-media/unsplash/webp/neutral-field.webp" parallax_hover_box_alignment="bottom" parallax_hover_box_overlay="#36302c" parallax_hover_box_overlay_opacity="0.9" parallax_hover_box_overlay_opacity_hover="0.3" border_radius="default" image_loading="default" color_scheme="dark" secondary_content="here's some awesome text that would only be shown on hover" min_height="400"]
<h4>Full Day Spa</h4>
5,000 square feet of pure bliss.[/fancy_box][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" top_padding="4%" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/4" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom" offset="vc_col-xs-6"][vc_column_text css=".vc_custom_1581452718117{margin-bottom: 15px !important;}"]
<h4>Skin Care</h4>
[/vc_column_text][fancy-ul icon_type="none" alignment="left" spacing="15px"]
<ul>
 	<li>Vitamin C Cleanse</li>
 	<li>Organic Tea Facial</li>
 	<li>Ultra Hydration Facial</li>
 	<li>Vampire Facial</li>
</ul>
[/fancy-ul][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/4" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom" delay="50" offset="vc_col-xs-6"][vc_column_text css=".vc_custom_1581452713162{margin-bottom: 15px !important;}"]
<h4>Psychology</h4>
[/vc_column_text][fancy-ul icon_type="none" alignment="left" spacing="15px"]
<ul>
 	<li>Mature life</li>
 	<li>Prenatal well-being</li>
 	<li>Relationship Counseling</li>
 	<li>General Stress</li>
</ul>
[/fancy-ul][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/4" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom" delay="100" offset="vc_col-xs-6"][vc_column_text css=".vc_custom_1581452723639{margin-bottom: 15px !important;}"]
<h4>Grooming</h4>
[/vc_column_text][fancy-ul icon_type="none" alignment="left" spacing="15px"]
<ul>
 	<li>Blow-Outs</li>
 	<li>General Styling</li>
 	<li>Keratin Treatments</li>
 	<li>Scalp Treatments</li>
</ul>
[/fancy-ul][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/4" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom" delay="150" offset="vc_col-xs-6"][vc_column_text css=".vc_custom_1581452728136{margin-bottom: 15px !important;}"]
<h4>Massage</h4>
[/vc_column_text][fancy-ul icon_type="none" alignment="left" spacing="15px"]
<ul>
 	<li>Therapeutic</li>
 	<li>Deep Tissue</li>
 	<li>Essential Oil</li>
 	<li>Couples</li>
</ul>
[/fancy-ul][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'Wellness Gradient Highlight Intro', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-10-Jan-2020';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/gradient-highlight-intro-text.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" bg_color="#ffffff" scene_position="center" top_padding="8%" constrain_group_1="yes" bottom_padding="8%" text_color="dark" text_align="left" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_row_inner column_margin="default" bottom_padding="" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="2/3" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][nectar_highlighted_text color_type="gradient" highlight_color="#ff6b30" secondary_color="#ffffff" style="regular_underline"]
<h3><em><a href="#">Achieve</a></em> your goals easier than ever before. We offer a wide range of rewarding amenities which are all <em><a href="#">personalized</a></em> to specific <a href="#"><em>your needs</em></a>.</h3>
[/nectar_highlighted_text][/vc_column_inner][vc_column_inner centered_text="true" column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Wellness Gradient Highlight Text Section', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-10-Jan-2020';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/overlapping-highlight-text.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="90px" equal_height="yes" content_placement="middle" bg_color="#ffffff" scene_position="center" top_padding="8%" constrain_group_1="yes" bottom_padding="8%" top_padding_tablet="15%" constrain_group_3="yes" bottom_padding_tablet="15%" text_color="dark" text_align="left" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/webp/flowers-light-bg.webp" background_image_position="center top" enable_bg_scale="true" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" bg_image_animation="zoom-out"][divider line_type="No Line" custom_height_tablet="600" custom_height_phone="500"][/vc_column][vc_column column_padding="padding-7-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" zindex="100" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_row_inner column_margin="default" translate_x="-28%" translate_x_tablet="0%" translate_x_phone="0%" text_align="left"][vc_column_inner column_padding="padding-10-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="right" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][nectar_highlighted_text color_type="gradient" highlight_color="#ff6b30" secondary_color="rgba(255,107,48,0.01)" style="half_text" custom_font_size="7vh"]
<h2>Elevate Your Body and <em>Mind</em></h2>
[/nectar_highlighted_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" top_margin="40" top_margin_tablet="0px" top_margin_phone="0px" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_column_text css=".vc_custom_1580329676960{padding-right: 10% !important;}"]Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean.[/vc_column_text][nectar_cta btn_style="arrow-animation" heading_tag="h5" text_color="#000000" button_color="default" link_type="regular" alignment="left" display="block" link_text="Explore amenities" url="#" margin_top="10"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Gradient Highlight Hero', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['hero_section'];
$data['custom_class'] = 'hero_section date-10-Jan-2020';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/gradient-highlight-hero.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" equal_height="yes" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-adventure.webp" bg_color="#0b473a" video_bg="use_video" video_mp4="" scene_position="center" top_padding="13%" constrain_group_1="yes" bottom_padding="13%" top_padding_tablet="20%" bottom_padding_tablet="25%" text_color="light" text_align="left" color_overlay="rgba(11,71,58,0.9)" overlay_strength="0.95" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" parallax_bg="true" parallax_bg_speed="fast" shape_type="curve"][vc_column centered_text="true" column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_row_inner column_margin="none" bottom_padding="60" bottom_padding_tablet="20" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/6" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="2/3" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][nectar_highlighted_text color_type="gradient" highlight_color="#ff6b30" secondary_color="rgba(255,107,48,0.01)" text_color="#f8eadc" style="half_text" custom_font_size="10vh" delay="200"]
<h1>Outside Health Starts <em>Inside</em></h1>
[/nectar_highlighted_text][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/6" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom" delay="600"][nectar_cta btn_style="next-section" btn_type="minimal-arrow" alignment="center" next_section_color="#f8eadc"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );






$data = array();
$data['name'] = esc_html__( 'Clean Image and Left Text', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'] . ', ' . $cat_display_names['about'];
$data['custom_class'] = 'general about date-17-Jan-2020';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/basic-left-text.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="90px" equal_height="yes" content_placement="middle" bg_color="#ffffff" top_padding_tablet="8%" constrain_group_1="yes" bottom_padding_tablet="8%" scene_position="center" text_color="dark" text_align="left" id="home" overlay_strength="0.5" gradient_direction="top_to_bottom" shape_divider_position="bottom" bg_image_animation="none" shape_type="straight_section"][vc_column column_padding="padding-2-percent" column_padding_tablet="no-extra-padding" column_padding_phone="no-extra-padding" column_padding_position="right" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" zindex="100" gradient_direction="left_t_to_right_b" overlay_strength="0.3" width="3/5" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" offset="vc_col-xs-12"][vc_row_inner column_margin="default" text_align="left" min_width="47vh"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" enable_border_animation="true" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][vc_column_text css_animation="none" css=".vc_custom_1583244983471{margin-bottom: 20px !important;}"]
<h2>Why we're different</h2>
[/vc_column_text][vc_custom_heading text="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean." font_container="tag:p|font_size:20px|text_align:left|line_height:2em" use_theme_fonts="yes" css_animation="none"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="70px" top_padding="25" bottom_padding="15" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="small_desktop" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][vc_column_text css_animation="none" css=".vc_custom_1583243653891{margin-bottom: 10px !important;}"]
<h4>Attention to Detail</h4>
[/vc_column_text][vc_custom_heading text="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts." font_container="tag:p|font_size:16px|text_align:left|line_height:2em" use_theme_fonts="yes" css_animation="none"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="small_desktop" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][vc_column_text css_animation="none" css=".vc_custom_1583243657396{margin-bottom: 10px !important;}"]
<h4>Experience</h4>
[/vc_column_text][vc_custom_heading text="Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean." font_container="tag:p|font_size:16px|text_align:left|line_height:2em" use_theme_fonts="yes" css_animation="none"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" bottom_padding="0px" bottom_padding_tablet="40px" bottom_padding_phone="40px" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][nectar_cta btn_style="arrow-animation" heading_tag="h6" text_color="#ffffff" button_color="accent-color" link_type="regular" alignment="left" display="block" link_text="Contact Us" padding_top="15" padding_right="35" padding_bottom="15" padding_left="35"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.5" width="2/5" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" offset="vc_col-xs-12"][vc_row_inner column_margin="default" text_align="left" min_width_desktop="43vw" min_width_tablet="50vw" min_width_phone="50vw"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/webp/large-adventure.webp" background_image_position="center center" enable_bg_scale="true" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.5" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="ro-reveal-from-right"][divider line_type="No Line" custom_height="80vh" custom_height_tablet="40vh" custom_height_phone="300px"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Clean Image and Right Text', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'] . ', ' . $cat_display_names['about'];
$data['custom_class'] = 'general about date-17-Jan-2020';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/basic-right-text.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" equal_height="yes" content_placement="middle" bg_color="#ffffff" scene_position="center" top_padding_tablet="8%" constrain_group_1="yes" bottom_padding_tablet="8%" text_color="dark" text_align="left" id="home" overlay_strength="0.5" gradient_direction="top_to_bottom" shape_divider_position="bottom" bg_image_animation="none" shape_type="straight_section"][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" right_margin_tablet="auto" left_margin_tablet="auto" right_margin_phone="auto" left_margin_phone="auto" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" max_width_tablet="600" max_width_phone="420px" gradient_direction="left_to_right" overlay_strength="0.5" width="2/5" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" offset="vc_col-xs-12"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/webp/mountain.webp" background_image_position="center center" enable_bg_scale="true" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.5" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="ro-reveal-from-left"][divider line_type="No Line" custom_height="90vh" custom_height_tablet="40vh" custom_height_phone="300px"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="padding-7-percent" column_padding_tablet="no-extra-padding" column_padding_phone="no-extra-padding" column_padding_position="left-right" top_margin_tablet="40" right_margin_tablet="auto" left_margin_tablet="auto" right_margin_phone="auto" left_margin_phone="auto" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" max_width_desktop="1000px" max_width_tablet="600px" max_width_phone="420px" zindex="100" gradient_direction="left_t_to_right_b" overlay_strength="0.3" width="3/5" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" offset="vc_col-xs-12"][vc_row_inner column_margin="40px" text_align="left" min_width="47vh"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" enable_border_animation="true" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][vc_column_text css_animation="none" css=".vc_custom_1583270538634{margin-bottom: 20px !important;}"]
<h2>Our Philosophy</h2>
[/vc_column_text][vc_custom_heading text="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean." font_container="tag:p|font_size:20px|text_align:left|line_height:2em" use_theme_fonts="yes" css_animation="none"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="70px" top_padding="25" bottom_padding="15" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="small_desktop" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][vc_column_text css_animation="none" css=".vc_custom_1583270560188{margin-bottom: 10px !important;}"]
<h4>Quality over Quantity</h4>
[/vc_column_text][vc_custom_heading text="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts." font_container="tag:p|font_size:16px|text_align:left|line_height:2em" use_theme_fonts="yes" css_animation="none"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="small_desktop" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][vc_column_text css_animation="none" css=".vc_custom_1583270575677{margin-bottom: 10px !important;}"]
<h4>Design Focused</h4>
[/vc_column_text][vc_custom_heading text="Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean." font_container="tag:p|font_size:16px|text_align:left|line_height:2em" use_theme_fonts="yes" css_animation="none"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" bottom_padding="0px" bottom_padding_tablet="40px" bottom_padding_phone="40px" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][nectar_cta btn_style="arrow-animation" heading_tag="h6" text_color="#ffffff" button_color="accent-color" link_type="regular" alignment="left" display="block" link_text="Contact Us" padding_top="15" padding_right="35" padding_bottom="15" padding_left="35"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Clean Self Hosted Video Hero', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['hero_section'];
$data['custom_class'] = 'hero_section date-18-Jan-2020';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/npo-video-hero.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" equal_height="yes" content_placement="middle" scene_position="center" top_padding="12%" constrain_group_1="yes" bottom_padding="12%" top_padding_tablet="20%" bottom_padding_tablet="20%" top_padding_phone="20%" bottom_padding_phone="20%" text_color="dark" text_align="left" overlay_strength="0.8" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_column_text css_animation="fadeInUp" css=".vc_custom_1579718474257{margin-bottom: 10px !important;}"]
<h5>Salient WordPress Theme</h5>
[/vc_column_text][split_line_heading animation_type="line-reveal-by-space" font_style="h1" text_content="Build a beautiful website, visually" max_width="475"][/split_line_heading][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][nectar_cta btn_style="arrow-animation" heading_tag="h4" text_color="#ffffff" button_color="accent-color" link_type="regular" alignment="left" display="block" link_text="Get Started" margin_top="30" padding_top="20" padding_right="40" padding_bottom="20" padding_left="40"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="padding-4-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-left"][nectar_video_player_self_hosted video_webm="" video_image="https://themenectar.com/img/demo-media/unsplash/webp/yellow-bg-plant.webp" loop="yes" border_radius="10px" box_shadow="none"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Promo Video Hero', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['hero_section'];
$data['custom_class'] = 'hero_section date-18-Jan-2020';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/yellow-header.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#ffcf6d" scene_position="center" top_padding="15%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" zindex="20" overlay_strength="1" gradient_direction="top_to_bottom" enable_shape_divider="true" shape_divider_color="#ffffff" shape_divider_position="bottom" shape_divider_height="20%" bg_image_animation="none" video_mute="true" shape_type="straight_section"][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_row_inner column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="slight-twist"][vc_column_text]
<h4>Salient WordPress Theme</h4>
[/vc_column_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" left_padding_desktop="13%" constrain_group_2="yes" right_padding_desktop="13%" left_padding_tablet="0" right_padding_tablet="0" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="slight-twist"][nectar_highlighted_text text_color="#000000" style="text_outline" outline_thickness="regular" custom_font_size="10vh"]
<h1>Beautiful &amp; unique
websites made easy</h1>
[/nectar_highlighted_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" left_padding_desktop="0" constrain_group_2="yes" right_padding_desktop="0" text_align="left"][vc_column_inner column_padding="padding-6-percent" column_padding_tablet="no-extra-padding" column_padding_phone="no-extra-padding" column_padding_position="left-right" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="slight-twist"][nectar_cta btn_style="basic" heading_tag="span" text_color="#000000" button_color="white" button_color_hover="#fff5e2" link_type="regular" alignment="center" constrain_group_1="yes" constrain_group_2="yes" constrain_group_3="yes" constrain_group_4="yes" display="inline" margin_top="20" margin_bottom="20" margin_left="15" margin_right="15" link_text="Why Choose Salient" padding_top="20" padding_bottom="20" padding_left="45" padding_right="45"][nectar_cta btn_style="arrow-animation" heading_tag="span" text_color="#ffffff" button_color="accent-color" button_color_hover="#2643ef" link_type="new_tab" alignment="left" constrain_group_1="yes" constrain_group_2="yes" constrain_group_3="yes" constrain_group_4="yes" display="inline" link_text="Purchase Salient" margin_top="20" margin_bottom="20" margin_left="15" margin_right="15" padding_top="20" padding_bottom="20" padding_left="45" padding_right="45"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" top_padding="5%" left_padding_desktop="8%" constrain_group_2="yes" right_padding_desktop="8%" left_padding_tablet="0" constrain_group_4="yes" right_padding_tablet="0" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="no-extra-padding" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom" delay="200"][nectar_video_player_self_hosted video_image="https://themenectar.com/img/demo-media/unsplash/webp/yellow-bg-plant.webp" hide_controls="yes" loop="yes" autoplay="yes" border_radius="15px" box_shadow="none"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row][vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#ffffff" scene_position="center" top_padding="6%" bottom_padding="8%" left_padding_desktop="12%" constrain_group_2="yes" right_padding_desktop="12%" left_padding_tablet="0" constrain_group_4="yes" right_padding_tablet="0" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overlay_strength="0.8" gradient_direction="left_t_to_right_b" shape_divider_color="#ff8b50" shape_divider_position="bottom" shape_divider_height="250" bg_image_animation="none" video_mute="true" shape_type="straight_section"][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_row_inner equal_height="yes" content_placement="middle" column_margin="40px" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left"][vc_column_inner column_padding="padding-1-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="left-right" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/5" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" offset="vc_col-xs-4"][image_with_animation image_url="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo-grey.png" animation="Grow In" hover_animation="none" alignment="" border_radius="none" box_shadow="none" image_loading="lazy-load" max_width="100%" max_width_mobile="default"][/vc_column_inner][vc_column_inner column_padding="padding-1-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="left-right" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/5" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" offset="vc_col-xs-4"][image_with_animation image_url="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo-grey.png" animation="Grow In" hover_animation="none" alignment="" border_radius="none" box_shadow="none" image_loading="lazy-load" max_width="100%" max_width_mobile="default" delay="70"][/vc_column_inner][vc_column_inner column_padding="padding-1-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="left-right" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/5" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" offset="vc_col-xs-4"][image_with_animation image_url="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo-grey.png" animation="Grow In" hover_animation="none" alignment="" border_radius="none" box_shadow="none" image_loading="lazy-load" max_width="100%" max_width_mobile="default" delay="140"][/vc_column_inner][vc_column_inner column_padding="padding-1-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="left-right" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/5" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" offset="vc_hidden-sm vc_hidden-xs"][image_with_animation image_url="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo-grey.png" animation="Grow In" hover_animation="none" alignment="" border_radius="none" box_shadow="none" image_loading="lazy-load" max_width="100%" max_width_mobile="default" delay="210"][/vc_column_inner][vc_column_inner column_padding="padding-1-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="left-right" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/5" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" offset="vc_hidden-sm vc_hidden-xs"][image_with_animation image_url="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo-grey.png" animation="Grow In" hover_animation="none" alignment="" border_radius="none" box_shadow="none" image_loading="lazy-load" max_width="100%" max_width_mobile="default" delay="280"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]

CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'Video Overflow Right', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-18-Jan-2020';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/promo-right-overflow-video.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="50px" equal_height="yes" content_placement="middle" column_direction="default" column_direction_tablet="column_reverse" column_direction_phone="column_reverse" bg_color="#ffffff" scene_position="center" top_padding="10%" constrain_group_1="yes" bottom_padding="10%" top_padding_tablet="15%" constrain_group_3="yes" bottom_padding_tablet="15%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overlay_strength="0.8" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="padding-4-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="right" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self"  gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" offset="vc_col-lg-6"][vc_row_inner column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bottom_padding="15" text_align="left" min_width="47vh"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" enable_border_animation="true" bg_image_animation="none"][split_line_heading animation_type="line-reveal-by-space" font_style="h2" text_content="Intuitive Interface"][/split_line_heading][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left"][vc_column_inner column_padding="padding-2-percent" column_padding_tablet="no-extra-padding" column_padding_phone="inherit" column_padding_position="right" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][vc_column_text]Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec posuere mi eget felis placerat, quis condimentum quam mattis. Aenean id diam sit amet lacus.[/vc_column_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left"][vc_column_inner column_padding="padding-2-percent" column_padding_tablet="no-extra-padding" column_padding_phone="inherit" column_padding_position="right" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][nectar_cta btn_style="arrow-animation" heading_tag="span" text_color="#000000" button_color="default" link_type="regular" alignment="left" constrain_group_3="yes" constrain_group_4="yes" display="block" link_text="Discover More" url="#design" padding_top="20" padding_bottom="20"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="padding-4-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" offset="vc_col-lg-6"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" min_width_desktop="58vw"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][nectar_video_player_self_hosted video_image="https://themenectar.com/img/demo-media/unsplash/webp/yellow-bg-plant.webp" hide_controls="yes" loop="yes" autoplay="yes" border_radius="10px" box_shadow="none"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Video Overflow Left', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-18-Jan-2020';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/promo-left-overflow-video.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" equal_height="yes" content_placement="middle" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#ffffff" scene_position="center" top_padding="10%" bottom_padding="10%" top_padding_tablet="15%" bottom_padding_tablet="15%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" zindex="200" id="design" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" left_margin_tablet="auto" right_margin_tablet="auto" left_margin_phone="auto" right_margin_phone="auto" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" max_width_tablet="600px" max_width_phone="420px" gradient_direction="left_to_right" overlay_strength="0.3" width="5/12" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bottom_padding_tablet="40" translate_x="-20%" translate_x_tablet="0" text_align="left" min_width_desktop="50vw" min_width_tablet="none"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][nectar_video_player_self_hosted video_image="https://themenectar.com/img/demo-media/unsplash/webp/large-adventure.webp" hide_controls="yes" loop="yes" autoplay="yes" border_radius="10px" box_shadow="none"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="padding-10-percent" column_padding_tablet="no-extra-padding" column_padding_phone="no-extra-padding" column_padding_position="left" left_margin_tablet="auto" right_margin_tablet="auto" left_margin_phone="auto" right_margin_phone="auto" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" max_width_desktop="850" max_width_tablet="600px" max_width_phone="420px" gradient_direction="left_to_right" overlay_strength="0.3" width="7/12" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_row_inner column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bottom_padding="15" right_padding_desktop="90" right_padding_tablet="0" text_align="left" min_width="47vh"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" enable_border_animation="true" bg_image_animation="none"][split_line_heading animation_type="line-reveal-by-space" font_style="h2" text_content="Award-Winning Design"][/split_line_heading][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bottom_padding="40" right_padding_desktop="90" right_padding_tablet="0" text_align="left"][vc_column_inner column_padding="padding-2-percent" column_padding_tablet="no-extra-padding" column_padding_phone="inherit" column_padding_position="right" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][vc_column_text]
<div class="wpb_text_column wpb_content_element vc_custom_1490624298920">
<div class="wpb_wrapper">
<h6>For over 7 years, we've focused on creating trend-setting designs that make people stop and stare.  Details matter, and we rush nothing. Quality, not quantity, is what guides us.</h6>
</div>
</div>
[/vc_column_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left"][vc_column_inner column_padding="padding-2-percent" column_padding_tablet="no-extra-padding" column_padding_phone="inherit" column_padding_position="right" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][nectar_cta btn_style="arrow-animation" heading_tag="span" text_color="#000000" button_color="default" link_type="regular" alignment="left" constrain_group_3="yes" constrain_group_4="yes" display="block" link_text="Great design for all" url="#" padding_top="20" padding_bottom="20"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Clean Dual CTA', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-17-Jan-2020';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/promo-cta.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#ffffff" scene_position="center" top_padding="2%" bottom_padding="7%" top_padding_tablet="8%" bottom_padding_tablet="10%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_b_to_right_t" overlay_strength="1" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="slight-twist"][vc_row_inner column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bottom_padding_tablet="10" bottom_padding_phone="5" left_padding_phone="25%" constrain_group_6="yes" right_padding_phone="25%" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="slight-twist"][vc_column_text]
<h6>This site was built with Salient</h6>
[/vc_column_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][nectar_highlighted_text text_color="#000000" style="text_outline" outline_thickness="regular" custom_font_size="10vh"]
<h1>You Can Build a</h1>
<h1>Stunning Website</h1>
[/nectar_highlighted_text][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row][vc_row type="full_width_background" full_screen_row_position="middle" column_margin="none" equal_height="yes" content_placement="middle" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#ffffff" scene_position="center" bottom_padding="8%" text_color="dark" text_align="left" row_border_radius="10px" row_border_radius_applies="inner" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color="#ffcf6d" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" tablet_text_alignment="center" phone_text_alignment="center" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_row_inner equal_height="yes" content_placement="middle" column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bottom_padding_tablet="10" left_padding_tablet="20%" constrain_group_4="yes" right_padding_tablet="20%" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/webp/minimal-white-desk-open-middle.webp" background_image_position="left top" enable_bg_scale="true" column_shadow="none" column_border_radius="none" column_link_target="_self" enable_gradient="true" color_overlay_2="#ffcf6d" gradient_direction="left_to_right" overlay_strength="1" width="5/6" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" offset="vc_col-lg-6 vc_col-md-5 vc_hidden-sm vc_hidden-xs"][/vc_column_inner][vc_column_inner column_padding="padding-15-percent" column_padding_tablet="padding-8-percent" column_padding_phone="padding-8-percent" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" offset="vc_col-lg-5 vc_col-md-6"][vc_column_text css=".vc_custom_1586179428508{margin-bottom: 50px !important;}"]Start by checking out the premade demo websites to see what's possible.[/vc_column_text][nectar_cta btn_style="basic" heading_tag="span" text_color="#ffffff" button_color="accent-color" button_color_hover="#2643ef" link_type="video_lightbox" alignment="left" display="block" link_text="See The Magic" url="https://www.youtube.com/watch?v=RDC1ZFFhZq8" padding_top="15" padding_right="35" padding_bottom="15" padding_left="35"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/webp/large-clouds.webp" background_image_position="center center" enable_bg_scale="true" column_shadow="none" column_border_radius="none" column_link_target="_self" color_overlay="#3452ff" gradient_direction="left_to_right" overlay_strength="0.8" width="1/2" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bottom_padding_tablet="10" text_align="left"][vc_column_inner column_padding="padding-12-percent" column_padding_tablet="inherit" column_padding_phone="padding-8-percent" column_padding_position="all" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" font_color="#ffffff" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_column_text css=".vc_custom_1586179434669{margin-bottom: 50px !important;}" max_width="280"]Salient is the ultimate WordPress theme for building beautiful websites.[/vc_column_text][nectar_cta btn_style="arrow-animation" heading_tag="span" text_color="#000000" button_color="white" button_color_hover="#e8e8ff" link_type="regular" alignment="center" display="block" link_text="Purchase Salient" url="#" padding_top="15" padding_right="35" padding_bottom="15" padding_left="35"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Sticky Vertical Tabs', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-17-Jan-2020';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/sticky-tabs.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#ffffff" scene_position="center" top_padding="6%" bottom_padding="6%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][tabbed_section style="vertical_scrolling" tab_color="Accent-Color" vs_navigation_width="regular" vs_navigation_spacing="45px" vs_tab_spacing="40%" vs_tab_tag="h3"][tab icon_family="none" title="The Best Features" id="1586441707425-5" sub_desc="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia." tab_id="1586441707426-2"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][nectar_video_player_self_hosted video_image="https://themenectar.com/img/demo-media/unsplash/webp/large-clouds.webp" border_radius="10px" box_shadow="none"][/vc_column_inner][/vc_row_inner][/tab][tab icon_family="none" title="Intuitive User Interface" id="1586441707538-9" sub_desc="Separated they live in Bookmarksgrove right at the coast of the Semantics." tab_id="1586441707540-6"][vc_row_inner column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="2/3" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_custom_heading text="Look deep into nature, and then you will understand everything better." font_container="tag:h2|font_size:40|text_align:left|line_height:50px" use_theme_fonts="yes"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left"][vc_column_inner column_padding="padding-3-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][vc_column_text css=".vc_custom_1586380254133{padding-right: 10% !important;}"]Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean.[/vc_column_text][/vc_column_inner][vc_column_inner column_padding="padding-3-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom" delay="100"][vc_column_text css=".vc_custom_1586380260249{padding-right: 10% !important;}"]Even the all-powerful Pointing has no control about the blind texts it is an almost unorthographic life One day however a small line of blind text by the name of Lorem Ipsum decided to leave for the far World of Grammar.[/vc_column_text][/vc_column_inner][/vc_row_inner][/tab][tab icon_family="none" title="Scorching Hot Design" id="1586441707700-1" sub_desc="It is a paradisematic country, in which roasted parts of sentences fly into your mouth." tab_id="1586441707701-2"][vc_row_inner column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="2/3" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_custom_heading text="Try not to become a man of success, but rather try to become a man of value." font_container="tag:h2|font_size:40|text_align:left|line_height:50px" use_theme_fonts="yes"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left"][vc_column_inner column_padding="padding-3-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][vc_column_text css=".vc_custom_1586380277392{padding-right: 10% !important;}"]Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean.[/vc_column_text][/vc_column_inner][vc_column_inner column_padding="padding-3-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom" delay="100"][vc_column_text css=".vc_custom_1586380281399{padding-right: 10% !important;}"]Even the all-powerful Pointing has no control about the blind texts it is an almost unorthographic life One day however a small line of blind text by the name of Lorem Ipsum decided to leave for the far World of Grammar.[/vc_column_text][/vc_column_inner][/vc_row_inner][/tab][/tabbed_section][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Dark Sticky Vertical Tabs', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-8-Jan-2020';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/sticky-tabs-dark.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#000000" scene_position="center" top_padding="10%" constrain_group_1="yes" bottom_padding="10%" text_color="light" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][tabbed_section style="vertical_scrolling" tab_color="extra-color-gradient-1" vs_navigation_width="regular" vs_navigation_spacing="45px" vs_tab_spacing="40%" vs_tab_tag="h3"][tab icon_family="none" title="Best Features Provided" id="1586451527673-0" tab_id="1586451527675-4"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][nectar_video_player_self_hosted video_image="https://themenectar.com/img/demo-media/unsplash/webp/large-city.webp" border_radius="10px" box_shadow="none"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left"][vc_column_inner column_padding="padding-3-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][vc_column_text css=".vc_custom_1586450820355{padding-right: 10% !important;}"]Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. They live.[/vc_column_text][/vc_column_inner][vc_column_inner column_padding="padding-3-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom" delay="100"][vc_column_text css=".vc_custom_1586450820355{padding-right: 10% !important;}"]Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. They live.[/vc_column_text][/vc_column_inner][/vc_row_inner][/tab][tab icon_family="none" title="Intuitive User Interface" id="1586451527867-5" tab_id="1586451527868-3"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][nectar_video_player_self_hosted video_image="https://themenectar.com/img/demo-media/unsplash/webp/large-fashion.webp" border_radius="10px" box_shadow="none"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left"][vc_column_inner column_padding="padding-3-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][vc_column_text css=".vc_custom_1586450830737{padding-right: 10% !important;}"]Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. They live.[/vc_column_text][/vc_column_inner][vc_column_inner column_padding="padding-3-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom" delay="100"][vc_column_text css=".vc_custom_1586450830737{padding-right: 10% !important;}"]Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. They live.[/vc_column_text][/vc_column_inner][/vc_row_inner][/tab][tab icon_family="none" title="Scorching Hot Design" id="1586451528012-3" tab_id="1586451528013-6"][vc_row_inner column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="2/3" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_custom_heading text="Try not to become a man of success, but rather try to become a man of value." font_container="tag:h2|font_size:40|text_align:left|line_height:50px" use_theme_fonts="yes"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left"][vc_column_inner column_padding="padding-3-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][vc_column_text css=".vc_custom_1586380277392{padding-right: 10% !important;}"]Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean.[/vc_column_text][/vc_column_inner][vc_column_inner column_padding="padding-3-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom" delay="100"][vc_column_text css=".vc_custom_1586380281399{padding-right: 10% !important;}"]Even the all-powerful Pointing has no control about the blind texts it is an almost unorthographic life One day however a small line of blind text by the name of Lorem Ipsum decided to leave for the far World of Grammar.[/vc_column_text][/vc_column_inner][/vc_row_inner][/tab][/tabbed_section][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Services Carousel', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['services'];
$data['custom_class'] = 'services date-18-Jan-2020';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/promo-services-carousel.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" scene_position="center" top_padding="14%" constrain_group_1="yes" bottom_padding="14%" top_padding_tablet="20%" constrain_group_3="yes" bottom_padding_tablet="20%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" id="more-features" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bottom_padding="15" text_align="left"][vc_column_inner column_padding="padding-4-percent" column_padding_tablet="padding-13-percent" column_padding_phone="padding-4-percent" column_padding_position="right" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][vc_column_text css_animation="none" css=".vc_custom_1585945715457{margin-bottom: 20px !important;}" max_width="500"]
<h2>Salient is loaded with the features you need</h2>
[/vc_column_text][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom" delay="100"][nectar_single_testimonial testimonial_style="basic" quote="Salient is an overall amazing theme. It packs all the features one may need, it's snappy, fast, incredibly user-friendly, and is by far, one of the best I've used."][nectar_cta btn_style="arrow-animation" heading_tag="span" text_color="#000000" button_color="default" link_type="regular" alignment="left" constrain_group_3="yes" display="block" link_text="See what people are saying" url="#" padding_top="20" padding_bottom="20" margin_top="40"][/vc_column_inner][/vc_row_inner][carousel script="flickity" flickity_formatting="default" desktop_cols_flickity="3" desktop_small_cols_flickity="3" tablet_cols_flickity="2" flickity_controls="touch_total" flickity_touch_total_hide_indicator="true" color="default" flickity_overflow="visible" flickity_wrap_around="no-wrap" flickity_spacing="20px" column_padding="0" flickity_image_scale_on_drag="true" border_radius="none" touch_total_hide_indicator="true"][item id="1586088313912-3" tab_id="1586088313913-8" title="Item"][fancy_box box_style="color_box_hover" icon_family="iconsmind" image_url="https://themenectar.com/img/demo-media/unsplash/webp/500-500-building.webp" color="accent-color" color_custom="#000000" color_box_hover_overlay_opacity="0.5" box_alignment="left" enable_border="true" border_radius="default" image_loading="lazy-load" color_scheme="dark" secondary_content="here's some awesome text that would only be shown on hover" icon_iconsmind="iconsmind-Edit" min_height="300" min_height_tablet="275" min_height_phone="255"]
<h3>Front-end Editor &amp; Back-end Editor</h3>
Edit your site visually or through a simplified interface. The choice is yours.[/fancy_box][/item][item id="1586088314180-7" tab_id="1586088314181-8" title="Item"][fancy_box box_style="color_box_hover" icon_family="iconsmind" image_url="https://themenectar.com/img/demo-media/unsplash/webp/500-500-forest.webp" color="accent-color" color_custom="#000000" color_box_hover_overlay_opacity="0.5" box_alignment="left" enable_border="true" border_radius="default" image_loading="lazy-load" enable_animation="true" animation="none" color_scheme="dark" secondary_content="here's some awesome text that would only be shown on hover" icon_iconsmind="iconsmind-Duplicate-Layer" min_height="300" min_height_tablet="275" min_height_phone="255"]
<h3>Huge Collection of Elements</h3>
Over 55 unique page builder elements to create your masterpiece.[/fancy_box][/item][item id="1586088314414-2" tab_id="1586088314415-9" title="Item"][fancy_box box_style="color_box_hover" icon_family="iconsmind" image_url="https://themenectar.com/img/demo-media/unsplash/webp/500-500-sky.webp" color="accent-color" color_custom="#000000" color_box_hover_overlay_opacity="0.5" box_alignment="left" enable_border="true" border_radius="default" image_loading="lazy-load" enable_animation="true" animation="none" color_scheme="dark" secondary_content="" icon_iconsmind="iconsmind-Flash" min_height="300" min_height_tablet="275" min_height_phone="255"]
<h3>Blazing Fast Performance</h3>
97% PageSpeed score &amp; 93% YSlow Score on GTMetrix.[/fancy_box][/item][item id="1586088314647-8" tab_id="1586088314648-4" title="Item"][fancy_box box_style="color_box_hover" icon_family="iconsmind" image_url="https://themenectar.com/img/demo-media/unsplash/webp/600-600-flame.webp" color="accent-color" color_custom="#000000" color_box_hover_overlay_opacity="0.5" box_alignment="left" enable_border="true" border_radius="default" image_loading="lazy-load" color_scheme="dark" secondary_content="here's some awesome text that would only be shown on hover" icon_iconsmind="iconsmind-Window-2" min_height="300" min_height_tablet="275" min_height_phone="255"]
<h3>Suitable for Any Website</h3>
Unlimited customization possibilities allow Salient to shine no matter the use case.[/fancy_box][/item][item id="1586088314855-1" tab_id="1586088314856-6" title="Item"][fancy_box box_style="color_box_hover" icon_family="iconsmind" image_url="https://themenectar.com/img/demo-media/unsplash/webp/600-600-girl.webp" color="accent-color" color_custom="#000000" color_box_hover_overlay_opacity="0.5" box_alignment="left" enable_border="true" border_radius="default" image_loading="lazy-load" color_scheme="dark" secondary_content="" icon_iconsmind="iconsmind-Monitor-phone" min_height="300" min_height_tablet="275" min_height_phone="255"]
<h3>Ultra Responsive and Retina Ready</h3>
Built with mobile in mind rather than it being an afterthought.[/fancy_box][/item][item id="1586088315048-2" tab_id="1586088315049-6" title="Item"][fancy_box box_style="color_box_hover" icon_family="iconsmind" image_url="https://themenectar.com/img/demo-media/unsplash/webp/600-600-guy.webp" color="accent-color" color_custom="#000000" color_box_hover_overlay_opacity="0.5" box_alignment="left" enable_border="true" border_radius="default" image_loading="lazy-load" color_scheme="dark" secondary_content="here's some awesome text that would only be shown on hover" icon_iconsmind="iconsmind-Newsvine" min_height="300" min_height_tablet="275" min_height_phone="255"]
<h3>Frequently Updated With New Features</h3>
With a single purchase, you'll enjoy lifetime updates.[/fancy_box][/item][item id="1586088315255-9" tab_id="1586088315257-6" title="Item"][fancy_box box_style="color_box_hover" icon_family="iconsmind" image_url="https://themenectar.com/img/demo-media/unsplash/webp/500-500-forest.webp" color="accent-color" color_custom="#000000" color_box_hover_overlay_opacity="0.5" box_alignment="left" enable_border="true" border_radius="default" image_loading="lazy-load" color_scheme="dark" secondary_content="here's some awesome text that would only be shown on hover" icon_iconsmind="iconsmind-Capricorn-2" min_height="300" min_height_tablet="275" min_height_phone="255"]
<h3>Thousands of Beautiful Icons</h3>
3,500+ icons ($59 value) are included to choose from.[/fancy_box][/item][item id="1586088315454-0" tab_id="1586088315455-4" title="Item"][fancy_box box_style="color_box_hover" icon_family="iconsmind" image_url="https://themenectar.com/img/demo-media/unsplash/webp/500-500-sky.webp" color="accent-color" color_custom="#000000" color_box_hover_overlay_opacity="0.5" box_alignment="left" enable_border="true" border_radius="default" image_loading="lazy-load" color_scheme="dark" secondary_content="here's some awesome text that would only be shown on hover" icon_iconsmind="iconsmind-Cursor-Click2" min_height="300" min_height_tablet="275" min_height_phone="255"]
<h3>One-Click Demo Importer</h3>
Get started in a flash with our user-friendly demo importer.[/fancy_box][/item][item id="1586088315649-9" tab_id="1586088315650-1" title="Item"][fancy_box box_style="color_box_hover" icon_family="iconsmind" image_url="https://themenectar.com/img/demo-media/unsplash/webp/600-600-flame.webp" color="accent-color" color_custom="#000000" color_box_hover_overlay_opacity="0.5" box_alignment="left" enable_border="true" border_radius="default" image_loading="lazy-load" color_scheme="dark" secondary_content="here's some awesome text that would only be shown on hover" icon_iconsmind="iconsmind-Book" min_height="300" min_height_tablet="275" min_height_phone="255"]
<h3>Salient Help Center</h3>
Find the answers you're looking for or request assistance in our forum.[/fancy_box][/item][/carousel][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'Autoplaying Video Hero', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['hero_section'];
$data['custom_class'] = 'hero_section date-04-Jan-2020';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/promo-hero.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" equal_height="yes" content_placement="middle" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-adventure.webp" bg_position="left top" bg_repeat="no-repeat" scene_position="center" top_padding="14%" constrain_group_1="yes" bottom_padding="14%" top_padding_tablet="20%" constrain_group_3="yes" bottom_padding_tablet="20%" top_padding_phone="20%" bottom_padding_phone="20%" text_color="light" text_align="left" color_overlay="#1b1c26d9" overlay_strength="0.8" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="zoom-out-slow" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_column_text css_animation="fadeInUp" css=".vc_custom_1579718474257{margin-bottom: 10px !important;}"]
<h5>Salient WordPress Theme</h5>
[/vc_column_text][split_line_heading animation_type="line-reveal-by-space" font_style="h1" text_content="Build a beautiful website, visually" max_width="475"][/split_line_heading][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="padding-4-percent" column_padding_phone="padding-4-percent" column_padding_position="bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom" delay="450"][nectar_video_lightbox link_style="play_button_with_text" nectar_play_button_color="Default-Accent-Color" nectar_play_button_style="default" font_style="h4" video_url="https://www.youtube.com/watch?v=6oTurM7gESE etc." link_text="Watch how easy it is"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="grow-in" delay="300"][nectar_video_player_self_hosted video_webm="" video_image="https://themenectar.com/img/demo-media/unsplash/webp/large-sunflowers.webp" hide_controls="yes" loop="yes" autoplay="yes" border_radius="10px" box_shadow="x_large_depth"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Dark Portfolio Grid Cards', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['portfolio'];
$data['custom_class'] = 'portfolio date-7-Jan-2020';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/promo-dark-post-grid.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#131418" scene_position="center" top_padding="14%" bottom_padding="14%" top_padding_tablet="20%" bottom_padding_tablet="20%" text_color="light" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_row_inner column_margin="none" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bottom_padding="35" left_padding_desktop="24%" constrain_group_2="yes" right_padding_desktop="24%" bottom_padding_tablet="25" constrain_group_4="yes" left_padding_phone="12%" constrain_group_6="yes" right_padding_phone="12%" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][split_line_heading animation_type="line-reveal-by-space" font_style="h2" text_content="Pre-built Websites Included with Salient" max_width="435"][/split_line_heading][/vc_column_inner][/vc_row_inner][nectar_post_grid post_type="portfolio" portfolio_category="all" order="DESC" orderby="date" pagination="load-more" button_color="accent-color" columns="3" grid_item_spacing="25px" grid_item_height="30vh" enable_sortable="yes" sortable_color="accent-color" enable_masonry="yes" image_size="portfolio-thumb_large" aspect_ratio_image_size="yes" image_loading="lazy-load" animation="fade-in-from-bottom" heading_tag="h4" enable_indicator="yes" mouse_indicator_style="default" mouse_indicator_text="view" mouse_indicator_color="#3452ff" display_categories="yes" category_functionality="static" grid_style="content_under_image" card_design="yes" card_bg_color="#1f2125" card_bg_color_hover="#25272b" content_under_image_text_align="center" text_color="light" hover_effect="none" border_radius="10px" card_design_bg_color="#00cae8" posts_per_page="15" css_class_name="nectar-browser-window-style"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Single Testimonial', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['testimonials'];
$data['custom_class'] = 'testimonials date-16-Jan-2020';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/clean-image-testimonial.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#ffffff" scene_position="center" top_padding="14%" constrain_group_1="yes" bottom_padding="14%" top_padding_tablet="20%" constrain_group_3="yes" bottom_padding_tablet="20%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_b_to_right_t" overlay_strength="1" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][vc_row_inner equal_height="yes" content_placement="middle" column_margin="90px" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="padding-3-percent" column_padding_phone="inherit" column_padding_position="bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][image_with_animation image_url="https://themenectar.com/img/demo-media/unsplash/webp/700-700-mountain-trees.webp" animation="None" hover_animation="none" alignment="" border_radius="15px" box_shadow="none" image_loading="default" max_width="100%" max_width_mobile="default"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][nectar_single_testimonial testimonial_style="basic" quote="I'm wondering why I never contacted these guys sooner! Seriously, they all have commendable talent in their respective fields and knocked my concept out of the ballpark. Thanks for an amazing experience!" name="phil martinez" subtitle="Interior Decorator"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'SVG Draw Animation Icons', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['icons']  .', '. $cat_display_names['general'];
$data['custom_class'] = 'general icons';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/svg_icon_draw.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_color="#3a6ee8" scene_position="center" text_color="light" text_align="center" top_padding="16%" bottom_padding="5%" overlay_strength="0.3" shape_divider_position="bottom"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/6" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][nectar_icon icon_family="linea" enable_animation="true" animation_speed="fast" icon_style="default" icon_color="Extra-Color-3" icon_padding="0px" icon_linea="icon-software-transform-bezier" icon_size="60"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid"][vc_column_text]
<h6>Sexy Design</h6>
[/vc_column_text][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/6" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][nectar_icon icon_family="linea" enable_animation="true" animation_speed="fast" icon_style="default" icon_color="Extra-Color-3" icon_padding="0px" icon_linea="icon-basic-mixer2" icon_size="60" animation_delay="500"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" delay="500"][vc_column_text]
<h6>True Power</h6>
[/vc_column_text][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/6" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][nectar_icon icon_family="linea" enable_animation="true" animation_speed="fast" icon_style="default" icon_color="Extra-Color-3" icon_padding="0px" icon_linea="icon-weather-wind-fullmoon" icon_size="60" animation_delay="1000"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" delay="1000"][vc_column_text]
<h6>Icon Paradise</h6>
[/vc_column_text][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/6" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][nectar_icon icon_family="linea" enable_animation="true" animation_speed="fast" icon_style="default" icon_color="Extra-Color-3" icon_padding="0px" icon_linea="icon-software-layout-header-complex" icon_size="60" animation_delay="1500"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" delay="1500"][vc_column_text]
<h6>Page Builder</h6>
[/vc_column_text][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/6" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][nectar_icon icon_family="linea" enable_animation="true" animation_speed="fast" icon_style="default" icon_color="Extra-Color-3" icon_padding="0px" icon_linea="icon-ecommerce-diamond" icon_size="60" animation_delay="2000"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" delay="2000"][vc_column_text]
<h6>Top Quality</h6>
[/vc_column_text][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/6" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][nectar_icon icon_family="linea" enable_animation="true" animation_speed="fast" icon_style="default" icon_color="Extra-Color-3" icon_padding="0px" icon_linea="icon-software-paintroller" icon_size="60" animation_delay="2500"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" delay="2500"][vc_column_text]
<h6>Customizable</h6>
[/vc_column_text][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row][vc_row type="full_width_background" full_screen_row_position="middle" bg_color="#3a6ee8" scene_position="center" text_color="light" text_align="left" bottom_padding="17%" overlay_strength="0.3" shape_divider_position="bottom"][vc_column enable_animation="true" animation="fade-in" column_padding="padding-1-percent" column_padding_position="left-right" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/2" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_column_text]
<h3 style="text-align: right;">Hello. We're Salient, A Creative Agency Located In New York City. Take A Look Around &amp; Don't Be Shy.</h3>
[/vc_column_text][/vc_column][vc_column enable_animation="true" animation="fade-in" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" font_color="#cdf4f4" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/2" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="padding-1-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/2" tablet_width_inherit="default" column_border_width="none" column_border_style="solid"][vc_column_text]Phasellus enim libero, blandit vel sapien vitae, condimentum ultricies magna et. Quisque euismod orci ut et lobortis aliquam.[/vc_column_text][/vc_column_inner][vc_column_inner column_padding="padding-1-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/2" tablet_width_inherit="default" column_border_width="none" column_border_style="solid"][vc_column_text]Phasellus enim libero, blandit vel sapien vitae, condimentum ultricies magna et. Quisque euismod orci ut et lobortis aliquam.[/vc_column_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="padding-1-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/2" tablet_width_inherit="default" column_border_width="none" column_border_style="solid"][vc_column_text]Phasellus enim libero, blandit vel sapien vitae, condimentum ultricies magna et. Quisque euismod orci ut et lobortis aliquam.[/vc_column_text][/vc_column_inner][vc_column_inner column_padding="padding-1-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/2" tablet_width_inherit="default" column_border_width="none" column_border_style="solid"][vc_column_text]Phasellus enim libero, blandit vel sapien vitae, condimentum ultricies magna et. Quisque euismod orci ut et lobortis aliquam.[/vc_column_text][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Mouse Based Parallax', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['about'] .', '. $cat_display_names['hero_section'];
$data['custom_class'] = 'about hero_section';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/mouse_parallax.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" mouse_based_parallax_bg="true" scene_position="center" mouse_sensitivity="19" layer_one_image="https://themenectar.com/demo/salient-frostwave/wp-content/uploads/2013/03/Comp-1-0-00-15-11_1.jpg" layer_one_strength="0.11" layer_two_image="https://themenectar.com/demo/salient-frostwave/wp-content/uploads/2013/03/mountains.png" layer_two_strength="0.24" layer_three_image="https://themenectar.com/demo/salient-frostwave/wp-content/uploads/2013/03/ground-revised.png" layer_three_strength="0.5" text_color="light" text_align="left" top_padding="20%" bottom_padding="18%" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" width="1/1" tablet_text_alignment="default" phone_text_alignment="default"][vc_column_text]<h1 class="jumbo">Hello</h1><h5><i>We are Salient. It's nice to meet you!</i></h5>[/vc_column_text][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Fondly Simple Service List', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['icons'] .', '. $cat_display_names['services'] .', '. $cat_display_names['general'];
$data['custom_class'] = 'icons services general date-15-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/services-icons.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_color="#ffffff" scene_position="center" text_color="dark" text_align="left" top_padding="10%" bottom_padding="10%" overlay_strength="0.5"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/6" column_border_width="none" column_border_style="solid"][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="2/3" column_border_width="none" column_border_style="solid"][vc_custom_heading text="We make it simple to share your ideas with target audiences." font_container="tag:h2|font_size:48px|text_align:center|line_height:57px" use_theme_fonts="yes" css_animation="none"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/6" column_border_width="none" column_border_style="solid"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/6" column_border_width="none" column_border_style="solid"][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="2/3" column_border_width="none" column_border_style="solid" delay="50"][vc_custom_heading text="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. A small river named Duden." font_container="tag:p|text_align:center|color:rgba(10%2C10%2C10%2C0.65)" use_theme_fonts="yes" css_animation="none" css=".vc_custom_1485869848994{padding-right: 13% !important;padding-left: 13% !important;}"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/6" column_border_width="none" column_border_style="solid"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" top_padding="20" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-3-percent" column_padding_position="all" centered_text="true" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color="grey" icon_padding="0px" icon_iconsmind="iconsmind-Upload-toCloud" url="#"][vc_column_text css_animation="fadeInUp" css=".vc_custom_1485869613252{margin-bottom: 15px !important;}"]
<h5>Upload your ideas to Salient</h5>
[/vc_column_text][vc_custom_heading text="Far far away, behind the word mountains, far from the countries Vokalia and texts" font_container="tag:p|text_align:center|color:rgba(10%2C10%2C10%2C0.65)" use_theme_fonts="yes" css_animation="fadeInUp"][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-3-percent" column_padding_position="all" centered_text="true" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid" delay="100"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color="grey" icon_padding="0px" icon_iconsmind="iconsmind-D-Eyeglasses2" url="#"][vc_column_text css_animation="fadeInUp" css=".vc_custom_1485869633028{margin-bottom: 15px !important;}"]
<h5>Watch the magic happen</h5>
[/vc_column_text][vc_custom_heading text="Far far away, behind the word mountains, far from the countries Vokalia and texts" font_container="tag:p|text_align:center|color:rgba(10%2C10%2C10%2C0.65)" use_theme_fonts="yes" css_animation="fadeInUp"][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-3-percent" column_padding_position="all" centered_text="true" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid" delay="200"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color="grey" icon_padding="0px" icon_iconsmind="iconsmind-Happy" url="#"][vc_column_text css_animation="fadeInUp" css=".vc_custom_1485869652646{margin-bottom: 15px !important;}"]
<h5>Enjoy your increased revenue</h5>
[/vc_column_text][vc_custom_heading text="Far far away, behind the word mountains, far from the countries Vokalia and texts" font_container="tag:p|text_align:center|color:rgba(10%2C10%2C10%2C0.65)" use_theme_fonts="yes" css_animation="fadeInUp"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="grow-in" column_padding="no-extra-padding" column_padding_position="all" centered_text="true" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid"][nectar_btn size="large" button_style="see-through-2" color_override="#b2b2b2" hover_color_override="#0a0a0a" hover_text_color_override="#ffffff" icon_family="none" url="#" text="Learn More" margin_top="50"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Restaurant CTA', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['cta'];
$data['custom_class'] = 'cta date-27-Sep-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/eat-with-us.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/food.webp" bg_position="center center" bg_repeat="no-repeat" parallax_bg="true" parallax_bg_speed="fast" bg_color="#000000" scene_position="center" text_color="light" text_align="left" top_padding="8%" bottom_padding="8%" color_overlay="#000000" overlay_strength="0.8"][vc_column centered_text="true" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/6" column_border_width="none" column_border_style="solid"][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" centered_text="true" background_color_opacity="1" width="2/3" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1487011499391{margin-bottom: 35px !important;}"]
<h2>Come in and eat with us</h2>
[/vc_column_text][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/6" column_border_width="none" column_border_style="solid"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-2-percent" column_padding_position="all" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid"][vc_column_text]<strong>Monday – Thursday:</strong> 9:00 am – 10:00 pm[/vc_column_text][vc_custom_heading text="<i>Food service until 9:00 pm</i>" font_container="tag:p|text_align:center|color:rgba(255%2C255%2C255%2C0.7)" use_theme_fonts="yes"][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-2-percent" column_padding_position="all" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid" delay="100"][vc_column_text]<strong>Friday - Saturday:</strong> 9:00 am – Midnight[/vc_column_text][vc_custom_heading text="<i>Food service until 10:00 pm</i>" font_container="tag:p|text_align:center|color:rgba(255%2C255%2C255%2C0.7)" use_theme_fonts="yes"][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-2-percent" column_padding_position="all" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid" delay="200"][vc_column_text]<strong>Sunday:</strong> 11:00 am – 10:00 pm[/vc_column_text][vc_custom_heading text="<i>Food service until 9:00 pm</i>" font_container="tag:p|text_align:center|color:rgba(255%2C255%2C255%2C0.7)" use_theme_fonts="yes"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="grow-in" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid" delay="300"][nectar_btn size="jumbo" open_new_tab="true" button_style="regular" button_color_2="Accent-Color" icon_family="none" url="http://opentable.com" text="Make A Reservation" margin_top="35"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]

CONTENT;

vc_add_default_templates( $data );






$data = array();
$data['name'] = esc_html__( 'Tour Schedule Dark', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['general'];
$data['custom_class'] = 'general date-03-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/dark-tour.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/concert.webp" bg_position="left top" bg_repeat="no-repeat" parallax_bg="true" parallax_bg_speed="fast" bg_color="#111111" scene_position="center" text_color="light" text_align="left" top_padding="10%" bottom_padding="10%" color_overlay="#0a0a0a" overlay_strength="0.95"][vc_column enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" centered_text="true" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1486348408362{margin-bottom: 90px !important;}"]
<h1>USA Tour</h1>
[/vc_column_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid"][nectar_horizontal_list_item columns="4" column_layout_using_4_columns="small_first_last" col_1_text_align="left" col_2_text_align="left" col_3_text_align="left" col_4_text_align="right" font_family="h6" hover_color="accent-color" col_1_content="May 24" col_2_content="Massey Hall" col_3_content="Toronto, ON" cta_1_text="Buy Tickets"][nectar_horizontal_list_item columns="4" column_layout_using_4_columns="small_first_last" col_1_text_align="left" col_2_text_align="left" col_3_text_align="left" col_4_text_align="right" font_family="h6" hover_color="accent-color" col_1_content="May 28" col_2_content="Electric Factory" col_3_content="Philadelphia, PA" cta_1_text="Buy Tickets"][nectar_horizontal_list_item columns="4" column_layout_using_4_columns="small_first_last" col_1_text_align="left" col_2_text_align="left" col_3_text_align="left" col_4_text_align="right" font_family="h6" hover_color="accent-color" col_1_content="June 12" col_2_content="Manhattan Center" col_3_content="New York, NY" cta_1_text="Buy Tickets" cta_1_url="#"][nectar_horizontal_list_item columns="4" column_layout_using_4_columns="small_first_last" col_1_text_align="left" col_2_text_align="left" col_3_text_align="left" col_4_text_align="right" font_family="h6" hover_color="accent-color" col_1_content="June 25" col_2_content="BB&amp;T Pavilion" col_3_content="Camden, NJ" cta_1_text="Buy Tickets" cta_1_url="#"][nectar_horizontal_list_item columns="4" column_layout_using_4_columns="small_first_last" col_1_text_align="left" col_2_text_align="left" col_3_text_align="left" col_4_text_align="right" font_family="h6" hover_color="accent-color" col_1_content="July 02" col_2_content="Aragon Ballroom" col_3_content="Chicago, IL" cta_1_text="Buy Tickets"][nectar_horizontal_list_item columns="4" column_layout_using_4_columns="small_first_last" col_1_text_align="left" col_2_text_align="left" col_3_text_align="left" col_4_text_align="right" font_family="h6" hover_color="accent-color" col_1_content="July 08" col_2_content="WaMu Theater" col_3_content="Seattle, WA" cta_1_text="Buy Tickets" cta_1_url="#"][nectar_horizontal_list_item columns="4" column_layout_using_4_columns="small_first_last" col_1_text_align="left" col_2_text_align="left" col_3_text_align="left" col_4_text_align="right" font_family="h6" hover_color="accent-color" col_1_content="July 15" col_2_content="Fox Theater" col_3_content="Oakland, CA" cta_1_text="Buy Tickets" cta_1_url="#"][nectar_horizontal_list_item columns="4" column_layout_using_4_columns="small_first_last" col_1_text_align="left" col_2_text_align="left" col_3_text_align="left" col_4_text_align="right" font_family="h6" hover_color="accent-color" col_1_content="July 21" col_2_content="Shrine Expo Hall" col_3_content="Los Angeles" cta_1_text="Buy Tickets"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]

CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Awesome Shape Divider Hero', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['hero_section'];
$data['custom_class'] = 'hero_section date-20-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/corporate-2-landing.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" scene_position="center" video_bg="use_video" video_mute="true" video_webm="" video_mp4="" video_external="https://www.youtube.com/watch?v=4BfKFCOCJe8" text_color="light" text_align="left" top_padding="12%" bottom_padding="7%" enable_gradient="true" color_overlay="#3452ff" color_overlay_2="#ff1053" gradient_direction="left_t_to_right_b" overlay_strength="0.8" enable_shape_divider="true" shape_divider_color="#ffffff" shape_divider_position="bottom" shape_divider_height="250" shape_type="curve"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/6" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][vc_column centered_text="true" column_padding="padding-1-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="2/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_column_text css_animation="fadeInUp" css=".vc_custom_1504325323751{margin-bottom: 15px !important;}"]
<h5>Have you noticed</h5>
[/vc_column_text][split_line_heading text_content="Small details create the big picture"][/split_line_heading][nectar_btn size="large" button_style="see-through-2" color_override="#ffffff" hover_color_override="#ffffff" hover_text_color_override="#000000" icon_family="none" url="#creative-services" text="Learn More" margin_top="25" css_animation="slideInUp" margin_bottom="85"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="padding-4-percent" column_padding_position="left-right" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" bottom_margin="-26%" width="1/1" column_border_width="none" column_border_style="solid"][nectar_video_lightbox link_style="play_button_2" nectar_play_button_color="Default-Accent-Color" image_url="https://themenectar.com/img/demo-media/unsplash/webp/800-500-fashion.webp" hover_effect="defaut" box_shadow="x_large_depth" border_radius="10px" play_button_size="larger" video_url="https://www.youtube.com/watch?v=i9NZfXRnA70"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/6" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][/vc_row]

CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Color Changing Client Rows', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['general'] .', '. $cat_display_names['about'];
$data['custom_class'] = 'general about date-20-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/clients-hover-color.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle"  bg_color="#ffffff" scene_position="center" text_color="dark" text_align="left" top_padding="7%" bottom_padding="7%" overlay_strength="0.3" shape_divider_position="bottom" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/12" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="10/12" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][clients columns="4" hover_effect="greyscale_to_color" additional_padding="4"][client image="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo.png" title="Client" id="1502894777216-0-4" tab_id="1502894621516-2" url="#" name="elevate"]  [/client][client image="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo.png" title="Client" id="1502894065-1-80" tab_id="1502894621516-3" url="#" name="harper"] [/client][client image="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo.png" title="Client" id="1502894782547-0-5" tab_id="1502894621516-4" url="#" name="waveform"] [/client][client image="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo.png" title="Client" id="1502894777848-0-9" tab_id="1502894621516-5" url="#" name="brooklyn"] [/client][client image="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo.png" title="Client" id="1502894784816-0-0" tab_id="1502894621516-9" url="#" name="camallero"][/client][client image="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo.png" title="Client" id="1503948180817-0-9" tab_id="1502894621516-6" url="#" name="ollostream"] [/client][client image="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo.png" title="Client" id="1503948181836-0-4" tab_id="1502894621516-7" url="#" name="golden grid"][/client][client image="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo.png" title="Client" id="1502894776482-0-6" tab_id="1502894621516-8" url="#" name="jacks"] [/client][/clients][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/12" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][/vc_row]

CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Delightful Service Blocks', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['services'];
$data['custom_class'] = 'services date-20-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/colorful-services.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" equal_height="yes" content_placement="middle" scene_position="center" text_color="dark" text_align="left" top_padding="5%" bottom_padding="5%" id="creative-services" overlay_strength="0.3" shape_divider_position="bottom" shape_type=""][vc_column column_padding="padding-2-percent" column_padding_position="right" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_column_text]
<h3>Striving to make the web a more beautiful place every single day</h3>
[/vc_column_text][vc_column_text css=".vc_custom_1504286255898{padding-right: 10% !important;}"]Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Aenean commodo ligula eget dolor. Aenean massa. Cum sociis natoque penatibus et magnis dis parturient montes.[/vc_column_text][nectar_btn size="large" button_style="see-through-2" color_override="#ff1053" hover_color_override="#ff1053" hover_text_color_override="#ffffff" icon_family="default_arrow" url="#explainer" text="Learn More" margin_top="15"][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="2/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="none" text_align="left"][vc_column_inner column_padding="padding-2-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/3" column_border_width="none" column_border_style="solid"][fancy_box box_style="color_box_basic" icon_family="iconsmind" box_color="#2ac4ea" content_color="#ffffff" box_color_opacity="0.6" box_alignment="left" enable_animation="true" animation="fade-in-from-bottom" color_scheme="none" secondary_content="here's some awesome text that would only be shown on hover" min_height="0" link_url="#http://google.com" icon_iconsmind="iconsmind-Environmental-3" css=".vc_custom_1504285427120{margin-top: 50px !important;margin-bottom: 2em !important;padding-top: 15% !important;padding-right: 15% !important;padding-bottom: 15% !important;padding-left: 15% !important;}" icon_size="40"]
<h4>Natural Flow</h4>
Sed cursus turpis vitae tortor donec eaque ipsa quaeab illo.[/fancy_box][fancy_box box_style="color_box_basic" icon_family="iconsmind" box_color_opacity="1" box_alignment="left" enable_animation="true" animation="fade-in-from-bottom" color_scheme="none" secondary_content="here's some awesome text that would only be shown on hover" min_height="0" link_url="#" icon_iconsmind="iconsmind-Sun" css=".vc_custom_1504285795178{margin-bottom: 50px !important;padding-top: 15% !important;padding-right: 15% !important;padding-bottom: 15% !important;padding-left: 15% !important;}" icon_size="40"]
<h4>Hot Looks</h4>
Nemo enim ipsam volup tatem quia vol uptas sit sunt in.[/fancy_box][/vc_column_inner][vc_column_inner column_padding="padding-2-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/3" column_border_width="none" column_border_style="solid"][fancy_box box_style="color_box_basic" icon_family="iconsmind" box_color="#ff1053" box_color_opacity="1" box_alignment="left" enable_animation="true" animation="fade-in-from-bottom" color_scheme="none" secondary_content="here's some awesome text that would only be shown on hover" min_height="0" link_url="#" icon_iconsmind="iconsmind-Rock-andRoll" css=".vc_custom_1504285430965{margin-bottom: 2em !important;padding-top: 15% !important;padding-right: 15% !important;padding-bottom: 15% !important;padding-left: 15% !important;}" delay="100" icon_size="40"]
<h4>Awesome Design</h4>
Nam libero tempore, cum soluta nobis placeat facere.[/fancy_box][fancy_box box_style="color_box_basic" icon_family="iconsmind" box_color="#fbbc05" box_color_opacity="1" box_alignment="left" enable_animation="true" animation="fade-in-from-bottom" color_scheme="none" secondary_content="here's some awesome text that would only be shown on hover" min_height="0" link_url="#" icon_iconsmind="iconsmind-Atom" delay="100" css=".vc_custom_1504286112774{padding-top: 15% !important;padding-right: 15% !important;padding-bottom: 15% !important;padding-left: 15% !important;}" icon_size="40"]
<h4>Unrivaled Quality</h4>
At vero eos et lorem accusamus et iusto ullam corporis.[/fancy_box][/vc_column_inner][vc_column_inner column_padding="padding-2-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/3" column_border_width="none" column_border_style="solid"][fancy_box box_style="color_box_basic" icon_family="iconsmind" box_color="#2f88d6" content_color="#ffffff" box_color_opacity="1" box_alignment="left" enable_animation="true" animation="fade-in-from-bottom" color_scheme="none" secondary_content="here's some awesome text that would only be shown on hover" min_height="0" link_url="#" icon_iconsmind="iconsmind-Motorcycle" css=".vc_custom_1504286068726{margin-top: 50px !important;margin-bottom: 2em !important;padding-top: 15% !important;padding-right: 15% !important;padding-bottom: 15% !important;padding-left: 15% !important;}" delay="200" icon_size="40"]
<h4>Visual Builder</h4>
Ipsum totam rem aperiam, eaque ipsa quae ab illo.[/fancy_box][fancy_box box_style="color_box_basic" icon_family="iconsmind" box_color="#34a853" box_color_opacity="1" box_alignment="left" enable_animation="true" animation="fade-in-from-bottom" color_scheme="none" secondary_content="here's some awesome text that would only be shown on hover" min_height="0" link_url="#" icon_iconsmind="iconsmind-Folder-Organizing" delay="200" css=".vc_custom_1504286089409{padding-top: 15% !important;padding-right: 15% !important;padding-bottom: 15% !important;padding-left: 15% !important;}" icon_size="40"]
<h4>Ton of Features</h4>
Incidunt ut labore et dolore magnam ali quam quaerat.[/fancy_box][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]

CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Quick FAQ & Overflowing Image', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['general'];
$data['custom_class'] = 'general date-20-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/quick-faq-and-image.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" equal_height="yes" content_placement="middle" scene_position="center" text_color="dark" text_align="left" top_padding="6%" bottom_padding="6%" id="explainer" overlay_strength="0.3" shape_divider_position="bottom" shape_type=""][vc_column column_padding="padding-2-percent" column_padding_position="right" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1505433788851{margin-bottom: 30px !important;}"]
<h3>Salient Studio changes the WordPress game forever.</h3>
[/vc_column_text][toggles style="minimal_small" accordion="true"][toggle color="Default" title="Over 200 Section Templates"][vc_column_text]Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Aenean commodo ligula eget dolor. Aenean massa. Cum sociis natoque.[/vc_column_text][/toggle][toggle color="Default" title="Available Directly in Page Builder"][vc_column_text]Malesuada fames ac turpis egestas. Ut non enim eleifend felis pretium feugiat. Vivamus quis mi.[/vc_column_text][/toggle][toggle color="Default" title="One Click Template Insert"][vc_column_text]Donec sodales sagittis magna. Sed consequat, leo eget bibendum sodales, augue velit cursus nunc, quis gravida magna mi a libero.[/vc_column_text][/toggle][/toggles][nectar_btn size="large" button_style="see-through-2" color_override="#3452ff" hover_text_color_override="#ffffff" icon_family="default_arrow" url="https://themenectar.com/demo/salient-corporate-2/about-us" text="Learn More" margin_top="35"][/vc_column][vc_column column_padding="padding-2-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="2/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][image_with_animation image_url="https://themenectar.com/img/demo-media/unsplash/webp/large-office.webp" alignment="" animation="Fade In From Right" border_radius="10px" box_shadow="x_large_depth" max_width="150%"][/vc_column][/vc_row]

CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Monotone Milestones', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['counters'];
$data['custom_class'] = 'counters date-20-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/minimal-milestones.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" scene_position="center" text_color="dark" text_align="left" top_padding="6%" bottom_padding="6%" overlay_strength="0.3" shape_divider_position="bottom" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/12" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][vc_column centered_text="true" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="5/6" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_column_text max_width="500"]
<h3>Helping people reclaim their time</h3>
[/vc_column_text][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="padding-4-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/3" column_border_width="none" column_border_style="solid"][milestone heading_inherit="h2" symbol_position="after" subject_padding="2%" color="Default" effect="count" symbol_alignment="Superscript" milestone_alignment="default" number="97" symbol="%" subject="Percent of users recommend us to friends and family" number_font_size="92" symbol_font_size="40"][/vc_column_inner][vc_column_inner column_padding="padding-4-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/3" column_border_width="none" column_border_style="solid"][milestone heading_inherit="h2" symbol_position="after" subject_padding="2%" color="Default" effect="count" symbol_alignment="Superscript" milestone_alignment="default" number="350" subject="Companies have shifted to using us recently" number_font_size="92" symbol="+" symbol_font_size="42"][/vc_column_inner][vc_column_inner column_padding="padding-4-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/3" column_border_width="none" column_border_style="solid"][milestone heading_inherit="h2" symbol_position="after" subject_padding="2%" color="Default" effect="count" symbol_alignment="Superscript" milestone_alignment="default" number="16" subject="We deliver so much more than the competition " number_font_size="92" symbol="x" symbol_font_size="40"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/12" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][/vc_row]

CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Auto Masonry Recent Posts', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['blog'];
$data['custom_class'] = 'blog date-19-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/auto-masonry-recent-posts.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" scene_position="center" text_color="dark" text_align="left" top_padding="6%" bottom_padding="6%" overlay_strength="0.3" shape_divider_position="bottom" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/1" column_border_width="none" column_border_style="solid"][vc_column_text max_width="500" css=".vc_custom_1503969123885{margin-bottom: 40px !important;}"]
<h3>Our Recent Writings</h3>
[/vc_column_text][/vc_column_inner][/vc_row_inner][nectar_blog layout="masonry-blog-fullwidth" blog_masonry_style="auto_meta_overlaid_spaced" auto_masonry_spacing="16px" category="all" load_in_animation="none" order="DESC" orderby="date" posts_per_page="3"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" bottom_margin="20" width="1/1" column_border_width="none" column_border_style="solid"][nectar_cta btn_style="material" heading_tag="h4" text_color="#34a853" link_type="regular" alignment="center" text="Like what you see?" link_text="See more posts" url="https://themenectar.com/demo/salient-corporate-2/news"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]

CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Rounded Box Over Shape Divider', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['cta'];
$data['custom_class'] = 'cta date-20-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/color-box-cta.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_color="#f2f2f2" scene_position="center" text_color="dark" text_align="left" top_padding="60" overlay_strength="0.3" enable_shape_divider="true" shape_divider_color="#ffffff" shape_divider_position="top" shape_divider_height="80" shape_type="curve"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" font_color="#ffffff" column_shadow="none" column_border_radius="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" translate_y="-50%"][vc_row_inner column_margin="default" translate_y="-50%" text_align="left"][vc_column_inner enable_animation="true" animation="flip-in-vertical" column_padding="padding-5-percent" column_padding_position="all" centered_text="true" background_color="#ff1053" background_color_opacity="1" background_hover_color_opacity="1" font_color="#ffffff" column_shadow="x_large_depth" column_border_radius="20px" top_margin="15" width="1/1" column_border_width="none" column_border_style="solid"][divider line_type="No Line" custom_height="15"][vc_custom_heading text="Build your dream website today." font_container="tag:h3|text_align:center" google_fonts="font_family:Nunito%3A300%2Cregular%2C700|font_style:700%20bold%20regular%3A700%3Anormal"][nectar_btn size="large" open_new_tab="true" button_style="see-through-2" color_override="#ffffff" hover_color_override="#ffffff" hover_text_color_override="#000000" icon_family="none" url="https://themeforest.net/item/salient-responsive-multipurpose-theme/4363266" text="Purchase Salient" margin_top="30" margin_bottom="1"][divider line_type="No Line" custom_height="15"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]

CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Impactful Header Text', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['general'] .', '. $cat_display_names['hero_section'];
$data['custom_class'] = 'general hero_section';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/impactful-header.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_color="#ffffff" scene_position="center" text_color="dark" text_align="left" top_padding="8%" bottom_padding="10%" overlay_strength="0.3" shape_divider_position="bottom" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/6" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][vc_column centered_text="true" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="2/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/1" column_border_width="none" column_border_style="solid"][nectar_gradient_text heading_tag="h5" color="extra-color-gradient-2" gradient_direction="horizontal" text="Together We Build Dreams"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/1" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1504326206457{margin-bottom: 20px !important;}"]
<h2>A wonderful serenity <strong>has</strong> <strong>taken possession</strong> of my entire soul, like these sweet mornings of spring which I enjoy with my <strong>whole heart</strong>.</h2>
[/vc_column_text][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/6" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][/vc_row]

CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Testimonial Popout', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['testimonials'];
$data['custom_class'] = 'testimonials date-20-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/testimonial-popout.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="in_container" full_screen_row_position="middle" scene_position="center" text_color="dark" text_align="left" overlay_strength="0.3" shape_divider_position="bottom"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][divider line_type="No Line" custom_height="250"][/vc_column][/vc_row][vc_row type="in_container" full_screen_row_position="middle" equal_height="yes" content_placement="bottom" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-room.webp" bg_position="center center" bg_repeat="no-repeat" parallax_bg="true" parallax_bg_speed="fast" scene_position="center" text_color="light" text_align="left" enable_gradient="true" color_overlay_2="rgba(10,10,10,0.87)" gradient_direction="left_t_to_right_b" overlay_strength="0.5" shape_divider_position="bottom" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" translate_y="-50%" translate_x="-17%" text_align="left"][vc_column_inner column_padding="padding-17-percent" column_padding_position="all" background_color="#ff3366" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/1" column_border_width="none" column_border_style="solid"][nectar_single_testimonial testimonial_style="small_modern" image="https://themenectar.com/img/demo-media/unsplash/webp/small-smile-guy.webp" color="Default" quote="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean. " name="Jessie Cohen" subtitle="Web Developer"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="padding-6-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="right"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/1" column_border_width="none" column_border_style="solid"][nectar_btn size="large" button_style="see-through" button_color_2="Accent-Color" color_override="#ffffff" icon_family="none" url="#team" text="Meet The Team"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]

CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Team Overlapping Section Below', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['team'];
$data['custom_class'] = 'team date-20-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/team-overlap-milestones.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" scene_position="center" text_color="dark" text_align="left" top_padding="8%" overlay_strength="0.3" shape_divider_position="bottom" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" bottom_margin="-6%" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" bottom_padding="60" text_align="left" el_id="team"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/1" column_border_width="none" column_border_style="solid"][vc_custom_heading text="Say hello to your team" font_container="tag:h3|text_align:center" use_theme_fonts="yes"][divider line_type="Small Line" line_thickness="2" divider_color="accent-color" animate="yes" custom_height="40" custom_line_width="40"][vc_column_text max_width="650"]Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec quis nisi vel dui porttitor volutpat. Curabitur vel maximus mauris. Sed in dictum sem.[/vc_column_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="grow-in" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="x_large_depth" column_border_radius="10px" width="1/3" column_border_width="none" column_border_style="solid"][team_member image_url="https://themenectar.com/img/demo-media/unsplash/webp/team-member-1-small-cropped.webp" bio_image_url="https://themenectar.com/img/demo-media/unsplash/webp/team-member-full-silhouette.webp" team_memeber_style="bio_fullscreen" name="Claire Kozlov" job_position="Graphic Designer" team_member_bio="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean. A small river named Duden flows by their place and supplies it with the necessary regelialia. It is a paradisematic country, in which roasted parts of sentences fly into your mouth. " social_icon_1="fa fa-facebook" social_link_1="# " social_icon_2="fa fa-twitter" social_link_2="# " social_icon_3="fa fa-instagram" social_link_3="# "][/vc_column_inner][vc_column_inner enable_animation="true" animation="grow-in" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="x_large_depth" column_border_radius="10px" width="1/3" column_border_width="none" column_border_style="solid" delay="100"][team_member image_url="https://themenectar.com/img/demo-media/unsplash/webp/team-member-2-small-cropped.webp" bio_image_url="https://themenectar.com/img/demo-media/unsplash/webp/team-member-full-silhouette.webp" team_memeber_style="bio_fullscreen" name="Mark Jones" job_position="Back-end Developer" team_member_bio="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean. A small river named Duden flows by their place and supplies it with the necessary regelialia. It is a paradisematic country, in which roasted parts of sentences fly into your mouth. " social_icon_1="fa fa-github-alt" social_icon_2="fa fa-instagram" social_icon_3="fa fa-facebook"][/vc_column_inner][vc_column_inner enable_animation="true" animation="grow-in" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="x_large_depth" column_border_radius="10px" width="1/3" column_border_width="none" column_border_style="solid" delay="200"][team_member image_url="https://themenectar.com/img/demo-media/unsplash/webp/team-member-3-small-cropped.webp" bio_image_url="https://themenectar.com/img/demo-media/unsplash/webp/team-member-full-silhouette.webp" team_memeber_style="bio_fullscreen" name="Andrea Smith" job_position="Fine Artist" team_member_bio="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean. A small river named Duden flows by their place and supplies it with the necessary regelialia. It is a paradisematic country, in which roasted parts of sentences fly into your mouth. " social_icon_1="fa fa-dribbble" social_link_1="# " social_icon_2="fa fa-deviantart" social_link_2="# " social_icon_3="fa fa-instagram" social_link_3="# "][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="grow-in" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="x_large_depth" column_border_radius="10px" width="1/3" column_border_width="none" column_border_style="solid"][team_member image_url="https://themenectar.com/img/demo-media/unsplash/webp/team-member-4-small-cropped.webp" bio_image_url="https://themenectar.com/img/demo-media/unsplash/webp/team-member-full-silhouette.webp" team_memeber_style="bio_fullscreen" name="Ethan Young" job_position="Team Leader" team_member_bio="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean. A small river named Duden flows by their place and supplies it with the necessary regelialia. It is a paradisematic country, in which roasted parts of sentences fly into your mouth. " social_icon_1="fa fa-facebook" social_link_1="#" social_icon_2="fa fa-instagram" social_link_2="#" social_icon_3="fa fa-linkedin" social_link_3="#"][/vc_column_inner][vc_column_inner enable_animation="true" animation="grow-in" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="x_large_depth" column_border_radius="10px" width="1/3" column_border_width="none" column_border_style="solid" delay="100"][team_member image_url="https://themenectar.com/img/demo-media/unsplash/webp/team-member-5-small-cropped.webp" bio_image_url="https://themenectar.com/img/demo-media/unsplash/webp/team-member-full-silhouette.webp" team_memeber_style="bio_fullscreen" name="Ava Morgan" job_position="The SEO Expert" team_member_bio="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean. A small river named Duden flows by their place and supplies it with the necessary regelialia. It is a paradisematic country, in which roasted parts of sentences fly into your mouth. " social_icon_1="fa fa-instagram" social_link_1="#" social_icon_2="fa fa-twitter" social_link_2="#"][/vc_column_inner][vc_column_inner enable_animation="true" animation="grow-in" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="x_large_depth" column_border_radius="10px" width="1/3" column_border_width="none" column_border_style="solid" delay="200"][team_member image_url="https://themenectar.com/img/demo-media/unsplash/webp/team-member-6-small-cropped.webp" bio_image_url="https://themenectar.com/img/demo-media/unsplash/webp/team-member-full-silhouette.webp" team_memeber_style="bio_fullscreen" name="James Anderson" job_position="Front-end Developer" team_member_bio="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean. A small river named Duden flows by their place and supplies it with the necessary regelialia. It is a paradisematic country, in which roasted parts of sentences fly into your mouth. " social_icon_1="fa fa-twitter" social_link_1="#" social_icon_2="fa fa-youtube-play" social_link_2="#"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row][vc_row type="full_width_background" full_screen_row_position="middle" bg_image="7094" background_image_mobile_hidden="true" bg_position="center top" bg_repeat="no-repeat" parallax_bg="true" parallax_bg_speed="fast" scene_position="center" text_color="light" text_align="left" top_padding="18%" bottom_padding="13%" enable_gradient="true" color_overlay="#3452ff" color_overlay_2="#ff1053" gradient_direction="left_t_to_right_b" overlay_strength="0.8" shape_divider_color="#ffffff" shape_divider_position="bottom" shape_divider_height="250" shape_type="curve_opacity"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/4" column_border_width="none" column_border_style="solid"][vc_custom_heading text="Percent Increase" font_container="tag:h5|text_align:center|color:rgba(255%2C255%2C255%2C0.63)" use_theme_fonts="yes" css=".vc_custom_1504326242419{margin-bottom: 10px !important;}"][milestone heading_inherit="h5" subject_padding="2%" color="Default" effect="count" milestone_alignment="default" number="87" number_font_size="92"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/4" column_border_width="none" column_border_style="solid"][vc_custom_heading text="Referrals " font_container="tag:h5|text_align:center|color:rgba(255%2C255%2C255%2C0.63)" use_theme_fonts="yes" css=".vc_custom_1504290730551{margin-bottom: 10px !important;}"][milestone heading_inherit="h5" symbol_position="after" subject_padding="2%" color="Default" effect="count" symbol_alignment="Superscript" milestone_alignment="default" number="479" symbol="+" number_font_size="92" symbol_font_size="40"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/4" column_border_width="none" column_border_style="solid"][vc_custom_heading text="New Accounts" font_container="tag:h5|text_align:center|color:rgba(255%2C255%2C255%2C0.63)" use_theme_fonts="yes" css=".vc_custom_1504288841908{margin-bottom: 10px !important;}"][milestone heading_inherit="h5" subject_padding="2%" color="Default" effect="count" milestone_alignment="default" number="247" number_font_size="92"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/4" column_border_width="none" column_border_style="solid"][vc_custom_heading text="Subscribers" font_container="tag:h5|text_align:center|color:rgba(255%2C255%2C255%2C0.63)" use_theme_fonts="yes" css=".vc_custom_1504290761477{margin-bottom: 10px !important;}"][milestone heading_inherit="h5" symbol_position="after" subject_padding="2%" color="Default" effect="count" symbol_alignment="Superscript" milestone_alignment="default" number="13" number_font_size="92" symbol="k" symbol_font_size="40"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]

CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Overflowing Testimonials & Text Snippet', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['testimonials'];
$data['custom_class'] = 'testimonials date-20-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/testimonial-carousel-with-text.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="in_container" full_screen_row_position="middle" scene_position="center" text_color="dark" text_align="left" top_padding="7%" bottom_padding="7%" id="testimonials" overlay_strength="0.3" shape_divider_position="bottom" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" top_margin="30" bottom_margin="30" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][carousel script="flickity" flickity_formatting="fixed_text_content_fullwidth" flickity_fixed_content="
<h4>What they've said about us</h4>
lorem ipsum dolor set amet et it lorem ipsum dolor set amet et it" button_color="Accent-Color" desktop_cols_flickity="3" desktop_small_cols_flickity="2" tablet_cols_flickity="1" column_padding="50px" autorotate="true" column_color="#ffffff" border_radius="10px" enable_column_border="true" cta_button_text="Contact Us" cta_button_url="#" autorotation_speed="7000"][item id="1504038498-1-94" tab_id="1504038676473-4" title="Item"][nectar_single_testimonial testimonial_style="basic" image="https://themenectar.com/img/demo-media/unsplash/webp/small-smile-guy.webp" quote="I've learned that people will forget what you said, people will forget what you did, but people will never forget how you made them feel." name="Ray Jackson" subtitle="Structural Engineer "][/item][item id="1504055252242-0-2" tab_id="1504038676473-4" title="Item"][nectar_single_testimonial testimonial_style="basic" image="https://themenectar.com/img/demo-media/unsplash/webp/small-smile-guy-2.webp" quote="Science is fun. Science is curiosity. We all have natural curiosity. Science is a process of investigating. It's posing questions and coming up with a method. It's delving in." name="Sam Murray " subtitle="Lead Architect"][/item][item id="1504038498-2-81" tab_id="1504038676738-8" title="Item"][nectar_single_testimonial testimonial_style="basic" image="https://themenectar.com/img/demo-media/unsplash/webp/small-smile.webp" quote="I feel confident imposing change on myself. It's a lot more fun progressing than looking back. That's why I need to throw curve balls." name="Jake Smith" subtitle="Salient Corp"][/item][item id="1504038498-3-53" tab_id="1504038677047-7" title="Item"][nectar_single_testimonial testimonial_style="basic" image="https://themenectar.com/img/demo-media/unsplash/webp/small-smile-guy-2.webp" quote="Our task must be to free ourselves by widening our circle of compassion to embrace all living creatures and the whole of nature and its beauty." name="Alice Johnson" subtitle="Writer at ThemeNectar"][/item][/carousel][/vc_column][/vc_row]

CONTENT;

vc_add_default_templates( $data );





$data = array();
$data['name'] = esc_html__( 'Info/Contact Box Overlapping Map', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['general'];
$data['custom_class'] = 'general date-20-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/contact-box-overlaying-map.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_image="5715" bg_position="center center" bg_repeat="no-repeat" scene_position="center" text_color="dark" text_align="left" top_padding="14%" zindex="100" enable_gradient="true" color_overlay="rgba(52,82,255,0.93)" color_overlay_2="rgba(255,16,83,0.92)" gradient_direction="left_t_to_right_b" overlay_strength="0.95" shape_divider_position="bottom" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/6" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="2/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" bottom_padding="7%" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" font_color="#ffffff" column_shadow="none" column_border_radius="none" width="1/1" column_border_width="none" column_border_style="solid"][vc_column_text]
<h5>Available booking space</h5>
<h2>Have a project in mind?</h2>
[/vc_column_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="grow-in" column_padding="padding-6-percent" column_padding_position="all" background_color="#ffffff" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="x_large_depth" column_border_radius="10px" bottom_margin="-25%" width="1/1" column_border_width="none" column_border_style="solid"][vc_column_text]
<h5 style="text-align:center;">Check this out.</h5>
<h2 style="text-align:center;">This area is where <br/> your text or contact<br/> form can go.</h2>
[/vc_column_text][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/6" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][/vc_row][vc_row type="full_width_content" full_screen_row_position="middle" scene_position="center" text_color="dark" text_align="left" overlay_strength="0.3" shape_divider_position="bottom" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][nectar_gmap zoom="14" enable_zoom="1" marker_style="nectar" nectar_marker_color="accent-color" map_greyscale="1" ultra_flat="1" size="650" map_center_lat="39.955" map_center_lng="-75.171" map_markers="39.949|-75.171|Our Location "][/vc_column][/vc_row]

CONTENT;

vc_add_default_templates( $data );





$data = array();
$data['name'] = esc_html__( 'Simple Client Carousel', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['general'];
$data['custom_class'] = 'general';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/clients-carousel.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_color="#ffffff" scene_position="center" text_color="dark" text_align="left" top_padding="7%" bottom_padding="7%" overlay_strength="0.3" shape_divider_position="bottom" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][clients columns="6" hover_effect="opacity" additional_padding="4" carousel="true"][client image="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo.png" title="Client" id="1502894621516-25bfe-029b" url="#" name="elevate" tab_id="1507130915658-5"]  [/client][client image="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo.png" title="Client" id="1502894621516-35bfe-029b" url="#" name="harper" tab_id="1507130915688-2"] [/client][client image="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo.png" title="Client" id="1502894621516-45bfe-029b" url="#" name="waveform" tab_id="1507130915722-3"] [/client][client image="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo.png" title="Client" id="1502894621516-55bfe-029b" url="#" name="brooklyn" tab_id="1507130915763-3"] [/client][client image="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo.png" title="Client" id="1502894621516-95bfe-029b" url="#" name="camallero" tab_id="1507130915805-3"][/client][client image="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo.png" title="Client" id="1502894621516-65bfe-029b" url="#" name="ollostream" tab_id="1507130915846-4"] [/client][client image="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo.png" title="Client" id="1502894621516-75bfe-029b" url="#" name="golden grid" tab_id="1507130915873-4"][/client][client image="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo.png" title="Client" id="1502894621516-85bfe-029b" url="#" name="jacks" tab_id="1507130915901-6"] [/client][/clients][/vc_column][/vc_row]

CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Shape Divider Hero Solid Color', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['hero_section'];
$data['custom_class'] = 'hero_section date-07-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/blue-hero-shape-divider.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#3452ff" scene_position="center" top_padding="13%" bottom_padding="19%" text_color="light" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" color_overlay="rgba(52,82,255,0.94)" overlay_strength="0.95" gradient_direction="left_to_right" enable_shape_divider="true" shape_divider_position="bottom" shape_divider_height="350" bg_image_animation="none" shape_type="mountains"][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/6" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][/vc_column][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="2/3" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][split_line_heading animation_type="line-reveal-by-space" font_style="h1" line_reveal_by_space_text_effect="default" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="WordPress Design as it should be"][/split_line_heading][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/6" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" delay="200"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="2/3" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_custom_heading text="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts The Big Oxmox advised her." font_container="tag:h4|font_size:20|text_align:center|color:rgba(255%2C255%2C255%2C0.7)|line_height:36px" google_fonts="font_family:Roboto%3A100%2C100italic%2C300%2C300italic%2Cregular%2Citalic%2C500%2C500italic%2C700%2C700italic%2C900%2C900italic|font_style:500%20bold%20regular%3A500%3Anormal" css=".vc_custom_1507135671940{padding-right: 5% !important;padding-left: 5% !important;}"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/6" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="grow-in" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][nectar_btn size="jumbo" button_style="see-through-2" color_override="#ffffff" hover_color_override="#ffffff" hover_text_color_override="#000000" icon_family="none" url="#discover" text="Discover More" margin_top="40"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_spacing="default" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/6" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][/vc_column][/vc_row]

CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Image And Text With Dark Image BG', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['general'];
$data['custom_class'] = 'general';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/image-and-text-btn.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" equal_height="yes" content_placement="middle" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-adventure.webp" bg_position="left top" bg_repeat="no-repeat" scene_position="center" text_color="light" text_align="left" top_padding="8%" bottom_padding="8%" color_overlay="#0a0a0a" overlay_strength="0.8" shape_divider_position="bottom" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="5/12" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" offset="vc_col-xs-12"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/1" column_border_width="none" column_border_style="solid"][vc_column_text css_animation="none" css=".vc_custom_1487084437567{margin-top: 20px !important;margin-bottom: 5px !important;}"]
<h5>Salient Powered</h5>
[/vc_column_text][vc_custom_heading text=" it's easy to feel the charm of existence in this spot." use_theme_fonts="yes" css_animation="none"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/1" column_border_width="none" column_border_style="solid" delay="50"][vc_custom_heading text="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, they live." font_container="tag:p|text_align:left|color:rgba(255%2C255%2C255%2C0.75)" use_theme_fonts="yes" css_animation="none"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/1" column_border_width="none" column_border_style="solid"][nectar_btn size="large" button_style="regular" button_color_2="Accent-Color" icon_family="default_arrow" url="#" text="Learn More" margin_top="25"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/12" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" offset="vc_col-xs-12"][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" offset="vc_col-xs-12"][image_with_animation image_url="https://themenectar.com/img/demo-media/unsplash/webp/800-500-room.webp" alignment="" animation="Grow In" border_radius="10px" box_shadow="large_depth" max_width="100%"][/vc_column][/vc_row]

CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Pricing Table 4 Column Dark', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['pricing'];
$data['custom_class'] = 'pricing date-10-Aug-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/4-col-pricing.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-adventure.webp" bg_position="left top" bg_repeat="no-repeat" scene_position="center" text_color="light" text_align="left" top_padding="7%" bottom_padding="7%" color_overlay="#232323" overlay_strength="0.8" shape_divider_position="bottom" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/4" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][fancy_box box_style="color_box_hover" icon_family="none" image_url="https://themenectar.com/img/demo-media/unsplash/webp/large-clouds.webp" color="Extra-Color-1" box_alignment="center" min_height="400"]
<h5>Try It Now</h5>
<h2>$5.99</h2>
Get a free domain name and custom cookies delivered to your door every month.

&nbsp;

[nectar_cta btn_style="see-through" heading_tag="h5" link_type="regular" alignment="center" link_text="Purchase now"][/fancy_box][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/4" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][fancy_box box_style="color_box_hover" icon_family="none" image_url="https://themenectar.com/img/demo-media/unsplash/webp/large-fashion.webp" color="Extra-Color-1" box_alignment="center" min_height="400"]
<h5>Most Popular</h5>
<h2>$9.99</h2>
Get a free domain name and 24/7 customer support &amp; month of free bandwidth.

&nbsp;

[nectar_cta btn_style="see-through" heading_tag="h5" link_type="regular" alignment="center" link_text="Purchase now"][/fancy_box][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/4" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][fancy_box box_style="color_box_hover" icon_family="none" image_url="https://themenectar.com/img/demo-media/unsplash/webp/large-mountain.webp" color="Extra-Color-1" box_alignment="center" min_height="400"]
<h5>Good Value</h5>
<h2>$19.99</h2>
Get a free domain name and 24/7 customer support &amp; design consultation &amp; premium support

&nbsp;

[nectar_cta btn_style="see-through" heading_tag="h5" link_type="regular" alignment="center" link_text="Purchase now"][/fancy_box][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/4" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][fancy_box box_style="color_box_hover" icon_family="none" image_url="https://themenectar.com/img/demo-media/unsplash/webp/large-sunflowers.webp" color="Extra-Color-1" box_alignment="center" min_height="400"]
<h5>Ultimate</h5>
<h2>$49.99</h2>
Everything the other plans have plus an annual subscription to nectar magazine

&nbsp;

[nectar_cta btn_style="see-through" heading_tag="h5" link_type="regular" alignment="center" link_text="Purchase now"][/fancy_box][/vc_column][/vc_row]

CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'FAQ Toggles And Image', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['general'];
$data['custom_class'] = 'general date-01-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/faq-and-img.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" equal_height="yes" content_placement="middle" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-clouds.webp" bg_position="center center" bg_repeat="no-repeat" parallax_bg="true" parallax_bg_speed="fast" bg_color="#1c1c1c" scene_position="center" text_color="light" text_align="left" top_padding="7%" bottom_padding="7%" color_overlay="#1e1e1e" overlay_strength="0.8" shape_divider_position="bottom" shape_type=""][vc_column column_padding="padding-2-percent" column_padding_position="right" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1505433788851{margin-bottom: 30px !important;}"]
<h3>Salient Studio changes the WordPress game forever.</h3>
[/vc_column_text][toggles style="minimal_small" accordion="true"][toggle color="Default" title="Over 200 Section Templates"][vc_column_text]Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Aenean commodo ligula eget dolor. Aenean massa. Cum sociis natoque.[/vc_column_text][/toggle][toggle color="Default" title="Available Directly in Page Builder"][vc_column_text]Malesuada fames ac turpis egestas. Ut non enim eleifend felis pretium feugiat. Vivamus quis mi.[/vc_column_text][/toggle][toggle color="Default" title="One Click Template Insert"][vc_column_text]Donec sodales sagittis magna. Sed consequat, leo eget bibendum sodales, augue velit cursus nunc, quis gravida magna mi a libero.[/vc_column_text][/toggle][/toggles][nectar_btn size="large" button_style="regular" button_color_2="Accent-Color" icon_family="default_arrow" url="" text="Learn More" margin_top="40"][/vc_column][vc_column column_padding="padding-2-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="2/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][image_with_animation image_url="https://themenectar.com/img/demo-media/unsplash/webp/large-clouds.webp" alignment="" animation="Fade In From Right" border_radius="10px" box_shadow="x_large_depth" max_width="100%"][/vc_column][/vc_row]

CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Huge Image Transition Hero', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['hero_section'];
$data['custom_class'] = 'hero_section date-03-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/image-trans.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-music.webp" bg_position="center top" bg_repeat="no-repeat" parallax_bg="true" parallax_bg_speed="fast" scene_position="center" text_color="light" text_align="left" top_padding="16%" bottom_padding="16%" id="intro" row_name="Intro" enable_gradient="true" color_overlay="rgba(16,16,16,0.2)" color_overlay_2="#101010" gradient_direction="top_to_bottom" overlay_strength="image_trans"][vc_column centered_text="true" column_padding="padding-6-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid"][vc_custom_heading text="Salient" font_container="tag:h1|font_size:103|text_align:center|color:%23ffffff|line_height:116px" use_theme_fonts="yes"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="grow-in" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid" delay="200"][nectar_btn size="large" button_style="see-through-3" color_override="#3452ff" hover_color_override="#3452ff" hover_text_color_override="#ffffff" icon_family="iconsmind" url="#" text="View Tour Dates" icon_iconsmind="iconsmind-Triangle-ArrowRight"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row][vc_row type="full_width_background" full_screen_row_position="middle" bg_color="#101010" scene_position="center" text_color="light" text_align="left" top_padding="7%" bottom_padding="7%" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/4" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][vc_column centered_text="true" column_padding="padding-4-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid"][vc_custom_heading text="THE STORY" font_container="tag:h5|font_size:14|text_align:center|color:%233452ff|line_height:24px" google_fonts="font_family:Roboto%3A100%2C100italic%2C300%2C300italic%2Cregular%2Citalic%2C500%2C500italic%2C700%2C700italic%2C900%2C900italic|font_style:700%20bold%20regular%3A700%3Anormal"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid" delay="50"][vc_column_text css=".vc_custom_1486330423766{margin-top: -8px !important;margin-bottom: -8px !important;}"]
<h3>An American progressive band from Washington, D.C</h3>
[/vc_column_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid" delay="100"][vc_column_text]A small river named Duden flows by their place and supplies it with the necessary regelialia. It is a paradisematic country, in which roasted parts of sentences fly into your mouth.[/vc_column_text][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/4" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Music Video Lightbox Link', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['general'];
$data['custom_class'] = 'general date-03-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/band-video.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/concert.webp" bg_position="center center" bg_repeat="no-repeat" scene_position="center" text_color="light" text_align="left" top_padding="15%" bottom_padding="15%" color_overlay="#3452ff" overlay_strength="0.8" shape_divider_position="bottom" bg_image_animation="none" parallax_bg="true" parallax_bg_speed="fast"][vc_column centered_text="true" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][vc_column_text css=".vc_custom_1486347995892{margin-bottom: -10px !important;}"]
<h5>Look Inside</h5>
[/vc_column_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][vc_column_text css=".vc_custom_1486348233904{margin-bottom: 10px !important;}"]
<h3>Live Concert Promo</h3>
[/vc_column_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="grow-in"][nectar_video_lightbox link_style="play_button" video_url="https://www.youtube.com/watch?v=6oTurM7gESE"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Layout Text Block Dark', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['general'];
$data['custom_class'] = 'general date-03-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/dark-text-block.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_color="#101010" scene_position="center" text_color="light" text_align="left" top_padding="7%" bottom_padding="7%" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/4" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][vc_column centered_text="true" column_padding="padding-4-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid"][vc_custom_heading text="THE STORY" font_container="tag:h5|font_size:14|text_align:center|color:%233452ff|line_height:24px" google_fonts="font_family:Roboto%3A100%2C100italic%2C300%2C300italic%2Cregular%2Citalic%2C500%2C500italic%2C700%2C700italic%2C900%2C900italic|font_style:900%20bold%20regular%3A900%3Anormal"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid" delay="50"][vc_column_text css=".vc_custom_1486330423766{margin-top: -8px !important;margin-bottom: -8px !important;}"]
<h3>An American progressive band from Washington, D.C</h3>
[/vc_column_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid" delay="100"][vc_custom_heading text="A small river named Duden flows by their place and supplies it with the necessary regelialia. It is a paradisematic country, in which roasted parts of sentences fly into your mouth." font_container="tag:p|text_align:center|color:rgba(255%2C255%2C255%2C0.69)" use_theme_fonts="yes"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/4" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Minimal Pricing Table', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['pricing'];
$data['custom_class'] = 'pricing';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/minimal_pricing.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" scene_position="center" text_color="dark" text_align="left" top_padding="4%" bottom_padding="7%" overlay_strength="0.3"][vc_column column_padding="padding-1-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" width="1/1" tablet_text_alignment="default" phone_text_alignment="default"][pricing_table style="flat-alternative" columns="3"][pricing_column color="Extra-Color-1" title="Free" price="0.00" currency_symbol="$" interval="Per Month" id="1435950853864-5" tab_id="1435950853865-3"]<ul class="features"><li>[icon color="Extra-Color-1" size="tiny" image="fa-check"] Custom Domain</li><li><del>[icon color="Extra-Color-1" size="tiny" image="fa-check"] 24/7 Customer Support</del></li><li><del>[icon color="Extra-Color-1" size="tiny" image="fa-check"] Month Of Free Bandwidth</del></li><li><del>[icon color="Extra-Color-1" size="tiny" image="fa-check"] Free WordPress Setup</del></li><li><del>[icon color="Extra-Color-1" size="tiny" image="fa-check"] Cake Delivered Daily</del></li></ul>[button color="see-through" hover_text_color_override="#fff" size="large" url="#" text="Get Free" color_override="#3a6ee8" image="default-arrow"][/pricing_column][pricing_column color="Extra-Color-2" title="Plus" price="7.99" currency_symbol="$" interval="Per Month" id="1435950853864-2" tab_id="1435950853865-2"]<ul class="features"><li>[icon color="Extra-Color-2" size="tiny" image="fa-check"] Custom Domain</li><li>[icon color="Extra-Color-2" size="tiny" image="fa-check"] 24/7 Customer Support</li><li>[icon color="Extra-Color-2" size="tiny" image="fa-check"] Month Of Free Bandwidth</li><li><del>[icon color="Extra-Color-2" size="tiny" image="fa-check"] Free WordPress Setup</del></li><li><del>[icon color="Extra-Color-2" size="tiny" image="fa-check"] Cake Delivered Daily</del></li></ul>[button color="see-through" hover_text_color_override="#fff" size="large" url="#" text="Sign Up Now" color_override="#fd0025" image="default-arrow"][/pricing_column][pricing_column highlight="true" color="Accent-Color" title="Premium" highlight_reason="Recommended" price="19.99" currency_symbol="$" interval="Per Month" id="1435950853953-5" tab_id="1435950853954-0"]<ul class="features"><li>[icon color="Accent-Color" size="tiny" image="fa-check"] Custom Domain</li><li>[icon color="Accent-Color" size="tiny" image="fa-check"] 24/7 Customer Support</li><li>[icon color="Accent-Color" size="tiny" image="fa-check"] Month Of Free Bandwidth</li><li>[icon color="Accent-Color" size="tiny" image="fa-check"] Free WordPress Setup</li><li>[icon color="Accent-Color" size="tiny" image="fa-check"] Cake Delivered Daily</li></ul>[button size="large" url="#" text="Sign Up Now" color="Accent-Color" image="default-arrow"][/pricing_column][/pricing_table][/vc_column][/vc_row][vc_row type="full_width_background" full_screen_row_position="middle" scene_position="center" text_color="dark" text_align="left" bottom_padding="4%" overlay_strength="0.3"][vc_column column_padding="padding-1-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" width="1/2" tablet_text_alignment="default" phone_text_alignment="default"][vc_column_text]<h4>Are there more plans?</h4>[/vc_column_text][divider line_type="No Line" custom_height="15"][vc_column_text]Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec porta, mi ut facilisis ullamcorper, magna risus vehicula augue, eget faucibus magna massa at justo. Nulla a arcu ut massa hendrerit.[/vc_column_text][/vc_column][vc_column column_padding="padding-1-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" width="1/2" tablet_text_alignment="default" phone_text_alignment="default"][vc_column_text]<h4>Plan Discounts</h4>[/vc_column_text][divider line_type="No Line" custom_height="15"][vc_column_text]Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec porta, mi ut facilisis ullamcorper, magna risus vehicula augue, eget faucibus magna massa at justo. Nulla a arcu ut massa hendrerit[/vc_column_text][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );

$data = array();
$data['name'] = esc_html__( 'Team Members Full Width Meta Overlaid', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['team'] .', '. $cat_display_names['about'];
$data['custom_class'] = 'team about';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/about-meta-overlaid.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" bg_color="#ffffff" scene_position="center" text_color="dark" text_align="left" overlay_strength="0.3"][vc_column column_padding="padding-1-percent" column_padding_position="left-right" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="padding-1-percent" column_padding_position="all" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid"][team_member team_memeber_style="meta_overlaid_alt" name="Jake Graham" image_url="https://themenectar.com/img/demo-media/unsplash/webp/team-member-1-small-cropped.webp" job_position="Founder"][/vc_column_inner][vc_column_inner column_padding="padding-1-percent" column_padding_position="all" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid"][team_member team_memeber_style="meta_overlaid_alt" image_url="https://themenectar.com/img/demo-media/unsplash/webp/team-member-2-small-cropped.webp" name="Aura Brooks" job_position="Graphic Designer"][/vc_column_inner][vc_column_inner column_padding="padding-1-percent" column_padding_position="all" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid"][team_member team_memeber_style="meta_overlaid_alt" image_url="https://themenectar.com/img/demo-media/unsplash/webp/team-member-3-small-cropped.webp" name="Eve Crawford" job_position="Product Designer"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" bottom_padding="1%" text_align="left"][vc_column_inner column_padding="padding-1-percent" column_padding_position="all" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid"][team_member team_memeber_style="meta_overlaid_alt" image_url="https://themenectar.com/img/demo-media/unsplash/webp/team-member-3-small-cropped.webp" name="Alex Parker" job_position="Founder"][/vc_column_inner][vc_column_inner column_padding="padding-1-percent" column_padding_position="all" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid"][team_member team_memeber_style="meta_overlaid_alt" image_url="https://themenectar.com/img/demo-media/unsplash/webp/team-member-4-small-cropped.webp" name="Ashley Collins" job_position="Graphic Designer"][/vc_column_inner][vc_column_inner column_padding="padding-1-percent" column_padding_position="all" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid"][team_member team_memeber_style="meta_overlaid_alt" image_url="https://themenectar.com/img/demo-media/unsplash/webp/team-member-5-small-cropped.webp" name="Luke Smith" job_position="Web Developer"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Incisive Text Columns', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['general'];
$data['custom_class'] = 'general';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/three-cols.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" scene_position="center" text_color="dark" text_align="left" top_padding="8%" bottom_padding="8%" overlay_strength="0.5"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" top_padding="20" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-2-percent" column_padding_position="top-bottom" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid"][vc_column_text css_animation="none" css=".vc_custom_1486920762999{margin-bottom: 15px !important;}"]
<h4>Customer Support</h4>
[/vc_column_text][vc_custom_heading text="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts" font_container="tag:p|text_align:left|color:rgba(10%2C10%2C10%2C0.65)" use_theme_fonts="yes" css_animation="none" css=".vc_custom_1486920757884{padding-right: 10% !important;}"][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-2-percent" column_padding_position="top-bottom" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid" delay="100"][vc_column_text css_animation="none" css=".vc_custom_1486920768475{margin-bottom: 15px !important;}"]
<h4>Web Design</h4>
[/vc_column_text][vc_custom_heading text="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts" font_container="tag:p|text_align:left|color:rgba(10%2C10%2C10%2C0.65)" use_theme_fonts="yes" css_animation="none" css=".vc_custom_1486920774094{padding-right: 10% !important;}"][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-2-percent" column_padding_position="top-bottom" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid" delay="200"][vc_column_text css_animation="none" css=".vc_custom_1486920745710{margin-bottom: 15px !important;}"]
<h4>Quality Assurance</h4>
[/vc_column_text][vc_custom_heading text="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts" font_container="tag:p|text_align:left|color:rgba(10%2C10%2C10%2C0.65)" use_theme_fonts="yes" css_animation="none" css=".vc_custom_1486920740195{padding-right: 10% !important;}"][nectar_cta heading_tag="h5" text_color="#3452ff" link_type="regular" alignment="left" link_text="Discover More" url="#"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Enhanced Recent Posts', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['blog'];
$data['custom_class'] = 'blog date-04-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/recent_posts.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_color="#eaeaea" scene_position="center" text_color="dark" text_align="left" top_padding="7%" bottom_padding="7%" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][recent_posts style="classic_enhanced" category="all" columns="3" posts_per_page="3"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" centered_text="true" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid"][nectar_btn size="large" button_style="regular" button_color_2="Accent-Color" icon_family="iconsmind" url="#" text="View All Posts" icon_iconsmind="iconsmind-Triangle-ArrowRight"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Youtube Video Background Row With Video Lightbox', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['general'] .', '. $cat_display_names['about'];
$data['custom_class'] = 'general about';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/youtube-video-bg.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" scene_position="center" video_bg="use_video" video_external="https://www.youtube.com/watch?v=4BfKFCOCJe8" text_color="light" text_align="left" top_padding="15%" bottom_padding="15%" enable_gradient="true" color_overlay="#585b64" color_overlay_2="#2c2f38" gradient_direction="left_to_right" overlay_strength="0.8"][vc_column centered_text="true" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][nectar_video_lightbox link_style="play_button" video_url="https://www.youtube.com/watch?v=6oTurM7gESE"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Image Overflowing Left Of Screen & Gradient Header', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['about'] .', '. $cat_display_names['services'];
$data['custom_class'] = 'general about date-29-Sep-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/img-overflow-left.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" equal_height="yes" content_placement="middle" bg_color="#ffffff" scene_position="center" text_color="dark" text_align="left" top_padding="4%" bottom_padding="4%" id="save-time" row_name="Save Time" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" width="7/12" tablet_text_alignment="default" phone_text_alignment="default"][image_with_animation image_url="https://themenectar.com/dummy_data_creation/wp-content/uploads/2016/07/app-1.jpg" alignment="right" animation="Fade In From Left" box_shadow="none" max_width="165%"][/vc_column][vc_column column_padding="padding-2-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" width="5/12" tablet_text_alignment="default" phone_text_alignment="default"][vc_row_inner text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1"][nectar_gradient_text heading_tag="h1" color="extra-color-gradient-1" gradient_direction="diagonal" text="Save Yourself Time By Using Salient"][/vc_column_inner][/vc_row_inner][vc_row_inner text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" delay="150"][vc_column_text]Handling how you manage payments online is very important. Salient is a new innovative and easy to use method of sending &amp; receiving money online. It's fast, secure and free to sign up.[/vc_column_text][/vc_column_inner][/vc_row_inner][vc_row_inner text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" delay="300"][fancy-ul icon_type="standard_dash" color="Extra-Color-3"]
<ul>
	<li>Top Customer Support</li>
	<li>Most Liked Company</li>
	<li>Best In Class 2016</li>
	<li>Friendliest Group</li>
	<li>Innovative Brand</li>
</ul>
[/fancy-ul][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Flip Box Carousel', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['about'] .', '. $cat_display_names['services'];
$data['custom_class'] = 'general about date-29-Sep-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/flipbox-carousel.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_color="#ffffff" scene_position="center" text_color="dark" text_align="left" top_padding="8%" bottom_padding="8%" id="core-features" row_name="Core Features" overlay_strength="0.3"][vc_column centered_text="true" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1469639641867{padding-bottom: 10px !important;}"]
<h2>Our Awesome Core Features</h2>
[/vc_column_text][divider line_type="Small Line" line_thickness="3" divider_color="extra-color-1" animate="yes" custom_height="30" custom_line_width="120" delay="100"][vc_column_text max_width="450"]<span style="color: #999999;">There are countless reasons why our service is better than the rest, but here you can learn about why we're different.</span>[/vc_column_text][/vc_column_inner][/vc_row_inner][carousel script="owl_carousel" desktop_cols="3" desktop_small_cols="2" tablet_cols="2" mobile_cols="1" column_padding="15px" enable_animation="true" delay="100"][item id="1485907949923-10af59-8004" title="Item" tab_id="1485999357987-9"][nectar_flip_box image_url_1="https://themenectar.com/img/demo-media/unsplash/webp/large-room.webp" bg_color="#0a0a0a" bg_color_overlay="true" text_color="light" icon_family="steadysets" icon_color="Extra-Color-1" image_url_2="https://themenectar.com/img/demo-media/unsplash/webp/large-room.webp" bg_color_2="#0a0a0a" bg_color_overlay_2="true" text_color_2="light" h_text_align="center" v_text_align="center" flip_direction="horizontal-to-left" front_content="
<h3>Use It Anywhere</h3>
Nullam gravida tellus lectus, in bibendum quam euismod" min_height="300" icon_size="44" icon_steadysets="steadysets-icon-map"]
<h3>Use It Anywhere</h3>
This is an amazing Nectar Flip Box element. Any content can be displayed on both sides to suit your specific project needs.[/nectar_flip_box][/item][item id="1485907949937-4af59-8004" title="Item" tab_id="1485999358001-10"][nectar_flip_box image_url_1="https://themenectar.com/img/demo-media/unsplash/webp/large-office.webp" bg_color="#0a0a0a" bg_color_overlay="true" text_color="light" icon_family="steadysets" icon_color="Extra-Color-1" image_url_2="https://themenectar.com/img/demo-media/unsplash/webp/large-office.webp" bg_color_2="#0a0a0a" bg_color_overlay_2="true" text_color_2="light" h_text_align="center" v_text_align="center" flip_direction="horizontal-to-left" front_content="
<h3>Secure Payments</h3>
Duis lorem magna, bibendum sed suscipit ut nec mauris." min_height="300" icon_size="44" icon_steadysets="steadysets-icon-lock"]
<h3>Secure Payments</h3>
You have control over the background image &amp; color in addition to the optional color overlay as well.[/nectar_flip_box][/item][item id="1485907949953-10af59-8004" title="Item" tab_id="1485999358019-1"][nectar_flip_box image_url_1="https://themenectar.com/img/demo-media/unsplash/webp/large-music.webp" bg_color="#0a0a0a" bg_color_overlay="true" text_color="light" icon_family="steadysets" icon_color="Extra-Color-1" image_url_2="https://themenectar.com/img/demo-media/unsplash/webp/large-music.webp" bg_color_2="#0a0a0a" bg_color_overlay_2="true" text_color_2="light" h_text_align="center" v_text_align="center" flip_direction="horizontal-to-left" front_content="
<h3>Detailed Statistics</h3>
In pharetra imperdiet facilisis. Integer elementum augue" min_height="300" icon_size="44" icon_steadysets="steadysets-icon-browser"]
<h3>Detailed Statistics</h3>
You also can control the flip direction. This example shows the "horizontal flip to left" option exclusively though.[/nectar_flip_box][/item][item id="1485907949982-6af59-8004" title="Item" tab_id="1485999358051-10"][nectar_flip_box image_url_1="https://themenectar.com/img/demo-media/unsplash/webp/large-mountain.webp" bg_color="#0a0a0a" bg_color_overlay="true" text_color="light" icon_family="steadysets" icon_color="Extra-Color-1" image_url_2="https://themenectar.com/img/demo-media/unsplash/webp/large-mountain.webp" bg_color_2="#0a0a0a" bg_color_overlay_2="true" text_color_2="light" h_text_align="center" v_text_align="center" flip_direction="horizontal-to-left" front_content="
<h3>Scheduled Payments</h3>
Nullam gravida tellus lectus, in bibendum quam euismod" min_height="300" icon_size="44" icon_steadysets="steadysets-icon-bookmark"]
<h3>Scheduled Payments</h3>
You can also control the X and Y axis for content positioning. This example shows all set to the middle.[/nectar_flip_box][/item][item id="1485907950009-2af59-8004" title="Item" tab_id="1485999358072-7"][nectar_flip_box image_url_1="https://themenectar.com/img/demo-media/unsplash/webp/large-fashion.webp" bg_color="#0a0a0a" bg_color_overlay="true" text_color="light" icon_color="Extra-Color-1" image_url_2="https://themenectar.com/img/demo-media/unsplash/webp/large-fashion.webp" bg_color_2="#0a0a0a" bg_color_overlay_2="true" text_color_2="light" h_text_align="center" v_text_align="center" flip_direction="horizontal-to-left" front_content="
<h3>Visa Gateway</h3>
Interdum et malesuada fames ac ante ipsum primis" min_height="300" icon_size="42" icon_fontawesome="fa fa-credit-card"]
<h3>Visa Gateway</h3>
These flip boxes are also placed within a carousel element which is completely optional. They can live in regular columns if desired.[/nectar_flip_box][/item][/carousel][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Pricing Table Dark', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['pricing'];
$data['custom_class'] = 'pricing date-10-Aug-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/dark-pricing.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_color="#1c1c1c" scene_position="center" text_color="light" text_align="left" top_padding="8%" bottom_padding="8%" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner equal_height="yes" content_placement="top" column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-5-percent" column_padding_position="all" centered_text="true" background_color_opacity="1" font_color="#919191" width="1/3" column_border_width="2px" column_border_color="#3a3a3a" column_border_style="solid"][vc_column_text css=".vc_custom_1485706251777{margin-bottom: 5px !important;}"]
<h5>Basic</h5>
[/vc_column_text][vc_custom_heading text="$10" font_container="tag:h2|font_size:80|text_align:center|color:%23ffffff|line_height:80px" google_fonts="font_family:Roboto%3A100%2C100italic%2C300%2C300italic%2Cregular%2Citalic%2C500%2C500italic%2C700%2C700italic%2C900%2C900italic|font_style:400%20regular%3A400%3Anormal"][vc_custom_heading text="/month" font_container="tag:h4|font_size:24|text_align:center|color:%23ffffff|line_height:34px" google_fonts="font_family:Roboto%3A100%2C100italic%2C300%2C300italic%2Cregular%2Citalic%2C500%2C500italic%2C700%2C700italic%2C900%2C900italic|font_style:400%20regular%3A400%3Anormal"][divider line_type="No Line" custom_height="40"][fancy-ul icon_type="none" alignment="center"]
<ul>
 	<li>Custom Domain</li>
 	<li>24/7 Customer Support</li>
 	<li>Month Of Free Bandwidth</li>
 	<li>-</li>
 	<li>-</li>
 	<li>-</li>
 	<li>-</li>
</ul>
[/fancy-ul][nectar_btn size="large" button_style="see-through-2" hover_text_color_override="#ffffff" icon_family="iconsmind" url="#" text="Buy Now" margin_top="20" icon_iconsmind="iconsmind-Triangle-ArrowRight"][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-5-percent" column_padding_position="all" centered_text="true" background_color_opacity="1" font_color="#919191" width="1/3" column_border_width="2px" column_border_color="#3a3a3a" column_border_style="solid" delay="100"][vc_column_text css=".vc_custom_1485706256916{margin-bottom: 5px !important;}"]
<h5>Premium</h5>
[/vc_column_text][vc_custom_heading text="$20" font_container="tag:h2|font_size:80|text_align:center|color:%23ffffff|line_height:80px" google_fonts="font_family:Roboto%3A100%2C100italic%2C300%2C300italic%2Cregular%2Citalic%2C500%2C500italic%2C700%2C700italic%2C900%2C900italic|font_style:400%20regular%3A400%3Anormal"][vc_custom_heading text="/month" font_container="tag:h4|font_size:24|text_align:center|color:%23ffffff|line_height:34px" google_fonts="font_family:Roboto%3A100%2C100italic%2C300%2C300italic%2Cregular%2Citalic%2C500%2C500italic%2C700%2C700italic%2C900%2C900italic|font_style:400%20regular%3A400%3Anormal"][divider line_type="No Line" custom_height="40"][fancy-ul icon_type="none" alignment="center"]
<ul>
 	<li>Custom Domain</li>
 	<li>24/7 Customer Support</li>
 	<li>Month Of Free Bandwidth</li>
 	<li>Free WordPress Setup</li>
 	<li>Cake Delivered Daily</li>
 	<li>-</li>
 	<li>-</li>
</ul>
[/fancy-ul][nectar_btn size="large" button_style="see-through-2" hover_text_color_override="#ffffff" icon_family="iconsmind" url="#" text="Buy Now" margin_top="20" icon_iconsmind="iconsmind-Triangle-ArrowRight"][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-5-percent" column_padding_position="all" centered_text="true" background_color_opacity="1" font_color="#919191" width="1/3" column_border_width="2px" column_border_color="#3a3a3a" column_border_style="solid" delay="200"][vc_column_text css=".vc_custom_1485706261609{margin-bottom: 5px !important;}"]
<h5>Developer</h5>
[/vc_column_text][vc_custom_heading text="$40" font_container="tag:h2|font_size:80|text_align:center|color:%23ffffff|line_height:80px" google_fonts="font_family:Roboto%3A100%2C100italic%2C300%2C300italic%2Cregular%2Citalic%2C500%2C500italic%2C700%2C700italic%2C900%2C900italic|font_style:400%20regular%3A400%3Anormal"][vc_custom_heading text="/month" font_container="tag:h4|font_size:24|text_align:center|color:%23ffffff|line_height:34px" google_fonts="font_family:Roboto%3A100%2C100italic%2C300%2C300italic%2Cregular%2Citalic%2C500%2C500italic%2C700%2C700italic%2C900%2C900italic|font_style:400%20regular%3A400%3Anormal"][divider line_type="No Line" custom_height="40"][fancy-ul icon_type="none" alignment="center"]
<ul>
 	<li>Custom Domain</li>
 	<li>24/7 Customer Support</li>
 	<li>Month Of Free Bandwidth</li>
 	<li>Free WordPress Setup</li>
 	<li>Cake Delivered Daily</li>
 	<li>Premium Support</li>
 	<li>Design Consultation</li>
</ul>
[/fancy-ul][nectar_btn size="large" button_style="see-through-2" hover_text_color_override="#ffffff" icon_family="iconsmind" url="#" text="Buy Now" margin_top="20" icon_iconsmind="iconsmind-Triangle-ArrowRight"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Image Overflowing Right Of Screen & Numerical Icon List', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['about'] .', '. $cat_display_names['services'];
$data['custom_class'] = 'general about date-29-Sep-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/img-overflow-right.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" equal_height="yes" content_placement="middle" bg_color="#ecf7ff" scene_position="center" text_color="dark" text_align="left" id="steps" row_name="Sign Up Steps" overlay_strength="0.3"][vc_column column_padding="padding-2-percent" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="5/12" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" offset="vc_col-xs-12"][nectar_icon_list animate="true" color="default" icon_size="small" icon_style="border"][nectar_icon_list_item icon_type="numerical" title="List Item" id="1469496380463-1039da-01ea" header="Sign Up For Free" text="Create your free account in a matter of minutes with our patented awesome sign up process." tab_id="1485703048239-5"] [/nectar_icon_list_item][nectar_icon_list_item icon_type="numerical" title="List Item" id="1469496380621-239da-01ea" header="Sell Goods Online" text="Next start integrating it with your e-commerce platform of choice and start accepting payments." tab_id="1485703048245-4"] [/nectar_icon_list_item][nectar_icon_list_item icon_type="numerical" title="List Item" id="1469496416453-939da-01ea" header="Love Your Life" text="Sit back, relax and pop a cold one because your life just got a whole lot easier by using Salient." tab_id="1485703048251-2"][/nectar_icon_list_item][/nectar_icon_list][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="7/12" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" offset="vc_col-xs-12"][image_with_animation image_url="https://themenectar.com/dummy_data_creation/wp-content/uploads/2016/07/laptop.jpg" alignment="" animation="Fade In From Right" box_shadow="none" max_width="175%"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Simple Text Columns', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['general'];
$data['custom_class'] = 'general';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/text-columns.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_color="#ffffff" scene_position="center" text_color="dark" text_align="left" top_padding="10%" bottom_padding="10%" overlay_strength="1"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid"][vc_column_text]
<h3>Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantic</h3>
[/vc_column_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" top_padding="40" bottom_padding="35" text_align="left"][vc_column_inner enable_animation="true" animation="none" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid"][divider line_type="Full Width Line" line_thickness="1" divider_color="default" animate="yes" custom_height="1"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-2-percent" column_padding_position="top-bottom" background_color_opacity="1" width="1/2" column_border_width="none" column_border_style="solid"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color="Accent-Color" icon_padding="0px" icon_iconsmind="iconsmind-King-2" icon_size="36"][vc_column_text css=".vc_custom_1486918825917{padding-bottom: 10px !important;}"]
<h5>Who are we</h5>
[/vc_column_text][vc_column_text css=".vc_custom_1486918759317{padding-right: 10% !important;}"]A small river named Duden flows by their place and supplies it with the necessary regelialia. It is a paradisematic country, in which roasted parts of sentences fly into your mouth.[/vc_column_text][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-2-percent" column_padding_position="top-bottom" background_color_opacity="1" width="1/2" column_border_width="none" column_border_style="solid" delay="100"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color="Accent-Color" icon_padding="0px" icon_iconsmind="iconsmind-Duplicate-Window" icon_size="36"][vc_column_text css=".vc_custom_1486918830515{padding-bottom: 10px !important;}"]
<h5>What we do</h5>
[/vc_column_text][vc_column_text css=".vc_custom_1486919428207{padding-right: 10% !important;}"]Even the all-powerful Pointing has no control about the blind texts it is an almost unorthographic life One day however a small line of blind text by the name of Lorem Ipsum decided to leave.[/vc_column_text][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Testimonial Slider Parallax', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['testimonials'];
$data['custom_class'] = 'testimonials';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/parallax-testimonial.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-room.webp" bg_position="left top" bg_repeat="no-repeat" parallax_bg="true" parallax_bg_speed="fast" bg_color="#383838" scene_position="center" text_color="light" text_align="left" top_padding="10%" bottom_padding="10%" color_overlay="#0a0a0a" overlay_strength="0.5"][vc_column enable_animation="true" animation="grow-in" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][testimonial_slider style="minimal" star_rating_color="accent-color" disable_height_animation="true"][testimonial star_rating="none" title="Testimonial" id="1475858133769-1f702-2797" name="Eve Crawford" subtitle="Product Designer" quote="It was really fun getting to know the team during the project. They were all helpful in answering my questions and made me feel at ease. The design ended up being better than I could have envisioned!" tab_id="1486839778816-4"] Click the edit button to add your testimonial. [/testimonial][testimonial star_rating="none" title="Testimonial" id="1475858133938-7f702-2797" name="Aura Brooks" subtitle="Graphic Designer" quote="By far the best team I've ever worked with. They truly understood the look I was going for and completely nailed it! I would highly recommend them as a company, you simply just won't find any better team!" tab_id="1486839779007-9"] Click the edit button to add your testimonial. [/testimonial][testimonial star_rating="none" title="Testimonial" id="1475867833938-7f702-2797" name="Zak Reid" subtitle="Instructor, Skate Nao" quote="Salient is by far the most astonishing WP theme out there! I literally could not be happier that I chose to buy your theme! Your regular updates and superb attention to detail blows me away every time I visit my new site!" tab_id="1486839779963-10"] Click the edit button to add your testimonial. [/testimonial][testimonial star_rating="none" title="Testimonial" id="1475858133939-7f702-2797" name="Jack Graham" subtitle="Co Founder, Coffee Inc" quote="I'm wondering why I never contacted these guys sooner! Seriously, they all have commendable talent in their respective fields and knocked my concept out of the ballpark. Thanks for an amazing experience!" tab_id="1486839779323-6"] Click the edit button to add your testimonial. [/testimonial][/testimonial_slider][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Practical Map & Contact Info Split', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['google_map'] .', '. $cat_display_names['general'];
$data['custom_class'] = 'general map';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/map-color-split.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" equal_height="yes" bg_color="#141414" scene_position="center" text_color="light" text_align="left" overlay_strength="0.3"][vc_column enable_animation="true" animation="grow-in" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" delay="200"][nectar_gmap zoom="6" enable_zoom="1" marker_style="nectar" nectar_marker_color="accent-color" map_greyscale="1" ultra_flat="1" dark_color_scheme="1" size="750" map_center_lat="40.793" map_center_lng="-73.954" map_markers="37.748458|-122.475586|Our Location
40.793|-73.954|Our Location #2"][/vc_column][vc_column enable_animation="true" animation="grow-in" column_padding="padding-8-percent" column_padding_position="all" background_color="#3452ff" background_color_opacity="0.9" background_hover_color_opacity="1" background_image="123" enable_bg_scale="true" column_shadow="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" delay="300"][vc_column_text css_animation="none"]
<h3>Contact.</h3>
We’re currently in look of a few new designers – If you’re a passionate worker and think you have what it takes, send your resume and details to for all opportunities.

&nbsp;
<h5>San Francisco</h5>
123 Nectar St. Suite 4917
hello@themenectar.com
<h5></h5>
<h5>New York</h5>
58 Nectar Rd. Apt 2C
hello@themenectar.com[/vc_column_text][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Map & Contact Info Split', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['google_map'] .', '. $cat_display_names['general'];
$data['custom_class'] = 'general map';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/map-split-light.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" bg_color="#ffffff" scene_position="center" text_color="dark" text_align="left" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][nectar_gmap zoom="16" marker_style="nectar" nectar_marker_color="accent-color" map_greyscale="1" dark_color_scheme="1" size="750" map_center_lat="39.949" map_center_lng="-75.172" map_markers="39.949|-75.171|
"][/vc_column][vc_column column_padding="padding-7-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_column_text]
<h3>Contact.</h3>
We’re currently in look of a few new designers – If you’re a passionate worker and think you have what it takes, send your resume and details to <a href="https://themenectar.com/demo/salient-corporate/contact/#">jobs@demo.com</a> for all opportunities.

&nbsp;
<h5>San Francisco</h5>
123 Nectar St. Suite 4917
hello@themenectar.com
<h5></h5>
<h5>New York</h5>
58 Nectar Rd. Apt 2C
hello@themenectar.com[/vc_column_text][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'The Awards Section Dark', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['about'] .', '. $cat_display_names['general'];
$data['custom_class'] = 'general about date-03-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/dark-awards.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_color="#0a0a0a" scene_position="center" text_color="light" text_align="left" top_padding="10%" bottom_padding="10%" overlay_strength="0.95"][vc_column enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" centered_text="true" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1486836945876{margin-top: -8px !important;margin-bottom: -8px !important;}"]
<h2>They Appreciate Us</h2>
[/vc_column_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" bottom_padding="80" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/4" column_border_width="none" column_border_style="solid"][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/2" column_border_width="none" column_border_style="solid" delay="50"][vc_custom_heading text="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. A small river named Duden flows by their place and supplies it with the necessary regelialia." font_container="tag:p|text_align:center|color:rgba(255%2C255%2C255%2C0.65)" use_theme_fonts="yes" css_animation="none"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/4" column_border_width="none" column_border_style="solid"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid"][nectar_horizontal_list_item columns="3" column_layout_using_3_columns="large_first" col_1_text_align="left" col_2_text_align="left" col_3_text_align="left" font_family="p" hover_color="accent-color" col_1_content="Design Awards" col_2_content="Nectar Convention" col_3_content="2016-01-23"][nectar_horizontal_list_item columns="3" column_layout_using_3_columns="large_first" col_1_text_align="left" col_2_text_align="left" col_3_text_align="left" font_family="p" hover_color="accent-color" col_1_content="UI Convention" col_2_content="Salient Awards" col_3_content="2016-04-12"][nectar_horizontal_list_item columns="3" column_layout_using_3_columns="large_first" col_1_text_align="left" col_2_text_align="left" col_3_text_align="left" font_family="p" hover_color="accent-color" col_1_content="Web Design Envy" col_2_content="ThemeNectar" col_3_content="2016-06-15"][nectar_horizontal_list_item columns="3" column_layout_using_3_columns="large_first" col_1_text_align="left" col_2_text_align="left" col_3_text_align="left" font_family="p" hover_color="accent-color" col_1_content="Design Fusion" col_2_content="Salient Team" col_3_content="2016-07-28"][nectar_horizontal_list_item columns="3" column_layout_using_3_columns="large_first" col_1_text_align="left" col_2_text_align="left" col_3_text_align="left" font_family="p" hover_color="accent-color" col_1_content="Nectar Gathering" col_2_content="Frostwave" col_3_content="2016-09-23"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Well-made Intro Section', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['about'] .', '. $cat_display_names['general'];
$data['custom_class'] = 'about general hero_section date-02-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/gradient-text.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#ffffff" scene_position="center" top_padding="10%" bottom_padding="10%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" overlay_strength="1" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none"][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" right_padding_desktop="50%" right_padding_tablet="0" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][split_line_heading animation_type="line-reveal-by-space" font_style="h1" line_reveal_by_space_text_effect="default" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="If you wish to make an apple pie from scratch, you must first invent the universe."][/split_line_heading][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="padding-3-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="top-bottom" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1485638236800{padding-right: 10% !important;}"]Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean. A small river named Duden flows by their place and supplies it with the necessary regelialia. It is a paradisematic country, in which roasted parts of sentences fly into your mouth.[/vc_column_text][/vc_column_inner][vc_column_inner column_padding="padding-3-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="top-bottom" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" delay="100"][vc_column_text css=".vc_custom_1485638241294{padding-right: 10% !important;}"]Even the all-powerful Pointing has no control about the blind texts it is an almost unorthographic life One day however a small line of blind text by the name of Lorem Ipsum decided to leave for the far World of Grammar. The Big Oxmox advised her not to do so, because there were thousands of bad Commas, wild Question Marks and devious Semikoli.[/vc_column_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" top_padding="20" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-left" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][nectar_cta btn_style="see-through" heading_tag="h5" button_color="default" text_color="#0a0000" button_border_thickness="0px" link_type="regular" alignment="left" alignment_tablet="default" alignment_phone="default" display="block" display_tablet="inherit" display_phone="inherit" link_text="Learn More" url="#"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Well-made Intro Section Dark', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['about'] .', '. $cat_display_names['general'];
$data['custom_class'] = 'general about date-02-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/dark-text-section.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#0a0a0a" scene_position="center" top_padding="10%" bottom_padding="10%" text_color="light" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" overlay_strength="1" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none"][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" right_padding_desktop="50%" right_padding_tablet="0" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][split_line_heading animation_type="line-reveal-by-space" font_style="h1" line_reveal_by_space_text_effect="default" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="If you wish to make an apple pie from scratch, you must first invent the universe."][/split_line_heading][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="top-bottom" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_custom_heading text="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean. A small river named Duden flows by their place and supplies it with the necessary regelialia. It is a paradisematic country, in which roasted parts of sentences fly into your mouth." font_container="tag:p|text_align:left|color:rgba(255%2C255%2C255%2C0.71)" use_theme_fonts="yes" css=".vc_custom_1486839091142{padding-right: 10% !important;}"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="top-bottom" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" delay="100"][vc_custom_heading text="Even the all-powerful Pointing has no control about the blind texts it is an almost unorthographic life One day however a small line of blind text by the name of Lorem Ipsum decided to leave for the far World of Grammar. The Big Oxmox advised her not to do so, because there were thousands of bad Commas, wild Question Marks and devious Semikoli." font_container="tag:p|text_align:left|color:rgba(255%2C255%2C255%2C0.71)" use_theme_fonts="yes"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" top_padding="20" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][nectar_btn size="large" button_style="see-through-2" hover_text_color_override="#ffffff" icon_family="default_arrow" url="#" text="Start a project" css_animation="none" margin_top="35"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Fullscreen Recent Project Slider', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['portfolio'] .', '. $cat_display_names['hero_section'];
$data['custom_class'] = 'portfolio hero_section date-05-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/recent-proj-slider.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" bg_color="#0a0a0a" scene_position="center" text_color="dark" text_align="left" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][recent_projects category="all" project_style="fullscreen_zoom_slider" slider_controls="both" slider_text_color="light" overlay_strength="0.4" number_to_display="10"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Minimal Dark About Section', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['about'];
$data['custom_class'] = 'about date-05-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/dark-about.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" equal_height="yes" content_placement="middle" full_height="yes" columns_placement="stretch" bg_color="#141414" scene_position="center" text_color="light" text_align="left" overlay_strength="0.3"][vc_column column_padding="padding-10-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid"][vc_custom_heading text="Philip Martinez" font_container="tag:h5|text_align:left|color:%23bfbfbf" use_theme_fonts="yes" css=".vc_custom_1485193607322{margin-bottom: 10px !important;}"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid" delay="100"][vc_custom_heading text="Creator of quality designs and thinker of fresh ideas." font_container="tag:h2|font_size:40|text_align:left|line_height:50px" use_theme_fonts="yes"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid" delay="200"][vc_column_text css=".vc_custom_1485195197203{margin-top: 30px !important;margin-bottom: 30px !important;}"]Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. A small river named Duden flows by their place and supplies it with the necessary regelialia[/vc_column_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid" delay="300"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color="white" open_new_tab="true" icon_padding="20px" icon_iconsmind="iconsmind-Facebook-2" icon_size="29" margin_left="-20px" url="#"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color="white" open_new_tab="true" icon_padding="20px" icon_iconsmind="iconsmind-Twitter" icon_size="29" url="#"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color="white" open_new_tab="true" icon_padding="20px" icon_iconsmind="iconsmind-Dribble" icon_size="29" url="#"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column enable_animation="true" animation="fade-in-from-left" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/webp/neutral-girl.webp" enable_bg_scale="true" column_shadow="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" delay="300"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Video Background Testimonial Slider Dark', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['testimonials'] .', '. $cat_display_names['about'];
$data['custom_class'] = 'testimonials about date-05-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/video-bg-testimonials.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_color="#333333" scene_position="center" video_bg="use_video" enable_video_color_overlay="true" video_overlay_color="#000000" video_external="https://www.youtube.com/watch?v=6oTurM7gESE" text_color="light" text_align="left" top_padding="15%" bottom_padding="15%" id="services" overlay_strength="0.3"][vc_column enable_animation="true" animation="flip-in" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][testimonial_slider style="default"][testimonial name="Carly Young, ThemeNectar" quote="By far the best team I've ever worked with. They truly understood the look I was going for and completely nailed it! I would highly recommend them as a company, you won't find any better!" id="1484513879050-1f107-50ab" title="Testimonial" tab_id="1485366100980-9"][/testimonial][testimonial name="Jeff Gemmell, ThemeNectar" quote="It was really fun getting to know the team during the project. They were all helpful in answering questions and made me feel at ease. The design ended up being better than I could've envisioned!" id="1484513879156-2f107-50ab" title="Testimonial" tab_id="1485366100985-3"][/testimonial][testimonial name="Mark Levin, ThemeNectar" quote="I'm wondering why I never contacted these guys sooner! They have commendable talent in their fields and knocked my concept out of the ballpark. An amazing experience!" id="1484513879236-7f107-50ab" title="Testimonial" tab_id="1485366101002-0"][/testimonial][/testimonial_slider][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Restaurant Hero', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['hero_section'];
$data['custom_class'] = 'hero_section date-28-Sep-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/restaurant-hero.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-rest.webp" bg_position="center center" bg_repeat="no-repeat" scene_position="center" top_padding="18%" bottom_padding="18%" text_color="light" text_align="left" color_overlay="#0a0a0a" overlay_strength="0.5" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" parallax_bg="true" parallax_bg_speed="fast" shape_type=""][vc_column centered_text="true" column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][split_line_heading animation_type="default"]
<h6>Honest.  Wholesome.  Quality</h6>
[/split_line_heading][split_line_heading animation_type="default"]
<h1>Voted Best In Philly</h1>
[/split_line_heading][/vc_column][/vc_row][vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" bg_color="#dde5f3" scene_position="center" text_color="light" text_align="left" overlay_strength="0.3" gradient_direction="left_to_right" enable_shape_divider="true" shape_divider_color="#ffffff" shape_divider_position="bottom" shape_divider_height="5%" bg_image_animation="none" shape_type="straight_section"][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" top_margin="-7%" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="large_depth" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_row_inner equal_height="yes" content_placement="middle" column_margin="none" text_align="left" id="about" css=".vc_custom_1486684329109{background-color: #ffffff !important;}"][vc_column_inner column_padding="padding-7-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color="#5b74ff" background_color_opacity="0.9" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/webp/neutral-field.webp" background_image_position="center center" enable_bg_scale="true" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_column_text]
<h2>The Great Story Of Our Culinary Journey</h2>
[/vc_column_text][vc_column_text css=".vc_custom_1579814999722{margin-top: 40px !important;}"]Lorem ipsum dolor sit amet, consectetur adipiscing elit. Phasellus hendrerit placerat feugiat. Praesent luctus est urna, id bibendum odio efficitur et. Cras imperdiet ipsum tincidunt lobortis accumsan.[/vc_column_text][vc_column_text css=".vc_custom_1483409005371{margin-top: 40px !important;}"]<strong>Claire Bianco</strong> - <em>Master Chef at Salient</em>[/vc_column_text][/vc_column_inner][vc_column_inner column_padding="padding-5-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/webp/neutral-girl.webp" background_image_position="center center" enable_bg_scale="true" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][divider line_type="No Line" custom_height="200"][/vc_column_inner][/vc_row_inner][vc_row_inner equal_height="yes" content_placement="middle" column_margin="none" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/webp/orange-food.webp" background_image_position="center center" enable_bg_scale="true" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][divider line_type="No Line" custom_height="400"][/vc_column_inner][vc_column_inner column_padding="padding-7-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color="#e9e9e9" background_color_opacity="1" background_hover_color_opacity="1" font_color="#000000" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_column_text max_width="350"]
<h2>Salient Hours Of Operation</h2>
[/vc_column_text][vc_column_text css=".vc_custom_1483374687395{margin-top: 40px !important;margin-bottom: 20px !important;}"]<strong>Monday – Thursday:</strong> 9:00 am – 10:00 pm
<em>Food service until 9:00 pm</em>[/vc_column_text][vc_column_text css=".vc_custom_1483374679842{margin-bottom: 20px !important;}"]<strong>Friday - Saturday:</strong> 9:00 am – Midnight
<em>Food service until 10:00 pm</em>[/vc_column_text][vc_column_text css=".vc_custom_1483373919590{margin-bottom: 40px !important;}"]<strong>Sunday:</strong> 11:00 am – 10:00 pm
<em>Food service until 9:00 pm</em>[/vc_column_text][nectar_cta btn_style="see-through" heading_tag="h5" text_color="#3452ff" button_color="default" link_type="new_tab" alignment="left" display="block" link_text="Make A Reservation" url="#"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Restaurant Testimonial Slider', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['testimonials'];
$data['custom_class'] = 'testimonials date-28-Sep-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/restaurant-testimonials.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/food.webp" bg_position="center center" bg_repeat="no-repeat" scene_position="center" top_padding="13%" bottom_padding="13%" text_color="light" text_align="left" color_overlay="#000000" overlay_strength="0.5" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" parallax_bg="true" parallax_bg_speed="fast"][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_row_inner column_margin="default" bottom_padding="3%" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][/vc_column_inner][vc_column_inner centered_text="true" column_padding="padding-3-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="default" column_border_width="2px" column_border_color="#ffffff" column_border_style="double_offset" enable_border_animation="true" bg_image_animation="none" enable_animation="true" animation="fade-in"][vc_column_text]
<h3>The Press</h3>
[/vc_column_text][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][/vc_column_inner][/vc_row_inner][testimonial_slider style="minimal" star_rating_color="accent-color" disable_height_animation="true"][testimonial star_rating="none" title="Testimonial" id="1579816010380-3" tab_id="1579816010381-7" name="Chase Carlson" subtitle="Salient FoodMag" quote="Something magical happened to my taste buds, it was one of the most beautiful things that I've ever experienced. ar far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live."][testimonial star_rating="none" title="Testimonial" id="1579816010453-0" tab_id="1579816010455-10" name="Carley Kohen" subtitle="WeDoFood" quote="The subline of her own road, the Line Lane. Pityful a rethoric question ran over her cheek, then The Big Oxmox advised her not to do so, because there were thousands of bad Commas."][testimonial star_rating="none" title="Testimonial" id="1579816010503-7" tab_id="1579816010503-2" name="Corey Smith" subtitle="FoodReviewz" quote="A small river named Duden flows by their place and supplies it with the necessary regelialia. It is a paradisematic country, in which roasted parts of sentences fly into your mouth. Even the all-powerful Pointing has no control."][/testimonial_slider][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Restaurant Food Menu (Tabbed)', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['pricing'];
$data['custom_class'] = 'pricing date-27-Sep-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/food-menu.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" scene_position="center" text_color="dark" text_align="left" top_padding="8%" bottom_padding="8%" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" top_padding="3%" bottom_padding="5%" text_align="left" id="menu"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid"][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in" column_padding="padding-3-percent" column_padding_position="all" centered_text="true" background_color_opacity="1" width="1/3" column_border_width="2px" column_border_color="#000000" column_border_style="double_offset" enable_border_animation="true"][vc_column_text]
<h3>The Menu</h3>
[/vc_column_text][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid"][/vc_column_inner][/vc_row_inner][tabbed_section style="minimal_alt" alignment="center" cta_button_style="extra-color-3"][tab title="Breakfast &amp; Brunch" id="1483371702-1-88" tab_id="1483371715854-2"][vc_row_inner column_margin="default" top_padding="30" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in" column_padding="padding-4-percent" column_padding_position="all" background_color_opacity="1" width="1/2" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1484520003986{margin-bottom: 30px !important;}"]
<h5>The Griddle</h5>
[/vc_column_text][nectar_food_menu_item style="line_between" item_name_heading_tag="h4" item_name="Western Sunrise" text="$9" item_price="$19" item_description="Two fried eggs with cheese &amp;two breakfast meats made to perfection"][nectar_food_menu_item style="line_between" item_name_heading_tag="h4" item_name="Classic California" text="$9" item_price="$17" item_description="You know it's good, just order it"][nectar_food_menu_item style="line_between" item_name_heading_tag="h4" item_name="Fried Eggs &amp; Ham" text="$9" item_price="$12" item_description="It's just plain and simple, but also tasty"][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in" column_padding="padding-4-percent" column_padding_position="all" background_color_opacity="1" width="1/2" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1484520027757{margin-bottom: 30px !important;}"]
<h5>Omelettes &amp; Skillets</h5>
[/vc_column_text][nectar_food_menu_item style="line_between" item_name_heading_tag="h4" item_name="Mr. Nectar Benedict " text="$9" item_price="$13" item_description="The best grilled English muffin, two poached eggs"][nectar_food_menu_item style="line_between" item_name_heading_tag="h4" item_name="Great Waffles" text="$9" item_price="$17" item_description="Chocolate chips, imported syrup"][nectar_food_menu_item style="line_between" item_name_heading_tag="h4" item_name="``Country`` Breakfast" text="$9" item_price="$12" item_description="Biscuits with fresh sausage patties &amp; country gravy"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in" column_padding="padding-4-percent" column_padding_position="all" background_color_opacity="1" width="1/2" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1484520078924{margin-bottom: 30px !important;}"]
<h5>Pancakes</h5>
[/vc_column_text][nectar_food_menu_item style="line_between" item_name_heading_tag="h4" item_name="American Pancakes" text="$9" item_price="$9" item_description="Large stack of three with maple syrup "][nectar_food_menu_item style="line_between" item_name_heading_tag="h4" item_name="Danish Style Pancakes" text="$9" item_price="$7" item_description="Served with pigs in a blanket"][nectar_food_menu_item style="line_between" item_name_heading_tag="h4" item_name="Sweet Tooth" text="$9" item_price="$9" item_description="Basically just a dessert "][nectar_food_menu_item style="line_between" item_name_heading_tag="h4" item_name="``Can't make up my mind``" text="$9" item_price="$12" item_description="Served with a sample of French toast"][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in" column_padding="padding-4-percent" column_padding_position="all" background_color_opacity="1" width="1/2" column_border_width="2px" column_border_color="#3452ff" column_border_style="double_offset" enable_border_animation="true"][vc_column_text css=".vc_custom_1484520037671{margin-bottom: 30px !important;}"]
<h5>Breakfast Specials</h5>
[/vc_column_text][nectar_food_menu_item style="line_between" item_name_heading_tag="h4" item_name="Salient Style" text="$9" item_price="$17" item_description="Three scrambled eggs, bacon &amp; a side of hash browns"][nectar_food_menu_item style="line_between" item_name_heading_tag="h4" item_name="The Really Good Stuff" text="$9" item_price="$12" item_description="It's just plain and simple"][nectar_food_menu_item style="line_between" item_name_heading_tag="h4" item_name="Nectar's Choice" text="$9" item_price="$11" item_description="Ask your server for more details"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" top_padding="60" text_align="left" css=".vc_custom_1486083303611{padding-right: 2% !important;padding-left: 2% !important;}"][vc_column_inner column_padding="padding-2-percent" column_padding_position="all" background_color_opacity="1" width="1/4" column_border_width="none" column_border_style="solid"][nectar_food_menu_item style="default" item_name_heading_tag="h4" item_name="Sodas" text="$9" item_price="$4" item_description="Coca cola, Pepsi, Sprite, Fanta, Nectar Soda, Salient Fizz"][/vc_column_inner][vc_column_inner column_padding="padding-2-percent" column_padding_position="all" background_color_opacity="1" width="1/4" column_border_width="none" column_border_style="solid"][nectar_food_menu_item style="default" item_name_heading_tag="h4" item_name="Tea" text="$9" item_price="$6" item_description="Green, Red, Black, Yellow, White Warm &amp; Hot"][/vc_column_inner][vc_column_inner column_padding="padding-2-percent" column_padding_position="all" background_color_opacity="1" width="1/4" column_border_width="none" column_border_style="solid"][nectar_food_menu_item style="default" item_name_heading_tag="h4" item_name="Juices" text="$9" item_price="$3" item_description="Orange, Apple, Vegetable, Strawberry, Blackberry, Lime"][/vc_column_inner][vc_column_inner column_padding="padding-2-percent" column_padding_position="all" background_color_opacity="1" width="1/4" column_border_width="none" column_border_style="solid"][nectar_food_menu_item style="default" item_name_heading_tag="h4" item_name="Water" text="$9" item_price="$1" item_description="Tap, Distilled, Reverse Osmosis "][/vc_column_inner][/vc_row_inner][/tab][tab title="Lunch" id="1486682634354-4-7" tab_id="1483371745398-1"][vc_row_inner column_margin="default" top_padding="30" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in" column_padding="padding-4-percent" column_padding_position="all" background_color_opacity="1" width="1/2" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1486682668056{margin-bottom: 30px !important;}"]
<h5>Appetizers</h5>
[/vc_column_text][nectar_food_menu_item style="line_between" item_name_heading_tag="h4" item_name="Shrimp Cocktail" text="$9" item_price="$10" item_description="A little shrimp, a little cocktail "][nectar_food_menu_item style="line_between" item_name_heading_tag="h4" item_name="Fried Mozzarella " text="$9" item_price="$8" item_description="It's just plain and simple, but also tasty"][nectar_food_menu_item style="line_between" item_name_heading_tag="h4" item_name="Classic California" text="$9" item_price="$11" item_description="You know it's good, just order it"][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in" column_padding="padding-4-percent" column_padding_position="all" background_color_opacity="1" width="1/2" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1486682675326{margin-bottom: 30px !important;}"]
<h5>Pasta</h5>
[/vc_column_text][nectar_food_menu_item style="line_between" item_name_heading_tag="h4" item_name="Nectar Linguine " text="$9" item_price="$15" item_description="The best pasta you'll ever eat"][nectar_food_menu_item style="line_between" item_name_heading_tag="h4" item_name="The Ravioli " text="$9" item_price="$17" item_description="Cooked to perfection by Chef Nectar "][nectar_food_menu_item style="line_between" item_name_heading_tag="h4" item_name="``Very Big`` Bowl" text="$9" item_price="$22" item_description="Made to share, four separate samples in one "][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in" column_padding="padding-4-percent" column_padding_position="all" background_color_opacity="1" width="1/2" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1486682685532{margin-bottom: 30px !important;}"]
<h5>Sandwiches</h5>
[/vc_column_text][nectar_food_menu_item style="line_between" item_name_heading_tag="h4" item_name="The Italian" text="$9" item_price="$13" item_description="Smoked ham, peppers and your choice of cheese "][nectar_food_menu_item style="line_between" item_name_heading_tag="h4" item_name="Double Decker Club" text="$9" item_price="$12" item_description="Grilled chicken, tomato and cheese "][nectar_food_menu_item style="line_between" item_name_heading_tag="h4" item_name="Classic BLT" text="$9" item_price="$13" item_description="Bacon, Lettuce and Tomatoes "][nectar_food_menu_item style="line_between" item_name_heading_tag="h4" item_name="``Can't make up my mind``" text="$9" item_price="$12" item_description="Served with a sample of everything"][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in" column_padding="padding-4-percent" column_padding_position="all" background_color_opacity="1" width="1/2" column_border_width="2px" column_border_color="#3452ff" column_border_style="double_offset" enable_border_animation="true"][vc_column_text css=".vc_custom_1486682692238{margin-bottom: 30px !important;}"]
<h5>Lunch Specials</h5>
[/vc_column_text][nectar_food_menu_item style="line_between" item_name_heading_tag="h4" item_name="Salient Style" text="$9" item_price="$17" item_description="Warn homemade chicken with melted cheese "][nectar_food_menu_item style="line_between" item_name_heading_tag="h4" item_name="The Really Good Stuff" text="$9" item_price="$12" item_description="It's just plain and simple"][nectar_food_menu_item style="line_between" item_name_heading_tag="h4" item_name="Nectar's Choice" text="$9" item_price="$11" item_description="Ask your server for more details"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" top_padding="60" text_align="left" css=".vc_custom_1486083303611{padding-right: 2% !important;padding-left: 2% !important;}"][vc_column_inner column_padding="padding-2-percent" column_padding_position="all" background_color_opacity="1" width="1/4" column_border_width="none" column_border_style="solid"][nectar_food_menu_item style="default" item_name_heading_tag="h4" item_name="Sodas" text="$9" item_price="$4" item_description="Coca cola, Pepsi, Sprite, Fanta, Nectar Soda, Salient Fizz"][/vc_column_inner][vc_column_inner column_padding="padding-2-percent" column_padding_position="all" background_color_opacity="1" width="1/4" column_border_width="none" column_border_style="solid"][nectar_food_menu_item style="default" item_name_heading_tag="h4" item_name="Tea" text="$9" item_price="$6" item_description="Green, Red, Black, Yellow, White Warm &amp; Hot"][/vc_column_inner][vc_column_inner column_padding="padding-2-percent" column_padding_position="all" background_color_opacity="1" width="1/4" column_border_width="none" column_border_style="solid"][nectar_food_menu_item style="default" item_name_heading_tag="h4" item_name="Juices" text="$9" item_price="$3" item_description="Orange, Apple, Vegetable, Strawberry, Blackberry, Lime"][/vc_column_inner][vc_column_inner column_padding="padding-2-percent" column_padding_position="all" background_color_opacity="1" width="1/4" column_border_width="none" column_border_style="solid"][nectar_food_menu_item style="default" item_name_heading_tag="h4" item_name="Water" text="$9" item_price="$1" item_description="Tap, Distilled, Reverse Osmosis "][/vc_column_inner][/vc_row_inner][/tab][tab title="Dinner" id="1486683129769-4-9" tab_id="1483371745354-1"][vc_row_inner column_margin="default" top_padding="30" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in" column_padding="padding-4-percent" column_padding_position="all" background_color_opacity="1" width="1/2" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1486682668056{margin-bottom: 30px !important;}"]
<h5>Appetizers</h5>
[/vc_column_text][nectar_food_menu_item style="line_between" item_name_heading_tag="h4" item_name="Fried Mozzarella " text="$9" item_price="$8" item_description="It's just plain and simple, but also tasty"][nectar_food_menu_item style="line_between" item_name_heading_tag="h4" item_name="Shrimp Cocktail" text="$9" item_price="$10" item_description="A little shrimp, a little cocktail "][nectar_food_menu_item style="line_between" item_name_heading_tag="h4" item_name="Classic California" text="$9" item_price="$11" item_description="You know it's good, just order it"][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in" column_padding="padding-4-percent" column_padding_position="all" background_color_opacity="1" width="1/2" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1486683213935{margin-bottom: 30px !important;}"]
<h5>Salads</h5>
[/vc_column_text][nectar_food_menu_item style="line_between" item_name_heading_tag="h4" item_name="The Caesar " text="$9" item_price="$13" item_description="Served with choice of chicken &amp; cheese "][nectar_food_menu_item style="line_between" item_name_heading_tag="h4" item_name="Stuffed Tomato" text="$9" item_price="$12" item_description="Chicken Salad stuffed with Roma Tomatoes "][nectar_food_menu_item style="line_between" item_name_heading_tag="h4" item_name="Club Salda" text="$9" item_price="$12" item_description="Fresh romaine lettuce &amp; grated cheese"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in" column_padding="padding-4-percent" column_padding_position="all" background_color_opacity="1" width="1/2" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1486683207946{margin-bottom: 30px !important;}"]
<h5>Pasta</h5>
[/vc_column_text][nectar_food_menu_item style="line_between" item_name_heading_tag="h4" item_name="The Ravioli " text="$9" item_price="$27" item_description="Cooked to perfection by Chef Nectar "][nectar_food_menu_item style="line_between" item_name_heading_tag="h4" item_name="Nectar Linguine " text="$9" item_price="$25" item_description="The best pasta you'll ever eat"][nectar_food_menu_item style="line_between" item_name_heading_tag="h4" item_name="Vodka Sauce" text="$9" item_price="$22" item_description="With Grilled chicken, tomato and cheese "][nectar_food_menu_item style="line_between" item_name_heading_tag="h4" item_name="``Very Big`` Bowl" text="$9" item_price="$22" item_description="Made to share, four separate samples in one "][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in" column_padding="padding-4-percent" column_padding_position="all" background_color_opacity="1" width="1/2" column_border_width="2px" column_border_color="#3452ff" column_border_style="double_offset" enable_border_animation="true"][vc_column_text css=".vc_custom_1486683185332{margin-bottom: 30px !important;}"]
<h5>Steak &amp; Seafood</h5>
[/vc_column_text][nectar_food_menu_item style="line_between" item_name_heading_tag="h4" item_name="Salient Filet" text="$9" item_price="$37" item_description="Served best medium rare "][nectar_food_menu_item style="line_between" item_name_heading_tag="h4" item_name="Oscar Salient FIlet" text="$9" item_price="$42" item_description="The Salient Filet with crab meat"][nectar_food_menu_item style="line_between" item_name_heading_tag="h4" item_name="Nectar's Choice" text="$9" item_price="$31" item_description="Ask your server for more details"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" top_padding="60" text_align="left" css=".vc_custom_1486083303611{padding-right: 2% !important;padding-left: 2% !important;}"][vc_column_inner column_padding="padding-2-percent" column_padding_position="all" background_color_opacity="1" width="1/4" column_border_width="none" column_border_style="solid"][nectar_food_menu_item style="default" item_name_heading_tag="h4" item_name="Sodas" text="$9" item_price="$4" item_description="Coca cola, Pepsi, Sprite, Fanta, Nectar Soda, Salient Fizz"][/vc_column_inner][vc_column_inner column_padding="padding-2-percent" column_padding_position="all" background_color_opacity="1" width="1/4" column_border_width="none" column_border_style="solid"][nectar_food_menu_item style="default" item_name_heading_tag="h4" item_name="Tea" text="$9" item_price="$6" item_description="Green, Red, Black, Yellow, White Warm &amp; Hot"][/vc_column_inner][vc_column_inner column_padding="padding-2-percent" column_padding_position="all" background_color_opacity="1" width="1/4" column_border_width="none" column_border_style="solid"][nectar_food_menu_item style="default" item_name_heading_tag="h4" item_name="Juices" text="$9" item_price="$3" item_description="Orange, Apple, Vegetable, Strawberry, Blackberry, Lime"][/vc_column_inner][vc_column_inner column_padding="padding-2-percent" column_padding_position="all" background_color_opacity="1" width="1/4" column_border_width="none" column_border_style="solid"][nectar_food_menu_item style="default" item_name_heading_tag="h4" item_name="Water" text="$9" item_price="$1" item_description="Tap, Distilled, Reverse Osmosis "][/vc_column_inner][/vc_row_inner][/tab][tab title="Drink List" id="1486683598327-4-5" tab_id="1483371745312-1"][vc_row_inner column_margin="default" top_padding="30" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in" column_padding="padding-4-percent" column_padding_position="all" background_color_opacity="1" width="1/2" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1486683632214{margin-bottom: 30px !important;}"]
<h5>Reds</h5>
[/vc_column_text][nectar_food_menu_item style="line_between" item_name_heading_tag="h4" item_name="Gina Pinot Noir" text="$9" item_price="$8" item_description="Black cherry notes, light bodied "][nectar_food_menu_item style="line_between" item_name_heading_tag="h4" item_name="Guilty Pleasure Merlot" text="$9" item_price="$10" item_description="Medium to full bodied, premium taste"][nectar_food_menu_item style="line_between" item_name_heading_tag="h4" item_name="Classic California" text="$9" item_price="$11" item_description="You know it's good, just order it"][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in" column_padding="padding-4-percent" column_padding_position="all" background_color_opacity="1" width="1/2" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1486683638682{margin-bottom: 30px !important;}"]
<h5>Whites</h5>
[/vc_column_text][nectar_food_menu_item style="line_between" item_name_heading_tag="h4" item_name="Flawless Pinot Grigo" text="$9" item_price="$10" item_description="Fresh, medium bodied "][nectar_food_menu_item style="line_between" item_name_heading_tag="h4" item_name="Sauvignon Blanc " text="$9" item_price="$12" item_description="The perfect medium bodied white"][nectar_food_menu_item style="line_between" item_name_heading_tag="h4" item_name="Chardon-hey " text="$9" item_price="$12" item_description="Chardonnay with a little twist"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in" column_padding="padding-4-percent" column_padding_position="all" background_color_opacity="1" width="1/2" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1486683647410{margin-bottom: 30px !important;}"]
<h5>Rose</h5>
[/vc_column_text][nectar_food_menu_item style="line_between" item_name_heading_tag="h4" item_name="Pacific Heights" text="$9" item_price="$12" item_description="A fun light tasty addition "][nectar_food_menu_item style="line_between" item_name_heading_tag="h4" item_name="Friday night out" text="$9" item_price="$11" item_description="Medium - full bodied mix"][nectar_food_menu_item style="line_between" item_name_heading_tag="h4" item_name="The Gavel" text="$9" item_price="$12" item_description="Earthy flavorsome notes "][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in" column_padding="padding-4-percent" column_padding_position="all" background_color_opacity="1" width="1/2" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1486683943715{margin-bottom: 30px !important;}"]
<h5>Blends</h5>
[/vc_column_text][nectar_food_menu_item style="line_between" item_name_heading_tag="h4" item_name="Petit Verdot " text="$9" item_price="$17" item_description="Once you try it, you'll never want anything else"][nectar_food_menu_item style="line_between" item_name_heading_tag="h4" item_name="Shiraz Dom" text="$9" item_price="$12" item_description="The drink to end your dinner with"][nectar_food_menu_item style="line_between" item_name_heading_tag="h4" item_name="Nectar's Choice" text="$9" item_price="$17" item_description="Ask your server for more details"][/vc_column_inner][/vc_row_inner][/tab][/tabbed_section][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Enticing Dual Fancy Box', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['general'] .', '. $cat_display_names['about'];
$data['custom_class'] = 'general about date-04-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/dual-fancy-box.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" bg_color="#f7f7f7" scene_position="center" text_color="dark" text_align="left" overlay_strength="0.3"][vc_column column_padding="padding-1-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="padding-1-percent" column_padding_position="all" background_color_opacity="1" width="1/2" column_border_width="none" column_border_style="solid"][fancy_box link_new_tab="true" color="Accent-Color" min_height="100" link_url="https://www.google.com/maps" link_text="Get Directions"]
<h3>San Francisco</h3>
123 Nectar St. Suite 4917
hello@themenectar.com[/fancy_box][/vc_column_inner][vc_column_inner column_padding="padding-1-percent" column_padding_position="all" background_color_opacity="1" width="1/2" column_border_width="none" column_border_style="solid"][fancy_box image_url="6135" link_new_tab="true" color="Extra-Color-1" min_height="100" link_url="https://www.google.com/maps" link_text="Get Directions"]
<h3>British Columbia</h3>
58 Nectar Rd. Apt 2C
hello@themenectar.com[/fancy_box][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Innovative Gradient Hero', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['hero_section'] .', '. $cat_display_names['about'];
$data['custom_class'] = 'hero_section about';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/gradient-header.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-adventure.webp" bg_position="center center" bg_repeat="no-repeat" bg_color="#454156" scene_position="center" text_color="light" text_align="left" top_padding="9%" bottom_padding="9%" id="intro" row_name="Intro" enable_gradient="true" color_overlay="#0a0a0a" color_overlay_2="rgba(102,102,102,0.74)" gradient_direction="left_b_to_right_t" overlay_strength="0.95"][vc_column centered_text="true" column_padding="padding-6-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid"][vc_custom_heading text="We craft experiences from customer information" font_container="tag:h1|font_size:83|text_align:center|color:%23ffffff|line_height:96px" use_theme_fonts="yes"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left" css=".vc_custom_1485550874781{margin-top: -10px !important;}"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid" delay="100"][vc_custom_heading text="We're changing the way people are connected by stories.
" font_container="tag:p|text_align:center|color:rgba(255%2C255%2C255%2C0.7)" use_theme_fonts="yes"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="grow-in" column_padding="padding-4-percent" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid" delay="200"][nectar_btn size="large" button_style="regular" button_color_2="Accent-Color" icon_family="iconsmind" url="#" text="Show Me How" icon_iconsmind="iconsmind-Triangle-ArrowRight"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Modern Recent Posts Dark', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['blog'];
$data['custom_class'] = 'blog date-03-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/recent-posts-parallax.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-adventure.webp" bg_position="center center" bg_repeat="no-repeat" parallax_bg="true" parallax_bg_speed="fast" bg_color="#eaeaea" scene_position="center" text_color="light" text_align="left" top_padding="7%" bottom_padding="7%" color_overlay="#0a0a0a" overlay_strength="0.8"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][recent_posts style="classic_enhanced_alt" category="all" columns="3" posts_per_page="3"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" centered_text="true" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid"][nectar_btn size="large" button_style="see-through" button_color_2="Accent-Color" icon_family="iconsmind" url="#" text="View All Posts" icon_iconsmind="iconsmind-Triangle-ArrowRight"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Weather Animated Icon Columns', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['icons'] .', '. $cat_display_names['about'];
$data['custom_class'] = 'icons about';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/weather-icons.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" bg_color="#ffffff" scene_position="center" text_color="dark" text_align="center" top_padding="3%" bottom_padding="3%" overlay_strength="0.3"][vc_column column_padding="padding-5-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/4" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid"][nectar_icon icon_family="linea" enable_animation="true" animation_speed="medium" icon_style="default" icon_color="Extra-Color-1" icon_padding="10px" icon_linea="icon-weather-sunset" icon_size="64"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid"][divider line_type="No Line" custom_height="10"][vc_column_text]<i>Item No. 01</i>[/vc_column_text][divider line_type="No Line" custom_height="10"][vc_column_text]
<h3>Summer</h3>
Quisque molestie elementum quam molestie malesuada. In sagittis urna vitae blandit molestie. Nam aliquet dui neque, eget tincidunt sem.[/vc_column_text][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="padding-5-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/4" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid"][nectar_icon icon_family="linea" enable_animation="true" animation_speed="medium" icon_style="default" icon_color="Extra-Color-1" icon_padding="10px" icon_linea="icon-weather-fog-halfmoon" icon_size="64" animation_delay="300"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid" delay="500"][divider line_type="No Line" custom_height="10"][vc_column_text]<i>Item No. 02</i>[/vc_column_text][divider line_type="No Line" custom_height="10"][vc_column_text]
<h3>Fall</h3>
Quisque molestie elementum quam molestie malesuada. In sagittis urna vitae blandit molestie. Nam aliquet dui neque, eget tincidunt sem.[/vc_column_text][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="padding-5-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/4" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid"][nectar_icon icon_family="linea" enable_animation="true" animation_speed="medium" icon_style="default" icon_color="Extra-Color-1" icon_padding="10px" icon_linea="icon-weather-snow-halfmoon" icon_size="64" animation_delay="600"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid" delay="1000"][divider line_type="No Line" custom_height="10"][vc_column_text]<i>Item No. 03</i>[/vc_column_text][divider line_type="No Line" custom_height="10"][vc_column_text]
<h3>Winter</h3>
Quisque molestie elementum quam molestie malesuada. In sagittis urna vitae blandit molestie. Nam aliquet dui neque, eget tincidunt sem.[/vc_column_text][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="padding-5-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/4" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid"][nectar_icon icon_family="linea" enable_animation="true" animation_speed="medium" icon_style="default" icon_color="Extra-Color-1" icon_padding="10px" icon_linea="icon-weather-downpour-sun" icon_size="64" animation_delay="900"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid" delay="1500"][divider line_type="No Line" custom_height="10"][vc_column_text]<i>Item No. 04</i>[/vc_column_text][divider line_type="No Line" custom_height="10"][vc_column_text]
<h3>Spring</h3>
Quisque molestie elementum quam molestie malesuada. In sagittis urna vitae blandit molestie. Nam aliquet dui neque, eget tincidunt sem.[/vc_column_text][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Exciting Services', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['services'] .', '. $cat_display_names['icons'];
$data['custom_class'] = 'services icons date-10-Sep-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/services.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" equal_height="yes" content_placement="top" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-adventure.webp" bg_position="center center" bg_repeat="no-repeat" parallax_bg="true" parallax_bg_speed="fast" bg_color="#1e1e1e" scene_position="center" text_color="light" text_align="left" top_padding="10%" bottom_padding="10%" enable_gradient="true" color_overlay="#0069ff" color_overlay_2="#ff3a6f" gradient_direction="left_b_to_right_t" overlay_strength="0.95"][vc_column enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_custom_heading text="We Offer Awesome Services" font_container="tag:h2|font_size:88px|text_align:left|line_height:97px" google_fonts="font_family:Roboto%3A100%2C100italic%2C300%2C300italic%2Cregular%2Citalic%2C500%2C500italic%2C700%2C700italic%2C900%2C900italic|font_style:700%20bold%20regular%3A700%3Anormal" css_animation="none"][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/2" column_border_width="none" column_border_style="solid"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color="white" icon_padding="0px" icon_iconsmind="iconsmind-Diamond" margin_top="20"][vc_column_text css_animation="fadeInUp" css=".vc_custom_1485371914654{margin-bottom: 15px !important;}"]
<h4>Design</h4>
[/vc_column_text][vc_custom_heading text="Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut elit tellus amet" font_container="tag:p|text_align:left|color:rgba(255%2C255%2C255%2C0.6)" use_theme_fonts="yes" css_animation="fadeInUp" css=".vc_custom_1485637636687{padding-right: 10% !important;}"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color="white" icon_padding="0px" icon_iconsmind="iconsmind-Helicopter" margin_top="30"][vc_column_text css_animation="fadeInUp" css=".vc_custom_1485371926430{margin-bottom: 15px !important;}"]
<h4>Deploy</h4>
[/vc_column_text][vc_custom_heading text="Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut elit tellus amet" font_container="tag:p|text_align:left|color:rgba(255%2C255%2C255%2C0.6)" use_theme_fonts="yes" css_animation="fadeInUp" css=".vc_custom_1485637641512{padding-right: 10% !important;}"][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/2" column_border_width="none" column_border_style="solid"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color="white" icon_padding="0px" icon_iconsmind="iconsmind-Gear-2" margin_top="20"][vc_column_text css_animation="fadeInUp" css=".vc_custom_1485371920498{margin-bottom: 15px !important;}"]
<h4>Develop</h4>
[/vc_column_text][vc_custom_heading text="Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut elit tellus amet" font_container="tag:p|text_align:left|color:rgba(255%2C255%2C255%2C0.6)" use_theme_fonts="yes" css_animation="fadeInUp" css=".vc_custom_1485637652526{padding-right: 10% !important;}"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color="white" icon_padding="0px" icon_iconsmind="iconsmind-Life-Jacket" margin_top="30"][vc_column_text css_animation="fadeInUp" css=".vc_custom_1485371933853{margin-bottom: 15px !important;}"]
<h4>Support</h4>
[/vc_column_text][vc_custom_heading text="Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut elit tellus amet" font_container="tag:p|text_align:left|color:rgba(255%2C255%2C255%2C0.6)" use_theme_fonts="yes" css_animation="fadeInUp" css=".vc_custom_1485637646805{padding-right: 10% !important;}"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Gradient Testimonials With Star Ratings', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['testimonials'];
$data['custom_class'] = 'testimonials date-15-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/new-testimonials.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" bg_color="#f2f2f2" scene_position="center" text_color="dark" text_align="left" top_padding="7%" bottom_padding="7%" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][testimonial_slider style="multiple_visible_minimal" star_rating_color="extra-color-gradient-1"][testimonial star_rating="100%" title="Testimonial" id="1485890278273-28f9f-ae83" name="Aura Brooks" subtitle="Graphic Designer, Owl Eyes" quote="By far the best team I've ever worked with. They truly understood the look I was going for and completely nailed it! I would highly recommend them as a company, you simply just won't find any better team! " tab_id="1485906261983-10"] Click the edit button to add your testimonial. [/testimonial][testimonial star_rating="80%" title="Testimonial" id="1485890278280-18f9f-ae83" name="Eve Crawford" subtitle="Product Designer, That Biz" quote="It was really fun getting to know the team during the project. They were all helpful in answering my questions and made me feel completely at ease. The design ended up being twice as good as I could have ever envisioned!" tab_id="1485906261988-8"] Click the edit button to add your testimonial. [/testimonial][testimonial star_rating="91%" title="Testimonial" id="1485890278299-28f9f-ae83" name="Jack Graham" subtitle="Co founder, Coffee Inc" quote="I'm wondering why I never contacted these guys sooner! Seriously, they all have commendable talent in their respective fields and knocked my concept out of the ballpark. Thanks for an amazing experience!" tab_id="1485906262005-7"] Click the edit button to add your testimonial. [/testimonial][testimonial star_rating="91%" title="Testimonial" id="1485890278307-98f9f-ae83" name="Zak Reid" subtitle="Instructor, Skate Nao" quote="Salient is by far the most astonishing WP theme out there! I literally could not be happier that I chose to buy your theme! Your regular updates and superb attention to detail blows me away every time I visit my new site! " tab_id="1485906262024-5"] Click the edit button to add your testimonial. [/testimonial][testimonial star_rating="100%" title="Testimonial" id="1485890278307-98f9f-ae33" name="Jake Smith" subtitle="Instructor, Skate Nao" quote="Salient is by far the most astonishing WP theme out there! I literally could not be happier that I chose to buy your theme! Your regular updates and superb attention to detail blows me away every time I visit my new site! " tab_id="1485906262039-2"] Click the edit button to add your testimonial. [/testimonial][/testimonial_slider][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Minimal Dark Testimonials', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['testimonials'];
$data['custom_class'] = 'testimonials date-05-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/dark-testimonials.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" bg_color="#202020" scene_position="center" text_color="light" text_align="left" top_padding="7%" bottom_padding="7%" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][testimonial_slider style="multiple_visible_minimal" star_rating_color="accent-color" add_border="true"][testimonial star_rating="100%" title="Testimonial" id="1485890278273-2fa6a-5d72" name="Aura Brooks" subtitle="Graphic Designer, Owl Eyes" quote="By far the best team I've ever worked with. They truly understood the look I was going for and completely nailed it! I would highly recommend them as a company, you simply just won't find any better team! " tab_id="1485906178798-1"] Click the edit button to add your testimonial. [/testimonial][testimonial star_rating="80%" title="Testimonial" id="1485890278280-1fa6a-5d72" name="Eve Crawford" subtitle="Product Designer, That Biz" quote="It was really fun getting to know the team during the project. They were all helpful in answering my questions and made me feel completely at ease. The design ended up being twice as good as I could have ever envisioned!" tab_id="1485906178802-3"] Click the edit button to add your testimonial. [/testimonial][testimonial star_rating="91%" title="Testimonial" id="1485890278299-2fa6a-5d72" name="Jack Graham" subtitle="Co founder, Coffee Inc" quote="I'm wondering why I never contacted these guys sooner! Seriously, they all have commendable talent in their respective fields and knocked my concept out of the ballpark. Thanks for an amazing experience!" tab_id="1485906178807-9"] Click the edit button to add your testimonial. [/testimonial][testimonial star_rating="91%" title="Testimonial" id="1485890278307-9fa6a-5d72" name="Zak Reid" subtitle="Instructor, Skate Nao" quote="Salient is by far the most astonishing WP theme out there! I literally could not be happier that I chose to buy your theme! Your regular updates and superb attention to detail blows me away every time I visit my new site! " tab_id="1485906178826-9"] Click the edit button to add your testimonial. [/testimonial][testimonial star_rating="100%" title="Testimonial" id="1485890278307-9fa6a-5d61" name="Jake Smith" subtitle="Instructor, Skate Nao" quote="Salient is by far the most astonishing WP theme out there! I literally could not be happier that I chose to buy your theme! Your regular updates and superb attention to detail blows me away every time I visit my new site! " tab_id="1485906178832-7"] Click the edit button to add your testimonial. [/testimonial][/testimonial_slider][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'About Me - Fullscreen vCard', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['about'] .', '. $cat_display_names['counters'];
$data['custom_class'] = 'about counters date-10-Sep-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/about-me.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" equal_height="yes" content_placement="middle" full_height="yes" columns_placement="stretch" bg_color="#232323" scene_position="center" text_color="dark" text_align="left" overlay_strength="0.3"][vc_column column_padding="padding-10-percent" column_padding_position="all" background_color="#ffffff" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_custom_heading text="Philip Martinez" font_container="tag:h5|text_align:left|color:%23bfbfbf" use_theme_fonts="yes" css=".vc_custom_1485193607322{margin-bottom: 10px !important;}"][vc_custom_heading text="Creator of quality designs and thinker of fresh ideas." font_container="tag:h2|font_size:40|text_align:left|line_height:50px" use_theme_fonts="yes"][vc_column_text css=".vc_custom_1485195197203{margin-top: 30px !important;margin-bottom: 30px !important;}"]Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. A small river named Duden flows by their place and supplies it with the necessary regelialia[/vc_column_text][bar color="extra-color-gradient-1" title="Web Design" percent="70"][bar color="extra-color-gradient-1" title="UI Design" percent="85"][bar color="extra-color-gradient-1" title="Video Editing" percent="65"][divider line_type="No Line" custom_height="100"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color="black" open_new_tab="true" icon_padding="20px" icon_iconsmind="iconsmind-Facebook-2" icon_size="29" margin_left="-20px" url="#"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color="black" open_new_tab="true" icon_padding="20px" icon_iconsmind="iconsmind-Reddit" icon_size="29" url="#"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color="black" open_new_tab="true" icon_padding="20px" icon_iconsmind="iconsmind-Dribble" icon_size="29" url="#"][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/webp/large-business.webp" enable_bg_scale="true" column_shadow="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Section CTA', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['cta'];
$data['custom_class'] = 'cta';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/cta-alt-see-through-btn.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" equal_height="yes" content_placement="middle" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-mountain.webp" bg_position="center center" bg_repeat="no-repeat" bg_color="#1e1e1e" scene_position="center" text_color="light" text_align="left" top_padding="5%" bottom_padding="5%" color_overlay="#242838" overlay_strength="0.95"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/6" column_border_width="none" column_border_style="solid"][/vc_column_inner][vc_column_inner column_padding="padding-2-percent" column_padding_position="left-right" centered_text="true" background_color_opacity="1" width="2/3" column_border_width="none" column_border_style="solid"][vc_custom_heading text="Your turn to make a move" font_container="tag:h2|font_size:52|text_align:center|line_height:52px" use_theme_fonts="yes"][divider line_type="No Line" custom_height="10"][vc_custom_heading text="Like Nothing You've Seen. Sign Up Today &amp; Experience Salient" font_container="tag:p|font_size:18|text_align:center|color:rgba(255%2C255%2C255%2C0.7)|line_height:26px" use_theme_fonts="yes"][nectar_btn size="large" button_style="see-through-3" color_override="#ff3067" hover_color_override="#ff3067" hover_text_color_override="#ffffff" icon_family="fontawesome" url="#" icon_fontawesome="fa fa-long-arrow-right" margin_top="25"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/6" column_border_width="none" column_border_style="solid"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Intense Colorful CTA Section', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['hero_section'].', '. $cat_display_names['cta'];
$data['custom_class'] = 'hero_section cta';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/cta-green.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_color="#3452ff" scene_position="center" text_color="light" text_align="left" top_padding="15%" bottom_padding="15%" overlay_strength="0.3"][vc_column centered_text="true" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1485448432282{margin-bottom: 5px !important;}"]
<h5>Look Inside</h5>
[/vc_column_text][vc_column_text css=".vc_custom_1485448368496{margin-bottom: 45px !important;}" max_width="800"]
<h2>Discover Salient App With Our <em>Free Download</em></h2>
[/vc_column_text][divider line_type="No Line" custom_height="10"][nectar_btn size="jumbo" button_style="see-through" button_color_2="Accent-Color" icon_family="fontawesome" url="#" text="Download Now" icon_fontawesome="fa fa-apple"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Motion Blur Milestone', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['counters'] .', '. $cat_display_names['general'];
$data['custom_class'] = 'general counters date-10-Aug-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/milestone-motion-blur.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_color="#ffffff" scene_position="center" text_color="dark" text_align="right" top_padding="8%" bottom_padding="8%" id="reasons" overlay_strength="0.8"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][milestone symbol_position="after" color="Accent-Color" effect="motion_blur" symbol_alignment="Superscript" number="35" symbol="*" number_font_size="200" symbol_font_size="60"][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/2" column_border_width="none" column_border_style="solid"][divider line_type="No Line" custom_height="20"][vc_column_text]
<h5 style="text-align: left;"><span style="color: #933ded;">Thousand </span></h5>
<h4 style="text-align: left;"><span style="color: #933ded;">Theme Users</span></h4>
<p style="text-align: left;">It takes a lot to be one of the most trusted themes on the market. Read more below why users keep coming back over and over again.</p>

[/vc_column_text][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/2" column_border_width="none" column_border_style="solid"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'Modern Service List', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['services'] .', '. $cat_display_names['icons'];
$data['custom_class'] = 'icons services';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/basic-services.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_color="#ffffff" scene_position="center" text_color="dark" text_align="left" top_padding="10%" bottom_padding="10%" overlay_strength="0.5"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid"][vc_custom_heading text="Our Specialties " font_container="tag:h2|font_size:48px|text_align:center|line_height:57px" use_theme_fonts="yes" css_animation="none"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/4" column_border_width="none" column_border_style="solid"][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/2" column_border_width="none" column_border_style="solid" delay="50"][vc_custom_heading text="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. A small river named Duden flows by their place and supplies it with the necessary regelialia." font_container="tag:p|text_align:center|color:rgba(10%2C10%2C10%2C0.65)" use_theme_fonts="yes" css_animation="none"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/4" column_border_width="none" column_border_style="solid"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" top_padding="20" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-3-percent" column_padding_position="all" centered_text="true" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color="grey" icon_padding="0px" icon_iconsmind="iconsmind-Umbrella-2" url="#"][vc_column_text css_animation="fadeInUp" css=".vc_custom_1485629426540{margin-bottom: 15px !important;}"]
<h4>Customer Support</h4>
[/vc_column_text][vc_custom_heading text="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts" font_container="tag:p|text_align:center|color:rgba(10%2C10%2C10%2C0.65)" use_theme_fonts="yes" css_animation="fadeInUp"][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-3-percent" column_padding_position="all" centered_text="true" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color="grey" icon_padding="0px" icon_iconsmind="iconsmind-Diamond" url="#"][vc_column_text css_animation="fadeInUp" css=".vc_custom_1485629480716{margin-bottom: 15px !important;}"]
<h4>Web Design</h4>
[/vc_column_text][vc_custom_heading text="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts" font_container="tag:p|text_align:center|color:rgba(10%2C10%2C10%2C0.65)" use_theme_fonts="yes" css_animation="fadeInUp"][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-3-percent" column_padding_position="all" centered_text="true" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color="grey" icon_padding="0px" icon_iconsmind="iconsmind-Trophy-2" url="#"][vc_column_text css_animation="fadeInUp" css=".vc_custom_1485629439769{margin-bottom: 15px !important;}"]
<h4>Quality Assurance</h4>
[/vc_column_text][vc_custom_heading text="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts" font_container="tag:p|text_align:center|color:rgba(10%2C10%2C10%2C0.65)" use_theme_fonts="yes" css_animation="fadeInUp"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" top_padding="20" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-3-percent" column_padding_position="all" centered_text="true" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color="grey" icon_padding="0px" icon_iconsmind="iconsmind-T-Shirt" url="#"][vc_column_text css_animation="fadeInUp" css=".vc_custom_1485629445076{margin-bottom: 15px !important;}"]
<h4>eCommerce</h4>
[/vc_column_text][vc_custom_heading text="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts" font_container="tag:p|text_align:center|color:rgba(10%2C10%2C10%2C0.65)" use_theme_fonts="yes" css_animation="fadeInUp"][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-3-percent" column_padding_position="all" centered_text="true" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color="grey" icon_padding="0px" icon_iconsmind="iconsmind-Wolf" url="#"][vc_column_text css_animation="fadeInUp" css=".vc_custom_1485629457675{margin-bottom: 15px !important;}"]
<h4>Event Planning</h4>
[/vc_column_text][vc_custom_heading text="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts" font_container="tag:p|text_align:center|color:rgba(10%2C10%2C10%2C0.65)" use_theme_fonts="yes" css_animation="fadeInUp"][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-3-percent" column_padding_position="all" centered_text="true" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color="grey" icon_padding="0px" icon_iconsmind="iconsmind-Grave" url="#"][vc_column_text css_animation="fadeInUp" css=".vc_custom_1485629467303{margin-bottom: 15px !important;}"]
<h4>Killing Competition</h4>
[/vc_column_text][vc_custom_heading text="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts" font_container="tag:p|text_align:center|color:rgba(10%2C10%2C10%2C0.65)" use_theme_fonts="yes" css_animation="fadeInUp"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Three Fullwidth Columns', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['general'];
$data['custom_class'] = 'general';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/three-col-fullwidth.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" scene_position="center" text_color="light" text_align="left" top_padding="0" bottom_padding="0" overlay_strength="0.3" background_color="#171920"][vc_column enable_animation="true" animation="flip-in" column_padding="padding-4-percent" column_padding_position="all" background_color="#3452ff" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-left" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid" delay="500"][vc_column_text]
<h3>A Breeze To Build With</h3>
Take full control of the power Salient has to offer with our new exciting page builder. You'll be grinning in delight when you see just how easy it is to create stunning layouts with little effort.[/vc_column_text][nectar_btn size="large" button_style="see-through" button_color_2="Accent-Color" icon_family="steadysets" url="#" text="Discover More" icon_steadysets="steadysets-icon-diamond" margin_top="20"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column enable_animation="true" animation="flip-in" column_padding="padding-4-percent" column_padding_position="all" background_color="#ff1e5a" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-left" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid" delay="500"][vc_column_text]
<h3>Tutorials To Help</h3>
The days of being overwhelmed by long documents without any visual guidance are over - We have an entire video tutorial series available for you that's narrated through the duration.[/vc_column_text][nectar_btn size="large" button_style="see-through" button_color_2="Accent-Color" icon_family="steadysets" url="#" text="See The Tutorials" icon_steadysets="steadysets-icon-screen" margin_top="20"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column enable_animation="true" animation="flip-in" column_padding="padding-4-percent" column_padding_position="all" background_color="#42d671" background_color_opacity="1" background_hover_color_opacity="1" font_color="#ffffff" column_shadow="none" width="1/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-left" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid" delay="500"][vc_column_text]
<h3>Show Off In Style</h3>
The looks &amp; functionality you've been dying for are finally easily accessible. We know you'll enjoy the freedom to showcase your content in the way that it deserves.[/vc_column_text][nectar_btn size="large" button_style="see-through" button_color_2="Accent-Color" icon_family="steadysets" url="#" text="Shine Like A Star" icon_steadysets="steadysets-icon-star" margin_top="20"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Interesting Milestones', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['counters'] .', '. $cat_display_names['about'];
$data['custom_class'] = 'counters about date-15-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/milestone-interesting.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-mountain.webp" background_image_mobile_hidden="true" bg_position="center top" bg_repeat="no-repeat" scene_position="center" text_color="dark" text_align="left" top_padding="13%" bottom_padding="13%" enable_gradient="true" color_overlay="#f2f2f2" color_overlay_2="rgba(242,242,242,0.01)" gradient_direction="top_to_bottom" overlay_strength="1"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/2" column_border_width="none" column_border_style="solid"][vc_custom_heading text="Business Increase" font_container="tag:h5|text_align:left|color:%23a5a5a5" use_theme_fonts="yes" css=".vc_custom_1486418466709{margin-bottom: 10px !important;}"][milestone heading_inherit="h5" symbol_position="after" subject_padding="2%" color="Accent-Color" effect="count" symbol_alignment="Superscript" milestone_alignment="left" number="87" symbol="%" number_font_size="92" symbol_font_size="40"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/2" column_border_width="none" column_border_style="solid"][vc_custom_heading text="New Accounts" font_container="tag:h5|text_align:left|color:%23a5a5a5" use_theme_fonts="yes" css=".vc_custom_1486418472478{margin-bottom: 10px !important;}"][milestone heading_inherit="h5" subject_padding="2%" color="Accent-Color" effect="count" milestone_alignment="left" number="247" number_font_size="92"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_custom_heading text="The Difference" font_container="tag:h5|text_align:left|color:%23a5a5a5" use_theme_fonts="yes" css=".vc_custom_1486418478917{margin-bottom: 10px !important;}"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid"][vc_custom_heading text="Experience true business performance increases" font_container="tag:h2|font_size:40|text_align:left|line_height:50px" use_theme_fonts="yes"][nectar_btn size="large" button_style="see-through-2" hover_text_color_override="#ffffff" icon_family="none" url="#" text="Learn More" margin_top="25"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Alternating Split Sections', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['general'] .', '. $cat_display_names['about'];
$data['custom_class'] = 'general about date-15-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/alt-split.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" equal_height="yes" content_placement="middle" bg_color="#ffffff" scene_position="center" text_color="dark" text_align="left" overlay_strength="0.3"][vc_column column_padding="padding-10-percent" column_padding_position="all" background_color="#f4f4f4" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid"][vc_custom_heading text="Our Company Values" font_container="tag:h5|text_align:left|color:%23bfbfbf" use_theme_fonts="yes" css=".vc_custom_1486408368541{margin-bottom: 10px !important;}"][vc_custom_heading text="Creator of quality designs and thinker of fresh ideas." font_container="tag:h2|font_size:40|text_align:left|line_height:50px" use_theme_fonts="yes"][vc_custom_heading text="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. A small river named Duden flows by their place and supplies it with the necessary regelialia" font_container="tag:p|text_align:left|color:rgba(10%2C10%2C10%2C0.6)" use_theme_fonts="yes"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/webp/large-adventure.webp" enable_bg_scale="true" column_shadow="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][/vc_row][vc_row type="full_width_content" full_screen_row_position="middle" equal_height="yes" content_placement="middle" bg_color="" scene_position="center" text_color="dark" text_align="left" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/webp/large-city.webp" enable_bg_scale="true" column_shadow="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][vc_column column_padding="padding-10-percent" column_padding_position="all" background_color="#ffffff" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid"][vc_custom_heading text="A Little Of Our Story" font_container="tag:h5|text_align:left|color:%23bfbfbf" use_theme_fonts="yes" css=".vc_custom_1486408382586{margin-bottom: 10px !important;}"][vc_custom_heading text="We were simply born to paint pixels for a living" font_container="tag:h2|font_size:40|text_align:left|line_height:50px" use_theme_fonts="yes"][vc_custom_heading text="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. A small river named Duden flows by their place and supplies it with the necessary regelialia" font_container="tag:p|text_align:left|color:rgba(10%2C10%2C10%2C0.6)" use_theme_fonts="yes"][nectar_btn size="large" button_style="see-through-2" hover_text_color_override="#ffffff" icon_family="none" url="#" text="See Our Story" margin_top="30"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Flawless Business Hero', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['hero_section'] .', '. $cat_display_names['about'];
$data['custom_class'] = 'hero_section about date-16-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/business-hero.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#ffffff" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-art.webp" bg_position="center center" background_image_loading="default" bg_repeat="no-repeat" scene_position="center" top_padding="4%" bottom_padding="4%" text_color="light" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" color_overlay="#0a0a0a" overlay_strength="0.5" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" parallax_bg="true" parallax_bg_speed="fast"][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_row_inner equal_height="yes" content_placement="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" top_padding="15%" bottom_padding="14%" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" offset="vc_col-lg-6 vc_col-md-6 vc_col-xs-12"][vc_column_text css_animation="fadeInUp" css=".vc_custom_1486426562428{margin-bottom: 15px !important;}"]
<h5>Let's Do This</h5>
[/vc_column_text][split_line_heading animation_type="line-reveal-by-space" font_style="h1" line_reveal_by_space_text_effect="default" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="We're Salient, A Creative Startup Based in Philly"][/split_line_heading][nectar_btn size="large" button_style="regular" button_color_2="Accent-Color" icon_family="default_arrow" url="#" text="Learn More" margin_top="25" css_animation="slideInUp"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/4" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" offset="vc_hidden-sm vc_hidden-xs"][vc_custom_heading text="" google_fonts="font_family:Roboto%3A100%2C100italic%2C300%2C300italic%2Cregular%2Citalic%2C500%2C500italic%2C700%2C700italic%2C900%2C900italic|font_style:100%20light%20regular%3A100%3Anormal"][/vc_column_inner][vc_column_inner column_padding="padding-6-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="bottom" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/4" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" offset="vc_col-xs-12"][nectar_video_lightbox link_style="play_button" video_url="https://www.youtube.com/watch?v=6oTurM7gESE"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="padding-2-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="top-bottom" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/4" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_column_text css_animation="fadeInUp" css=".vc_custom_1486426628130{margin-bottom: 15px !important;}"]
<h5>There For You</h5>
[/vc_column_text][vc_custom_heading text="Far far away, behind the word, far from the countries." font_container="tag:p|text_align:left|color:rgba(255%2C255%2C255%2C0.65)" use_theme_fonts="yes" css_animation="fadeInUp" css=".vc_custom_1486418797897{padding-right: 20% !important;}"][/vc_column_inner][vc_column_inner column_padding="padding-2-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="top-bottom" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/4" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_column_text css_animation="fadeInUp" css=".vc_custom_1486426637035{margin-bottom: 15px !important;}"]
<h5>Pristine Quality</h5>
[/vc_column_text][vc_custom_heading text="Far far away, behind the word, far from the countries." font_container="tag:p|text_align:left|color:rgba(255%2C255%2C255%2C0.65)" use_theme_fonts="yes" css_animation="fadeInUp" css=".vc_custom_1486418801921{padding-right: 20% !important;}"][/vc_column_inner][vc_column_inner column_padding="padding-2-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="top-bottom" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/4" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_column_text css_animation="fadeInUp" css=".vc_custom_1486426643514{margin-bottom: 15px !important;}"]
<h5>Heavily Awarded</h5>
[/vc_column_text][vc_custom_heading text="Far far away, behind the word, far from the countries." font_container="tag:p|text_align:left|color:rgba(255%2C255%2C255%2C0.65)" use_theme_fonts="yes" css_animation="fadeInUp" css=".vc_custom_1486418805797{padding-right: 20% !important;}"][/vc_column_inner][vc_column_inner column_padding="padding-2-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="top-bottom" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/4" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_column_text css_animation="fadeInUp" css=".vc_custom_1486426698874{margin-bottom: 15px !important;}"]
<h5>Documentation</h5>
[/vc_column_text][vc_custom_heading text="Far far away, behind the word, far from the countries." font_container="tag:p|text_align:left|color:rgba(255%2C255%2C255%2C0.65)" use_theme_fonts="yes" css_animation="fadeInUp" css=".vc_custom_1486418809890{padding-right: 20% !important;}"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Phone & Icon List', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['general'] .', '. $cat_display_names['icons'];
$data['custom_class'] = 'general icons  date-15-Aug-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/phone-icons.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_color="#ffffff" scene_position="center" text_color="dark" text_align="left" top_padding="10%" bottom_padding="10%" overlay_strength="0.5"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner equal_height="yes" content_placement="middle" column_margin="default" top_padding="20" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in" column_padding="padding-3-percent" column_padding_position="all" centered_text="true" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color="grey" icon_padding="0px" icon_iconsmind="iconsmind-Refresh" url="#"][vc_column_text css_animation="fadeInUp" css=".vc_custom_1485632968860{margin-bottom: 15px !important;}"]
<h4>AJAX Loading</h4>
[/vc_column_text][vc_custom_heading text="Far far away, behind the word mountains, far from the countries Vokalia place." font_container="tag:p|text_align:center|color:rgba(10%2C10%2C10%2C0.65)" use_theme_fonts="yes" css_animation="fadeInUp"][divider line_type="No Line" custom_height="40"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color="grey" icon_padding="0px" icon_iconsmind="iconsmind-T-Shirt" url="#"][vc_column_text css_animation="fadeInUp" css=".vc_custom_1485629445076{margin-bottom: 15px !important;}"]
<h4>eCommerce</h4>
[/vc_column_text][vc_custom_heading text="Far far away, behind the word mountains, far from the countries Vokalia place." font_container="tag:p|text_align:center|color:rgba(10%2C10%2C10%2C0.65)" use_theme_fonts="yes" css_animation="fadeInUp"][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" centered_text="true" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid"][image_with_animation image_url="http://54cb3baa74d4d851e8b7-2e7f88565dceb0a8192c6645d1f8b1b4.r12.cf2.rackcdn.com/phone-normal.jpg" alignment="" animation="None" box_shadow="none" max_width="100%"][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in" column_padding="padding-3-percent" column_padding_position="all" centered_text="true" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color="grey" icon_padding="0px" icon_iconsmind="iconsmind-Quill-2" url="#"][vc_column_text css_animation="fadeInUp" css=".vc_custom_1485632976739{margin-bottom: 15px !important;}"]
<h4>UI Design</h4>
[/vc_column_text][vc_custom_heading text="Far far away, behind the word mountains, far from the countries Vokalia place." font_container="tag:p|text_align:center|color:rgba(10%2C10%2C10%2C0.65)" use_theme_fonts="yes" css_animation="fadeInUp"][divider line_type="No Line" custom_height="40"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color="grey" icon_padding="0px" icon_iconsmind="iconsmind-Trophy-2" url="#"][vc_column_text css_animation="fadeInUp" css=".vc_custom_1485629439769{margin-bottom: 15px !important;}"]
<h4>Quality Assurance</h4>
[/vc_column_text][vc_custom_heading text="Far far away, behind the word mountains, far from the countries Vokalia place." font_container="tag:p|text_align:center|color:rgba(10%2C10%2C10%2C0.65)" use_theme_fonts="yes" css_animation="fadeInUp"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Cascading Image & Text Section', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['about'];
$data['custom_class'] = 'about date-29-Sep-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/image-highlight.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" equal_height="yes" content_placement="middle" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#6a6b6f" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-dark.webp" bg_position="left top" background_image_loading="default" bg_repeat="no-repeat" scene_position="center" top_padding="5%" bottom_padding="5%" text_color="light" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" id="built-by-riders" row_name="Built By Riders" color_overlay="#0a0a0a" overlay_strength="0.5" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none"][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][nectar_cascading_images image_1_bg_color="#2b4bff" image_1_offset_x_sign="+" image_1_offset_x="0%" image_1_offset_y_sign="+" image_1_offset_y="0%" image_1_rotate_sign="+" image_1_rotate="none" image_1_scale="1" image_1_animation="Grow In" image_1_padding="auto" image_1_box_shadow="none" image_1_max_width_desktop="100%" image_1_max_width_mobile="100%" image_1_image_width_mobile="default" image_2_url="https://themenectar.com/img/demo-media/unsplash/webp/350-450-nature.webp" image_2_offset_x_sign="+" image_2_offset_x="15%" image_2_offset_y_sign="+" image_2_offset_y="25%" image_2_rotate_sign="+" image_2_rotate="none" image_2_scale="1" image_2_animation="Grow In" image_2_padding="auto" image_2_box_shadow="none" image_2_max_width_desktop="100%" image_2_max_width_mobile="100%" image_2_image_width_mobile="default" image_3_url="https://themenectar.com/img/demo-media/unsplash/webp/500-400-adventure.webp" image_3_offset_x_sign="-" image_3_offset_x="25%" image_3_offset_y_sign="-" image_3_offset_y="25%" image_3_rotate_sign="+" image_3_rotate="none" image_3_scale="0.75" image_3_animation="Grow In" image_3_padding="auto" image_3_box_shadow="x_large_depth" image_3_max_width_desktop="100%" image_3_max_width_mobile="100%" image_3_image_width_mobile="default" image_4_offset_x_sign="+" image_4_offset_x="0%" image_4_offset_y_sign="+" image_4_offset_y="0%" image_4_rotate_sign="+" image_4_rotate="none" image_4_scale="1" image_4_animation="Fade In" image_4_padding="auto" image_4_box_shadow="none" image_4_max_width_desktop="100%" image_4_max_width_mobile="100%" image_4_image_width_mobile="default" element_sizing="default" image_loading="default" border_radius="none" overflow="visible"][/vc_column][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][nectar_animated_title heading_tag="h6" style="color-strip-reveal" color="Accent-Color" text="Handmade Quality"][vc_column_text]
<h2>Built By Actual Riders</h2>
[/vc_column_text][vc_column_text css=".vc_custom_1485702321346{margin-top: 20px !important;padding-right: 10% !important;}"]Everyone at Salient bike industries is a die hard rider, and what this translates into ultimately is a higher quality product. We know the trails you want to go on so rest assured; we know exactly what's needed to handle them.[/vc_column_text][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Gradient Pricing Columns', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['pricing'] .', '. $cat_display_names['services'];
$data['custom_class'] = 'pricing services date-29-Sep-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/gradient-pricing.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_color="#f7f7f7" scene_position="center" text_color="dark" text_align="left" top_padding="6%" bottom_padding="6%" id="pricing" row_name="Pricing" overlay_strength="0.95"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" width="1/1" tablet_text_alignment="default" phone_text_alignment="default"][vc_row_inner text_align="left"][vc_column_inner enable_animation="true" animation="fade-in" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" centered_text="true" width="1/1"][vc_column_text css=".vc_custom_1469641915676{padding-bottom: 10px !important;}"]
<h2>Affordable Pricing</h2>
[/vc_column_text][divider line_type="Small Line" line_thickness="3" divider_color="extra-color-gradient-1" animate="yes" custom_height="30" custom_line_width="120" delay="100"][vc_column_text max_width="450" css=".vc_custom_1469652796078{margin-bottom: 30px !important;}"]<span style="color: #999999;">You've reached the pricing plans. Choose from one of our three plans or start your free 30 day trial risk-free.</span>[/vc_column_text][/vc_column_inner][/vc_row_inner][vc_row_inner text_align="left"][vc_column_inner enable_animation="true" animation="grow-in" boxed="true" column_padding="padding-4-percent" column_padding_position="all" background_color_opacity="1" centered_text="true" width="1/3" column_link="#"][vc_column_text]
<h5>Basic</h5>
[/vc_column_text][nectar_gradient_text heading_tag="h1" color="extra-color-gradient-1" gradient_direction="horizontal" text="$10"][nectar_gradient_text heading_tag="h6" color="extra-color-gradient-1" gradient_direction="horizontal" text="/month" margin_top="-40px"][vc_column_text css=".vc_custom_1469649138903{margin-top: -20px !important;}"]Up to 5 Users[/vc_column_text][/vc_column_inner][vc_column_inner enable_animation="true" animation="grow-in" boxed="true" column_padding="padding-4-percent" column_padding_position="all" background_color_opacity="1" centered_text="true" width="1/3" delay="200" column_link="#"][vc_column_text]
<h5>Premium</h5>
[/vc_column_text][nectar_gradient_text heading_tag="h1" color="extra-color-gradient-1" gradient_direction="horizontal" text="$20"][nectar_gradient_text heading_tag="h6" color="extra-color-gradient-1" gradient_direction="horizontal" text="/month" margin_top="-40px"][vc_column_text css=".vc_custom_1469649167245{margin-top: -20px !important;}"]Up to 50 Users[/vc_column_text][/vc_column_inner][vc_column_inner enable_animation="true" animation="grow-in" boxed="true" column_padding="padding-4-percent" column_padding_position="all" background_color_opacity="1" centered_text="true" width="1/3" delay="400" column_link="#"][vc_column_text]
<h5>Developer</h5>
[/vc_column_text][nectar_gradient_text heading_tag="h1" color="extra-color-gradient-1" gradient_direction="horizontal" text="$40"][nectar_gradient_text heading_tag="h6" color="extra-color-gradient-1" gradient_direction="horizontal" text="/month" margin_top="-40px"][vc_column_text css=".vc_custom_1469649229899{margin-top: -20px !important;}"]No Limit On Users[/vc_column_text][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Fullscreen Pricing Grid', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['pricing'];
$data['custom_class'] = 'pricing';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/gradient-pricing-2.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" equal_height="yes" content_placement="middle" full_height="yes" columns_placement="stretch" scene_position="center" text_color="dark" text_align="left" overlay_strength="0.3"][vc_column centered_text="true" column_padding="padding-7-percent" column_padding_position="all" background_color="#ffffff" background_color_opacity="1" background_color_hover="#f4f4f4" background_hover_color_opacity="1" column_shadow="none" width="1/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_column_text]
<h5>Basic</h5>
[/vc_column_text][nectar_gradient_text heading_tag="h1" color="extra-color-gradient-1" gradient_direction="horizontal" text="$10"][nectar_gradient_text heading_tag="h6" color="extra-color-gradient-1" gradient_direction="horizontal" text="/month" margin_top="-40px"][vc_column_text css=".vc_custom_1485375453676{margin-top: 20px !important;}"]Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantic[/vc_column_text][nectar_btn size="large" button_style="regular" button_color_2="Accent-Color" color_override="#0a0101" icon_family="iconsmind" url="#" text="Buy Now" margin_top="80" icon_iconsmind="iconsmind-Triangle-ArrowRight"][/vc_column][vc_column centered_text="true" column_padding="padding-7-percent" column_padding_position="all" background_color="#ffffff" background_color_opacity="1" background_color_hover="#f4f4f4" background_hover_color_opacity="1" column_shadow="none" width="1/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_column_text]
<h5>Premium</h5>
[/vc_column_text][nectar_gradient_text heading_tag="h1" color="extra-color-gradient-1" gradient_direction="horizontal" text="$20"][nectar_gradient_text heading_tag="h6" color="extra-color-gradient-1" gradient_direction="horizontal" text="/month" margin_top="-40px"][vc_column_text css=".vc_custom_1485375453676{margin-top: 20px !important;}"]Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantic[/vc_column_text][nectar_btn size="large" button_style="regular" button_color_2="Accent-Color" color_override="#0a0101" icon_family="iconsmind" url="#" text="Buy Now" margin_top="80" icon_iconsmind="iconsmind-Triangle-ArrowRight"][/vc_column][vc_column centered_text="true" column_padding="padding-7-percent" column_padding_position="all" background_color="#ffffff" background_color_opacity="1" background_color_hover="#f4f4f4" background_hover_color_opacity="1" column_shadow="none" width="1/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_column_text]
<h5>Developer</h5>
[/vc_column_text][nectar_gradient_text heading_tag="h1" color="extra-color-gradient-1" gradient_direction="horizontal" text="$40"][nectar_gradient_text heading_tag="h6" color="extra-color-gradient-1" gradient_direction="horizontal" text="/month" margin_top="-40px"][vc_column_text css=".vc_custom_1485375453676{margin-top: 20px !important;}"]Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantic[/vc_column_text][nectar_btn size="large" button_style="regular" button_color_2="Accent-Color" color_override="#0a0101" icon_family="iconsmind" url="#" text="Buy Now" margin_top="80" icon_iconsmind="iconsmind-Triangle-ArrowRight"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Full Width Parallax Posts Slider', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['blog'];
$data['custom_class'] = 'blog';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/recent-posts-slider-full.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" bg_color="#ffffff" scene_position="center" text_color="dark" text_align="left" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][recent_posts style="slider" category="all" slider_size="650" posts_per_page="3"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Minimal Color CTA Section', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['cta'];
$data['custom_class'] = 'cta';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/color-cta.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" equal_height="yes" content_placement="middle" bg_color="#3452ff" scene_position="center" text_color="light" text_align="left" top_padding="60" bottom_padding="60" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/4" tablet_text_alignment="center" phone_text_alignment="center" column_border_width="none" column_border_style="solid"][vc_custom_heading text="Sign Up Today" font_container="tag:h5|text_align:left" google_fonts="font_family:Roboto%20Condensed%3A300%2C300italic%2Cregular%2Citalic%2C700%2C700italic|font_style:700%20bold%20regular%3A700%3Anormal"][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/2" tablet_text_alignment="center" phone_text_alignment="center" column_border_width="none" column_border_style="solid"][vc_custom_heading text="Get 30 days free when you create an account" font_container="tag:h5|text_align:center" google_fonts="font_family:Roboto%20Condensed%3A300%2C300italic%2Cregular%2Citalic%2C700%2C700italic|font_style:700%20bold%20regular%3A700%3Anormal"][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/4" tablet_text_alignment="center" phone_text_alignment="center" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="right"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid"][divider line_type="No Line" custom_height="10"][nectar_btn size="large" button_style="see-through" button_color_2="Accent-Color" icon_family="none" url="#" text="Sign Up Now" margin_bottom="0"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Video Lightbox Inline With Text', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['general'] .', '. $cat_display_names['about'];
$data['custom_class'] = 'general about';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/video-cta.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-mountains-2.webp" bg_position="left top" bg_repeat="no-repeat" parallax_bg="true" parallax_bg_speed="fast" bg_color="#333333" scene_position="center" text_color="light" text_align="left" top_padding="15%" bottom_padding="15%" color_overlay="#0a0a0a" overlay_strength="0.8"][vc_column centered_text="true" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" top_padding="30" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid" delay="500"][nectar_video_lightbox link_style="play_button_with_text" nectar_play_button_color="Default-Accent-Color" font_style="h3" video_url="https://www.youtube.com/watch?v=6oTurM7gESE" link_text="Watch Our Intro Video"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );

$data = array();
$data['name'] = esc_html__( 'Layout Text Block', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['general'];
$data['custom_class'] = 'general';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/text-block.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_color="#ffffff" scene_position="center" text_color="dark" text_align="left" top_padding="7%" bottom_padding="7%" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/4" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][vc_column centered_text="true" column_padding="padding-4-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid"][vc_custom_heading text="THE STORY" font_container="tag:h5|font_size:14|text_align:center|color:%233452ff|line_height:24px" google_fonts="font_family:Roboto%3A100%2C100italic%2C300%2C300italic%2Cregular%2Citalic%2C500%2C500italic%2C700%2C700italic%2C900%2C900italic|font_style:700%20bold%20regular%3A700%3Anormal"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid" delay="50"][vc_column_text css=".vc_custom_1486153382692{margin-top: -8px !important;margin-bottom: -8px !important;}"]
<h3>A Good Design Solves A Problem. A Bad Design Will Create One.</h3>
[/vc_column_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid" delay="100"][vc_column_text]A small river named Duden flows by their place and supplies it with the necessary regelialia. It is a paradisematic country, in which roasted parts of sentences fly into your mouth.[/vc_column_text][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/4" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Imaginative Video CTA Section', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['cta'] .', '. $cat_display_names['general'];
$data['custom_class'] = 'cta general';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/right-gradient-section.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#333333" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-mountains-2.webp" bg_position="center center" background_image_loading="default" bg_repeat="no-repeat" scene_position="center" top_padding="15%" bottom_padding="15%" text_color="light" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" enable_gradient="true" color_overlay="rgba(10,10,10,0.2)" color_overlay_2="#000000" overlay_strength="1" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none"][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][/vc_column][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][split_line_heading animation_type="line-reveal-by-space" font_style="h1" line_reveal_by_space_text_effect="default" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="Let's Change How We Manage Business"][/split_line_heading][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" delay="300"][vc_custom_heading text="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics. It is a paradisematic country, in which roasted parts of sentences fly into your mouth. Even the all-powerful Pointing has no control." font_container="tag:p|text_align:left|color:rgba(255%2C255%2C255%2C0.7)" use_theme_fonts="yes"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" top_padding="30" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" delay="500"][nectar_video_lightbox link_style="play_button_with_text" nectar_play_button_color="Default-Accent-Color" nectar_play_button_style="default" font_style="p" video_url="https://www.youtube.com/watch?v=6oTurM7gESE" link_text="View Explainer Video"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Parallax Posts Slider', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['blog'];
$data['custom_class'] = 'blog';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/recent-posts-slider.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_color="#ffffff" scene_position="center" text_color="dark" text_align="left" top_padding="7%" bottom_padding="7%" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][recent_posts style="slider" category="all" slider_size="650" posts_per_page="3"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Moving CTA Section', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['cta'];
$data['custom_class'] = 'cta date-15-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/image-cta.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" equal_height="yes" content_placement="middle" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-clouds.webp" bg_position="center center" bg_repeat="no-repeat" scene_position="center" text_color="light" text_align="left" top_padding="8%" bottom_padding="8%" color_overlay="rgba(10,6,6,0.84)" overlay_strength="0.5"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/6" column_border_width="none" column_border_style="solid"][/vc_column_inner][vc_column_inner column_padding="padding-2-percent" column_padding_position="left-right" centered_text="true" background_color_opacity="1" width="2/3" column_border_width="none" column_border_style="solid"][vc_custom_heading text="Let's Start This Party" font_container="tag:h2|font_size:52|text_align:center|line_height:52px" use_theme_fonts="yes" css_animation="fadeInUp"][divider line_type="No Line" custom_height="10"][vc_custom_heading text="Like Nothing You've Seen. Sign Up Today &amp; Experience Salient" font_container="tag:p|text_align:center|color:rgba(255%2C255%2C255%2C0.7)" use_theme_fonts="yes" css_animation="fadeInUp" css=".vc_custom_1486565241232{margin-top: 10px !important;margin-bottom: 10px !important;}"][nectar_btn size="large" button_style="regular" button_color_2="Accent-Color" icon_family="default_arrow" url="#" text="Learn More" css_animation="zoomIn"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/6" column_border_width="none" column_border_style="solid"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Sweet Hero Section', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['hero_section'];
$data['custom_class'] = 'hero_section';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/hero-inline-video-link.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-clouds.webp" bg_position="left top" bg_repeat="no-repeat" parallax_bg="true" parallax_bg_speed="fast" bg_color="#333333" scene_position="center" text_color="light" text_align="left" top_padding="15%" bottom_padding="15%" color_overlay="#0a0a0a" overlay_strength="0.8"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="2/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][split_line_heading animation_type="default"]
<h2>Every Human Has</h2>
<h2>A Story To Tell</h2>
[/split_line_heading][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="5/6" column_border_width="none" column_border_style="solid" delay="300"][vc_custom_heading text="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts The Big Oxmox advised her." font_container="tag:h5|font_size:20|text_align:left|color:rgba(255%2C255%2C255%2C0.7)|line_height:36px" google_fonts="font_family:Roboto%3A100%2C100italic%2C300%2C300italic%2Cregular%2Citalic%2C500%2C500italic%2C700%2C700italic%2C900%2C900italic|font_style:400%20regular%3A400%3Anormal"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/6" column_border_width="none" column_border_style="solid"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" top_padding="30" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid" delay="500"][nectar_video_lightbox link_style="play_button_with_text" nectar_play_button_color="Default-Accent-Color" font_style="h5" video_url="https://www.youtube.com/watch?v=6oTurM7gESE" link_text="Watch Our Intro Video"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Recent Posts Dark Color Scheme', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['blog'];
$data['custom_class'] = 'blog';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/recent_posts_dark.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_color="#131416" scene_position="center" text_color="dark" text_align="left" top_padding="7%" bottom_padding="7%" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][recent_posts style="classic_enhanced" color_scheme="dark" category="all" columns="3" posts_per_page="3"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" centered_text="true" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid"][nectar_btn size="large" button_style="regular" button_color_2="Accent-Color" icon_family="iconsmind" url="#" text="View All Posts" icon_iconsmind="iconsmind-Triangle-ArrowRight"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Features With Background Color Overlay', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['about'] .', '. $cat_display_names['services'] .', '. $cat_display_names['icons'];
$data['custom_class'] = 'about services icons';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/features.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-clouds.webp" bg_position="center center" bg_repeat="no-repeat" scene_position="center" text_color="light" text_align="left" top_padding="10%" bottom_padding="10%" color_overlay="#2b4bff" overlay_strength="0.8"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" centered_text="true" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid"][vc_column_text css_animation="fadeIn"]
<h4>See To Believe</h4>
[/vc_column_text][vc_custom_heading text="We Have All The Features" font_container="tag:h2|font_size:48|text_align:center" use_theme_fonts="yes"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" top_padding="20" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-3-percent" column_padding_position="all" centered_text="true" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color="white" icon_padding="20px" icon_iconsmind="iconsmind-Umbrella-2"][vc_column_text css_animation="fadeInUp"]
<h4>There For You</h4>
[/vc_column_text][vc_column_text css_animation="fadeInUp" css=".vc_custom_1485216414954{margin-top: 15px !important;}"]Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts[/vc_column_text][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-3-percent" column_padding_position="all" centered_text="true" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color="white" icon_padding="20px" icon_iconsmind="iconsmind-Diamond"][vc_column_text css_animation="fadeInUp"]
<h4>Pristine Quality</h4>
[/vc_column_text][vc_column_text css_animation="fadeInUp" css=".vc_custom_1485216419423{margin-top: 15px !important;}"]Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts[/vc_column_text][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-3-percent" column_padding_position="all" centered_text="true" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color="white" icon_padding="20px" icon_iconsmind="iconsmind-Favorite-Window"][vc_column_text css_animation="fadeInUp"]
<h4>Heavily Awarded</h4>
[/vc_column_text][vc_column_text css_animation="fadeInUp" css=".vc_custom_1485216423454{margin-top: 15px !important;}"]Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts[/vc_column_text][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Creative Hero With Device', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['hero_section'];
$data['custom_class'] = 'hero_section';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/ipad-bottom-dark.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-mountain.webp" bg_position="center center" bg_repeat="no-repeat" scene_position="center" text_color="dark" text_align="left" top_padding="8%" enable_gradient="true" color_overlay="#ffffff" color_overlay_2="rgba(252,252,252,0.93)" gradient_direction="left_b_to_right_t" overlay_strength="0.95"][vc_column centered_text="true" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/12" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][vc_column centered_text="true" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="10/12" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][split_line_heading animation_type="default"]
<h2>The Possibilities</h2>
<h2>Are Endless</h2>
[/split_line_heading][vc_row_inner column_margin="default" bottom_padding="80" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid" delay="450"][nectar_btn size="large" button_style="regular" button_color_2="Accent-Color" icon_family="none" url="#" text="Tell Me How" margin_top="10" margin_right="10" margin_left="10"][/vc_column_inner][/vc_row_inner][image_with_animation image_url="https://themenectar.com/img/demo-media/transparent/ipad-hor-cut.png" alignment="center" animation="Fade In" box_shadow="none" max_width="100%"][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/12" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Hot Hero Tablet Section', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['hero_section'];
$data['custom_class'] = 'hero_section';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/ipad-bottom.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_color="#ff1456" scene_position="center" text_color="light" text_align="left" top_padding="8%" overlay_strength="0.8"][vc_column centered_text="true" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/12" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][vc_column centered_text="true" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="10/12" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][split_line_heading animation_type="default"]
<h2>Create The Website</h2>
<h2>Of Your Dreams</h2>
[/split_line_heading][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid" delay="300"][vc_custom_heading text="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts" font_container="tag:h5|font_size:20|text_align:center|color:rgba(255%2C255%2C255%2C0.8)|line_height:36px" google_fonts="font_family:Roboto%3A100%2C100italic%2C300%2C300italic%2Cregular%2Citalic%2C500%2C500italic%2C700%2C700italic%2C900%2C900italic|font_style:400%20regular%3A400%3Anormal" css=".vc_custom_1485877986603{padding-right: 20% !important;padding-left: 20% !important;}"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" bottom_padding="80" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid" delay="450"][nectar_btn size="large" button_style="see-through-2" color_override="#ffffff" hover_color_override="#ffffff" hover_text_color_override="#000000" icon_family="none" url="#" text="Tell Me How" margin_top="10" margin_right="10" margin_bottom="10" margin_left="10"][nectar_btn size="large" button_style="see-through-2" color_override="#ffffff" hover_color_override="#ffffff" hover_text_color_override="#000000" icon_family="none" url="#" text="Purchase Now" margin_top="10" margin_right="10" margin_bottom="10" margin_left="10"][/vc_column_inner][/vc_row_inner][image_with_animation image_url="https://themenectar.com/img/demo-media/transparent/ipad-hor-cut.png" alignment="center" animation="Fade In" box_shadow="none" max_width="100%"][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/12" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );

$data = array();
$data['name'] = esc_html__( 'Direct Minimal Hero', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['hero_section'].', '. $cat_display_names['general'];
$data['custom_class'] = 'hero_section general date-10-Sep-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/light-video-minimal-hero.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_color="#ffffff" scene_position="center" text_color="dark" text_align="left" top_padding="10%" bottom_padding="10%" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="3/4" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1487092529487{margin-bottom: 20px !important;}"]
<h3>A wonderful serenity has <em>taken possession</em> of my entire soul, like these sweet mornings of spring which I enjoy with my<em> whole heart</em>.</h3>
[/vc_column_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid" delay="100"][nectar_video_lightbox link_style="play_button_with_text" nectar_play_button_color="Default-Accent-Color" font_style="p" video_url="https://www.youtube.com/watch?v=6oTurM7gESE" link_text="<strong>Introduction Video </strong> — 30 seconds"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/4" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Fancy Hero Section', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['hero_section'];
$data['custom_class'] = 'hero_section';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/hero-video.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-mountain.webp" bg_position="center center" bg_repeat="no-repeat" bg_color="#0a0303" scene_position="center" text_color="dark" text_align="left" top_padding="10%" bottom_padding="10%" enable_gradient="true" color_overlay="#0a0000" color_overlay_2="#4f4f4f" gradient_direction="left_b_to_right_t" overlay_strength="0.5"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/6" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][vc_column centered_text="true" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="2/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left" css=".vc_custom_1485381645515{margin-bottom: -10px !important;}"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid"][vc_custom_heading text="Welcome To Salient" font_container="tag:h1|text_align:center|color:%23ffffff" google_fonts="font_family:Roboto%3A100%2C100italic%2C300%2C300italic%2Cregular%2Citalic%2C500%2C500italic%2C700%2C700italic%2C900%2C900italic|font_style:900%20bold%20regular%3A900%3Anormal" css_animation="none"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/12" column_border_width="none" column_border_style="solid" offset="vc_hidden-sm vc_hidden-xs"][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="5/6" column_border_width="none" column_border_style="solid" offset="vc_col-xs-12" delay="50"][vc_custom_heading text="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in." font_container="tag:h4|font_size:20|text_align:center|color:rgba(255%2C255%2C255%2C0.7)|line_height:35px" use_theme_fonts="yes" css_animation="none" css=".vc_custom_1487090569024{margin-top: 10px !important;}"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/12" column_border_width="none" column_border_style="solid" offset="vc_hidden-sm vc_hidden-xs"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" top_padding="30" bottom_padding="20" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/6" column_border_width="none" column_border_style="solid" offset="vc_hidden-sm vc_hidden-xs"][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="2/3" column_border_width="none" column_border_style="solid" offset="vc_col-xs-12" delay="100"][nectar_video_lightbox link_style="play_button_2" nectar_play_button_color="Default-Accent-Color" image_url="https://themenectar.com/img/demo-media/unsplash/webp/large-room.webp" hover_effect="defaut" box_shadow="x_large_depth" video_url="https://www.youtube.com/watch?v=6oTurM7gESE"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/6" column_border_width="none" column_border_style="solid" offset="vc_hidden-sm vc_hidden-xs"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="grow-in" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid" delay="150"][nectar_btn size="large" button_style="see-through-2" color_override="#ffffff" hover_color_override="#ffffff" hover_text_color_override="#000000" icon_family="iconsmind" url="#" text="Learn More" icon_iconsmind="iconsmind-Triangle-ArrowRight" margin_top="30"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/6" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Wireframe Structure Of A Fixed Page Submenu', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['general'];
$data['custom_class'] = 'general date-04-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/page-submenu.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" scene_position="center" text_color="dark" text_align="left" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][page_submenu alignment="left" sticky="true" bg_color="#004cff" link_color="#ffffff"][page_link link_url="#section-one" title="Section One" id="1485377879-1-86" tab_id="1485378066812-2"] [/page_link][page_link link_url="#section-two" title="Section Two" id="1485377879-2-40" tab_id="1485378066819-3"] [/page_link][page_link link_url="#section-three" title="Section Three" id="1485378132323-0-4" tab_id="1481372066319-3"] [/page_link][/page_submenu][/vc_column][/vc_row][vc_row type="full_width_background" full_screen_row_position="middle" bg_color="#232323" scene_position="center" text_color="light" text_align="left" top_padding="20%" bottom_padding="20%" id="section-one" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color="extra-color-gradient-1" icon_padding="0px" icon_iconsmind="iconsmind-Aquarius" margin_bottom="5"][/vc_column_inner][/vc_row_inner][vc_custom_heading text="Section One" font_container="tag:h2|font_size:80|text_align:left|line_height:94px" google_fonts="font_family:Roboto%20Condensed%3A300%2C300italic%2Cregular%2Citalic%2C700%2C700italic|font_style:700%20bold%20regular%3A700%3Anormal" css_animation="fadeIn"][vc_custom_heading text="I am text block. Click edit button to change this text. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut elit tellus, luctus nec ullamcorper mattis, pulvinar dapibus leo." font_container="tag:p|text_align:left|color:rgba(255%2C255%2C255%2C0.6)" use_theme_fonts="yes" css_animation="fadeIn"][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][/vc_row][vc_row type="full_width_background" full_screen_row_position="middle" bg_color="#303030" scene_position="center" text_color="light" text_align="left" top_padding="20%" bottom_padding="20%" id="section-two" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color="extra-color-gradient-1" icon_padding="0px" icon_iconsmind="iconsmind-Aquarius" margin_bottom="5"][vc_custom_heading text="Section Two" font_container="tag:h2|font_size:80|text_align:left|line_height:94px" google_fonts="font_family:Roboto%20Condensed%3A300%2C300italic%2Cregular%2Citalic%2C700%2C700italic|font_style:700%20bold%20regular%3A700%3Anormal" css_animation="fadeIn"][vc_custom_heading text="I am text block. Click edit button to change this text. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut elit tellus, luctus nec ullamcorper mattis, pulvinar dapibus leo." font_container="tag:p|text_align:left|color:rgba(255%2C255%2C255%2C0.6)" use_theme_fonts="yes" css_animation="fadeIn"][/vc_column][/vc_row][vc_row type="full_width_background" full_screen_row_position="middle" bg_color="#232323" scene_position="center" text_color="light" text_align="left" top_padding="20%" bottom_padding="20%" id="section-three" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color="extra-color-gradient-1" icon_padding="0px" icon_iconsmind="iconsmind-Aquarius" margin_bottom="5"][vc_custom_heading text="Section Three" font_container="tag:h2|font_size:80|text_align:left|line_height:94px" google_fonts="font_family:Roboto%20Condensed%3A300%2C300italic%2Cregular%2Citalic%2C700%2C700italic|font_style:700%20bold%20regular%3A700%3Anormal" css_animation="fadeIn"][vc_custom_heading text="I am text block. Click edit button to change this text. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut elit tellus, luctus nec ullamcorper mattis, pulvinar dapibus leo." font_container="tag:p|text_align:left|color:rgba(255%2C255%2C255%2C0.6)" use_theme_fonts="yes" css_animation="fadeIn"][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Simple Hero With Gradient CTA Button', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['hero_section'].', '. $cat_display_names['cta'];
$data['custom_class'] = 'hero_section cta';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/simple-hero.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-mountains-2.webp" bg_position="center top" bg_repeat="no-repeat" bg_color="#454156" scene_position="center" text_color="light" text_align="left" top_padding="9%" bottom_padding="9%" id="intro" row_name="Intro" color_overlay="#0a0a0a" overlay_strength="0.5"][vc_column centered_text="true" column_padding="padding-6-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid"][vc_column_text max_width="700"]
<h1>Receive &amp; Send Payments No Matter Where You Aimmenre</h1>
[/vc_column_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid" delay="100"][vc_column_text css=".vc_custom_1469551223317{margin-top: -10px !important;}"]We're changing the way money is processed on-the-go.[/vc_column_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-4-percent" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid" delay="200"][nectar_btn size="jumbo" button_style="see-through" button_color_2="extra-color-gradient-1" icon_family="none" url="#" text="Show Me How"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Project With Video Player', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['portfolio'];
$data['custom_class'] = 'portfolio';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/basic-video-project.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#f9f9f9" scene_position="center" top_padding="5%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none"][vc_column column_padding="padding-1-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_column_text]
<h2><span style="color: #3f59ff;">Overview</span></h2>
[/vc_column_text][/vc_column][/vc_row][vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#f9f9f9" scene_position="center" bottom_padding="4%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none"][vc_column column_padding="padding-1-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_column_text]<span style="color: #999999;">Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean. A small river named Duden flows by their place and supplies it with the necessary regelialia. It is a paradisematic country, in which roasted parts of sentences fly into your mouth. Even the all-powerful Pointing has no control about the blind texts it is an almost unorthographic life One day however a small line of blind text by the name of Lorem Ipsum decided to leave for the far World of Grammar.</span>[/vc_column_text][/vc_column][vc_column column_padding="padding-1-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_column_text]<span style="color: #999999;">She packed her seven versalia, put her initial into the belt and made herself on the way. When she reached the first hills of the Italic Mountains, she had a last view back on the skyline of her hometown Bookmarksgrove, the headline of Alphabet Village and the subline of her own road, the Line Lane. Pityful a rethoric question ran over her cheek, then she continued her way. On her way she met a copy.</span>[/vc_column_text][/vc_column][vc_column column_padding="padding-1-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_column_text]
<h6><span style="color: #3f59ff;">Project</span></h6>
<span style="color: #999999;">Mountains </span>[/vc_column_text][divider line_type="No Line" custom_height="30"][vc_column_text]
<h6><span style="color: #3f59ff;">Client</span></h6>
<span style="color: #999999;">Good People</span>[/vc_column_text][divider line_type="No Line" custom_height="30"][vc_column_text]
<h6><span style="color: #3f59ff;">What We Did</span></h6>
<span style="color: #999999;">UI/UX Design, Video Production</span>[/vc_column_text][/vc_column][/vc_row][vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#ffffff" scene_position="center" top_padding="5%" bottom_padding="3%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none"][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="2/3" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][split_line_heading animation_type="line-reveal-by-space" font_style="h1" text_color="#3f59ff" line_reveal_by_space_text_effect="default" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="We Delivered An Advert Of Individuality, Eccentricity, Abnormality, and Humors."][/split_line_heading][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_column_text]<span style="color: #999999;">She packed her seven versalia, put her initial into the belt and made herself on the way. When she reached the first hills of the Italic Mountains, she had a last view back on the skyline of her hometown Bookmarksgrove</span>,[/vc_column_text][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="padding-2-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][/vc_column][/vc_row][vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" scene_position="center" bottom_padding="8%" text_color="light" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" overlay_strength="0.8" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none"][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][nectar_video_lightbox link_style="play_button_2" nectar_play_button_color="Default-Accent-Color" image_url="https://themenectar.com/img/demo-media/unsplash/webp/large-blur.webp" hover_effect="defaut" box_shadow="none" border_radius="none" play_button_size="default" video_url="https://www.youtube.com/watch?v=6oTurM7gESE"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Overlapping Testimonial Section', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['testimonials'] .', '. $cat_display_names['about'];
$data['custom_class'] = 'testimonials about date-29-Aug-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/overlapping-testimonial.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-clouds.webp" bg_color="#3a3a3a" scene_position="center" text_color="light" text_align="left" top_padding="17%" bottom_padding="17%" overlay_strength="0.3"][vc_column enable_animation="true" animation="none" centered_text="true" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][nectar_video_lightbox link_style="play_button" video_url="https://www.youtube.com/watch?v=6oTurM7gESE"][/vc_column][/vc_row][vc_row type="in_container" full_screen_row_position="middle" bg_color="#ffffff" scene_position="center" text_color="dark" text_align="left" overlay_strength="0.3"][vc_column centered_text="true" column_padding="padding-7-percent" column_padding_position="all" background_color="#ffffff" background_color_opacity="1" background_hover_color_opacity="1" top_margin="-6%" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_column_text]
<h5 style="text-align: center;">How The Project Was Received</h5>
[/vc_column_text][divider line_type="Small Line" line_thickness="2" divider_color="accent-color" animate="yes" custom_height="50" custom_line_width="80"][testimonial_slider style="minimal" disable_height_animation="true"][testimonial title="Testimonial" id="1475857961-1-94" tab_id="1475858133769-1" name="Eve Crawford" subtitle="Product Designer" quote="It was really fun getting to know the team during the project. They were all helpful in answering my questions and made me feel at ease. The design ended up being better than I could have envisioned!"] Click the edit button to add your testimonial. [/testimonial][/testimonial_slider][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );

$data = array();
$data['name'] = esc_html__( 'Split Large Icon Column & Animated Titles', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['general'] .', '. $cat_display_names['icons'];
$data['custom_class'] = 'general icons date-29-Aug-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/animated-titles.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" equal_height="yes" content_placement="middle" scene_position="center" text_color="dark" text_align="left" overlay_strength="0.3"][vc_column centered_text="true" column_padding="padding-10-percent" column_padding_position="all" background_color="#3f59ff" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color="Extra-Color-3" icon_padding="20px" icon_iconsmind="iconsmind-Plant" icon_size="200"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column centered_text="true" column_padding="padding-8-percent" column_padding_position="all" background_color="#ffffff" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][nectar_animated_title heading_tag="h2" style="color-strip-reveal" color="Accent-Color" text="Our life is"][nectar_animated_title heading_tag="h2" style="color-strip-reveal" color="Accent-Color" text="Frittered away"][nectar_animated_title heading_tag="h2" style="color-strip-reveal" color="Accent-Color" text="By detail"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Minimal Jumbo Button With 3D Hover Effect', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['portfolio'].', '. $cat_display_names['cta'];
$data['custom_class'] = 'about cta date-29-Aug-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/jumbo-3d-button.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-clouds.webp" bg_position="center center" bg_repeat="no-repeat" bg_color="#383838" scene_position="center" text_color="light" text_align="left" top_padding="10%" bottom_padding="10%" color_overlay="#0a0101" overlay_strength="0.5"][vc_column centered_text="true" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][nectar_btn size="extra_jumbo" button_style="see-through-3d" url="#" text="View Website"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Icon Sections, Dual With Gradient Coloring', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['icons'] .', '. $cat_display_names['services'].', '. $cat_display_names['cta'];
$data['custom_class'] = 'icons services cta date-10-Sep-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/fullwidth-icons.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" equal_height="yes" content_placement="middle" scene_position="center" text_color="dark" text_align="left" overlay_strength="0.3"][vc_column centered_text="true" column_padding="padding-10-percent" column_padding_position="all" background_color="#f7f7f7" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][nectar_icon icon_family="iconsmind" icon_style="border-animation" icon_border_thickness="2px" icon_color="extra-color-gradient-1" icon_padding="25px" icon_iconsmind="iconsmind-Microscope" margin_bottom="15" icon_size="40" url="#"][divider line_type="No Line" custom_height="10"][vc_column_text max_width="315"]
<h4>Extensive Documentation</h4>
[/vc_column_text][divider line_type="No Line" custom_height="5"][vc_column_text max_width="350" css=".vc_custom_1485463707253{margin-bottom: 40px !important;}"]<span style="color: #aaa;"> Never feel lost again. Documentation is available in addition to a series of video tutorials exclusively for Salient.</span>[/vc_column_text][nectar_cta heading_tag="h5" text_color="#a5a5a5" link_type="regular" alignment="center" link_text="Learn More"][/vc_column][vc_column centered_text="true" column_padding="padding-10-percent" column_padding_position="all" background_color="#ffffff" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][nectar_icon icon_family="iconsmind" icon_style="border-animation" icon_border_thickness="2px" icon_color="extra-color-gradient-1" icon_padding="25px" icon_iconsmind="iconsmind-Wolf" margin_bottom="15" icon_size="40" url="#"][divider line_type="No Line" custom_height="10"][vc_column_text max_width="315"]
<h4>Beautiful Design</h4>
[/vc_column_text][divider line_type="No Line" custom_height="5"][vc_column_text max_width="350" css=".vc_custom_1485463711391{margin-bottom: 40px !important;}"]<span style="color: #aaa;">Quality over quantity. Enjoy a vast array of carefully designed &amp; unique elements with tons of control over fine tuning them.</span>[/vc_column_text][nectar_cta heading_tag="h5" text_color="#a5a5a5" link_type="regular" alignment="center" link_text="Learn More"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Split Line Heading & Video Background', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['about'] .', '. $cat_display_names['hero_section'];
$data['custom_class'] = 'about general date-29-Aug-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/animated-split-line-heading.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#2b2b2b" video_bg="use_video" enable_video_color_overlay="true" video_overlay_color="#0a0a0a" video_external="https://www.youtube.com/watch?v=6oTurM7gESE" background_video_loading="default" scene_position="center" top_padding="15%" bottom_padding="15%" right_padding_desktop="40%" right_padding_tablet="0" text_color="light" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" gradient_type="default" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][split_line_heading animation_type="line-reveal-by-space" font_style="h1" line_reveal_by_space_text_effect="default" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="We Make Amazing Things Every Day."][/split_line_heading][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Section With Cascading Images', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['about'] .', '. $cat_display_names['general'];
$data['custom_class'] = 'about general date-29-Aug-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/cascading-imgs.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" equal_height="yes" content_placement="middle" scene_position="center" text_color="dark" text_align="left" top_padding="7%" bottom_padding="7%" overlay_strength="0.3"][vc_column column_padding="padding-3-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][nectar_cascading_images image_1_url="https://themenectar.com/img/demo-media/unsplash/webp/large-clouds.webp" image_1_offset_x_sign="+" image_1_offset_x="0%" image_1_offset_y_sign="-" image_1_offset_y="55%" image_1_rotate_sign="+" image_1_rotate="none" image_1_animation="Grow In" image_1_box_shadow="none" image_2_url="https://themenectar.com/img/demo-media/unsplash/webp/large-mountain.webp" image_2_offset_x_sign="+" image_2_offset_x="50%" image_2_offset_y_sign="+" image_2_offset_y="35%" image_2_rotate_sign="+" image_2_rotate="none" image_2_animation="Grow In" image_2_box_shadow="none" image_3_url="https://themenectar.com/img/demo-media/unsplash/webp/large-sunflowers.webp" image_3_offset_x_sign="-" image_3_offset_x="35%" image_3_offset_y_sign="+" image_3_offset_y="30%" image_3_rotate_sign="+" image_3_rotate="none" image_3_animation="Grow In" image_3_box_shadow="x_large_depth" image_4_offset_x_sign="+" image_4_offset_x="0%" image_4_offset_y_sign="+" image_4_offset_y="0%" image_4_rotate_sign="+" image_4_rotate="none" image_4_animation="Fade In" image_4_box_shadow="none"][/vc_column][vc_column column_padding="padding-6-percent" column_padding_position="left" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1476219400968{margin-top: 50px !important;margin-bottom: 20px !important;}"]
<h5><span style="color: #999999;">Connecting brands and ideas</span></h5>
<h2>Our True Passion</h2>
[/vc_column_text][vc_column_text]Every great dream begins with a dreamer. Always remember, you have within you the strength, the patience, and the passion to reach for the stars to change the world.[/vc_column_text][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Fullscreen Biography On Click Team Members', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['about'] .', '. $cat_display_names['team'];
$data['custom_class'] = 'about team date-29-Aug-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/about-fullscreen.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" bg_color="#ffffff" scene_position="center" text_color="dark" text_align="left" id="team" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][team_member image_url="https://themenectar.com/img/demo-media/unsplash/webp/team-member-1-small-cropped.webp" bio_image_url="https://themenectar.com/demo/dummy-data-imgs/business/about-team-member-big.jpg" team_memeber_style="bio_fullscreen" name="Igor Kozlov" job_position="Graphic Designer" team_member_bio="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean. A small river named Duden flows by their place and supplies it with the necessary regelialia. It is a paradisematic country, in which roasted parts of sentences fly into your mouth. "][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][team_member image_url="https://themenectar.com/img/demo-media/unsplash/webp/team-member-2-small-cropped.webp" bio_image_url="https://themenectar.com/demo/dummy-data-imgs/business/about-team-member-big.jpg" team_memeber_style="bio_fullscreen" name="Mark Jones" job_position="Back-end Developer" team_member_bio="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean. A small river named Duden flows by their place and supplies it with the necessary regelialia. It is a paradisematic country, in which roasted parts of sentences fly into your mouth. "][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][team_member image_url="https://themenectar.com/img/demo-media/unsplash/webp/team-member-3-small-cropped.webp" bio_image_url="https://themenectar.com/demo/dummy-data-imgs/business/about-team-member-big.jpg" team_memeber_style="bio_fullscreen" name="Andre Smith" job_position="Fine Artist" team_member_bio="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean. A small river named Duden flows by their place and supplies it with the necessary regelialia. It is a paradisematic country, in which roasted parts of sentences fly into your mouth. "][/vc_column][/vc_row][vc_row type="full_width_content" full_screen_row_position="middle" bg_color="#ffffff" scene_position="center" text_color="dark" text_align="left" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][team_member image_url="https://themenectar.com/img/demo-media/unsplash/webp/team-member-4-small-cropped.webp" bio_image_url="https://themenectar.com/demo/dummy-data-imgs/business/about-team-member-big.jpg" team_memeber_style="bio_fullscreen" name="Ethan Young" job_position="Team Leader" team_member_bio="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean. A small river named Duden flows by their place and supplies it with the necessary regelialia. It is a paradisematic country, in which roasted parts of sentences fly into your mouth. "][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][team_member image_url="https://themenectar.com/img/demo-media/unsplash/webp/team-member-5-small-cropped.webp" bio_image_url="https://themenectar.com/demo/dummy-data-imgs/business/about-team-member-big.jpg" team_memeber_style="bio_fullscreen" name="Ava Morgan" job_position="The SEO Expert" team_member_bio="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean. A small river named Duden flows by their place and supplies it with the necessary regelialia. It is a paradisematic country, in which roasted parts of sentences fly into your mouth. "][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][team_member image_url="https://themenectar.com/img/demo-media/unsplash/webp/team-member-6-small-cropped.webp" bio_image_url="https://themenectar.com/demo/dummy-data-imgs/business/about-team-member-big.jpg" team_memeber_style="bio_fullscreen" name="James Anderson" job_position="Front-end Developer" team_member_bio="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean. A small river named Duden flows by their place and supplies it with the necessary regelialia. It is a paradisematic country, in which roasted parts of sentences fly into your mouth. "][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );

$data = array();
$data['name'] = esc_html__( 'Fulfilling Recent Blog Posts', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['blog'];
$data['custom_class'] = 'blog date-10-Sep-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/recent-posts-alt.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_color="#eaeaea" scene_position="center" text_color="dark" text_align="left" top_padding="7%" bottom_padding="7%" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][recent_posts style="classic_enhanced_alt" category="all" columns="3" posts_per_page="3"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" centered_text="true" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid"][nectar_btn size="large" button_style="regular" button_color_2="Accent-Color" icon_family="iconsmind" url="#" text="View All Posts" icon_iconsmind="iconsmind-Triangle-ArrowRight"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Image Overflowing Sections', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['services'] .', '. $cat_display_names['general'];
$data['custom_class'] = 'services general';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/image-overflowing.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" equal_height="yes" content_placement="middle" scene_position="center" text_color="dark" text_align="left" top_padding="10%" bottom_padding="5%" overlay_strength="0.3"][vc_column column_padding="padding-2-percent" column_padding_position="left-right" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][image_with_animation image_url="http://54cb3baa74d4d851e8b7-2e7f88565dceb0a8192c6645d1f8b1b4.r12.cf2.rackcdn.com/ipad-hor.png" alignment="right" animation="Fade In From Left" box_shadow="none" max_width="175%"][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_custom_heading text="Section No. 1" font_container="tag:h5|font_size:16|text_align:left|color:%23000000|line_height:32px" use_theme_fonts="yes"][vc_custom_heading text="Solid Design For Business" font_container="tag:h2|text_align:left|color:%23058efb" use_theme_fonts="yes"][divider line_type="Small Line" line_thickness="8" divider_color="default" animate="yes" custom_height="100" custom_line_width="120"][vc_column_text css_animation="bottom-to-top" css=".vc_custom_1485640195002{padding-right: 10% !important;}"]<span style="color: #999;">Even the all-powerful Pointing has no control about the blind texts it is an almost unorthographic life One day however a small line of blind text by the name of Lorem Ipsum decided to leave for the far World of Grammar. The Big Oxmox advised her not to do so, because there were thousands of bad Commas, wild Question Marks and devious Semikoli.</span>[/vc_column_text][/vc_column][/vc_row][vc_row type="full_width_background" full_screen_row_position="middle" equal_height="yes" content_placement="middle" scene_position="center" text_color="dark" text_align="left" top_padding="5%" bottom_padding="10%" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_custom_heading text="Section No. 2" font_container="tag:h5|font_size:16|text_align:left|color:%23000000|line_height:32px" use_theme_fonts="yes"][vc_custom_heading text="With looks to kill competition " font_container="tag:h2|text_align:left|color:%23058efb" use_theme_fonts="yes"][divider line_type="Small Line" line_thickness="8" divider_color="default" animate="yes" custom_height="100" custom_line_width="120"][vc_column_text css_animation="bottom-to-top" css=".vc_custom_1485640190159{padding-right: 10% !important;}"]<span style="color: #999;">Even the all-powerful Pointing has no control about the blind texts it is an almost unorthographic life One day however a small line of blind text by the name of Lorem Ipsum decided to leave for the far World of Grammar. The Big Oxmox advised her not to do so, because there were thousands of bad Commas, wild Question Marks and devious Semikoli.</span>[/vc_column_text][/vc_column][vc_column column_padding="padding-2-percent" column_padding_position="left-right" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][image_with_animation image_url="http://54cb3baa74d4d851e8b7-2e7f88565dceb0a8192c6645d1f8b1b4.r12.cf2.rackcdn.com/ipad-hor.png" alignment="" animation="Fade In From Right" box_shadow="none" max_width="175%"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Image Gallery Project', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['portfolio'];
$data['custom_class'] = 'portfolio gallery date-29-Aug-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/image-gallery-project.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" scene_position="center" text_color="dark" text_align="left" top_padding="10%" bottom_padding="1%" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" bottom_padding="40" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid"][vc_custom_heading text="You've never seen architecture like this." font_container="tag:h2|text_align:left|color:%2322d2d8" use_theme_fonts="yes"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/4" column_border_width="none" column_border_style="solid"][vc_custom_heading text="DELIVERABLES" font_container="tag:h5|font_size:14|text_align:left|color:%23b2b2b2" google_fonts="font_family:Hind%3A300%2Cregular%2C500%2C600%2C700|font_style:500%20bold%20regular%3A500%3Anormal"][fancy-ul icon_type="none" alignment="left"]
<ul>
 	<li>Photography</li>
 	<li>Strategy</li>
</ul>
[/fancy-ul][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/4" column_border_width="none" column_border_style="solid"][vc_custom_heading text="AWARDS &amp; MENTIONS" font_container="tag:h5|font_size:14|text_align:left|color:%23b2b2b2" google_fonts="font_family:Hind%3A300%2Cregular%2C500%2C600%2C700|font_style:500%20bold%20regular%3A500%3Anormal"][fancy-ul icon_type="none" alignment="left"]
<ul>
 	<li>Building Inspire</li>
 	<li>Best Promo</li>
</ul>
[/fancy-ul][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/4" column_border_width="none" column_border_style="solid"][vc_custom_heading text="CLIENT" font_container="tag:h5|font_size:14|text_align:left|color:%23b2b2b2" google_fonts="font_family:Hind%3A300%2Cregular%2C500%2C600%2C700|font_style:500%20bold%20regular%3A500%3Anormal"][fancy-ul icon_type="none" alignment="left"]Salient Construction[/fancy-ul][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/4" column_border_width="none" column_border_style="solid"][vc_custom_heading text="YEAR" font_container="tag:h5|font_size:14|text_align:left|color:%23b2b2b2" google_fonts="font_family:Hind%3A300%2Cregular%2C500%2C600%2C700|font_style:500%20bold%20regular%3A500%3Anormal"][vc_column_text]2017[/vc_column_text][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row][vc_row type="full_width_content" full_screen_row_position="middle" scene_position="center" text_color="dark" text_align="left" bottom_padding="7%" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_gallery type="flickity_style" flickity_controls="material_pagination" flickity_desktop_columns="1" flickity_small_desktop_columns="1" flickity_tablet_columns="1" flickity_box_shadow="large_depth" onclick="link_no" img_size="full"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Minimal CTA Section With Flip In Animation', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['about'] .', '. $cat_display_names['cta'];
$data['custom_class'] = 'about cta hero_section date-29-Aug-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/3d-cta.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-art.webp" full_screen_row_position="middle" bg_color="#5e5e5e" scene_position="center" text_color="light" text_align="left" top_padding="10%" bottom_padding="10%" color_overlay="#0a0a0a" overlay_strength="0.8"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/6" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][vc_column enable_animation="true" animation="flip-in-vertical" centered_text="true" column_padding="padding-5-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="2/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_column_text max_width="575"]
<h5>High Quality. Stunning Design.</h5>
<h2>Take Your Website To New Heights With Salient</h2>
[/vc_column_text][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid"][nectar_btn size="large" button_style="see-through" button_color_2="extra-color-gradient-2" color_override="#ffffff" icon_family="none" text="Purchase Now" margin_top="50"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/6" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Red(ish) Background Milestones', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['counters'];
$data['custom_class'] = 'counters';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/milestone-red.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_color="#ff3a6f" scene_position="center" text_color="light" text_align="left" top_padding="10%" bottom_padding="10%" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/12" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][vc_column centered_text="true" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="5/6" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="padding-2-percent" column_padding_position="all" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid"][milestone heading_inherit="h2" subject_padding="2%" color="Default" effect="count" number="4860" subject="User downloads" number_font_size="76"][/vc_column_inner][vc_column_inner column_padding="padding-2-percent" column_padding_position="all" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid"][milestone heading_inherit="h2" subject_padding="2%" color="Default" effect="count" number="3470" subject="Hours watched" number_font_size="76"][/vc_column_inner][vc_column_inner column_padding="padding-2-percent" column_padding_position="all" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid"][milestone heading_inherit="h2" subject_padding="2%" color="Default" effect="count" number="239" subject="Raving reviews" number_font_size="76"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/12" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Flip Box Services', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['services'];
$data['custom_class'] = 'services date-29-Aug-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/flipbox-services.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" bg_color="#f9f7f5" scene_position="center" text_color="dark" text_align="left" bottom_padding="5%" id="services" overlay_strength="0.3"][vc_column column_padding="padding-4-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" bottom_margin="20" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="grow-in" column_padding="padding-1-percent" column_padding_position="all" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid" offset="vc_col-lg-4 vc_col-md-12"][nectar_flip_box image_url_1="https://themenectar.com/img/demo-media/unsplash/webp/600-600-flame.webp" bg_color="#0a0a0a" bg_color_overlay="true" text_color="light" icon_family="iconsmind" icon_color="Accent-Color" bg_color_2="#1239ff" text_color_2="light" h_text_align="center" v_text_align="center" flip_direction="horizontal-to-left" front_content="
<h3>Content
<i>Creation</i></h3>
" icon_iconsmind="iconsmind-Telescope" min_height="400"]Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live on.[/nectar_flip_box][/vc_column_inner][vc_column_inner enable_animation="true" animation="grow-in" column_padding="padding-1-percent" column_padding_position="all" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid" offset="vc_col-lg-4 vc_col-md-12"][nectar_flip_box image_url_1="https://themenectar.com/img/demo-media/unsplash/webp/600-600-girl.webp" bg_color="#0a0a0a" bg_color_overlay="true" text_color="light" icon_family="iconsmind" icon_color="Accent-Color" bg_color_2="#1239ff" text_color_2="light" h_text_align="center" v_text_align="center" flip_direction="horizontal-to-left" front_content="
<h3>Market
<i>Growth</i></h3>
" icon_iconsmind="iconsmind-Spring" min_height="400"]The Big Oxmox advised her not to do so, because there were thousands of bad Commas, wild Question Marks and devious Semikoli.[/nectar_flip_box][/vc_column_inner][vc_column_inner enable_animation="true" animation="grow-in" column_padding="padding-1-percent" column_padding_position="all" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid" offset="vc_col-lg-4 vc_col-md-12"][nectar_flip_box image_url_1="https://themenectar.com/img/demo-media/unsplash/webp/600-600-guy.webp" bg_color="#0a0a0a" bg_color_overlay="true" text_color="light" icon_family="iconsmind" icon_color="Accent-Color" bg_color_2="#1239ff" text_color_2="light" h_text_align="center" v_text_align="center" flip_direction="horizontal-to-left" front_content="
<h3>Ending
<i>Competition</i></h3>
" icon_iconsmind="iconsmind-Grave" min_height="400"]Pityful a rethoric question ran over her cheek, then she continued her way. On her way she met a copy. The copy warned the Little Blind Text.[/nectar_flip_box][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="grow-in" column_padding="padding-1-percent" column_padding_position="all" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid" offset="vc_col-lg-4 vc_col-md-12"][nectar_flip_box image_url_1="https://themenectar.com/img/demo-media/unsplash/webp/600-800-leaves.webp" bg_color="#0a0a0a" bg_color_overlay="true" text_color="light" icon_family="iconsmind" icon_color="Accent-Color" bg_color_2="#1239ff" text_color_2="light" h_text_align="center" v_text_align="center" flip_direction="horizontal-to-left" front_content="
<h3>Private
<i>Tutoring</i></h3>
" icon_iconsmind="iconsmind-Face-Style2" min_height="400"]ar from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast.[/nectar_flip_box][/vc_column_inner][vc_column_inner enable_animation="true" animation="grow-in" column_padding="padding-1-percent" column_padding_position="all" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid" offset="vc_col-lg-4 vc_col-md-12"][nectar_flip_box image_url_1="https://themenectar.com/img/demo-media/unsplash/webp/600-800-waterfall.webp" bg_color="#0a0a0a" bg_color_overlay="true" text_color="light" icon_family="iconsmind" icon_color="Accent-Color" bg_color_2="#1239ff" text_color_2="light" h_text_align="center" v_text_align="center" flip_direction="horizontal-to-left" front_content="
<h3>Event
<i>Hosting</i></h3>
" icon_iconsmind="iconsmind-The-WhiteHouse" min_height="400"]Even the all-powerful Pointing has no control about the blind texts it is an almost life One day however a small line of blind text.[/nectar_flip_box][/vc_column_inner][vc_column_inner enable_animation="true" animation="grow-in" column_padding="padding-1-percent" column_padding_position="all" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid" offset="vc_col-lg-4 vc_col-md-12"][nectar_flip_box image_url_1="https://themenectar.com/img/demo-media/unsplash/webp/600-600-man.webp" bg_color="#0a0a0a" bg_color_overlay="true" text_color="light" icon_family="iconsmind" icon_color="Accent-Color" bg_color_2="#1239ff" text_color_2="light" h_text_align="center" v_text_align="center" flip_direction="horizontal-to-left" front_content="
<h3>Browser<i>Addons</i></h3>
" icon_iconsmind="iconsmind-Love-Window" min_height="400"]But nothing the copy said could convince her and so it didn’t take long until a few insidious Copy Writers ambushed her, made her drunk.[/nectar_flip_box][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );

$data = array();
$data['name'] = esc_html__( 'Minimal Testimonial Slider', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['testimonials'];
$data['custom_class'] = 'testimonials date-29-Aug-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/minimal-testimonial-slider.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_color="#ffffff" scene_position="center" text_color="dark" text_align="left" top_padding="7%" bottom_padding="7%" overlay_strength="0.3"][vc_column centered_text="true" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_column_text]
<h5 style="text-align: center;">What They're Saying</h5>
[/vc_column_text][divider line_type="Small Line" line_thickness="2" divider_color="accent-color" animate="yes" custom_height="50" custom_line_width="80"][testimonial_slider style="minimal" disable_height_animation="true"][testimonial title="Testimonial" id="1475857961-1-94" tab_id="1475858133769-1" name="Eve Crawford" subtitle="Product Designer" quote="It was really fun getting to know the team during the project. They were all helpful in answering my questions and made me feel at ease. The design ended up being better than I could have envisioned!"] Click the edit button to add your testimonial. [/testimonial][testimonial title="Testimonial" id="1475857961-2-87" tab_id="1475858133938-7" name="Aura Brooks" subtitle="Graphic Designer" quote="By far the best team I've ever worked with. They truly understood the look I was going for and completely nailed it! I would highly recommend them as a company, you simply just won't find any better team!"] Click the edit button to add your testimonial. [/testimonial][testimonial title="Testimonial" id="1475858204372-0-6" tab_id="1475858133938-7" name="Zak Reid" subtitle="Instructor, Skate Nao" quote="Salient is by far the most astonishing WP theme out there! I literally could not be happier that I chose to buy your theme! Your regular updates and superb attention to detail blows me away every time I visit my new site!"] Click the edit button to add your testimonial. [/testimonial][testimonial title="Testimonial" id="1475858232487-0-1" tab_id="1475858133938-7" name="Jack Graham" subtitle="Co Founder, Coffee Inc" quote="I'm wondering why I never contacted these guys sooner! Seriously, they all have commendable talent in their respective fields and knocked my concept out of the ballpark. Thanks for an amazing experience!"] Click the edit button to add your testimonial. [/testimonial][/testimonial_slider][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );

$data = array();
$data['name'] = esc_html__( 'Three Columns With Icons & Text Block', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['services'] .', '. $cat_display_names['icons'];
$data['custom_class'] = 'services icons date-29-Aug-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/3-col-icons.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_color="#ffffff" scene_position="center" text_color="dark" text_align="left" top_padding="7%" bottom_padding="7%" overlay_strength="0.3"][vc_column centered_text="true" column_padding="padding-1-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="grow-in" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid"][nectar_icon icon_family="iconsmind" icon_style="border-basic" icon_border_thickness="2px" icon_color="Accent-Color" icon_padding="25px" icon_iconsmind="iconsmind-Ship-2" margin_bottom="15" icon_size="40"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid" delay="100"][vc_column_text max_width="315"]
<h4>Thousands Of Icons</h4>
[/vc_column_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid" delay="200"][vc_column_text max_width="315" css=".vc_custom_1476572530813{margin-top: -20px !important;}"]<span style="color: #aaa;">Salient comes packed with amazing icon families for you to choose from. Practically anything you could imagine exists.</span>[/vc_column_text][/vc_column_inner][/vc_row_inner][/vc_column][vc_column centered_text="true" column_padding="padding-1-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="grow-in" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid" delay="200"][nectar_icon icon_family="iconsmind" icon_style="border-basic" icon_border_thickness="2px" icon_color="Accent-Color" icon_padding="25px" icon_iconsmind="iconsmind-Wolf" margin_bottom="15" icon_size="40"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid" delay="300"][vc_column_text max_width="315"]
<h4>Beautiful Design</h4>
[/vc_column_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid" delay="400"][vc_column_text max_width="315" css=".vc_custom_1476572575460{margin-top: -20px !important;}"]<span style="color: #aaa;">Quality over quantity. Enjoy a vast array of carefully designed &amp; unique elements with tons of control over fine tuning them.</span>[/vc_column_text][/vc_column_inner][/vc_row_inner][/vc_column][vc_column centered_text="true" column_padding="padding-1-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="grow-in" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid" delay="400"][nectar_icon icon_family="iconsmind" icon_style="border-basic" icon_border_thickness="2px" icon_color="Accent-Color" icon_padding="25px" icon_iconsmind="iconsmind-Microscope" margin_bottom="15" icon_size="40"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid" delay="400"][vc_column_text max_width="315"]
<h4>Extensive Documentation</h4>
[/vc_column_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid" delay="500"][vc_column_text max_width="315" css=".vc_custom_1476572677993{margin-top: -20px !important;}"]<span style="color: #aaa;"> Never feel lost again. Documentation is available in addition to a series of video tutorials exclusively for Salient.</span>[/vc_column_text][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Single Project Simple', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['about'] .', '. $cat_display_names['portfolio'];
$data['custom_class'] = 'about portfolio';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/green-proj.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#f9f9f9" scene_position="center" top_padding="5%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none"][vc_column column_padding="padding-1-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_column_text]
<h6><span style="color: #50d18d;">Overview</span></h6>
[/vc_column_text][/vc_column][/vc_row][vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#f9f9f9" scene_position="center" bottom_padding="4%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none"][vc_column column_padding="padding-1-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_column_text]Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean. A small river named Duden flows by their place and supplies it with the necessary regelialia. It is a paradisematic country, in which roasted parts of sentences fly into your mouth. Even the all-powerful Pointing has no control about the blind texts it is an almost unorthographic life One day however a small line of blind text by the name of Lorem Ipsum decided to leave for the far World of Grammar.[/vc_column_text][/vc_column][vc_column column_padding="padding-1-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_column_text]She packed her seven versalia, put her initial into the belt and made herself on the way. When she reached the first hills of the Italic Mountains, she had a last view back on the skyline of her hometown Bookmarksgrove, the headline of Alphabet Village and the subline of her own road, the Line Lane. Pityful a rethoric question ran over her cheek, then she continued her way. On her way she met a copy.[/vc_column_text][/vc_column][vc_column column_padding="padding-1-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1451934363103{border-top-width: 2px !important;border-right-width: 2px !important;border-bottom-width: 2px !important;border-left-width: 2px !important;padding-top: 40px !important;padding-right: 40px !important;padding-bottom: 40px !important;padding-left: 40px !important;border-left-color: #0a0a0a !important;border-left-style: solid !important;border-right-color: #0a0a0a !important;border-right-style: solid !important;border-top-color: #0a0a0a !important;border-top-style: solid !important;border-bottom-color: #0a0a0a !important;border-bottom-style: solid !important;}"]
<h6><span style="color: #50d18d;">Project</span></h6>
Waveform Concept Design[/vc_column_text][divider line_type="No Line" custom_height="30"][vc_column_text css=".vc_custom_1451934370844{border-top-width: 2px !important;border-right-width: 2px !important;border-bottom-width: 2px !important;border-left-width: 2px !important;padding-top: 40px !important;padding-right: 40px !important;padding-bottom: 40px !important;padding-left: 40px !important;border-left-color: #0a0a0a !important;border-left-style: solid !important;border-right-color: #0a0a0a !important;border-right-style: solid !important;border-top-color: #0a0a0a !important;border-top-style: solid !important;border-bottom-color: #0a0a0a !important;border-bottom-style: solid !important;}"]
<h6><span style="color: #50d18d;">Client</span></h6>
The People Inc.[/vc_column_text][divider line_type="No Line" custom_height="30"][vc_column_text css=".vc_custom_1451934352663{border-top-width: 2px !important;border-right-width: 2px !important;border-bottom-width: 2px !important;border-left-width: 2px !important;padding-top: 40px !important;padding-right: 40px !important;padding-bottom: 40px !important;padding-left: 40px !important;border-left-color: #0a0a0a !important;border-left-style: solid !important;border-right-color: #0a0a0a !important;border-right-style: solid !important;border-top-color: #0a0a0a !important;border-top-style: solid !important;border-bottom-color: #0a0a0a !important;border-bottom-style: solid !important;}"]
<h6><span style="color: #50d18d;">What We Did</span></h6>
Company Branding, Responsive Web Design[/vc_column_text][/vc_column][/vc_row][vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" scene_position="center" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none"][vc_column column_padding="padding-10-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][split_line_heading animation_type="line-reveal-by-space" font_style="h3" text_color="#50d18d" line_reveal_by_space_text_effect="default" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="The Big Oxmox advised
her not to do so, because there
were thousands of devious Semikoli"][/split_line_heading][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_column_text]I am text block. Click edit button to change this text. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut elit tellus, luctus nec ullamcorper mattis, pulvinar dapibus leo.[/vc_column_text][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color="#212121" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="reveal-from-bottom" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][/vc_column][/vc_row][vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" scene_position="center" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none"][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color="#282828" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="reveal-from-bottom" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][/vc_column][vc_column column_padding="padding-10-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][split_line_heading animation_type="line-reveal-by-space" font_style="h3" text_color="#50d18d" line_reveal_by_space_text_effect="default" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="The Big Oxmox advised
her not to do so, because there
were thousands of devious Semikoli"][/split_line_heading][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_column_text]I am text block. Click edit button to change this text. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut elit tellus, luctus nec ullamcorper mattis, pulvinar dapibus leo.[/vc_column_text][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Single Project With Gallery Slider', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['portfolio'];
$data['custom_class'] = 'portfolio';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/project-with-slider.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" image_bg="https://themenectar.com/img/demo-media/unsplash/webp/large-mountain.webp" bg_color="#f9f9f9" scene_position="center" text_color="dark" text_align="left" top_padding="5%" overlay_strength="0.3"][vc_column column_padding="padding-1-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_column_text]
<h2><span style="color: #50d18e;">Overview</span></h2>
[/vc_column_text][/vc_column][/vc_row][vc_row type="full_width_background" full_screen_row_position="middle" bg_color="#f9f9f9" scene_position="center" text_color="dark" text_align="left" bottom_padding="4%" overlay_strength="0.3"][vc_column column_padding="padding-1-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_column_text]<span style="color: #999999;">Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean. A small river named Duden flows by their place and supplies it with the necessary regelialia. It is a paradisematic country, in which roasted parts of sentences fly into your mouth. Even the all-powerful Pointing has no control about the blind texts it is an almost unorthographic life One day however a small line of blind text by the name of Lorem Ipsum decided to leave for the far World of Grammar.</span>[/vc_column_text][/vc_column][vc_column column_padding="padding-1-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_column_text]<span style="color: #999999;">She packed her seven versalia, put her initial into the belt and made herself on the way. When she reached the first hills of the Italic Mountains, she had a last view back on the skyline of her hometown Bookmarksgrove, the headline of Alphabet Village and the subline of her own road, the Line Lane. Pityful a rethoric question ran over her cheek, then she continued her way. On her way she met a copy.</span>[/vc_column_text][/vc_column][vc_column column_padding="padding-1-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_column_text]
<h6><span style="color: #50d18e;">Project</span></h6>
<span style="color: #999999;">Salient Blog Design</span>[/vc_column_text][divider line_type="No Line" custom_height="30"][vc_column_text]
<h6><span style="color: #50d18e;">Client</span></h6>
<span style="color: #999999;">ThemeNectar</span>[/vc_column_text][divider line_type="No Line" custom_height="30"][vc_column_text]
<h6><span style="color: #50d18e;">What We Did</span></h6>
<span style="color: #999999;">UI/UX Design, Responsive Web Design</span>[/vc_column_text][/vc_column][/vc_row][vc_row type="full_width_background" full_screen_row_position="middle" bg_image="6225" bg_position="center center" bg_repeat="no-repeat" scene_position="center" text_color="light" text_align="center" top_padding="22%" bottom_padding="22%" enable_gradient="true" color_overlay="#585b64" color_overlay_2="#2c2f38" gradient_direction="left_t_to_right_b" overlay_strength="0.8"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][nectar_video_lightbox link_style="play_button" video_url="https://www.youtube.com/watch?v=6oTurM7gESE"][/vc_column][/vc_row][vc_row type="full_width_background" full_screen_row_position="middle" scene_position="center" text_color="dark" text_align="left" top_padding="5%" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="2/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][split_line_heading animation_type="default"]
<h2 style="color: #50d18e;">Design How it's meant to be.</h2>
<h2 style="color: #50d18e;">Salient Will Enhance Your Content</h2>
<h2 style="color: #50d18e;">And Allow It To Fully Shine.</h2>
[/split_line_heading][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid"][vc_column_text]<span style="color: #999999;">She packed her seven versalia, put her initial into the belt and made herself on the way. When she reached the first hills of the Italic Mountains, she had a last view back on the skyline of her hometown Bookmarksgrove</span>,[/vc_column_text][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="padding-2-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][/vc_row][vc_row type="full_width_content" full_screen_row_position="middle" scene_position="center" text_color="dark" text_align="left" bottom_padding="5%" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_gallery type="flickity_style" flickity_controls="pagination" flickity_desktop_columns="1" flickity_small_desktop_columns="1" flickity_tablet_columns="1" flickity_box_shadow="none" onclick="link_no" img_size="full"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Info Boxes Bordered & Heading', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['services'] .', '. $cat_display_names['about'];
$data['custom_class'] = 'about services';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/three-info-boxes.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" scene_position="center" text_color="dark" text_align="left" top_padding="10%" bottom_padding="10%" overlay_strength="0.3"][vc_column column_padding="padding-4-percent" column_padding_position="bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/4" column_border_width="none" column_border_style="solid" offset="vc_hidden-sm vc_hidden-xs"][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" centered_text="true" background_color_opacity="1" width="1/2" column_border_width="none" column_border_style="solid" offset="vc_col-xs-12"][vc_column_text max_width="600"]
<h2>We Are Salient</h2>
[/vc_column_text][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/4" column_border_width="none" column_border_style="solid" offset="vc_hidden-sm vc_hidden-xs"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" bottom_padding="80" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/4" column_border_width="none" column_border_style="solid" delay="50" offset="vc_hidden-sm vc_hidden-xs"][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" centered_text="true" background_color_opacity="1" width="1/2" column_border_width="none" column_border_style="solid" delay="100" offset="vc_col-xs-12"][vc_custom_heading text="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the little blind texts. The Big Oxmox advised her not to do so, because there were thousands of bad Commas." font_container="tag:p|text_align:center|color:rgba(0%2C0%2C0%2C0.65)" use_theme_fonts="yes" css_animation="none"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/4" column_border_width="none" column_border_style="solid" offset="vc_hidden-sm vc_hidden-xs"][/vc_column_inner][/vc_row_inner][vc_row_inner equal_height="yes" content_placement="middle" column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in" column_padding="padding-4-percent" column_padding_position="all" background_color_opacity="1" width="1/3" column_border_width="2px" column_border_color="#e2e2e2" column_border_style="solid" enable_border_animation="true"][vc_custom_heading text="It's time to make moves" font_container="tag:p|font_size:14|text_align:left|color:%230a0a0a|line_height:20px" google_fonts="font_family:Roboto%3A100%2C100italic%2C300%2C300italic%2Cregular%2Citalic%2C500%2C500italic%2C700%2C700italic%2C900%2C900italic|font_style:700%20bold%20regular%3A700%3Anormal" css_animation="none" css=".vc_custom_1485617597027{margin-bottom: -15px !important;}"][vc_custom_heading text="A small river named Duden flows by their place and supplies it with the necessary regelialia. It is a paradisematic country." font_container="tag:p|text_align:left|color:%23878787" use_theme_fonts="yes" css_animation="none" css=".vc_custom_1485617691025{margin-bottom: -15px !important;}"][nectar_btn size="large" button_style="regular" button_color_2="Accent-Color" color_override="#ff1654" icon_family="iconsmind" text="See More" icon_iconsmind="iconsmind-Triangle-ArrowRight" margin_top="50"][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in" column_padding="padding-4-percent" column_padding_position="all" background_color_opacity="1" width="1/3" column_border_width="2px" column_border_color="#e2e2e2" column_border_style="solid" enable_border_animation="true" border_animation_delay="300" delay="300"][vc_custom_heading text="Now or never" font_container="tag:p|font_size:14|text_align:left|color:%230a0a0a|line_height:20px" google_fonts="font_family:Roboto%3A100%2C100italic%2C300%2C300italic%2Cregular%2Citalic%2C500%2C500italic%2C700%2C700italic%2C900%2C900italic|font_style:700%20bold%20regular%3A700%3Anormal" css_animation="none" css=".vc_custom_1485617617425{margin-bottom: -15px !important;}"][vc_custom_heading text="A small river named Duden flows by their place and supplies it with the necessary regelialia. It is a paradisematic country." font_container="tag:p|text_align:left|color:%23878787" use_theme_fonts="yes" css_animation="none" css=".vc_custom_1485617691025{margin-bottom: -15px !important;}"][nectar_btn size="large" button_style="regular" button_color_2="Accent-Color" color_override="#ff1654" icon_family="iconsmind" text="See More" icon_iconsmind="iconsmind-Triangle-ArrowRight" margin_top="50"][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in" column_padding="padding-4-percent" column_padding_position="all" background_color_opacity="1" width="1/3" column_border_width="2px" column_border_color="#e2e2e2" column_border_style="solid" enable_border_animation="true" border_animation_delay="600" delay="600"][vc_custom_heading text="Stop waiting around" font_container="tag:p|font_size:14|text_align:left|color:%230a0a0a|line_height:20px" google_fonts="font_family:Roboto%3A100%2C100italic%2C300%2C300italic%2Cregular%2Citalic%2C500%2C500italic%2C700%2C700italic%2C900%2C900italic|font_style:700%20bold%20regular%3A700%3Anormal" css_animation="none" css=".vc_custom_1485617623831{margin-bottom: -15px !important;}"][vc_custom_heading text="A small river named Duden flows by their place and supplies it with the necessary regelialia. It is a paradisematic country." font_container="tag:p|text_align:left|color:%23878787" use_theme_fonts="yes" css_animation="none" css=".vc_custom_1485617691025{margin-bottom: -15px !important;}"][nectar_btn size="large" button_style="regular" button_color_2="Accent-Color" color_override="#ff1654" icon_family="iconsmind" text="See More" icon_iconsmind="iconsmind-Triangle-ArrowRight" margin_top="50"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Info Box Right Animated & Dark', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['hero_section'] .', '. $cat_display_names['about'];
$data['custom_class'] = 'about hero_section';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/info-box-right-dark.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_color="#161616" scene_position="center" text_color="light" text_align="left" top_padding="12%" bottom_padding="12%" overlay_strength="0.3"][vc_column column_padding="padding-4-percent" column_padding_position="bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="2/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" offset="vc_col-lg-8 vc_col-md-8 vc_col-xs-12"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="5/6" column_border_width="none" column_border_style="solid"][vc_column_text max_width="600" css=".vc_custom_1485444155911{margin-bottom: 30px !important;}"]
<h2>We Are Salient, A Digital First Design Agency</h2>
[/vc_column_text][vc_custom_heading text="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. The Big Oxmox advised her not to do so, because there were thousands of bad Commas." font_container="tag:p|text_align:left|color:%23828282" use_theme_fonts="yes" css_animation="none" css=".vc_custom_1485444104883{padding-right: 10% !important;}"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/6" column_border_width="none" column_border_style="solid"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="padding-4-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="4px" column_border_color="#2d2d2d" column_border_style="solid" enable_border_animation="true" offset="vc_col-lg-offset-0 vc_col-lg-4 vc_col-md-offset-0 vc_col-md-4 vc_col-xs-12"][vc_row_inner column_margin="default" text_align="left" css=".vc_custom_1485444358185{margin-bottom: 10px !important;}"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid"][vc_custom_heading text="It's time to make moves" font_container="tag:p|font_size:14|text_align:left|color:%23828282|line_height:20px" use_theme_fonts="yes" css_animation="none"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" bottom_padding="30" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid" delay="75"][vc_column_text css_animation="none"]A small river named Duden flows by their place and supplies it with the necessary regelialia. It is a paradisematic country.[/vc_column_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="grow-in" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid" delay="150"][nectar_btn size="large" button_style="regular" button_color_2="Accent-Color" color_override="#ff2861" icon_family="iconsmind" text="See More" icon_iconsmind="iconsmind-Triangle-ArrowRight"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Touch Enabled Gallery With Arrows', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['portfolio'];
$data['custom_class'] = 'portfolio gallery';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/gallery-arrows.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" scene_position="center" text_color="dark" text_align="left" top_padding="5%" bottom_padding="5%" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_gallery type="flickity_style" flickity_controls="next_prev_arrows" flickity_desktop_columns="1" flickity_small_desktop_columns="1" flickity_tablet_columns="1" flickity_box_shadow="large_depth" onclick="link_no"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Services & Company Gradient Intro Dark', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['about'] .', '. $cat_display_names['services'];
$data['custom_class'] = 'about services date-04-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/about-services-gradient.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#cbcbc3" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-mountain.webp" bg_position="center top" background_image_loading="default" bg_repeat="no-repeat" scene_position="center" top_padding="4%" bottom_padding="4%" text_color="light" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" id="intro" enable_gradient="true" color_overlay_2="#151519" overlay_strength="1" gradient_direction="top_to_bottom" shape_divider_position="bottom" bg_image_animation="none"][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" top_padding="65%" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][/vc_column_inner][/vc_row_inner][split_line_heading animation_type="line-reveal-by-space" font_style="h1" line_reveal_by_space_text_effect="default" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="Whether you need a new web application or company branding - we can help."][/split_line_heading][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_column_text]Our team has many skills so we're able to offer a wide array of services. Far away, behind the word mountains, far from the countries Vokalia and Contia, there live the blind texts. Separated they live in Booksgrove right at the coast of the Semantics, a large language ocean.

It is a paradisematic country, in which roasted parts of sentences fly into your mouth. Even the all-powerful Pointing has no control about the blind texts it is an almost unorthographic life.[/vc_column_text][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][/vc_column][/vc_row][vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#151519" scene_position="center" top_padding="7%" bottom_padding="7%" text_color="dark" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" id="services" enable_gradient="true" color_overlay="#232323" color_overlay_2="#191919" overlay_strength="1" gradient_direction="left_t_to_right_b" shape_divider_position="bottom" bg_image_animation="none"][vc_column column_padding="padding-1-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="reveal-from-bottom" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][fancy_box box_style="default" icon_family="none" image_url="6083" color="Accent-Color" border_radius="default" image_loading="default" link_url="https://themenectar.com/demo/salient-corporate/portfolio/blog-ui/" link_text="View Case Study" min_height="400"]
<h3>UI Design</h3>
Lorem ipsum dolor sit amet, consectetur adipiscing elit. In et arcu vel risus ullamcorper aliquet.[/fancy_box][/vc_column][vc_column column_padding="padding-1-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="reveal-from-bottom" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" delay="200"][fancy_box box_style="default" icon_family="none" image_url="6082" color="Extra-Color-1" border_radius="default" image_loading="default" link_url="https://themenectar.com/demo/salient-corporate/portfolio/night-sky-app/" link_text="View Case Study" min_height="400"]
<h3>Web Design</h3>
Lorem ipsum dolor sit amet, consectetur adipiscing elit. In et arcu vel risus ullamcorper aliquet.[/fancy_box][/vc_column][vc_column column_padding="padding-1-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="reveal-from-bottom" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" delay="400"][fancy_box box_style="default" icon_family="none" image_url="6052" color="Extra-Color-2" border_radius="default" image_loading="default" link_url="https://themenectar.com/demo/salient-corporate/portfolio/waveform/" link_text="View Case Study" min_height="400"]
<h3>Mountain Design</h3>
Lorem ipsum dolor sit amet, consectetur adipiscing elit. In et arcu vel risus ullamcorper aliquet.[/fancy_box][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Icons With SVG Draw Animation 4 Columns', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['icons']  .', '. $cat_display_names['general'];
$data['custom_class'] = 'general icons date-04-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/svg_icon_draw_2.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_color="#ffffff" scene_position="center" text_color="dark" text_align="left" top_padding="8%" bottom_padding="4%" overlay_strength="0.3" shape_divider_position="bottom"][vc_column centered_text="true" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_column_text]
<h2>Stunning Looks &amp; Functionality</h2>
<h5><span style="color: #bbbbbb;">Eliminate your website building stress by using Salient</span></h5>
[/vc_column_text][/vc_column][/vc_row][vc_row type="full_width_background" full_screen_row_position="middle" bg_color="#ffffff" scene_position="center" text_color="dark" text_align="left" bottom_padding="8%" overlay_strength="1" shape_divider_position="bottom"][vc_column enable_animation="true" animation="none" centered_text="true" column_padding="padding-1-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/4" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][nectar_icon icon_family="linea" enable_animation="true" animation_speed="fast" icon_style="default" icon_color="Accent-Color" icon_padding="0px" icon_linea="icon-ecommerce-diamond" icon_size="60"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid"][vc_column_text]
<h5>Hot Looks</h5>
<span style="color: #a3a3a3;">Ut elit tellus, luctus nec magna mattis et, pulvinar dapibus lorem leo ultricies et vitae enim.</span>[/vc_column_text][/vc_column_inner][/vc_row_inner][/vc_column][vc_column centered_text="true" column_padding="padding-1-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/4" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][nectar_icon icon_family="linea" enable_animation="true" animation_speed="fast" icon_style="default" icon_color="Accent-Color" icon_padding="0px" icon_linea="icon-basic-compass" animation_delay="400" icon_size="60"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" delay="400"][vc_column_text]
<h5>Easy Interface</h5>
<span style="color: #a3a3a3;">Ut elit tellus, luctus nec magna mattis et, pulvinar dapibus lorem leo ultricies et vitae enim.</span>[/vc_column_text][/vc_column_inner][/vc_row_inner][/vc_column][vc_column centered_text="true" column_padding="padding-1-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/4" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][nectar_icon icon_family="linea" enable_animation="true" animation_speed="fast" icon_style="default" icon_color="Accent-Color" icon_padding="0px" icon_linea="icon-software-layers2" animation_delay="800" icon_size="60"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" delay="800"][vc_column_text]
<h5>True Power</h5>
<span style="color: #a3a3a3;">Ut elit tellus, luctus nec magna mattis et, pulvinar dapibus lorem leo ultricies et vitae enim.</span>
[/vc_column_text][/vc_column_inner][/vc_row_inner][/vc_column][vc_column centered_text="true" column_padding="padding-1-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/4" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][nectar_icon icon_family="linea" enable_animation="true" animation_speed="fast" icon_style="default" icon_color="Accent-Color" icon_padding="0px" icon_linea="icon-basic-anchor" animation_delay="1200" icon_size="60"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" delay="1200"][vc_column_text]
<h5>Solid Code</h5>
<span style="color: #a3a3a3;">Ut elit tellus, luctus nec magna mattis et, pulvinar dapibus lorem leo ultricies et vitae enim.</span>[/vc_column_text][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Services With BG Hover', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['services'];
$data['custom_class'] = 'services';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/minimal_services.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" bg_position="left top" bg_repeat="no-repeat" parallax_bg_speed="slow" bg_color="#ffffff" scene_position="center" text_color="dark" text_align="left"][vc_column width="1/3" animation="none" column_padding="padding-7-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" background_color_hover="#f9f9f9"][vc_row_inner][vc_column_inner width="1/1" enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all"][vc_column_text]<span style="color: #000000;"><i>Item No.</i></span>[/vc_column_text][divider line_type="No Line" custom_height="10"][vc_column_text]
<h3><span style="color: #e4e4e4;">01.</span> Research</h3>
Quisque molestie elementum quam molestie malesuada. In sagittis urna vitae blandit molestie. Nam aliquet dui neque, eget tincidunt sem accumsan et. Suspendisse egestas, turpis eu pellentesque aliquam.[/vc_column_text][/vc_column_inner][/vc_row_inner][/vc_column][vc_column width="1/3" animation="none" column_padding="padding-7-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" background_color_hover="#f9f9f9"][vc_row_inner][vc_column_inner width="1/1" enable_animation="true" animation="fade-in-from-bottom" delay="200" column_padding="no-extra-padding" column_padding_position="all"][vc_column_text]<span style="color: #000000;"><i>Item No.</i></span>[/vc_column_text][divider line_type="No Line" custom_height="10"][vc_column_text]
<h3><span style="color: #e4e4e4;">02.</span> Design</h3>
Quisque molestie elementum quam molestie malesuada. In sagittis urna vitae blandit molestie. Nam aliquet dui neque, eget tincidunt sem accumsan et. Suspendisse egestas, turpis eu pellentesque aliquam.[/vc_column_text][/vc_column_inner][/vc_row_inner][/vc_column][vc_column width="1/3" animation="fade-in-from-bottom" column_padding="padding-7-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" background_color_hover="#f9f9f9"][vc_row_inner][vc_column_inner width="1/1" enable_animation="true" animation="fade-in-from-bottom" delay="400" column_padding="no-extra-padding" column_padding_position="all"][vc_column_text]<span style="color: #000000;"><i>Item No.</i></span>[/vc_column_text][divider line_type="No Line" custom_height="10"][vc_column_text]
<h3><span style="color: #e4e4e4;">03.</span> Develop</h3>
Quisque molestie elementum quam molestie malesuada. In sagittis urna vitae blandit molestie. Nam aliquet dui neque, eget tincidunt sem accumsan et. Suspendisse egestas, turpis eu pellentesque aliquam.[/vc_column_text][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'Before & After', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-04-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/before_after.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="in_container" full_screen_row_position="middle" top_padding="8%" bottom_padding="8%" scene_position="center" text_color="dark" text_align="left" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" width="1/1" tablet_text_alignment="default" phone_text_alignment="default"][vc_row_inner text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-right" column_padding="padding-4-percent" column_padding_position="all" background_color_opacity="1" width="1/4" offset="vc_col-lg-3 vc_col-md-4"][vc_column_text]
<h5 style="text-align: right;">Before Salient</h5>
<p style="text-align: right;"><span style="color: #a3a3a3;">Hand rolling code is fun sometimes, but not ideal for getting projects done quickly or allowing clients to maintain pages.</span></p>

[/vc_column_text][/vc_column_inner][vc_column_inner column_padding="padding-4-percent" column_padding_position="bottom" background_color_opacity="1" width="1/2" offset="vc_col-lg-6 vc_col-md-8"][nectar_image_comparison][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-left" column_padding="padding-4-percent" column_padding_position="all" background_color_opacity="1" width="1/4" offset="vc_col-lg-offset-0 vc_col-lg-3 vc_col-md-offset-4 vc_col-md-8"][vc_column_text]
<h5>With Salient</h5>
<span style="color: #a3a3a3;">Salient provides you a highly customized version of Visual Composer bundled with unique elements all available for use via the drag &amp; drop interface.</span>[/vc_column_text][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Hero Gradient Overlay With Video Lightbox', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['hero_section'];
$data['custom_class'] = 'hero_section date-04-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/hero_video_lightbox.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-mountain.webp" bg_position="left top" bg_repeat="no-repeat" scene_position="center" text_color="light" text_align="left" top_padding="14%" bottom_padding="12%" enable_gradient="true" color_overlay="#585b64" color_overlay_2="#2c2f38" gradient_direction="left_t_to_right_b" overlay_strength="0.95"][vc_column centered_text="true" column_padding="padding-3-percent" column_padding_position="left-right" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-1-percent" column_padding_position="bottom" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid" delay="200"][vc_column_text]
<h1>Salient Is Digital Brilliance</h1>
[/vc_column_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" bottom_padding="30" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid" delay="300"][vc_column_text]
<h2>Get Noticed and Stay Remembered</h2>
[/vc_column_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid" delay="400"][nectar_video_lightbox link_style="play_button" video_url="https://www.youtube.com/watch?v=6oTurM7gESE"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Bold Touch Enabled Testimonials', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['testimonials'];
$data['custom_class'] = 'testimonials date-04-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/flickity_testimonials.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" bg_color="#ffffff" scene_position="center" text_color="dark" text_align="left" top_padding="7%" bottom_padding="6%" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" width="1/1" tablet_text_alignment="default" phone_text_alignment="default"][testimonial_slider style="multiple_visible" color="accent-color-dark"][testimonial image="" title="Testimonial" tab_id="1451491481781-2" name="Aura Brooks" subtitle="Graphic Designer, Owl Eyes" quote="By far the best team I've ever worked with. They truly understood the look I was going for and completely nailed it! I would highly recommend them as a company, you simply just won't find any better team!" id="1484342188374-1"] Click the edit button to add your testimonial. [/testimonial][testimonial image="" title="Testimonial" tab_id="1451491481781-2" name="Eve Crawford" subtitle="Product Designer, That Biz" quote="It was really fun getting to know the team during the project. They were all helpful in answering my questions and made me feel completely at ease. The design ended up being twice as good as I could have ever envisioned!" id="1484342188403-2"] Click the edit button to add your testimonial. [/testimonial][testimonial image="" title="Testimonial" tab_id="1451491482058-4" name="Jack Graham" subtitle="Co founder, Coffee Inc" quote="I'm wondering why I never contacted these guys sooner! Seriously, they all have commendable talent in their respective fields and knocked my concept out of the ballpark. Thanks for an amazing experience!" id="1484342188418-3"] Click the edit button to add your testimonial. [/testimonial][testimonial image="" title="Testimonial" tab_id="1451491482058-4" name="Zak Reid" subtitle="Instructor, Skate Nao" quote="Salient is by far the most astonishing WP theme out there! I literally could not be happier that I chose to buy your theme! Your regular updates and superb attention to detail blows me away every time I visit my new site! " id="1484342188452-2"] Click the edit button to add your testimonial. [/testimonial][/testimonial_slider][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Light Cascading Images', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'] .', '. $cat_display_names['services'];
$data['custom_class'] = 'general services';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/cascading-imgs-light.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" scene_position="center" text_color="dark" text_align="left" top_padding="10%" bottom_padding="10%" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner equal_height="yes" content_placement="middle" column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/2" column_border_width="none" column_border_style="solid"][split_line_heading animation_type="line-reveal-by-space" font_style="h1" text_content="Nectar Automotive Is the Future"][/split_line_heading][vc_column_text css_animation="bottom-to-top" css=".vc_custom_1484775533999{margin-top: 15px !important;}" max_width="500"]Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean.[/vc_column_text][vc_column_text css_animation="bottom-to-top" css=".vc_custom_1484775539312{margin-top: 15px !important;}" max_width="500"]A small river named Duden flows by their place and supplies it with the necessary regelialia. It is a paradisematic country, in which roasted parts of sentences[/vc_column_text][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/2" column_border_width="none" column_border_style="solid"][nectar_cascading_images image_1_bg_color="#3452ff" image_1_offset_x_sign="+" image_1_offset_x="0%" image_1_offset_y_sign="+" image_1_offset_y="0%" image_1_rotate_sign="+" image_1_rotate="none" image_1_animation="Grow In" image_1_box_shadow="none" image_2_url="https://themenectar.com/img/demo-media/unsplash/webp/800-500-adventure.webp" image_2_offset_x_sign="+" image_2_offset_x="25%" image_2_offset_y_sign="+" image_2_offset_y="30%" image_2_rotate_sign="+" image_2_rotate="none" image_2_animation="Grow In" image_2_box_shadow="none" image_3_url="https://themenectar.com/img/demo-media/unsplash/webp/800-500-bike.webp" image_3_offset_x_sign="-" image_3_offset_x="15%" image_3_offset_y_sign="-" image_3_offset_y="30%" image_3_rotate_sign="+" image_3_rotate="none" image_3_animation="Grow In" image_3_box_shadow="x_large_depth" image_4_offset_x_sign="+" image_4_offset_x="0%" image_4_offset_y_sign="+" image_4_offset_y="0%" image_4_rotate_sign="+" image_4_rotate="none" image_4_animation="Fade In" image_4_box_shadow="none"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Dark Cascading Images', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'] .', '. $cat_display_names['hero_section'];
$data['custom_class'] = 'general hero_section date-05-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/dark-cascading-images.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_color="#18191c" scene_position="center" text_color="light" text_align="left" top_padding="10%" bottom_padding="10%" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner equal_height="yes" content_placement="middle" column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/2" column_border_width="none" column_border_style="solid"][split_line_heading animation_type="line-reveal-by-space" font_style="h1" line_reveal_by_space_text_effect="default" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="Nectar Automotive Is the Future"][/split_line_heading][vc_column_text css_animation="bottom-to-top" css=".vc_custom_1484775533999{margin-top: 15px !important;}" max_width="500"]Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean.[/vc_column_text][vc_column_text css_animation="bottom-to-top" css=".vc_custom_1484775539312{margin-top: 15px !important;}" max_width="500"]A small river named Duden flows by their place and supplies it with the necessary regelialia. It is a paradisematic country, in which roasted parts of sentences[/vc_column_text][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/2" column_border_width="none" column_border_style="solid"][nectar_cascading_images image_1_bg_color="#ff3a6f" image_1_offset_x_sign="+" image_1_offset_x="0%" image_1_offset_y_sign="+" image_1_offset_y="0%" image_1_rotate_sign="+" image_1_rotate="none" image_1_animation="Grow In" image_1_box_shadow="none" image_2_url="https://themenectar.com/img/demo-media/unsplash/webp/800-500-adventure.webp" image_2_offset_x_sign="+" image_2_offset_x="25%" image_2_offset_y_sign="+" image_2_offset_y="30%" image_2_rotate_sign="+" image_2_rotate="none" image_2_animation="Grow In" image_2_box_shadow="none" image_3_url="https://themenectar.com/img/demo-media/unsplash/webp/800-500-bike.webp" image_3_offset_x_sign="-" image_3_offset_x="15%" image_3_offset_y_sign="-" image_3_offset_y="30%" image_3_rotate_sign="+" image_3_rotate="none" image_3_animation="Grow In" image_3_box_shadow="x_large_depth" image_4_offset_x_sign="+" image_4_offset_x="0%" image_4_offset_y_sign="+" image_4_offset_y="0%" image_4_rotate_sign="+" image_4_rotate="none" image_4_animation="Fade In" image_4_box_shadow="none"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Colorful Blocks', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['about'] .', '. $cat_display_names['general'] .', '. $cat_display_names['portfolio'];
$data['custom_class'] = 'about general portfolio date-05-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/colorful-blocks.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" bg_color="#18191c" scene_position="center" text_color="light" text_align="left" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner equal_height="yes" content_placement="middle" column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="flip-in-vertical" background_image="https://themenectar.com/img/demo-media/unsplash/webp/mountain.webp" enable_bg_scale="true" column_padding="padding-7-percent" column_padding_position="all" background_color="#568283" background_color_opacity="0.7" width="1/2" column_border_width="none" column_border_style="solid"][divider line_type="No Line" custom_height="150"][/vc_column_inner][vc_column_inner enable_animation="true" animation="flip-in-vertical" column_padding="padding-7-percent" column_padding_position="all" background_color="#ffffff" background_color_opacity="1" font_color="#e2e2e2" width="1/2" column_border_width="none" column_border_style="solid" delay="100"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color="black" icon_padding="0px" icon_size="40" icon_iconsmind="iconsmind-Finger-Print"][vc_custom_heading text="Assembled Custom Just For You" font_container="tag:h4|font_size:38|text_align:left|color:%233f3f3f|line_height:46px" use_theme_fonts="yes" css=".vc_custom_1484779752863{margin-top: -10px !important;}"][/vc_column_inner][/vc_row_inner][vc_row_inner equal_height="yes" content_placement="middle" column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="flip-in-vertical" column_padding="padding-7-percent" column_padding_position="all" background_color="#ff3a6f" background_color_opacity="1" width="1/2" column_border_width="none" column_border_style="solid"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color="white" icon_padding="0px" icon_iconsmind="iconsmind-Car-3" icon_size="40"][vc_custom_heading text="Speed &amp; Beauty Combined" font_container="tag:h4|font_size:38|text_align:left|color:%23ffffff|line_height:46px" use_theme_fonts="yes" css=".vc_custom_1484778589853{margin-top: -15px !important;}"][divider line_type="No Line" custom_height="100"][nectar_cta heading_tag="h5" text_color="#ffffff" link_type="regular" alignment="left" link_text="Learn More" url="#"][/vc_column_inner][vc_column_inner enable_animation="true" animation="flip-in-vertical" background_image="https://themenectar.com/img/demo-media/unsplash/webp/800-500-bike.webp" enable_bg_scale="true" column_padding="padding-7-percent" column_padding_position="all" background_color="#121212" background_color_opacity="0.7" width="1/2" column_border_width="none" column_border_style="solid" delay="100"][divider line_type="No Line" custom_height="150"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column enable_animation="true" animation="flip-in-vertical" column_padding="padding-9-percent" column_padding_position="all" background_color="#333333" background_color_opacity="0.5" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/webp/800-500-watch.webp" column_shadow="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" delay="200"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Testimonials With Color Background', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['testimonials'];
$data['custom_class'] = 'general';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/testimonial-blue.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_color="#0054ff" scene_position="center" text_color="light" text_align="left" top_padding="8%" bottom_padding="8%" overlay_strength="0.3"][vc_column centered_text="true" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_column_text]
<h3 style="text-align: center;">What They're Saying</h3>
[/vc_column_text][divider line_type="Small Line" line_thickness="4" divider_color="default" animate="yes" custom_height="80" custom_line_width="80"][testimonial_slider style="minimal" disable_height_animation="true"][testimonial title="Testimonial" id="1475858133769-1e903-6491" name="Eve Crawford" subtitle="Product Designer" quote="It was really fun getting to know the team during the project. They were all helpful in answering my questions and made me feel at ease. The design ended up being better than I could have envisioned!" tab_id="1484853492958-1"] Click the edit button to add your testimonial. [/testimonial][testimonial title="Testimonial" id="1475858133938-7e903-6491" name="Aura Brooks" subtitle="Graphic Designer" quote="By far the best team I've ever worked with. They truly understood the look I was going for and completely nailed it! I would highly recommend them as a company, you simply just won't find any better team!" tab_id="1484853492998-1"] Click the edit button to add your testimonial. [/testimonial][testimonial title="Testimonial" id="1475858133938-7e903-6491" name="Zak Reid" subtitle="Instructor, Skate Nao" quote="Salient is by far the most astonishing WP theme out there! I literally could not be happier that I chose to buy your theme! Your regular updates and superb attention to detail blows me away every time I visit my new site!" tab_id="1484853493034-5"] Click the edit button to add your testimonial. [/testimonial][testimonial title="Testimonial" id="1475858133938-7e903-6491" name="Jack Graham" subtitle="Co Founder, Coffee Inc" quote="I'm wondering why I never contacted these guys sooner! Seriously, they all have commendable talent in their respective fields and knocked my concept out of the ballpark. Thanks for an amazing experience!" tab_id="1484853493065-4"] Click the edit button to add your testimonial. [/testimonial][/testimonial_slider][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Video Lightbox With Preview Image', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'] .', '. $cat_display_names['portfolio'];
$data['custom_class'] = 'general portfolio';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/project-video.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_color="#f4f4f4" scene_position="center" text_color="dark" text_align="left" top_padding="8%" bottom_padding="8%" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/12" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][vc_column centered_text="true" column_padding="padding-5-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="10/12" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1484854759420{margin-bottom: 30px !important;}"]
<h2>Project Breakdown</h2>
[/vc_column_text][divider line_type="Small Line" line_thickness="4" divider_color="extra-color-gradient-2" animate="yes" custom_height="80" custom_line_width="100"][vc_column_text css=".vc_custom_1484854550359{margin-bottom: 50px !important;}" max_width="550"]Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean.[/vc_column_text][nectar_video_lightbox link_style="play_button_2" nectar_play_button_color="Default-Accent-Color" image_url="https://themenectar.com/img/demo-media/unsplash/webp/800-500-watch.webp" box_shadow="x_large_depth" video_url="https://www.youtube.com/watch?v=6oTurM7gESE"][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/12" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Trusty Milestones With Dark Background', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['counters'];
$data['custom_class'] = 'counters date-05-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/dark-milestones.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_color="#18191c" scene_position="center" text_color="light" text_align="left" top_padding="10%" bottom_padding="10%" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/12" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][vc_column centered_text="true" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="5/6" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="padding-4-percent" column_padding_position="all" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid"][milestone heading_inherit="h2" symbol_position="after" subject_padding="2%" color="Default" effect="count" symbol_alignment="Superscript" number="186" symbol="mph" subject="Top Speed" number_font_size="92" symbol_font_size="24"][/vc_column_inner][vc_column_inner column_padding="padding-4-percent" column_padding_position="all" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid"][milestone heading_inherit="h2" subject_padding="2%" color="Default" effect="count" number="547" subject="Horse Power" number_font_size="92"][/vc_column_inner][vc_column_inner column_padding="padding-4-percent" column_padding_position="all" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid"][milestone heading_inherit="h2" subject_padding="2%" color="Default" effect="count" number="413 " subject="pound-feet of torque" number_font_size="92"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/12" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Colors Used In Case Study', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['portfolio'];
$data['custom_class'] = 'portfolio';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/colors-used.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_color="#f4f4f4" scene_position="center" text_color="dark" text_align="left" top_padding="10%" bottom_padding="10%" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="5/12" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" offset="vc_col-xs-12"][vc_column_text max_width="450"]
<div data-mh="-1">
<h2 class="_HTf">Color &amp; material</h2>
</div>
[/vc_column_text][vc_column_text css=".vc_custom_1484678468218{margin-top: 25px !important;padding-right: 15% !important;}" max_width="500"]I am text block. Click edit button to change this text. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut elit tellus, luctus nec ullamcorper mattis, pulvinar dapibus leo. I am text block. Click edit button to change this text. Lorem ipsum dolor sit amet.[/vc_column_text][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="7/12" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" offset="vc_col-xs-12"][vc_row_inner equal_height="yes" content_placement="bottom" column_margin="none" text_align="left"][vc_column_inner enable_animation="true" animation="grow-in" column_padding="padding-7-percent" column_padding_position="top" background_color="#417e94" background_color_opacity="1" font_color="#ffffff" width="1/3" column_border_width="none" column_border_style="solid"][divider line_type="No Line" custom_height="85"][vc_column_text css=".vc_custom_1484677912962{padding-top: 25px !important;padding-right: 25px !important;padding-left: 25px !important;}"]
<h5>Washed Blue</h5>
[/vc_column_text][vc_column_text css=".vc_custom_1484677918997{padding-right: 25px !important;padding-bottom: 25px !important;padding-left: 25px !important;}"]#417e94[/vc_column_text][/vc_column_inner][vc_column_inner enable_animation="true" animation="grow-in" column_padding="padding-7-percent" column_padding_position="top" background_color="#ff3e57" background_color_opacity="1" font_color="#ffffff" width="1/3" column_border_width="none" column_border_style="solid" delay="200"][divider line_type="No Line" custom_height="85"][vc_column_text css=".vc_custom_1484677927395{padding-top: 25px !important;padding-right: 25px !important;padding-left: 25px !important;}"]
<h5>Magenta Magma</h5>
[/vc_column_text][vc_column_text css=".vc_custom_1484677934273{padding-right: 25px !important;padding-bottom: 25px !important;padding-left: 25px !important;}"]#c62a41[/vc_column_text][/vc_column_inner][vc_column_inner enable_animation="true" animation="grow-in" column_padding="padding-7-percent" column_padding_position="top" background_color="#634f4b" background_color_opacity="1" font_color="#ffffff" width="1/3" column_border_width="none" column_border_style="solid" delay="400"][divider line_type="No Line" custom_height="85"][vc_column_text css=".vc_custom_1484694811278{padding-top: 25px !important;padding-right: 25px !important;padding-left: 25px !important;}"]
<h5>Jaded Earth</h5>
[/vc_column_text][vc_column_text css=".vc_custom_1484677949891{padding-right: 25px !important;padding-bottom: 25px !important;padding-left: 25px !important;}"]#2f3530[/vc_column_text][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Fonts & Colors Used In Case Study', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['portfolio'];
$data['custom_class'] = 'portfolio';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/colors-used4.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" scene_position="center" text_color="light" text_align="left" top_padding="10%" bottom_padding="10%" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="flip-in-vertical" column_padding="padding-3-percent" column_padding_position="all" centered_text="true" background_color="#4800ff" background_color_opacity="1" width="1/6" column_border_width="none" column_border_style="solid"][vc_column_text]#4800ff[/vc_column_text][/vc_column_inner][vc_column_inner enable_animation="true" animation="flip-in-vertical" column_padding="padding-3-percent" column_padding_position="all" centered_text="true" background_color="#006aff" background_color_opacity="1" width="1/6" column_border_width="none" column_border_style="solid" delay="50"][vc_column_text]#003fff[/vc_column_text][/vc_column_inner][vc_column_inner enable_animation="true" animation="flip-in-vertical" column_padding="padding-3-percent" column_padding_position="all" centered_text="true" background_color="#00a9ff" background_color_opacity="1" width="1/6" column_border_width="none" column_border_style="solid" delay="100"][vc_column_text]#0099ff[/vc_column_text][/vc_column_inner][vc_column_inner enable_animation="true" animation="flip-in-vertical" column_padding="padding-3-percent" column_padding_position="all" centered_text="true" background_color="#00cbff" background_color_opacity="1" width="1/6" column_border_width="none" column_border_style="solid" delay="150"][vc_column_text]#00cbff[/vc_column_text][/vc_column_inner][vc_column_inner enable_animation="true" animation="flip-in-vertical" column_padding="padding-3-percent" column_padding_position="all" centered_text="true" background_color="#5cce5e" background_color_opacity="1" width="1/6" column_border_width="none" column_border_style="solid" delay="200"][vc_column_text]#5cce5e[/vc_column_text][/vc_column_inner][vc_column_inner enable_animation="true" animation="flip-in-vertical" column_padding="padding-3-percent" column_padding_position="all" centered_text="true" background_color="#4faf57" background_color_opacity="1" width="1/6" column_border_width="none" column_border_style="solid" delay="250"][vc_column_text]#4faf57[/vc_column_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" top_padding="7%" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid"][vc_custom_heading text="Exo Bold" font_container="tag:h4|font_size:20|text_align:left|color:%230a0a0a" google_fonts="font_family:Exo%3A100%2C100italic%2C200%2C200italic%2C300%2C300italic%2Cregular%2Citalic%2C500%2C500italic%2C600%2C600italic%2C700%2C700italic%2C800%2C800italic%2C900%2C900italic|font_style:700%20bold%20regular%3A700%3Anormal"][vc_custom_heading text="Aa" font_container="tag:h2|font_size:80|text_align:left|color:%230a0a0a|line_height:110px" google_fonts="font_family:Exo%3A100%2C100italic%2C200%2C200italic%2C300%2C300italic%2Cregular%2Citalic%2C500%2C500italic%2C600%2C600italic%2C700%2C700italic%2C800%2C800italic%2C900%2C900italic|font_style:700%20bold%20regular%3A700%3Anormal"][vc_custom_heading text="A B C D E F G H I J K L M N O P Q R S T U V W X Y Z
a b c d e f g h i j k l m n o p q r s t u v w x y z" font_container="tag:p|font_size:12|text_align:left|color:%230a0a0a|line_height:22px" google_fonts="font_family:Exo%3A100%2C100italic%2C200%2C200italic%2C300%2C300italic%2Cregular%2Citalic%2C500%2C500italic%2C600%2C600italic%2C700%2C700italic%2C800%2C800italic%2C900%2C900italic|font_style:700%20bold%20regular%3A700%3Anormal"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid"][vc_custom_heading text="Exo Regular" font_container="tag:h4|font_size:20|text_align:left|color:%230a0a0a" google_fonts="font_family:Exo%3A100%2C100italic%2C200%2C200italic%2C300%2C300italic%2Cregular%2Citalic%2C500%2C500italic%2C600%2C600italic%2C700%2C700italic%2C800%2C800italic%2C900%2C900italic|font_style:400%20regular%3A400%3Anormal"][vc_custom_heading text="Aa" font_container="tag:h2|font_size:80|text_align:left|color:%230a0a0a|line_height:110px" google_fonts="font_family:Exo%3A100%2C100italic%2C200%2C200italic%2C300%2C300italic%2Cregular%2Citalic%2C500%2C500italic%2C600%2C600italic%2C700%2C700italic%2C800%2C800italic%2C900%2C900italic|font_style:400%20regular%3A400%3Anormal"][vc_custom_heading text="A B C D E F G H I J K L M N O P Q R S T U V W X Y Z
a b c d e f g h i j k l m n o p q r s t u v w x y z" font_container="tag:p|font_size:12|text_align:left|color:%230a0a0a|line_height:22px" google_fonts="font_family:Exo%3A100%2C100italic%2C200%2C200italic%2C300%2C300italic%2Cregular%2Citalic%2C500%2C500italic%2C600%2C600italic%2C700%2C700italic%2C800%2C800italic%2C900%2C900italic|font_style:400%20regular%3A400%3Anormal"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid"][vc_custom_heading text="Philosopher Regular" font_container="tag:h4|font_size:20|text_align:left|color:%230a0a0a" google_fonts="font_family:Philosopher%3Aregular%2Citalic%2C700%2C700italic|font_style:400%20regular%3A400%3Anormal"][vc_custom_heading text="Aa" font_container="tag:h2|font_size:80|text_align:left|color:%230a0a0a|line_height:110px" google_fonts="font_family:Philosopher%3Aregular%2Citalic%2C700%2C700italic|font_style:400%20regular%3A400%3Anormal"][vc_custom_heading text="A B C D E F G H I J K L M N O P Q R S T U V W X Y Z
a b c d e f g h i j k l m n o p q r s t u v w x y z" font_container="tag:p|font_size:12|text_align:left|color:%230a0a0a|line_height:22px" google_fonts="font_family:Philosopher%3Aregular%2Citalic%2C700%2C700italic|font_style:400%20regular%3A400%3Anormal"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Project Header With Gradient', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['portfolio'];
$data['custom_class'] = 'portfolio date-10-Aug-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/project-header-3.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" scene_position="center" text_color="dark" text_align="left" top_padding="10%" bottom_padding="10%" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/12" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="10/12" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" bottom_padding="40" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid"][nectar_gradient_text heading_tag="h2" color="extra-color-gradient-1" gradient_direction="diagonal" text="Imagination will often carry us to worlds that never were. But without it we go nowhere."][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/4" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1484758894175{margin-bottom: 5px !important;}"]
<h5>Deliverables</h5>
[/vc_column_text][fancy-ul icon_type="none"]
<ul>
 	<li>App Design</li>
 	<li>Photography</li>
 	<li>Strategy</li>
</ul>
[/fancy-ul][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/4" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1484674851189{margin-bottom: 5px !important;}"]
<h5>Awards &amp; Mentions</h5>
[/vc_column_text][fancy-ul icon_type="none"]
<ul>
 	<li>App Inspire</li>
 	<li>Best Promo</li>
</ul>
[/fancy-ul][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/4" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1484674945481{margin-bottom: 5px !important;}"]
<h5>Client</h5>
[/vc_column_text][fancy-ul icon_type="none"]Salient App[/fancy-ul][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/4" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1484758899086{margin-bottom: 5px !important;}"]
<h5>Year</h5>
[/vc_column_text][vc_column_text]2017[/vc_column_text][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/12" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'Project Colors & Fonts Used Alternative', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['portfolio'];
$data['custom_class'] = 'portfolio';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/colors-used3.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_color="#f4f4f4" scene_position="center" text_color="dark" text_align="left" top_padding="10%" bottom_padding="10%" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/12" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" offset="vc_col-xs-12"][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="10/12" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" offset="vc_col-xs-12"][vc_column_text]
<h3>Colors &amp; Material</h3>
[/vc_column_text][divider line_type="Small Line" line_thickness="2" divider_color="extra-color-gradient-1" animate="yes" custom_height="50" custom_line_width="50"][vc_row_inner equal_height="yes" content_placement="bottom" column_margin="none" top_padding="20" text_align="left"][vc_column_inner enable_animation="true" animation="grow-in" column_padding="padding-7-percent" column_padding_position="top" background_color="#007eff" background_color_opacity="1" font_color="#ffffff" width="1/3" column_border_width="none" column_border_style="solid"][divider line_type="No Line" custom_height="85"][vc_column_text css=".vc_custom_1484761535257{padding-top: 25px !important;padding-right: 25px !important;padding-left: 25px !important;}"]
<h5>Extra Blue</h5>
[/vc_column_text][vc_column_text css=".vc_custom_1484761580916{padding-right: 25px !important;padding-bottom: 25px !important;padding-left: 25px !important;}"]#007eff[/vc_column_text][/vc_column_inner][vc_column_inner enable_animation="true" animation="grow-in" column_padding="padding-7-percent" column_padding_position="top" background_color="#ff3e57" background_color_opacity="1" font_color="#ffffff" width="1/3" column_border_width="none" column_border_style="solid" delay="200"][divider line_type="No Line" custom_height="85"][vc_column_text css=".vc_custom_1484677927395{padding-top: 25px !important;padding-right: 25px !important;padding-left: 25px !important;}"]
<h5>Magenta Magma</h5>
[/vc_column_text][vc_column_text css=".vc_custom_1484677934273{padding-right: 25px !important;padding-bottom: 25px !important;padding-left: 25px !important;}"]#c62a41[/vc_column_text][/vc_column_inner][vc_column_inner enable_animation="true" animation="grow-in" column_padding="padding-7-percent" column_padding_position="top" background_color="#333437" background_color_opacity="1" font_color="#ffffff" width="1/3" column_border_width="none" column_border_style="solid" delay="400"][divider line_type="No Line" custom_height="85"][vc_column_text css=".vc_custom_1484761552756{padding-top: 25px !important;padding-right: 25px !important;padding-left: 25px !important;}"]
<h5>Night Sky</h5>
[/vc_column_text][vc_column_text css=".vc_custom_1484761569924{padding-right: 25px !important;padding-bottom: 25px !important;padding-left: 25px !important;}"]#333437[/vc_column_text][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/12" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][/vc_row][vc_row type="full_width_background" full_screen_row_position="middle" scene_position="center" text_color="dark" text_align="left" top_padding="10%" bottom_padding="10%" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/12" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="10/12" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_column_text]
<h3>Typography</h3>
[/vc_column_text][divider line_type="Small Line" line_thickness="2" divider_color="extra-color-gradient-1" animate="yes" custom_height="50" custom_line_width="50"][vc_column_text css=".vc_custom_1484761292387{margin-bottom: 10px !important;}"]Lato Bold[/vc_column_text][vc_custom_heading text="A B C D E F G H I J K L M N O P Q R S T U V W X Y Z" font_container="tag:h3|font_size:30|text_align:left|color:%230a0a0a" google_fonts="font_family:Lato%3A100%2C100italic%2C300%2C300italic%2Cregular%2Citalic%2C700%2C700italic%2C900%2C900italic|font_style:900%20bold%20regular%3A900%3Anormal"][vc_custom_heading text="a b c d e f g h i j k l m n o p q r s t u v w x y z" font_container="tag:h4|font_size:30|text_align:left|color:%230a0a0a" google_fonts="font_family:Lato%3A100%2C100italic%2C300%2C300italic%2Cregular%2Citalic%2C700%2C700italic%2C900%2C900italic|font_style:900%20bold%20regular%3A900%3Anormal"][vc_column_text css=".vc_custom_1484761407248{margin-top: 60px !important;margin-bottom: 10px !important;}"]Raleway[/vc_column_text][vc_custom_heading text="A B C D E F G H I J K L M N O P Q R S T U V W X Y Z" font_container="tag:h3|font_size:30|text_align:left|color:%230a0a0a" google_fonts="font_family:Raleway%3A100%2C200%2C300%2Cregular%2C500%2C600%2C700%2C800%2C900|font_style:400%20regular%3A400%3Anormal"][vc_custom_heading text="a b c d e f g h i j k l m n o p q r s t u v w x y z" font_container="tag:h4|font_size:30|text_align:left|color:%230a0a0a" google_fonts="font_family:Raleway%3A100%2C200%2C300%2Cregular%2C500%2C600%2C700%2C800%2C900|font_style:400%20regular%3A400%3Anormal"][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/12" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Project Colors & Fonts Used', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['portfolio'];
$data['custom_class'] = 'portfolio';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/colors-used2.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_color="#f2f2f2" scene_position="center" text_color="dark" text_align="left" top_padding="10%" bottom_padding="10%" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/6" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="2/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner equal_height="yes" column_margin="none" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/6" column_border_width="none" column_border_style="solid"][vc_column_text]
<h5>Colors</h5>
[/vc_column_text][/vc_column_inner][vc_column_inner enable_animation="true" animation="reveal-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color="#603dff" background_color_opacity="1" font_color="#ffffff" width="5/12" column_border_width="none" column_border_style="solid" delay="100"][divider line_type="No Line" custom_height="150"][vc_column_text css=".vc_custom_1484860156218{padding-top: 25px !important;padding-right: 25px !important;padding-left: 25px !important;}"]
<h5>Revered Purple</h5>
[/vc_column_text][vc_column_text css=".vc_custom_1484677934273{padding-right: 25px !important;padding-bottom: 25px !important;padding-left: 25px !important;}"]#c62a41[/vc_column_text][/vc_column_inner][vc_column_inner enable_animation="true" animation="reveal-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color="#ff0000" background_color_opacity="1" font_color="#ffffff" width="5/12" column_border_width="none" column_border_style="solid"][divider line_type="No Line" custom_height="150"][vc_column_text css=".vc_custom_1484860096921{padding-top: 25px !important;padding-right: 25px !important;padding-left: 25px !important;}"]
<h5>Extra Red</h5>
[/vc_column_text][vc_column_text css=".vc_custom_1484761580916{padding-right: 25px !important;padding-bottom: 25px !important;padding-left: 25px !important;}"]#007eff[/vc_column_text][/vc_column_inner][/vc_row_inner][vc_row_inner equal_height="yes" column_margin="none" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/6" column_border_width="none" column_border_style="solid"][/vc_column_inner][vc_column_inner enable_animation="true" animation="reveal-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color="#232323" background_color_opacity="1" font_color="#ffffff" width="5/12" column_border_width="none" column_border_style="solid"][divider line_type="No Line" custom_height="150"][vc_column_text css=".vc_custom_1484761552756{padding-top: 25px !important;padding-right: 25px !important;padding-left: 25px !important;}"]
<h5>Night Sky</h5>
[/vc_column_text][vc_column_text css=".vc_custom_1484761569924{padding-right: 25px !important;padding-bottom: 25px !important;padding-left: 25px !important;}"]#333437[/vc_column_text][/vc_column_inner][vc_column_inner enable_animation="true" animation="reveal-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color="#ffffff" background_color_opacity="1" font_color="#000000" width="5/12" column_border_width="none" column_border_style="solid" delay="100"][divider line_type="No Line" custom_height="150"][vc_column_text css=".vc_custom_1484859490216{padding-top: 25px !important;padding-right: 25px !important;padding-left: 25px !important;}"]
<h5>Pure White</h5>
[/vc_column_text][vc_column_text css=".vc_custom_1484859473293{padding-right: 25px !important;padding-bottom: 25px !important;padding-left: 25px !important;}"]#ffffff[/vc_column_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" top_padding="100" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/6" column_border_width="none" column_border_style="solid"][vc_column_text]
<h5>Fonts</h5>
[/vc_column_text][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="5/6" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1484859891164{margin-bottom: 10px !important;}"]Ubuntu Bold[/vc_column_text][vc_custom_heading text="A B C D E F G H I J K L M N O P Q R S T U V W X Y Z" font_container="tag:h3|font_size:30|text_align:left|color:%230a0a0a" google_fonts="font_family:Ubuntu%3A300%2C300italic%2Cregular%2Citalic%2C500%2C500italic%2C700%2C700italic|font_style:700%20bold%20regular%3A700%3Anormal"][vc_custom_heading text="a b c d e f g h i j k l m n o p q r s t u v w x y z" font_container="tag:h4|font_size:30|text_align:left|color:%230a0a0a" google_fonts="font_family:Ubuntu%3A300%2C300italic%2Cregular%2Citalic%2C500%2C500italic%2C700%2C700italic|font_style:700%20bold%20regular%3A700%3Anormal"][vc_column_text css=".vc_custom_1484859970902{margin-top: 60px !important;margin-bottom: 10px !important;}"]Raleway[/vc_column_text][vc_custom_heading text="A B C D E F G H I J K L M N O P Q R S T U V W X Y Z" font_container="tag:h3|font_size:30|text_align:left|color:%230a0a0a" google_fonts="font_family:Raleway%3A100%2C200%2C300%2Cregular%2C500%2C600%2C700%2C800%2C900|font_style:400%20regular%3A400%3Anormal"][vc_custom_heading text="a b c d e f g h i j k l m n o p q r s t u v w x y z" font_container="tag:h4|font_size:30|text_align:left|color:%230a0a0a" google_fonts="font_family:Raleway%3A100%2C200%2C300%2Cregular%2C500%2C600%2C700%2C800%2C900|font_style:400%20regular%3A400%3Anormal"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/6" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Project Header', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['portfolio'] .', '. $cat_display_names['general'];
$data['custom_class'] = 'portfolio general  date-10-Aug-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/project-header.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" scene_position="center" text_color="dark" text_align="left" top_padding="10%" bottom_padding="10%" overlay_strength="0.3" shape_divider_position="bottom" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/6" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" offset="vc_col-xs-6"][vc_column_text css=".vc_custom_1484674945481{margin-bottom: 5px !important;}"]
<h5>Client</h5>
[/vc_column_text][fancy-ul icon_type="none" alignment="left"]Salient VR[/fancy-ul][vc_column_text css=".vc_custom_1484674769843{margin-top: 30px !important;margin-bottom: 5px !important;}"]
<h5>Year</h5>
[/vc_column_text][vc_column_text]2017[/vc_column_text][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/4" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" offset="vc_col-xs-6"][vc_column_text css=".vc_custom_1484674851189{margin-bottom: 5px !important;}"]
<h5>Awards &amp; Mentions</h5>
[/vc_column_text][fancy-ul icon_type="none" alignment="left"]
<ul>
 	<li>VR Inspire</li>
 	<li>Reality Awards</li>
 	<li>Best Promo</li>
</ul>
[/fancy-ul][vc_column_text css=".vc_custom_1484674634267{margin-top: 30px !important;margin-bottom: 5px !important;}"]
<h5>Deliverables</h5>
[/vc_column_text][fancy-ul icon_type="none" alignment="left"]
<ul>
 	<li>Advertisement</li>
 	<li>Photography</li>
 	<li>Strategy</li>
</ul>
[/fancy-ul][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="7/12" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" offset="vc_col-xs-12"][vc_column_text]
<h2>Somewhere, something incredible is waiting to be known.</h2>
[/vc_column_text][vc_column_text css=".vc_custom_1484675963264{margin-top: 50px !important;}"]I am text block. Click edit button to change this text. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut elit tellus, luctus nec ullamcorper mattis, pulvinar dapibus leo. I am text block. Click edit button to change this text. Lorem ipsum dolor sit amet.[/vc_column_text][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Project Header Dark Background', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['portfolio'];
$data['custom_class'] = 'portfolio date-05-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/project-header-4.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_color="#212121" scene_position="center" text_color="light" text_align="left" top_padding="10%" bottom_padding="10%" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/6" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" offset="vc_col-xs-6"][vc_column_text css=".vc_custom_1484674945481{margin-bottom: 5px !important;}"]
<h5>Client</h5>
[/vc_column_text][fancy-ul icon_type="none"]Salient VR[/fancy-ul][vc_column_text css=".vc_custom_1484674769843{margin-top: 30px !important;margin-bottom: 5px !important;}"]
<h5>Year</h5>
[/vc_column_text][vc_column_text]2017[/vc_column_text][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/4" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" offset="vc_col-xs-6"][vc_column_text css=".vc_custom_1484674851189{margin-bottom: 5px !important;}"]
<h5>Awards &amp; Mentions</h5>
[/vc_column_text][fancy-ul icon_type="none"]
<ul>
 	<li>VR Inspire</li>
 	<li>Reality Awards</li>
 	<li>Best Promo</li>
</ul>
[/fancy-ul][vc_column_text css=".vc_custom_1484674634267{margin-top: 30px !important;margin-bottom: 5px !important;}"]
<h5>Deliverables</h5>
[/vc_column_text][fancy-ul icon_type="none"]
<ul>
 	<li>Advertisement</li>
 	<li>Photography</li>
 	<li>Strategy</li>
</ul>
[/fancy-ul][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="7/12" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" offset="vc_col-xs-12"][vc_column_text]
<h2>Somewhere, something incredible is waiting to be known.</h2>
[/vc_column_text][vc_column_text css=".vc_custom_1484675963264{margin-top: 50px !important;}"]I am text block. Click edit button to change this text. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut elit tellus, luctus nec ullamcorper mattis, pulvinar dapibus leo. I am text block. Click edit button to change this text. Lorem ipsum dolor sit amet.[/vc_column_text][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Milestone With Icons Hero', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['icons'] .', '. $cat_display_names['hero_section'] .', '. $cat_display_names['counters'];
$data['custom_class'] = 'icons hero_section counters date-10-Sep-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/milestone-hero.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" equal_height="yes" content_placement="middle" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-adventure.webp" bg_position="left top" bg_repeat="no-repeat" bg_color="#1e1e1e" scene_position="center" text_color="light" text_align="left" top_padding="15%" bottom_padding="15%" color_overlay="#0a0a0a" overlay_strength="0.5"][vc_column column_padding="padding-5-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/4" column_border_width="none" column_border_style="solid"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/2" column_border_width="none" column_border_style="solid"][nectar_animated_title heading_tag="h5" style="hinge-drop" color="Accent-Color" text="Section No. 4"][split_line_heading animation_type="default"]
<h2>Far far away, behind</h2>
<h2>the word mountains</h2>
[/split_line_heading][vc_column_text]far from the countries Vokalia and Consonantia, there live the blind texts Separated they live in Bookmarksgrove right at the coast of the Semantics.[/vc_column_text][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/4" column_border_width="none" column_border_style="solid"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" top_padding="10%" text_align="left"][vc_column_inner column_padding="padding-4-percent" column_padding_position="top-bottom" centered_text="true" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color="Accent-Color" icon_padding="0px" icon_iconsmind="iconsmind-Duplicate-Window"][milestone heading_inherit="h2" symbol_position="after" subject_padding="2%" color="Default" effect="count" symbol_alignment="Superscript" number="125" subject="Salient Templates" number_font_size="92" symbol="+" symbol_font_size="44"][/vc_column_inner][vc_column_inner column_padding="padding-4-percent" column_padding_position="top-bottom" centered_text="true" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color="Accent-Color" icon_padding="0px" icon_iconsmind="iconsmind-Add-User"][milestone heading_inherit="h2" symbol_position="after" subject_padding="2%" color="Default" effect="count" symbol_alignment="Default" number="55" subject="Theme Users" number_font_size="92" symbol="k" symbol_font_size="92"][/vc_column_inner][vc_column_inner column_padding="padding-4-percent" column_padding_position="top-bottom" centered_text="true" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color="Accent-Color" icon_padding="0px" icon_iconsmind="iconsmind-Trophy"][milestone heading_inherit="h2" subject_padding="2%" color="Default" effect="count" number="4000" subject="Five star ratings" number_font_size="92"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Minimal Header With CTA', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'].', '. $cat_display_names['cta'];
$data['custom_class'] = 'general cta';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/minimal-header.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" scene_position="center" text_color="dark" text_align="left" top_padding="120" bottom_padding="80" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_column_text max_width="700" css=".vc_custom_1482355453219{margin-bottom: 30px !important;}"]
<h2><span style="color: #000000;">Hello, I'm Phil. I am a digital designer from Philly focusing on UI design.</span></h2>
[/vc_column_text][nectar_cta heading_tag="h4" link_type="new_tab" alignment="left" text="Wanna get in touch?" link_text="Let's talk" url="#"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Parallax Video Lightbox Row Dark', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'] .', '. $cat_display_names['hero_section'];
$data['custom_class'] = 'general hero_section date-19-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/parallax-video-lightbox.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-adventure.webp" bg_position="left top" bg_repeat="no-repeat" parallax_bg="true" parallax_bg_speed="fast" bg_color="#333333" scene_position="center" text_color="light" text_align="left" top_padding="15%" bottom_padding="15%" color_overlay="#0a0a0a" overlay_strength="0.8"][vc_column centered_text="true" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1484862427754{margin-bottom: 5px !important;}"]
<h5>Look Inside</h5>
[/vc_column_text][vc_column_text css=".vc_custom_1484862386675{margin-bottom: 35px !important;}"]
<h2>Discover Salient VR</h2>
[/vc_column_text][nectar_video_lightbox link_style="play_button" video_url="https://www.youtube.com/watch?v=6oTurM7gESE"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Project Header Alternative', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['portfolio'];
$data['custom_class'] = 'portfolio general';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/project-header-2.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" scene_position="center" text_color="dark" text_align="left" top_padding="8%" bottom_padding="8%" overlay_strength="1"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/6" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="2/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" bottom_padding="80" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/6" column_border_width="none" column_border_style="solid"][vc_custom_heading text="Intro" font_container="tag:h5|text_align:left|color:%23603dff" use_theme_fonts="yes"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="5/6" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1484856757740{margin-bottom: 30px !important;}"]
<h3>Imagination will often carry us to worlds that never were. But without it we go nowhere.</h3>
[/vc_column_text][vc_column_text]Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean. A small river named Duden flows by their place.[/vc_column_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" bottom_padding="40" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/6" column_border_width="none" column_border_style="solid"][vc_custom_heading text="Services" font_container="tag:h5|text_align:left|color:%23603dff" use_theme_fonts="yes"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="5/6" column_border_width="none" column_border_style="solid"][vc_column_text]Web design, Graphic design, Photography[/vc_column_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/6" column_border_width="none" column_border_style="solid"][vc_custom_heading text="Clients" font_container="tag:h5|text_align:left|color:%23603dff" use_theme_fonts="yes"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="5/6" column_border_width="none" column_border_style="solid"][vc_column_text]ThemeNectar[/vc_column_text][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/6" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Google Map Flat', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['google_map'];
$data['custom_class'] = 'map';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/ultra-flat-map-2.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" scene_position="center" text_color="dark" text_align="left" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][nectar_gmap zoom="14" enable_zoom="1" marker_style="nectar" nectar_marker_color="accent-color" map_greyscale="1" ultra_flat="1" size="700" map_center_lat="40.793" map_center_lng="-73.954" map_markers="39.949|-75.171|Our Location
40.793|-73.954|Our Location #2"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Four Visible, Touch Enabled Gallery', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['portfolio'] .', '. $cat_display_names['general'];
$data['custom_class'] = 'portfolio gallery general date-05-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/image-gallery-phones.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_color="#ffffff" scene_position="center" text_color="dark" text_align="left" top_padding="10%" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][nectar_gradient_text heading_tag="h2" color="extra-color-gradient-1" gradient_direction="horizontal" text="What We Delivered"][vc_column_text max_width="600"]Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean. A small river named Duden flows by their place and supplies[/vc_column_text][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][/vc_row][vc_row type="full_width_content" full_screen_row_position="middle" bg_color="#ffffff" scene_position="center" text_color="dark" text_align="left" bottom_padding="6%" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_gallery type="flickity_style" images="" flickity_controls="material_pagination" flickity_desktop_columns="4" flickity_small_desktop_columns="3" flickity_tablet_columns="2" flickity_box_shadow="none" onclick="link_no" img_size="full"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Three Visible, Touch Enabled Gallery Dark', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['portfolio'];
$data['custom_class'] = 'portfolio gallery';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/touch-enabled-3.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" bg_color="#181a1c" scene_position="center" text_color="light" text_align="left" top_padding="6%" bottom_padding="6%" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_gallery type="flickity_style" images="" flickity_controls="material_pagination" flickity_desktop_columns="3" flickity_small_desktop_columns="3" flickity_tablet_columns="1" flickity_box_shadow="x_large_depth" onclick="link_no" img_size="full"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Nifty Hero With Bottom Columns & Gradient Overlay', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['hero_section'] .', '. $cat_display_names['about'];
$data['custom_class'] = 'hero_section about';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/hero-bottom-cols.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#383838" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-adventure.webp" bg_position="center center" background_image_loading="default" bg_repeat="no-repeat" scene_position="center" top_padding="4%" bottom_padding="4%" text_color="light" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" enable_gradient="true" color_overlay="#191919" color_overlay_2="#6b6b6b" overlay_strength="0.8" gradient_direction="left_b_to_right_t" shape_divider_position="bottom" bg_image_animation="none"][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" top_padding="15%" bottom_padding="14%" right_padding_desktop="40%" right_padding_tablet="0" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][split_line_heading animation_type="line-reveal-by-space" font_style="h1" line_reveal_by_space_text_effect="default" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="We Are Salient, A Creative Agency Based in Philly"][/split_line_heading][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="padding-3-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="top-bottom" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color_type="color_scheme" icon_color="white" icon_padding="0px" pointer_events="all" icon_iconsmind="iconsmind-Umbrella-2" icon_size="36" margin_bottom="5"][vc_column_text css_animation="fadeInUp" css=".vc_custom_1485465877383{margin-bottom: 15px !important;}"]
<h4>There For You</h4>
[/vc_column_text][vc_custom_heading text="Far far away, behind the word mountains, far from the countries Vokalia texts." font_container="tag:p|text_align:left|color:rgba(255%2C255%2C255%2C0.65)" use_theme_fonts="yes" css_animation="fadeInUp" css=".vc_custom_1485466909711{padding-right: 20% !important;}"][/vc_column_inner][vc_column_inner column_padding="padding-3-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="top-bottom" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color_type="color_scheme" icon_color="white" icon_padding="0px" pointer_events="all" icon_iconsmind="iconsmind-Diamond" icon_size="36" margin_bottom="5px"][vc_column_text css_animation="fadeInUp" css=".vc_custom_1485363986301{margin-bottom: 15px !important;}"]
<h4>Pristine Quality</h4>
[/vc_column_text][vc_custom_heading text="Far far away, behind the word mountains, far from the countries Vokalia texts." font_container="tag:p|text_align:left|color:rgba(255%2C255%2C255%2C0.65)" use_theme_fonts="yes" css_animation="fadeInUp" css=".vc_custom_1485466916092{padding-right: 20% !important;}"][/vc_column_inner][vc_column_inner column_padding="padding-3-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="top-bottom" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color_type="color_scheme" icon_color="white" icon_padding="0px" pointer_events="all" icon_iconsmind="iconsmind-Favorite-Window" icon_size="36" margin_bottom="5px"][vc_column_text css_animation="fadeInUp" css=".vc_custom_1485363991162{margin-bottom: 15px !important;}"]
<h4>Heavily Awarded</h4>
[/vc_column_text][vc_custom_heading text="Far far away, behind the word mountains, far from the countries Vokalia texts." font_container="tag:p|text_align:left|color:rgba(255%2C255%2C255%2C0.65)" use_theme_fonts="yes" css_animation="fadeInUp" css=".vc_custom_1485466921027{padding-right: 20% !important;}"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Fresh Background Hero Full Height Section', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['hero_section'];
$data['custom_class'] = 'hero_section date-02-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/purple_hero.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-art.webp" bg_position="center center" bg_repeat="no-repeat" full_height="yes" scene_position="center" text_color="light" text_align="left" enable_gradient="true" color_overlay="#1d89f9" color_overlay_2="#0a56d1" gradient_direction="top_to_bottom" overlay_strength="0.8"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/4" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][vc_column centered_text="true" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid"][vc_custom_heading text="Are you ready?" font_container="tag:h4|font_size:20|text_align:center|color:%23ffffff|line_height:26px" google_fonts="font_family:Playfair%20Display%3Aregular%2Citalic%2C700%2C700italic%2C900%2C900italic|font_style:400%20regular%3A400%3Anormal" css_animation="none" css=".vc_custom_1485614491282{margin-bottom: -10px !important;}"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid" delay="100"][vc_custom_heading text="This is Salient" font_container="tag:h4|font_size:94|text_align:center|color:%23ffffff|line_height:114px" google_fonts="font_family:Roboto%3A100%2C100italic%2C300%2C300italic%2Cregular%2Citalic%2C500%2C500italic%2C700%2C700italic%2C900%2C900italic|font_style:700%20bold%20regular%3A700%3Anormal" css_animation="none" css=".vc_custom_1485614497918{margin-bottom: -10px !important;}"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid" delay="200"][vc_custom_heading text="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast." font_container="tag:p|font_size:18|text_align:center|color:rgba(255%2C255%2C255%2C0.74)|line_height:28px" google_fonts="font_family:Roboto%3A100%2C100italic%2C300%2C300italic%2Cregular%2Citalic%2C500%2C500italic%2C700%2C700italic%2C900%2C900italic|font_style:400%20regular%3A400%3Anormal" css_animation="none" css=".vc_custom_1485614418364{padding-right: 5% !important;padding-left: 5% !important;}"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="grow-in" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid" delay="300"][nectar_btn size="large" button_style="see-through-2" color_override="#ffffff" hover_color_override="#ffffff" hover_text_color_override="#000000" icon_family="iconsmind" url="#" text="Learn More" icon_iconsmind="iconsmind-Triangle-ArrowRight" margin_top="30"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/4" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );

$data = array();
$data['name'] = esc_html__( 'Simple Google Map', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['google_map'];
$data['custom_class'] = 'map';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/google-map.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" scene_position="center" text_color="dark" text_align="left" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][nectar_gmap zoom="15" enable_zoom="1" marker_style="nectar" nectar_marker_color="accent-color" map_greyscale="1" size="700" map_center_lat="40.793" map_center_lng="-73.954" map_markers="39.949|-75.171|Our Location
40.793|-73.954|Our Location #2"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Milestones', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['counters'] .', '. $cat_display_names['general'];
$data['custom_class'] = 'counters general';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/project-stats.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" scene_position="center" text_color="dark" text_align="left" top_padding="10%" bottom_padding="10%" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/12" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][vc_column centered_text="true" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="5/6" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_column_text]
<h2>Project Stats</h2>
[/vc_column_text][divider line_type="Small Line" line_thickness="4" divider_color="accent-color" animate="yes" custom_height="100" custom_line_width="100"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="padding-4-percent" column_padding_position="all" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid"][milestone heading_inherit="h2" symbol_position="after" subject_padding="2%" color="Accent-Color" effect="count" symbol_alignment="Superscript" number="186" symbol="%" subject="Percent increase in overall concert head count" number_font_size="92" symbol_font_size="40"][/vc_column_inner][vc_column_inner column_padding="padding-4-percent" column_padding_position="all" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid"][milestone heading_inherit="h2" subject_padding="2%" color="Accent-Color" effect="count" number="347" subject="Merchandise items sold during the main concert" number_font_size="92"][/vc_column_inner][vc_column_inner column_padding="padding-4-percent" column_padding_position="all" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid"][milestone heading_inherit="h2" subject_padding="2%" color="Accent-Color" effect="count" number="239" subject="Raving reviews written after the show ended" number_font_size="92"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/12" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Flat Dark Scheme Map', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['google_map'];
$data['custom_class'] = 'map';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/ultra-flat-map.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" scene_position="center" text_color="dark" text_align="left" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][nectar_gmap zoom="6" enable_zoom="1" marker_style="nectar" nectar_marker_color="accent-color" map_greyscale="1" ultra_flat="1" dark_color_scheme="1" size="700" map_center_lat="39.949" map_center_lng="-75.176" map_markers="39.949|-75.171|
"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );

$data = array();
$data['name'] = esc_html__( 'Map Section Dark Scheme', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['google_map'];
$data['custom_class'] = 'map';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/dark-map.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" scene_position="center" text_color="dark" text_align="left" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][nectar_gmap zoom="16" marker_style="nectar" nectar_marker_color="accent-color" map_greyscale="1" dark_color_scheme="1" size="700" map_center_lat="39.949" map_center_lng="-75.176" map_markers="39.949|-75.171|
"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Gradient Icons Dark Background', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['icons'] .', '. $cat_display_names['services'] .', '. $cat_display_names['about'];
$data['custom_class'] = 'icons services about date-12-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/gradient-icons.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_color="#161616" scene_position="center" text_color="light" text_align="left" top_padding="10%" bottom_padding="10%" overlay_strength="0.5"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid"][vc_custom_heading text="Beauty Like You've Never Seen" font_container="tag:h2|font_size:48px|text_align:center|line_height:57px" use_theme_fonts="yes" css_animation="none"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" top_padding="20" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-3-percent" column_padding_position="all" centered_text="true" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid"][nectar_icon icon_family="iconsmind" icon_style="border-animation" icon_border_thickness="2px" icon_color="extra-color-gradient-1" icon_padding="25px" icon_iconsmind="iconsmind-Umbrella-2" url="#"][vc_column_text css_animation="fadeInUp" css=".vc_custom_1485363965531{margin-bottom: 15px !important;}"]
<h4>There For You</h4>
[/vc_column_text][vc_custom_heading text="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts" font_container="tag:p|text_align:center|color:rgba(255%2C255%2C255%2C0.65)" use_theme_fonts="yes" css_animation="fadeInUp"][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-3-percent" column_padding_position="all" centered_text="true" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid"][nectar_icon icon_family="iconsmind" icon_style="border-animation" icon_border_thickness="2px" icon_color="extra-color-gradient-1" icon_padding="25px" icon_iconsmind="iconsmind-Diamond" url="#"][vc_column_text css_animation="fadeInUp" css=".vc_custom_1485363986301{margin-bottom: 15px !important;}"]
<h4>Pristine Quality</h4>
[/vc_column_text][vc_custom_heading text="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts" font_container="tag:p|text_align:center|color:rgba(255%2C255%2C255%2C0.65)" use_theme_fonts="yes" css_animation="fadeInUp"][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-3-percent" column_padding_position="all" centered_text="true" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid"][nectar_icon icon_family="iconsmind" icon_style="border-animation" icon_border_thickness="2px" icon_color="extra-color-gradient-1" icon_padding="25px" icon_iconsmind="iconsmind-Trophy-2" url="#"][vc_column_text css_animation="fadeInUp" css=".vc_custom_1485363991162{margin-bottom: 15px !important;}"]
<h4>Heavily Awarded</h4>
[/vc_column_text][vc_custom_heading text="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts" font_container="tag:p|text_align:center|color:rgba(255%2C255%2C255%2C0.65)" use_theme_fonts="yes" css_animation="fadeInUp"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" top_padding="20" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-3-percent" column_padding_position="all" centered_text="true" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid"][nectar_icon icon_family="iconsmind" icon_style="border-animation" icon_border_thickness="2px" icon_color="extra-color-gradient-1" icon_padding="25px" icon_iconsmind="iconsmind-T-Shirt" url="#"][vc_column_text css_animation="fadeInUp" css=".vc_custom_1485368415399{margin-bottom: 15px !important;}"]
<h4>eCommerce Ready</h4>
[/vc_column_text][vc_custom_heading text="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts" font_container="tag:p|text_align:center|color:rgba(255%2C255%2C255%2C0.65)" use_theme_fonts="yes" css_animation="fadeInUp"][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-3-percent" column_padding_position="all" centered_text="true" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid"][nectar_icon icon_family="iconsmind" icon_style="border-animation" icon_border_thickness="2px" icon_color="extra-color-gradient-1" icon_padding="25px" icon_iconsmind="iconsmind-Wolf" url="#"][vc_column_text css_animation="fadeInUp" css=".vc_custom_1485368428679{margin-bottom: 15px !important;}"]
<h4>Ready For All</h4>
[/vc_column_text][vc_custom_heading text="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts" font_container="tag:p|text_align:center|color:rgba(255%2C255%2C255%2C0.65)" use_theme_fonts="yes" css_animation="fadeInUp"][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-3-percent" column_padding_position="all" centered_text="true" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid"][nectar_icon icon_family="iconsmind" icon_style="border-animation" icon_border_thickness="2px" icon_color="extra-color-gradient-1" icon_padding="25px" icon_iconsmind="iconsmind-Grave" url="#"][vc_column_text css_animation="fadeInUp" css=".vc_custom_1485368441656{margin-bottom: 15px !important;}"]
<h4>Eliminate Competition</h4>
[/vc_column_text][vc_custom_heading text="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts" font_container="tag:p|text_align:center|color:rgba(255%2C255%2C255%2C0.65)" use_theme_fonts="yes" css_animation="fadeInUp"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Team Member Carousel (Classic Style)', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['team'];
$data['custom_class'] = 'team';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/team-member-carousel.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" scene_position="center" text_color="dark" text_align="left" top_padding="7%" bottom_padding="7%" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][carousel script="owl_carousel" desktop_cols="3" desktop_small_cols="3" tablet_cols="2" mobile_cols="1" column_padding="20px" autorotate="true" enable_animation="true" autorotation_speed="6000"][item id="1485280429528-2f311-50d3" title="Item" tab_id="1485798432237-4"][team_member team_memeber_style="meta_below" link_element="none" color="Accent-Color" name="Aura Brooks" image_url="https://themenectar.com/img/demo-media/unsplash/webp/team-member-1-small-cropped.webp" job_position="Graphic Designer" description="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. A small river named Duden flows." social="Facebook,http://facebook.com, Twitter,http://twitter.com, Youtube,http://youtube.com"][/item][item id="1485280429578-0f311-50d3" title="Item" tab_id="1485798432247-5"][team_member image_url="https://themenectar.com/img/demo-media/unsplash/webp/team-member-2-small-cropped.webp" team_memeber_style="meta_below" link_element="none" color="Accent-Color" name="Eve Crawford" job_position="Product Designer" description="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. A small river named Duden flows." social="Facebook,http://facebook.com, Twitter,http://twitter.com, Youtube,http://youtube.com"][/item][item id="1485280429578-0f311-50d3" title="Item" tab_id="1485798432271-6"][team_member image_url="https://themenectar.com/img/demo-media/unsplash/webp/team-member-3-small-cropped.webp" team_memeber_style="meta_below" link_element="none" color="Accent-Color" name="Alex Parker" job_position="Founder" description="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. A small river named Duden flows." social="Facebook,http://facebook.com, Twitter,http://twitter.com, Youtube,http://youtube.com"][/item][item id="1485280429578-0f311-50d3" title="Item" tab_id="1485798432293-8"][team_member image_url="https://themenectar.com/img/demo-media/unsplash/webp/team-member-4-small-cropped.webp" team_memeber_style="meta_below" link_element="none" color="Accent-Color" name="Jessica Collins" job_position="Graphic Designer" description="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. A small river named Duden flows." social="Facebook,http://facebook.com, Twitter,http://twitter.com, Youtube,http://youtube.com"][/item][item id="1485280429578-0f311-50d3" title="Item" tab_id="1485798432305-6"][team_member team_memeber_style="meta_below" image_url="https://themenectar.com/img/demo-media/unsplash/webp/team-member-5-small-cropped.webp" link_element="none" color="Accent-Color" name="Luke Smith" job_position="Web Developer" description="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. A small river named Duden flows." social="Facebook,http://facebook.com, Twitter,http://twitter.com, Youtube,http://youtube.com"][/item][/carousel][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Two Info Boxes', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['about'] .', '. $cat_display_names['services'];
$data['custom_class'] = 'about services';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/two-color-boxes.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" equal_height="yes" content_placement="middle" bg_color="#d0d7dd" scene_position="center" text_color="light" text_align="left" top_padding="8%" bottom_padding="8%" overlay_strength="0.3"][vc_column enable_animation="true" animation="flip-in-vertical" column_padding="padding-6-percent" column_padding_position="all" background_color="#ff3a6f" background_color_opacity="1" background_hover_color_opacity="1" font_color="#ffffff" column_shadow="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1485280135262{margin-bottom: 10px !important;}"]
<h5>Reason One</h5>
[/vc_column_text][vc_custom_heading text="Salient can elevate your business to new heights" font_container="tag:h2|font_size:44|text_align:left|color:%23ffffff|line_height:50px" use_theme_fonts="yes"][vc_column_text css=".vc_custom_1485279924521{margin-top: 30px !important;margin-bottom: 30px !important;}"]I am text block. Click edit button to change this text. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut elit tellus, luctus nec ullamcorper mattis, pulvinar dapibus leo.[/vc_column_text][nectar_cta heading_tag="h5" text_color="#ffffff" link_type="regular" alignment="left" link_text="Learn More"][/vc_column][vc_column enable_animation="true" animation="flip-in-vertical" column_padding="padding-6-percent" column_padding_position="all" background_color="#ffffff" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="x_large_depth" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" delay="200"][vc_column_text css=".vc_custom_1485280173184{margin-bottom: 10px !important;}"]
<h5><span style="color: #ff3a6f;">Reason Two</span></h5>
[/vc_column_text][vc_custom_heading text="The ultimate WordPress theme" font_container="tag:h2|font_size:44|text_align:left|color:%23ff3a6f|line_height:50px" use_theme_fonts="yes"][vc_column_text css=".vc_custom_1485279928611{margin-top: 30px !important;margin-bottom: 30px !important;}"]<span style="color: #ff3a6f;">I am text block. Click edit button to change this text. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut elit tellus, luctus nec ullamcorper mattis, pulvinar dapibus leo.</span>[/vc_column_text][nectar_cta heading_tag="h5" text_color="#ff3a6f" link_type="regular" alignment="left" link_text="Learn More"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Misty Background Info Boxes', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'] .', '. $cat_display_names['services'];
$data['custom_class'] = 'general services';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/two-color-boxes-2.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" equal_height="yes" content_placement="middle" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-art.webp" bg_position="left top" bg_repeat="no-repeat" bg_color="#0a0909" scene_position="center" text_color="light" text_align="left" top_padding="10%" bottom_padding="10%" color_overlay="#262e38" overlay_strength="0.95"][vc_column enable_animation="true" animation="flip-in-vertical" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" delay="200"][nectar_video_lightbox link_style="play_button_2" nectar_play_button_color="Default-Accent-Color" image_url="https://themenectar.com/img/demo-media/unsplash/webp/800-500-fashion.webp" hover_effect="defaut" box_shadow="none" video_url="https://www.youtube.com/watch?v=6oTurM7gESE"][/vc_column][vc_column enable_animation="true" animation="flip-in-vertical" column_padding="padding-6-percent" column_padding_position="all" background_color="#3454ff" background_color_opacity="1" background_hover_color_opacity="1" font_color="#ffffff" column_shadow="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_custom_heading text="Salient can elevate your business to new heights. Separated they live in Bookmarksgrove right at the coast of the Semantic." font_container="tag:h2|font_size:26|text_align:left|color:%23ffffff|line_height:36px" google_fonts="font_family:Roboto%3A100%2C100italic%2C300%2C300italic%2Cregular%2Citalic%2C500%2C500italic%2C700%2C700italic%2C900%2C900italic|font_style:400%20regular%3A400%3Anormal"][divider line_type="No Line" custom_height="20"][nectar_cta heading_tag="h5" text_color="#ffffff" link_type="regular" alignment="left" link_text="Learn More"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Side Area With Toggle Panels', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'] .', '. $cat_display_names['services'];
$data['custom_class'] = 'general services';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/toggles.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" scene_position="center" text_color="dark" text_align="left" top_padding="7%" bottom_padding="7%" overlay_strength="0.3"][vc_column column_padding="padding-2-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="2/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][toggles style="minimal" accordion="true"][toggle color="Default" title="What exactly is Salient App? "][vc_column_text]Lorem ipsum dolor sit amet, consectetur adipiscing elit. In eget bibendum libero. Etiam id velit at enim porttitor facilisis. Vivamus tincidunt lectus at risus pharetra ultrices. In tincidunt turpis at odio dapibus maximus. Lorem ipsum dolor sit amet, consectetur adipiscing elit. In eget bibendum libero. Etiam id velit at enim porttitor facilisis. Vivamus tincidunt lectus at risus pharetra ultrices. In tincidunt turpis at odio dapibus maximus.[/vc_column_text][/toggle][toggle color="Default" title="How do I create my own Salient App account?"][vc_column_text]Lorem ipsum dolor sit amet, consectetur adipiscing elit. In eget bibendum libero. Etiam id velit at enim porttitor facilisis. Vivamus tincidunt lectus at risus pharetra ultrices. In tincidunt turpis at odio dapibus maximus.[/vc_column_text][/toggle][toggle color="Default" title="Do I need to link my bank account in order to use it?"][vc_column_text]Lorem ipsum dolor sit amet, consectetur adipiscing elit. In eget bibendum libero. Etiam id velit at enim porttitor facilisis. Vivamus tincidunt lectus at risus pharetra ultrices. In tincidunt turpis at odio dapibus maximus.[/vc_column_text][/toggle][toggle color="Default" title="Will Salient Service work on my mobile device?"][vc_column_text]Lorem ipsum dolor sit amet, consectetur adipiscing elit. In eget bibendum libero. Etiam id velit at enim porttitor facilisis. Vivamus tincidunt lectus at risus pharetra ultrices. In tincidunt turpis at odio dapibus maximus.[/vc_column_text][/toggle][toggle color="Default" title="Is it available in my country?"][vc_column_text]Lorem ipsum dolor sit amet, consectetur adipiscing elit. In eget bibendum libero. Etiam id velit at enim porttitor facilisis. Vivamus tincidunt lectus at risus pharetra ultrices. In tincidunt turpis at odio dapibus maximus.[/vc_column_text][/toggle][/toggles][/vc_column][vc_column column_padding="padding-2-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_custom_heading text="Quality Design" font_container="tag:h5|font_size:16|text_align:left|color:%230a0a0a" google_fonts="font_family:Roboto%3A100%2C100italic%2C300%2C300italic%2Cregular%2Citalic%2C500%2C500italic%2C700%2C700italic%2C900%2C900italic|font_style:700%20bold%20regular%3A700%3Anormal"][vc_column_text css=".vc_custom_1485277620875{margin-bottom: 40px !important;}"]I am text block. Click edit button to change this text. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut elit tellus, luctus nec ullamcorper mattis, pulvinar dapibus leo.[/vc_column_text][vc_custom_heading text="High Performance " font_container="tag:h5|font_size:16|text_align:left|color:%230a0a0a" google_fonts="font_family:Roboto%3A100%2C100italic%2C300%2C300italic%2Cregular%2Citalic%2C500%2C500italic%2C700%2C700italic%2C900%2C900italic|font_style:700%20bold%20regular%3A700%3Anormal"][vc_column_text css=".vc_custom_1485277635320{margin-bottom: 40px !important;}"]I am text block. Click edit button to change this text. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut elit tellus, luctus nec ullamcorper mattis, pulvinar dapibus leo.[/vc_column_text][nectar_btn size="large" button_style="see-through-3d" color_override="#006afe" url="#" text="Learn More"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Full Height Split Section', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'] .', '. $cat_display_names['about'];
$data['custom_class'] = 'general about date-29-Aug-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/full-height.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" equal_height="yes" content_placement="middle" full_height="yes" columns_placement="stretch" scene_position="center" text_color="dark" text_align="left" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/webp/large-art.webp" column_shadow="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][divider line_type="No Line" custom_height="500"][/vc_column][vc_column column_padding="padding-8-percent" column_padding_position="all" background_color="#ffffff" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][nectar_animated_title heading_tag="h5" style="color-strip-reveal" color="Accent-Color" text="Not even lying"][vc_custom_heading text="The best WordPress theme that ever existed" font_container="tag:h2|font_size:42|text_align:left|line_height:52px" use_theme_fonts="yes"][vc_column_text css=".vc_custom_1485279202957{margin-top: 30px !important;margin-bottom: 30px !important;}"]I am text block. Click edit button to change this text. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut elit tellus, luctus nec ullamcorper mattis, pulvinar dapibus leo. I am text block. Click edit button to change this text. Lorem ipsum dolor sit amet, consectetur adipiscing elit.[/vc_column_text][vc_column_text css=".vc_custom_1485279159583{margin-bottom: 30px !important;}"]I am text block. Click edit button to change this text. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut elit tellus, luctus nec ullamcorper mattis, pulvinar dapibus leo. I am text block.[/vc_column_text][nectar_cta heading_tag="h5" text_color="#2f4eff" link_type="regular" alignment="left" link_text="Learn More" url="#"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Brilliant Animated Hero Section', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['hero_section'] .', '. $cat_display_names['about'];
$data['custom_class'] = 'hero_section about date-10-Sep-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/hero-video-2.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#333333" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-art.webp" bg_position="left top" background_image_loading="default" bg_repeat="no-repeat" scene_position="center" top_padding="15%" bottom_padding="15%" text_color="light" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" color_overlay="#0a0a0a" overlay_strength="0.8" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" parallax_bg="true" parallax_bg_speed="fast"][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" centered_text="true" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/6" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][/vc_column][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" centered_text="true" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="2/3" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="grow-in" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][nectar_video_lightbox link_style="play_button" video_url="https://www.youtube.com/watch?v=6oTurM7gESE"][/vc_column_inner][/vc_row_inner][split_line_heading animation_type="line-reveal-by-space" font_style="h1" line_reveal_by_space_text_effect="default" content_alignment="default" mobile_content_alignment="inherit" link_target="_self" text_content="The Ultimate WordPress Theme"][/split_line_heading][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" delay="300"][vc_custom_heading text="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts The Big Oxmox advised her." font_container="tag:h5|font_size:20|text_align:center|color:rgba(255%2C255%2C255%2C0.7)|line_height:36px" google_fonts="font_family:Roboto%3A100%2C100italic%2C300%2C300italic%2Cregular%2Citalic%2C500%2C500italic%2C700%2C700italic%2C900%2C900italic|font_style:300%20light%20regular%3A300%3Anormal" css=".vc_custom_1485461515255{padding-right: 10% !important;padding-left: 10% !important;}"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" delay="450"][nectar_btn size="large" button_style="see-through" button_color_2="Accent-Color" icon_family="iconsmind" url="#" text="Learn About Us" margin_top="10" margin_right="10" margin_bottom="10" margin_left="10" icon_iconsmind="iconsmind-Triangle-ArrowRight"][nectar_btn size="large" button_style="regular" button_color_2="Accent-Color" color_override="#ff3269" icon_family="iconsmind" url="#" text="View Our Work" margin_top="10" margin_right="10" margin_bottom="10" margin_left="10" icon_iconsmind="iconsmind-Triangle-ArrowRight"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/6" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Icon List', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['icons'] .', '. $cat_display_names['services'];
$data['custom_class'] = 'icons services';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/icon-list.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" equal_height="yes" content_placement="middle" bg_color="#ffffff" scene_position="center" text_color="dark" text_align="left" top_padding="5%" bottom_padding="5%" id="steps" row_name="Sign Up Steps" overlay_strength="0.3"][vc_column column_padding="padding-5-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/12" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][vc_column column_padding="padding-3-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="5/12" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" offset="vc_col-xs-12"][image_with_animation image_url="http://54cb3baa74d4d851e8b7-2e7f88565dceb0a8192c6645d1f8b1b4.r12.cf2.rackcdn.com/phone-normal.jpg" alignment="" animation="Fade In From Left" box_shadow="none" max_width="100%"][/vc_column][vc_column column_padding="padding-3-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="5/12" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" offset="vc_col-xs-12"][nectar_icon_list animate="true" color="default" icon_size="small" icon_style="border"][nectar_icon_list_item icon_type="numerical" title="List Item" id="1485276126956-360e1-d94e" header="Sign Up For Free" text="Create your free account in a matter of minutes with our patented awesome sign up process." tab_id="1485457205085-0"] [/nectar_icon_list_item][nectar_icon_list_item icon_type="numerical" title="List Item" id="1485276126966-560e1-d94e" header="Sell Goods Online" text="Next start integrating it with your e-commerce platform of choice and start accepting payments." tab_id="1485457205092-10"] [/nectar_icon_list_item][nectar_icon_list_item icon_type="numerical" title="List Item" id="1485276126979-860e1-d94e" header="Love Your Life" text="Sit back, relax and pop a cold one because your life just got a whole lot easier by using Salient." tab_id="1485457205111-2"][/nectar_icon_list_item][/nectar_icon_list][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/12" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Professional Info & Icon List ', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['icons'] .', '. $cat_display_names['services'] .', '. $cat_display_names['general'];
$data['custom_class'] = 'icons services general date-10-Aug-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/icons-right.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" equal_height="yes" content_placement="middle" bg_color="#1a1d21" scene_position="center" text_color="light" text_align="left" overlay_strength="0.3"][vc_column centered_text="true" column_padding="padding-10-percent" column_padding_position="all" background_color="#0054ff" background_color_opacity="0.9" background_hover_color_opacity="1" background_image="" enable_bg_scale="true" font_color="#ffffff" column_shadow="none" width="2/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_custom_heading text="How's This Look?" font_container="tag:h5|text_align:center|color:%23ffffff" use_theme_fonts="yes"][vc_custom_heading text="Beauty And Power Meet In Salient" font_container="tag:h2|text_align:center|color:%23ffffff" use_theme_fonts="yes"][divider line_type="No Line" custom_height="20"][vc_custom_heading text="I am text block. Click edit button to change this text. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut elit tellus, luctus nec ullamcorper mattis, pulvinar dapibus leo." font_container="tag:p|text_align:center|color:rgba(255%2C255%2C255%2C0.69)" use_theme_fonts="yes" css=".vc_custom_1485459419272{padding-right: 15% !important;padding-left: 15% !important;}"][/vc_column][vc_column centered_text="true" column_padding="padding-6-percent" column_padding_position="all" background_color="#1a1d21" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][nectar_icon icon_family="iconsmind" icon_style="border-animation" icon_border_thickness="2px" icon_color="Accent-Color" icon_padding="15px" icon_iconsmind="iconsmind-Thunder" url="#" margin_bottom="10"][divider line_type="No Line" custom_height="10"][vc_column_text max_width="315"]
<h4>Thousands Of Icons</h4>
[/vc_column_text][divider line_type="No Line" custom_height="5"][vc_column_text max_width="350"]<span style="color: #aaa;">Salient comes packed with amazing icon families for you to choose from. Practically anything you could imagine exists.</span>[/vc_column_text][divider line_type="No Line" custom_height="50"][nectar_icon icon_family="iconsmind" icon_style="border-animation" icon_border_thickness="2px" icon_color="Accent-Color" icon_padding="25px" icon_iconsmind="iconsmind-Wolf" margin_bottom="15" icon_size="40" url="#"][divider line_type="No Line" custom_height="10"][vc_column_text max_width="315"]
<h4>Beautiful Design</h4>
[/vc_column_text][divider line_type="No Line" custom_height="5"][vc_column_text max_width="350"]<span style="color: #aaa;">Quality over quantity. Enjoy a vast array of carefully designed &amp; unique elements with tons of control over fine tuning them.</span>[/vc_column_text][divider line_type="No Line" custom_height="50"][nectar_icon icon_family="iconsmind" icon_style="border-animation" icon_border_thickness="2px" icon_color="Accent-Color" icon_padding="25px" icon_iconsmind="iconsmind-Microscope" margin_bottom="15" icon_size="40" url="#"][divider line_type="No Line" custom_height="10"][vc_column_text max_width="315"]
<h4>Extensive Documentation</h4>
[/vc_column_text][divider line_type="No Line" custom_height="5"][vc_column_text max_width="350"]<span style="color: #aaa;"> Never feel lost again. Documentation is available in addition to a series of video tutorials exclusively for Salient.</span>[/vc_column_text][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Mighty Split - Gradient Icons & Info ', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['icons'] .', '. $cat_display_names['services'] .', '. $cat_display_names['general'];
$data['custom_class'] = 'icons services general date-10-Sep-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/icons-left.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" equal_height="yes" content_placement="middle" scene_position="center" text_color="dark" text_align="left" overlay_strength="0.3"][vc_column centered_text="true" column_padding="padding-6-percent" column_padding_position="all" background_color="#ffffff" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][nectar_icon icon_family="iconsmind" icon_style="border-animation" icon_border_thickness="2px" icon_color="extra-color-gradient-1" icon_padding="15px" icon_iconsmind="iconsmind-Thunder" url="#" margin_bottom="10"][divider line_type="No Line" custom_height="10"][vc_column_text max_width="315"]
<h4>Thousands Of Icons</h4>
[/vc_column_text][divider line_type="No Line" custom_height="5"][vc_column_text max_width="350"]<span style="color: #aaa;">Salient comes packed with amazing icon families for you to choose from. Practically anything you could imagine exists.</span>[/vc_column_text][divider line_type="No Line" custom_height="50"][nectar_icon icon_family="iconsmind" icon_style="border-animation" icon_border_thickness="2px" icon_color="extra-color-gradient-1" icon_padding="25px" icon_iconsmind="iconsmind-Wolf" margin_bottom="15" icon_size="40" url="#"][divider line_type="No Line" custom_height="10"][vc_column_text max_width="315"]
<h4>Beautiful Design</h4>
[/vc_column_text][divider line_type="No Line" custom_height="5"][vc_column_text max_width="350"]<span style="color: #aaa;">Quality over quantity. Enjoy a vast array of carefully designed &amp; unique elements with tons of control over fine tuning them.</span>[/vc_column_text][divider line_type="No Line" custom_height="50"][nectar_icon icon_family="iconsmind" icon_style="border-animation" icon_border_thickness="2px" icon_color="extra-color-gradient-1" icon_padding="25px" icon_iconsmind="iconsmind-Microscope" margin_bottom="15" icon_size="40" url="#"][divider line_type="No Line" custom_height="10"][vc_column_text max_width="315"]
<h4>Extensive Documentation</h4>
[/vc_column_text][divider line_type="No Line" custom_height="5"][vc_column_text max_width="350"]<span style="color: #aaa;"> Never feel lost again. Documentation is available in addition to a series of video tutorials exclusively for Salient.</span>[/vc_column_text][/vc_column][vc_column centered_text="true" column_padding="padding-10-percent" column_padding_position="all" background_color="#0a0a0a" background_color_opacity="0.5" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/webp/large-art.webp" font_color="#ffffff" column_shadow="none" width="2/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_custom_heading text="How's This Look?" font_container="tag:h5|text_align:center|color:%23ffffff" use_theme_fonts="yes"][vc_custom_heading text="Ultra Fast, Modern And Very Sexy" font_container="tag:h2|text_align:center|color:%23ffffff" use_theme_fonts="yes"][divider line_type="No Line" custom_height="20"][vc_custom_heading text="I am text block. Click edit button to change this text. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut elit tellus, luctus nec ullamcorper mattis, pulvinar dapibus leo." font_container="tag:p|text_align:center|color:rgba(255%2C255%2C255%2C0.69)" use_theme_fonts="yes" css=".vc_custom_1485459419272{padding-right: 15% !important;padding-left: 15% !important;}"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Info Boxes & Testimonial', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['icons'] .', '. $cat_display_names['testimonials'];
$data['custom_class'] = 'icons testimonials';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/testimonial-text-columns.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-clouds.webp" bg_position="left top" bg_repeat="no-repeat" bg_color="#383838" scene_position="center" text_color="light" text_align="left" top_padding="10%" bottom_padding="10%" color_overlay="#0a0a0a" overlay_strength="0.5"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/4" column_border_width="none" column_border_style="solid"][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" centered_text="true" background_color_opacity="1" width="1/2" column_border_width="none" column_border_style="solid"][vc_custom_heading text="“Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantic”" font_container="tag:h4|font_size:18px|text_align:center|line_height:37px" google_fonts="font_family:Roboto%3A100%2C100italic%2C300%2C300italic%2Cregular%2Citalic%2C500%2C500italic%2C700%2C700italic%2C900%2C900italic|font_style:500%20bold%20regular%3A500%3Anormal" css_animation="none"][divider line_type="No Line" custom_height="15"][vc_custom_heading text="Jennifer Smith" font_container="tag:h5|font_size:16px|text_align:center|line_height:22px" google_fonts="font_family:Roboto%3A100%2C100italic%2C300%2C300italic%2Cregular%2Citalic%2C500%2C500italic%2C700%2C700italic%2C900%2C900italic|font_style:500%20bold%20regular%3A500%3Anormal" css_animation="none"][vc_custom_heading text="Graphic Designer" font_container="tag:h5|font_size:13px|text_align:center|color:rgba(255%2C255%2C255%2C0.45)|line_height:13px" google_fonts="font_family:Roboto%3A100%2C100italic%2C300%2C300italic%2Cregular%2Citalic%2C500%2C500italic%2C700%2C700italic%2C900%2C900italic|font_style:500%20bold%20regular%3A500%3Anormal" css_animation="none"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/4" column_border_width="none" column_border_style="solid"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" top_padding="20" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-3-percent" column_padding_position="all" centered_text="true" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color="white" icon_padding="20px" icon_iconsmind="iconsmind-Umbrella-2"][vc_column_text css_animation="fadeInUp" css=".vc_custom_1485363965531{margin-bottom: 15px !important;}"]
<h4>There For You</h4>
[/vc_column_text][vc_custom_heading text="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts" font_container="tag:p|text_align:center|color:rgba(255%2C255%2C255%2C0.65)" use_theme_fonts="yes" css_animation="fadeInUp"][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-3-percent" column_padding_position="all" centered_text="true" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color="white" icon_padding="20px" icon_iconsmind="iconsmind-Diamond"][vc_column_text css_animation="fadeInUp" css=".vc_custom_1485363986301{margin-bottom: 15px !important;}"]
<h4>Pristine Quality</h4>
[/vc_column_text][vc_custom_heading text="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts" font_container="tag:p|text_align:center|color:rgba(255%2C255%2C255%2C0.65)" use_theme_fonts="yes" css_animation="fadeInUp"][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-3-percent" column_padding_position="all" centered_text="true" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color="white" icon_padding="20px" icon_iconsmind="iconsmind-Favorite-Window"][vc_column_text css_animation="fadeInUp" css=".vc_custom_1485363991162{margin-bottom: 15px !important;}"]
<h4>Heavily Awarded</h4>
[/vc_column_text][vc_custom_heading text="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts" font_container="tag:p|text_align:center|color:rgba(255%2C255%2C255%2C0.65)" use_theme_fonts="yes" css_animation="fadeInUp"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Hero With Video, Testimonial & Info Columns', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['about'] .', '. $cat_display_names['hero_section'] .', '. $cat_display_names['testimonials'];
$data['custom_class'] = 'about hero_section testimonials';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/video-testimonial-hero.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" equal_height="yes" content_placement="top" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-clouds.webp" bg_position="left top" bg_repeat="no-repeat" bg_color="#1e1e1e" scene_position="center" text_color="light" text_align="left" top_padding="15%" bottom_padding="15%" color_overlay="#0a0a0a" overlay_strength="0.8"][vc_column column_padding="padding-5-percent" column_padding_position="right" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="grow-in" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid"][nectar_video_lightbox link_style="play_button_2" nectar_play_button_color="Default-Accent-Color" image_url="https://themenectar.com/img/demo-media/unsplash/webp/875-1000-mountains.webp" hover_effect="defaut" box_shadow="x_large_depth" video_url="https://www.youtube.com/watch?v=6oTurM7gESE"][/vc_column_inner][/vc_row_inner][divider line_type="No Line" custom_height="15"][vc_custom_heading text="“Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantic”" font_container="tag:h4|font_size:18px|text_align:left|line_height:37px" google_fonts="font_family:Roboto%3A100%2C100italic%2C300%2C300italic%2Cregular%2Citalic%2C500%2C500italic%2C700%2C700italic%2C900%2C900italic|font_style:500%20bold%20regular%3A500%3Anormal" css_animation="fadeInLeft"][divider line_type="No Line" custom_height="15"][vc_custom_heading text="Jennifer Smith" font_container="tag:h5|font_size:16px|text_align:left|line_height:22px" google_fonts="font_family:Roboto%3A100%2C100italic%2C300%2C300italic%2Cregular%2Citalic%2C500%2C500italic%2C700%2C700italic%2C900%2C900italic|font_style:500%20bold%20regular%3A500%3Anormal" css_animation="fadeInLeft"][vc_custom_heading text="Graphic Designer" font_container="tag:h5|font_size:13px|text_align:left|color:rgba(255%2C255%2C255%2C0.45)|line_height:13px" google_fonts="font_family:Roboto%3A100%2C100italic%2C300%2C300italic%2Cregular%2Citalic%2C500%2C500italic%2C700%2C700italic%2C900%2C900italic|font_style:500%20bold%20regular%3A500%3Anormal" css_animation="fadeInLeft"][divider line_type="No Line" custom_height="50"][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid"][vc_custom_heading text="This Is Salient" font_container="tag:h2|font_size:62|text_align:left|line_height:62px" use_theme_fonts="yes" css_animation="fadeInUp"][vc_custom_heading text="I am text block. Click edit button to change this text. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut elit tellus, luctus nec ullamcorper mattis, pulvinar dapibus leo elit tellus amet." font_container="tag:p|text_align:left|color:rgba(255%2C255%2C255%2C0.6)" use_theme_fonts="yes" css_animation="fadeInUp"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" top_padding="30" text_align="left"][vc_column_inner column_padding="padding-2-percent" column_padding_position="top-bottom" background_color_opacity="1" width="1/2" column_border_width="none" column_border_style="solid"][vc_column_text css_animation="fadeInUp" css=".vc_custom_1485359757045{margin-bottom: 15px !important;}"]
<h5>Design</h5>
[/vc_column_text][vc_custom_heading text="Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut elit tellus amet" font_container="tag:p|text_align:left|color:rgba(255%2C255%2C255%2C0.6)" use_theme_fonts="yes" css_animation="fadeInUp" css=".vc_custom_1485637066714{padding-right: 8% !important;}"][vc_column_text css_animation="fadeInUp" css=".vc_custom_1485359780281{margin-top: 40px !important;margin-bottom: 15px !important;}"]
<h5>Deploy</h5>
[/vc_column_text][vc_custom_heading text="Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut elit tellus amet" font_container="tag:p|text_align:left|color:rgba(255%2C255%2C255%2C0.6)" use_theme_fonts="yes" css_animation="fadeInUp" css=".vc_custom_1485637073423{padding-right: 8% !important;}"][/vc_column_inner][vc_column_inner column_padding="padding-2-percent" column_padding_position="top-bottom" background_color_opacity="1" width="1/2" column_border_width="none" column_border_style="solid"][vc_column_text css_animation="fadeInUp" css=".vc_custom_1485359774542{margin-bottom: 15px !important;}"]
<h5>Develop</h5>
[/vc_column_text][vc_custom_heading text="Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut elit tellus amet" font_container="tag:p|text_align:left|color:rgba(255%2C255%2C255%2C0.6)" use_theme_fonts="yes" css_animation="fadeInUp" css=".vc_custom_1485637078780{padding-right: 8% !important;}"][vc_column_text css_animation="fadeInUp" css=".vc_custom_1485359784260{margin-top: 40px !important;margin-bottom: 15px !important;}"]
<h5>Support</h5>
[/vc_column_text][vc_custom_heading text="Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut elit tellus amet" font_container="tag:p|text_align:left|color:rgba(255%2C255%2C255%2C0.6)" use_theme_fonts="yes" css_animation="fadeInUp" css=".vc_custom_1485637085146{padding-right: 8% !important;}"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );

$data = array();
$data['name'] = esc_html__( 'Image Overflowing Left Dark Hero', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['about'] .', '. $cat_display_names['hero_section'];
$data['custom_class'] = 'about hero_section';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/dark-overflow.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" equal_height="yes" content_placement="middle" bg_color="#151515" scene_position="center" text_color="light" text_align="left" top_padding="7%" bottom_padding="7%" overlay_strength="0.3"][vc_column column_padding="padding-5-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][image_with_animation image_url="http://54cb3baa74d4d851e8b7-2e7f88565dceb0a8192c6645d1f8b1b4.r12.cf2.rackcdn.com/macbook.png" alignment="right" animation="Fade In From Left" box_shadow="none" max_width="225%"][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid"][vc_custom_heading text="This Is Salient" font_container="tag:h2|font_size:62|text_align:left|line_height:62px" use_theme_fonts="yes" css_animation="fadeInUp"][vc_custom_heading text="I am text block. Click edit button to change this text. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut elit tellus, luctus nec ullamcorper mattis, pulvinar dapibus leo elit tellus amet." font_container="tag:p|text_align:left|color:rgba(255%2C255%2C255%2C0.6)" use_theme_fonts="yes" css_animation="fadeInUp"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" top_padding="40" text_align="left"][vc_column_inner column_padding="padding-2-percent" column_padding_position="top-bottom" background_color_opacity="1" width="1/2" column_border_width="none" column_border_style="solid"][vc_column_text css_animation="fadeInUp" css=".vc_custom_1485359757045{margin-bottom: 15px !important;}"]
<h5>Design</h5>
[/vc_column_text][vc_custom_heading text="Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut elit tellus amet" font_container="tag:p|text_align:left|color:rgba(255%2C255%2C255%2C0.6)" use_theme_fonts="yes" css_animation="fadeInUp" css=".vc_custom_1485638352644{padding-right: 10% !important;}"][vc_column_text css_animation="fadeInUp" css=".vc_custom_1485359780281{margin-top: 40px !important;margin-bottom: 15px !important;}"]
<h5>Deploy</h5>
[/vc_column_text][vc_custom_heading text="Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut elit tellus amet" font_container="tag:p|text_align:left|color:rgba(255%2C255%2C255%2C0.6)" use_theme_fonts="yes" css_animation="fadeInUp" css=".vc_custom_1485638357220{padding-right: 10% !important;}"][/vc_column_inner][vc_column_inner column_padding="padding-2-percent" column_padding_position="top-bottom" background_color_opacity="1" width="1/2" column_border_width="none" column_border_style="solid"][vc_column_text css_animation="fadeInUp" css=".vc_custom_1485359774542{margin-bottom: 15px !important;}"]
<h5>Develop</h5>
[/vc_column_text][vc_custom_heading text="Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut elit tellus amet" font_container="tag:p|text_align:left|color:rgba(255%2C255%2C255%2C0.6)" use_theme_fonts="yes" css_animation="fadeInUp" css=".vc_custom_1485638366488{padding-right: 10% !important;}"][vc_column_text css_animation="fadeInUp" css=".vc_custom_1485359784260{margin-top: 40px !important;margin-bottom: 15px !important;}"]
<h5>Support</h5>
[/vc_column_text][vc_custom_heading text="Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut elit tellus amet" font_container="tag:p|text_align:left|color:rgba(255%2C255%2C255%2C0.6)" use_theme_fonts="yes" css_animation="fadeInUp" css=".vc_custom_1485638371087{padding-right: 10% !important;}"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Image Overflowing Right Dark Hero', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['about'] .', '. $cat_display_names['hero_section'];
$data['custom_class'] = 'about hero_section';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/ipad-right-dark.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" equal_height="yes" content_placement="middle" bg_color="#151515" scene_position="center" text_color="light" text_align="left" top_padding="7%" bottom_padding="7%" id="save-time" row_name="Save Time" overlay_strength="0.3"][vc_column column_padding="padding-2-percent" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="5/12" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" offset="vc_col-xs-12"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid"][vc_custom_heading text="Save Yourself Time By Using Salient" font_container="tag:h2|font_size:62|text_align:left|line_height:62px" use_theme_fonts="yes" css_animation="fadeInUp"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" font_color="#777777" width="1/1" column_border_width="none" column_border_style="solid" delay="150"][vc_custom_heading text="I am text block. Click edit button to change this text. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut elit tellus, luctus nec ullamcorper mattis, pulvinar dapibus leo elit tellus amet." font_container="tag:p|text_align:left" use_theme_fonts="yes" css_animation="fadeInUp"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" font_color="#777777" width="1/1" column_border_width="none" column_border_style="solid" delay="300"][fancy-ul icon_type="font_icon" icon="icon-caret-right" color="Accent-Color" alignment="left" enable_animation="true" delay="100"]
<ul>
 	<li>Top Customer Support</li>
 	<li>Most Liked Company</li>
 	<li>Best In Class 2016</li>
 	<li>Friendliest Group</li>
 	<li>Innovative Brand</li>
</ul>
[/fancy-ul][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="padding-3-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="7/12" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" offset="vc_col-xs-12"][image_with_animation image_url="http://54cb3baa74d4d851e8b7-2e7f88565dceb0a8192c6645d1f8b1b4.r12.cf2.rackcdn.com/ipad-hor-dark.png" alignment="" animation="Fade In From Right" box_shadow="none" max_width="165%"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Parallax Image Background', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/parallax-bg-img.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-clouds.webp" bg_position="left top" bg_repeat="no-repeat" parallax_bg="true" parallax_bg_speed="fast" scene_position="center" text_color="light" text_align="left" top_padding="15%" bottom_padding="15%" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Minimal CTA Strip', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'].', '. $cat_display_names['cta'];
$data['custom_class'] = 'general cta';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/call-to-action.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" equal_height="yes" content_placement="middle" bg_color="#f4f4f4" scene_position="center" text_color="dark" text_align="left" top_padding="80" bottom_padding="80" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/2" tablet_text_alignment="center" phone_text_alignment="center" column_border_width="none" column_border_style="solid"][vc_custom_heading text="Sign Up Today &amp; Start Sending Money." font_container="tag:h2|font_size:52|text_align:left|line_height:56px" google_fonts="font_family:Roboto%20Condensed%3A300%2C300italic%2Cregular%2Citalic%2C700%2C700italic|font_style:700%20bold%20regular%3A700%3Anormal"][vc_column_text css=".vc_custom_1485272593024{margin-top: 15px !important;}"]Get 30 days free when you sign up now.[/vc_column_text][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/2" tablet_text_alignment="center" phone_text_alignment="center" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="right"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid"][nectar_btn size="jumbo" button_style="see-through-3d" color_override="#006afe" url="#" text="Sign Up Now"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Device Video Hero', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['hero_section'];
$data['custom_class'] = 'hero_section';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/device_video.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" equal_height="yes" content_placement="middle" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-clouds.webp" bg_position="left top" bg_repeat="no-repeat" bg_color="#1e1e1e" scene_position="center" text_color="light" text_align="left" top_padding="15%" bottom_padding="15%" color_overlay="#242838" overlay_strength="0.95"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" bottom_padding="30" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/6" column_border_width="none" column_border_style="solid"][/vc_column_inner][vc_column_inner column_padding="padding-2-percent" column_padding_position="left-right" background_color_opacity="1" width="2/3" column_border_width="none" column_border_style="solid"][vc_custom_heading text="Like Nothing You've Seen" font_container="tag:h2|font_size:52|text_align:center|line_height:52px" use_theme_fonts="yes"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/6" column_border_width="none" column_border_style="solid"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/6" column_border_width="none" column_border_style="solid"][/vc_column_inner][vc_column_inner enable_animation="true" animation="grow-in" column_padding="padding-1-percent" column_padding_position="left-right" centered_text="true" background_color_opacity="1" width="2/3" column_border_width="none" column_border_style="solid"][nectar_video_lightbox link_style="play_button_2" nectar_play_button_color="Default-Accent-Color" image_url="http://54cb3baa74d4d851e8b7-2e7f88565dceb0a8192c6645d1f8b1b4.r12.cf2.rackcdn.com/iphone-hor.png" hover_effect="zoom_button" box_shadow="none" video_url="https://www.youtube.com/watch?v=6oTurM7gESE"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/6" column_border_width="none" column_border_style="solid"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" top_padding="60" text_align="left"][vc_column_inner column_padding="padding-2-percent" column_padding_position="top-bottom" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid"][vc_column_text css_animation="fadeInUp" css=".vc_custom_1485620340174{margin-bottom: 15px !important;}"]
<h5>Design</h5>
[/vc_column_text][vc_custom_heading text="But nothing the copy said could convince her and so it didn’t take long until a few insidious Copy Writers ambushed her." font_container="tag:p|text_align:left|color:rgba(255%2C255%2C255%2C0.7)" use_theme_fonts="yes" css_animation="fadeInUp" css=".vc_custom_1485639261992{padding-right: 13% !important;}"][/vc_column_inner][vc_column_inner column_padding="padding-2-percent" column_padding_position="top-bottom" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid"][vc_column_text css_animation="fadeInUp" css=".vc_custom_1485620353894{margin-bottom: 15px !important;}"]
<h5>Develop</h5>
[/vc_column_text][vc_custom_heading text="But nothing the copy said could convince her and so it didn’t take long until a few insidious Copy Writers ambushed her." font_container="tag:p|text_align:left|color:rgba(255%2C255%2C255%2C0.7)" use_theme_fonts="yes" css_animation="fadeInUp" css=".vc_custom_1485639271098{padding-right: 13% !important;}"][/vc_column_inner][vc_column_inner column_padding="padding-2-percent" column_padding_position="top-bottom" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid"][vc_column_text css_animation="fadeInUp" css=".vc_custom_1485620358602{margin-bottom: 15px !important;}"]
<h5>Deploy</h5>
[/vc_column_text][vc_custom_heading text="But nothing the copy said could convince her and so it didn’t take long until a few insidious Copy Writers ambushed her." font_container="tag:p|text_align:left|color:rgba(255%2C255%2C255%2C0.7)" use_theme_fonts="yes" css_animation="fadeInUp" css=".vc_custom_1485639277257{padding-right: 13% !important;}"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Pristine Team', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['team'] .', '. $cat_display_names['about'];
$data['custom_class'] = 'team about';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/non-fullwidth-team.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="in_container" full_screen_row_position="middle" scene_position="center" text_color="dark" text_align="left" top_padding="7%" bottom_padding="7%" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" bottom_padding="60" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" centered_text="true" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid"][vc_custom_heading text="Meet Our Team" font_container="tag:h3|text_align:center" use_theme_fonts="yes"][divider line_type="Small Line" line_thickness="2" divider_color="accent-color" animate="yes" custom_height="40" custom_line_width="40"][vc_column_text max_width="650"]I am text block. Click edit button to change this text. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut elit tellus, luctus nec ullamcorper mattis.[/vc_column_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="grow-in" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid"][team_member image_url="https://themenectar.com/img/demo-media/unsplash/webp/team-member-1-small-cropped.webp" bio_image_url="https://themenectar.com/demo/dummy-data-imgs/business/about-team-member-big.jpg" team_memeber_style="bio_fullscreen" name="Igor Kozlov" job_position="Graphic Designer" team_member_bio="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean. A small river named Duden flows by their place and supplies it with the necessary regelialia. It is a paradisematic country, in which roasted parts of sentences fly into your mouth. "][/vc_column_inner][vc_column_inner enable_animation="true" animation="grow-in" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid"][team_member image_url="https://themenectar.com/img/demo-media/unsplash/webp/team-member-2-small-cropped.webp" bio_image_url="https://themenectar.com/demo/dummy-data-imgs/business/about-team-member-big.jpg" team_memeber_style="bio_fullscreen" name="Mark Jones" job_position="Back-end Developer" team_member_bio="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean. A small river named Duden flows by their place and supplies it with the necessary regelialia. It is a paradisematic country, in which roasted parts of sentences fly into your mouth. "][/vc_column_inner][vc_column_inner enable_animation="true" animation="grow-in" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid"][team_member image_url="https://themenectar.com/img/demo-media/unsplash/webp/team-member-3-small-cropped.webp" bio_image_url="https://themenectar.com/demo/dummy-data-imgs/business/about-team-member-big.jpg" team_memeber_style="bio_fullscreen" name="Andre Smith" job_position="Fine Artist" team_member_bio="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean. A small river named Duden flows by their place and supplies it with the necessary regelialia. It is a paradisematic country, in which roasted parts of sentences fly into your mouth. "][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="grow-in" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid"][team_member image_url="https://themenectar.com/img/demo-media/unsplash/webp/team-member-4-small-cropped.webp" bio_image_url="https://themenectar.com/demo/dummy-data-imgs/business/about-team-member-big.jpg" team_memeber_style="bio_fullscreen" name="Ethan Young" job_position="Team Leader" team_member_bio="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean. A small river named Duden flows by their place and supplies it with the necessary regelialia. It is a paradisematic country, in which roasted parts of sentences fly into your mouth. "][/vc_column_inner][vc_column_inner enable_animation="true" animation="grow-in" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid"][team_member image_url="https://themenectar.com/img/demo-media/unsplash/webp/team-member-5-small-cropped.webp" bio_image_url="https://themenectar.com/demo/dummy-data-imgs/business/about-team-member-big.jpg" team_memeber_style="bio_fullscreen" name="Ava Morgan" job_position="The SEO Expert" team_member_bio="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean. A small river named Duden flows by their place and supplies it with the necessary regelialia. It is a paradisematic country, in which roasted parts of sentences fly into your mouth. "][/vc_column_inner][vc_column_inner enable_animation="true" animation="grow-in" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/3" column_border_width="none" column_border_style="solid"][team_member image_url="https://themenectar.com/img/demo-media/unsplash/webp/team-member-6-small-cropped.webp" bio_image_url="https://themenectar.com/demo/dummy-data-imgs/business/about-team-member-big.jpg" team_memeber_style="bio_fullscreen" name="James Anderson" job_position="Front-end Developer" team_member_bio="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean. A small river named Duden flows by their place and supplies it with the necessary regelialia. It is a paradisematic country, in which roasted parts of sentences fly into your mouth. "][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Pie Chart Three Columns', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['counters'] .', '. $cat_display_names['about'];
$data['custom_class'] = 'counters about';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/piechart.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="in_container" full_screen_row_position="middle" scene_position="center" text_color="dark" text_align="left" overlay_strength="0.3"][vc_column centered_text="true" column_padding="padding-4-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="padding-4-percent" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid"][vc_pie value="80" color="#0090ff" title="UI Design" units="%"][/vc_column_inner][/vc_row_inner][vc_column_text css=".vc_custom_1485285889042{margin-top: -15px !important;}"]I am text block. Click edit button to change this text. Lorem ipsum dolor sit amet, consectetur adipiscing elit.[/vc_column_text][/vc_column][vc_column centered_text="true" column_padding="padding-4-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="padding-4-percent" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid"][vc_pie value="64" color="#ff3a3a" title="Web Design" units="%"][/vc_column_inner][/vc_row_inner][vc_column_text css=".vc_custom_1485285893250{margin-top: -15px !important;}"]I am text block. Click edit button to change this text. Lorem ipsum dolor sit amet, consectetur adipiscing elit.[/vc_column_text][/vc_column][vc_column centered_text="true" column_padding="padding-4-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="padding-4-percent" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid"][vc_pie value="75" color="#2AC4EA" title="Photography" units="%"][/vc_column_inner][/vc_row_inner][vc_column_text css=".vc_custom_1485285897481{margin-top: -15px !important;}"]I am text block. Click edit button to change this text. Lorem ipsum dolor sit amet, consectetur adipiscing elit.[/vc_column_text][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Minimal CTA Strip Alt', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'].', '. $cat_display_names['cta'];
$data['custom_class'] = 'general cta';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/call-to-action-2.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" equal_height="yes" content_placement="middle" bg_color="#ffffff" scene_position="center" text_color="dark" text_align="left" top_padding="80" bottom_padding="80" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/2" tablet_text_alignment="center" phone_text_alignment="center" column_border_width="none" column_border_style="solid"][vc_custom_heading text="Sign Up Today &amp; Start Sending Money." font_container="tag:h2|font_size:52|text_align:left|line_height:56px" google_fonts="font_family:Roboto%20Condensed%3A300%2C300italic%2Cregular%2Citalic%2C700%2C700italic|font_style:700%20bold%20regular%3A700%3Anormal"][vc_column_text css=".vc_custom_1485272593024{margin-top: 15px !important;}"]Get 30 days free when you sign up now.[/vc_column_text][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/2" tablet_text_alignment="center" phone_text_alignment="center" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="right"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid"][nectar_btn size="jumbo" button_style="see-through-3d" color_override="#ff0044" url="#" text="Sign Up Now"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );

$data = array();
$data['name'] = esc_html__( 'vCard Minimal Colorful', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['about'];
$data['custom_class'] = 'about date-10-Aug-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/about-minimal-2.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" equal_height="yes" content_placement="middle" bg_color="#3452ff" scene_position="center" text_color="light" text_align="left" top_padding="7%" bottom_padding="7%" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][image_with_animation image_url="https://themenectar.com/img/demo-media/unsplash/webp/team-member-full-silhouette.webp" alignment="" animation="Fade In" box_shadow="x_large_depth" max_width="100%"][/vc_column][vc_column column_padding="padding-6-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_custom_heading text="Philip Martinez" font_container="tag:h5|text_align:left|color:rgba(255%2C255%2C255%2C0.6)" use_theme_fonts="yes" css=".vc_custom_1485271332280{margin-bottom: 10px !important;}"][vc_custom_heading text="Creator of quality designs and thinker of fresh ideas." font_container="tag:h2|font_size:40|text_align:left|line_height:50px" use_theme_fonts="yes"][vc_column_text css=".vc_custom_1485195197203{margin-top: 30px !important;margin-bottom: 30px !important;}"]Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. A small river named Duden flows by their place and supplies it with the necessary regelialia[/vc_column_text][divider line_type="No Line" custom_height="50"][vc_custom_heading text="What I Do" font_container="tag:h5|text_align:left|color:rgba(255%2C255%2C255%2C0.6)" use_theme_fonts="yes" css=".vc_custom_1485271340468{margin-bottom: 10px !important;}"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/2" column_border_width="none" column_border_style="solid"][fancy-ul icon_type="none" alignment="left"]
<ul>
	<li>Graphic Design</li>
	<li>Web Development</li>
	<li>Video Editing</li>
	<li>Audio Engineering</li>
</ul>
[/fancy-ul][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/2" column_border_width="none" column_border_style="solid"][fancy-ul icon_type="none" alignment="left"]
<ul>
	<li>Social Marketing</li>
	<li>NEC Strategy</li>
	<li>SEO Audits</li>
	<li>Branding</li>
</ul>
[/fancy-ul][/vc_column_inner][/vc_row_inner][nectar_icon icon_family="iconsmind" icon_style="default" icon_color="white" open_new_tab="true" icon_padding="20px" icon_iconsmind="iconsmind-Facebook-2" icon_size="29" margin_left="-20px" url="#"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color="white" open_new_tab="true" icon_padding="20px" icon_iconsmind="iconsmind-Reddit" icon_size="29" url="#"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color="white" open_new_tab="true" icon_padding="20px" icon_iconsmind="iconsmind-Dribble" icon_size="29" url="#"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'vCard Minimal', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['about'];
$data['custom_class'] = 'about date-10-Aug-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/about-minimal.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" equal_height="yes" content_placement="middle" bg_color="#ffffff" scene_position="center" text_color="dark" text_align="left" top_padding="4%" bottom_padding="7%" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][image_with_animation image_url="https://themenectar.com/img/demo-media/unsplash/webp/team-member-full-silhouette.webp" alignment="" animation="Fade In" box_shadow="x_large_depth" max_width="100%"][/vc_column][vc_column column_padding="padding-6-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_custom_heading text="Philip Martinez" font_container="tag:h5|text_align:left|color:%23bfbfbf" use_theme_fonts="yes" css=".vc_custom_1485193607322{margin-bottom: 10px !important;}"][vc_custom_heading text="Creator of quality designs and thinker of fresh ideas." font_container="tag:h2|font_size:40|text_align:left|line_height:50px" use_theme_fonts="yes"][vc_column_text css=".vc_custom_1485195197203{margin-top: 30px !important;margin-bottom: 30px !important;}"]Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. A small river named Duden flows by their place and supplies it with the necessary regelialia[/vc_column_text][divider line_type="No Line" custom_height="50"][vc_custom_heading text="What I Do" font_container="tag:h5|text_align:left|color:%23bfbfbf" use_theme_fonts="yes" css=".vc_custom_1485193623501{margin-bottom: 10px !important;}"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/2" column_border_width="none" column_border_style="solid"][fancy-ul icon_type="none" alignment="left"]
<ul>
	<li>Graphic Design</li>
	<li>Web Development</li>
	<li>Video Editing</li>
	<li>Audio Engineering</li>
</ul>
[/fancy-ul][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/2" column_border_width="none" column_border_style="solid"][fancy-ul icon_type="none" alignment="left"]
<ul>
	<li>Social Marketing</li>
	<li>NEC Strategy</li>
	<li>SEO Audits</li>
	<li>Branding</li>
</ul>
[/fancy-ul][/vc_column_inner][/vc_row_inner][nectar_icon icon_family="iconsmind" icon_style="default" icon_color="Accent-Color" open_new_tab="true" icon_padding="20px" icon_iconsmind="iconsmind-Facebook-2" icon_size="29" margin_left="-20px" url="#"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color="Accent-Color" open_new_tab="true" icon_padding="20px" icon_iconsmind="iconsmind-Reddit" icon_size="29" url="#"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color="Accent-Color" open_new_tab="true" icon_padding="20px" icon_iconsmind="iconsmind-Dribble" icon_size="29" url="#"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Personal Story', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['about'];
$data['custom_class'] = 'about date-10-Aug-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/personal_story.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" vertically_center_columns="true" bg_color="#a65bf4" scene_position="center" text_color="light" text_align="left" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/webp/neutral-girl-2.webp" column_shadow="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][vc_column column_padding="padding-7-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_column_text]
<h1>Eric Jördis</h1>
[/vc_column_text][divider line_type="No Line" custom_height="20"][vc_column_text]
<h2>"Aliquam" erat volutpat. Phasellus tortor velit, ornare at ullamcorper at, ultrices et diam at nunc.</h2>
[/vc_column_text][divider line_type="No Line" custom_height="30"][vc_column_text]Morbi nec ultrices tellus. Fusce id est quis orci faucibus congue. Aliquam erat volutpat. Phasellus tortor velit, ornare at ullamcorper at, ultrices et justo. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Quisque cursus, sem eget convallis viverra, nunc ante vulputate nunc, at sagittis nisi diam at nunc. Morbi posuere fringilla viverra. Vivamus vestibulum nisl non elementum. Nulla lorem tellus, pulvinar in neque luctus, scelerisque facilisis lectus. In leo justo, scelerisque et auctor nec, suscipit accumsan neque. Nullam feugiat diam at mauris fermentum

Maximus justo vulputate vitae. Nulla ipsum leo, commodo sit amet congue sed, porta nec elit. Mauris mollis tempus ipsum, id bibendum metus lobortis ac. Donec vitae felis imperdiet, lobortis lorem vitae, efficitur ligula. Pellentesque in condimentum libero. Duis iaculis magna diam, vitae fringilla sapien commodo eget. Pellentesque vehicula varius placerat. Sed aliquam commodo dolor. Quisque cursus, sem eget convallis viverra, nunc ante vulputate nunc, at sagittis nisi diam at nunc.[/vc_column_text][/vc_column][/vc_row][vc_row type="full_width_content" full_screen_row_position="middle" vertically_center_columns="true" bg_color="#ffffff" scene_position="center" text_color="light" text_align="right" id="reasons" overlay_strength="0.3"][vc_column column_padding="padding-3-percent" column_padding_position="all" background_color="#f2f2f2" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" centered_text="true" background_color_opacity="1" width="1/2" column_border_width="none" column_border_style="solid"][milestone heading_inherit="default" symbol_position="after" subject_padding="0" color="Accent-Color" effect="motion_blur" symbol_alignment="Superscript" number="78" symbol="+" number_font_size="158" symbol_font_size="57"][/vc_column_inner][vc_column_inner column_padding="padding-2-percent" column_padding_position="left" background_color_opacity="1" width="1/2" column_border_width="none" column_border_style="solid"][divider line_type="No Line" custom_height="25"][vc_column_text]
<h5 style="text-align: left;"><span style="color: #933ded;">Projects</span></h5>
<h4 style="text-align: left;"><span style="color: #933ded;">Completed</span></h4>
<p style="text-align: left;"><span style="color: #000000;">Duis iaculis magna diam neque </span>
<span style="color: #000000;">Sed aliqua commodo aliquet. </span>

[/vc_column_text][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="padding-10-percent" column_padding_position="all" background_color="#a65bf4" background_color_opacity="0.8" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/webp/700-700-food.webp" column_shadow="none" width="1/4" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][vc_column column_padding="padding-10-percent" column_padding_position="all" background_color="#a65bf4" background_color_opacity="0.7" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/webp/800-500-adventure.webp" column_shadow="none" width="1/4" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Fancy Horizontal Tabbed Section', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'].', '. $cat_display_names['services'];
$data['custom_class'] = 'general services date-04-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/fancy_tabs.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" scene_position="center" text_color="dark" text_align="left" top_padding="100" bottom_padding="5%" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" width="1/1"][tabbed_section style="minimal" alignment="left" cta_button_style="extra-color-2" cta_button_text="Buy Now" cta_button_link="http://themeforest.net/item/salient-responsive-multipurpose-theme/4363266"][tab title="Page Builder" tab_id="1446568150305-7"][vc_row_inner][vc_column_inner enable_animation="true" animation="fade-in-from-right" column_padding="padding-4-percent" column_padding_position="all" background_color_opacity="1" width="1/4" offset="vc_col-lg-3 vc_col-md-4"][vc_column_text]
<h5 style="text-align: right;">Before Salient</h5>
<p style="text-align: right;"><span style="color: #a3a3a3;">Hand rolling code is fun sometimes, but not ideal for getting projects done quickly or allowing clients to maintain pages.</span></p>
[/vc_column_text][/vc_column_inner][vc_column_inner column_padding="padding-4-percent" column_padding_position="bottom" background_color_opacity="1" width="1/2" offset="vc_col-lg-6 vc_col-md-8"][nectar_image_comparison][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-left" column_padding="padding-4-percent" column_padding_position="all" background_color_opacity="1" width="1/4" offset="vc_col-lg-offset-0 vc_col-lg-3 vc_col-md-offset-4 vc_col-md-8"][vc_column_text]
<h5>With Salient</h5>
<span style="color: #a3a3a3;">Salient provides you a highly customized version of Visual Composer bundled with unique elements all available for use via the drag &amp; drop interface.</span>[/vc_column_text][/vc_column_inner][/vc_row_inner][/tab][tab title="Imagine" tab_id="1446565195463-2"][vc_row_inner][vc_column_inner column_padding="padding-2-percent" column_padding_position="right" background_color_opacity="1" width="1/2"][vc_column_text]
<h6><span style="color: #1e83ec;">No Matter What</span></h6>
[/vc_column_text][vc_column_text]
<h2>All we do is win</h2>
[/vc_column_text][vc_column_text]Vivamus eu neque ut sem malesuada consectetur sed sed felis. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae. ullam et eros ornare, porttitor urna sed, auctor lacus. Morbi viverra lorem at neque tincidunt consequat.

<span style="color: #a3a3a3;">Praesent eget ullamcorper enim. Curabitur scelerisque mi dolor, eget egestas sem interdum eget. Etiam eros tortor, malesuada sed velit a, rhoncus congue elit.</span>

[button color="see-through-2" hover_text_color_override="#fff" image="default-arrow" size="medium" url="https://themenectar.com/demo/salient-corporate/2013/03/magna-fringilla-quis-condimentum/" text="Seriously, we do" color_override="#1e83ec" hover_color_override="#1e83ec"][/vc_column_text][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/4"][vc_column_text css=".vc_custom_1452016245742{margin-bottom: 18px !important;}"]
<h5>Target Auidence</h5>
[/vc_column_text][fancy-ul icon_type="standard_dash" color="Extra-Color-3" enable_animation="true"]
<ul>
	<li><span style="color: #999999;">Medium Businesses</span></li>
	<li><span style="color: #999999;">Freelance Designers</span></li>
	<li><span style="color: #999999;">College Students</span></li>
	<li><span style="color: #999999;">Sorta Athletes</span></li>
	<li><span style="color: #999999;">Dairy Farmers</span></li>
</ul>
[/fancy-ul][divider line_type="No Line" custom_height="20"][vc_column_text css=".vc_custom_1452016227170{margin-bottom: 18px !important;}"]
<h5>Our Specialties</h5>
[/vc_column_text][fancy-ul icon_type="standard_dash" color="Extra-Color-3" enable_animation="true"]
<ul>
	<li><span style="color: #999999;">Program Management</span></li>
	<li><span style="color: #999999;">Graphic &amp; UI Design</span></li>
	<li><span style="color: #999999;">Customer Support</span></li>
	<li><span style="color: #999999;">Video Editing</span></li>
	<li><span style="color: #999999;">Sound Design</span></li>
</ul>
[/fancy-ul][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/4"][vc_column_text css=".vc_custom_1452016219737{margin-bottom: 18px !important;}"]
<h5>Notable Awards</h5>
[/vc_column_text][fancy-ul icon_type="standard_dash" color="Extra-Color-3" enable_animation="true"]
<ul>
	<li><span style="color: #999999;">Top Customer Support</span></li>
	<li><span style="color: #999999;">Most Liked Company</span></li>
	<li><span style="color: #999999;">Best In Class 2016</span></li>
	<li><span style="color: #999999;">Friendliest Group</span></li>
	<li><span style="color: #999999;">Innovative Brand</span></li>
</ul>
[/fancy-ul][divider line_type="No Line" custom_height="20"][vc_column_text css=".vc_custom_1452016235987{margin-bottom: 18px !important;}"]
<h5>Featured On</h5>
[/vc_column_text][fancy-ul icon_type="standard_dash" color="Extra-Color-3" enable_animation="true"]
<ul>
	<li><span style="color: #999999;">ThemeNectar Show</span></li>
	<li><span style="color: #999999;">Mr. Nectar's Blog</span></li>
	<li><span style="color: #999999;">Top WP Themes</span></li>
	<li><span style="color: #999999;">ThemeForest</span></li>
	<li><span style="color: #999999;">Salient</span></li>
</ul>
[/fancy-ul][/vc_column_inner][/vc_row_inner][/tab][tab title="Statistics" tab_id="1446568150305-7" id="1451522261332-5"][vc_row_inner][vc_column_inner column_padding="padding-2-percent" column_padding_position="right" background_color_opacity="1" width="1/2"][bar color="Accent-Color" percent="75" title="Marketing"][bar color="Accent-Color" percent="90" title="UI/UX Design"][bar color="Accent-Color" percent="80" title="Strategy"][bar color="Accent-Color" percent="65" title="3d Modeling"][bar color="Accent-Color" percent="95" title="Video Production"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/2"][vc_column_text]
<h2>It's time you regained
control over your website</h2>
[/vc_column_text][vc_column_text]Vivamus eu neque ut sem malesuada consectetur sed sed felis. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae. ullam et eros ornare, porttitor urna sed.

<span style="color: #a3a3a3;">Praesent eget ullamcorper enim. Curabitur scelerisque mi dolor, eget egestas sem interdum eget. Etiam eros tortor, malesuada sed velit.</span>[/vc_column_text][/vc_column_inner][/vc_row_inner][/tab][/tabbed_section][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Video Player Lightbox', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'] .', '. $cat_display_names['portfolio'];
$data['custom_class'] = 'general portfolio';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/video-player-lightbox.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" equal_height="yes" content_placement="middle" bg_image="" bg_position="center bottom" bg_repeat="no-repeat" bg_color="#3452ff" scene_position="center" text_color="light" text_align="left" top_padding="5%" bottom_padding="5%" id="discover" row_name="Discover" disable_ken_burns="yes" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/6" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" offset="vc_hidden-sm vc_hidden-xs"][/vc_column][vc_column column_padding="padding-3-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid"][vc_column_text]
<h2>Your Productivity
Boosted With Salient</h2>
[/vc_column_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid" delay="200"][vc_column_text css=".vc_custom_1469377177047{margin-top: 20px !important;}"]Salient app will change the way we stay connected and interact. Meet Kara, a young aspiring writer who's been using Salient to improve her skills every day.[/vc_column_text][/vc_column_inner][/vc_row_inner][/vc_column][vc_column enable_animation="true" animation="grow-in" column_padding="padding-3-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][nectar_video_lightbox link_style="play_button_2" nectar_play_button_color="Default-Accent-Color" image_url="https://themenectar.com/img/demo-media/unsplash/webp/800-500-room.webp" box_shadow="x_large_depth" video_url="https://www.youtube.com/watch?v=6oTurM7gESE"][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/6" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" offset="vc_hidden-sm vc_hidden-xs"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Recent Posts Grid Minimal ', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['blog'];
$data['custom_class'] = 'blog date-10-Aug-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/recent_post_grid.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" bg_position="left top" bg_repeat="no-repeat" parallax_bg_speed="slow" bg_color="#ffffff" scene_position="center" text_color="dark" text_align="left" top_padding="13%" bottom_padding="13%"][vc_column width="1/3" animation="fade-in" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" enable_animation="true"][recent_posts style="title_only" category="all" columns="1" posts_per_page="1"][/vc_column][vc_column width="2/3" enable_animation="true" animation="fade-in" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1"][recent_posts category="all" columns="2" posts_per_page="4" style="minimal" post_offset="1"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Video Lightboxes', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'] .', '. $cat_display_names['portfolio'];
$data['custom_class'] = 'general portfolio';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/video-lightboxes.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_color="#f2f2f2" scene_position="center" text_color="dark" text_align="left" top_padding="5%" bottom_padding="5%" id="footage" row_name="Action Footage" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" width="1/1" tablet_text_alignment="default" phone_text_alignment="default"][vc_row_inner text_align="left"][vc_column_inner enable_animation="true" animation="fade-in" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" centered_text="true" width="1/1"][vc_column_text css=".vc_custom_1468952632915{margin-top: 50px !important;margin-bottom: 15px !important;}"]
<h2>Enter Into A World Of Fun</h2>
<h4><span style="color: #999999;">First Person Clips Of Mountain Rides With The X1</span></h4>
[/vc_column_text][/vc_column_inner][/vc_row_inner][vc_row_inner text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-1-percent" column_padding_position="all" background_color_opacity="1" width="1/3"][nectar_video_lightbox link_style="play_button_2" nectar_play_button_color="Default-Accent-Color" image_url="https://themenectar.com/img/demo-media/unsplash/webp/800-500-room.webp" box_shadow="x_large_depth" video_url="https://www.youtube.com/watch?v=6oTurM7gESE"][vc_column_text css=".vc_custom_1469672460721{padding-top: 20px !important;}"]
<h3>Aerial Footage <span style="color: #bbb;">5:29</span></h3>
Watch some drone footage of our team's best riders going downhill on Salient mountain.[/vc_column_text][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-1-percent" column_padding_position="all" background_color_opacity="1" width="1/3" delay="150"][nectar_video_lightbox link_style="play_button_2" nectar_play_button_color="Default-Accent-Color" image_url="https://themenectar.com/img/demo-media/unsplash/webp/800-500-watch.webp" box_shadow="x_large_depth" video_url="https://www.youtube.com/watch?v=6oTurM7gESE"][vc_column_text css=".vc_custom_1469672453177{margin-top: 5px !important;padding-top: 20px !important;}"]
<h3>The Quick Route <span style="color: #bbb;">3:20</span></h3>
There's staying on the trail and then there's taking the "alternative" route.[/vc_column_text][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-1-percent" column_padding_position="all" background_color_opacity="1" width="1/3" delay="300"][nectar_video_lightbox link_style="play_button_2" nectar_play_button_color="Default-Accent-Color" image_url="https://themenectar.com/img/demo-media/unsplash/webp/800-500-bike.webp" box_shadow="x_large_depth" video_url="https://www.youtube.com/watch?v=6oTurM7gESE"][vc_column_text css=".vc_custom_1469672468298{padding-top: 20px !important;}"]
<h3>Kevin Robertson <span style="color: #bbb;">6:45</span></h3>
Check out Kevin treck some of the most intense courses in all of the Salient area.[/vc_column_text][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Product Specifications Dark', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'] .', '. $cat_display_names['portfolio'];
$data['custom_class'] = 'general portfolio date-01-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/specifications.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" equal_height="yes" content_placement="middle" bg_color="#282828" scene_position="center" text_color="light" text_align="left" top_padding="4%" bottom_padding="4%" id="specs" row_name="Specifications" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" width="1/2" tablet_text_alignment="default" phone_text_alignment="default"][vc_row_inner text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1"][nectar_animated_title heading_tag="h6" style="color-strip-reveal" color="Accent-Color" text="Specifications "][/vc_column_inner][/vc_row_inner][vc_row_inner bottom_padding="40" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/3"][vc_column_text]
<h4>Base Frameset</h4>
<h5>Salient Package</h5>
[/vc_column_text][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-10-percent" column_padding_position="left-right" background_color_opacity="1" width="2/3" delay="100"][vc_column_text]<span style="color: #c5c5c5;">Salient main frame, G4 Link Tube, 220mm Travel, EVOX Link, Micro Truss, Enhanced Armor</span>[/vc_column_text][/vc_column_inner][/vc_row_inner][vc_row_inner bottom_padding="30" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/3" delay="200"][vc_column_text]
<h4>Wheels &amp; Tires</h4>
<h5>Infinity R5</h5>
[/vc_column_text][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-10-percent" column_padding_position="left-right" background_color_opacity="1" width="2/3" delay="300"][vc_column_text]<span style="color: #c5c5c5;">20mm front, 150x10 rear, Ultra durable J3 Group Issue Tires 26.5"x2.4"</span>[/vc_column_text][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" width="1/2" tablet_text_alignment="default" phone_text_alignment="default"][vc_row_inner text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" offset="vc_hidden-sm vc_hidden-xs"][divider line_type="No Line" custom_height="50"][/vc_column_inner][/vc_row_inner][vc_row_inner bottom_padding="40" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/3" delay="400"][vc_column_text]
<h4>Drivetrain</h4>
<h5>Nectar Triggers 26X</h5>
[/vc_column_text][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-10-percent" column_padding_position="left-right" background_color_opacity="1" width="2/3" delay="500"][vc_column_text]<span style="color: #c5c5c5;">HyperX Crank 48, Salient K7M Chain, Ultra6 Bottom Bracket, 10 Speed up/down Gearbox</span>[/vc_column_text][/vc_column_inner][/vc_row_inner][vc_row_inner bottom_padding="30" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/3" delay="600"][vc_column_text]
<h4>Components</h4>
<h5>Nectar Set</h5>
[/vc_column_text][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-10-percent" column_padding_position="left-right" background_color_opacity="1" width="2/3" delay="700"][vc_column_text]<span style="color: #c5c5c5;">Elite Ultra Comfort Seat, Salient xGrip Handlebars 32mm, Orbit Bearing</span>[/vc_column_text][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Hotspot Tooltips', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-02-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/hotspots.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_color="#ffffff" scene_position="center" text_color="dark" text_align="left" top_padding="5%" bottom_padding="5%" id="features" row_name="Features" overlay_strength="0.3"][vc_column column_padding="padding-11-percent" column_padding_position="left-right" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in" column_padding="no-extra-padding" column_padding_position="all" centered_text="true" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1468952242655{margin-top: 50px !important;margin-bottom: 15px !important;}"]
<h2>Prepare For The Adrenaline</h2>
<h4><span style="color: #999999;">The Best Materials. Handcrafted. Zero Compromises.</span></h4>
[/vc_column_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid"][nectar_image_with_hotspots image="https://themenectar.com/img/demo-media/unsplash/webp/large-building-business.webp" preview="https://themenectar.com/img/demo-media/unsplash/webp/large-building-business.webp" color_1="Extra-Color-1" hotspot_icon="plus_sign" tooltip="hover" tooltip_shadow="large_depth" animation="true"][nectar_hotspot left="15.4752%" top="36.8464%" position="bottom"]
<h5 style="color: #227bf7;">Cool Design</h5>
Lorem ipsum dolor sit sodales, augue velit cursus nunc.[/nectar_hotspot][nectar_hotspot left="64.4137%" top="56.923%" position="bottom"]
<h5 style="color: #227bf7;">Amazing Style</h5>
Lorem ipsum dolor sit sodales, augue velit cursus nunc.[/nectar_hotspot][nectar_hotspot left="84.5971%" top="35.4192%" position="bottom"]
<h5 style="color: #227bf7;">Sharp Edges</h5>
Lorem ipsum dolor sit sodales, augue velit cursus nunc.[/nectar_hotspot][nectar_hotspot left="38.6493%" top="24.5514%" position="bottom"]
<h5 style="color: #227bf7;">Ultra Durable</h5>
Lorem ipsum dolor sit sodales, augue velit cursus nunc.[/nectar_hotspot][/nectar_image_with_hotspots][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Toggles - FAQ Section', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/minimal-toggles.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_color="#f7f7f7" scene_position="center" text_color="dark" text_align="left" top_padding="100" bottom_padding="100" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_column_text]
<h2>About Salient App</h2>
[/vc_column_text][toggles style="minimal"][toggle color="Default" title="What exactly is Salient App? "][vc_column_text]Lorem ipsum dolor sit amet, consectetur adipiscing elit. In eget bibendum libero. Etiam id velit at enim porttitor facilisis. Vivamus tincidunt lectus at risus pharetra ultrices. In tincidunt turpis at odio dapibus maximus.[/vc_column_text][/toggle][toggle color="Default" title="How do I create my own Salient App account?"][vc_column_text]Lorem ipsum dolor sit amet, consectetur adipiscing elit. In eget bibendum libero. Etiam id velit at enim porttitor facilisis. Vivamus tincidunt lectus at risus pharetra ultrices. In tincidunt turpis at odio dapibus maximus.[/vc_column_text][/toggle][toggle color="Default" title="Do I need to link my bank account in order to use it?"][vc_column_text]Lorem ipsum dolor sit amet, consectetur adipiscing elit. In eget bibendum libero. Etiam id velit at enim porttitor facilisis. Vivamus tincidunt lectus at risus pharetra ultrices. In tincidunt turpis at odio dapibus maximus.[/vc_column_text][/toggle][toggle color="Default" title="Will Salient Service work on my mobile device?"][vc_column_text]Lorem ipsum dolor sit amet, consectetur adipiscing elit. In eget bibendum libero. Etiam id velit at enim porttitor facilisis. Vivamus tincidunt lectus at risus pharetra ultrices. In tincidunt turpis at odio dapibus maximus.[/vc_column_text][/toggle][toggle color="Default" title="Is it available in my country?"][vc_column_text]Lorem ipsum dolor sit amet, consectetur adipiscing elit. In eget bibendum libero. Etiam id velit at enim porttitor facilisis. Vivamus tincidunt lectus at risus pharetra ultrices. In tincidunt turpis at odio dapibus maximus.[/vc_column_text][/toggle][/toggles][vc_column_text css=".vc_custom_1469747464544{margin-top: 80px !important;}"]
<h2>Managing Your Account</h2>
[/vc_column_text][toggles style="minimal"][toggle color="Default" title="How do I manage my account?"][vc_column_text]Lorem ipsum dolor sit amet, consectetur adipiscing elit. In eget bibendum libero. Etiam id velit at enim porttitor facilisis. Vivamus tincidunt lectus at risus pharetra ultrices. In tincidunt turpis at odio dapibus maximus.[/vc_column_text][/toggle][toggle color="Default" title="How secure is the admin area?"][vc_column_text]Lorem ipsum dolor sit amet, consectetur adipiscing elit. In eget bibendum libero. Etiam id velit at enim porttitor facilisis. Vivamus tincidunt lectus at risus pharetra ultrices. In tincidunt turpis at odio dapibus maximus.[/vc_column_text][/toggle][toggle color="Default" title="How do I cancel my account?"][vc_column_text]Lorem ipsum dolor sit amet, consectetur adipiscing elit. In eget bibendum libero. Etiam id velit at enim porttitor facilisis. Vivamus tincidunt lectus at risus pharetra ultrices. In tincidunt turpis at odio dapibus maximus.[/vc_column_text][/toggle][toggle color="Default" title="Can I send more than one at a time?"][vc_column_text]Lorem ipsum dolor sit amet, consectetur adipiscing elit. In eget bibendum libero. Etiam id velit at enim porttitor facilisis. Vivamus tincidunt lectus at risus pharetra ultrices. In tincidunt turpis at odio dapibus maximus.[/vc_column_text][/toggle][/toggles][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Cascading Images With Animated Icons', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'] .', '. $cat_display_names['icons'];
$data['custom_class'] = 'general icons date-29-Sep-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/app-features.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" equal_height="yes" content_placement="middle" bg_image="133" bg_position="right top" bg_repeat="no-repeat" bg_color="#fd1742" scene_position="center" text_color="light" text_align="left" top_padding="2%" bottom_padding="2%" id="features" row_name="Features" disable_ken_burns="yes" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/12" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" offset="vc_hidden-sm vc_hidden-xs"][/vc_column][vc_column column_padding="padding-2-percent" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/4" tablet_text_alignment="center" phone_text_alignment="center" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="right"][vc_column_inner enable_animation="true" animation="fade-in" column_padding="padding-3-percent" column_padding_position="left-right" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid" delay="200"][nectar_icon icon_family="linea" enable_animation="true" animation_speed="fast" icon_style="default" icon_color="white" icon_padding="10px" icon_linea="icon-music-microphone-old" icon_size="64" animation_delay="200"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" bottom_padding="35" text_align="right"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-3-percent" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid" delay="400"][vc_column_text css=".vc_custom_1469466155666{margin-bottom: 10px !important;}"]
<h5>Voice Calling</h5>
[/vc_column_text][vc_column_text max_width="225"]Simplify your social life by communicating via voice.[/vc_column_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="right"][vc_column_inner enable_animation="true" animation="fade-in" column_padding="padding-3-percent" column_padding_position="left-right" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid" delay="700"][nectar_icon icon_family="linea" enable_animation="true" animation_speed="fast" icon_style="default" icon_color="white" icon_padding="10px" icon_linea="icon-software-layers2" animation_delay="700" icon_size="64"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="right"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-3-percent" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid" delay="900"][vc_column_text css=".vc_custom_1469466205775{margin-bottom: 10px !important;}"]
<h5>Ultimate Interface</h5>
[/vc_column_text][vc_column_text max_width="225"]No matter how hard you look, you'll never find better.[/vc_column_text][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="padding-6-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][nectar_cascading_images image_1_url="https://themenectar.com/demo/salient-app/wp-content/uploads/2017/01/app2.jpg" image_1_offset_x_sign="-" image_1_offset_x="10%" image_1_offset_y_sign="-" image_1_offset_y="5%" image_1_rotate_sign="+" image_1_rotate="none" image_1_animation="Grow In" image_1_box_shadow="none" image_2_url="https://themenectar.com/demo/salient-app/wp-content/uploads/2017/01/app.jpg" image_2_offset_x_sign="+" image_2_offset_x="10%" image_2_offset_y_sign="+" image_2_offset_y="5%" image_2_rotate_sign="+" image_2_rotate="none" image_2_animation="Grow In" image_2_box_shadow="x_large_depth" image_3_offset_x_sign="+" image_3_offset_x="0%" image_3_offset_y_sign="+" image_3_offset_y="0%" image_3_rotate_sign="+" image_3_rotate="none" image_3_animation="Fade In" image_3_box_shadow="none" image_4_offset_x_sign="+" image_4_offset_x="0%" image_4_offset_y_sign="+" image_4_offset_y="0%" image_4_rotate_sign="+" image_4_rotate="none" image_4_animation="Fade In" image_4_box_shadow="none"][/vc_column][vc_column column_padding="padding-2-percent" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/4" tablet_text_alignment="center" phone_text_alignment="center" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in" column_padding="padding-3-percent" column_padding_position="left-right" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid" delay="200"][nectar_icon icon_family="linea" enable_animation="true" animation_speed="fast" icon_style="default" icon_color="white" icon_padding="10px" icon_linea="icon-basic-globe" animation_delay="200" icon_size="64"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" bottom_padding="35" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-3-percent" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid" delay="400"][vc_column_text css=".vc_custom_1469466163499{margin-bottom: 10px !important;}"]
<h5>Available Globally</h5>
[/vc_column_text][vc_column_text max_width="225"]Salient App is now out for download everywhere.[/vc_column_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in" column_padding="padding-3-percent" column_padding_position="left-right" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid" delay="700"][nectar_icon icon_family="linea" enable_animation="true" animation_speed="fast" icon_style="default" icon_color="white" icon_padding="10px" icon_linea="icon-basic-picture-multiple" animation_delay="700" icon_size="64"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-3-percent" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid" delay="900"][vc_column_text css=".vc_custom_1469303109495{margin-bottom: 10px !important;}"]
<h5>Media Storage</h5>
[/vc_column_text][vc_column_text max_width="225"]Get 10gb storage on our servers with a free account.[/vc_column_text][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/12" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" offset="vc_hidden-sm vc_hidden-xs"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Clean Company Intro', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['about'] .', '. $cat_display_names['services'];
$data['custom_class'] = 'about services date-04-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/interesting-text.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_color="#ffffff" scene_position="center" text_color="dark" text_align="left" top_padding="5%" bottom_padding="5%" overlay_strength="0.3"][vc_column column_padding="padding-2-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" width="1/2" tablet_text_alignment="default" phone_text_alignment="default"][split_line_heading animation_type="default"]
<h2 style="color: #1e83ec;"><span style="color: #1e83ec;">Design is the paradise</span></h2>
<h2 style="color: #1e83ec;"><span style="color: #1e83ec;">of individuality, eccentricity,</span></h2>
<h2 style="color: #1e83ec;"><span style="color: #1e83ec;">abnormality, and humors.</span></h2>
[/split_line_heading][vc_row_inner top_padding="15" bottom_padding="25" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1"][vc_column_text]We're Salient, a creative agency located in the heart of New York city. We pride ourselves on developing unique and professional solutions with a wide variety of mediums. Take a look around and don't be shy.[/vc_column_text][/vc_column_inner][/vc_row_inner][vc_row_inner text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1"][vc_column_text]
<h6 style="color: #1e83ec;">What we can help you achieve</h6>
<span style="color: rgba(0,0,0,0.45);">Personal or corporate branding | SEO optimization | Web &amp; UI Design | Standing out in the crowd</span>[/vc_column_text][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="padding-2-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" width="1/4" tablet_text_alignment="default" phone_text_alignment="default"][vc_column_text css=".vc_custom_1452014618584{margin-bottom: 18px !important;}"]
<h5>Target Audience</h5>
[/vc_column_text][fancy-ul icon_type="standard_dash" color="Extra-Color-3" enable_animation="true"]
<ul>
	<li><span style="color: #999999;">Medium Businesses</span></li>
	<li><span style="color: #999999;">Freelance Designers</span></li>
	<li><span style="color: #999999;">College Students</span></li>
	<li><span style="color: #999999;">Sorta Athletes</span></li>
	<li><span style="color: #999999;">Dairy Farmers</span></li>
</ul>
[/fancy-ul][divider line_type="No Line" custom_height="20"][vc_column_text css=".vc_custom_1452014599720{margin-bottom: 18px !important;}"]
<h5>Our Specialties</h5>
[/vc_column_text][fancy-ul icon_type="standard_dash" color="Extra-Color-3" enable_animation="true"]
<ul>
	<li><span style="color: #999999;">Program Management</span></li>
	<li><span style="color: #999999;">Graphic &amp; UI Design</span></li>
	<li><span style="color: #999999;">Customer Support</span></li>
	<li><span style="color: #999999;">Video Editing</span></li>
	<li><span style="color: #999999;">Sound Design</span></li>
</ul>
[/fancy-ul][/vc_column][vc_column column_padding="padding-2-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" width="1/4" tablet_text_alignment="default" phone_text_alignment="default"][vc_column_text css=".vc_custom_1452014465975{margin-bottom: 18px !important;}"]
<h5>Notable Awards</h5>
[/vc_column_text][fancy-ul icon_type="standard_dash" color="Extra-Color-3" enable_animation="true"]
<ul>
	<li><span style="color: #999999;">Top Customer Support</span></li>
	<li><span style="color: #999999;">Most Liked Company</span></li>
	<li><span style="color: #999999;">Best In Class 2016</span></li>
	<li><span style="color: #999999;">Friendliest Group</span></li>
	<li><span style="color: #999999;">Innovative Brand</span></li>
</ul>
[/fancy-ul][divider line_type="No Line" custom_height="20"][vc_column_text css=".vc_custom_1452014481555{margin-bottom: 18px !important;}"]
<h5>Featured On</h5>
[/vc_column_text][fancy-ul icon_type="standard_dash" color="Extra-Color-3" enable_animation="true"]
<ul>
	<li><span style="color: #999999;">ThemeNectar Show</span></li>
	<li><span style="color: #999999;">Mr. Nectar's Blog</span></li>
	<li><span style="color: #999999;">Top WP Themes</span></li>
	<li><span style="color: #999999;">ThemeForest</span></li>
	<li><span style="color: #999999;">Salient</span></li>
</ul>
[/fancy-ul][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Feelgood Image & Text Blocks', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-06-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/image-text.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" equal_height="yes" content_placement="middle" scene_position="center" text_color="dark" text_align="left" top_padding="8%" bottom_padding="8%" overlay_strength="0.3"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" offset="vc_col-xs-12"][image_with_animation image_url="https://themenectar.com/img/demo-media/unsplash/webp/800-500-adventure.webp" alignment="" animation="Grow In" box_shadow="large_depth" max_width="100%"][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/12" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" offset="vc_col-xs-12"][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="5/12" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" offset="vc_col-xs-12"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid"][vc_custom_heading text=" it's easy to feel the charm of existence in this spot." font_container="tag:h3|text_align:left|color:rgba(0%2C0%2C0%2C0.75)" use_theme_fonts="yes" css_animation="none"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid" delay="50"][vc_column_text css_animation="none" css=".vc_custom_1487084437567{margin-top: 20px !important;margin-bottom: 5px !important;}"]
<h5>Salient Powered</h5>
[/vc_column_text][vc_custom_heading text="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, they live." font_container="tag:p|text_align:left|color:rgba(10%2C10%2C10%2C0.75)" use_theme_fonts="yes" css_animation="none"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid" delay="100"][vc_column_text css_animation="none" css=".vc_custom_1487084385405{margin-top: 20px !important;margin-bottom: 5px !important;}"]
<h5>Exceptional Quality</h5>
[/vc_column_text][vc_custom_heading text="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, they live." font_container="tag:p|text_align:left|color:rgba(10%2C10%2C10%2C0.75)" use_theme_fonts="yes" css_animation="none"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Image Background Dual CTA', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'] .', '. $cat_display_names['cta'];
$data['custom_class'] = 'general cta date-07-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/cta-imgs.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" equal_height="yes" content_placement="middle" scene_position="center" text_color="light" text_align="left" overlay_strength="0.3"][vc_column enable_animation="true" animation="grow-in" centered_text="true" column_padding="padding-8-percent" column_padding_position="all" background_color="#2d2d2d" background_color_opacity="0.4" background_hover_color_opacity="0.4" background_image="https://themenectar.com/img/demo-media/unsplash/webp/800-500-adventure.webp" enable_bg_scale="true" column_shadow="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][divider line_type="No Line" custom_height="100"][vc_custom_heading text="Heavily Awarded" font_container="tag:h5|text_align:center|color:rgba(255%2C255%2C255%2C0.7)" use_theme_fonts="yes"][vc_custom_heading text="We do great work" font_container="tag:h3|text_align:center" use_theme_fonts="yes"][nectar_btn size="large" button_style="see-through-2" hover_text_color_override="#ffffff" icon_family="none" url="#" text="See our portfolio" margin_top="25"][divider line_type="No Line" custom_height="100"][/vc_column][vc_column enable_animation="true" animation="grow-in" centered_text="true" column_padding="padding-8-percent" column_padding_position="all" background_color="#2d2d2d" background_color_opacity="0.5" background_hover_color_opacity="0.5" background_image="https://themenectar.com/img/demo-media/unsplash/webp/700-700-earphones.webp" enable_bg_scale="true" column_shadow="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" delay="150"][divider line_type="No Line" custom_height="100"][vc_custom_heading text="We care about skill" font_container="tag:h5|text_align:center|color:rgba(255%2C255%2C255%2C0.7)" use_theme_fonts="yes"][vc_custom_heading text="Great minds work here" font_container="tag:h3|text_align:center" use_theme_fonts="yes"][nectar_btn size="large" button_style="see-through-2" hover_text_color_override="#ffffff" icon_family="none" url="#" text="Meet The Team" margin_top="25"][divider line_type="No Line" custom_height="100"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Company Values & Quote Section', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['testimonials']  .', '. $cat_display_names['hero_section'];
$data['custom_class'] = 'hero_section testimonials date-17-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/header-overlapping-quote.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" equal_height="yes" content_placement="middle" scene_position="center" text_color="dark" text_align="left" overlay_strength="0.3" shape_divider_position="bottom" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" top_margin="-3%" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" translate_y="13%" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-left" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/1" column_border_width="none" column_border_style="solid"][image_with_animation image_url="https://themenectar.com/img/demo-media/unsplash/webp/800-500-adventure.webp" alignment="" animation="None" border_radius="10px" box_shadow="x_large_depth" max_width="100%"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="padding-4-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" top_margin="4%" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/1" column_border_width="none" column_border_style="solid"][vc_custom_heading text="Read this first" font_container="tag:h5|text_align:left|color:%237a7a7a" use_theme_fonts="yes" css=".vc_custom_1504390675021{margin-top: 65px !important;margin-bottom: 10px !important;}"][vc_custom_heading text="Company Values" font_container="tag:h2|font_size:40|text_align:left|line_height:50px" use_theme_fonts="yes" css=".vc_custom_1504033815057{margin-bottom: 30px !important;}"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-2-percent" column_padding_position="right" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/2" column_border_width="none" column_border_style="solid" offset="vc_col-xs-4"][vc_column_text css_animation="none" css=".vc_custom_1504394228032{margin-top: 20px !important;margin-bottom: 5px !important;}"]
<h4>Honest</h4>
[/vc_column_text][vc_custom_heading text="Lorem ipsum dolor sit amet, onecis et mollis." font_container="tag:p|text_align:left|color:rgba(10%2C10%2C10%2C0.75)" use_theme_fonts="yes" css_animation="none"][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-2-percent" column_padding_position="right" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/2" column_border_width="none" column_border_style="solid" offset="vc_col-xs-8" delay="50"][vc_column_text css_animation="none" css=".vc_custom_1504394232676{margin-top: 20px !important;margin-bottom: 5px !important;}"]
<h4>Efficient</h4>
[/vc_column_text][vc_custom_heading text="Lorem ipsum dolor sit amet, onecis et mollis." font_container="tag:p|text_align:left|color:rgba(10%2C10%2C10%2C0.75)" use_theme_fonts="yes" css_animation="none"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" bottom_padding="30" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-2-percent" column_padding_position="right" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/2" column_border_width="none" column_border_style="solid" delay="100"][vc_column_text css_animation="none" css=".vc_custom_1504394236447{margin-top: 20px !important;margin-bottom: 5px !important;}"]
<h4>Helpful</h4>
[/vc_column_text][vc_custom_heading text="Lorem ipsum dolor sit amet, onecis et mollis." font_container="tag:p|text_align:left|color:rgba(10%2C10%2C10%2C0.75)" use_theme_fonts="yes" css_animation="none"][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-2-percent" column_padding_position="right" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/2" column_border_width="none" column_border_style="solid" delay="150"][vc_column_text css_animation="none" css=".vc_custom_1504394240503{margin-top: 20px !important;margin-bottom: 5px !important;}"]
<h4>Quality</h4>
[/vc_column_text][vc_custom_heading text="Lorem ipsum dolor sit amet, onecis et mollis." font_container="tag:p|text_align:left|color:rgba(10%2C10%2C10%2C0.75)" use_theme_fonts="yes" css_animation="none"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" bottom_padding="15" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/1" column_border_width="none" column_border_style="solid" delay="200"][nectar_cta btn_style="material" heading_tag="h4" text_color="#ff1053" link_type="regular" alignment="left" link_text="Why we're different" url="#"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row][vc_row type="full_width_background" full_screen_row_position="middle" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-clouds.webp" bg_position="center center" bg_repeat="no-repeat" bg_color="#272729" scene_position="center" text_color="light" text_align="left" top_padding="15%" bottom_padding="8%" color_overlay="rgba(28,28,30,0.93)" overlay_strength="0.95" shape_divider_position="bottom" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="2/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left" css=".vc_custom_1504394107673{margin-bottom: 0px !important;}"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/1" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1504392885908{margin-bottom: 20px !important;}"]
<h4>Words to live by</h4>
[/vc_column_text][/vc_column_inner][/vc_row_inner][split_line_heading animation_type="default"]
<h2>Kind words creates confidence.</h2>
<h2>Kind thinking creates profoundness.</h2>
<h2>Kind giving creates love.</h2>
[/split_line_heading][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][/vc_row]

CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Overflowing Team Members & Text Snippet', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['team'];
$data['custom_class'] = 'team date-17-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/about-carousel-fixed-content.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" scene_position="center" text_color="dark" text_align="left" top_padding="5%" bottom_padding="13%" id="team" overlay_strength="0.3" shape_divider_position="bottom" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][carousel script="flickity" flickity_formatting="fixed_text_content_fullwidth" flickity_fixed_content="
<h5>Our Mugshots</h5>
<h3>Say hello to your potential team, each a master of their respective craft.</h3>
" button_color="Accent-Color" desktop_cols_flickity="3" desktop_small_cols_flickity="2" tablet_cols_flickity="1" column_padding="0" border_radius="10px"][item id="1504038676473-46596-9e8f" title="Item" tab_id="1508882258172-9"][team_member image_url="https://themenectar.com/img/demo-media/unsplash/webp/team-member-1-small-cropped.webp" bio_image_url="https://themenectar.com/img/demo-media/unsplash/webp/team-member-full-silhouette.webp" team_memeber_style="bio_fullscreen" name="Ethan Young" job_position="Team Leader" team_member_bio="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean. A small river named Duden flows by their place and supplies it with the necessary regelialia. It is a paradisematic country, in which roasted parts of sentences fly into your mouth. " social_icon_1="fa fa-facebook" social_link_1="#" social_icon_2="fa fa-instagram" social_link_2="#" social_icon_3="fa fa-linkedin" social_link_3="#"][/item][item id="1504038676473-46596-56gj" title="Item" tab_id="1508882258184-4"][team_member image_url="https://themenectar.com/img/demo-media/unsplash/webp/team-member-2-small-cropped.webp" bio_image_url="https://themenectar.com/img/demo-media/unsplash/webp/team-member-full-silhouette.webp" team_memeber_style="bio_fullscreen" name="Ava Morgan" job_position="The SEO Expert" team_member_bio="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean. A small river named Duden flows by their place and supplies it with the necessary regelialia. It is a paradisematic country, in which roasted parts of sentences fly into your mouth. " social_icon_1="fa fa-instagram" social_link_1="#" social_icon_2="fa fa-twitter" social_link_2="#"][/item][item id="1504038676738-86596-mh3d" title="Item" tab_id="1508882258210-7"][team_member image_url="https://themenectar.com/img/demo-media/unsplash/webp/team-member-3-small-cropped.webp" bio_image_url="https://themenectar.com/img/demo-media/unsplash/webp/team-member-full-silhouette.webp" team_memeber_style="bio_fullscreen" name="James Anderson" job_position="Front-end Developer" team_member_bio="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean. A small river named Duden flows by their place and supplies it with the necessary regelialia. It is a paradisematic country, in which roasted parts of sentences fly into your mouth. " social_icon_1="fa fa-twitter" social_link_1="#" social_icon_2="fa fa-youtube-play" social_link_2="#"][/item][item id="1504038677047-76596-33hf" title="Item" tab_id="1508882258235-10"][team_member image_url="https://themenectar.com/img/demo-media/unsplash/webp/team-member-4-small-cropped.webp" bio_image_url="https://themenectar.com/img/demo-media/unsplash/webp/team-member-full-silhouette.webp" team_memeber_style="bio_fullscreen" name="Mark Jones" job_position="Back-end Developer" team_member_bio="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean. A small river named Duden flows by their place and supplies it with the necessary regelialia. It is a paradisematic country, in which roasted parts of sentences fly into your mouth. " social_icon_1="fa fa-github-alt" social_icon_2="fa fa-instagram" social_icon_3="fa fa-facebook"][/item][/carousel][/vc_column][/vc_row]

CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Team About Us Blurb', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['about'];
$data['custom_class'] = 'about date-17-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/about-us-row.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-art.webp" bg_position="center center" bg_repeat="no-repeat" parallax_bg="true" parallax_bg_speed="fast" bg_color="#ffffff" scene_position="center" text_color="light" text_align="left" top_padding="14%" bottom_padding="12%" enable_gradient="true" color_overlay="#0a0000" color_overlay_2="rgba(10,10,10,0.5)" gradient_direction="left_to_right" overlay_strength="0.5" shape_divider_color="#ffffff" shape_divider_position="bottom" shape_divider_height="350" shape_type="waves_opacity_alt"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner equal_height="yes" content_placement="middle" column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/2" column_border_width="none" column_border_style="solid" offset="vc_col-lg-6 vc_col-md-6 vc_col-xs-12"][vc_column_text css_animation="fadeInUp" css=".vc_custom_1504392866047{margin-bottom: 15px !important;}"]
<h5>Fun and freedom</h5>
[/vc_column_text][split_line_heading animation_type="default"]
<h2>We put emphasis on having</h2>
<h2>a creative work environment</h2>
[/split_line_heading][nectar_btn size="large" button_style="regular" button_color_2="Extra-Color-1" icon_family="default_arrow" url="#team" text="Meet the team" margin_top="25" css_animation="slideInUp"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/4" column_border_width="none" column_border_style="solid" offset="vc_hidden-sm vc_hidden-xs"][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-6-percent" column_padding_position="bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/4" column_border_width="none" column_border_style="solid" offset="vc_col-xs-12"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]

CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Fancy Box Hover Color Effect', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['services'];
$data['custom_class'] = 'services date-17-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/fancy-box-hover-color.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_color="#f7f7f7" scene_position="center" text_color="dark" text_align="left" top_padding="7%" bottom_padding="2%" overlay_strength="0.3" shape_divider_position="bottom" shape_type=""][vc_column enable_animation="true" animation="grow-in" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][fancy_box box_style="color_box_hover" icon_family="iconsmind" color="Accent-Color" box_alignment="left" icon_iconsmind="iconsmind-Split-FourSquareWindow" min_height="200"]
<h4>Massive Element Library</h4>
Aenean massa. Cum sociis natoque penatibus et magnis dis aenean.[/fancy_box][/vc_column][vc_column enable_animation="true" animation="grow-in" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" delay="100"][fancy_box box_style="color_box_hover" icon_family="iconsmind" color="Accent-Color" box_alignment="left" icon_iconsmind="iconsmind-Book" min_height="200"]
<h4>Great Documentation</h4>
Aenean massa. Cum sociis natoque penatibus et magnis dis aenean.[/fancy_box][/vc_column][vc_column enable_animation="true" animation="grow-in" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" delay="200"][fancy_box box_style="color_box_hover" icon_family="iconsmind" color="Accent-Color" box_alignment="left" icon_iconsmind="iconsmind-Paint-Bucket" min_height="200"]
<h4>Killer Design Work</h4>
Aenean massa. Cum sociis natoque penatibus et magnis dis aenean.[/fancy_box][/vc_column][/vc_row][vc_row type="full_width_background" full_screen_row_position="middle" bg_color="#f7f7f7" scene_position="center" text_color="dark" text_align="left" bottom_padding="7%" overlay_strength="0.3" shape_divider_position="bottom" shape_type=""][vc_column enable_animation="true" animation="grow-in" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][fancy_box box_style="color_box_hover" icon_family="iconsmind" color="Accent-Color" box_alignment="left" icon_iconsmind="iconsmind-Scooter" min_height="200"]
<h4>Attention Grabbing Looks</h4>
Aenean massa. Cum sociis natoque penatibus et magnis dis aenean.[/fancy_box][/vc_column][vc_column enable_animation="true" animation="grow-in" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" delay="100"][fancy_box box_style="color_box_hover" icon_family="iconsmind" color="Accent-Color" box_alignment="left" icon_iconsmind="iconsmind-Love2" min_height="200"]
<h4>Saves Precious Time</h4>
Aenean massa. Cum sociis natoque penatibus et magnis dis aenean.[/fancy_box][/vc_column][vc_column enable_animation="true" animation="grow-in" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" delay="200"][fancy_box box_style="color_box_hover" icon_family="iconsmind" color="Accent-Color" box_alignment="left" icon_iconsmind="iconsmind-D-Eyeglasses" min_height="200"]
<h4>Visual Page Builder</h4>
Aenean massa. Cum sociis natoque penatibus et magnis dis aenean.[/fancy_box][/vc_column][/vc_row]

CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'Two Rounded Color Boxes Over Shape Divider', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['cta'];
$data['custom_class'] = 'cta date-17-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/dual-color-boxes.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_color="#f2f2f2" scene_position="center" text_color="light" text_align="left" top_padding="2%" overlay_strength="0.3" enable_shape_divider="true" shape_divider_color="#ffffff" shape_divider_position="top" shape_divider_height="80" shape_type="curve"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" translate_y="-50%"][vc_row_inner column_margin="default" translate_y="-100" text_align="left"][vc_column_inner column_padding="padding-6-percent" column_padding_position="all" centered_text="true" background_color="#ff1053" background_color_opacity="1" background_hover_color_opacity="1" font_color="#ffffff" column_shadow="medium_depth" column_border_radius="15px" width="1/2" column_border_width="none" column_border_style="solid"][vc_custom_heading text="Don't forget we blog too!" font_container="tag:h3|text_align:center" use_theme_fonts="yes"][nectar_btn size="large" button_style="see-through-2" color_override="#ffffff" hover_color_override="#ffffff" hover_text_color_override="#000000" icon_family="none" url="#" text="Read our posts" margin_top="30" margin_bottom="1"][/vc_column_inner][vc_column_inner column_padding="padding-6-percent" column_padding_position="all" centered_text="true" background_color="#3452ff" background_color_opacity="1" background_hover_color_opacity="1" font_color="#ffffff" column_shadow="medium_depth" column_border_radius="10px" width="1/2" column_border_width="none" column_border_style="solid"][vc_custom_heading text="Ready to have a conversation? " font_container="tag:h3|text_align:center" use_theme_fonts="yes"][nectar_btn size="large" button_style="see-through-2" color_override="#ffffff" hover_color_override="#ffffff" hover_text_color_override="#000000" icon_family="none" url="#" text="Contact Us" margin_top="30" margin_bottom="1"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]

CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'Creative Header With Shape Divider', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['hero_section'];
$data['custom_class'] = 'hero_section date-19-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/creative-header.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-building-business.webp" bg_position="left top" bg_repeat="no-repeat" parallax_bg="true" parallax_bg_speed="fast" bg_color="#ff0059" scene_position="center" text_color="light" text_align="left" top_padding="13%" bottom_padding="19%" enable_gradient="true" color_overlay="rgba(255,0,89,0.94)" color_overlay_2="rgba(255,50,0,0.71)" gradient_direction="left_t_to_right_b" overlay_strength="0.95" enable_shape_divider="true" shape_divider_position="bottom" shape_divider_height="350" shape_type="waves_opacity_alt"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][split_line_heading animation_type="default"]
<h1>WordPress Design</h1>
<h1>as it should be</h1>
[/split_line_heading][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="3/4" column_border_width="none" column_border_style="solid" delay="200"][vc_custom_heading text="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts The Big Oxmox advised her." font_container="tag:h4|font_size:20|text_align:left|color:rgba(255%2C255%2C255%2C0.7)|line_height:36px" google_fonts="font_family:Roboto%3A100%2C100italic%2C300%2C300italic%2Cregular%2Citalic%2C500%2C500italic%2C700%2C700italic%2C900%2C900italic|font_style:500%20bold%20regular%3A500%3Anormal"][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/4" column_border_width="none" column_border_style="solid" delay="300"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/1" column_border_width="none" column_border_style="solid" delay="400"][nectar_btn size="jumbo" button_style="see-through-2" color_override="#ffffff" hover_color_override="#ffffff" hover_text_color_override="#000000" icon_family="none" url="#discover" text="Discover More" margin_top="30"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][/vc_row]

CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'Clever Overlapping Quote', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['testimonials'];
$data['custom_class'] = 'testimonials date-19-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/overlapping-quote.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" equal_height="yes" content_placement="middle" bg_color="#ffffff" scene_position="center" text_color="dark" text_align="left" top_padding="10%" bottom_padding="10%" id="discover" overlay_strength="0.3" shape_divider_position="bottom" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="2/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left" css=".vc_custom_1504128844236{margin-right: -1px !important;}"][vc_column_inner enable_animation="true" animation="fade-in-from-left" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/1" column_border_width="none" column_border_style="solid"][nectar_single_testimonial testimonial_style="bold" color="Extra-Color-1" style="bold" quote="A wonderful serenity has taken possession of my entire soul, like these sweet mornings of spring." name="Mr. ThemeNectar" subtitle="Pro Acrobat"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][image_with_animation image_url="https://themenectar.com/img/demo-media/unsplash/webp/large-clouds.webp" alignment="right" animation="Grow In" border_radius="none" box_shadow="none" max_width="175%"][/vc_column][/vc_row]

CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'Fancy Box Fullwidth Parallax', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['general'] .', '. $cat_display_names['services'];
$data['custom_class'] = 'general services date-19-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/parallax-fancy-box.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" scene_position="center" text_color="dark" text_align="left" top_padding="5%" overlay_strength="0.3" shape_divider_position="bottom" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/4" column_border_width="none" column_border_style="solid"][fancy_box box_style="parallax_hover" icon_family="iconsmind" image_url="https://themenectar.com/img/demo-media/unsplash/webp/800-500-bike.webp" color_scheme="dark" secondary_content="here's some awesome text that would only be shown on hover" icon_iconsmind="iconsmind-Snow" min_height="600"]
<h2>Exclusive Design</h2>
<h5>Lorem Ipsum</h5>
[/fancy_box][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/4" column_border_width="none" column_border_style="solid"][fancy_box box_style="parallax_hover" icon_family="iconsmind" image_url="https://themenectar.com/img/demo-media/unsplash/webp/800-500-room.webp" color_scheme="dark" secondary_content="" icon_iconsmind="iconsmind-Drag-Down" min_height="600"]
<h2>Visual Builder</h2>
<h5>Lorem Ipsum</h5>
[/fancy_box][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/4" column_border_width="none" column_border_style="solid"][fancy_box box_style="parallax_hover" icon_family="iconsmind" image_url="https://themenectar.com/img/demo-media/unsplash/webp/800-500-watch.webp" color_scheme="dark" secondary_content="here's some awesome text that would only be shown on hover" link_url="#" icon_iconsmind="iconsmind-Crown-2" min_height="600"]
<h2>Powerful Tools</h2>
<h5>Lorem Ipsum</h5>
[/fancy_box][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/4" column_border_width="none" column_border_style="solid"][fancy_box box_style="parallax_hover" icon_family="iconsmind" image_url="https://themenectar.com/img/demo-media/unsplash/webp/800-550-city.webp" color_scheme="dark" secondary_content="here's some awesome text that would only be shown on hover" link_url="#" icon_iconsmind="iconsmind-Snow" min_height="600"]
<h2>Quick Importer</h2>
<h5>Lorem Ipsum</h5>
[/fancy_box][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]

CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'Gradient Header And Text', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['general'];
$data['custom_class'] = 'general date-19-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/gradient-header-and-text.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_color="#ffffff" scene_position="center" text_color="dark" text_align="left" top_padding="10%" bottom_padding="10%" overlay_strength="1" shape_divider_position="bottom"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/2" column_border_width="none" column_border_style="solid"][nectar_gradient_text heading_tag="h2" color="extra-color-gradient-2" gradient_direction="diagonal" text="If you wish to make an apple pie from scratch, you must first invent the universe."][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/2" column_border_width="none" column_border_style="solid"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="padding-3-percent" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/2" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1504205183336{padding-right: 10% !important;}"]Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean.[/vc_column_text][/vc_column_inner][vc_column_inner column_padding="padding-3-percent" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/2" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1504205188668{padding-right: 10% !important;}"]Even the all-powerful Pointing has no control about the blind texts it is an almost unorthographic life One day however a small line of blind text by the name of Lorem Ipsum decided to leave for the far World of Grammar.[/vc_column_text][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]

CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Fancy Box Color Hover Gradient', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['general']  .', '. $cat_display_names['services'];
$data['custom_class'] = 'general services date-19-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/gradient-fancy-box-color-hover.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" scene_position="center" text_color="dark" text_align="left" top_padding="8%" bottom_padding="8%" overlay_strength="0.3" shape_divider_position="bottom" shape_type=""][vc_column column_padding="padding-2-percent" column_padding_position="right" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1504200789745{padding-top: 10% !important;}"]
<h2>An exceptionally unique experience tailored to you</h2>
[/vc_column_text][nectar_btn size="large" button_style="see-through" button_color_2="extra-color-gradient-2" icon_family="default_arrow" url="#" text="Learn More" margin_top="15"][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="2/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left" css=".vc_custom_1504187365562{margin-bottom: 2% !important;}"][vc_column_inner column_padding="padding-1-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/2" column_border_width="none" column_border_style="solid"][fancy_box box_style="color_box_hover" icon_family="iconsmind" color="extra-color-gradient-2" box_alignment="left" icon_iconsmind="iconsmind-Yacht" min_height="200"]
<h3>Fast Turnaround</h3>
I throw myself down among the tall grass by the stream as I lie close to the earth.[/fancy_box][/vc_column_inner][vc_column_inner column_padding="padding-1-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/2" column_border_width="none" column_border_style="solid"][fancy_box box_style="color_box_hover" icon_family="iconsmind" color="extra-color-gradient-2" box_alignment="left" icon_iconsmind="iconsmind-Butterfly" min_height="200"]
<h3>Elegant Design</h3>
And the meridian sun strikes the upper surface of the impenetrable foliage.[/fancy_box][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="padding-1-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/2" column_border_width="none" column_border_style="solid"][fancy_box box_style="color_box_hover" icon_family="iconsmind" color="extra-color-gradient-2" box_alignment="left" icon_iconsmind="iconsmind-Cool-Guy" min_height="200"]
<h3>Super Fresh</h3>
I am so happy, my dear friend, so absorbed in the exquisite sense of mere tranquil existence.[/fancy_box][/vc_column_inner][vc_column_inner column_padding="padding-1-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/2" column_border_width="none" column_border_style="solid"][fancy_box box_style="color_box_hover" icon_family="iconsmind" color="extra-color-gradient-2" box_alignment="left" icon_iconsmind="iconsmind-Trophy" min_height="200"]
<h3>Award Winning</h3>
As I lie close to the earth, a thousand unknown plants are noticed by me.[/fancy_box][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]

CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Row of Featured Posts', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['blog'];
$data['custom_class'] = 'blog date-19-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/recent-blog-featured-3.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" scene_position="center" text_color="dark" text_align="left" top_padding="8%" bottom_padding="6%" overlay_strength="0.3" shape_divider_position="bottom" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" bottom_padding="50" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/1" column_border_width="none" column_border_style="solid"][vc_column_text]
<h3>Our Recent Writings</h3>
[/vc_column_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" bottom_padding="0" text_align="left" css=".vc_custom_1504236091614{margin-bottom: 0px !important;}"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/1" column_border_width="none" column_border_style="solid"][recent_posts style="list_featured_first_row" category="all" columns="3" order="DESC" orderby="date" posts_per_page="3"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/1" column_border_width="none" column_border_style="solid"][nectar_btn size="large" button_style="see-through" button_color_2="extra-color-gradient-2" icon_family="default_arrow" url="#" text="See Full Blog" margin_top="15" css_animation="none"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]

CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Posts Slider Right Nav', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['blog'];
$data['custom_class'] = 'blog date-18-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/recent-posts-slider-right-nav.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" scene_position="center" text_color="dark" text_align="left" overlay_strength="0.3" shape_divider_position="bottom" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][recent_posts style="multiple_large_featured" category="all" multiple_large_featured_num="3" auto_rotate="8000" large_featured_padding="14%" mlf_navigation_location="side" button_color="Accent-Color" bg_overlay="solid_color" order="DESC" orderby="date"][/vc_column][/vc_row]

CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Overlapping Posts Slider & Masonry Blog', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['blog'];
$data['custom_class'] = 'blog date-18-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/recent-posts-slider-masonry-overlap.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" scene_position="center" text_color="dark" text_align="left" overlay_strength="0.3" shape_divider_position="bottom" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][recent_posts style="multiple_large_featured" category="all" multiple_large_featured_num="3" auto_rotate="8000" large_featured_padding="14%" mlf_navigation_location="side" button_color="Accent-Color" bg_overlay="solid_color" order="DESC" orderby="date"][/vc_column][/vc_row][vc_row type="in_container" full_screen_row_position="middle" scene_position="center" text_color="dark" text_align="left" overlay_strength="0.3" shape_divider_position="bottom"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" top_margin="-5%" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][nectar_blog layout="masonry-blog-fullwidth" blog_masonry_style="material" category="all" load_in_animation="perspective" order="DESC" orderby="date" posts_per_page="6" post_offset="3"][/vc_column][/vc_row]

CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Sticky Sidebar & Left Featured Image Posts', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['blog'];
$data['custom_class'] = 'blog date-18-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/fixed-sidebar-featured-left.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="in_container" full_screen_row_position="middle" scene_position="center" text_color="dark" text_align="left" overlay_strength="0.3" shape_divider_position="bottom" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][nectar_blog layout="std-blog-sidebar" blog_standard_style="featured_img_left" category="all" enable_ss="true" load_in_animation="none" order="DESC" orderby="date" posts_per_page="4" post_offset="0"][/vc_column][/vc_row]

CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Multiple Visible Recent Post Slider', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['blog'];
$data['custom_class'] = 'blog date-18-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/recent-posts-multple-vis.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" scene_position="center" text_color="dark" text_align="left" overlay_strength="0.3" shape_divider_position="bottom" top_padding="3%" bottom_padding="3%" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1506507046942{margin-top: 60px !important;margin-bottom: 60px !important;}"]<h2 style="text-align: center;">Recent Posts</h2>[/vc_column_text][recent_posts style="slider_multiple_visible" category="all" columns="3" button_color="Accent-Color" order="DESC" orderby="date" posts_per_page="6"][/vc_column][/vc_row]

CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Random Posts Featured Top Row', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['blog'];
$data['custom_class'] = 'blog date-18-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/recent-posts-featured-top-row.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" scene_position="center" text_color="dark" text_align="left" top_padding="5%" bottom_padding="5%" overlay_strength="0.3" shape_divider_position="bottom" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1505076927694{margin-top: 20px !important;margin-bottom: 60px !important;}"]
<h2 style="text-align: center;">An Assorted Pick</h2>
[/vc_column_text][recent_posts style="list_featured_first_row" category="all" columns="3" order="ASC" orderby="rand" posts_per_page="9"][/vc_column][/vc_row]

CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Cool Dark Auto Masonry Blog & Featured Top Post', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['blog'];
$data['custom_class'] = 'blog date-08-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/auto-masonry-blog-overlap-featured.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" scene_position="center" text_color="dark" text_align="left" overlay_strength="0.3" shape_divider_position="bottom" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][recent_posts style="single_large_featured" category="all" large_featured_padding="12%" button_color="extra-color-gradient-2" bg_overlay="diagonal_gradient" order="DESC" orderby="date"][/vc_column][/vc_row][vc_row type="full_width_background" full_screen_row_position="middle" bg_color="#0a0a0a" scene_position="center" text_color="dark" text_align="left" overlay_strength="0.3" shape_divider_position="bottom" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" top_margin="-5%" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][nectar_blog layout="masonry-blog-fullwidth" blog_masonry_style="auto_meta_overlaid_spaced" auto_masonry_spacing="4px" category="all" load_in_animation="none" order="DESC" orderby="date" posts_per_page="6" post_offset="1"][/vc_column][/vc_row]

CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Pretty Dark CTA Gradient Button', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['cta'];
$data['custom_class'] = 'cta date-08-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/dark-cta.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" equal_height="yes" content_placement="middle" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-clouds.webp" bg_position="center bottom" bg_repeat="no-repeat" parallax_bg="true" parallax_bg_speed="fast" bg_color="#0a0a0a" scene_position="center" text_color="light" text_align="left" top_padding="15%" bottom_padding="15%" enable_gradient="true" color_overlay="#0a0a0a" color_overlay_2="rgba(17,17,17,0.31)" gradient_direction="top_to_bottom" overlay_strength="1" shape_divider_position="bottom" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/6" column_border_width="none" column_border_style="solid"][/vc_column_inner][vc_column_inner column_padding="padding-2-percent" column_padding_position="left-right" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="2/3" column_border_width="none" column_border_style="solid"][vc_custom_heading text="Let's Start This Party" font_container="tag:h2|font_size:52|text_align:center|line_height:52px" use_theme_fonts="yes" css_animation="fadeInUp"][divider line_type="No Line" custom_height="10"][vc_custom_heading text="Like Nothing You've Seen. Purchase Today &amp; Experience Salient" font_container="tag:p|text_align:center|color:rgba(255%2C255%2C255%2C0.7)" use_theme_fonts="yes" css_animation="fadeInUp" css=".vc_custom_1504487727704{margin-top: 10px !important;margin-bottom: 10px !important;}"][nectar_btn size="jumbo" button_style="regular" button_color_2="extra-color-gradient-2" icon_family="default_arrow" url="https://themeforest.net/item/salient-responsive-multipurpose-theme/4363266" text="Learn More" css_animation="zoomIn"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/6" column_border_width="none" column_border_style="solid"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]

CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Two Recent Posts Dark Background', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['blog'];
$data['custom_class'] = 'blog date-08-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/two-recent-posts-dark.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_color="#0a0a0a" scene_position="center" text_color="light" text_align="left" top_padding="4%" bottom_padding="3%" overlay_strength="0.3" shape_divider_position="bottom" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1504490629058{margin-bottom: 60px !important;}"]
<h2 style="text-align: center;">Latest In Travel Ideas</h2>
[/vc_column_text][recent_posts style="list_featured_first_row" category="all" columns="2" order="DESC" orderby="date" posts_per_page="2" post_offset="0"][/vc_column][/vc_row]

CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Bottom Navigation Recent Post Slider', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['blog'];
$data['custom_class'] = 'blog date-18-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/recent-posts-bottom-nav.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" scene_position="center" text_color="dark" text_align="left" bottom_padding="4%" overlay_strength="0.3" shape_divider_position="bottom" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][recent_posts style="multiple_large_featured" category="all" multiple_large_featured_num="4" auto_rotate="9000" large_featured_padding="14%" mlf_navigation_location="bottom" button_color="extra-color-gradient-1" bg_overlay="solid_color" order="DESC" orderby="date"][/vc_column][/vc_row]

CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Pricing Gradient Boxes', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['pricing'];
$data['custom_class'] = 'pricing date-07-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/pricing-table-gradient.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" scene_position="center" text_color="dark" text_align="left" top_padding="7%" bottom_padding="7%" overlay_strength="0.3" shape_divider_position="bottom" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][fancy_box box_style="color_box_hover" icon_family="none" image_url="https://themenectar.com/img/demo-media/unsplash/webp/large-clouds.webp" color="extra-color-gradient-2" box_alignment="center" min_height="450"]
<h5>Try It Now</h5>
<h2>Basic</h2>
Get a free domain name and custom cookies delivered to your door every month.
<h3>Free</h3>
&nbsp;

[nectar_cta btn_style="see-through" heading_tag="h5" link_type="regular" alignment="center" link_text="Purchase now"][/fancy_box][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][fancy_box box_style="color_box_hover" icon_family="none" image_url="https://themenectar.com/img/demo-media/unsplash/webp/large-fashion.webp" color="extra-color-gradient-2" box_alignment="center" min_height="450"]
<h5>Most Popular</h5>
<h2>Premium</h2>
Get a free domain name and 24/7 customer support &amp; month of free bandwidth.
<h3>$30/mo</h3>
&nbsp;

[nectar_cta btn_style="see-through" heading_tag="h5" link_type="regular" alignment="center" link_text="Purchase now"][/fancy_box][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][fancy_box box_style="color_box_hover" icon_family="none" image_url="https://themenectar.com/img/demo-media/unsplash/webp/large-room.webp" color="extra-color-gradient-2" box_alignment="center" min_height="450"]
<h5>Good Value</h5>
<h2>Ultimate</h2>
Get a free domain name and 24/7 customer support &amp; design consultation &amp; premium support
<h3>$49.99/mo</h3>
&nbsp;

[nectar_cta btn_style="see-through" heading_tag="h5" link_type="regular" alignment="center" link_text="Purchase now"][/fancy_box][/vc_column][/vc_row]

CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Simple Single Quote', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['general']  .', '. $cat_display_names['testimonials'];
$data['custom_class'] = 'general testimonials date-07-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/simple-quote.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="in_container" full_screen_row_position="middle" scene_position="center" text_color="dark" text_align="left" top_padding="50" bottom_padding="50" overlay_strength="0.3" shape_divider_position="bottom" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][nectar_single_testimonial testimonial_style="bold" color="Accent-Color" quote="But nothing the copy said could convince her and so it didn’t take long until a few insidious Copy Writers ambushed her" name="Robert Johnson" subtitle="ThemeNectar"][/vc_column][/vc_row]

CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Material Masonry Blog Posts', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['blog'];
$data['custom_class'] = 'blog date-18-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/material-blog.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" scene_position="center" text_color="dark" text_align="left" top_padding="6%" bottom_padding="6%" overlay_strength="0.3" shape_divider_position="bottom" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][nectar_blog layout="masonry-blog-fullwidth" blog_masonry_style="material" category="all" enable_pagination="true" pagination_type="default" load_in_animation="fade_in_from_bottom" order="DESC" orderby="date" posts_per_page="20"][/vc_column][/vc_row]

CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Posts With Featured Row & Sticky Sidebar', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['blog'];
$data['custom_class'] = 'blog date-18-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/featured-row-recent-posts-sticky-sidebar.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="in_container" full_screen_row_position="middle" scene_position="center" text_color="dark" text_align="left" overlay_strength="0.3" shape_divider_position="bottom" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="right" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="2/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][recent_posts style="list_featured_first_row_tall" category="all" columns="3" order="DESC" orderby="date" posts_per_page="9"][/vc_column][vc_column column_padding="padding-2-percent" column_padding_position="left" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_widget_sidebar enable_sticky="true" sidebar_id="blog-sidebar"][/vc_column][/vc_row]

CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Four Boxes And Text With Dark Image BG ', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['hero_section'];
$data['custom_class'] = 'hero_section date-07-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/four-cols-right.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" equal_height="yes" content_placement="middle" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-art.webp" bg_position="left top" bg_repeat="no-repeat" bg_color="#141414" scene_position="center" text_color="light" text_align="left" top_padding="9%" bottom_padding="8%" color_overlay="#212121" overlay_strength="0.8" shape_divider_position="bottom" shape_type=""][vc_column column_padding="padding-2-percent" column_padding_position="right" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1507069609150{margin-bottom: 5px !important;}"]
<h5>Check This Out</h5>
[/vc_column_text][vc_column_text css=".vc_custom_1507069688019{padding-right: 5% !important;}"]
<h2>Always striving to make the web beautiful</h2>
[/vc_column_text][vc_column_text css=".vc_custom_1507069647653{margin-bottom: 30px !important;padding-right: 10% !important;}" max_width="550"]Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Aenean commodo ligula eget dolor. Aenean massa. Cum sociis natoque penatibus et magnis dis parturient montes.[/vc_column_text][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/1" column_border_width="none" column_border_style="solid"][nectar_btn size="large" button_style="regular" button_color_2="Accent-Color" icon_family="default_arrow" url="#explainer" text="Learn More" margin_top="15"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="none" text_align="left"][vc_column_inner column_padding="padding-2-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/2" column_border_width="none" column_border_style="solid"][fancy_box box_style="color_box_basic" icon_family="iconsmind" box_color="#ffffff" content_color="#3452ff" box_color_opacity="0.6" box_alignment="left" enable_animation="true" animation="fade-in-from-bottom" color_scheme="none" secondary_content="here's some awesome text that would only be shown on hover" min_height="200" link_url="#" icon_iconsmind="iconsmind-Environmental-3" css=".vc_custom_1507069485243{margin-bottom: 1.8em !important;padding-top: 15% !important;padding-right: 15% !important;padding-bottom: 15% !important;padding-left: 15% !important;}" icon_size="40"]
<h4>Natural Flow</h4>
Sed cursus turpis vitae tortor donec eaque ipsa quaeab illo.[/fancy_box][fancy_box box_style="color_box_basic" icon_family="iconsmind" box_color="#ffffff" content_color="#3452ff" box_color_opacity="1" box_alignment="left" enable_animation="true" animation="fade-in-from-bottom" color_scheme="none" secondary_content="here's some awesome text that would only be shown on hover" min_height="200" link_url="" icon_iconsmind="iconsmind-Sun" css=".vc_custom_1507069237522{margin-bottom: 50px !important;padding-top: 15% !important;padding-right: 15% !important;padding-bottom: 15% !important;padding-left: 15% !important;}" icon_size="40"]
<h4>Hot Looks</h4>
Nemo enim ipsam volup tatem quia vol uptas sit sunt in.[/fancy_box][/vc_column_inner][vc_column_inner column_padding="padding-2-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/2" column_border_width="none" column_border_style="solid"][fancy_box box_style="color_box_basic" icon_family="iconsmind" box_color="#ffffff" content_color="#3452ff" box_color_opacity="1" box_alignment="left" enable_animation="true" animation="fade-in-from-bottom" color_scheme="none" secondary_content="here's some awesome text that would only be shown on hover" min_height="200" link_url="" icon_iconsmind="iconsmind-Rock-andRoll" css=".vc_custom_1507069493020{margin-bottom: 1.8em !important;padding-top: 15% !important;padding-right: 15% !important;padding-bottom: 15% !important;padding-left: 15% !important;}" delay="100" icon_size="40"]
<h4>Awesome Design</h4>
Nam libero tempore, cum soluta nobis placeat facere.[/fancy_box][fancy_box box_style="color_box_basic" icon_family="iconsmind" box_color="#ffffff" content_color="#3452ff" box_color_opacity="1" box_alignment="left" enable_animation="true" animation="fade-in-from-bottom" color_scheme="none" secondary_content="here's some awesome text that would only be shown on hover" min_height="200" icon_iconsmind="iconsmind-Atom" delay="100" css=".vc_custom_1507069246915{padding-top: 15% !important;padding-right: 15% !important;padding-bottom: 15% !important;padding-left: 15% !important;}" icon_size="40"]
<h4>Unrivaled Quality</h4>
At vero eos et lorem accusamus et iusto ullam corporis.[/fancy_box][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]

CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Grid Based Testimonials Dark', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['testimonials'];
$data['custom_class'] = 'testimonials date-07-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/separate-testimonials.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" equal_height="yes" content_placement="middle" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-adventure.webp" bg_position="left top" bg_repeat="no-repeat" bg_color="#141414" scene_position="center" text_color="light" text_align="left" top_padding="9%" bottom_padding="8%" color_overlay="#212121" overlay_strength="0.8" shape_divider_position="bottom" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="right" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/1" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1507069609150{margin-bottom: 5px !important;}"]
<h5>Check This Out</h5>
[/vc_column_text][vc_column_text css=".vc_custom_1507070135832{padding-right: 5% !important;}"]
<h2>What They're Saying About Us</h2>
[/vc_column_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" top_padding="3%" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/12" column_border_width="none" column_border_style="solid"][/vc_column_inner][vc_column_inner enable_animation="true" animation="grow-in" column_padding="padding-2-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="5/12" column_border_width="none" column_border_style="solid"][nectar_single_testimonial testimonial_style="basic" image="https://themenectar.com/img/demo-media/unsplash/webp/small-smile-guy.webp" quote="Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vivamus tempus consectetur mi nec hendrerit. Integer id est massa." name="Alley Cohen " subtitle="Designer"][/vc_column_inner][vc_column_inner enable_animation="true" animation="grow-in" column_padding="padding-2-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="5/12" column_border_width="none" column_border_style="solid" delay="150"][nectar_single_testimonial testimonial_style="basic" image="https://themenectar.com/img/demo-media/unsplash/webp/small-smile.webp" quote="Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vivamus tempus consectetur mi nec hendrerit. Integer id est massa." name="Jason Smith" subtitle="Developer "][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/12" column_border_width="none" column_border_style="solid"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" bottom_padding="3%" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/12" column_border_width="none" column_border_style="solid"][/vc_column_inner][vc_column_inner enable_animation="true" animation="grow-in" column_padding="padding-2-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="5/12" column_border_width="none" column_border_style="solid"][nectar_single_testimonial testimonial_style="basic" image="https://themenectar.com/img/demo-media/unsplash/webp/small-smile-guy.webp" quote="Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vivamus tempus consectetur mi nec hendrerit. Integer id est massa." name="Kara Lucas" subtitle="Interior Decorator "][/vc_column_inner][vc_column_inner enable_animation="true" animation="grow-in" column_padding="padding-2-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="5/12" column_border_width="none" column_border_style="solid" delay="150"][nectar_single_testimonial testimonial_style="basic" image="https://themenectar.com/img/demo-media/unsplash/webp/small-smile.webp" quote="Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vivamus tempus consectetur mi nec hendrerit. Integer id est massa." name="Casey Jacobs " subtitle="Cookie Monster"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/12" column_border_width="none" column_border_style="solid"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/1" column_border_width="none" column_border_style="solid"][nectar_btn size="jumbo" button_style="regular" button_color_2="Accent-Color" icon_family="default_arrow" text="See All Testimonials" margin_top="15"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]

CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Dark Pricing Gradient Boxes', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['pricing'];
$data['custom_class'] = 'pricing date-07-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/pricing-table-gradient-dark.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-clouds.webp" bg_position="left top" bg_repeat="no-repeat" scene_position="center" text_color="light" text_align="left" top_padding="7%" bottom_padding="7%" color_overlay="#232323" overlay_strength="0.95" shape_divider_position="bottom" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][fancy_box box_style="color_box_hover" icon_family="none" image_url="https://themenectar.com/img/demo-media/unsplash/webp/large-clouds.webp" color="extra-color-gradient-1" box_alignment="center" min_height="450"]
<h5>Try It Now</h5>
<h2>Basic</h2>
Get a free domain name and custom cookies delivered to your door every month.
<h3>Free</h3>
&nbsp;

[nectar_cta btn_style="see-through" heading_tag="h5" link_type="regular" alignment="center" link_text="Purchase now"][/fancy_box][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][fancy_box box_style="color_box_hover" icon_family="none" image_url="https://themenectar.com/img/demo-media/unsplash/webp/500-500-forest.webp" color="extra-color-gradient-1" box_alignment="center" min_height="450"]
<h5>Most Popular</h5>
<h2>Premium</h2>
Get a free domain name and 24/7 customer support &amp; month of free bandwidth.
<h3>$30/mo</h3>
&nbsp;

[nectar_cta btn_style="see-through" heading_tag="h5" link_type="regular" alignment="center" link_text="Purchase now"][/fancy_box][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][fancy_box box_style="color_box_hover" icon_family="none" image_url="https://themenectar.com/img/demo-media/unsplash/webp/500-500-building.webp" color="extra-color-gradient-1" box_alignment="center" min_height="450"]
<h5>Good Value</h5>
<h2>Ultimate</h2>
Get a free domain name and 24/7 customer support &amp; design consultation &amp; premium support
<h3>$49.99/mo</h3>
&nbsp;

[nectar_cta btn_style="see-through" heading_tag="h5" link_type="regular" alignment="center" link_text="Purchase now"][/fancy_box][/vc_column][/vc_row]

CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Service Boxes Dark Gradient Coloring', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['services'];
$data['custom_class'] = 'services date-07-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/text-gradient-hover-boxes.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-city.webp" bg_position="left top" bg_repeat="no-repeat" parallax_bg="true" parallax_bg_speed="fast" bg_color="#212121" scene_position="center" text_color="light" text_align="left" top_padding="8%" bottom_padding="8%" color_overlay="#212121" overlay_strength="0.8" shape_divider_position="bottom" shape_type=""][vc_column enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-3-percent" column_padding_position="right" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1507121674772{margin-bottom: 10px !important;}"]
<h5>How We Can Help</h5>
[/vc_column_text][vc_column_text]
<h2>An exceptional experience</h2>
[/vc_column_text][vc_custom_heading text="Lorem ipsum dolor sit amet, consectetur adipiscing elit. Pellentesque finibus ullamcorper dui et eleifend. In hac habitasse platea dictumst. Mauris sit amet feugiat tortor, a fermentum mi." font_container="tag:p|text_align:left|color:rgba(255%2C255%2C255%2C0.72)" use_theme_fonts="yes"][nectar_btn size="large" button_style="regular" button_color_2="extra-color-gradient-1" icon_family="default_arrow" url="#" text="Learn More" margin_top="15"][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="2/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left" css=".vc_custom_1504187365562{margin-bottom: 2% !important;}"][vc_column_inner enable_animation="true" animation="grow-in" column_padding="padding-1-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/2" column_border_width="none" column_border_style="solid"][fancy_box box_style="color_box_hover" icon_family="none" color="extra-color-gradient-1" box_alignment="left" min_height="140"]
<h3>Fast Turnaround</h3>
I throw myself down among the tall grass by the stream as I lie close to the earth.[/fancy_box][/vc_column_inner][vc_column_inner enable_animation="true" animation="grow-in" column_padding="padding-1-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/2" column_border_width="none" column_border_style="solid" delay="150"][fancy_box box_style="color_box_hover" icon_family="none" color="extra-color-gradient-1" box_alignment="left" min_height="140"]
<h3>Elegant Design</h3>
And the meridian sun strikes the upper surface of the impenetrable foliage.[/fancy_box][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="grow-in" column_padding="padding-1-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/2" column_border_width="none" column_border_style="solid"][fancy_box box_style="color_box_hover" icon_family="none" color="extra-color-gradient-1" box_alignment="left" min_height="140"]
<h3>Super Fresh</h3>
I am so happy, my dear friend, so absorbed in the exquisite sense of mere tranquil existence.[/fancy_box][/vc_column_inner][vc_column_inner enable_animation="true" animation="grow-in" column_padding="padding-1-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/2" column_border_width="none" column_border_style="solid" delay="150"][fancy_box box_style="color_box_hover" icon_family="none" color="extra-color-gradient-1" box_alignment="left" min_height="140"]
<h3>Award Winning</h3>
As I lie close to the earth, a thousand unknown plants are noticed by me.[/fancy_box][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]

CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Excellent Hero With BG Image', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['hero_section'];
$data['custom_class'] = 'hero_section date-07-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/bg-landing-hero.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-city.webp" bg_position="center center" bg_repeat="no-repeat" parallax_bg="true" parallax_bg_speed="fast" bg_color="#ffffff" scene_position="center" text_color="light" text_align="left" top_padding="8%" bottom_padding="4%" color_overlay="#0a0a0a" overlay_strength="0.8" shape_divider_position="bottom" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/1" column_border_width="none" column_border_style="solid"][vc_custom_heading text="Are you ready?" font_container="tag:h5|font_size:20|text_align:center|color:%23ffffff|line_height:26px" use_theme_fonts="yes" css_animation="none" css=".vc_custom_1507127425871{margin-bottom: -10px !important;}"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/1" column_border_width="none" column_border_style="solid" delay="100"][vc_custom_heading text="We're Salient" font_container="tag:h4|font_size:94|text_align:center|color:%23ffffff|line_height:114px" use_theme_fonts="yes" css_animation="none" css=".vc_custom_1507127344251{margin-bottom: -10px !important;}"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/6" column_border_width="none" column_border_style="solid" delay="200"][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="2/3" column_border_width="none" column_border_style="solid" delay="150"][vc_custom_heading text="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast." font_container="tag:p|font_size:18|text_align:center|color:rgba(255%2C255%2C255%2C0.74)|line_height:28px" google_fonts="font_family:Roboto%3A100%2C100italic%2C300%2C300italic%2Cregular%2Citalic%2C500%2C500italic%2C700%2C700italic%2C900%2C900italic|font_style:400%20regular%3A400%3Anormal" css_animation="none" css=".vc_custom_1485614418364{padding-right: 5% !important;padding-left: 5% !important;}"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/6" column_border_width="none" column_border_style="solid"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" bottom_padding="5%" text_align="left"][vc_column_inner enable_animation="true" animation="grow-in" column_padding="no-extra-padding" column_padding_position="all" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/1" column_border_width="none" column_border_style="solid" delay="300"][nectar_btn size="large" button_style="regular" button_color_2="Extra-Color-1" icon_family="default_arrow" url="#" text="Learn More" margin_top="30"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-2-percent" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/4" column_border_width="none" column_border_style="solid"][vc_column_text css_animation="fadeInUp" css=".vc_custom_1486426628130{margin-bottom: 15px !important;}"]
<h5>There For You</h5>
[/vc_column_text][vc_custom_heading text="Far far away, behind the word, far from the countries." font_container="tag:p|text_align:left|color:rgba(255%2C255%2C255%2C0.65)" use_theme_fonts="yes" css_animation="fadeInUp" css=".vc_custom_1486418797897{padding-right: 20% !important;}"][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-2-percent" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/4" column_border_width="none" column_border_style="solid"][vc_column_text css_animation="fadeInUp" css=".vc_custom_1486426637035{margin-bottom: 15px !important;}"]
<h5>Pristine Quality</h5>
[/vc_column_text][vc_custom_heading text="Far far away, behind the word, far from the countries." font_container="tag:p|text_align:left|color:rgba(255%2C255%2C255%2C0.65)" use_theme_fonts="yes" css_animation="fadeInUp" css=".vc_custom_1486418801921{padding-right: 20% !important;}"][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-2-percent" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/4" column_border_width="none" column_border_style="solid"][vc_column_text css_animation="fadeInUp" css=".vc_custom_1486426643514{margin-bottom: 15px !important;}"]
<h5>Heavily Awarded</h5>
[/vc_column_text][vc_custom_heading text="Far far away, behind the word, far from the countries." font_container="tag:p|text_align:left|color:rgba(255%2C255%2C255%2C0.65)" use_theme_fonts="yes" css_animation="fadeInUp" css=".vc_custom_1486418805797{padding-right: 20% !important;}"][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-2-percent" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" width="1/4" column_border_width="none" column_border_style="solid"][vc_column_text css_animation="fadeInUp" css=".vc_custom_1486426698874{margin-bottom: 15px !important;}"]
<h5>Documentation</h5>
[/vc_column_text][vc_custom_heading text="Far far away, behind the word, far from the countries." font_container="tag:p|text_align:left|color:rgba(255%2C255%2C255%2C0.65)" use_theme_fonts="yes" css_animation="fadeInUp" css=".vc_custom_1486418809890{padding-right: 20% !important;}"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]

CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Fervent Intro Hero', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['hero_section'];
$data['custom_class'] = 'hero_section date-15-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/about-header.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-mountains-2.webp" bg_position="left top" bg_repeat="no-repeat" parallax_bg="true" parallax_bg_speed="fast" bg_color="#333333" scene_position="center" video_bg="use_video" video_mute="true" text_color="light" text_align="left" top_padding="13%" bottom_padding="13%" color_overlay="#0a0a0a" overlay_strength="0.5"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_custom_heading text="Our Story" font_container="tag:h5|text_align:left|color:rgba(255%2C255%2C255%2C0.74)" use_theme_fonts="yes" css_animation="fadeInUp"][split_line_heading animation_type="default"]
<h2>Let's Change How We</h2>
<h2>Manage Business</h2>
[/split_line_heading][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="5/6" column_border_width="none" column_border_style="solid" delay="300"][vc_custom_heading text="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics. " font_container="tag:p|text_align:left|color:rgba(255%2C255%2C255%2C0.7)" use_theme_fonts="yes"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/6" column_border_width="none" column_border_style="solid"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" top_padding="30" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid" delay="500"][nectar_video_lightbox link_style="play_button_with_text" nectar_play_button_color="Extra-Color-1" font_style="p" video_url="https://www.youtube.com/watch?v=6oTurM7gESE" link_text="View Explainer Video"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Career Table', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['about'] .', '. $cat_display_names['general'];
$data['custom_class'] = 'about general date-15-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/career-table.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" scene_position="center" text_color="dark" text_align="left" top_padding="10%" bottom_padding="10%" overlay_strength="0.95"][vc_column enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" centered_text="true" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1486569314523{margin-top: -8px !important;margin-bottom: -8px !important;}"]
<h2>Career Opportunities</h2>
[/vc_column_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" bottom_padding="80" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/4" column_border_width="none" column_border_style="solid"][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/2" column_border_width="none" column_border_style="solid" delay="50"][vc_custom_heading text="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. A small river named Duden flows by their place and supplies it with the necessary regelialia." font_container="tag:p|text_align:center|color:rgba(10%2C10%2C10%2C0.65)" use_theme_fonts="yes" css_animation="none"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/4" column_border_width="none" column_border_style="solid"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/1" column_border_width="none" column_border_style="solid"][nectar_horizontal_list_item columns="3" column_layout_using_3_columns="large_first" col_1_text_align="left" col_2_text_align="left" col_3_text_align="right" font_family="h4" hover_color="accent-color" col_1_content="Content Director " col_2_content="On Location" cta_1_text="Apply Now"][nectar_horizontal_list_item columns="3" column_layout_using_3_columns="large_first" col_1_text_align="left" col_2_text_align="left" col_3_text_align="right" font_family="h4" hover_color="accent-color" col_1_content="Producer" col_2_content="On Location" cta_1_text="Apply Now"][nectar_horizontal_list_item columns="3" column_layout_using_3_columns="large_first" col_1_text_align="left" col_2_text_align="left" col_3_text_align="right" font_family="h4" hover_color="accent-color" col_1_content="We Developer" col_2_content="On Location" cta_1_text="Apply Now"][nectar_horizontal_list_item columns="3" column_layout_using_3_columns="large_first" col_1_text_align="left" col_2_text_align="left" col_3_text_align="right" font_family="h4" hover_color="accent-color" col_1_content="SEO Specialist " col_2_content="Remote" cta_1_text="Apply Now"][nectar_horizontal_list_item columns="3" column_layout_using_3_columns="large_first" col_1_text_align="left" col_2_text_align="left" col_3_text_align="right" font_family="h4" hover_color="accent-color" col_1_content="Social Media Manager" col_2_content="Remote" cta_1_text="Apply Now"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );

$data = array();
$data['name'] = esc_html__( 'Parallax Cascading Images', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['about'] .', '. $cat_display_names['general'];
$data['custom_class'] = 'about general date-15-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/cascading-img-modern.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-mountains-2.webp" bg_position="left top" bg_repeat="no-repeat" parallax_bg="true" parallax_bg_speed="fast" scene_position="center" text_color="light" text_align="left" top_padding="10%" bottom_padding="10%" color_overlay="rgba(10,10,10,0.67)" overlay_strength="0.5"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner equal_height="yes" content_placement="middle" column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/2" column_border_width="none" column_border_style="solid"][nectar_cascading_images image_1_bg_color="#3452ff" image_1_offset_x_sign="+" image_1_offset_x="0%" image_1_offset_y_sign="+" image_1_offset_y="0%" image_1_rotate_sign="+" image_1_rotate="none" image_1_animation="Grow In" image_1_box_shadow="none" image_2_url="https://themenectar.com/img/demo-media/unsplash/webp/600-600-flame.webp" image_2_offset_x_sign="-" image_2_offset_x="25%" image_2_offset_y_sign="+" image_2_offset_y="30%" image_2_rotate_sign="+" image_2_rotate="none" image_2_animation="Grow In" image_2_box_shadow="none" image_3_url="https://themenectar.com/img/demo-media/unsplash/webp/700-700-earphones.webp" image_3_offset_x_sign="+" image_3_offset_x="15%" image_3_offset_y_sign="-" image_3_offset_y="30%" image_3_rotate_sign="+" image_3_rotate="none" image_3_animation="Grow In" image_3_box_shadow="x_large_depth" image_4_offset_x_sign="+" image_4_offset_x="0%" image_4_offset_y_sign="+" image_4_offset_y="0%" image_4_rotate_sign="+" image_4_rotate="none" image_4_animation="Fade In" image_4_box_shadow="none"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" width="1/2" column_border_width="none" column_border_style="solid"][vc_custom_heading text="Way back when" font_container="tag:h5|text_align:left|color:rgba(255%2C255%2C255%2C0.74)" use_theme_fonts="yes" css_animation="fadeInUp"][split_line_heading animation_type="default"]
<h2>We decided to move</h2>
<h2>forward with building</h2>
[/split_line_heading][vc_custom_heading text="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean." font_container="tag:p|text_align:left|color:rgba(255%2C255%2C255%2C0.7)" use_theme_fonts="yes" css_animation="fadeInUp" css=".vc_custom_1486564699536{padding-right: 10% !important;}"][nectar_btn size="large" button_style="see-through-2" hover_text_color_override="#ffffff" icon_family="none" url="#" text="Show Me How" margin_top="25" css_animation="fadeInUp"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Daring CTA Morphing Outline Buttons', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['services'] .', '. $cat_display_names['cta'];
$data['custom_class'] = 'services cta date-10-Aug-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/morphing-outline.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" bg_position="left top" bg_repeat="no-repeat" parallax_bg_speed="slow" scene_position="center" text_color="light" text_align="left"][vc_column width="1/2" animation="none" column_padding="padding-10-percent" column_padding_position="all" background_color="#f7f7f7" background_color_opacity="1" column_link="#" background_hover_color_opacity="0.9" background_image="5364" background_color_hover="#f7f7f7"][morphing_outline starting_color="#fd0025" border_thickness="11" hover_color="#fd0025"]
<h5><i>Continue Exploring</i></h5>
<h2>View More</h2>
[/morphing_outline][/vc_column][vc_column width="1/2" animation="none" column_padding="padding-10-percent" column_padding_position="all" background_color="#fd0025" background_color_opacity="1" column_link="#" background_color_hover="#fd0025" background_hover_color_opacity="0.9" background_image="5275"][morphing_outline border_thickness="11" starting_color="#ffffff" hover_color="#ffffff"]
<h5><i>Already In Love</i></h5>
<h2>Purchase</h2>
[/morphing_outline][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );

$data = array();
$data['name'] = esc_html__( 'Icons With Text & Column BG Hover', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'] .', '. $cat_display_names['icons'];
$data['custom_class'] = 'general icons date-10-Aug-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/icon_with_text_1.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-clouds.webp" bg_position="center center" bg_repeat="no-repeat" parallax_bg="true" parallax_bg_speed="fast" bg_color="#4e475c" scene_position="center" text_color="light" text_align="center" color_overlay="#4e475c" overlay_strength="0.95" shape_divider_position="bottom"][vc_column centered_text="true" column_padding="padding-4-percent" column_padding_position="all" background_color_opacity="1" background_color_hover="#0a0a0a" background_hover_color_opacity="0.2" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/4" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][divider line_type="No Line" custom_height="75"][nectar_icon icon_family="linea" icon_style="default" icon_color="Accent-Color" icon_padding="10px" icon_linea="icon-basic-heart" icon_size="60"][divider line_type="No Line" custom_height="15"][vc_column_text] Take full control of the power Salient has to offer with our new exciting page builder. You’ll be grinning in delight when you see just how easy it is to create stunning layouts with little effort.[/vc_column_text][divider line_type="No Line" custom_height="75"][/vc_column][vc_column column_padding="padding-4-percent" column_padding_position="all" background_color_opacity="1" background_color_hover="#0a0a0a" background_hover_color_opacity="0.2" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/4" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][divider line_type="No Line" custom_height="75"][nectar_icon icon_family="linea" icon_style="default" icon_color="Accent-Color" icon_padding="10px" icon_linea="icon-basic-mouse" icon_size="60"][divider line_type="No Line" custom_height="15"][vc_column_text] Take full control of the power Salient has to offer with our new exciting page builder. You’ll be grinning in delight when you see just how easy it is to create stunning layouts with little effort.[/vc_column_text][divider line_type="No Line" custom_height="75"][/vc_column][vc_column column_padding="padding-4-percent" column_padding_position="all" background_color_opacity="1" background_color_hover="#0a0a0a" background_hover_color_opacity="0.2" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/4" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][divider line_type="No Line" custom_height="75"][nectar_icon icon_family="linea" icon_style="default" icon_color="Accent-Color" icon_padding="10px" icon_linea="icon-arrows-rotate" icon_size="60"][divider line_type="No Line" custom_height="15"][vc_column_text] Take full control of the power Salient has to offer with our new exciting page builder. You’ll be grinning in delight when you see just how easy it is to create stunning layouts with little effort.[/vc_column_text][divider line_type="No Line" custom_height="75"][/vc_column][vc_column column_padding="padding-4-percent" column_padding_position="all" background_color_opacity="1" background_color_hover="#0a0a0a" background_hover_color_opacity="0.2" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/4" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][divider line_type="No Line" custom_height="75"][nectar_icon icon_family="linea" icon_style="default" icon_color="Accent-Color" icon_padding="10px" icon_linea="icon-basic-video" icon_size="60"][divider line_type="No Line" custom_height="15"][vc_column_text] Take full control of the power Salient has to offer with our new exciting page builder. You’ll be grinning in delight when you see just how easy it is to create stunning layouts with little effort.[/vc_column_text][divider line_type="No Line" custom_height="75"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Soft Color Icons And Text Blocks', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'] .', '. $cat_display_names['icons'];
$data['custom_class'] = 'general icons date-13-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/soft-color-icon-boxes.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" equal_height="yes" content_placement="top" scene_position="center" text_color="dark" text_align="left" top_padding="10%" bottom_padding="10%" overlay_strength="0.3" shape_divider_position="bottom" shape_type=""][vc_column enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-3-percent" column_padding_position="right" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="2/5" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_column_text css_animation="none" max_width="375"]
<h2>Take the risk or you will lose the chance.</h2>
[/vc_column_text][vc_column_text css_animation="none" css=".vc_custom_1531849673065{margin-top: 30px !important;margin-bottom: 30px !important;}" max_width="400"]Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. A small river named Duden flows by their place and supplies it with the necessary regelialia[/vc_column_text][/vc_column][vc_column column_padding="padding-4-percent" column_padding_position="right" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="3/5" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" bottom_padding="30" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/2" column_border_width="none" column_border_style="solid"][nectar_icon icon_family="iconsmind" icon_style="soft-bg" icon_color="Extra-Color-2" icon_padding="15px" icon_iconsmind="iconsmind-Helicopter" icon_size="36"][vc_column_text css_animation="none" css=".vc_custom_1531417490305{margin-bottom: 15px !important;}"]
<h4>Deploy</h4>
[/vc_column_text][vc_custom_heading text="Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut elit tellus amet" font_container="tag:p|text_align:left" use_theme_fonts="yes" css_animation="none" css=".vc_custom_1531417497722{padding-right: 13% !important;}"][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/2" column_border_width="none" column_border_style="solid" delay="200"][nectar_icon icon_family="iconsmind" icon_style="soft-bg" icon_color="Extra-Color-3" icon_padding="15px" icon_iconsmind="iconsmind-Life-Jacket" icon_size="36"][vc_column_text css_animation="none" css=".vc_custom_1531417485581{margin-bottom: 15px !important;}"]
<h4>Support</h4>
[/vc_column_text][vc_custom_heading text="Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut elit tellus amet" font_container="tag:p|text_align:left" use_theme_fonts="yes" css_animation="none" css=".vc_custom_1531417502263{padding-right: 10% !important;}"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/2" column_border_width="none" column_border_style="solid"][nectar_icon icon_family="iconsmind" icon_style="soft-bg" icon_color="Accent-Color" icon_padding="15px" icon_iconsmind="iconsmind-Diamond" margin_top="20" icon_size="36"][vc_column_text css_animation="none" css=".vc_custom_1531417507799{margin-bottom: 15px !important;}"]
<h4>Design</h4>
[/vc_column_text][vc_custom_heading text="Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut elit tellus amet" font_container="tag:p|text_align:left" use_theme_fonts="yes" css_animation="none" css=".vc_custom_1531417513482{padding-right: 13% !important;}"][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/2" column_border_width="none" column_border_style="solid" delay="200"][nectar_icon icon_family="iconsmind" icon_style="soft-bg" icon_color="Extra-Color-1" icon_padding="15px" icon_iconsmind="iconsmind-Gear-2" margin_top="20" icon_size="36"][vc_column_text css_animation="none" css=".vc_custom_1531417518183{margin-bottom: 15px !important;}"]
<h4>Develop</h4>
[/vc_column_text][vc_custom_heading text="Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut elit tellus amet" font_container="tag:p|text_align:left" use_theme_fonts="yes" css_animation="none" css=".vc_custom_1531417525057{padding-right: 10% !important;}"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



if(version_compare(WPB_VC_VERSION,'5.5','>=')) {

$data = array();
$data['name'] = esc_html__( 'Easy Wide Broken Image Grid', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['general'] .', '. $cat_display_names['about'];
$data['custom_class'] = 'general about date-14-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/broken-image-grid-3.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" scene_position="center" text_color="dark" text_align="left" overlay_strength="0.3" shape_divider_position="bottom" top_padding="2%" bottom_padding="2%" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner equal_height="yes" content_placement="bottom" column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="grow-in" column_padding="padding-1-percent" column_padding_position="bottom-right" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/5" column_border_width="none" column_border_style="solid" offset="vc_col-xs-1/5"][image_with_animation image_url="https://themenectar.com/img/demo-media/unsplash/webp/500-500-forest.webp" alignment="" animation="None" border_radius="none" box_shadow="none" max_width="100%"][/vc_column_inner][vc_column_inner enable_animation="true" animation="grow-in" column_padding="padding-1-percent" column_padding_position="bottom-right" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/5" column_border_width="none" column_border_style="solid" offset="vc_col-xs-1/5" delay="100"][image_with_animation image_url="https://themenectar.com/img/demo-media/unsplash/webp/500-500-sky.webp" alignment="" animation="None" border_radius="none" box_shadow="none" max_width="100%"][/vc_column_inner][vc_column_inner enable_animation="true" animation="grow-in" column_padding="padding-1-percent" column_padding_position="bottom-right" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/5" column_border_width="none" column_border_style="solid" offset="vc_col-xs-1/5" delay="200"][image_with_animation image_url="https://themenectar.com/img/demo-media/unsplash/webp/600-800-waterfall.webp" alignment="" animation="None" border_radius="none" box_shadow="none" max_width="100%"][/vc_column_inner][vc_column_inner enable_animation="true" animation="grow-in" column_padding="padding-1-percent" column_padding_position="bottom-right" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/5" column_border_width="none" column_border_style="solid" offset="vc_col-xs-1/5" delay="300"][image_with_animation image_url="https://themenectar.com/img/demo-media/unsplash/webp/800-500-adventure.webp" alignment="" animation="None" border_radius="none" box_shadow="none" max_width="100%"][image_with_animation image_url="https://themenectar.com/img/demo-media/unsplash/webp/800-500-bike.webp" alignment="" animation="None" border_radius="none" box_shadow="none" max_width="100%" margin_top="5%"][/vc_column_inner][vc_column_inner enable_animation="true" animation="grow-in" column_padding="padding-1-percent" column_padding_position="bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/5" column_border_width="none" column_border_style="solid" offset="vc_col-xs-1/5" delay="400"][image_with_animation image_url="https://themenectar.com/img/demo-media/unsplash/webp/700-500-city.webp" alignment="" animation="None" border_radius="none" box_shadow="none" max_width="100%"][/vc_column_inner][/vc_row_inner][vc_row_inner equal_height="yes" content_placement="top" column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="grow-in" column_padding="padding-1-percent" column_padding_position="bottom-right" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/5" column_border_width="none" column_border_style="solid" offset="vc_col-xs-1/5"][image_with_animation image_url="https://themenectar.com/img/demo-media/unsplash/webp/350-450-nature.webp" alignment="" animation="None" border_radius="none" box_shadow="none" max_width="100%"][/vc_column_inner][vc_column_inner enable_animation="true" animation="grow-in" column_padding="padding-1-percent" column_padding_position="bottom-right" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/5" column_border_width="none" column_border_style="solid" offset="vc_col-xs-1/5" delay="100"][image_with_animation image_url="https://themenectar.com/img/demo-media/unsplash/webp/500-400-adventure.webp" alignment="" animation="None" border_radius="none" box_shadow="none" max_width="100%"][image_with_animation image_url="https://themenectar.com/img/demo-media/unsplash/webp/700-500-city.webp" alignment="" animation="None" border_radius="none" box_shadow="none" max_width="100%" margin_top="5%"][/vc_column_inner][vc_column_inner enable_animation="true" animation="grow-in" column_padding="padding-1-percent" column_padding_position="bottom-right" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/5" column_border_width="none" column_border_style="solid" offset="vc_col-xs-1/5" delay="200"][image_with_animation image_url="https://themenectar.com/img/demo-media/unsplash/webp/700-700-food.webp" alignment="" animation="None" border_radius="none" box_shadow="none" max_width="100%"][/vc_column_inner][vc_column_inner enable_animation="true" animation="grow-in" column_padding="padding-1-percent" column_padding_position="bottom-right" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/5" column_border_width="none" column_border_style="solid" offset="vc_col-xs-1/5" delay="300"][image_with_animation image_url="https://themenectar.com/img/demo-media/unsplash/webp/700-700-man.webp" alignment="" animation="None" border_radius="none" box_shadow="none" max_width="100%"][/vc_column_inner][vc_column_inner enable_animation="true" animation="grow-in" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/5" column_border_width="none" column_border_style="solid" offset="vc_col-xs-1/5" delay="400"][image_with_animation image_url="https://themenectar.com/img/demo-media/unsplash/webp/600-600-flame.webp" alignment="" animation="None" border_radius="none" box_shadow="none" max_width="100%"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );

}




$data = array();
$data['name'] = esc_html__( 'Clear Hero Section', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['hero_section'];
$data['custom_class'] = 'hero_section date-11-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/landing-video-right.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-clouds.webp" bg_position="center center" bg_repeat="no-repeat" parallax_bg="true" parallax_bg_speed="fast" bg_color="#ffffff" scene_position="center" text_color="light" text_align="left" color_overlay="#3452ff" overlay_strength="0.95" shape_divider_position="bottom" shape_type=""][vc_column enable_animation="true" animation="fade-in" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner equal_height="yes" content_placement="middle" column_margin="default" top_padding="15%" bottom_padding="14%" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="5/12" column_border_width="none" column_border_style="solid" offset="vc_col-xs-12"][nectar_highlighted_text highlight_color="#ff1053" style="half_text"]
<h1>We're Salient, A <em>Creative</em> Startup Based in Philly</h1>
[/nectar_highlighted_text][vc_column_text max_width="550"]I am text block. Click edit button to change this text. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut elit tellus, luctus nec.[/vc_column_text][divider line_type="No Line"][nectar_btn size="large" button_style="regular" button_color_2="Extra-Color-1" icon_family="default_arrow" url="#" text="Learn More" css_animation="none"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/12" column_border_width="none" column_border_style="solid" offset="vc_hidden-sm vc_hidden-xs"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/2" column_border_width="none" column_border_style="solid"][nectar_video_lightbox link_style="play_button_2" nectar_play_button_color="Extra-Color-1" image_url="https://themenectar.com/img/demo-media/unsplash/webp/700-700-mountain-trees.webp" hover_effect="zoom_button" box_shadow="x_large_depth" border_radius="10px" play_button_size="default" video_url="https://www.youtube.com/watch?v=6oTurM7gESE"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="padding-4-percent" column_padding_position="bottom-right" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/6" column_border_width="none" column_border_style="solid"][image_with_animation image_url="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo-light.png" alignment="" animation="None" border_radius="none" box_shadow="none" max_width="100%"][/vc_column_inner][vc_column_inner column_padding="padding-4-percent" column_padding_position="bottom-right" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/6" column_border_width="none" column_border_style="solid"][image_with_animation image_url="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo-light.png" alignment="" animation="None" border_radius="none" box_shadow="none" max_width="100%"][/vc_column_inner][vc_column_inner column_padding="padding-4-percent" column_padding_position="bottom-right" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/6" column_border_width="none" column_border_style="solid"][image_with_animation image_url="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo-light.png" alignment="" animation="None" border_radius="none" box_shadow="none" max_width="100%"][/vc_column_inner][vc_column_inner column_padding="padding-4-percent" column_padding_position="bottom-right" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/6" column_border_width="none" column_border_style="solid"][image_with_animation image_url="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo-light.png" alignment="" animation="None" border_radius="none" box_shadow="none" max_width="100%"][/vc_column_inner][vc_column_inner column_padding="padding-4-percent" column_padding_position="bottom-right" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/6" column_border_width="none" column_border_style="solid"][image_with_animation image_url="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo-light.png" alignment="" animation="None" border_radius="none" box_shadow="none" max_width="100%"][/vc_column_inner][vc_column_inner column_padding="padding-4-percent" column_padding_position="bottom-right" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/6" column_border_width="none" column_border_style="solid"][image_with_animation image_url="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo-light.png" alignment="" animation="None" border_radius="none" box_shadow="none" max_width="100%"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Great Image Overflow Hero', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['hero_section'] .', '. $cat_display_names['icons'];
$data['custom_class'] = 'hero_section icons date-01-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/right-overflow-img-hero.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" equal_height="yes" content_placement="middle" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-clouds.webp" bg_position="left top" bg_repeat="no-repeat" parallax_bg="true" parallax_bg_speed="fast" bg_color="#151515" scene_position="center" text_color="light" text_align="left" top_padding="10%" bottom_padding="10%" color_overlay="rgba(10,10,10,0.87)" overlay_strength="0.8" shape_divider_position="bottom" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" column_border_width="none" column_border_style="solid"][nectar_highlighted_text highlight_color="#3452ff" style="half_text"]
<h1>This is <em>Salient</em></h1>
[/nectar_highlighted_text][vc_custom_heading text="I am text block. Click edit button to change this text. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut elit tellus, luctus nec ullamcorper mattis, pulvinar dapibus leo elit tellus amet." font_container="tag:p|text_align:left|color:rgba(255%2C255%2C255%2C0.6)" use_theme_fonts="yes" css_animation="none"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" top_padding="40" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-2-percent" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/2" column_border_width="none" column_border_style="solid"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color="Accent-Color" icon_padding="0px" icon_iconsmind="iconsmind-Helicopter" icon_size="36"][vc_column_text css_animation="none" css=".vc_custom_1532110637877{margin-bottom: 15px !important;}"]
<h5>Design</h5>
[/vc_column_text][vc_custom_heading text="Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut elit tellus amet" font_container="tag:p|text_align:left|color:rgba(255%2C255%2C255%2C0.6)" use_theme_fonts="yes" css_animation="none" css=".vc_custom_1532110649107{padding-right: 10% !important;}"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color="Accent-Color" icon_padding="0px" icon_iconsmind="iconsmind-Diamond" margin_top="40" icon_size="36"][vc_column_text css_animation="none" css=".vc_custom_1532110654226{margin-bottom: 15px !important;}"]
<h5>Deploy</h5>
[/vc_column_text][vc_custom_heading text="Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut elit tellus amet" font_container="tag:p|text_align:left|color:rgba(255%2C255%2C255%2C0.6)" use_theme_fonts="yes" css_animation="none" css=".vc_custom_1532110661455{padding-right: 10% !important;}"][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-2-percent" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/2" column_border_width="none" column_border_style="solid" delay="100"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color="Accent-Color" icon_padding="0px" icon_iconsmind="iconsmind-Life-Jacket" icon_size="36"][vc_column_text css_animation="none" css=".vc_custom_1532110643322{margin-bottom: 15px !important;}"]
<h5>Develop</h5>
[/vc_column_text][vc_custom_heading text="Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut elit tellus amet" font_container="tag:p|text_align:left|color:rgba(255%2C255%2C255%2C0.6)" use_theme_fonts="yes" css_animation="none" css=".vc_custom_1485638366488{padding-right: 10% !important;}"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color="Accent-Color" icon_padding="0px" icon_iconsmind="iconsmind-Gear-2" margin_top="40" icon_size="36"][vc_column_text css_animation="none" css=".vc_custom_1532110665831{margin-bottom: 15px !important;}"]
<h5>Support</h5>
[/vc_column_text][vc_custom_heading text="Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut elit tellus amet" font_container="tag:p|text_align:left|color:rgba(255%2C255%2C255%2C0.6)" use_theme_fonts="yes" css_animation="none" css=".vc_custom_1532110673654{padding-right: 10% !important;}"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="padding-5-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][image_with_animation image_url="https://themenectar.com/img/demo-media/unsplash/webp/large-sunflowers.webp" alignment="" animation="Fade In From Left" img_link_large="yes" border_radius="10px" box_shadow="x_large_depth" max_width="225%"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Great Image Overflow Hero #2', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['hero_section'] .', '. $cat_display_names['icons'];
$data['custom_class'] = 'hero_section icons date-01-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/left-overflow-img-hero.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" equal_height="yes" content_placement="middle" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-sunflowers.webp" bg_position="left top" bg_repeat="no-repeat" parallax_bg="true" parallax_bg_speed="fast" bg_color="#151515" scene_position="center" text_color="light" text_align="left" top_padding="10%" bottom_padding="10%" color_overlay="rgba(10,10,10,0.87)" overlay_strength="0.8" shape_divider_position="bottom" shape_type=""][vc_column column_padding="padding-5-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][image_with_animation image_url="https://themenectar.com/img/demo-media/unsplash/webp/large-sunflowers.webp" alignment="right" animation="Fade In From Left" img_link_large="yes" border_radius="10px" box_shadow="x_large_depth" max_width="225%"][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" column_border_width="none" column_border_style="solid"][nectar_highlighted_text highlight_color="#3452ff" style="half_text"]
<h1>This is <em>Salient</em></h1>
[/nectar_highlighted_text][vc_custom_heading text="I am text block. Click edit button to change this text. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut elit tellus, luctus nec ullamcorper mattis, pulvinar dapibus leo elit tellus amet." font_container="tag:p|text_align:left|color:rgba(255%2C255%2C255%2C0.6)" use_theme_fonts="yes" css_animation="none"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" top_padding="40" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-2-percent" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/2" column_border_width="none" column_border_style="solid"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color="Accent-Color" icon_padding="0px" icon_iconsmind="iconsmind-Helicopter" icon_size="36"][vc_column_text css_animation="none" css=".vc_custom_1532110637877{margin-bottom: 15px !important;}"]
<h5>Design</h5>
[/vc_column_text][vc_custom_heading text="Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut elit tellus amet" font_container="tag:p|text_align:left|color:rgba(255%2C255%2C255%2C0.6)" use_theme_fonts="yes" css_animation="none" css=".vc_custom_1532110649107{padding-right: 10% !important;}"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color="Accent-Color" icon_padding="0px" icon_iconsmind="iconsmind-Diamond" margin_top="40" icon_size="36"][vc_column_text css_animation="none" css=".vc_custom_1532110654226{margin-bottom: 15px !important;}"]
<h5>Deploy</h5>
[/vc_column_text][vc_custom_heading text="Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut elit tellus amet" font_container="tag:p|text_align:left|color:rgba(255%2C255%2C255%2C0.6)" use_theme_fonts="yes" css_animation="none" css=".vc_custom_1532110661455{padding-right: 10% !important;}"][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-2-percent" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/2" column_border_width="none" column_border_style="solid" delay="100"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color="Accent-Color" icon_padding="0px" icon_iconsmind="iconsmind-Life-Jacket" icon_size="36"][vc_column_text css_animation="none" css=".vc_custom_1532110643322{margin-bottom: 15px !important;}"]
<h5>Develop</h5>
[/vc_column_text][vc_custom_heading text="Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut elit tellus amet" font_container="tag:p|text_align:left|color:rgba(255%2C255%2C255%2C0.6)" use_theme_fonts="yes" css_animation="none" css=".vc_custom_1485638366488{padding-right: 10% !important;}"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color="Accent-Color" icon_padding="0px" icon_iconsmind="iconsmind-Gear-2" margin_top="40" icon_size="36"][vc_column_text css_animation="none" css=".vc_custom_1532110665831{margin-bottom: 15px !important;}"]
<h5>Support</h5>
[/vc_column_text][vc_custom_heading text="Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut elit tellus amet" font_container="tag:p|text_align:left|color:rgba(255%2C255%2C255%2C0.6)" use_theme_fonts="yes" css_animation="none" css=".vc_custom_1532110673654{padding-right: 10% !important;}"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'Four Columns With Soft Color Icons', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['general'] .', '. $cat_display_names['icons'];
$data['custom_class'] = 'general icons date-01-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/4-col-soft-icon-text.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" equal_height="yes" content_placement="top" scene_position="center" text_color="dark" text_align="left" top_padding="10%" bottom_padding="10%" overlay_strength="0.3" shape_divider_position="bottom" shape_type=""][vc_column enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-3-percent" column_padding_position="right" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" bottom_padding="30" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/2" column_border_width="none" column_border_style="solid"][vc_column_text css_animation="none"]
<h2>Failure will never overtake me if my determination to succeed is strong enough.</h2>
[/vc_column_text][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/2" column_border_width="none" column_border_style="solid"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" bottom_padding="40" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/4" column_border_width="none" column_border_style="solid"][nectar_icon icon_family="iconsmind" icon_style="soft-bg" icon_color="Accent-Color" icon_padding="15px" icon_iconsmind="iconsmind-Helicopter" icon_size="36" margin_top="20"][vc_column_text css_animation="none" css=".vc_custom_1532036834843{margin-bottom: 15px !important;padding-right: 20px !important;}"]
<h4>We Deploy Our Strategies Unbelievably Fast</h4>
[/vc_column_text][vc_custom_heading text="Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut elit tellus amet" font_container="tag:p|text_align:left" use_theme_fonts="yes" css_animation="none" css=".vc_custom_1531417497722{padding-right: 13% !important;}"][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/4" column_border_width="none" column_border_style="solid" delay="150"][nectar_icon icon_family="iconsmind" icon_style="soft-bg" icon_color="Accent-Color" icon_padding="15px" icon_iconsmind="iconsmind-Life-Jacket" icon_size="36" margin_top="20"][vc_column_text css_animation="none" css=".vc_custom_1532036686189{margin-bottom: 15px !important;padding-right: 20px !important;}"]
<h4>Great Customer Support Is  What We're About</h4>
[/vc_column_text][vc_custom_heading text="Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut elit tellus amet" font_container="tag:p|text_align:left" use_theme_fonts="yes" css_animation="none" css=".vc_custom_1531417502263{padding-right: 10% !important;}"][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/4" column_border_width="none" column_border_style="solid" delay="300"][nectar_icon icon_family="iconsmind" icon_style="soft-bg" icon_color="Accent-Color" icon_padding="15px" icon_iconsmind="iconsmind-Diamond" margin_top="20" icon_size="36"][vc_column_text css_animation="none" css=".vc_custom_1532036822769{margin-bottom: 15px !important;padding-right: 20px !important;}"]
<h4>We Make Killer Designs For Amazing Clients</h4>
[/vc_column_text][vc_custom_heading text="Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut elit tellus amet" font_container="tag:p|text_align:left" use_theme_fonts="yes" css_animation="none" css=".vc_custom_1531417513482{padding-right: 13% !important;}"][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/4" column_border_width="none" column_border_style="solid" delay="450"][nectar_icon icon_family="iconsmind" icon_style="soft-bg" icon_color="Accent-Color" icon_padding="15px" icon_iconsmind="iconsmind-Gear-2" margin_top="20" icon_size="36"][vc_column_text css_animation="none" css=".vc_custom_1532036746257{margin-bottom: 15px !important;padding-right: 20px !important;}"]
<h4>Developing Business Models For 10 Years</h4>
[/vc_column_text][vc_custom_heading text="Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut elit tellus amet" font_container="tag:p|text_align:left" use_theme_fonts="yes" css_animation="none" css=".vc_custom_1531417525057{padding-right: 10% !important;}"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" column_border_width="none" column_border_style="solid"][nectar_cta btn_style="underline" heading_tag="h5" text_color="#3452ff" link_type="regular" alignment="left" link_text="Check Out More"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Light Color Gradient Overlay Information Section', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['testimonials']  .', '. $cat_display_names['about'];
$data['custom_class'] = 'testimonials about date-12-Nov-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/about-gradient.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-mountain.webp" bg_position="left center" bg_repeat="no-repeat" parallax_bg="true" parallax_bg_speed="fast" scene_position="center" text_color="dark" text_align="left" top_padding="10%" bottom_padding="10%" enable_gradient="true" color_overlay="#fff3ef" gradient_direction="left_to_right" overlay_strength="1" shape_divider_position="bottom" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="5/12" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" column_border_width="none" column_border_style="solid"][nectar_video_lightbox link_style="play_button" video_url="https://www.youtube.com/watch?v=6oTurM7gESE"][vc_column_text css=".vc_custom_1531925847334{margin-top: 40px !important;margin-bottom: 5px !important;}"]
<h5>Look Inside</h5>
[/vc_column_text][nectar_highlighted_text highlight_color="rgba(52,82,255,0.33)" style="half_text"]
<h2>Why We're The Most <em>Awesome</em> eCommerce Business</h2>
[/nectar_highlighted_text][/vc_column_inner][/vc_row_inner][divider line_type="Full Width Line" line_thickness="1" divider_color="default" custom_height="100"][carousel script="flickity" flickity_formatting="default" desktop_cols_flickity="1" desktop_small_cols_flickity="1" tablet_cols_flickity="1" pagination_alignment_flickity="left" column_padding="5px" autorotate="true" border_radius="none" autorotation_speed="9000"][item id="1531926429-2-75" tab_id="1531926651954-9" title="Item"][nectar_single_testimonial testimonial_style="basic" image="https://themenectar.com/img/demo-media/unsplash/webp/small-smile-guy-2.webp" style="bold" quote="I am so happy, my dear friend, so absorbed in the exquisite sense of mere tranquil existence, that I neglect my talents. I should be incapable of drawing a single stroke at the present moment; and yet I feel that I never was a greater artist than now." name="Mr. ThemeNectar" subtitle="Pro Acrobat"][/item][item id="1531926429-1-21" tab_id="1531926651819-3" title="Item"][nectar_single_testimonial testimonial_style="basic" image="https://themenectar.com/img/demo-media/unsplash/webp/small-smile-guy.webp" style="bold" quote="A wonderful serenity has taken possession of my entire soul, like these sweet mornings of spring. I am alone, and feel the charm of existence in this spot." name="Mr. ThemeNectar" subtitle="Pro Acrobat"][/item][item id="1531926429-3-51" tab_id="1531926652117-10" title="Item"][nectar_single_testimonial testimonial_style="basic" image="https://themenectar.com/img/demo-media/unsplash/webp/small-smile.webp" style="bold" quote="When, while the lovely valley teems with vapour around me, and the meridian sun strikes the upper surface of the impenetrable foliage of my trees, I throw myself down among the tall grass by the trickling stream." name="Mr. ThemeNectar" subtitle="Pro Acrobat"][/item][/carousel][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="7/12" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Cool Gradient Overlay Information Section Dark', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['testimonials'] .', '. $cat_display_names['about'];
$data['custom_class'] = 'testimonials about date-12-Nov-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/about-gradient-dark.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-mountain.webp" bg_position="left center" bg_repeat="no-repeat" parallax_bg="true" parallax_bg_speed="fast" scene_position="center" text_color="light" text_align="left" top_padding="10%" bottom_padding="10%" enable_gradient="true" color_overlay="#263336" gradient_direction="left_to_right" overlay_strength="1" shape_divider_position="bottom" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="5/12" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" column_border_width="none" column_border_style="solid"][nectar_video_lightbox link_style="play_button" video_url="https://www.youtube.com/watch?v=6oTurM7gESE"][vc_column_text css=".vc_custom_1531925847334{margin-top: 40px !important;margin-bottom: 5px !important;}"]
<h5>Look Inside</h5>
[/vc_column_text][nectar_highlighted_text highlight_color="#ff1053" style="half_text"]
<h2>Why We're The Most <em>Awesome</em> eCommerce Business</h2>
[/nectar_highlighted_text][/vc_column_inner][/vc_row_inner][divider line_type="Full Width Line" line_thickness="1" divider_color="default" custom_height="100"][carousel script="flickity" flickity_formatting="default" desktop_cols_flickity="1" desktop_small_cols_flickity="1" tablet_cols_flickity="1" pagination_alignment_flickity="left" column_padding="5px" autorotate="true" border_radius="none" autorotation_speed="9000"][item id="1531926651954-97774-9140" title="Item" tab_id="1532114245109-7"][nectar_single_testimonial testimonial_style="basic" image="https://themenectar.com/img/demo-media/unsplash/webp/small-smile-guy-2.webp" style="bold" quote="I am so happy, my dear friend, so absorbed in the exquisite sense of mere tranquil existence, that I neglect my talents. I should be incapable of drawing a single stroke at the present moment; and yet I feel that I never was a greater artist than now." name="Mr. ThemeNectar" subtitle="Pro Acrobat"][/item][item id="1531926651819-37774-9140" title="Item" tab_id="1532114245130-8"][nectar_single_testimonial testimonial_style="basic" image="https://themenectar.com/img/demo-media/unsplash/webp/small-smile-guy.webp" style="bold" quote="A wonderful serenity has taken possession of my entire soul, like these sweet mornings of spring. I am alone, and feel the charm of existence in this spot." name="Mr. ThemeNectar" subtitle="Pro Acrobat"][/item][item id="1531926652117-107774-9140" title="Item" tab_id="1532114245167-0"][nectar_single_testimonial testimonial_style="basic" image="https://themenectar.com/img/demo-media/unsplash/webp/small-smile-guy-2.webp" style="bold" quote="When, while the lovely valley teems with vapour around me, and the meridian sun strikes the upper surface of the impenetrable foliage of my trees, I throw myself down among the tall grass by the trickling stream." name="Mr. ThemeNectar" subtitle="Pro Acrobat"][/item][/carousel][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="7/12" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );





$data = array();
$data['name'] = esc_html__( 'Gradient Tabbed Section', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['general'];
$data['custom_class'] = 'general date-21-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/gradient-tabs.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_color="#ffffff" scene_position="center" text_color="dark" text_align="left" top_padding="6%" bottom_padding="6%" overlay_strength="0.3" shape_divider_position="bottom" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][tabbed_section style="material" alignment="center" spacing="side-45px" tab_color="extra-color-gradient-1" full_width_line="true" icon_size="32"][tab icon_family="iconsmind" title="Enforcement" id="1617863276-2-39" tab_id="1517863323662-4" icon_iconsmind="iconsmind-Police-Man"][vc_row_inner column_margin="default" top_padding="20" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-3-percent" column_padding_position="all" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/3" column_border_width="none" column_border_style="solid"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color="grey" icon_padding="0px" icon_iconsmind="iconsmind-Upload-toCloud" url="#"][vc_column_text css_animation="fadeInUp" css=".vc_custom_1485869613252{margin-bottom: 15px !important;}"]
<h5>Upload your ideas to Salient</h5>
[/vc_column_text][vc_custom_heading text="Far far away, behind the word mountains, far from the countries Vokalia and texts" font_container="tag:p|text_align:center|color:rgba(10%2C10%2C10%2C0.65)" use_theme_fonts="yes" css_animation="fadeInUp"][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-3-percent" column_padding_position="all" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/3" column_border_width="none" column_border_style="solid" delay="100"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color="grey" icon_padding="0px" icon_iconsmind="iconsmind-D-Eyeglasses2" url="#"][vc_column_text css_animation="fadeInUp" css=".vc_custom_1485869633028{margin-bottom: 15px !important;}"]
<h5>Watch the magic happen</h5>
[/vc_column_text][vc_custom_heading text="Far far away, behind the word mountains, far from the countries Vokalia and texts" font_container="tag:p|text_align:center|color:rgba(10%2C10%2C10%2C0.65)" use_theme_fonts="yes" css_animation="fadeInUp"][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-3-percent" column_padding_position="all" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/3" column_border_width="none" column_border_style="solid" delay="200"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color="grey" icon_padding="0px" icon_iconsmind="iconsmind-Happy" url="#"][vc_column_text css_animation="fadeInUp" css=".vc_custom_1485869652646{margin-bottom: 15px !important;}"]
<h5>Enjoy your increased revenue</h5>
[/vc_column_text][vc_custom_heading text="Far far away, behind the word mountains, far from the countries Vokalia and texts" font_container="tag:p|text_align:center|color:rgba(10%2C10%2C10%2C0.65)" use_theme_fonts="yes" css_animation="fadeInUp"][/vc_column_inner][/vc_row_inner][/tab][tab icon_family="iconsmind" title="Lightning" id="1517893276-1-15" tab_id="1517863323418-9" icon_iconsmind="iconsmind-Thunder"][vc_row_inner column_margin="default" top_padding="20" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1487092529487{margin-bottom: 20px !important;}"]
<h3>A wonderful serenity has <em>taken possession</em> of my entire soul, like these sweet mornings of spring which I enjoy with my<em> whole heart</em>.</h3>
[/vc_column_text][nectar_video_lightbox link_style="play_button_with_text" nectar_play_button_color="Default-Accent-Color" font_style="p" video_url="https://www.youtube.com/watch?v=6oTurM7gESE" link_text="<strong>Introduction Video </strong> — 30 seconds"][/vc_column_inner][/vc_row_inner][/tab][tab icon_family="iconsmind" title="Scorching Design" id="1517823751641-3-0" tab_id="1517863323642-9" icon_iconsmind="iconsmind-Fire-Flame"][vc_row_inner column_margin="default" top_padding="20" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-3-percent" column_padding_position="all" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/4" column_border_width="none" column_border_style="solid"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color="grey" icon_padding="0px" icon_iconsmind="iconsmind-Upload-toCloud" url="#"][vc_column_text css_animation="fadeInUp" css=".vc_custom_1485869613252{margin-bottom: 15px !important;}"]
<h5>Upload your ideas to Salient</h5>
[/vc_column_text][vc_custom_heading text="Far far away, behind the word mountains, far from the countries Vokalia and texts" font_container="tag:p|text_align:center|color:rgba(10%2C10%2C10%2C0.65)" use_theme_fonts="yes" css_animation="fadeInUp"][/vc_column_inner][vc_column_inner column_padding="padding-3-percent" column_padding_position="all" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/4" column_border_width="none" column_border_style="solid"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color="grey" icon_padding="0px" icon_iconsmind="iconsmind-Tripod-andVideo" url="#"][vc_column_text css_animation="fadeInUp" css=".vc_custom_1517863865199{margin-bottom: 15px !important;}"]
<h5>Watch video tutorials</h5>
[/vc_column_text][vc_custom_heading text="Far far away, behind the word mountains, far from the countries Vokalia and texts" font_container="tag:p|text_align:center|color:rgba(10%2C10%2C10%2C0.65)" use_theme_fonts="yes" css_animation="fadeInUp"][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-3-percent" column_padding_position="all" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/4" column_border_width="none" column_border_style="solid" delay="100"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color="grey" icon_padding="0px" icon_iconsmind="iconsmind-D-Eyeglasses2" url="#"][vc_column_text css_animation="fadeInUp" css=".vc_custom_1485869633028{margin-bottom: 15px !important;}"]
<h5>Watch the magic happen</h5>
[/vc_column_text][vc_custom_heading text="Far far away, behind the word mountains, far from the countries Vokalia and texts" font_container="tag:p|text_align:center|color:rgba(10%2C10%2C10%2C0.65)" use_theme_fonts="yes" css_animation="fadeInUp"][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-3-percent" column_padding_position="all" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/4" column_border_width="none" column_border_style="solid" delay="200"][nectar_icon icon_family="iconsmind" icon_style="default" icon_color="grey" icon_padding="0px" icon_iconsmind="iconsmind-Happy" url="#"][vc_column_text css_animation="fadeInUp" css=".vc_custom_1485869652646{margin-bottom: 15px !important;}"]
<h5>Enjoy your increased revenue</h5>
[/vc_column_text][vc_custom_heading text="Far far away, behind the word mountains, far from the countries Vokalia and texts" font_container="tag:p|text_align:center|color:rgba(10%2C10%2C10%2C0.65)" use_theme_fonts="yes" css_animation="fadeInUp"][/vc_column_inner][/vc_row_inner][/tab][tab icon_family="iconsmind" title="Clothing" id="1517663483844-2-1" tab_id="1517863323687-5" icon_iconsmind="iconsmind-Blouse"][vc_row_inner column_margin="default" top_padding="20" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1487092529487{margin-bottom: 20px !important;}"]
<h3>A wonderful serenity has <em>taken possession</em> of my entire soul, like these sweet mornings of spring which I enjoy with my<em> whole heart</em>.</h3>
[/vc_column_text][nectar_video_lightbox link_style="play_button_with_text" nectar_play_button_color="Default-Accent-Color" font_style="p" video_url="https://www.youtube.com/watch?v=6oTurM7gESE" link_text="<strong>Introduction Video </strong> — 30 seconds"][/vc_column_inner][/vc_row_inner][/tab][/tabbed_section][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );





$data = array();
$data['name'] = esc_html__( 'Fun Image Arrangement With Color Strip BG', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['general'];
$data['custom_class'] = 'general date-18-Nov-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/broken-image-grid-1.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" scene_position="center" text_color="light" text_align="left" top_padding="7%" bottom_padding="7%" overlay_strength="0.3" enable_shape_divider="true" shape_divider_color="#3452ff" shape_divider_position="bottom" shape_divider_height="40%" shape_type="straight_section"][vc_column enable_animation="true" animation="fade-in" column_padding="padding-2-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner equal_height="yes" content_placement="bottom" column_margin="none" text_align="left"][vc_column_inner column_padding="padding-1-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/2" column_border_width="none" column_border_style="solid" offset="vc_col-xs-6"][image_with_animation image_url="https://themenectar.com/img/demo-media/unsplash/webp/800-500-room.webp" alignment="" animation="None" border_radius="none" box_shadow="none" max_width="100%"][/vc_column_inner][vc_column_inner column_padding="padding-1-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/3" column_border_width="none" column_border_style="solid" offset="vc_col-xs-4"][image_with_animation image_url="https://themenectar.com/img/demo-media/unsplash/webp/800-500-watch.webp" alignment="" animation="None" border_radius="none" box_shadow="none" max_width="100%"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/6" column_border_width="none" column_border_style="solid"][/vc_column_inner][/vc_row_inner][vc_row_inner equal_height="yes" content_placement="top" column_margin="none" text_align="left"][vc_column_inner column_padding="padding-2-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/12" column_border_width="none" column_border_style="solid" offset="vc_col-xs-1"][/vc_column_inner][vc_column_inner column_padding="padding-1-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/4" column_border_width="none" column_border_style="solid" offset="vc_col-xs-3"][image_with_animation image_url="https://themenectar.com/img/demo-media/unsplash/webp/600-800-waterfall.webp" alignment="" animation="None" border_radius="none" box_shadow="x_large_depth" max_width="100%"][/vc_column_inner][vc_column_inner column_padding="padding-1-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/3" column_border_width="none" column_border_style="solid" offset="vc_col-xs-4"][image_with_animation image_url="https://themenectar.com/img/demo-media/unsplash/webp/600-800-trees.webp" alignment="" animation="None" border_radius="none" box_shadow="x_large_depth" max_width="100%"][/vc_column_inner][vc_column_inner column_padding="padding-1-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/3" column_border_width="none" column_border_style="solid" offset="vc_col-xs-4"][image_with_animation image_url="https://themenectar.com/img/demo-media/unsplash/webp/600-600-girl.webp" alignment="" animation="None" border_radius="none" box_shadow="x_large_depth" max_width="100%"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Image Arrangement', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['general'];
$data['custom_class'] = 'general date-18-Nov-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/broken-image-grid-2.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" scene_position="center" text_color="light" text_align="left" top_padding="7%" bottom_padding="7%" overlay_strength="0.3" shape_divider_position="bottom" shape_type="straight_section"][vc_column enable_animation="true" animation="fade-in" column_padding="padding-2-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner equal_height="yes" content_placement="bottom" column_margin="none" text_align="left"][vc_column_inner column_padding="padding-1-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/2" column_border_width="none" column_border_style="solid" offset="vc_col-xs-6"][image_with_animation image_url="https://themenectar.com/img/demo-media/unsplash/webp/600-600-girl.webp" alignment="" animation="None" border_radius="none" box_shadow="none" max_width="100%"][/vc_column_inner][vc_column_inner column_padding="padding-1-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/3" column_border_width="none" column_border_style="solid" offset="vc_col-xs-4"][image_with_animation image_url="https://themenectar.com/img/demo-media/unsplash/webp/500-500-sky.webp" alignment="" animation="None" border_radius="none" box_shadow="none" max_width="100%"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/6" column_border_width="none" column_border_style="solid"][/vc_column_inner][/vc_row_inner][vc_row_inner equal_height="yes" content_placement="top" column_margin="none" text_align="left"][vc_column_inner column_padding="padding-2-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/12" column_border_width="none" column_border_style="solid" offset="vc_col-xs-1"][/vc_column_inner][vc_column_inner column_padding="padding-1-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/4" column_border_width="none" column_border_style="solid" offset="vc_col-xs-3"][image_with_animation image_url="https://themenectar.com/img/demo-media/unsplash/webp/500-500-forest.webp" alignment="" animation="None" border_radius="none" box_shadow="x_large_depth" max_width="100%"][/vc_column_inner][vc_column_inner column_padding="padding-1-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/3" column_border_width="none" column_border_style="solid" offset="vc_col-xs-4"][image_with_animation image_url="https://themenectar.com/img/demo-media/unsplash/webp/500-500-building.webp" alignment="" animation="None" border_radius="none" box_shadow="x_large_depth" max_width="100%"][/vc_column_inner][vc_column_inner column_padding="padding-1-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/3" column_border_width="none" column_border_style="solid" offset="vc_col-xs-4"][image_with_animation image_url="https://themenectar.com/img/demo-media/unsplash/webp/700-700-earphones.webp" alignment="" animation="None" border_radius="none" box_shadow="x_large_depth" max_width="100%"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Blog Category Grid', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['blog'];
$data['custom_class'] = 'blog date-24-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/blog-categories.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" scene_position="center" text_color="dark" text_align="left" top_padding="6%" bottom_padding="6%" overlay_strength="0.3" shape_divider_position="bottom" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][nectar_category_grid post_type="posts" blog_category="all" text_content_alignment="bottom_left" subtext="cat_item_count" columns="4" grid_item_spacing="10px" enable_masonry="yes" color_overlay="#000000" color_overlay_opacity="0.2" color_overlay_hover_opacity="0.4" text_color="light" text_color_hover="light" shadow_on_hover="yes" subtext_visibility="on_hover" orderby="" order="" text_style="" color_strip_bg="" color_strip_bg_hover="" color_strip_text="" color_strip_text_hover="" block_sizing="square"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'Single Word Text Highlight', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-12-Nov-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/highlight-text-half.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" scene_position="center" text_color="dark" text_align="left" top_padding="6%" bottom_padding="6%" overlay_strength="0.3" shape_divider_position="bottom" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][nectar_highlighted_text style="half_text"]
<h2 style="text-align: center;"><em>#NECTARSHOP</em></h2>
[/nectar_highlighted_text][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Interesting Dark Instagram Link', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-12-Nov-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/insta-link.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_color="#242828" scene_position="center" text_color="light" text_align="left" top_padding="5%" bottom_padding="5%" overlay_strength="0.3" shape_divider_position="bottom" shape_divider_height="50%" shape_type="straight_section"][vc_column enable_animation="true" animation="fade-in" column_padding="padding-2-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][nectar_highlighted_text highlight_color="#3452ff" style="half_text"]
<h1 style="text-align: center;"><em>@NECTARSHOP</em></h1>
[/nectar_highlighted_text][nectar_cta btn_style="underline" heading_tag="h5" text_color="#ffffff" link_type="regular" alignment="center" text="Follow Us On" link_text="Instagram" url="#"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'Key Points With Soft Color Icons', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['general'] .', '. $cat_display_names['icons'];
$data['custom_class'] = 'general icons date-18-Nov-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/key-points.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_color="#ffffff" scene_position="center" text_color="dark" text_align="left" top_padding="7%" bottom_padding="7%" overlay_strength="1" shape_divider_position="bottom" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" column_border_width="none" column_border_style="solid"][split_line_heading animation_type="default"]
<h2>If you wish to make an apple</h2>
<h2>pie from scratch, you must first</h2>
<h2>invent the universe.</h2>
[/split_line_heading][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-3-percent" column_padding_position="top" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/3" column_border_width="none" column_border_style="solid"][nectar_icon icon_family="iconsmind" icon_style="soft-bg" icon_color="Accent-Color" icon_padding="10px" icon_iconsmind="iconsmind-Plant" icon_size="40" margin_bottom="30"][vc_column_text css=".vc_custom_1531919831641{padding-right: 10% !important;}"]
<h4>Sustainable Materials</h4>
Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove.[/vc_column_text][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-3-percent" column_padding_position="top" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/3" column_border_width="none" column_border_style="solid" delay="100"][nectar_icon icon_family="iconsmind" icon_style="soft-bg" icon_color="Accent-Color" icon_padding="10px" icon_iconsmind="iconsmind-Shirt" icon_size="40" margin_bottom="30"][vc_column_text css=".vc_custom_1531919836584{padding-right: 10% !important;}"]
<h4>Tailored Fit</h4>
Even the all-powerful Pointing has no control about the blind texts. One day a line of blind text by the name of Lorem Ipsum decided to leave.[/vc_column_text][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-3-percent" column_padding_position="top" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/3" column_border_width="none" column_border_style="solid" delay="200"][nectar_icon icon_family="iconsmind" icon_style="soft-bg" icon_color="Accent-Color" icon_padding="10px" icon_iconsmind="iconsmind-Plane" icon_size="40" margin_bottom="30"][vc_column_text css=".vc_custom_1531919841519{padding-right: 10% !important;}"]
<h4>Fast Shipping</h4>
A small river named Duden flows by their place and supplies it with the necessary regelialia. It is a paradisematic country.[/vc_column_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" top_padding="20" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" column_border_width="none" column_border_style="solid"][nectar_cta btn_style="underline" heading_tag="h5" text_color="#0a0000" link_type="regular" alignment="left" link_text="Learn More" url="#"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'Minimal Underlined Heading', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['general'];
$data['custom_class'] = 'general date-18-Nov-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/light-underlined-text.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" scene_position="center" text_color="dark" text_align="left" top_padding="5%" bottom_padding="5%" overlay_strength="0.3" shape_divider_position="bottom" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/4" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][nectar_highlighted_text highlight_color="rgba(52,82,255,0.43)" style="half_text"]
<h2 style="text-align: center;">Style is a way to say <em>who you are</em> without saying anything at all.</h2>
[/nectar_highlighted_text][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/4" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Heading With Underlined Link Dark', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['general'] .', '. $cat_display_names['cta'];
$data['custom_class'] = 'general cta date-29-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/underlined-cta-dark.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="in_container" full_screen_row_position="middle" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-mountain.webp" bg_position="center center" bg_repeat="no-repeat" parallax_bg="true" parallax_bg_speed="fast" scene_position="center" text_color="light" text_align="left" top_padding="8%" bottom_padding="8%" color_overlay="#0c0c0c" overlay_strength="0.5" shape_divider_position="bottom" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/6" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][vc_column enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-5-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="2/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][nectar_highlighted_text highlight_color="#ff1053" style="half_text"]
<h2 style="text-align: center;">Style is a way to say <a href="https://themenectar.com" target="_blank" rel="noopener"><em>who you are</em></a> without saying anything at all.</h2>
[/nectar_highlighted_text][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/6" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );





$data = array();
$data['name'] = esc_html__( 'Image BG Simple CTA', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['cta'];
$data['custom_class'] = 'cta date-30-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/bg-img-cta.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" equal_height="yes" content_placement="middle" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-mountain.webp" bg_position="center center" bg_repeat="no-repeat" bg_color="#ffffff" scene_position="center" text_color="light" text_align="left" top_padding="80" bottom_padding="80" color_overlay="#3452ff" overlay_strength="0.95" shape_divider_position="bottom" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="5/12" tablet_text_alignment="center" phone_text_alignment="center" column_border_width="none" column_border_style="solid"][nectar_highlighted_text highlight_color="#ff1053" style="half_text"]
<h2>Sign Up <em>Today</em> &amp; Start Sending Money.</h2>
[/nectar_highlighted_text][vc_column_text css=".vc_custom_1485272593024{margin-top: 15px !important;}"]Get 30 days free when you sign up now.[/vc_column_text][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/12" tablet_text_alignment="center" phone_text_alignment="center" column_border_width="none" column_border_style="solid"][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/2" tablet_text_alignment="center" phone_text_alignment="center" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="right"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" column_border_width="none" column_border_style="solid"][nectar_btn size="jumbo" button_style="see-through-2" color_override="#ffffff" hover_color_override="#ffffff" hover_text_color_override="#000000" icon_family="default_arrow" url="#" text="Sign Up Now"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'Even Columns With Buttons', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general']  .', '. $cat_display_names['icons'];
$data['custom_class'] = 'general icons date-01-Nov-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/text-content-and-buttons.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" equal_height="yes" content_placement="top" scene_position="center" text_color="dark" text_align="left" top_padding="10%" bottom_padding="10%" overlay_strength="0.3" shape_divider_position="bottom" shape_type=""][vc_column enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-3-percent" column_padding_position="right" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" bottom_padding="60" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/5" column_border_width="none" column_border_style="solid"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="3/5" column_border_width="none" column_border_style="solid"][vc_column_text css_animation="none"]
<h2>Imagination is everything. It is the preview of life's coming attractions.</h2>
[/vc_column_text][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/5" column_border_width="none" column_border_style="solid"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" bottom_padding="40" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-1-percent" column_padding_position="all" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/4" column_border_width="none" column_border_style="solid"][nectar_icon icon_family="fontawesome" icon_style="soft-bg" icon_color="black" icon_padding="10px" icon_size="24" margin_top="20" icon_fontawesome="fa fa-handshake-o"][vc_column_text css_animation="none" css=".vc_custom_1532176384930{margin-bottom: 15px !important;}"]
<h4>We Deploy Our Strategies Unbelievably Fast</h4>
[/vc_column_text][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-1-percent" column_padding_position="all" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/4" column_border_width="none" column_border_style="solid" delay="100"][nectar_icon icon_family="fontawesome" icon_style="soft-bg" icon_color="black" icon_padding="10px" icon_size="24" margin_top="20" icon_fontawesome="fa fa-motorcycle"][vc_column_text css_animation="none" css=".vc_custom_1532176380836{margin-bottom: 15px !important;}"]
<h4>Great Customer Support Is  What We're About</h4>
[/vc_column_text][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-1-percent" column_padding_position="all" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/4" column_border_width="none" column_border_style="solid" delay="200"][nectar_icon icon_family="fontawesome" icon_style="soft-bg" icon_color="black" icon_padding="10px" icon_size="24" margin_top="20" icon_fontawesome="fa fa-leaf"][vc_column_text css_animation="none" css=".vc_custom_1532176376162{margin-bottom: 15px !important;}"]
<h4>We Make Killer Designs For Amazing Clients</h4>
[/vc_column_text][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-1-percent" column_padding_position="all" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/4" column_border_width="none" column_border_style="solid" delay="300"][nectar_icon icon_family="fontawesome" icon_style="soft-bg" icon_color="black" icon_padding="10px" icon_size="24" margin_top="20" icon_fontawesome="fa fa-graduation-cap"][vc_column_text css_animation="none" css=".vc_custom_1532176389381{margin-bottom: 15px !important;}"]
<h4>Developing Business Models For 10 Year</h4>
[/vc_column_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" top_padding="10" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" column_border_width="none" column_border_style="solid"][nectar_btn size="jumbo" button_style="regular" button_color_2="Accent-Color" icon_family="none" url="#" text="Discover" margin_right="10" margin_left="10"][nectar_btn size="jumbo" button_style="regular" button_color_2="Extra-Color-1" icon_family="none" url="#" text="Contact Us" margin_right="10" margin_left="10"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );





$data = array();
$data['name'] = esc_html__( 'Creative Testimonials With Shape Divider', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['testimonials'];
$data['custom_class'] = 'testimonials date-02-Nov-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/sweet-testimonials.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" equal_height="yes" content_placement="middle" bg_color="#e1e4f7" scene_position="center" text_color="dark" text_align="left" top_padding="9%" bottom_padding="12%" overlay_strength="1" enable_shape_divider="true" shape_divider_color="#ffffff" shape_divider_position="bottom" shape_divider_height="40%" shape_type="curve_opacity"][vc_column column_padding="no-extra-padding" column_padding_position="right" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1507069609150{margin-bottom: 5px !important;}"]
<h5>Check This Out</h5>
[/vc_column_text][vc_column_text]
<h2 class="center">Our Clients Absolutely Adore Us</h2>
[/vc_column_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" top_padding="3%" text_align="left"][vc_column_inner enable_animation="true" animation="grow-in" column_padding="padding-2-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/3" column_border_width="none" column_border_style="solid"][nectar_single_testimonial testimonial_style="basic_left_image" image="https://themenectar.com/img/demo-media/unsplash/webp/small-smile-guy.webp" quote="Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vivamus tempus consectetur mi nec hendrerit. Integer id est massa." name="Kara Lucas" subtitle="Interior Decorator"][/vc_column_inner][vc_column_inner enable_animation="true" animation="grow-in" column_padding="padding-2-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/3" column_border_width="none" column_border_style="solid" delay="100"][nectar_single_testimonial testimonial_style="basic_left_image" image="https://themenectar.com/img/demo-media/unsplash/webp/small-smile-guy.webp" quote="Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vivamus tempus consectetur mi nec hendrerit. Integer id est massa." name="Alley Cohen" subtitle="Designer"][/vc_column_inner][vc_column_inner enable_animation="true" animation="grow-in" column_padding="padding-2-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/3" column_border_width="none" column_border_style="solid" delay="200"][nectar_single_testimonial testimonial_style="basic_left_image" image="https://themenectar.com/img/demo-media/unsplash/webp/small-smile-guy.webp" quote="Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vivamus tempus consectetur mi nec hendrerit. Integer id est massa." name="Jason Smith" subtitle="Developer"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" column_border_width="none" column_border_style="solid"][nectar_btn size="jumbo" button_style="regular" button_color_2="Extra-Color-1" icon_family="default_arrow" text="See All Testimonials" margin_top="15"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Light Gradient Call To Action', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['cta'];
$data['custom_class'] = 'cta date-03-Nov-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/light-cta.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" equal_height="yes" content_placement="middle" scene_position="center" text_color="dark" text_align="left" top_padding="6%" bottom_padding="6%" overlay_strength="0.3" shape_divider_position="bottom" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/6" column_border_width="none" column_border_style="solid"][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in" column_padding="padding-2-percent" column_padding_position="left-right" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="2/3" column_border_width="none" column_border_style="solid"][nectar_gradient_text heading_tag="h5" color="extra-color-gradient-2" gradient_direction="horizontal" text="Together We Build Dreams" margin_bottom="10"][vc_custom_heading text="Ready To See What's Next?" font_container="tag:h2|font_size:52|text_align:center|line_height:52px" use_theme_fonts="yes" css_animation="fadeInUp"][divider line_type="No Line" custom_height="10"][vc_custom_heading text="Like Nothing You've Seen. Sign Up Today &amp; Experience Salient" font_container="tag:p|text_align:center|color:rgba(0%2C0%2C0%2C0.7)" use_theme_fonts="yes" css_animation="fadeInUp" css=".vc_custom_1532179760585{margin-top: 10px !important;margin-bottom: 10px !important;}"][nectar_btn size="jumbo" button_style="regular" button_color_2="extra-color-gradient-2" icon_family="default_arrow" url="#" text="Sign Up Today" css_animation="zoomIn" margin_top="30"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/6" column_border_width="none" column_border_style="solid"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'Modern Vertical Tabbed Section', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-04-Nov-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/vertical-tabs-material.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_color="#ffffff" scene_position="center" text_color="dark" text_align="left" top_padding="6%" bottom_padding="6%" overlay_strength="0.3" shape_divider_position="bottom" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][tabbed_section style="vertical_modern" tab_color="Accent-Color"][tab icon_family="iconsmind" title="Enforcement" id="1532183515355-2a409-746f" icon_iconsmind="iconsmind-Police-Man" tab_id="1532189429947-7"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="2/3" column_border_width="none" column_border_style="solid"][vc_custom_heading text="Creator of quality designs and thinker of fresh ideas." font_container="tag:h2|font_size:40|text_align:left|line_height:50px" use_theme_fonts="yes"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/3" column_border_width="none" column_border_style="solid"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-3-percent" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/2" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1485638236800{padding-right: 10% !important;}"]Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean. A small river named Duden flows by their place and supplies it with the necessary regelialia. It is a paradisematic country, in which roasted parts of sentences fly into your mouth.[/vc_column_text][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-3-percent" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/2" column_border_width="none" column_border_style="solid" delay="100"][vc_column_text css=".vc_custom_1485638241294{padding-right: 10% !important;}"]Even the all-powerful Pointing has no control about the blind texts it is an almost unorthographic life One day however a small line of blind text by the name of Lorem Ipsum decided to leave for the far World of Grammar. The Big Oxmox advised her not to do so, because there were thousands of bad Commas, wild Question Marks and devious Semikoli.[/vc_column_text][/vc_column_inner][/vc_row_inner][/tab][tab icon_family="iconsmind" title="Lightning" id="1532183515615-0a409-746f" icon_iconsmind="iconsmind-Thunder" tab_id="1532189430070-5"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="2/3" column_border_width="none" column_border_style="solid"][vc_custom_heading text="Look deep into nature, and then you will understand everything better." font_container="tag:h2|font_size:40|text_align:left|line_height:50px" use_theme_fonts="yes"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/3" column_border_width="none" column_border_style="solid"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-3-percent" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/2" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1485638236800{padding-right: 10% !important;}"]Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean. A small river named Duden flows by their place and supplies it with the necessary regelialia. It is a paradisematic country, in which roasted parts of sentences fly into your mouth.[/vc_column_text][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-3-percent" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/2" column_border_width="none" column_border_style="solid" delay="100"][vc_column_text css=".vc_custom_1485638241294{padding-right: 10% !important;}"]Even the all-powerful Pointing has no control about the blind texts it is an almost unorthographic life One day however a small line of blind text by the name of Lorem Ipsum decided to leave for the far World of Grammar. The Big Oxmox advised her not to do so, because there were thousands of bad Commas, wild Question Marks and devious Semikoli.[/vc_column_text][/vc_column_inner][/vc_row_inner][/tab][tab icon_family="iconsmind" title="Scorching Design" id="1542183515734-7a409-746f" icon_iconsmind="iconsmind-Fire-Flame" tab_id="1532189430246-6"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="2/3" column_border_width="none" column_border_style="solid"][vc_custom_heading text="Try not to become a man of success, but rather try to become a man of value." font_container="tag:h2|font_size:40|text_align:left|line_height:50px" use_theme_fonts="yes"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/3" column_border_width="none" column_border_style="solid"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-3-percent" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/2" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1485638236800{padding-right: 10% !important;}"]Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean. A small river named Duden flows by their place and supplies it with the necessary regelialia. It is a paradisematic country, in which roasted parts of sentences fly into your mouth.[/vc_column_text][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-3-percent" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/2" column_border_width="none" column_border_style="solid" delay="100"][vc_column_text css=".vc_custom_1485638241294{padding-right: 10% !important;}"]Even the all-powerful Pointing has no control about the blind texts it is an almost unorthographic life One day however a small line of blind text by the name of Lorem Ipsum decided to leave for the far World of Grammar. The Big Oxmox advised her not to do so, because there were thousands of bad Commas, wild Question Marks and devious Semikoli.[/vc_column_text][/vc_column_inner][/vc_row_inner][/tab][tab icon_family="iconsmind" title="Clothing" id="1532183516284-3a409-746f" icon_iconsmind="iconsmind-Bee" tab_id="1532189430412-6"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="2/3" column_border_width="none" column_border_style="solid"][vc_custom_heading text="The true sign of intelligence is not knowledge but imagination." font_container="tag:h2|font_size:40|text_align:left|line_height:50px" use_theme_fonts="yes"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/3" column_border_width="none" column_border_style="solid"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-3-percent" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/2" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1485638236800{padding-right: 10% !important;}"]Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean. A small river named Duden flows by their place and supplies it with the necessary regelialia. It is a paradisematic country, in which roasted parts of sentences fly into your mouth.[/vc_column_text][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-3-percent" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/2" column_border_width="none" column_border_style="solid" delay="100"][vc_column_text css=".vc_custom_1485638241294{padding-right: 10% !important;}"]Even the all-powerful Pointing has no control about the blind texts it is an almost unorthographic life One day however a small line of blind text by the name of Lorem Ipsum decided to leave for the far World of Grammar. The Big Oxmox advised her not to do so, because there were thousands of bad Commas, wild Question Marks and devious Semikoli.[/vc_column_text][/vc_column_inner][/vc_row_inner][/tab][/tabbed_section][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );





$data = array();
$data['name'] = esc_html__( 'Leaflet Interactive Map', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['google_map'];
$data['custom_class'] = 'map date-05-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/leaflet-map.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" scene_position="center" text_color="dark" text_align="left" overlay_strength="0.3" shape_divider_position="bottom"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][nectar_gmap map_type="leaflet" zoom="6" marker_style="default" color="accent-color" leaflet_map_greyscale="1" infowindow_start_open="1" size="700" map_center_lat="39.949" map_center_lng="-75.171" map_markers="39.949|-75.171|Our Location"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );





$data = array();
$data['name'] = esc_html__( 'Wonderful Product Collection Parallax', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general']  .', '. $cat_display_names['shop'];
$data['custom_class'] = 'general shop date-13-Nov-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/featured-collections.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#333333" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-art.webp" bg_position="center center" background_image_loading="default" bg_repeat="no-repeat" scene_position="center" top_padding="18%" bottom_padding="18%" text_color="light" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" color_overlay="rgba(10,10,10,0.78)" overlay_strength="0.8" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" parallax_bg="true" parallax_bg_speed="fast" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1532368660277{margin-bottom: 5px !important;}"]
<h4>Summer Collection</h4>
[/vc_column_text][vc_column_text css_animation="none" css=".vc_custom_1532366822753{margin-bottom: 15px !important;}"]
<h2>Bathing Suits</h2>
[/vc_column_text][vc_column_text css_animation="none" max_width="500" css=".vc_custom_1532366818395{margin-bottom: 30px !important;}"]Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean.[/vc_column_text][nectar_cta btn_style="underline" heading_tag="h5" button_color="default" text_color="#ffffff" button_border_thickness="0px" link_type="regular" alignment="left" alignment_tablet="default" alignment_phone="default" display="block" display_tablet="inherit" display_phone="inherit" icon_family="none" link_text="Browse Collection" url="#"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/2" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row][vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#333333" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-music.webp" bg_position="right center" background_image_loading="default" bg_repeat="no-repeat" scene_position="center" top_padding="18%" bottom_padding="18%" text_color="light" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" color_overlay="#0a0a0a" overlay_strength="0.5" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" parallax_bg="true" parallax_bg_speed="fast" shape_type="" gradient_type="default"][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="2/3" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1532368666674{margin-bottom: 5px !important;}"]
<h4>Summer Collection</h4>
[/vc_column_text][vc_column_text css_animation="none" css=".vc_custom_1532368205362{margin-bottom: 15px !important;}"]
<h2>Breathable Pants</h2>
[/vc_column_text][vc_column_text css_animation="none" max_width="500" css=".vc_custom_1532366818395{margin-bottom: 30px !important;}"]Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean.[/vc_column_text][nectar_cta btn_style="underline" heading_tag="h5" button_color="default" text_color="#ffffff" button_border_thickness="0px" link_type="regular" alignment="left" alignment_tablet="default" alignment_phone="default" display="block" display_tablet="inherit" display_phone="inherit" icon_family="none" link_text="Browse Collection" url="#"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row][vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#333333" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-adventure.webp" bg_position="center center" background_image_loading="default" bg_repeat="no-repeat" scene_position="center" top_padding="18%" bottom_padding="18%" text_color="light" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" color_overlay="#0a0a0a" overlay_strength="0.8" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" parallax_bg="true" parallax_bg_speed="fast" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/6" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" centered_text="true" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="2/3" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1532368672431{margin-bottom: 5px !important;}"]
<h4>Summer Collection</h4>
[/vc_column_text][vc_column_text css_animation="none" css=".vc_custom_1532368218567{margin-bottom: 15px !important;}"]
<h2>Adventure Clothes</h2>
[/vc_column_text][vc_column_text css_animation="none" max_width="500" css=".vc_custom_1532366818395{margin-bottom: 30px !important;}"]Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean.[/vc_column_text][nectar_cta btn_style="underline" heading_tag="h5" button_color="default" text_color="#ffffff" button_border_thickness="0px" link_type="regular" alignment="center" alignment_tablet="default" alignment_phone="default" display="block" display_tablet="inherit" display_phone="inherit" icon_family="none" link_text="Browse Collection" url="#"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/6" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Shop Sale Section', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general']  .', '. $cat_display_names['shop'];
$data['custom_class'] = 'general shop date-07-Nov-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/shop-sale-col.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_color="#ffffff" scene_position="center" text_color="light" text_align="left" top_padding="30" bottom_padding="30" overlay_strength="0.3" shape_divider_position="bottom" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in" background_image="https://themenectar.com/img/demo-media/unsplash/webp/700-700-devices-yellow.webp" enable_bg_scale="true" column_padding="padding-7-percent" column_padding_position="all" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="5px" column_link_target="_self" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid"][vc_column_text css_animation="none"]
<h4>A summer exclusive deal</h4>
[/vc_column_text][vc_custom_heading text="50% off" font_container="tag:h1|font_size:100px|text_align:center|color:%23ffffff" use_theme_fonts="yes"][vc_column_text max_width="400" css=".vc_custom_1534967899684{margin-top: 15px !important;}"]Far far away, behind the word mountains, far from the countries Vokalia and Consonantia.[/vc_column_text][nectar_cta btn_style="underline" heading_tag="h5" text_color="#ffffff" link_type="regular" alignment="center" link_text="Shop Now" url="#"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Overflowing Title Gradient CTA', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['cta'];
$data['custom_class'] = 'cta date-08-Nov-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/cta-overlap-box.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="in_container" full_screen_row_position="middle" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-mountain.webp" bg_position="center center" bg_repeat="no-repeat" parallax_bg="true" parallax_bg_speed="fast" scene_position="center" text_color="light" text_align="left" bottom_padding="8%" enable_gradient="true" color_overlay="#3452ff" color_overlay_2="#ff1053" gradient_direction="left_t_to_right_b" overlay_strength="0.8" shape_divider_position="bottom" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/6" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" offset="vc_hidden-sm vc_hidden-xs"][/vc_column][vc_column enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="2/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" offset="vc_col-lg-offset-0 vc_col-md-offset-0"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/3" column_border_width="none" column_border_style="solid" offset="vc_col-xs-3"][/vc_column_inner][vc_column_inner column_padding="padding-6-percent" column_padding_position="all" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" top_margin="-45" column_link_target="_self" width="1/3" column_border_width="8px" column_border_color="#f4f4f4" column_border_style="solid" offset="vc_col-lg-offset-0 vc_col-md-offset-0 vc_col-sm-offset-0 vc_col-xs-6"][divider line_type="No Line" custom_height="25"][vc_column_text css=".vc_custom_1532371457622{margin-bottom: 0px !important;padding-bottom: 0px !important;}"]
<h4>Reach Out</h4>
[/vc_column_text][divider line_type="No Line" custom_height="25"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/3" column_border_width="none" column_border_style="solid" offset="vc_hidden-sm vc_hidden-xs"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" top_padding="10%" text_align="left"][vc_column_inner column_padding="padding-2-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/6" column_border_width="none" column_border_style="solid" offset="vc_col-xs-2"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="2/3" column_border_width="none" column_border_style="solid" offset="vc_col-lg-offset-0 vc_col-md-offset-0 vc_col-xs-8"][nectar_highlighted_text highlight_color="#ff1053" style="half_text"]
<h2 style="text-align: center;">Ready to take the next move? Get in touch <em>today</em></h2>
[/nectar_highlighted_text][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/6" column_border_width="none" column_border_style="solid"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/6" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'Blog Post Carousel Split Color BG', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['blog'];
$data['custom_class'] = 'blog date-09-Nov-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/blog-split-bg.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" bg_color="#ffffff" scene_position="center" text_color="light" text_align="left" top_padding="6%" bottom_padding="5%" overlay_strength="0.3" enable_shape_divider="true" shape_divider_color="#3452ff" shape_divider_position="bottom" shape_divider_height="50%" shape_type="straight_section"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_custom_heading text="We Write Sometimes" font_container="tag:h5|text_align:center|color:%23000000" use_theme_fonts="yes" css=".vc_custom_1532373327184{margin-bottom: 10px !important;}"][vc_custom_heading text="Fresh From The Blog" font_container="tag:h2|text_align:center|color:%233452ff" use_theme_fonts="yes" css=".vc_custom_1532373516395{margin-bottom: 5% !important;}"][divider line_type="No Line" custom_height="20"][recent_posts style="slider_multiple_visible" category="all" columns="4" button_color="Accent-Color" hover_shadow_type="dark" order="DESC" orderby="date" posts_per_page="6"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'Recent Posts Split Parallax BG', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['blog'];
$data['custom_class'] = 'blog';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/recent-posts-overlap.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-mountain.webp" bg_position="left top" bg_repeat="no-repeat" parallax_bg="true" parallax_bg_speed="fast" scene_position="center" text_color="dark" text_align="left" top_padding="8%" bottom_padding="10%" color_overlay="#3452ff" overlay_strength="0.8" shape_divider_position="bottom" shape_type="straight_section"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" font_color="#ffffff" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" column_border_width="none" column_border_style="solid"][split_line_heading]
<h2>The best Wordpress</h2>
<h2>articles, written daily.</h2>
[/split_line_heading][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" bottom_padding="7%" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-3-percent" column_padding_position="top" background_color_opacity="1" background_hover_color_opacity="1" font_color="#ffffff" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/2" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1532380343090{padding-right: 10% !important;}"]
<h4>Expert Authors</h4>
[/vc_column_text][vc_custom_heading text="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove." font_container="tag:p|text_align:left|color:rgba(255%2C255%2C255%2C0.73)" use_theme_fonts="yes" css=".vc_custom_1532379238082{padding-right: 7% !important;}"][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-3-percent" column_padding_position="top" background_color_opacity="1" background_hover_color_opacity="1" font_color="#ffffff" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/2" column_border_width="none" column_border_style="solid" delay="100"][vc_column_text css=".vc_custom_1532380349040{padding-right: 10% !important;}"]
<h4>Useful Content</h4>
[/vc_column_text][vc_custom_heading text="Even the all-powerful Pointing has no control about the blind texts. One day a line of blind text by the name of Lorem Ipsum decided to leave." font_container="tag:p|text_align:left|color:rgba(255%2C255%2C255%2C0.73)" use_theme_fonts="yes" css=".vc_custom_1532379243556{padding-right: 7% !important;}"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row][vc_row type="full_width_background" full_screen_row_position="middle" scene_position="center" text_color="dark" text_align="left" bottom_padding="8%" overlay_strength="0.8" shape_divider_position="bottom" shape_type="straight_section"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" top_margin="-12%" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" column_border_width="none" column_border_style="solid"][recent_posts style="list_featured_first_row" category="all" columns="3" order="DESC" orderby="date" posts_per_page="3" post_offset="0"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'Image And Text Overlapping', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-11-Nov-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/overlap-img-alt.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" equal_height="yes" content_placement="middle" bg_color="#ffffff" scene_position="center" text_color="dark" text_align="left" top_padding="10%" bottom_padding="10%" id="discover" overlay_strength="0.3" shape_divider_position="bottom" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="2/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][image_with_animation image_url="https://themenectar.com/img/demo-media/unsplash/webp/large-clouds.webp" alignment="" animation="Grow In" border_radius="none" box_shadow="none" max_width="110%"][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left" css=".vc_custom_1504128844236{margin-right: -1px !important;}"][vc_column_inner enable_animation="true" animation="fade-in-from-left" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" column_border_width="none" column_border_style="solid"][vc_custom_heading text="Quality is what matters most" font_container="tag:h2|font_size:40|text_align:left|line_height:50px" use_theme_fonts="yes"][vc_column_text css=".vc_custom_1532382151945{margin-top: 30px !important;margin-bottom: 30px !important;}"]Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. A small river named Duden flows.[/vc_column_text][nectar_btn size="large" button_style="regular" button_color_2="extra-color-gradient-2" icon_family="default_arrow" url="https://themeforest.net/item/salient-responsive-multipurpose-theme/4363266" text="Learn More" css_animation="none" margin_top="20"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'Horizontal List Items', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general']  .', '. $cat_display_names['icons']  .', '. $cat_display_names['services'];
$data['custom_class'] = 'general icons services date-18-Nov-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/hor-list-items-light.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" equal_height="yes" content_placement="middle" scene_position="center" text_color="dark" text_align="left" top_padding="8%" bottom_padding="3%" id="steps" row_name="Sign Up Steps" overlay_strength="0.3" shape_divider_position="bottom" shape_type=""][vc_column column_padding="padding-2-percent" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" offset="vc_col-xs-12"][vc_row_inner equal_height="yes" content_placement="middle" column_margin="default" bottom_padding="6%" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/2" column_border_width="none" column_border_style="solid"][vc_custom_heading text="Quality Over Quantity" font_container="tag:h5|text_align:left|color:rgba(0%2C0%2C0%2C0.78)" use_theme_fonts="yes" css=".vc_custom_1532457389216{margin-bottom: 10px !important;}"][nectar_highlighted_text style="half_text"]
<h2>Salient makes building websites <em>easier</em> than ever before.</h2>
[/nectar_highlighted_text][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/2" column_border_width="none" column_border_style="solid"][/vc_column_inner][/vc_row_inner][nectar_icon_list animate="true" color="default" direction="horizontal" columns="3" icon_size="small" icon_style="border"][nectar_icon_list_item icon_type="numerical" title="List Item" id="1532455438526-8b6e3-03cc" header="Sign Up For Free" text="Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Aenean commodo ligula eget dolor." tab_id="1532458311229-4"] [/nectar_icon_list_item][nectar_icon_list_item icon_type="numerical" title="List Item" id="1732455438531-10b6e3-03dc" header="Sell Goods Online" text="In enim justo, rhoncus ut, imperdiet a, venenatis vitae, justo. Nullam dictum felis eu pede." tab_id="1532458311239-1"] [/nectar_icon_list_item][nectar_icon_list_item icon_type="numerical" title="List Item" id="1532455438526-8b6e3-03fc" header="Write Beautiful Posts" text="Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. velit cursus nunc," tab_id="1532458311259-10"] [/nectar_icon_list_item][nectar_icon_list_item icon_type="numerical" title="List Item" id="1532455438526-2b6e3-03kc" header="Monitor Your Gains" text="orem ipsum dolor sit amet, consectetuer adipiscing elit. Aenean commodo ligula eget dolor." tab_id="1532458311282-3"] [/nectar_icon_list_item][nectar_icon_list_item icon_type="numerical" title="List Item" id="1532455438526-8b6e3-033c" header="Enjoy Your New Site" text="Sed fringilla mauris sit amet nibh. Donec sodales sagittis magna. Sed consequat, leo eget bibendum." tab_id="1532458311305-5"] [/nectar_icon_list_item][nectar_icon_list_item icon_type="numerical" title="List Item" id="1532455538526-1b6e3-031c" header="Love Your Life" text="Sit back, relax and pop a cold one because your life just got a whole lot easier by using Salient." tab_id="1532458311326-0"] [/nectar_icon_list_item][/nectar_icon_list][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'Pink Color Overlay With Video & Testimonials', 'js_composer' );
$data['cat_display_name'] =  $cat_display_names['testimonials'] .', '. $cat_display_names['about'];
$data['custom_class'] = 'testimonials about date-13-Nov-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/video-bg-testimonials-2.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" equal_height="yes" content_placement="middle" scene_position="center" video_bg="use_video" video_external="https://www.youtube.com/watch?v=6oTurM7gESE" text_color="dark" text_align="left" top_padding="8%" bottom_padding="8%" color_overlay="#ffe8f8" overlay_strength="0.95" shape_divider_position="bottom" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/2" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1531925847334{margin-top: 40px !important;margin-bottom: 5px !important;}"]
<h5>Look Inside</h5>
[/vc_column_text][nectar_highlighted_text highlight_color="#ff1053" style="half_text"]
<h2>Why We're The Most <em>Awesome</em> eCommerce Business</h2>
[/nectar_highlighted_text][/vc_column_inner][/vc_row_inner][carousel script="flickity" flickity_formatting="default" desktop_cols_flickity="1" desktop_small_cols_flickity="1" tablet_cols_flickity="1" pagination_alignment_flickity="left" column_padding="5px" autorotate="true" border_radius="none" autorotation_speed="9000"][item id="1531926429-2-75" tab_id="1531926651954-9" title="Item"][nectar_single_testimonial testimonial_style="basic" image="https://themenectar.com/img/demo-media/unsplash/webp/small-smile.webp" style="bold" quote="I am so happy, my dear friend, so absorbed in the exquisite sense of mere tranquil existence, that I neglect my talents. I should be incapable of drawing a single stroke at the present moment; and yet I feel that I never was a greater artist than now." name="Mr. ThemeNectar" subtitle="Pro Acrobat"][/item][item id="1531926429-1-21" tab_id="1531926651819-3" title="Item"][nectar_single_testimonial testimonial_style="basic" image="https://themenectar.com/img/demo-media/unsplash/webp/small-smile-guy.webp" style="bold" quote="A wonderful serenity has taken possession of my entire soul, like these sweet mornings of spring. I am alone, and feel the charm of existence in this spot." name="Adam Martin" subtitle="Pro Acrobat"][/item][item id="1531926429-3-51" tab_id="1531926652117-10" title="Item"][nectar_single_testimonial testimonial_style="basic" image="https://themenectar.com/img/demo-media/unsplash/webp/small-smile.webp" style="bold" quote="When, while the lovely valley teems with vapour around me, and the meridian sun strikes the upper surface of the impenetrable foliage of my trees, I throw myself down among the tall grass by the trickling stream." name="Kara James" subtitle="Pro Acrobat"][/item][/carousel][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/4" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" offset="vc_hidden-sm vc_hidden-xs"][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/4" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][nectar_video_lightbox link_style="play_button" video_url="https://www.youtube.com/watch?v=6oTurM7gESE"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Distinct Company Image And Bottom Contact Box', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-14-Nov-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/contact-row.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-mountains-2.webp" bg_position="center bottom" bg_repeat="no-repeat" bg_color="#333333" scene_position="center" text_color="light" text_align="left" top_padding="15%" bottom_padding="5%" overlay_strength="0.8" shape_divider_position="bottom" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][divider line_type="No Line" custom_height="300"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="padding-3-percent" column_padding_position="all" background_color="#ff1053" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="large_depth" column_border_radius="10px" column_link_target="_self" width="1/4" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" offset="vc_col-lg-3 vc_col-md-4 vc_col-xs-8"][vc_column_text]
<h4>The Salient</h4>
<p>58 Nectar Rd. Apt 2C
Malibu, California</p>
[/vc_column_text][nectar_cta btn_style="underline" heading_tag="h5" text_color="#ffffff" link_type="new_tab" alignment="left" link_text="Get Directions" url="https://www.google.com/maps"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="3/4" tablet_width_inherit="default" column_border_width="none" column_border_style="solid"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Other Office Locations Row', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-15-Nov-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/other-locations.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" scene_position="center" text_color="dark" text_align="left" top_padding="8%" bottom_padding="8%" overlay_strength="0.5" shape_divider_position="bottom"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left" css=".vc_custom_1533663492429{margin-bottom: 0px !important;}"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid"][vc_column_text]
<h2>Other Offices</h2>
[/vc_column_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" top_padding="20" text_align="left"][vc_column_inner column_padding="padding-4-percent" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/4" tablet_width_inherit="default" column_border_width="none" column_border_style="solid"][vc_column_text css_animation="none"]
<h5>San Francisco</h5>
123 Nectar St. Suite 4
hello@themenectar.com[/vc_column_text][nectar_cta btn_style="material" heading_tag="h5" text_color="#ff1053" link_type="regular" alignment="left" link_text="View Map" url="#"][/vc_column_inner][vc_column_inner column_padding="padding-4-percent" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/4" tablet_width_inherit="default" column_border_width="none" column_border_style="solid"][vc_column_text css_animation="none"]
<h5>Manhatten</h5>
58 Nectar Rd. Apt 2C
hello@themenectar.com[/vc_column_text][nectar_cta btn_style="material" heading_tag="h5" text_color="#ff1053" link_type="regular" alignment="left" link_text="View Map" url="#"][/vc_column_inner][vc_column_inner column_padding="padding-4-percent" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/4" tablet_width_inherit="default" column_border_width="none" column_border_style="solid"][vc_column_text css_animation="none"]
<h5>Seattle</h5>
123 Nectar St. Suite 17
hello@themenectar.com[/vc_column_text][nectar_cta btn_style="material" heading_tag="h5" text_color="#ff1053" link_type="regular" alignment="left" link_text="View Map" url="#"][/vc_column_inner][vc_column_inner column_padding="padding-4-percent" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/4" tablet_width_inherit="default" column_border_width="none" column_border_style="solid"][vc_column_text css_animation="none"]
<h5>Philadelphia</h5>
58 Nectar Rd. Apt 2C
hello@themenectar.com[/vc_column_text][nectar_cta btn_style="material" heading_tag="h5" text_color="#ff1053" link_type="regular" alignment="left" link_text="View Map" url="#"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'Paragraphs With Large Headings', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'] .', '. $cat_display_names['about'];
$data['custom_class'] = 'general about date-16-Nov-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/basic-about-text.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_color="#ffffff" scene_position="center" text_color="dark" text_align="left" top_padding="8%" bottom_padding="7%" id="about-text" overlay_strength="1" shape_divider_position="bottom" shape_type=""][vc_column enable_animation="true" animation="fade-in-from-bottom" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1533312705391{padding-bottom: 1.5% !important;}"]
<h2>Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean.</h2>
[/vc_column_text][vc_column_text]
<h2>A small river named Duden flows by their place and supplies it with the necessary regelialia. Pityful a rethoric question ran over her.</h2>
[/vc_column_text][vc_row_inner column_margin="default" text_align="left"][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-3-percent" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/2" tablet_width_inherit="default" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1485638236800{padding-right: 10% !important;}"]Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean. A small river named Duden flows by their place and supplies it with the necessary regelialia. It is a paradisematic country, in which roasted parts of sentences fly into your mouth.[/vc_column_text][/vc_column_inner][vc_column_inner enable_animation="true" animation="fade-in-from-bottom" column_padding="padding-3-percent" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/2" tablet_width_inherit="default" column_border_width="none" column_border_style="solid" delay="100"][vc_column_text css=".vc_custom_1485638241294{padding-right: 10% !important;}"]Even the all-powerful Pointing has no control about the blind texts it is an almost unorthographic life One day however a small line of blind text by the name of Lorem Ipsum decided to leave for the far World of Grammar. The Big Oxmox advised her not to do so, because there were thousands of bad Commas, wild Question Marks and devious Semikoli.[/vc_column_text][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Product Features With Colorful Background', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-17-Nov-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/colorful-features.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" equal_height="yes" content_placement="middle" bg_color="#3452ff" scene_position="center" text_color="light" text_align="left" top_padding="8%" bottom_padding="3%" id="steps" row_name="Sign Up Steps" overlay_strength="0.3" shape_divider_position="bottom" shape_type=""][vc_column column_padding="padding-2-percent" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" offset="vc_col-xs-12"][nectar_icon_list color="default" direction="horizontal" columns="4" icon_size="small" icon_style="border"][nectar_icon_list_item icon_type="icon" title="List Item" id="1533573991183-5f44c-aa90" header="Eco Friendly" text="Lorem ipsum dolor sit amet, consectetuer adipiscing elit." icon_fontawesome="fa fa-leaf" tab_id="1533665101767-1"] [/nectar_icon_list_item][nectar_icon_list_item icon_type="icon" title="List Item" id="1533573991269-10f44c-bb90" header="Trendy Look" text="Cum sociis natoque penatibus et magnis dis parturient montes." icon_fontawesome="fa fa-arrow-circle-o-up" tab_id="1533665101811-7"] [/nectar_icon_list_item][nectar_icon_list_item icon_type="icon" title="List Item" id="1533573991269-10f44c-cc90" header="Keeps Body Cool" text="Cum sociis natoque penatibus et magnis dis parturient montes." icon_fontawesome="fa fa-thermometer-three-quarters" tab_id="1533665101854-7"] [/nectar_icon_list_item][nectar_icon_list_item icon_type="icon" title="List Item" id="1533573991311-8f44c-dd90" header="Attention To Detail" text="Lorem ipsum dolor sit amet, consectetuer adipiscing elit." icon_fontawesome="fa fa-eye" tab_id="1533665101900-8"] [/nectar_icon_list_item][nectar_icon_list_item icon_type="icon" title="List Item" id="1533573991311-8f44c-ee90" header="Stain Resistant" text="Lorem ipsum dolor sit amet, consectetuer adipiscing elit." icon_fontawesome="fa fa-paw" tab_id="1533665101959-2"] [/nectar_icon_list_item][nectar_icon_list_item icon_type="icon" title="List Item" id="1533573991352-8f44c-gg90" header="Many Colors" text="Sed fringilla mauris sit amet nibh. Donec sodales sagitti." icon_fontawesome="fa fa-tint" tab_id="1533665102013-3"] [/nectar_icon_list_item][nectar_icon_list_item icon_type="icon" title="List Item" id="1533573991406-0f44c-hh90" header="Designer Materials" text="Lorem ipsum dolor sit amet, consectetuer adipiscing elit." icon_fontawesome="fa fa-paint-brush" tab_id="1533665102056-5"] [/nectar_icon_list_item][nectar_icon_list_item icon_type="icon" title="List Item" id="1533573991225-4f44c-jj90" header="Free Shipping" text="In enim justo, rhoncus ut, imperdiet a, venenatis vitae." icon_fontawesome="fa fa-truck" tab_id="1533665102129-3"] [/nectar_icon_list_item][/nectar_icon_list][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Split Contact FAQ', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-18-Nov-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/split-contact.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" equal_height="yes" content_placement="middle" bg_color="#f7f7f7" scene_position="center" text_color="dark" text_align="left" overlay_strength="0.3" shape_divider_position="bottom" shape_type=""][vc_column column_padding="padding-8-percent" column_padding_position="all" background_color="#0a0a0a" background_color_opacity="0.8" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/webp/large-mountains-2.webp" font_color="#ffffff" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/2" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_custom_heading text="Got a question?
No problem." font_container="tag:h2|text_align:left|color:%23ffffff" use_theme_fonts="yes"][vc_column_text css=".vc_custom_1534891977895{margin-top: 20px !important;margin-bottom: 60px !important;}" max_width="475"]Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live at enim porttitor facilisis.[/vc_column_text][nectar_cta btn_style="see-through" heading_tag="h5" text_color="#ffffff" link_type="regular" alignment="left" link_text="Customer Service" url="#"][nectar_cta btn_style="see-through" heading_tag="h5" text_color="#ffffff" link_type="regular" alignment="left" link_text="General Inquiry" url="#"][nectar_cta btn_style="see-through" heading_tag="h5" text_color="#ffffff" link_type="regular" alignment="left" link_text="Business" url="#"][/vc_column][vc_column column_padding="padding-8-percent" column_padding_position="all" background_color="#b8ecce" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/2" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_column_text]
<h3>About Salient Store</h3>
[/vc_column_text][toggles style="minimal_small"][toggle color="Default" title="How do I place an order on Salient shop?"][vc_column_text]Lorem ipsum dolor sit amet, consectetur adipiscing elit. In eget bibendum libero. Etiam id velit at enim porttitor facilisis.[/vc_column_text][/toggle][toggle color="Default" title="How do I create my own Salient account?"][vc_column_text]Lorem ipsum dolor sit amet, consectetur adipiscing elit. In eget bibendum libero. Etiam id velit at enim porttitor facilisis. Vivamus tincidunt lectus at risus pharetra ultrices. In tincidunt turpis at odio dapibus maximus.[/vc_column_text][/toggle][toggle color="Default" title="Do I need to link my bank account?"][vc_column_text]Lorem ipsum dolor sit amet, consectetur adipiscing elit. In eget bibendum libero. Etiam id velit at enim porttitor facilisis. Vivamus tincidunt lectus at risus pharetra ultrices. In tincidunt turpis at odio dapibus maximus.[/vc_column_text][/toggle][toggle color="Default" title="How do I track my order?"][vc_column_text]Lorem ipsum dolor sit amet, consectetur adipiscing elit. In eget bibendum libero. Etiam id velit at enim porttitor facilisis. Vivamus tincidunt lectus at risus pharetra ultrices. In tincidunt turpis at odio dapibus maximus.[/vc_column_text][/toggle][/toggles][vc_column_text css=".vc_custom_1534890457743{margin-top: 80px !important;}"]
<h3>Managing Your Account</h3>
[/vc_column_text][toggles style="minimal_small"][toggle color="Default" title="How do I manage my account?"][vc_column_text]Lorem ipsum dolor sit amet, consectetur adipiscing elit. In eget bibendum libero. Etiam id velit at enim porttitor facilisis. Vivamus tincidunt lectus at risus pharetra ultrices.[/vc_column_text][/toggle][toggle color="Default" title="How secure is the admin area?"][vc_column_text]Lorem ipsum dolor sit amet, consectetur adipiscing elit. In eget bibendum libero. Etiam id velit at enim porttitor facilisis. Vivamus tincidunt lectus at risus pharetra ultrices. In tincidunt turpis at odio dapibus maximus.[/vc_column_text][/toggle][toggle color="Default" title="How do I cancel my account?"][vc_column_text]Lorem ipsum dolor sit amet, consectetur adipiscing elit. In eget bibendum libero. Etiam id velit at enim porttitor facilisis. Vivamus tincidunt lectus at risus pharetra ultrices. In tincidunt turpis at odio dapibus maximus.[/vc_column_text][/toggle][/toggles][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Three Fancy Boxes with Borders', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-19-Nov-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/3-col-fancy-box.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_color="#ffffff" scene_position="center" text_color="dark" text_align="left" top_padding="6%" bottom_padding="6%" overlay_strength="0.3" shape_divider_position="bottom" shape_type="straight_section"][vc_column column_padding="no-extra-padding" column_padding_position="right" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1534961409224{margin-bottom: 50px !important;}"]
<h3 style="text-align: center;">Salient has you covered</h3>
<p style="text-align: center;"><em> Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut elit tellus, luctus.</em></p>
[/vc_column_text][vc_row_inner column_margin="default" text_align="left" css=".vc_custom_1504187365562{margin-bottom: 2% !important;}"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/3" tablet_width_inherit="default" column_border_width="none" column_border_style="solid"][fancy_box box_style="color_box_hover" icon_family="fontawesome" color="Accent-Color" box_alignment="center" enable_border="true" min_height="120" icon_fontawesome="fa fa-truck" icon_size="20" link_url="#"]
<h5>Fast Turnaround</h5>
<em>Lorem ipsum dolor sit amet.</em>[/fancy_box][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/3" tablet_width_inherit="default" column_border_width="none" column_border_style="solid"][fancy_box box_style="color_box_hover" icon_family="fontawesome" color="Accent-Color" box_alignment="center" enable_border="true" min_height="120" icon_fontawesome="fa fa-user-circle-o" icon_size="20" link_url="#"]
<h5>Elegant Design</h5>
<em>Lorem ipsum dolor sit amet.</em>[/fancy_box][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/3" tablet_width_inherit="default" column_border_width="none" column_border_style="solid"][fancy_box box_style="color_box_hover" icon_family="fontawesome" color="Accent-Color" box_alignment="center" enable_border="true" min_height="120" icon_fontawesome="fa fa-trophy" icon_size="20" link_url="#"]
<h5>Award Winning</h5>
<em>Lorem ipsum dolor sit amet.</em>[/fancy_box][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'Recent Posts With BG Image', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['blog'];
$data['custom_class'] = 'blog date-20-Nov-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/blog-recent-dark.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-mountains-2.webp" bg_position="left top" bg_repeat="no-repeat" bg_color="#eaeaea" scene_position="center" text_color="light" text_align="left" top_padding="7%" bottom_padding="7%" color_overlay="#000000" overlay_strength="0.8" shape_divider_position="bottom" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/6" tablet_width_inherit="default" column_border_width="none" column_border_style="solid"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="2/3" tablet_width_inherit="default" column_border_width="none" column_border_style="solid"][vc_column_text max_width="600" css=".vc_custom_1535063574481{margin-bottom: 50px !important;}"]
<h2 style="text-align: center;">Latest Articles</h2>
<p style="text-align: center;">Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts separated.</p>
[/vc_column_text][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/6" tablet_width_inherit="default" column_border_width="none" column_border_style="solid"][/vc_column_inner][/vc_row_inner][recent_posts style="list_featured_first_row" category="business,company,fashion" columns="4" order="DESC" orderby="date" posts_per_page="4"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" tablet_width_inherit="default" column_border_width="none" column_border_style="solid"][nectar_btn size="large" button_style="regular" button_color_2="Accent-Color" icon_family="iconsmind" url="#" text="View All Posts" icon_iconsmind="iconsmind-Triangle-ArrowRight"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Icon List Horizontal With BG', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'] .', '. $cat_display_names['icons'];
$data['custom_class'] = 'general icons date-18-Nov-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/icon-list-horizontal-bg.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" equal_height="yes" content_placement="middle" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-mountains-2.webp" bg_position="center center" bg_repeat="no-repeat" parallax_bg="true" parallax_bg_speed="fast" scene_position="center" text_color="light" text_align="left" top_padding="8%" bottom_padding="3%" id="steps" row_name="Sign Up Steps" color_overlay="#0a0a0a" overlay_strength="0.8" shape_divider_position="bottom" shape_type=""][vc_column column_padding="padding-2-percent" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" offset="vc_col-xs-12"][vc_row_inner equal_height="yes" content_placement="middle" column_margin="default" bottom_padding="6%" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/2" tablet_width_inherit="default" column_border_width="none" column_border_style="solid"][vc_custom_heading text="Quality Over Quantity" font_container="tag:h5|text_align:left|color:rgba(255%2C255%2C255%2C0.78)" use_theme_fonts="yes" css=".vc_custom_1535064392273{margin-bottom: 10px !important;}"][nectar_highlighted_text highlight_color="#ff1053" style="half_text"]
<h2>Salient makes building websites <em>easier</em> than ever before.</h2>
[/nectar_highlighted_text][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/2" tablet_width_inherit="default" column_border_width="none" column_border_style="solid"][/vc_column_inner][/vc_row_inner][nectar_icon_list color="default" direction="horizontal" columns="default" icon_size="medium" icon_style="no-border"][nectar_icon_list_item icon_type="icon" icon_family="iconsmind" title="List Item" id="1532458311229-41f11-29d0" header="Sign Up For Free" text="Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Aenean commodo ligula eget dolor." tab_id="1535064315669-7" icon_iconsmind="iconsmind-Money-Bag"] [/nectar_icon_list_item][nectar_icon_list_item icon_type="icon" icon_family="iconsmind" title="List Item" id="1532458311239-11f11-29d0" header="Sell Goods Online" text="In enim justo, rhoncus ut, imperdiet a, venenatis vitae, justo. Nullam dictum felis eu pede." tab_id="1535064315677-9" icon_iconsmind="iconsmind-Shopping-Cart"] [/nectar_icon_list_item][nectar_icon_list_item icon_type="icon" icon_family="iconsmind" title="List Item" id="1532458311259-101f11-29d0" header="Write Beautiful Posts" text="Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. velit cursus nunc," tab_id="1535064315702-10" icon_iconsmind="iconsmind-Text-Box"] [/nectar_icon_list_item][nectar_icon_list_item icon_type="icon" icon_family="iconsmind" title="List Item" id="1532458311282-31f11-29d0" header="Monitor Your Gains" text="orem ipsum dolor sit amet, consectetuer adipiscing elit. Aenean commodo ligula eget dolor." tab_id="1535064315745-7" icon_iconsmind="iconsmind-Bar-Chart"] [/nectar_icon_list_item][nectar_icon_list_item icon_type="icon" icon_family="iconsmind" title="List Item" id="1532458311305-51f11-29d0" header="Enjoy Your New Site" text="Sed fringilla mauris sit amet nibh. Donec sodales sagittis magna. Sed consequat, leo eget bibendum." tab_id="1535064315768-6" icon_iconsmind="iconsmind-Newsvine"] [/nectar_icon_list_item][nectar_icon_list_item icon_type="icon" icon_family="iconsmind" title="List Item" id="1532458311326-01f11-29d0" header="Love Your Life" text="Sit back, relax and pop a cold one because your life just got a whole lot easier by using Salient." tab_id="1535064315794-9" icon_iconsmind="iconsmind-Sun"] [/nectar_icon_list_item][/nectar_icon_list][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'Colorful BG Hero', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['hero_section'];
$data['custom_class'] = 'hero_section date-10-Oct-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/colorful-bg-hero.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-blur.webp" bg_position="center center" bg_repeat="no-repeat" bg_color="#3452ff" scene_position="center" text_color="light" text_align="left" top_padding="16%" bottom_padding="16%" color_overlay="#0c0c0c" overlay_strength="0.3" shape_divider_position="bottom" shape_divider_height="350" bg_image_animation="none" shape_type="mountains"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/6" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][/vc_column][vc_column centered_text="true" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="2/3" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="zoom-out"][vc_custom_heading text="Salient Front End Editing Is Here" font_container="tag:h4|font_size:20|text_align:center|color:rgba(255%2C255%2C255%2C0.7)|line_height:36px" google_fonts="font_family:Roboto%3A100%2C100italic%2C300%2C300italic%2Cregular%2Citalic%2C500%2C500italic%2C700%2C700italic%2C900%2C900italic|font_style:500%20bold%20regular%3A500%3Anormal" css=".vc_custom_1544016696269{padding-right: 20% !important;padding-left: 20% !important;}"][vc_custom_heading text="WordPress Design As It Should Be" font_container="tag:h1|font_size:93px|text_align:center|line_height:98px" google_fonts="font_family:Playfair%20Display%3Aregular%2Citalic%2C700%2C700italic%2C900%2C900italic|font_style:400%20regular%3A400%3Anormal" css=".vc_custom_1544056620410{padding-right: 6% !important;padding-bottom: 30px !important;padding-left: 6% !important;}"][nectar_btn size="jumbo" button_style="regular" button_color_2="Accent-Color" color_override="#000000" icon_family="default_arrow" url="#discover" text="Explore More Now" margin_top="40" margin_right="20" margin_left="20"][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/6" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" bg_image_animation="none"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'Huge Triple Section', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['services'];
$data['custom_class'] = 'services date-23-Nov-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/triple-fullscreen-cols.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" equal_height="yes" content_placement="middle" full_height="yes" columns_placement="stretch" scene_position="center" text_color="light" text_align="left" overlay_strength="0.3" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column centered_text="true" column_padding="padding-8-percent" column_padding_position="all" background_color="#2d2d2d" background_color_opacity="0.6" background_hover_color_opacity="0.6" background_image="https://themenectar.com/img/demo-media/unsplash/webp/large-urban.webp" enable_bg_scale="true" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/3" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="grow-in"][vc_custom_heading text="Heavily Awarded" font_container="tag:h5|text_align:center|color:rgba(255%2C255%2C255%2C0.7)" use_theme_fonts="yes"][vc_custom_heading text="We only do excellent work" font_container="tag:h3|text_align:center" use_theme_fonts="yes"][nectar_btn size="large" button_style="see-through-2" hover_text_color_override="#ffffff" icon_family="none" url="#" text="See our portfolio" margin_top="25"][/vc_column][vc_column centered_text="true" column_padding="padding-8-percent" column_padding_position="all" background_color="#0a0a0a" background_color_opacity="0.3" background_color_hover="#0a0a0a" background_hover_color_opacity="0.3" background_image="https://themenectar.com/img/demo-media/unsplash/webp/multicolor-large.webp" enable_bg_scale="true" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/3" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="grow-in" delay="50"][vc_custom_heading text="Here For You" font_container="tag:h5|text_align:center|color:rgba(255%2C255%2C255%2C0.7)" use_theme_fonts="yes"][vc_custom_heading text="Useful Innovation" font_container="tag:h3|text_align:center" use_theme_fonts="yes"][nectar_btn size="large" button_style="see-through-2" hover_text_color_override="#ffffff" icon_family="none" url="#" text="Explore Now" margin_top="25"][/vc_column][vc_column centered_text="true" column_padding="padding-8-percent" column_padding_position="all" background_color="#2d2d2d" background_color_opacity="0.7" background_hover_color_opacity="0.7" background_image="https://themenectar.com/img/demo-media/unsplash/webp/large-city.webp" enable_bg_scale="true" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/3" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="grow-in" delay="100"][vc_custom_heading text="We care about skill" font_container="tag:h5|text_align:center|color:rgba(255%2C255%2C255%2C0.7)" use_theme_fonts="yes"][vc_custom_heading text="Great minds work here" font_container="tag:h3|text_align:center" use_theme_fonts="yes"][nectar_btn size="large" button_style="see-through-2" hover_text_color_override="#ffffff" icon_family="none" url="#" text="Meet The Team" margin_top="25"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'Dark Fancy Grid', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['services'];
$data['custom_class'] = 'services date-24-Nov-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/dark-fancy-grid.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" bg_color="#0a0a0a" scene_position="center" top_padding="10%" bottom_padding="10%" text_color="light" text_align="left" row_border_radius="none" row_border_radius_applies="bg" overflow="visible" id="more-features" overlay_strength="0.3" gradient_direction="left_to_right" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" column_position="default" gradient_direction="left_to_right" overlay_strength="0.3" width="1/1" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="padding-4-percent" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="right" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="2/3" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][vc_column_text css_animation="fadeInUp"]
<h5>Beautiful design &amp; robust options</h5>
[/vc_column_text][split_line_heading animation_type="default"]
<h3>Salient is loaded with powerful features</h3>
<h3>that makes building a website easy</h3>
[/split_line_heading][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/3" tablet_width_inherit="default" animation_type="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][/vc_column_inner][/vc_row_inner][vc_row_inner equal_height="yes" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" top_padding="50" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/4" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][fancy_box box_style="color_box_hover" icon_family="iconsmind" image_url="https://themenectar.com/img/demo-media/unsplash/webp/600-600-flame.webp" color="extra-color-gradient-1" color_box_hover_overlay_opacity="default" box_alignment="left" enable_border="true" border_radius="default" image_loading="default" color_scheme="dark" secondary_content="here's some awesome text that would only be shown on hover" icon_iconsmind="iconsmind-Crown-2" min_height="300"]
<h4>Custom WPBakery Page Builder</h4>
Exclusive UI, elements &amp; studio template library[/fancy_box][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/4" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" delay="100"][fancy_box box_style="color_box_hover" icon_family="iconsmind" image_url="https://themenectar.com/img/demo-media/unsplash/webp/750-750-business.webp" color="extra-color-gradient-1" color_box_hover_overlay_opacity="default" box_alignment="left" enable_border="true" border_radius="default" image_loading="default" color_scheme="dark" secondary_content="here's some awesome text that would only be shown on hover" icon_iconsmind="iconsmind-Duplicate-Layer" min_height="300"]
<h4>Huge Element Collection</h4>
With award winning attention to detail[/fancy_box][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/4" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" delay="200"][fancy_box box_style="color_box_hover" icon_family="iconsmind" image_url="https://themenectar.com/img/demo-media/unsplash/webp/600-600-girl.webp" color="extra-color-gradient-1" color_box_hover_overlay_opacity="default" box_alignment="left" enable_border="true" border_radius="default" image_loading="default" color_scheme="dark" secondary_content="" icon_iconsmind="iconsmind-Monitor-phone" min_height="300"]
<h4>Responsive and Retina Ready</h4>
Built with mobile in mind[/fancy_box][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/4" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" delay="300"][fancy_box box_style="color_box_hover" icon_family="iconsmind" image_url="https://themenectar.com/img/demo-media/unsplash/webp/875-1000-mountains.webp" color="extra-color-gradient-1" color_box_hover_overlay_opacity="default" box_alignment="left" enable_border="true" border_radius="default" image_loading="default" color_scheme="dark" secondary_content="here's some awesome text that would only be shown on hover" icon_iconsmind="iconsmind-Refresh" min_height="300"]
<h4>Animated Page Transitions</h4>
Set your site even further apart from the crowd[/fancy_box][/vc_column_inner][/vc_row_inner][vc_row_inner equal_height="yes" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/4" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][fancy_box box_style="color_box_hover" icon_family="iconsmind" image_url="https://themenectar.com/img/demo-media/unsplash/webp/800-500-watch.webp" color="extra-color-gradient-1" color_box_hover_overlay_opacity="default" box_alignment="left" enable_border="true" border_radius="default" image_loading="default" color_scheme="dark" secondary_content="here's some awesome text that would only be shown on hover" icon_iconsmind="iconsmind-Photos" min_height="300"]
<h4>Adaptive Images</h4>
load in the fastest manner with the least bandwidth[/fancy_box][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/4" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" delay="100"][fancy_box box_style="color_box_hover" icon_family="iconsmind" image_url="https://themenectar.com/img/demo-media/unsplash/webp/800-500-adventure.webp" color="extra-color-gradient-1" color_box_hover_overlay_opacity="default" box_alignment="left" enable_border="true" border_radius="default" image_loading="default" color_scheme="dark" secondary_content="" icon_iconsmind="iconsmind-Flash" min_height="300"]
<h4>Blazing Performance</h4>
97% PageSpeed score &amp; 89% YSlow Score[/fancy_box][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/4" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" delay="200"][fancy_box box_style="color_box_hover" icon_family="iconsmind" image_url="https://themenectar.com/img/demo-media/unsplash/webp/800-500-room.webp" color="extra-color-gradient-1" color_box_hover_overlay_opacity="default" box_alignment="left" enable_border="true" border_radius="default" image_loading="default" color_scheme="dark" secondary_content="here's some awesome text that would only be shown on hover" icon_iconsmind="iconsmind-Newsvine" min_height="300"]
<h4>Updated Frequently</h4>
One purchase grants you lifetime updates[/fancy_box][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/4" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" delay="300"][fancy_box box_style="color_box_hover" icon_family="iconsmind" image_url="https://themenectar.com/img/demo-media/unsplash/webp/700-500-city.webp" color="extra-color-gradient-1" color_box_hover_overlay_opacity="default" box_alignment="left" enable_border="true" border_radius="default" image_loading="default" color_scheme="dark" secondary_content="here's some awesome text that would only be shown on hover" icon_iconsmind="iconsmind-Sidebar-Window" min_height="300"]
<h4>Tons of Header Layouts</h4>
Don't get limited by your theme again[/fancy_box][/vc_column_inner][/vc_row_inner][vc_row_inner equal_height="yes" column_margin="default" column_direction="default" column_direction_tablet="default" column_direction_phone="default" text_align="left" row_position="default" row_position_tablet="inherit" row_position_phone="inherit" overflow="visible" pointer_events="all"][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/4" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid"][fancy_box box_style="color_box_hover" icon_family="iconsmind" image_url="https://themenectar.com/img/demo-media/unsplash/webp/800-500-fashion.webp" color="extra-color-gradient-1" color_box_hover_overlay_opacity="default" box_alignment="left" enable_border="true" border_radius="default" image_loading="default" color_scheme="dark" secondary_content="" icon_iconsmind="iconsmind-Optimization" min_height="300"]
<h4>Loaded With Theme Options</h4>
User friendly &amp; loaded with power[/fancy_box][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/4" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" delay="100"][fancy_box box_style="color_box_hover" icon_family="iconsmind" image_url="https://themenectar.com/img/demo-media/unsplash/webp/700-700-food.webp" color="extra-color-gradient-1" color_box_hover_overlay_opacity="default" box_alignment="left" enable_border="true" border_radius="default" image_loading="default" color_scheme="dark" secondary_content="" icon_iconsmind="iconsmind-Font-Window" min_height="300"]
<h4>800+ Google Fonts</h4>
Easily show off your brand how you want to[/fancy_box][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/4" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" delay="200"][fancy_box box_style="color_box_hover" icon_family="iconsmind" image_url="https://themenectar.com/img/demo-media/unsplash/webp/700-700-mountain-trees.webp" color="extra-color-gradient-1" color_box_hover_overlay_opacity="default" box_alignment="left" enable_border="true" border_radius="default" image_loading="default" color_scheme="dark" secondary_content="here's some awesome text that would only be shown on hover" icon_iconsmind="iconsmind-King-2" min_height="300"]
<h4>Thousands of Beautiful Icons</h4>
3,500+ icons ($59 value) are included[/fancy_box][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_tablet="inherit" column_padding_phone="inherit" column_padding_position="all" column_element_direction_desktop="default" column_element_spacing="default" desktop_text_alignment="default" tablet_text_alignment="default" phone_text_alignment="default" background_color_opacity="1" background_hover_color_opacity="1" column_backdrop_filter="none" column_shadow="none" column_border_radius="none" column_link_target="_self" overflow="visible" gradient_direction="left_to_right" overlay_strength="0.3" width="1/4" tablet_width_inherit="default" animation_type="default" enable_animation="true" animation="fade-in-from-bottom" animation_easing="default" bg_image_animation="none" border_type="simple" column_border_width="none" column_border_style="solid" delay="300"][fancy_box box_style="color_box_hover" icon_family="iconsmind" image_url="https://themenectar.com/img/demo-media/unsplash/webp/750-750-business.webp" color="extra-color-gradient-1" color_box_hover_overlay_opacity="default" box_alignment="left" enable_border="true" border_radius="default" image_loading="default" color_scheme="dark" secondary_content="here's some awesome text that would only be shown on hover" icon_iconsmind="iconsmind-Books" min_height="300"]
<h4>Extensive Documentation</h4>
Never feel lost again[/fancy_box][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );








$data = array();
$data['name'] = esc_html__( 'Blurb With CTAs', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['about'] .', '. $cat_display_names['general'];
$data['custom_class'] = 'general about date-02-Jan-2020';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/freelance-about-text.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="90px" bg_color="#ffffff" scene_position="center" text_color="dark" text_align="left" top_padding="8%" bottom_padding="8%" overlay_strength="0.3" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="padding-5-percent" column_padding_position="bottom" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/2" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][split_line_heading animation_type="line-reveal-by-space" font_style="h2" text_content="I am a Philadelphia based digital designer with a passion for code"][/split_line_heading][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/2" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/2" tablet_width_inherit="small_desktop" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom" delay="100"][vc_column_text css=".vc_custom_1567861185252{margin-bottom: 10px !important;}"]
<h4>Work</h4>
[/vc_column_text][vc_column_text]Lorem ipsum dolor sit amet, consectetur adipiscing elit. Curabitur aliquam mi.[/vc_column_text][nectar_cta btn_style="arrow-animation" heading_tag="h5" text_color="#ff2d2d" button_color="default" link_type="regular" alignment="left" display="block" link_text="Latest Project" url="https://themenectar.com/demo/salient-freelance-portfolio/portfolio/salient-gateway/" margin_bottom="30" margin_top="10"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/2" tablet_width_inherit="small_desktop" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom" delay="200"][vc_column_text css=".vc_custom_1567861190140{margin-bottom: 10px !important;}"]
<h4>Contact</h4>
[/vc_column_text][vc_column_text]Lorem ipsum dolor sit amet, consectetur adipiscing elit. Curabitur aliquam mi.[/vc_column_text][nectar_cta btn_style="arrow-animation" heading_tag="h5" text_color="#ff2d2d" button_color="default" link_type="regular" alignment="left" display="block" link_text="Get in touch" url="mailto:hello@themenectar.com" margin_top="10"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'Full Width Portfolio Grid, 2 Columns', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['portfolio'];
$data['custom_class'] = 'portfolio date-02-Jan-2020';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/post-grid-portfolio.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" scene_position="center" text_color="dark" text_align="left" overlay_strength="0.3" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][nectar_post_grid post_type="portfolio" portfolio_category="all" enable_sortable="yes" order="DESC" orderby="date" pagination="load-more" button_color="black" columns="2" grid_item_spacing="none" grid_item_height="30vh" enable_masonry="yes" image_size="large_featured" image_loading="lazy-load" enable_indicator="yes" mouse_indicator_style="default" mouse_indicator_text="view" mouse_indicator_color="#ff2d2d" display_date="yes" text_content_layout="all_bottom_left_shadow" color_overlay_opacity="0" color_overlay_hover_opacity="0" text_color="light" text_color_hover="light" hover_effect="slow_zoom" border_radius="none" meta_visibility="always" posts_per_page="6"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Full Width Portfolio Grid, Spaced, Middle Aligned, 2 Columns', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['portfolio'];
$data['custom_class'] = 'portfolio date-02-Jan-2020';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/post-grid-portfolio-2.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" scene_position="center" text_color="dark" text_align="left" overlay_strength="0.3" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][nectar_post_grid post_type="portfolio" portfolio_category="all" enable_sortable="yes" order="DESC" orderby="date" pagination="load-more" button_color="black" columns="2" grid_item_spacing="10px" grid_item_height="30vh" enable_masonry="yes" image_size="large_featured" image_loading="lazy-load" enable_indicator="yes" mouse_indicator_style="default" mouse_indicator_text="view" mouse_indicator_color="#ff2d2d" display_date="yes" text_content_layout="all_middle" color_overlay="#0a0a0a" color_overlay_opacity="0.4" color_overlay_hover_opacity="0.6" text_color="light" text_color_hover="light" hover_effect="slow_zoom" border_radius="none" meta_visibility="always" posts_per_page="6"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Portfolio Grid, Spaced, 4 Columns', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['portfolio'];
$data['custom_class'] = 'portfolio date-29-Nov-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/portfolio-grid-4-cols.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" scene_position="center" text_color="dark" text_align="left" overlay_strength="0.3" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][nectar_post_grid post_type="portfolio" portfolio_category="all" enable_sortable="yes" order="DESC" orderby="date" pagination="load-more" button_color="black" columns="4" grid_item_spacing="10px" grid_item_height="30vh" enable_masonry="yes" image_size="large_featured" image_loading="lazy-load" enable_indicator="yes" mouse_indicator_style="default" mouse_indicator_text="view" mouse_indicator_color="#ff2d2d" display_date="yes" text_content_layout="all_bottom_left_shadow" color_overlay_opacity="0" color_overlay_hover_opacity="0" text_color="light" text_color_hover="light" hover_effect="slow_zoom" border_radius="5px" shadow_on_hover="yes" meta_visibility="always" posts_per_page="6"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Post Grid, Spaced, 3 Columns', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['blog'];
$data['custom_class'] = 'blog date-01-Dec-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/post-grid-blog-3-cols.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" scene_position="center" text_color="dark" text_align="left" overlay_strength="0.3" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][nectar_post_grid post_type="post" blog_category="all" enable_sortable="yes" order="DESC" orderby="date" pagination="load-more" button_color="black" columns="3" grid_item_spacing="15px" grid_item_height="30vh" enable_masonry="yes" image_size="default" image_loading="lazy-load" enable_indicator="yes" mouse_indicator_style="default" mouse_indicator_text="read" mouse_indicator_color="#000000" display_categories="yes" text_content_layout="all_bottom_left_shadow" color_overlay_opacity="0" color_overlay_hover_opacity="0" text_color="light" text_color_hover="light" hover_effect="slow_zoom" border_radius="5px" shadow_on_hover="yes" meta_visibility="always" posts_per_page="6"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'Post Grid, 4 Columns', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['blog'];
$data['custom_class'] = 'blog date-02-Dec-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/post-grid-blog-4-cols.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" column_margin="default" scene_position="center" text_color="dark" text_align="left" overlay_strength="0.3" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][nectar_post_grid post_type="post" blog_category="all" order="DESC" orderby="date" pagination="load-more" button_color="accent-color" columns="4" grid_item_spacing="none" grid_item_height="30vh" enable_masonry="yes" image_size="large_featured" image_loading="lazy-load" enable_indicator="yes" mouse_indicator_style="see-through" mouse_indicator_text="read" display_categories="yes" text_content_layout="all_middle" color_overlay="#0a0a0a" color_overlay_opacity="0.4" color_overlay_hover_opacity="0.5" text_color="light" text_color_hover="light" hover_effect="zoom" border_radius="none" meta_visibility="always" posts_per_page="6"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'Fancy Box Services Carousel', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'] .', '. $cat_display_names['services'];
$data['custom_class'] = 'general services date-02-Jan-2020';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/touch-follow-fancy-boxes.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" bg_color="#ffffff" scene_position="center" text_color="dark" text_align="left" top_padding="6%" bottom_padding="6%" overlay_strength="0.3" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_row_inner column_margin="default" text_align="left" css=".vc_custom_1567864668835{margin-bottom: -20px !important;}"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/2" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][split_line_heading animation_type="line-reveal-by-space" font_style="h2" text_content="How I can help take your next project to new heights"][/split_line_heading][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/2" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][/vc_column_inner][/vc_row_inner][carousel script="flickity" flickity_formatting="default" desktop_cols_flickity="3" desktop_small_cols_flickity="3" tablet_cols_flickity="2" flickity_controls="touch_total" color="default" flickity_overflow="visible" flickity_wrap_around="no-wrap" flickity_spacing="default" column_padding="0" border_radius="none"][item id="1569344320969-3" tab_id="1569344320971-4" title="Item"][fancy_box box_style="color_box_hover" icon_family="iconsmind" image_url="https://themenectar.com/img/demo-media/unsplash/webp/750-750-business.webp" color="accent-color" box_alignment="left" enable_border="true" border_radius="default" image_loading="lazy-load" color_scheme="dark" secondary_content="here's some awesome text that would only be shown on hover" icon_iconsmind="iconsmind-Crown-2" min_height="300"]
<h3>Design</h3>
Sed vulputate purus sed facilisis dignissim erat.[/fancy_box][/item][item id="1569344321103-0" tab_id="1569344321104-6" title="Item"][fancy_box box_style="color_box_hover" icon_family="iconsmind" image_url="https://themenectar.com/img/demo-media/unsplash/webp/600-600-girl.webp" color="accent-color" box_alignment="left" enable_border="true" border_radius="default" image_loading="lazy-load" color_scheme="dark" secondary_content="here's some awesome text that would only be shown on hover" icon_iconsmind="iconsmind-Duplicate-Layer" min_height="300"]
<h3>Development</h3>
Vestibulum luctus purus ligula, id ultrices ligula.[/fancy_box][/item][item id="1569344321216-7" tab_id="1569344321218-2" title="Item"][fancy_box box_style="color_box_hover" icon_family="iconsmind" image_url="https://themenectar.com/img/demo-media/unsplash/webp/600-600-guy.webp" color="accent-color" box_alignment="left" enable_border="true" border_radius="default" image_loading="lazy-load" color_scheme="dark" secondary_content="" icon_iconsmind="iconsmind-Video-Tripod" min_height="300"]
<h3>Video Production</h3>
Nulla blandit accumsan nunc, at elementum.[/fancy_box][/item][item id="1569344321312-5" tab_id="1569344321313-5" title="Item"][fancy_box box_style="color_box_hover" icon_family="iconsmind" image_url="https://themenectar.com/img/demo-media/unsplash/webp/700-700-food.webp" color="accent-color" box_alignment="left" enable_border="true" border_radius="default" image_loading="lazy-load" color_scheme="dark" secondary_content="here's some awesome text that would only be shown on hover" icon_iconsmind="iconsmind-Leo-2" min_height="300"]
<h3>Illustrations</h3>
Orci varius natoque penatibus et magnis dis.[/fancy_box][/item][item id="1569344321397-1" tab_id="1569344321398-4" title="Item"][fancy_box box_style="color_box_hover" icon_family="iconsmind" image_url="https://themenectar.com/img/demo-media/unsplash/webp/500-400-adventure.webp" color="accent-color" box_alignment="left" enable_border="true" border_radius="default" image_loading="lazy-load" color_scheme="dark" secondary_content="here's some awesome text that would only be shown on hover" icon_iconsmind="iconsmind-Photos" min_height="300"]
<h3>Marketing</h3>
Nulla auctor sodales risus donec pretium pharetra.[/fancy_box][/item][item id="1569344321486-7" tab_id="1569344321487-6" title="Item"][fancy_box box_style="color_box_hover" icon_family="iconsmind" image_url="https://themenectar.com/img/demo-media/unsplash/webp/500-500-building.webp" color="accent-color" box_alignment="left" enable_border="true" border_radius="default" image_loading="lazy-load" color_scheme="dark" secondary_content="" icon_iconsmind="iconsmind-Flash" min_height="300"]
<h3>Search Placement</h3>
Maecenas tellus est, varius sed lorem at.[/fancy_box][/item][item id="1569344321564-9" tab_id="1569344321565-7" title="Item"][fancy_box box_style="color_box_hover" icon_family="iconsmind" image_url="https://themenectar.com/img/demo-media/unsplash/webp/500-500-forest.webp" color="accent-color" box_alignment="left" enable_border="true" border_radius="default" image_loading="lazy-load" color_scheme="dark" secondary_content="here's some awesome text that would only be shown on hover" icon_iconsmind="iconsmind-Newsvine" min_height="300"]
<h3>Promotion</h3>
Proin eget sapien ultricies nunc mattis.[/fancy_box][/item][item id="1569344321647-10" tab_id="1569344321648-8" title="Item"][fancy_box box_style="color_box_hover" icon_family="iconsmind" image_url="https://themenectar.com/img/demo-media/unsplash/webp/500-500-sky.webp" color="accent-color" box_alignment="left" enable_border="true" border_radius="default" image_loading="lazy-load" color_scheme="dark" secondary_content="here's some awesome text that would only be shown on hover" icon_iconsmind="iconsmind-Audio" min_height="300"]
<h3>Music Production</h3>
Lorem ipsum dolor sit amet, consectetur elit.[/fancy_box][/item][/carousel][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );







$data = array();
$data['name'] = esc_html__( 'Brief About Me', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['about'] .', '. $cat_display_names['general'];
$data['custom_class'] = 'general about date-02-Jan-2020';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/freelance-about.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" bg_color="#ffffff" scene_position="center" text_color="dark" text_align="left" top_padding="5%" bottom_padding="2%" overlay_strength="1" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][vc_row_inner column_margin="90px" text_align="left"][vc_column_inner column_padding="padding-3-percent" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/2" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][vc_column_text css=".vc_custom_1569347226840{margin-bottom: 10px !important;padding-right: 10% !important;}"]
<h3>My Story</h3>
[/vc_column_text][vc_column_text css=".vc_custom_1565984556133{padding-right: 10% !important;}"]behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean. A small river named Duden flows by their place and supplies it with the necessary regelialia.[/vc_column_text][vc_column_text css=".vc_custom_1565984302226{padding-right: 10% !important;}"]Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean. A small river named Duden flows by their place and supplies it with the necessary regelialia.[/vc_column_text][/vc_column_inner][vc_column_inner column_padding="padding-3-percent" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/2" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom" delay="100"][vc_column_text css=".vc_custom_1569347220775{margin-bottom: 10px !important;padding-right: 10% !important;}"]
<h3>Where I've Worked</h3>
[/vc_column_text][nectar_horizontal_list_item columns="2" column_layout_using_2_columns="medium_last" col_1_text_align="left" col_2_text_align="left" col_1_text_element="p" col_2_text_element="h5" font_family="p" hover_effect="none" col_1_content="2019 - Now" col_2_content="Developer at ThemeNectar"][nectar_horizontal_list_item columns="2" column_layout_using_2_columns="medium_last" col_1_text_align="left" col_2_text_align="left" col_1_text_element="p" col_2_text_element="h5" font_family="p" hover_effect="none" col_1_content="2017 - 2019" col_2_content="Lead Designer at ThemeForest"][nectar_horizontal_list_item columns="2" column_layout_using_2_columns="medium_last" col_1_text_align="left" col_2_text_align="left" col_1_text_element="p" col_2_text_element="h5" font_family="p" hover_effect="none" col_1_content="2016-2017" col_2_content="Photographer for Salient"][nectar_horizontal_list_item columns="2" column_layout_using_2_columns="medium_last" col_1_text_align="left" col_2_text_align="left" col_1_text_element="p" col_2_text_element="h5" font_family="p" hover_effect="none" col_1_content="2015" col_2_content="Junior Designer at Nectar"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row][vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" bg_color="#ffffff" scene_position="center" text_color="dark" text_align="left" bottom_padding="9%" overlay_strength="0.3" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_row_inner column_margin="80px" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/6" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="reveal-from-bottom" offset="vc_col-md-2 vc_col-xs-4"][image_with_animation image_url="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo-grey.png" alignment="center" animation="Fade In" hover_animation="none" border_radius="none" box_shadow="none" image_loading="lazy-load" max_width="100%" max_width_mobile="default"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/6" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="reveal-from-bottom" delay="50" offset="vc_col-md-2 vc_col-xs-4"][image_with_animation image_url="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo-grey.png" alignment="center" animation="Fade In" hover_animation="none" border_radius="none" box_shadow="none" image_loading="lazy-load" max_width="100%" max_width_mobile="default" delay="50"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/6" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="reveal-from-bottom" delay="100" offset="vc_col-md-2 vc_col-xs-4"][image_with_animation image_url="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo-grey.png" alignment="center" animation="Fade In" hover_animation="none" border_radius="none" box_shadow="none" image_loading="lazy-load" max_width="100%" max_width_mobile="default" delay="100"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/6" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="reveal-from-bottom" delay="150" offset="vc_col-md-2 vc_col-xs-4"][image_with_animation image_url="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo-grey.png" alignment="center" animation="Fade In" hover_animation="none" border_radius="none" box_shadow="none" image_loading="lazy-load" max_width="100%" max_width_mobile="default" delay="150"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/6" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="reveal-from-bottom" delay="200" offset="vc_col-md-2 vc_col-xs-4"][image_with_animation image_url="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo-grey.png" alignment="center" animation="Fade In" hover_animation="none" border_radius="none" box_shadow="none" image_loading="lazy-load" max_width="100%" max_width_mobile="default" delay="200"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/6" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="reveal-from-bottom" delay="250" offset="vc_col-md-2 vc_col-xs-4"][image_with_animation image_url="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo-grey.png" alignment="center" animation="Fade In" hover_animation="none" border_radius="none" box_shadow="none" image_loading="lazy-load" max_width="100%" max_width_mobile="default" delay="250"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Freelance CTA With Images', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['cta'];
$data['custom_class'] = 'cta date-02-Jan-2020';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/freelance-contact.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" equal_height="yes" content_placement="middle" column_margin="90px" bg_color="#efe9e9" scene_position="center" text_color="dark" text_align="left" top_padding="10%" bottom_padding="10%" overlay_strength="0.3" shape_divider_color="#ffffff" shape_divider_position="top" shape_divider_height="10%" bg_image_animation="none" shape_type="straight_section"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/2" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][vc_row_inner equal_height="yes" content_placement="middle" column_margin="40px" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/3" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" offset="vc_col-xs-6"][image_with_animation image_url="https://themenectar.com/img/demo-media/unsplash/webp/350-450-nature.webp" alignment="" animation="None" hover_animation="none" border_radius="none" box_shadow="none" image_loading="lazy-load" max_width="100%" max_width_mobile="default" margin_bottom="30"][image_with_animation image_url="https://themenectar.com/img/demo-media/unsplash/webp/300-200-business.webp" alignment="right" animation="None" hover_animation="none" border_radius="none" box_shadow="none" image_loading="lazy-load" max_width="100%" max_width_mobile="default"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="2/3" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" offset="vc_col-xs-6"][image_with_animation image_url="https://themenectar.com/img/demo-media/unsplash/webp/700-500-city.webp" alignment="" animation="None" hover_animation="none" border_radius="none" box_shadow="none" image_loading="lazy-load" max_width="100%" max_width_mobile="default" margin_bottom="30"][image_with_animation image_url="https://themenectar.com/img/demo-media/unsplash/webp/800-550-city.webp" alignment="" animation="None" hover_animation="none" border_radius="none" box_shadow="none" image_loading="lazy-load" max_width="100%" max_width_mobile="default"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/2" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][split_line_heading animation_type="line-reveal-by-space" font_style="h1" text_color="#ff2d2d" text_content="Ready to take the next step and work together?" max_width="500"][/split_line_heading][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][nectar_cta btn_style="arrow-animation" heading_tag="h4" text_color="#ffffff" button_color="accent-color" link_type="regular" alignment="left" display="block" link_text="Contact Me" padding_top="20" padding_right="40" padding_bottom="20" padding_left="40" margin_bottom="20" margin_top="40"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Project Header With CTA', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['portfolio'] .', '. $cat_display_names['general'];
$data['custom_class'] = 'portfolio general date-01-Jan-2020';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/freelance-project-header.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="90px" scene_position="center" text_color="dark" text_align="left" top_padding="8%" bottom_padding="8%" overlay_strength="0.3" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="padding-1-percent" column_padding_position="top" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="2/3" tablet_width_inherit="small_desktop" tablet_text_alignment="default" phone_text_alignment="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][vc_column_text]
<h2>Imagination will often carry us to worlds that never were. But without it we go nowhere.</h2>
[/vc_column_text][vc_row_inner column_margin="60px" top_padding="15" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/2" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_column_text]Lorem ipsum dolor sit amet, consectetur adipiscing elit. Curabitur aliquam mi eu nulla ornare, eu aliquet diam fringilla. Nullam id lectus porttitor, euismod sapien vitae.[/vc_column_text][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/2" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_column_text]Lorem ipsum dolor sit amet, consectetur adipiscing elit. Curabitur aliquam mi eu nulla ornare, eu aliquet diam fringilla. Nullam id lectus porttitor, euismod sapien vitae.[/vc_column_text][/vc_column_inner][/vc_row_inner][nectar_cta btn_style="arrow-animation" heading_tag="h4" text_color="#ff2d2d" button_color="default" link_type="regular" alignment="left" display="block" link_text="Visit Site" url="#" margin_bottom="30"][/vc_column][vc_column column_padding="padding-1-percent" column_padding_position="top" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/3" tablet_width_inherit="small_desktop" tablet_text_alignment="default" phone_text_alignment="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom" delay="100"][vc_row_inner column_margin="none" bottom_padding="20" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_column_text css=".vc_custom_1567618201809{margin-bottom: 20px !important;}"]
<h4>Scope</h4>
[/vc_column_text][fancy-ul icon_type="standard_dot" alignment="left" spacing="default"]
<ul>
 	<li>Advertisement</li>
 	<li>Photography</li>
 	<li>Strategy</li>
</ul>
[/fancy-ul][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="none" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_column_text css=".vc_custom_1567629948763{margin-bottom: 20px !important;}"]
<h4>Awards &amp; Mentions</h4>
[/vc_column_text][fancy-ul icon_type="standard_dot" alignment="left" spacing="default"]
<ul>
 	<li>Promolicious</li>
 	<li>Site of the day</li>
</ul>
[/fancy-ul][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Project Outcome', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['portfolio'] .', '. $cat_display_names['general'];
$data['custom_class'] = 'portfolio general date-01-Jan-2020';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/freelance-project-outcome.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="80px" scene_position="center" text_color="dark" text_align="left" top_padding="8%" bottom_padding="8%" overlay_strength="0.3" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="padding-2-percent" column_padding_position="bottom" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/3" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][vc_column_text css=".vc_custom_1567863257459{padding-right: 25% !important;}"]
<h2>Project Outcome</h2>
[/vc_column_text][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="2/3" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_row_inner column_margin="90px" text_align="left"][vc_column_inner column_padding="padding-3-percent" column_padding_position="bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/2" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][vc_column_text]
<h4>Easy Transition</h4>
[/vc_column_text][vc_column_text]Aliquam ligula lectus, efficitur non pretium quis, elementum quis sapien. Nunc dapibus mi vitae mi placerat eleifend. Cras ullamcorper molestie massa, at suscipit quam rhoncus vel. Suspendisse accumsan id diam.[/vc_column_text][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/2" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom" delay="100"][vc_column_text]
<h4>Amazing Results</h4>
[/vc_column_text][vc_column_text]Aliquam ligula lectus, efficitur non pretium quis, elementum quis sapien. Nunc dapibus mi vitae mi placerat eleifend. Cras ullamcorper molestie massa, at suscipit quam rhoncus vel.[/vc_column_text][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="90px" top_padding="30" text_align="left"][vc_column_inner column_padding="padding-2-percent" column_padding_position="right" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][nectar_single_testimonial testimonial_style="basic" quote="Our greatest weakness lies in giving up. The most certain way to succeed is always to try just one more time." name="Alan Adams" subtitle="CEO, Essential Company"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Video Lightbox, Play Button Follows Mouse', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-01-Jan-2020';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/video-follow-mouse.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="in_container" full_screen_row_position="middle" column_margin="default" scene_position="center" text_color="light" text_align="left" top_padding="4%" bottom_padding="4%" overlay_strength="0.3" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column centered_text="true" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][nectar_video_lightbox link_style="play_button_mouse_follow" image_url="https://themenectar.com/img/demo-media/unsplash/webp/large-business.webp" mouse_indicator_style="solid_color" mouse_indicator_color="#ff2d2d" video_url="https://www.youtube.com/watch?v=6oTurM7gESE etc" image_size="large_featured"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Project Outcome With Milestones', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['portfolio'] .', '. $cat_display_names['counters'];
$data['custom_class'] = 'portfolio counters date-01-Jan-2020';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/freelance-project-outcome-2.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" scene_position="center" text_color="dark" text_align="left" top_padding="4%" bottom_padding="4%" overlay_strength="0.3" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_row_inner column_margin="90px" text_align="left"][vc_column_inner column_padding="padding-2-percent" column_padding_position="right" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/3" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][vc_column_text]
<h4>The Results</h4>
[/vc_column_text][divider line_type="No Line" custom_height="30"][vc_column_text css=".vc_custom_1567800196287{margin-bottom: 30px !important;}"]
<blockquote>“By far the best team I've ever worked with. They truly understood the look I was going for and completely nailed it!”</blockquote>
[/vc_column_text][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="2/3" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom" delay="100"][vc_column_text]
<h2>What is the use of a house if you haven't got a tolerable planet to put it on?</h2>
[/vc_column_text][vc_column_text]Lorem ipsum dolor sit amet, consectetur adipiscing elit. Curabitur aliquam mi eu nulla ornare, eu aliquet diam fringilla. Nullam id lectus porttitor, euismod sapien vitae, tincidunt ante.[/vc_column_text][vc_column_text]Aliquam ligula lectus, efficitur non pretium quis, elementum quis sapien. Nunc dapibus mi vitae mi placerat eleifend. Cras ullamcorper molestie massa, at suscipit quam rhoncus vel. Suspendisse accumsan id diam et laoreet. Etiam eu feugiat nulla, sit amet volutpat purus. Vivamus vel erat pharetra, imperdiet ex eget, ornare tellus.[/vc_column_text][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row][vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" scene_position="center" text_color="dark" text_align="left" top_padding="3%" bottom_padding="10%" overlay_strength="0.3" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/12" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][/vc_column][vc_column centered_text="true" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="5/6" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="padding-4-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/3" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][milestone heading_inherit="h2" symbol_position="after" subject_padding="2%" color="Accent-Color" effect="count" symbol_alignment="Superscript" milestone_alignment="default" number="186" symbol="%" subject="Percent increase in overall business" number_font_size="92" symbol_font_size="40"][/vc_column_inner][vc_column_inner column_padding="padding-4-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/3" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][milestone heading_inherit="h2" subject_padding="2%" color="Accent-Color" effect="count" milestone_alignment="default" number="847" subject="Products sold during the ad campaign" number_font_size="92"][/vc_column_inner][vc_column_inner column_padding="padding-4-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/3" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][milestone heading_inherit="h2" subject_padding="2%" color="Accent-Color" effect="count" milestone_alignment="default" number="239" subject="Raving reviews written since the launch" number_font_size="92"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/12" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'Overlapping Contact Form and Testimonials', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-01-Jan-2020';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/freelance-contact-2.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" bg_image="" bg_position="center center" bg_repeat="no-repeat" bg_color="#efe9e9" scene_position="center" text_color="dark" text_align="left" top_padding="14%" zindex="100" overlay_strength="0.3" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_row_inner column_margin="default" bottom_padding="4%" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" font_color="#ffffff" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][split_line_heading animation_type="twist-in" font_style="h1" text_color="#ff2d2d" text_content="Let's work together" font_size="7vw"][/split_line_heading][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="padding-6-percent" column_padding_position="all" background_color="#ffffff" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" bottom_margin="-10%" column_link_target="_self" width="1/1" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][vc_column_text]
<h5 style="text-align:center;">Check this out.</h5>
<h2 style="text-align:center;">This area is where <br/> your text or contact<br/> form can go.</h2>
[/vc_column_text][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row][vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-fashion.webp" bg_position="center center" bg_repeat="no-repeat" scene_position="center" text_color="light" text_align="left" top_padding="20%" bottom_padding="10%" color_overlay="#0a0a0a" overlay_strength="0.5" shape_divider_position="bottom" bg_image_animation="zoom-out-slow" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][testimonial_slider style="minimal" star_rating_color="accent-color" autorotate="9000" disable_height_animation="true"][testimonial star_rating="none" title="Testimonial" id="1569348706787-8" name="Eve Crawford" subtitle="Product Designer" quote="It was really fun getting to know the team during the project. They were all helpful in answering my questions and made me feel at ease. The design ended up being better than I could have envisioned!" tab_id="1569348706788-9"][testimonial star_rating="none" title="Testimonial" id="1569348706850-6" name="Aura Brooks" subtitle="Graphic Designer" quote="By far the best team I've ever worked with. They truly understood the look I was going for and completely nailed it! I would highly recommend them as a company, you simply just won't find any better team!" tab_id="1569348706851-0"][testimonial star_rating="none" title="Testimonial" id="1569348706882-1" name="Zak Reid" subtitle="Instructor, Skate Nao" quote="Salient is by far the most astonishing WP theme out there! I literally could not be happier that I chose to buy your theme! Your regular updates and superb attention to detail blows me away every time I visit my new site!" tab_id="1569348706883-7"][testimonial star_rating="none" title="Testimonial" id="1569348706909-1" name="Jack Graham" subtitle="Co Founder, Coffee Inc" quote="I'm wondering why I never contacted these guys sooner! Seriously, they all have commendable talent in their respective fields and knocked my concept out of the ballpark. Thanks for an amazing experience!" tab_id="1569348706910-1"][/testimonial_slider][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );





$data = array();
$data['name'] = esc_html__( 'Corporate Simple Hero', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['hero_section'];
$data['custom_class'] = 'hero_section date-30-Dec-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/corporate-simple-hero.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" equal_height="yes" content_placement="bottom" column_margin="default" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-building-business.webp" bg_position="center center" bg_repeat="no-repeat" bg_color="#d1d1ca" scene_position="center" text_color="light" text_align="left" top_padding="15%" bottom_padding="13%" color_overlay="#0a0a0a" overlay_strength="0.5" shape_divider_position="bottom" shape_divider_height="350" bg_image_animation="fade-in" parallax_bg="true" parallax_bg_speed="fast" shape_type="mountains"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/2" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][split_line_heading animation_type="line-reveal-by-space" font_style="h1" text_content="Breathing life into brands through stunning design"][/split_line_heading][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in" delay="800"][nectar_cta btn_style="arrow-animation" heading_tag="h4" text_color="#ffffff" button_color="accent-color" link_type="regular" alignment="left" display="block" link_text="Discover More" url="#about" margin_top="30" padding_top="20" padding_right="40" padding_bottom="20" padding_left="40"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/2" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );





$data = array();
$data['name'] = esc_html__( 'Corporate About Blurb', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'] .', '. $cat_display_names['about'];
$data['custom_class'] = 'general about date-29-Dec-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/about-blurb.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="in_container" full_screen_row_position="middle" equal_height="yes" content_placement="middle" column_margin="90px" scene_position="center" text_color="dark" text_align="left" top_padding="12%" bottom_padding="9%" id="about" overlay_strength="0.3" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="padding-5-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/webp/750-750-business.webp" enable_bg_scale="true" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/2" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="zoom-out-reveal"][divider line_type="No Line" custom_height="300"][/vc_column][vc_column column_padding="padding-2-percent" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/2" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][split_line_heading animation_type="line-reveal-by-space" font_style="h2" text_content="We can take your business to the next level" max_width="450"][/split_line_heading][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][vc_column_text max_width="500"]Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean[/vc_column_text][nectar_cta btn_style="arrow-animation" heading_tag="h4" text_color="#ff6716" button_color="default" link_type="regular" alignment="left" display="block" link_text="View Services" url="#services"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/2" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][divider line_type="Full Width Line" line_thickness="1" divider_color="default" custom_height="10"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/2" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="right" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/2" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom" offset="vc_col-lg-6 vc_col-md-8"][nectar_single_testimonial testimonial_style="basic" image="https://themenectar.com/img/demo-media/unsplash/webp/small-smile-guy.webp" name="Phil Martinez" subtitle="Designer, Owl Eyes" quote="I had a great experience with Salient from start to finish."][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/2" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );





$data = array();
$data['name'] = esc_html__( 'Fullwidth Fancy Boxes Hover Description', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'] .', '. $cat_display_names['services'];
$data['custom_class'] = 'general services date-29-Dec-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/hover-description-fancy-boxes-fullwidth.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" top_padding="6%" column_margin="default" scene_position="center" text_color="dark" text_align="left" id="services" overlay_strength="0.3" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_row_inner column_margin="default" bottom_padding="5%" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/4" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/2" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][split_line_heading animation_type="line-reveal-by-space" font_style="h2" text_content="We offer a wide array of services aimed at simplifying your life"][/split_line_heading][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/4" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row][vc_row type="full_width_content" full_screen_row_position="middle" column_margin="20px" scene_position="center" text_color="dark" text_align="left" id="services" overlay_strength="0.3" shape_divider_position="bottom" bg_image_animation="none" shape_type="" bottom_padding="6%"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_row_inner column_margin="20px" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/4" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][fancy_box box_style="hover_desc" icon_family="iconsmind" image_url="https://themenectar.com/img/demo-media/unsplash/webp/500-500-forest.webp" hover_color="accent-color" border_radius="default" image_loading="lazy-load" color_scheme="dark" secondary_content="here's some awesome text that would only be shown on hover" icon_iconsmind="iconsmind-Snow" min_height="500" hover_content="Lorem ipsum dolor sit amet, consectetur adipiscing elit."]
<h2>Exclusive Design</h2>
[/fancy_box][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/4" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom" delay="50"][fancy_box box_style="hover_desc" icon_family="iconsmind" image_url="https://themenectar.com/img/demo-media/unsplash/webp/500-500-sky.webp" hover_color="accent-color" border_radius="default" image_loading="lazy-load" color_scheme="dark" secondary_content="" icon_iconsmind="iconsmind-Drag-Down" min_height="500" hover_content="Lorem ipsum dolor sit amet, consectetur adipiscing elit."]
<h2>Visual Builder</h2>
[/fancy_box][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/4" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom" delay="100"][fancy_box box_style="hover_desc" icon_family="iconsmind" image_url="https://themenectar.com/img/demo-media/unsplash/webp/500-500-building.webp" hover_color="accent-color" border_radius="default" image_loading="lazy-load" color_scheme="dark" secondary_content="here's some awesome text that would only be shown on hover" icon_iconsmind="iconsmind-Crown-2" min_height="500" hover_content="Lorem ipsum dolor sit amet, consectetur adipiscing elit."]
<h2>Powerful Tools</h2>
<h5></h5>
[/fancy_box][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/4" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom" delay="150"][fancy_box box_style="hover_desc" icon_family="iconsmind" image_url="https://themenectar.com/img/demo-media/unsplash/webp/700-700-food.webp" hover_color="accent-color" border_radius="default" image_loading="lazy-load" color_scheme="dark" secondary_content="here's some awesome text that would only be shown on hover" icon_iconsmind="iconsmind-Snow" min_height="500" hover_content="Lorem ipsum dolor sit amet, consectetur adipiscing elit."]
<h2>Quick Importer</h2>
[/fancy_box][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'Corporate About Blurb 2', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'] .', '. $cat_display_names['about'];
$data['custom_class'] = 'general about date-29-Dec-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/about-blurb-2.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="in_container" full_screen_row_position="middle" equal_height="yes" content_placement="middle" column_margin="90px" scene_position="center" text_color="dark" text_align="left" top_padding="12%" bottom_padding="9%" overlay_strength="0.3" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="padding-2-percent" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/2" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][split_line_heading animation_type="line-reveal-by-space" font_style="h2" text_content="Our company mission is to exceed expectations" max_width="500"][/split_line_heading][vc_row_inner column_margin="default" top_padding="20" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/2" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][fancy-ul icon_type="standard_dot" alignment="left" spacing="20px" enable_animation="true"]
<ul>
 	<li>275+ premium section templates to mix and match</li>
 	<li>Page builder with front-end and back-end editing</li>
 	<li>Massive element library with extensive options</li>
</ul>
[/fancy-ul][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/2" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][fancy-ul icon_type="standard_dot" alignment="left" spacing="20px" enable_animation="true"]
<ul>
 	<li>275+ premium section templates to mix and match</li>
 	<li>Page builder with front-end and back-end editing</li>
 	<li>Updated frequently with new features</li>
</ul>
[/fancy-ul][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][nectar_cta btn_style="arrow-animation" heading_tag="h4" text_color="#ff6716" button_color="default" link_type="regular" alignment="left" display="block" link_text="Meet The Team" url="#team"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="padding-5-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/webp/700-700-devices-yellow.webp" enable_bg_scale="true" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/2" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="zoom-out-reveal"][divider line_type="No Line" custom_height="300"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Full Width Video BG and Video Lightbox', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-29-Dec-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/video-lightbox-preview-video.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" bg_color="#d6d6d6" scene_position="center" video_bg="use_video" video_external="https://www.youtube.com/watch?v=6oTurM7gESE" text_color="light" text_align="left" top_padding="15%" bottom_padding="15%" color_overlay="rgba(10,10,10,0.7)" overlay_strength="0.8" shape_divider_position="bottom" shape_divider_height="350" bg_image_animation="zoom-out-reveal" parallax_bg="true" parallax_bg_speed="fast" shape_type="mountains"][vc_column centered_text="true" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][nectar_video_lightbox link_style="play_button_with_text" nectar_play_button_color="Default-Accent-Color" nectar_play_button_style="bordered_top" font_style="h2" parent_hover_relationship="1" video_url="https://www.youtube.com/watch?v=6oTurM7gESE" link_text="See What We're About"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );






$data = array();
$data['name'] = esc_html__( 'Drag Indicator Image Carousel', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-28-Dec-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/overflowing-touch-gallery.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" top_padding="8%" scene_position="center" text_color="dark" text_align="left" overlay_strength="0.3" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_row_inner column_margin="default" bottom_padding="5%" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/6" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="2/3" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][split_line_heading animation_type="line-reveal-by-space" font_style="h2" text_content="A vibrant work culture that flows with creativity is our secret"][/split_line_heading][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/6" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row][vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" scene_position="center" text_color="dark" text_align="left" bottom_padding="8%" overlay_strength="0.3" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_gallery type="flickity_static_height_style" flickity_spacing="10px" flickity_controls="touch_total" flickity_overflow="visible" flickity_wrap_around="no-wrap" flickity_box_shadow="none" image_loading="lazy-load" onclick="link_no" flickity_img_height="500"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'Simple And Dark CTA', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['cta'];
$data['custom_class'] = 'cta date-28-Dec-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/cta-dark.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" equal_height="yes" content_placement="middle" column_margin="default" bg_color="#000000" scene_position="center" text_color="light" text_align="left" top_padding="70" bottom_padding="70" overlay_strength="0.95" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="5/12" tablet_width_inherit="default" tablet_text_alignment="center" phone_text_alignment="center" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][split_line_heading animation_type="line-reveal-by-space" font_style="h2" text_content="Enough Talk, Let's Build Something Together"][/split_line_heading][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/12" tablet_width_inherit="default" tablet_text_alignment="center" phone_text_alignment="center" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/2" tablet_width_inherit="default" tablet_text_alignment="center" phone_text_alignment="center" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_row_inner column_margin="default" text_align="right"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][nectar_cta btn_style="arrow-animation" heading_tag="h4" text_color="#ffffff" button_color="accent-color" link_type="regular" alignment="left" display="inline" link_text="Reach out now" url="mailto:hello@themenectar.com" padding_top="20" padding_right="40" padding_bottom="20" padding_left="40"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Ten Clients', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-28-Dec-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/10-clients.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" scene_position="center" text_color="dark" text_align="left" top_padding="10%" overlay_strength="0.3" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_row_inner column_margin="default" bottom_padding="5%" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][split_line_heading animation_type="line-reveal-by-space" font_style="h2" text_content="We've worked with some of the biggest brands" max_width="500"][/split_line_heading][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row][vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" scene_position="center" text_color="dark" text_align="left" top_padding="30" bottom_padding="9%" overlay_strength="0.3" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_row_inner equal_height="yes" content_placement="middle" column_margin="80px" bottom_padding="30" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/5" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" offset="vc_col-xs-6"][image_with_animation image_url="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo-grey.png" alignment="" animation="Grow In" hover_animation="none" border_radius="none" box_shadow="none" image_loading="lazy-load" max_width="100%" max_width_mobile="default"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/5" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" offset="vc_col-xs-6"][image_with_animation image_url="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo-grey.png" alignment="" animation="Grow In" hover_animation="none" border_radius="none" box_shadow="none" image_loading="lazy-load" max_width="100%" max_width_mobile="default"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/5" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" offset="vc_col-xs-6"][image_with_animation image_url="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo-grey.png" alignment="" animation="Grow In" hover_animation="none" border_radius="none" box_shadow="none" image_loading="lazy-load" max_width="100%" max_width_mobile="default"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/5" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" offset="vc_col-xs-6"][image_with_animation image_url="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo-grey.png" alignment="" animation="Grow In" hover_animation="none" border_radius="none" box_shadow="none" image_loading="lazy-load" max_width="100%" max_width_mobile="default"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/5" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" offset="vc_hidden-sm vc_hidden-xs"][image_with_animation image_url="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo-grey.png" alignment="" animation="Grow In" hover_animation="none" border_radius="none" box_shadow="none" image_loading="lazy-load" max_width="100%" max_width_mobile="default"][/vc_column_inner][/vc_row_inner][vc_row_inner equal_height="yes" content_placement="middle" column_margin="80px" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/5" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" offset="vc_col-xs-6"][image_with_animation image_url="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo-grey.png" alignment="" animation="Grow In" hover_animation="none" border_radius="none" box_shadow="none" image_loading="lazy-load" max_width="100%" max_width_mobile="default"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/5" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" offset="vc_col-xs-6"][image_with_animation image_url="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo-grey.png" alignment="" animation="Grow In" hover_animation="none" border_radius="none" box_shadow="none" image_loading="lazy-load" max_width="100%" max_width_mobile="default"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/5" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" offset="vc_col-xs-6"][image_with_animation image_url="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo-grey.png" alignment="" animation="Grow In" hover_animation="none" border_radius="none" box_shadow="none" image_loading="lazy-load" max_width="100%" max_width_mobile="default"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/5" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" offset="vc_col-xs-6"][image_with_animation image_url="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo-grey.png" alignment="" animation="Grow In" hover_animation="none" border_radius="none" box_shadow="none" image_loading="lazy-load" max_width="100%" max_width_mobile="default"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/5" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" offset="vc_hidden-sm vc_hidden-xs"][image_with_animation image_url="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo-grey.png" alignment="" animation="Grow In" hover_animation="none" border_radius="none" box_shadow="none" image_loading="lazy-load" max_width="100%" max_width_mobile="default"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Charming Gradient Hero', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['hero_section'];
$data['custom_class'] = 'hero_section date-27-Dec-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/hero-gradient-shape-divider.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bottom_padding="8%" top_padding="8%" column_margin="default" bg_color="#ffffff" scene_position="center" text_color="light" text_align="left" id="home" overlay_strength="1" enable_shape_divider="true" shape_divider_color="#eaf1fd" shape_divider_position="bottom" shape_divider_height="40%" bg_image_animation="none" parallax_bg="true" parallax_bg_speed="fast" shape_type="straight_section"][vc_column column_padding="padding-7-percent" column_padding_position="left-right" background_color_opacity="1" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/webp/large-room.webp" enable_bg_scale="true" column_link_target="_self" column_shadow="none" column_border_radius="5px" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" enable_gradient="true" color_overlay="#ff5433" color_overlay_2="#5689ff" gradient_direction="left_t_to_right_b" overlay_strength="0.8" column_border_width="none" bg_image_animation="zoom-out-reveal"][vc_row_inner column_margin="none" top_padding="10%" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/2" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][split_line_heading animation_type="line-reveal-by-space" font_style="h1" text_content="Join the Revolution in Workspaces" animation_delay="400"][/split_line_heading][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/2" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" top_padding="5%" bottom_padding="8%" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom" delay="800"][nectar_btn size="jumbo" button_style="regular" button_color_2="Accent-Color" color_override="#ffffff" solid_text_color_override="#000000" icon_family="none" text="Discover More" margin_right="35" url="#amenities"][nectar_video_lightbox link_style="play_button_with_text" nectar_play_button_color="Default-Accent-Color" nectar_play_button_style="small" font_style="nectar-btn-jumbo" nectar_play_button_size="small" video_url="https://www.youtube.com/watch?v=6oTurM7gESE" link_text="How Salient Works"][/vc_column_inner][/vc_row_inner][vc_row_inner equal_height="yes" content_placement="middle" column_margin="60px" bottom_padding="4%" text_align="left" class="opacity"][vc_column_inner column_padding="padding-1-percent" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/6" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="grow-in" delay="900"][image_with_animation image_url="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo-light-trans.png" alignment="" animation="None" hover_animation="none" border_radius="none" box_shadow="none" image_loading="default" max_width="100%" max_width_mobile="default"][/vc_column_inner][vc_column_inner column_padding="padding-1-percent" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/6" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="grow-in" delay="950"][image_with_animation image_url="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo-light-trans.png" alignment="" animation="None" hover_animation="none" border_radius="none" box_shadow="none" image_loading="default" max_width="100%" max_width_mobile="default"][/vc_column_inner][vc_column_inner column_padding="padding-1-percent" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/6" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="grow-in" delay="1000"][image_with_animation image_url="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo-light-trans.png" alignment="" animation="None" hover_animation="none" border_radius="none" box_shadow="none" image_loading="default" max_width="100%" max_width_mobile="default"][/vc_column_inner][vc_column_inner column_padding="padding-1-percent" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/6" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="grow-in" delay="1050"][image_with_animation image_url="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo-light-trans.png" alignment="" animation="None" hover_animation="none" border_radius="none" box_shadow="none" image_loading="default" max_width="100%" max_width_mobile="default"][/vc_column_inner][vc_column_inner column_padding="padding-1-percent" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/6" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="grow-in" delay="1100"][image_with_animation image_url="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo-light-trans.png" alignment="" animation="None" hover_animation="none" border_radius="none" box_shadow="none" image_loading="default" max_width="100%" max_width_mobile="default"][/vc_column_inner][vc_column_inner column_padding="padding-1-percent" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/6" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="grow-in" delay="1150"][image_with_animation image_url="https://themenectar.com/demo/dummy-data-imgs/tn-sample-logo-light-trans.png" alignment="" animation="None" hover_animation="none" border_radius="none" box_shadow="none" image_loading="default" max_width="100%" max_width_mobile="default"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'Creative Gradient BG Fancy Boxes', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'] .', '. $cat_display_names['services'];
$data['custom_class'] = 'general services date-26-Dec-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/hover-description-fancy-boxes.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" equal_height="yes" content_placement="middle" column_margin="default" scene_position="center" text_color="dark" text_align="left" top_padding="6%" bottom_padding="6%" enable_gradient="true" color_overlay="#eaf1fd" gradient_direction="top_to_bottom" overlay_strength="1" shape_divider_color="#f4f4f4" shape_divider_position="bottom" shape_divider_height="40%" bg_image_animation="none" shape_type="curve_opacity"][vc_column column_padding="no-extra-padding" column_padding_position="right" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_row_inner column_margin="default" bottom_padding="2%" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/6" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="2/3" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][split_line_heading animation_type="line-reveal-by-space" font_style="h2" text_content="If you're ready to ditch the dated office cubicle paradigm, we have the solution"][/split_line_heading][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/6" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="20px" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/4" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][fancy_box box_style="hover_desc" icon_family="iconsmind" image_url="https://themenectar.com/img/demo-media/unsplash/webp/large-sunflowers.webp" hover_color="accent-color" border_radius="5px" image_loading="lazy-load" color_scheme="dark" secondary_content="here's some awesome text that would only be shown on hover" min_height="350" hover_content="Enjoy dedicated focus and coworking spaces." icon_iconsmind="iconsmind-Environmental-3" icon_size="34"]
<h3>Well thought out, balanced spaces</h3>
[/fancy_box][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/4" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom" delay="100"][fancy_box box_style="hover_desc" icon_family="iconsmind" image_url="https://themenectar.com/img/demo-media/unsplash/webp/large-office.webp" hover_color="accent-color" border_radius="5px" image_loading="lazy-load" color_scheme="dark" secondary_content="here's some awesome text that would only be shown on hover" min_height="350" hover_content="Offering ultra premium finishes natural light." icon_iconsmind="iconsmind-Empire-StateBuilding" icon_size="34"]
<h3>State of the art buildings</h3>
[/fancy_box][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/4" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom" delay="200"][fancy_box box_style="hover_desc" icon_family="iconsmind" image_url="https://themenectar.com/img/demo-media/unsplash/webp/large-city.webp" hover_color="accent-color" border_radius="5px" image_loading="lazy-load" color_scheme="dark" secondary_content="here's some awesome text that would only be shown on hover" min_height="350" hover_content="Find a space that suits you and your work." icon_iconsmind="iconsmind-Palm-Tree" icon_size="34"]
<h3>875+ unique office locations</h3>
[/fancy_box][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/4" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom" delay="300"][fancy_box box_style="hover_desc" icon_family="iconsmind" image_url="https://themenectar.com/img/demo-media/unsplash/webp/large-business.webp" hover_color="accent-color" border_radius="5px" image_loading="lazy-load" color_scheme="dark" secondary_content="here's some awesome text that would only be shown on hover" min_height="350" hover_content="5G wireless internet standard at all locations." icon_iconsmind="iconsmind-Internet" icon_size="34"]
<h3>Blazing fast wireless internet</h3>
[/fancy_box][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'Parallax Cascading Images', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-27-Dec-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/parallax-cascading-imgs.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" equal_height="yes" content_placement="middle" column_margin="20px" scene_position="center" text_color="dark" text_align="left" top_padding="7%" bottom_padding="8%" overlay_strength="0.3" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="padding-5-percent" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/3" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" offset="vc_col-md-offset-0 vc_col-sm-offset-2 vc_col-xs-offset-2 vc_col-xs-8"][nectar_cascading_images image_1_url="https://themenectar.com/img/demo-media/unsplash/webp/500-500-sky.webp" image_1_offset_x_sign="+" image_1_offset_x="0%" image_1_offset_y_sign="+" image_1_offset_y="0%" image_1_rotate_sign="+" image_1_rotate="none" image_1_scale="1" image_1_box_shadow="none" image_1_padding="none" image_1_max_width_desktop="100%" image_1_max_width_mobile="100%" image_2_url="https://themenectar.com/img/demo-media/unsplash/webp/500-400-adventure.webp" image_2_offset_x_sign="+" image_2_offset_x="20%" image_2_offset_y_sign="+" image_2_offset_y="25%" image_2_rotate_sign="+" image_2_rotate="none" image_2_scale="1" image_2_box_shadow="x_large_depth" image_2_padding="none" image_2_max_width_desktop="100%" image_2_max_width_mobile="100%" image_3_offset_x_sign="-" image_3_offset_x="0%" image_3_offset_y_sign="-" image_3_offset_y="0%" image_3_rotate_sign="+" image_3_rotate="none" image_3_scale="1" image_3_box_shadow="none" image_3_padding="auto" image_3_max_width_desktop="100%" image_3_max_width_mobile="100%" image_4_offset_x_sign="+" image_4_offset_x="0%" image_4_offset_y_sign="+" image_4_offset_y="0%" image_4_rotate_sign="+" image_4_rotate="none" image_4_scale="1" image_4_box_shadow="none" image_4_padding="auto" image_4_max_width_desktop="100%" image_4_max_width_mobile="100%" border_radius="5px" image_loading="lazy-load" parallax_scrolling="yes" parallax_scrolling_intensity="subtle"][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/6" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][/vc_column][vc_column column_padding="padding-2-percent" column_padding_position="top" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/2" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_row_inner equal_height="yes" content_placement="middle" column_margin="30px" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][nectar_icon icon_family="iconsmind" icon_style="shadow-bg" icon_color="Accent-Color" icon_padding="15px" icon_iconsmind="iconsmind-Chrysler-Building" icon_size="24"][/vc_column_inner][/vc_row_inner][vc_row_inner content_placement="middle" column_margin="none" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][split_line_heading animation_type="line-reveal-by-space" font_style="h2" text_content="Refreshingly unique workspace locations" max_width="520"][/split_line_heading][/vc_column_inner][/vc_row_inner][vc_row_inner content_placement="middle" column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom" delay="100"][vc_column_text css_animation="none" css=".vc_custom_1568915213980{margin-top: 15px !important;}" max_width="550"]Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean.[/vc_column_text][vc_column_text css_animation="none" max_width="550"]A small river named Duden flows by their place and supplies it with the necessary regelialia. It is a paradisematic country, in which roasted parts of sentences[/vc_column_text][nectar_cta btn_style="arrow-animation" heading_tag="h4" text_color="#ff5433" button_color="default" link_type="new_tab" alignment="left" display="block" link_text="Purchase Salient" url="https://themeforest.net/item/salient-responsive-multipurpose-theme/4363266" margin_top="10"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Parallax Cascading Images 2', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-27-Dec-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/parallax-cascading-imgs-2.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" equal_height="yes" content_placement="middle" column_margin="20px" scene_position="center" text_color="dark" text_align="left" top_padding="7%" bottom_padding="8%" overlay_strength="0.3" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="padding-2-percent" column_padding_position="top" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/2" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_row_inner equal_height="yes" content_placement="middle" column_margin="30px" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][nectar_icon icon_family="iconsmind" icon_style="shadow-bg" icon_color="Extra-Color-1" icon_padding="15px" icon_iconsmind="iconsmind-Statistic" icon_size="24"][/vc_column_inner][/vc_row_inner][vc_row_inner content_placement="middle" column_margin="none" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][split_line_heading animation_type="line-reveal-by-space" font_style="h2" text_content="Luxury amenities come standard in every office" max_width="520"][/split_line_heading][/vc_column_inner][/vc_row_inner][vc_row_inner content_placement="middle" column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom" delay="100"][vc_column_text css_animation="none" css=".vc_custom_1568915209703{margin-top: 15px !important;}" max_width="550"]Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean.[/vc_column_text][vc_column_text css_animation="none" max_width="550"]A small river named Duden flows by their place and supplies it with the necessary regelialia. It is a paradisematic country, in which roasted parts of sentences[/vc_column_text][nectar_cta btn_style="arrow-animation" heading_tag="h4" text_color="#5694ff" button_color="default" link_type="new_tab" alignment="left" display="block" link_text="Sign up now" url="https://themeforest.net/item/salient-responsive-multipurpose-theme/4363266" margin_top="10"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/6" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/3" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" offset="vc_col-md-offset-0 vc_col-sm-offset-2 vc_col-xs-offset-2 vc_col-xs-8"][nectar_cascading_images image_1_url="https://themenectar.com/img/demo-media/unsplash/webp/500-500-sky.webp" image_1_offset_x_sign="+" image_1_offset_x="0%" image_1_offset_y_sign="+" image_1_offset_y="0%" image_1_rotate_sign="+" image_1_rotate="none" image_1_scale="1" image_1_box_shadow="none" image_1_padding="none" image_1_max_width_desktop="100%" image_1_max_width_mobile="100%" image_2_url="https://themenectar.com/img/demo-media/unsplash/webp/700-700-mountain-trees.webp" image_2_offset_x_sign="-" image_2_offset_x="20%" image_2_offset_y_sign="+" image_2_offset_y="20%" image_2_rotate_sign="+" image_2_rotate="none" image_2_scale="1" image_2_box_shadow="x_large_depth" image_2_padding="none" image_2_max_width_desktop="100%" image_2_max_width_mobile="100%" image_3_offset_x_sign="-" image_3_offset_x="0%" image_3_offset_y_sign="-" image_3_offset_y="0%" image_3_rotate_sign="+" image_3_rotate="none" image_3_scale="1" image_3_box_shadow="none" image_3_padding="auto" image_3_max_width_desktop="100%" image_3_max_width_mobile="100%" image_4_offset_x_sign="+" image_4_offset_x="0%" image_4_offset_y_sign="+" image_4_offset_y="0%" image_4_rotate_sign="+" image_4_rotate="none" image_4_scale="1" image_4_box_shadow="none" image_4_padding="auto" image_4_max_width_desktop="100%" image_4_max_width_mobile="100%" border_radius="5px" image_loading="lazy-load" parallax_scrolling="yes" parallax_scrolling_intensity="subtle"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Clean Overflowing Images With Parallax', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-27-Dec-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/overflowing-parallax-cascading-imgs.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" equal_height="yes" content_placement="middle" column_margin="90px" scene_position="center" text_color="dark" text_align="left" top_padding="8%" bottom_padding="8%" id="locations" enable_gradient="true" color_overlay="#fff0ed" color_overlay_2="#ffffff" gradient_direction="left_to_right" overlay_strength="1" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="padding-4-percent" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/2" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_row_inner equal_height="yes" content_placement="middle" column_margin="30px" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][nectar_icon icon_family="iconsmind" icon_style="shadow-bg" icon_color="white" icon_padding="15px" icon_iconsmind="iconsmind-Location-2" icon_size="24"][/vc_column_inner][/vc_row_inner][vc_row_inner content_placement="middle" column_margin="none" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][split_line_heading animation_type="line-reveal-by-space" font_style="h2" text_content="Tons of locations worldwide and more on the way" max_width="520"][/split_line_heading][/vc_column_inner][/vc_row_inner][vc_row_inner content_placement="middle" column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][vc_column_text css_animation="none" css=".vc_custom_1568913052077{margin-top: 15px !important;}" max_width="500"]Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove.[/vc_column_text][/vc_column_inner][/vc_row_inner][vc_row_inner content_placement="middle" column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/2" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][fancy-ul icon_type="standard_dot" alignment="left" spacing="20px"]
<ul>
 	<li>875+ premium locations available worldwide</li>
 	<li>Reservable conference rooms at every office location</li>
 	<li>Flexible membership offered for weekly/monthly/yearly</li>
</ul>
[/fancy-ul][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/2" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom" delay="100"][fancy-ul icon_type="standard_dot" alignment="left" spacing="20px"]
<ul>
 	<li>Exclusive events &amp; social gatherings at no extra cost</li>
 	<li>Office list updated frequently with new locations</li>
 	<li>Personal desk and access to high speed internet</li>
</ul>
[/fancy-ul][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="padding-5-percent" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/2" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][nectar_cascading_images image_1_url="https://themenectar.com/img/demo-media/unsplash/webp/875-1000-mountains.webp" image_1_offset_x_sign="+" image_1_offset_x="15%" image_1_offset_y_sign="-" image_1_offset_y="0%" image_1_rotate_sign="+" image_1_rotate="none" image_1_scale="1" image_1_box_shadow="none" image_1_padding="none" image_1_max_width_desktop="150%" image_1_max_width_mobile="100%" image_2_url="https://themenectar.com/demo/dummy-data-imgs/cascadingparallax-sample.jpg" image_2_offset_x_sign="-" image_2_offset_x="40%" image_2_offset_y_sign="+" image_2_offset_y="0%" image_2_rotate_sign="+" image_2_rotate="none" image_2_scale="1" image_2_box_shadow="x_large_depth" image_2_padding="auto" image_2_max_width_desktop="100%" image_2_max_width_mobile="100%" image_3_offset_x_sign="+" image_3_offset_x="0%" image_3_offset_y_sign="-" image_3_offset_y="0%" image_3_rotate_sign="+" image_3_rotate="none" image_3_scale="1" image_3_box_shadow="none" image_3_padding="auto" image_3_max_width_desktop="100%" image_3_max_width_mobile="100%" image_4_offset_x_sign="+" image_4_offset_x="0%" image_4_offset_y_sign="+" image_4_offset_y="0%" image_4_rotate_sign="+" image_4_rotate="none" image_4_scale="1" image_4_box_shadow="x_large_depth" image_4_padding="auto" image_4_max_width_desktop="100%" image_4_max_width_mobile="100%" border_radius="5px" image_loading="default" parallax_scrolling="yes" parallax_scrolling_intensity="medium"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );






$data = array();
$data['name'] = esc_html__( 'Friendly Triple Testmonial Section', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['testimonials'];
$data['custom_class'] = 'testimonials date-27-Dec-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/three-testimonials.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" scene_position="center" text_color="dark" text_align="left" top_padding="12%" bottom_padding="7%" id="reviews" overlay_strength="0.3" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/4" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" centered_text="true" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/2" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][split_line_heading animation_type="line-reveal-by-space" font_style="h2" text_content="We don't like to brag, but we're changing the game"][/split_line_heading][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/4" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="80px" text_align="left"][vc_column_inner column_padding="padding-4-percent" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/3" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="grow-in"][nectar_single_testimonial testimonial_style="basic" image="https://themenectar.com/img/demo-media/unsplash/webp/small-smile-guy-2.webp" add_image_shadow="true" quote="Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vivamus tempus consectetur mi nec hendrerit. Integer id est massa." name="Kara Lucas" subtitle="Interior Decorator"][/vc_column_inner][vc_column_inner column_padding="padding-4-percent" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/3" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="grow-in" delay="100"][nectar_single_testimonial testimonial_style="basic" image="https://themenectar.com/img/demo-media/unsplash/webp/small-smile-guy.webp" add_image_shadow="true" quote="Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vivamus tempus consectetur mi nec hendrerit. Integer id est massa." name="Alex Cohen" subtitle="Designer"][/vc_column_inner][vc_column_inner column_padding="padding-4-percent" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/3" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="grow-in" delay="200"][nectar_single_testimonial testimonial_style="basic" image="https://themenectar.com/img/demo-media/unsplash/webp/small-smile.webp" add_image_shadow="true" quote="Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vivamus tempus consectetur mi nec hendrerit. Integer id est massa." name="Jake Smith" subtitle="Developer"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );





$data = array();
$data['name'] = esc_html__( 'Flexible Width Tabbed Section', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-20-Dec-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/tabbed-flex-width.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" bg_color="#ffffff" scene_position="center" text_color="dark" text_align="left" top_padding="6%" bottom_padding="6%" overlay_strength="0.3" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][tabbed_section style="minimal_flexible" tab_color="Accent-Color" icon_size="32"][tab icon_family="iconsmind" title="Community Trusted" id="1569435304406-0" icon_iconsmind="iconsmind-Love2" tab_id="1569435304407-1"][vc_row_inner equal_height="yes" content_placement="middle" column_margin="90px" top_padding="3%" bottom_padding="3%" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/3" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][nectar_icon icon_family="fontawesome" icon_style="default" icon_color="Accent-Color" icon_padding="0px" icon_fontawesome="fa fa-star" icon_size="18" margin_right="2"][nectar_icon icon_family="fontawesome" icon_style="default" icon_color="Accent-Color" icon_padding="0px" icon_fontawesome="fa fa-star" icon_size="18" margin_right="2"][nectar_icon icon_family="fontawesome" icon_style="default" icon_color="Accent-Color" icon_padding="0px" icon_fontawesome="fa fa-star" icon_size="18" margin_right="2"][nectar_icon icon_family="fontawesome" icon_style="default" icon_color="Accent-Color" icon_padding="0px" icon_fontawesome="fa fa-star" icon_size="18" margin_right="2"][nectar_icon icon_family="fontawesome" icon_style="default" icon_color="Accent-Color" icon_padding="0px" icon_fontawesome="fa fa-star" icon_size="18" margin_right="2"][divider line_type="No Line" custom_height="10"][split_line_heading animation_type="line-reveal-by-space" font_style="h3" text_content="4.8/5 rating based on over 5000 reviews" max_width="275"][/split_line_heading][vc_column_text css_animation="none" css=".vc_custom_1569435277498{margin-top: 15px !important;}" max_width="500"]Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live.[/vc_column_text][nectar_cta btn_style="underline" heading_tag="h4" text_color="#000000" button_color="default" link_type="regular" alignment="left" display="block" link_text="Learn More" url="#"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/12" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="7/12" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][image_with_animation image_url="https://themenectar.com/img/demo-media/unsplash/webp/800-500-room.webp" alignment="" animation="Fade In" img_link_large="yes" hover_animation="zoom-crop" border_radius="none" box_shadow="none" image_loading="default" max_width="100%" max_width_mobile="default"][/vc_column_inner][/vc_row_inner][/tab][tab icon_family="iconsmind" title="Visual Builder" id="1569435304810-7" icon_iconsmind="iconsmind-D-Eyeglasses2" tab_id="1569435304812-6"][vc_row_inner equal_height="yes" content_placement="middle" column_margin="90px" top_padding="3%" bottom_padding="3%" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/3" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][split_line_heading animation_type="line-reveal-by-space" font_style="h3" text_content="Create stunning designs easier than ever before" max_width="300"][/split_line_heading][vc_column_text css_animation="none" css=".vc_custom_1569435283163{margin-top: 15px !important;}" max_width="500"]Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live.[/vc_column_text][nectar_cta btn_style="underline" heading_tag="h4" text_color="#000000" button_color="default" link_type="regular" alignment="left" display="block" link_text="Learn More" url="#"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/12" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="7/12" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][image_with_animation image_url="https://themenectar.com/img/demo-media/unsplash/webp/tall-food.webp" alignment="" animation="Fade In" img_link_large="yes" hover_animation="zoom-crop" border_radius="none" box_shadow="none" image_loading="default" max_width="100%" max_width_mobile="default"][/vc_column_inner][/vc_row_inner][/tab][tab icon_family="iconsmind" title="Future Proof" id="1569435305107-3" icon_iconsmind="iconsmind-Sand-watch2" tab_id="1569435305108-3"][vc_row_inner equal_height="yes" content_placement="middle" column_margin="90px" top_padding="3%" bottom_padding="3%" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/3" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][split_line_heading animation_type="line-reveal-by-space" font_style="h3" text_content="It's just that easy to make something amazing" max_width="300"][/split_line_heading][vc_column_text css_animation="none" css=".vc_custom_1569435287620{margin-top: 15px !important;}" max_width="500"]Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live.[/vc_column_text][nectar_cta btn_style="underline" heading_tag="h4" text_color="#000000" button_color="default" link_type="regular" alignment="left" display="block" link_text="Learn More" url="#"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/12" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="7/12" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][image_with_animation image_url="https://themenectar.com/img/demo-media/unsplash/webp/800-500-food.webp" alignment="" animation="Fade In" img_link_large="yes" hover_animation="zoom-crop" border_radius="none" box_shadow="none" image_loading="default" max_width="100%" max_width_mobile="default"][/vc_column_inner][/vc_row_inner][/tab][/tabbed_section][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Forward Hero Section', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['hero_section'];
$data['custom_class'] = 'hero_section date-20-Dec-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/hero-to-the-point.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" equal_height="yes" content_placement="bottom" column_margin="default" bg_image="https://themenectar.com/img/demo-media/unsplash/webp/large-mountain.webp" bg_position="left top" bg_repeat="no-repeat" scene_position="center" text_color="light" text_align="left" top_padding="8%" bottom_padding="8%" color_overlay="#0a0a0a" overlay_strength="0.8" shape_divider_position="bottom" shape_divider_height="350" bg_image_animation="none" parallax_bg="true" parallax_bg_speed="fast" shape_type="mountains"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/2" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][nectar_highlighted_text color_type="regular" highlight_color="#ffffff" style="regular_underline"]
<h1>Salient will breathe</h1>
<h1><em>new life</em> to your</h1>
<h1>online presense.</h1>
[/nectar_highlighted_text][vc_column_text max_width="400"]Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts.[/vc_column_text][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/2" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/2" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_column_text]
<h3>Services</h3>
[/vc_column_text][nectar_cta btn_style="arrow-animation" heading_tag="h4" text_color="#ffffff" button_color="default" link_type="regular" alignment="left" display="block" link_text="Discover More" url="#"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/2" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_column_text]
<h3>Individuals</h3>
[/vc_column_text][nectar_cta btn_style="arrow-animation" heading_tag="h4" text_color="#ffffff" button_color="default" link_type="regular" alignment="left" display="block" link_text="Explore" url="#"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );





$data = array();
$data['name'] = esc_html__( 'Diverse Text and Image Section', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-20-Dec-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/overlapping-img-section.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" equal_height="yes" content_placement="middle" column_margin="none" scene_position="center" text_color="dark" text_align="left" top_padding="6%" bottom_padding="6%" overlay_strength="0.3" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="5/12" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][image_with_animation image_url="https://themenectar.com/img/demo-media/unsplash/webp/700-700-food.webp" alignment="" animation="Grow In" hover_animation="zoom-crop" border_radius="none" box_shadow="none" image_loading="default" max_width="110%" max_width_mobile="default"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="padding-12-percent" column_padding_position="all" background_color="#eaecff" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="7/12" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_row_inner column_margin="default" text_align="left" css=".vc_custom_1569518583590{margin-bottom: 10px !important;}"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/12" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" offset="vc_col-lg-offset-0 vc_col-md-offset-0 vc_hidden-sm vc_hidden-xs"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="11/12" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" offset="vc_col-xs-12"][split_line_heading animation_type="line-reveal-by-space" font_style="h2" text_content="If you wish to make an apple pie from scratch, you must first invent the universe."][/split_line_heading][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/12" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" offset="vc_col-lg-offset-0 vc_col-md-offset-0 vc_hidden-sm vc_hidden-xs"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="11/12" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom" offset="vc_col-xs-12"][vc_column_text css=".vc_custom_1569502859297{padding-right: 10% !important;}"]Even the all-powerful Pointing has no control about the blind texts it is an almost unorthographic life One day however a small line of blind text by the name of Lorem Ipsum decided to leave for the far World of Grammar.[/vc_column_text][nectar_cta btn_style="arrow-animation" heading_tag="h5" text_color="#0a0000" button_color="default" link_type="regular" alignment="left" display="block" link_text="Learn More" url="#" margin_top="20"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Diverse Text and Image Section 2', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['general'];
$data['custom_class'] = 'general date-20-Dec-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/overlapping-img-section2.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" equal_height="yes" content_placement="middle" column_margin="none" scene_position="center" text_color="dark" text_align="left" top_padding="6%" bottom_padding="6%" overlay_strength="0.3" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="padding-12-percent" column_padding_position="all" background_color="#fff0ed" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="7/12" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_row_inner column_margin="none" bottom_padding="10" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" offset="vc_col-lg-11 vc_col-md-11 vc_col-xs-12"][split_line_heading animation_type="line-reveal-by-space" font_style="h2" text_content="If you wish to make an apple pie from scratch, you must first invent the universe."][/split_line_heading][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom" offset="vc_col-lg-11 vc_col-md-11 vc_col-xs-12"][vc_column_text css=".vc_custom_1569502859297{padding-right: 10% !important;}"]Even the all-powerful Pointing has no control about the blind texts it is an almost unorthographic life One day however a small line of blind text by the name of Lorem Ipsum decided to leave for the far World of Grammar.[/vc_column_text][nectar_cta btn_style="arrow-animation" heading_tag="h5" text_color="#0a0000" button_color="default" link_type="regular" alignment="left" display="block" link_text="Learn More" url="#" margin_top="20"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="5/12" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][image_with_animation image_url="https://themenectar.com/img/demo-media/unsplash/webp/700-700-mountain-trees.webp" alignment="right" animation="Grow In" hover_animation="zoom-crop" border_radius="none" box_shadow="none" image_loading="default" max_width="110%" max_width_mobile="default"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Engaging Team Section', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['team'];
$data['custom_class'] = 'team date-28-Dec-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/minimal-team.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="in_container" full_screen_row_position="middle" column_margin="default" scene_position="center" text_color="dark" text_align="left" bottom_padding="6%" top_padding="6%" id="" overlay_strength="0.3" shape_divider_position="bottom" bg_image_animation="none" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][divider line_type="No Line" custom_height="30"][vc_row_inner column_margin="none" bottom_padding="7%" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][split_line_heading animation_type="line-reveal-by-space" font_style="h2" text_content="Our team is comprised of genuinely gifted minds" max_width="550"]
<h2></h2>
[/split_line_heading][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="80px" text_align="left"][vc_column_inner column_padding="padding-4-percent" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/3" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom" delay="50"][team_member image_url="https://themenectar.com/img/demo-media/unsplash/webp/team-member-6-small.webp" bio_alt_image_url="https://themenectar.com/demo/dummy-data-imgs/business/about-team-member-big.webp" team_memeber_style="bio_fullscreen_alt" image_loading="lazy-load" name="Jamie Warren" job_position="CEO, Founder" team_member_mini_bio="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts." team_member_bio="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean. A small river named Duden flows by their place and supplies it with the necessary regelialia. It is a paradisematic country, in which roasted parts of sentences fly into your mouth." social_icon_1="fa fa-linkedin" social_link_1="#" social_icon_2="fa fa-instagram" social_link_2="#" social_icon_3="fa fa-github-alt" social_link_3="#"][divider line_type="No Line" custom_height="30"][team_member image_url="https://themenectar.com/img/demo-media/unsplash/webp/team-member-5-small.webp" bio_alt_image_url="https://themenectar.com/demo/dummy-data-imgs/business/about-team-member-big.webp" team_memeber_style="bio_fullscreen_alt" image_loading="lazy-load" name="Corey Williams" job_position="Developer" team_member_mini_bio="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts." team_member_bio="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean. A small river named Duden flows by their place and supplies it with the necessary regelialia. It is a paradisematic country, in which roasted parts of sentences fly into your mouth." social_icon_1="fa fa-linkedin" social_link_1="#" social_icon_2="fa fa-instagram" social_link_2="#" social_icon_3="fa fa-github-alt" social_link_3="#"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/3" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom"][team_member image_url="https://themenectar.com/img/demo-media/unsplash/webp/team-member-4-small.webp" bio_alt_image_url="https://themenectar.com/demo/dummy-data-imgs/business/about-team-member-big.webp" team_memeber_style="bio_fullscreen_alt" image_loading="lazy-load" name="Zachary Miller" job_position="Designer" team_member_mini_bio="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts." team_member_bio="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean. A small river named Duden flows by their place and supplies it with the necessary regelialia. It is a paradisematic country, in which roasted parts of sentences fly into your mouth." social_icon_1="fa fa-linkedin" social_link_1="#" social_icon_2="fa fa-instagram" social_link_2="#" social_icon_3="fa fa-github-alt" social_link_3="#"][divider line_type="No Line" custom_height="30"][team_member image_url="https://themenectar.com/img/demo-media/unsplash/webp/team-member-3-small.webp" bio_alt_image_url="https://themenectar.com/demo/dummy-data-imgs/business/about-team-member-big.webp" team_memeber_style="bio_fullscreen_alt" image_loading="lazy-load" name="Daniel Wilson" job_position="Art Director" team_member_mini_bio="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts." team_member_bio="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean. A small river named Duden flows by their place and supplies it with the necessary regelialia. It is a paradisematic country, in which roasted parts of sentences fly into your mouth." social_icon_1="fa fa-linkedin" social_link_1="#" social_icon_2="fa fa-instagram" social_link_2="#" social_icon_3="fa fa-github-alt" social_link_3="#"][/vc_column_inner][vc_column_inner column_padding="padding-4-percent" column_padding_position="top-bottom" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/3" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom" delay="100"][team_member image_url="https://themenectar.com/img/demo-media/unsplash/webp/team-member-2-small.webp" bio_alt_image_url="https://themenectar.com/demo/dummy-data-imgs/business/about-team-member-big.webp" team_memeber_style="bio_fullscreen_alt" image_loading="lazy-load" name="Kara Lucas" job_position="UX Designer" team_member_mini_bio="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts." team_member_bio="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean. A small river named Duden flows by their place and supplies it with the necessary regelialia. It is a paradisematic country, in which roasted parts of sentences fly into your mouth." social_icon_1="fa fa-linkedin" social_link_1="#" social_icon_2="fa fa-instagram" social_link_2="#" social_icon_3="fa fa-github-alt" social_link_3="#"][divider line_type="No Line" custom_height="30"][team_member image_url="https://themenectar.com/img/demo-media/unsplash/webp/team-member-1-small.webp" bio_alt_image_url="https://themenectar.com/demo/dummy-data-imgs/business/about-team-member-big.webp" team_memeber_style="bio_fullscreen_alt" image_loading="lazy-load" name="Sophia Johnson" job_position="Marketing" team_member_mini_bio="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts." team_member_bio="Far far away, behind the word mountains, far from the countries Vokalia and Consonantia, there live the blind texts. Separated they live in Bookmarksgrove right at the coast of the Semantics, a large language ocean. A small river named Duden flows by their place and supplies it with the necessary regelialia. It is a paradisematic country, in which roasted parts of sentences fly into your mouth." social_icon_1="fa fa-linkedin" social_link_1="#" social_icon_2="fa fa-instagram" social_link_2="#" social_icon_3="fa fa-github-alt" social_link_3="#"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Peaceful Gradient CTA Section', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['cta'];
$data['custom_class'] = 'cta date-26-Dec-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/gradient-cta.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" column_margin="default" bg_color="#ffffff" scene_position="center" text_color="light" text_align="left" top_padding="6%" bottom_padding="6%" overlay_strength="0.95" enable_shape_divider="true" shape_divider_color="#eaf1fd" shape_divider_position="bottom" shape_divider_height="50%" bg_image_animation="none" shape_type="straight_section"][vc_column centered_text="true" column_padding="padding-5-percent" column_padding_position="left-right" background_color_opacity="1" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/webp/large-room.webp" enable_bg_scale="true" font_color="#ffffff" column_link_target="_self" column_shadow="none" column_border_radius="5px" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" enable_gradient="true" color_overlay="#ff5433" color_overlay_2="#5689ff" gradient_direction="left_t_to_right_b" overlay_strength="0.8" column_border_width="none" bg_image_animation="zoom-out-reveal"][vc_row_inner column_margin="default" top_padding="10%" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/4" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/2" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][split_line_heading animation_type="line-reveal-by-space" font_style="h2" text_content="If you wish to make an apple pie from scratch,
you must first invent the universe." animation_delay="400"][/split_line_heading][/vc_column_inner][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/4" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][/vc_column_inner][/vc_row_inner][vc_row_inner column_margin="default" top_padding="20" bottom_padding="10%" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in-from-bottom" delay="500"][nectar_btn size="jumbo" open_new_tab="true" button_style="regular" button_color_2="Accent-Color" color_override="#ffffff" solid_text_color_override="#0a0101" icon_family="none" text="Puchase Salient" margin_right="25" url="https://themeforest.net/item/salient-responsive-multipurpose-theme/4363266"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Freelancer Hero', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['hero_section'];
$data['custom_class'] = 'hero_section date-03-Jan-2020';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/freelance-header.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" equal_height="yes" column_margin="default" bg_color="#efe9e9" scene_position="center" text_color="dark" text_align="left" top_padding="10%" bottom_padding="4%" overlay_strength="0.3" enable_shape_divider="true" shape_divider_color="#ffffff" shape_divider_position="bottom" shape_divider_height="12%" bg_image_animation="none" shape_type="straight_section"][vc_column column_padding="padding-3-percent" column_padding_position="top" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/2" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" offset="vc_col-xs-6"][divider line_type="No Line" custom_height="60"][vc_row_inner equal_height="yes" content_placement="middle" column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none"][split_line_heading animation_type="twist-in" font_style="h1" text_color="#ff3535" text_content="Bentley Martinez" font_size="17vh"][/split_line_heading][/vc_column_inner][/vc_row_inner][vc_row_inner equal_height="yes" content_placement="middle" column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" tablet_width_inherit="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" enable_animation="true" animation="fade-in" offset="vc_hidden-xs"][nectar_cta btn_style="next-section" btn_type="minimal-arrow" alignment="left" next_section_color="#000000" color="#4271a3" margin_top="10"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/2" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" overlay_strength="0.3" column_border_width="none" column_border_style="solid" bg_image_animation="none" offset="vc_col-xs-6"][image_with_animation image_url="https://themenectar.com/img/demo-media/unsplash/webp/freelance-portfolio-man.webp" alignment="right" animation="Fade In" hover_animation="none" border_radius="none" box_shadow="none" image_loading="default" max_width="125%" max_width_mobile="150%"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );




/* WooCommerce specific templates */

$data = array();
$data['name'] = esc_html__( 'Tabbed Product Display', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['shop'];
$data['custom_class'] = 'shop date-13-Nov-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/tabbed-products.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" bg_color="#ffffff" scene_position="center" text_color="dark" text_align="left" top_padding="6%" bottom_padding="6%" overlay_strength="0.3" shape_divider_position="bottom" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/1" tablet_width_inherit="default" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][tabbed_section style="material" alignment="center" spacing="side-45px" tab_color="Accent-Color" full_width_line="true" icon_size="24"][tab icon_family="iconsmind" title="Latest" id="1532376475359-1c2bb-31f9" icon_iconsmind="iconsmind-Megaphone" tab_id="1533724809332-3"][nectar_woo_products product_type="all" category="all" columns="4" orderby="date" order="DESC" per_page="8"][/tab][tab icon_family="iconsmind" title="On Sale" id="1532376475534-2c2bb-3133" icon_iconsmind="iconsmind-Tag" tab_id="1533724809384-1"][nectar_woo_products product_type="sale" category="all" columns="4" orderby="date" order="DESC" per_page="8"][/tab][tab icon_family="iconsmind" title="Best Sellers" id="1532376475534-2c2bb-31f9" icon_iconsmind="iconsmind-Trophy" tab_id="1533724809506-9"][nectar_woo_products product_type="best_selling" category="all" columns="4" orderby="date" order="DESC" per_page="8"][/tab][/tabbed_section][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Modern Product Category Grid: Four Column Based', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['shop'];
$data['custom_class'] = 'shop date-18-Nov-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/category-grid.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" scene_position="center" text_color="dark" text_align="left" top_padding="6%" bottom_padding="6%" overlay_strength="0.3" shape_divider_position="bottom" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][nectar_category_grid post_type="products" product_category="all" text_content_alignment="bottom_left" subtext="custom" columns="4" grid_item_spacing="10px" enable_masonry="yes" color_overlay="#000000" color_overlay_opacity="0.2" color_overlay_hover_opacity="0.4" text_color="light" text_color_hover="light" shadow_on_hover="yes" subtext_visibility="always" orderby="" order="" text_style="" color_strip_bg="" color_strip_bg_hover="" color_strip_text="" color_strip_text_hover="" block_sizing="square" custom_subtext="Shop Now"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


$data = array();
$data['name'] = esc_html__( 'Fullwidth Product Carousel With Split Color BG', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['shop'];
$data['custom_class'] = 'shop date-18-Nov-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/woo-carousel.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" bg_color="#fff6f1" scene_position="center" text_color="dark" text_align="left" top_padding="3%" bottom_padding="5%" overlay_strength="0.3" enable_shape_divider="true" shape_divider_color="#ffffff" shape_divider_position="bottom" shape_divider_height="50%" shape_type="straight_section"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][nectar_woo_products product_type="all" category="all" columns="dynamic" orderby="date" order="DESC" carousel="1" script="flickity" flickity_controls="arrows-and-text" flickity_heading_tag="h2" carousel_script="flickity" per_page="8" flickity_heading_text="Fresh New Products"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Dual Section Products And Image', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['shop'];
$data['custom_class'] = 'shop date-13-Nov-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/woo-2-products.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" equal_height="yes" content_placement="middle" bg_color="#ffffff" scene_position="center" text_color="dark" text_align="left" overlay_strength="0.3" shape_divider_position="bottom"][vc_column column_padding="padding-6-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_column_text max_width="325" css=".vc_custom_1532191621300{margin-bottom: 60px !important;}"]
<h2>Stand Out
This Season.</h2>
<em>Stay ahead of the fashion trends with our new selection</em>[/vc_column_text][nectar_woo_products product_type="all" category="all" columns="2" orderby="date" order="DESC" per_page="2"][/vc_column][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/webp/large-fashion.webp" enable_bg_scale="true" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Flush Product Category Grid: Three Column Based', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['shop'];
$data['custom_class'] = 'shop date-13-Nov-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/woo-cat-grid-2.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" scene_position="center" text_color="dark" text_align="left" top_padding="6%" bottom_padding="6%" overlay_strength="0.3" shape_divider_position="bottom" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][nectar_category_grid post_type="products" product_category="all" text_content_alignment="middle" subtext="custom" columns="3" grid_item_spacing="none" enable_masonry="yes" color_overlay="#000000" color_overlay_opacity="0.3" color_overlay_hover_opacity="0.5" text_color="light" text_color_hover="light" subtext_visibility="on_hover" orderby="" order="" text_style="" color_strip_bg="" color_strip_bg_hover="" color_strip_text="" color_strip_text_hover="" block_sizing="square" custom_subtext="Shop Now"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'Product Carousel Split', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['shop'];
$data['custom_class'] = 'shop date-13-Nov-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/woo-2-products-carousel.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" equal_height="yes" content_placement="middle" bg_color="#ffffff" scene_position="center" text_color="dark" text_align="left" overlay_strength="0.3" shape_divider_position="bottom" shape_type=""][vc_column centered_text="true" column_padding="padding-6-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/webp/large-girl-pink.webp" font_color="#ffffff" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_custom_heading text="Leave
A Timeless
Impression." font_container="tag:h2|font_size:60px|text_align:left|color:%23ffffff|line_height:68px" use_theme_fonts="yes"][divider line_type="No Line" custom_height="40"][nectar_cta btn_style="underline" heading_tag="h5" text_color="#ffffff" link_type="regular" alignment="left" link_text="Explore Full Collection" url="#"][/vc_column][vc_column column_padding="padding-4-percent" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][nectar_woo_products product_type="all" category="all" columns="2" orderby="date" order="DESC" carousel="1" script="flickity" flickity_controls="bottom-pagination" autorotate="true" item_shadow="1" per_page="6" autorotation_speed="4000"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );




$data = array();
$data['name'] = esc_html__( 'Normal Product Carousel', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['shop'];
$data['custom_class'] = 'shop date-18-Nov-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/container-product-carousel.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_background" full_screen_row_position="middle" scene_position="center" text_color="dark" text_align="left" top_padding="4%" bottom_padding="5%" overlay_strength="0.3" shape_divider_position="bottom" shape_type="straight_section"][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][nectar_woo_products product_type="all" category="all" columns="dynamic" orderby="date" order="DESC" carousel="1" script="flickity" flickity_controls="arrows-and-text" flickity_heading_tag="h2" item_shadow="1" carousel_script="flickity" per_page="8" flickity_heading_text="New Products" flickity_link_text="See All Products" flickity_link_url="#"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Fullwidth Custom Product Section', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['shop'];
$data['custom_class'] = 'shop date-13-Nov-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/single-product-block-1.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" equal_height="yes" content_placement="middle" scene_position="center" text_color="dark" text_align="left" overlay_strength="0.3" shape_divider_position="bottom" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/webp/large-adventure.webp" enable_bg_scale="true" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][divider line_type="No Line" custom_height="400"][/vc_column][vc_column centered_text="true" column_padding="padding-5-percent" column_padding_position="left-right" background_color="#e1e1e1" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/2" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner column_margin="default" top_padding="17%" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1532438962001{margin-bottom: 5px !important;}"]A whole new world of sound.[/vc_column_text][vc_column_text css=".vc_custom_1532438974675{margin-bottom: 35px !important;}"]
<h2>Amazing Earbuds</h2>
[/vc_column_text][add_to_cart id=""][divider line_type="No Line" custom_height="40"][image_with_animation image_url="https://themenectar.com/img/demo-media/unsplash/webp/earphones-700-700.webp" alignment="" animation="None" border_radius="none" box_shadow="none" max_width="100%"][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Creative Fullwidth Custom Product Display', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['shop'];
$data['custom_class'] = 'shop date-13-Nov-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/modern-full-width-product-display.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" equal_height="yes" content_placement="middle" scene_position="center" text_color="dark" text_align="left" overlay_strength="0.3" shape_divider_position="bottom" shape_type=""][vc_column centered_text="true" column_padding="padding-6-percent" column_padding_position="all" background_color="#0a0a0a" background_color_opacity="0.6" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/webp/large-urban.webp" enable_bg_scale="true" font_color="#ffffff" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_custom_heading text="Leave
A Timeless
Impression." font_container="tag:h2|text_align:center|color:%23ffffff" use_theme_fonts="yes"][divider line_type="No Line" custom_height="40"][nectar_cta btn_style="underline" heading_tag="h5" text_color="#ffffff" link_type="regular" alignment="center" link_text="Explore Full Collection" url="#"][/vc_column][vc_column centered_text="true" column_padding="padding-3-percent" column_padding_position="all" background_color="#ffedf1" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1532441498347{margin-top: 30px !important;margin-bottom: 10px !important;}"]
<h2>The Best Bike</h2>
[/vc_column_text][vc_column_text css=".vc_custom_1532440860879{margin-bottom: 35px !important;}"]Discover true off-road performance.[/vc_column_text][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="left-right" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" column_border_width="none" column_border_style="solid"][image_with_animation image_url="https://themenectar.com/img/demo-media/unsplash/webp/800-500-bike.webp" alignment="center" animation="None" img_link_large="yes" border_radius="10px" box_shadow="small_depth" max_width="75%" margin_bottom="40"][/vc_column_inner][/vc_row_inner][add_to_cart id=""][/vc_column][vc_column centered_text="true" column_padding="padding-3-percent" column_padding_position="all" background_color="#dde3ff" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1532441502354{margin-top: 30px !important;margin-bottom: 10px !important;}"]
<h2>Amazing Earbuds</h2>
[/vc_column_text][vc_column_text css=".vc_custom_1532440864198{margin-bottom: 35px !important;}"]A whole new world of sound.[/vc_column_text][vc_row_inner column_margin="default" text_align="left"][vc_column_inner column_padding="no-extra-padding" column_padding_position="left-right" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" column_border_width="none" column_border_style="solid"][image_with_animation image_url="https://themenectar.com/img/demo-media/unsplash/webp/800-500-watch.webp" alignment="center" animation="None" img_link_large="yes" border_radius="10px" box_shadow="small_depth" max_width="75%" margin_bottom="40"][/vc_column_inner][/vc_row_inner][add_to_cart id=""][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Vertical Fullwidth Custom Product Display', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['shop'];
$data['custom_class'] = 'shop date-13-Nov-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/modern-full-width-product-display-2.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" equal_height="yes" content_placement="middle" scene_position="center" text_color="dark" text_align="left" overlay_strength="0.3" shape_divider_position="bottom" shape_type=""][vc_column centered_text="true" column_padding="padding-6-percent" column_padding_position="all" background_color="#0a0a0a" background_color_opacity="0.6" background_hover_color_opacity="1" background_image="https://themenectar.com/img/demo-media/unsplash/webp/large-mountain.webp" enable_bg_scale="true" font_color="#ffffff" column_link_target="_self" column_shadow="none" column_border_radius="none" width="2/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_custom_heading text="Leave
A Timeless
Impression." font_container="tag:h2|text_align:center|color:%23ffffff" use_theme_fonts="yes"][divider line_type="No Line" custom_height="40"][nectar_cta btn_style="underline" heading_tag="h5" text_color="#ffffff" link_type="regular" alignment="center" link_text="Explore Full Collection" url="#"][/vc_column][vc_column centered_text="true" column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/3" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][vc_row_inner equal_height="yes" content_placement="middle" column_margin="default" text_align="left"][vc_column_inner column_padding="padding-6-percent" column_padding_position="all" background_color="#ffedf1" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1532441498347{margin-top: 30px !important;margin-bottom: 10px !important;}"]
<h2>The Best Jacket</h2>
[/vc_column_text][vc_column_text css=".vc_custom_1532440860879{margin-bottom: 35px !important;}"]Discover true off-road performance.[/vc_column_text][image_with_animation image_url="https://themenectar.com/img/demo-media/unsplash/webp/800-500-adventure.webp" alignment="center" animation="None" img_link_large="yes" border_radius="10px" box_shadow="small_depth" max_width="75%" margin_bottom="40"][add_to_cart id=""][/vc_column_inner][/vc_row_inner][vc_row_inner equal_height="yes" content_placement="middle" column_margin="default" text_align="left"][vc_column_inner column_padding="padding-6-percent" column_padding_position="all" background_color="#dde3ff" background_color_opacity="1" background_hover_color_opacity="1" column_shadow="none" column_border_radius="none" column_link_target="_self" width="1/1" column_border_width="none" column_border_style="solid"][vc_column_text css=".vc_custom_1532441502354{margin-top: 30px !important;margin-bottom: 10px !important;}"]
<h2>Amazing Backpack</h2>
[/vc_column_text][vc_column_text css=".vc_custom_1532440864198{margin-bottom: 35px !important;}"]A whole new world of sound.[/vc_column_text][image_with_animation image_url="https://themenectar.com/img/demo-media/unsplash/webp/800-500-fashion.webp" alignment="center" animation="None" img_link_large="yes" border_radius="10px" box_shadow="small_depth" max_width="75%" margin_bottom="40"][add_to_cart id=""][/vc_column_inner][/vc_row_inner][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );



$data = array();
$data['name'] = esc_html__( 'Three Column Basic Fullwidth Category Grid', 'js_composer' );
$data['cat_display_name'] = $cat_display_names['shop'];
$data['custom_class'] = 'shop date-13-Nov-2019';
$data['image_path'] = preg_replace( '/\s/', '%20', SALIENT_CORE_PLUGIN_PATH . '/includes/img/templates/full-width-3-col-product-cats.jpg' );
$data['content'] = <<<CONTENT
[vc_row type="full_width_content" full_screen_row_position="middle" scene_position="center" text_color="dark" text_align="left" overlay_strength="0.3" shape_divider_position="bottom" shape_type=""][vc_column column_padding="no-extra-padding" column_padding_position="all" background_color_opacity="1" background_hover_color_opacity="1" column_link_target="_self" column_shadow="none" column_border_radius="none" width="1/1" tablet_text_alignment="default" phone_text_alignment="default" column_border_width="none" column_border_style="solid"][nectar_category_grid post_type="products" product_category="all" text_content_alignment="middle" subtext="cat_item_count" columns="3" grid_item_spacing="5px" color_overlay="#000000" color_overlay_opacity="0.2" color_overlay_hover_opacity="0.4" text_color="light" text_color_hover="light" shadow_on_hover="yes" subtext_visibility="on_hover" orderby="" order="" text_style="" color_strip_bg="" color_strip_bg_hover="" color_strip_text="" color_strip_text_hover="" block_sizing="square"][/vc_column][/vc_row]
CONTENT;

vc_add_default_templates( $data );


/* WooCommerce specific templates end */

}

}



?>
